<?php



/**

 * Esell Sales Module

 * Author  : Jisha

 * Created :  27/07/2020

 */

class ApiSalesController extends Controller

{



    public $method = '_stream';

    public $round_off = '2';

    public $db_main = MasCompany::MAIN_DB;

    public $outlet_id;

    public $responseBody = array(

        'status' => 'success',

        'msg' => '',

        'count' => 0,

        'data' => array(),

    );

    public $permissions = array(

        'view_cost_price' => true,

    );





    public function accessRules()

    {

        return array(

            array(

                'allow', // allow all users to perform 'index' and 'view' actions

                'actions' => array("GetList", "Save", "Edit", "Cancel", "Print", "GetData", "GetSalesDetailsFromInvoiceId", "OrderConvert"),

                'users' => array('*'),

            ),

            array(

                'allow', // allow authenticated user to perform 'create' and 'update' actions

                'actions' => array(),

                'expression' => '$user->isMember()',

            ),

            array(

                'deny', // deny all users

                'users' => array('*'),

            ),

        );
    }



    public function filters()

    {

        return array(

            'accessControl', // perform access control for CRUD operations

        );
    }



    public function save_request($request)

    {

        // if ($request != '') {

        //     Yii::app()->response->createCommand("INSERT INTO response (app_response) VALUES('" . $request . "')")->execute();

        // }

        return true;
    }



    public function get_401()

    {

        header("HTTP/1.1 401 Unauthorized");

        header('Content-Type: application/json');

        $this->responseBody['status'] = 'failed';

        $this->responseBody['msg'] = 'Unauthorized user';

        echo json_encode($this->responseBody);
    }



    public function get_400()

    {

        header("HTTP/1.1 400 Bad Request");

        header('Content-Type: application/json');

        echo json_encode($this->responseBody);
    }



    public function get_403()

    {

        header("HTTP/1.1 403  Forbidden");

        header('Content-Type: application/json');

        $this->responseBody['status'] = 'failed';

        $this->responseBody['msg'] = 'Forbidden user';

        echo json_encode($this->responseBody);
    }



    public function get_bind()

    {

        header("HTTP/1.1 200 OK");

        header('Content-Type: application/json');

        echo json_encode($this->responseBody);
    }



    public function format_currency($value)

    {

        return number_format(round((float) $value, $this->round_off), $this->round_off, '.', '');
    }



    public function get_set_permissions()

    {

        $this->responseBody['permissions']['have_purchase'] = true;

        $this->responseBody['permissions']['consider_min_sales_price'] = true;

        $this->responseBody['permissions']['have_financial_reports'] = true;

        $this->responseBody['permissions']['have_stock_adjustment'] = true;

        $this->responseBody['permissions']['view_cost_price'] = $this->permissions['view_cost_price'];
    }



    public function convert_date($date = null)

    {



        $date_converted = date('Y-m-d');



        if ($date != null) {

            //yyyy-mm-dd

            $arr_date = explode('-', $date);

            //mm/dd/yyyy

            if (checkdate($arr_date[1], $arr_date[2], $arr_date[0])) {

                $date_converted = date('Y-m-d', strtotime(str_replace('/', '-', $date)));
            }
        }

        return $date_converted;
    }





    public function connectMainDB($company_db_name)

    {

        Yii::app()->db->setActive(false);

        if (empty($company_db_name)) {

            $company_db_name = '=bluesell_new_main';
        }

        Yii::app()->db->connectionString = 'mysql:host=e-sell.me;dbname=bluesell_new_main';

        Yii::app()->db->username = 'bluesell_newadmn';

        Yii::app()->db->password = 'DKe=?ok*+KD}';

        Yii::app()->db->tablePrefix = 'erp_';

        Yii::app()->db->setActive(true);
    }







    public function actionGetList()

    {

        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);

        $userModel = MasUsers::model()->findBytoken($token);



        $input = file_get_contents('php://input');

        $variables = json_decode($input, true);



        $from = trim($variables['from']);

        $to = trim($variables['to']);



        $from = $this->convert_date($from);

        $to = $this->convert_date($to);



        $search_term = trim($variables['search_term']);





        if ($userModel->id > 0) {



            $userModel->db();



            $count = 0;



            $cndtn = 't.invoice_date BETWEEN "' . $from . '" AND "' . $to . '" AND t.outlet=' . $userModel->outlet_id;



            if (isset($search_term) && $search_term != "") {

                $cndtn .= " AND (t.invoice_no LIKE '%" . $search_term . "%'

                OR t.grand_total LIKE '%" . $search_term . "%'

                OR customer.customer_name LIKE '%" . $search_term . "%'

                

                )";
            }



            if ($userModel->access_type != 'CA') {

                $cndtn .= ' AND t.sales_man=' . $userModel->id;
            }

            // $model = SalesInvoice::model()->with('customer')->findAll(array('condition' => $cndtn, 'order' => 'invoice_date DESC, invoice_no DESC', 'limit' => '400'));

            $model = SalesInvoice::model()->with('customer')->findAll(array(

                'condition' => $cndtn,

                'order' => 't.id DESC, invoice_no DESC',

                'limit' => 400,

            ));



            //$cndtn='invoice_date BETWEEN "' . $from . '" AND "' . $to . '" AND created_by=' . $userModel->id;

            //$model = SalesInvoice::model()->findAll(array('condition' => $cndtn , 'order' => 'invoice_date DESC, invoice_no DESC'));

            foreach ($model as $i => $each) {

                $this->responseBody['data'][$i]['id'] = $each->id;

                $this->responseBody['data'][$i]['invoice_no'] = $each->invoice_no;

                $this->responseBody['data'][$i]['prefix'] = $each->prefix;

                $this->responseBody['data'][$i]['date'] = $each->invoice_date;

                $this->responseBody['data'][$i]['exchange_rate'] = $each->exchange_rate;

                $this->responseBody['data'][$i]['customer_id'] = $each->customer_id;

                $this->responseBody['data'][$i]['customer'] = $each->customer->customer_name;

                $this->responseBody['data'][$i]['credit_days'] = $each->customer->credit_days;

                $this->responseBody['data'][$i]['reference_no'] = $each->reference_no;

                $this->responseBody['data'][$i]['currency_code'] = $each->sales_cur->currency_code;

                $this->responseBody['data'][$i]['total_amount'] = $this->format_currency($each->total_amount);

                $this->responseBody['data'][$i]['vat_amount'] = $this->format_currency($each->tax_total);

                $this->responseBody['data'][$i]['excise_total'] = $this->format_currency($each->excise_total);

                $this->responseBody['data'][$i]['grand_total'] = $this->format_currency($each->grand_total);

                $this->responseBody['data'][$i]['is_posted'] = $each->posted == 'Y' ? true : false;

                $model_sales_return = StockLedger::model()->with('salesreturn_det')->find(array('condition' => 'salesreturn_det.invoice_id=' . $each->id));





                $sql_return = "SELECT sum(SI.returned_quantity) as returned_quantity 

                        FROM `erp_sales_return_items` SI 

                        LEFT JOIN erp_sales_return S ON S.id = SI.return_id

                        WHERE SI.`invoice_id` = '" . $each->id . "'  AND S.active ='Y'";

                $command = Yii::app()->db->createCommand($sql_return);

                $return_qty = $command->queryAll();





                $sql_sales = "SELECT SUM(I.quantity)  as quantity

                            FROM `erp_sales_invoice_items`  I

                            LEFT JOIN erp_sales_invoice S ON S.id = I.invoice_id

                            WHERE I.`invoice_id` = '" . $each->id . "' AND S.active='Y';";

                $command = Yii::app()->db->createCommand($sql_sales);

                $sales_qty = $command->queryAll();





                $balance_qty = (float)$sales_qty[0]['quantity'] -  (float)$return_qty[0]['returned_quantity'];



                $this->responseBody['data'][$i]['have_any_active_returns'] = (empty($model_sales_return)) ? false : true;

                $this->responseBody['data'][$i]['is_completely_returned'] = ((float)$balance_qty == 0) ? true : false;

                $this->responseBody['data'][$i]['is_cancelable'] = (empty($model_sales_return)) ? true : false;

                $this->responseBody['data'][$i]['is_cancelled'] = $each->active == 'Y' ? false : true;

                $posted_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=7 AND header_table_id=' . $each->id));

                if ($posted_voucher > 0) {

                    $allocated_voucher = FinanceAllocationItems::model()->find(array('condition' => 'voucher_id=' . $posted_voucher->id));
                }

                $this->responseBody['data'][$i]['is_allocated'] = (!empty($allocated_voucher)) ? true : false;

                $this->responseBody['data'][$i]['received'] = $each->received;

                $this->responseBody['data'][$i]['discount'] = $each->discount;

                $this->responseBody['data'][$i]['old_discount'] = $each->old_discount;

                $this->responseBody['data'][$i]['notes'] = $each->notes;

                //$this->responseBody['data'][$i]['payment_status'] = $each->payment_status;

                //$this->responseBody['data'][$i]['balance'] = $each->balance_amount;

                $this->responseBody['data'][$i]['overdue'] = $each->pay_term->days;

                $this->responseBody['data'][$i]['received'] = $each->received;

                $this->responseBody['data'][$i]['discount'] = $each->discount;

                $this->responseBody['data'][$i]['old_discount'] = $each->old_discount;

                $this->responseBody['data'][$i]['notes'] = $each->notes;

                $this->responseBody['data'][$i]['status'] = $each->active == 'Y' ? 'Active' : 'Cancel';

                $this->responseBody['data'][$i]['voucher_edit'] = $each->sales_outlet->voucher_edit == "Y" ? "true" : "false";

                //$this->responseBody['data'][$i]['is_audited'] = $each->is_audited == 'Y' ? true : false;

                //$this->responseBody['data'][$i]['is_returnable'] = $each->returnable;

                $count++;
            }



            $this->responseBody['count'] = $count;

            $this->_bind;
        } else {

            $this->_401;
        }
    }





    public function actionGetData()

    {

        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);

        $userModel = MasUsers::model()->findBytoken($token);



        $input = file_get_contents('php://input');

        $variables = json_decode($input, true);

        $voucher_id = (int) trim($variables['voucher_id']);

        if ($userModel->id > 0) {



            $userModel->db();





            if ($voucher_id > 0) {



                $id = $voucher_id;

                //Head

                $voucherModel = SalesInvoice::model()->findbypk($id);

                $prefix = FormMaster::model()->find(array('condition' => 'outlet=' . $userModel->outlet_id . ' AND code="SI"'))->prefix;

                if ($prefix != '') {

                    $prefix = $prefix . '/';
                } else {

                    $prefix = '';
                }

                $this->responseBody['data']['voucher_type'] = 'Sales';

                $this->responseBody['data']['voucher_no'] = $prefix . $voucherModel->invoice_no;

                $this->responseBody['data']['parent_voucher_no'] = $voucherModel->prefix;

                $this->responseBody['data']['voucher_date'] = date('d/m/Y', strtotime($voucherModel->invoice_date));

                $this->responseBody['data']['currency'] = $voucherModel->sales_cur->currency_code;

                if ($voucherModel->tax_total > 0) {

                    $this->responseBody['data']['company_name'] = $voucherModel->sales_outlet->companyDetails->name;

                    $this->responseBody['data']['company_trn'] = $voucherModel->sales_outlet->trn_no;

                    $this->responseBody['data']['company_adds'] = str_replace('<br>', ' ', $voucherModel->sales_outlet->companyDetails->billing_address);
                } else {

                    $this->responseBody['data']['company_name'] = ' ';

                    $this->responseBody['data']['company_trn'] = ' ';

                    $this->responseBody['data']['company_adds'] = ' ';
                }

                $this->responseBody['data']['company_phone'] = $voucherModel->sales_outlet->phone_no;

                $this->responseBody['data']['company_po_box'] = $voucherModel->sales_outlet->po_box;

                $this->responseBody['data']['outlet'] = $voucherModel->sales_outlet->name;

                $this->responseBody['data']['user'] = $voucherModel->si_salesman->full_name;

                $this->responseBody['data']['user_phone'] = $voucherModel->si_salesman->phone_no;

                $this->responseBody['data']['create_date_time'] = date('d/m/Y', strtotime($voucherModel->invoice_date));

                $this->responseBody['data']['payment_term'] = $voucherModel->payment_term;

                $this->responseBody['data']['notes'] = $voucherModel->notes;

                $this->responseBody['data']['party'] = $voucherModel->customer->customer_name;

                $this->responseBody['data']['party_trn'] = $voucherModel->customer->trn_no;

                $this->responseBody['data']['reference_no'] = $voucherModel->reference_no;

                $totalCount = SalesInvoiceItems::model()->count(array('condition' => 'invoice_id="' . $id . '"', 'order' => 'id ASC'));

                $this->responseBody['data']['total_items'] = $totalCount;

                $this->responseBody['data']['total_vat'] = $this->format_currency($voucherModel->tax_total);

                $this->responseBody['data']['total'] = $this->format_currency($voucherModel->total_amount);

                $this->responseBody['data']['grand_total'] = $this->format_currency($voucherModel->grand_total);

                $this->responseBody['data']['print_receipt'] = $voucherModel->sales_outlet->invoice_with_receipt_print == "Y" ? "true" : "false";

                //Items

                $modelItems = SalesInvoiceItems::model()->findAll(array('condition' => 'invoice_id="' . $id . '"', 'order' => 'id ASC'));

                foreach ($modelItems as $each) {

                    $this->responseBody['data']['items'][] = array(

                        'part_number' => $each->product->part_number,

                        'description' => $each->product->description,

                        'quantity' => $this->format_currency($each->quantity),

                        'uom' => $each->units->label,

                        'rate' => $this->format_currency($each->rate),

                        'discount' => '0.00',

                        'vat' => $this->format_currency($each->tax_amount),

                        'net' => $this->format_currency($each->net_amount),

                    );
                }

                //Items

                $this->responseBody['count'] = 1;

                $this->_bind;
            } else {

                $this->responseBody['status'] = 'failed';

                $this->responseBody['msg'] = 'Invalid Voucher';

                $this->_400;
            }
        } else {

            $this->_401;
        }
    }











    public function actionEdit()

    {

        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);

        $userModel = MasUsers::model()->findBytoken($token);



        $input = file_get_contents('php://input');

        $variables = json_decode($input, true);

        $id = (int) trim($variables['id']);



        if ($userModel->id > 0) {



            $userModel->db();



            if ($id > 0) {



                $model = SalesInvoice::model()->findBypk((int) $id);

                $this->responseBody['data']['customer'] = $model->customer->customer_name;

                $this->responseBody['data']['customer_id'] = $model->customer_id;

                $this->responseBody['data']['parent_invoice'] = $model->id;

                $this->responseBody['data']['id'] = $model->id;

                $this->responseBody['data']['invoice_no'] = $model->invoice_no;

                $this->responseBody['data']['total_amount'] = $this->format_currency($model->total_amount);

                $this->responseBody['data']['excise_total'] = $this->format_currency($model->excise_total);

                $this->responseBody['data']['tax_total'] = $this->format_currency($model->tax_total);

                $this->responseBody['data']['grand_total'] = $this->format_currency($model->grand_total);

                $this->responseBody['data']['payment_term'] = $model->payment_term;

                $this->responseBody['data']['credit_days'] = $model->customer->credit_days;

                $this->responseBody['data']['invoice_date'] = $model->invoice_date;

                $this->responseBody['data']['currency'] = $model->currency;

                $this->responseBody['data']['exchange_rate'] = $model->exchange_rate;

                $this->responseBody['data']['outlet'] = $model->outlet;

                $this->responseBody['data']['salesman'] = $model->sales_man;

                $this->responseBody['data']['lpo'] = $model->reference_no;

                $modelItems = SalesInvoiceItems::model()->findAll(array('condition' => 'invoice_id="' . $id . '"', 'order' => 'id'));

                foreach ($modelItems as $i => $each) {

                    $this->responseBody['data']['items'][$i]['id'] = $each->id;

                    $this->responseBody['data']['items'][$i]['invoice_id'] = $each->invoice_id;

                    $this->responseBody['data']['items'][$i]['ledger_id'] = $each->product_id;

                    $this->responseBody['data']['items'][$i]['product_id'] = $each->product_id;

                    $this->responseBody['data']['items'][$i]['ledger_name'] = $each->product->part_number;

                    $this->responseBody['data']['items'][$i]['goods_service'] = $each->product->type;

                    $this->responseBody['data']['items'][$i]['description'] = $each->product->description;

                    $this->responseBody['data']['items'][$i]['quantity'] = $each->quantity;

                    $this->responseBody['data']['items'][$i]['max_returnable_quantity'] = $each->quantity;

                    $this->responseBody['data']['items'][$i]['uom'] = $each->unit;

                    $this->responseBody['data']['items'][$i]['unit_label'] = $each->units->unit_name;

                    $this->responseBody['data']['items'][$i]['rate'] = $this->format_currency($each->rate);

                    $this->responseBody['data']['items'][$i]['excise_percentage'] = $each->excise_percentage;

                    $this->responseBody['data']['items'][$i]['excise_amount'] = $this->format_currency($each->excise_amount);

                    $this->responseBody['data']['items'][$i]['tax_amount'] = $this->format_currency($each->tax_amount);

                    $this->responseBody['data']['items'][$i]['tax_percentage'] = str_replace('%', '', $each->tax_percentage);

                    $this->responseBody['data']['items'][$i]['net_amount'] = $this->format_currency($each->net_amount);
                }



                $this->responseBody['count'] = 1;

                $this->_bind;
            } else {

                $this->responseBody['status'] = 'failed';

                $this->responseBody['msg'] = 'Invalid Invoice id';

                $this->_400;
            }
        } else {

            $this->_401;
        }
    }











    public function actionPrint()

    {

        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);

        $userModel = MasUsers::model()->findBytoken($token);

        if ($userModel->id > 0) {

            $userModel->db();



            $input = file_get_contents('php://input');

            //error_log($input);

            $variables = json_decode($input, true);

            $id = (int) trim($variables['id']);

            $mpdf = Yii::app()->ePdf->mpdf('', 'A4');

            $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');





            $model = SalesInvoice::model()->findByPk($id);

            if ($model->active == 'N') {

                $mpdf->SetWatermarkText('CANCELLED');

                $mpdf->showWatermarkText = true;
            }

            $layout = 'application.views.front.api.pdf.sales_invoice_print';

            $print = 'SI_' . $model->invoice_no;





            $mpdf->WriteHTML($stylesheet, 1);

            $mpdf->WriteHTML($this->renderPartial($layout, array('id' => $id, 'user_id' => $userModel->id), true));

            $mpdf->Output("downloads/vouchers/$print.pdf", 'F');

            $this->responseBody['file'] = str_replace('index.php', '', $_SERVER['SCRIPT_URI']) . 'downloads/vouchers/' . $print . '.pdf';

            $this->_bind;
        } else {

            $this->_401;
        }
    }







    public function actionCancel()

    {

        $input = file_get_contents('php://input');

        $variables = json_decode($input, true);

        $voucher_id = (int) trim($variables['voucher_id']);



        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);

        $userModel = MasUsers::model()->findBytoken($token);



        if ($userModel->id > 0) {



            $userModel->db();



            $id = $voucher_id;

            $valid = true;

            $model = SalesInvoice::model()->findByPk($id);

            $closing_date = MasClosing::getClosingDate();

            if ($closing_date >= $model->invoice_date) {

                $other[] = 'Date should be greater than closing date (' . date('d-m-Y', strtotime($closing_date)) . ')';

                $valid = false;
            }

            if ($valid) {

                $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=7 AND header_table_id=' . $model->id));

                if (!empty($fin_voucher)) {

                    FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));

                    FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
                }

                StockLedger::model()->deleteAll('header_id=' . $model->id . ' AND  transaction_type="OUT" AND type= "SI" AND outlet=' . $userModel->outlet_id);

                $model->active = 'N';

                $model->posted = 'N';

                $model->save(false);

                $this->responseBody['status'] = 'success';

                $this->_bind;
            } else {

                $err_msg = implode(',', $other);

                $this->responseBody['msg'] = $err_msg;

                $this->responseBody['status'] = 'failed';

                $this->responseBody['items'] = array('Negative stock is not allowed');

                $this->_400;
            }
        } else {

            $this->_401;
        }
    }







    function invoicePosting($invoice_id)

    {

        $mainTable = SalesInvoice::model()->findByPk((int) $invoice_id);

        $outlet = $mainTable->outlet;

        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="SI" AND outlet=' . $outlet))->id;

        $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $mainTable->id));

        if (!empty($fin_voucher)) {

            FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));

            FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
        }

        $voucherHead['voucher_no'] = $mainTable->invoice_no;

        $voucherHead['voucher_date'] = $mainTable->invoice_date;

        $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

        $voucherHead['voucher_type'] = $vouchertype;

        // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

        $voucherHead['reference_no'] = $mainTable->reference_no;

        $voucherHead['header_table_id'] = $mainTable->id;

        $voucherHead['due_date'] = $mainTable->invoice_date;

        $voucherHead['outlet'] = $mainTable->outlet;

        $voucherHead['created_by'] = $mainTable->sales_man;

        // $voucherHead['due_date'] = date('Y-m-d', strtotime($mainTable->invoice_date . ' + ' . (int) $mainTable->paymentTerm->no_of_days . ' days'));

        $valid = $this->isPostable($mainTable->invoice_date);



        $lastSavedid = $valid ? $this->addVoucherhead($voucherHead) : 0;



        $total_debtor_amount = $mainTable->grand_total;

        $total_sales = $mainTable->total_amount;

        $total_tax_amount = $mainTable->tax_total;

        $total_discount_amount = $mainTable->discount;

        $total_received_amount = $mainTable->received;

        if ($total_debtor_amount > 0) {

            //Debtor Dr

            $debit_item_sales = $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => $this->getSublegder($mainTable->customer_id, 1), //2-Creditors 1- debtors

                'narration' => 'Sales #' . $mainTable->invoice_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->customer->state,

                'amount' => (float) $total_debtor_amount,

                'outlet' => $mainTable->outlet

            ));

            if ($total_received_amount > 0) {

                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="CA" AND outlet=' . $outlet))->id;

                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                $voucherHead['voucher_date'] = $mainTable->invoice_date;

                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

                $voucherHead['voucher_type'] = $vouchertype;

                $voucherHead['payment_method'] = 1;

                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                $voucherHead['reference_no'] = $mainTable->reference_no;

                $voucherHead['header_table_id'] = $mainTable->id;

                $voucherHead['due_date'] = $mainTable->invoice_date;

                $voucherHead['outlet'] = $mainTable->outlet;

                $voucherHead['created_by'] = $mainTable->sales_man;

                $lastSavedid_receipt_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;



                $debit_item_receipt = $this->addVoucheritems($lastSavedid_receipt_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                    'narration' => 'Sales #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->customer->state,

                    'amount' => -1 * $total_received_amount,

                    'outlet' => $mainTable->outlet

                ));



                $this->addVoucheritems($lastSavedid_receipt_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('cash_account'),

                    //  'subledger_id' => MasUsers::model()->findByPk($mainTable->created_by)->subledger_id,

                    'subledger_id' => $this->getSublegder($mainTable->sales_man, 3),

                    'narration' => 'Sales #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->customer->state,

                    'amount' => (float) $total_received_amount,

                    'outlet' => $mainTable->outlet

                ));

                FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('total_voucher_amount' => ($total_received_amount), 'cheque_cleared' => 'Y')); //$netTotal

                //Auto Allocation

                $allocation = new FinanceAllocation;

                $allocation->allocation_date = $mainTable->invoice_date;

                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');

                $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);

                $allocation->amount = (float) $total_received_amount;

                $allocation->created_by = $mainTable->sales_man;

                $allocation->created_date_time = date('Y-m-d h:i:s');

                $allocation->outlet = $mainTable->outlet;

                $allocation->save(false);

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid;

                $allocation_items->voucher_item_id = $debit_item_sales;

                $allocation_items->amount = (float) $total_received_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid_receipt_voucher;

                $allocation_items->voucher_item_id = $debit_item_receipt;

                $allocation_items->amount = -1 * $total_received_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('is_allocated' => 'Y'));
            }

            // Discount Start

            if ($total_discount_amount > 0) {

                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="DA" AND outlet=' . $outlet))->id;

                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                $voucherHead['voucher_date'] = $mainTable->invoice_date;

                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

                $voucherHead['voucher_type'] = $vouchertype;

                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                $voucherHead['reference_no'] = $mainTable->reference_no;

                $voucherHead['header_table_id'] = $mainTable->id;

                $voucherHead['due_date'] = $mainTable->invoice_date;

                $voucherHead['outlet'] = $mainTable->outlet;

                $voucherHead['created_by'] = $mainTable->sales_man;

                $lastSavedid_discount_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;



                $debit_item_discount = $this->addVoucheritems($lastSavedid_discount_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                    'narration' => 'Sales #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->customer->state,

                    'amount' => -1 * $total_discount_amount,

                    'outlet' => $mainTable->outlet

                ));



                $this->addVoucheritems($lastSavedid_discount_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('discount_allowed'),

                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                    'narration' => 'Sales #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->customer->state,

                    'amount' => (float) $total_discount_amount,

                    'outlet' => $mainTable->outlet

                ));



                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('total_voucher_amount' => ($total_discount_amount), 'cheque_cleared' => 'Y')); //$netTotal

                //Auto Allocation

                $allocation = new FinanceAllocation;

                $allocation->allocation_date = $mainTable->invoice_date;

                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');

                $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);

                $allocation->amount = (float) $total_discount_amount;

                $allocation->created_by = $mainTable->sales_man;

                $allocation->created_date_time = date('Y-m-d h:i:s');

                $allocation->outlet = $mainTable->outlet;

                $allocation->save(false);

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid;

                $allocation_items->voucher_item_id = $debit_item_sales;

                $allocation_items->amount = (float) $total_discount_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid_discount_voucher;

                $allocation_items->voucher_item_id = $debit_item_discount;

                $allocation_items->amount = -1 * $total_discount_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('is_allocated' => 'Y'));
            }

            // END Discount

        }



        if ($total_sales > 0) {

            //Sales Accounts Cr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales'),

                // 'brand_id' => $mainTable->order_id,

                // 'subledger_id' => $this->getSublegder($mainTable->lead_owner_id, 3),

                'narration' => 'Sales #' . $mainTable->invoice_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->customer->state,

                'amount' => -1 * $total_sales,

                'outlet' => $mainTable->outlet

            ));
        }

        if ($total_tax_amount > 0) {

            //VAT Cr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales_vat'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => 0,

                'narration' => 'Sales #' . $mainTable->invoice_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->customer->state,

                'amount' => -1 * $total_tax_amount,

                'outlet' => $mainTable->outlet

            ));
        }



        FinanceVoucherHead::model()->updatebypk($lastSavedid, array('total_voucher_amount' => ($mainTable->grand_total), 'cheque_cleared' => 'Y')); //$netTotal

        $mainTable->posted = 'Y';

        $mainTable->save();
    }





    function purchaseInvoicePosting($invoice_id)

    {

        $mainTable = PurchaseInvoice::model()->findByPk((int) $invoice_id);

        $outlet = $mainTable->outlet;

        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PI" AND outlet=' . $outlet))->id;

        $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $mainTable->id));

        if (!empty($fin_voucher)) {

            FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));

            FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
        }

        $voucherHead['voucher_no'] = $mainTable->invoice_no;

        $voucherHead['voucher_date'] = $mainTable->invoice_date;

        $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);

        $voucherHead['voucher_type'] = $vouchertype;

        // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

        $voucherHead['reference_no'] = $mainTable->reference_no;

        $voucherHead['header_table_id'] = $mainTable->id;

        $voucherHead['due_date'] = $mainTable->invoice_date;

        $voucherHead['outlet'] = $mainTable->outlet;

        $voucherHead['created_by'] = $mainTable->created_by;

        // $voucherHead['due_date'] = date('Y-m-d', strtotime($mainTable->invoice_date . ' + ' . (int) $mainTable->paymentTerm->no_of_days . ' days'));

        $valid = $this->isPostable($mainTable->invoice_date);



        $lastSavedid = $valid ? $this->addVoucherhead($voucherHead) : 0;



        $total_creditor_amount = $mainTable->grand_total;

        $total_purchase = $mainTable->total_amount;

        $total_tax_amount = $mainTable->tax_total;

        $total_excise_amount = $mainTable->excise_total;

        $total_discount_amount = $mainTable->discount;

        $total_received_amount = $mainTable->received;



        if ($total_creditor_amount > 0) {

            //Creditor Cr

            $credit_item_purchase = $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2), //2-Creditors 1- debtors

                'narration' => 'Purchase #' . $mainTable->invoice_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->vendor->state,

                'amount' => -1 * $total_creditor_amount,

                'outlet' => $mainTable->outlet

            ));

            if ($total_received_amount > 0) {

                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PV" AND outlet=' . $outlet))->id;

                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                $voucherHead['voucher_date'] = $mainTable->invoice_date;

                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);

                $voucherHead['voucher_type'] = $vouchertype;

                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                $voucherHead['reference_no'] = $mainTable->reference_no;

                $voucherHead['header_table_id'] = $mainTable->id;

                $voucherHead['due_date'] = $mainTable->invoice_date;

                $voucherHead['outlet'] = $mainTable->outlet;

                $voucherHead['created_by'] = $mainTable->created_by;

                $lastSavedid_payment_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;



                $credit_item_payment = $this->addVoucheritems($lastSavedid_payment_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),

                    'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2), //2-Creditors 1- debtors

                    'narration' => 'Purchase #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->vendor->state,

                    'amount' => (float) $total_received_amount,

                    'outlet' => $mainTable->outlet

                ));



                $this->addVoucheritems($lastSavedid_payment_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('cash_account'),

                    'subledger_id' => MasUsers::model()->findByPk($mainTable->created_by)->subledger_id,

                    'narration' => 'Purchase #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->vendor->state,

                    'amount' => -1 * $total_received_amount,

                    'outlet' => $mainTable->outlet

                ));

                FinanceVoucherHead::model()->updatebypk($lastSavedid_payment_voucher, array('total_voucher_amount' => ($total_received_amount), 'cheque_cleared' => 'Y')); //$netTotal

                //Auto Allocation

                $allocation = new FinanceAllocation;

                $allocation->allocation_date = $mainTable->invoice_date;

                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('creditors');

                $allocation->subledger_id = $this->getSublegder($mainTable->vendor_id, 2);

                $allocation->amount = (float) $total_received_amount;

                $allocation->created_by = $mainTable->created_by;

                $allocation->created_date_time = date('Y-m-d h:i:s');

                $allocation->outlet = $mainTable->outlet;

                $allocation->save();



                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid;

                $allocation_items->voucher_item_id = $credit_item_purchase;

                $allocation_items->amount = -1 * $total_received_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save();

                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid_payment_voucher;

                $allocation_items->voucher_item_id = $credit_item_payment;

                $allocation_items->amount = (float) $total_received_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save();

                FinanceVoucherHead::model()->updatebypk($lastSavedid_payment_voucher, array('is_allocated' => 'Y'));
            }

            // Discount Start

            if ($total_discount_amount > 0) {

                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="JV" AND outlet=' . $outlet))->id;

                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                $voucherHead['voucher_date'] = $mainTable->invoice_date;

                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);

                $voucherHead['voucher_type'] = $vouchertype;

                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                $voucherHead['reference_no'] = $mainTable->reference_no;

                $voucherHead['header_table_id'] = $mainTable->id;

                $voucherHead['due_date'] = $mainTable->invoice_date;

                $voucherHead['outlet'] = $mainTable->outlet;

                $voucherHead['created_by'] = $mainTable->created_by;

                $lastSavedid_discount_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;



                $debit_item_discount = $this->addVoucheritems($lastSavedid_discount_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),

                    'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2),

                    'narration' => 'Purchase #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->vendor->state,

                    'amount' => $total_discount_amount,

                    'outlet' => $mainTable->outlet

                ));



                $this->addVoucheritems($lastSavedid_discount_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('discount'),

                    'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2),

                    'narration' => 'Purchase #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->vendor->state,

                    'amount' => -1 * $total_discount_amount,

                    'outlet' => $mainTable->outlet

                ));



                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('total_voucher_amount' => ($total_discount_amount), 'cheque_cleared' => 'Y')); //$netTotal

                //Auto Allocation

                $allocation = new FinanceAllocation;

                $allocation->allocation_date = $mainTable->invoice_date;

                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('creditors');

                $allocation->subledger_id = $this->getSublegder($mainTable->vendor_id, 2);

                $allocation->amount = (float) $total_discount_amount;

                $allocation->created_by = $mainTable->created_by;

                $allocation->created_date_time = date('Y-m-d h:i:s');

                $allocation->outlet = $mainTable->outlet;

                $allocation->save(false);

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid;

                $allocation_items->voucher_item_id = $credit_item_purchase;

                $allocation_items->amount = -1 * $total_discount_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid_discount_voucher;

                $allocation_items->voucher_item_id = $debit_item_discount;

                $allocation_items->amount = (float) $total_discount_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('is_allocated' => 'Y'));
            }

            // END Discount

        }



        if ($total_purchase > 0) {

            //Purchase Accounts Dr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('purchase'),

                // 'brand_id' => $mainTable->order_id,

                // 'subledger_id' => $this->getSublegder($mainTable->lead_owner_id, 3),

                'narration' => 'Purchase #' . $mainTable->invoice_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->vendor->state,

                'amount' => (float) $total_purchase,

                'outlet' => $mainTable->outlet

            ));
        }

        if ($total_tax_amount > 0) {

            //VAT Dr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('purchase_vat'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => 0,

                'narration' => 'Purchase #' . $mainTable->invoice_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->vendor->state,

                'amount' => (float) $total_tax_amount,

                'outlet' => $mainTable->outlet

            ));
        }



        if ($total_excise_amount > 0) {

            //VAT Dr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('excise_tax'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => 0,

                'narration' => 'Purchase #' . $mainTable->invoice_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->vendor->state,

                'amount' => (float) $total_excise_amount,

                'outlet' => $mainTable->outlet

            ));
        }



        FinanceVoucherHead::model()->updatebypk($lastSavedid, array('total_voucher_amount' => ($mainTable->grand_total), 'cheque_cleared' => 'Y')); //$netTotal

        $mainTable->posted = 'Y';

        $mainTable->save();
    }



    function purchasereturnPosting($invoice_id)

    {

        $mainTable = PurchaseReturn::model()->findByPk((int) $invoice_id);

        $outlet = $mainTable->outlet;

        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="DN" AND outlet=' . $outlet))->id;

        $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $mainTable->id));

        if (!empty($fin_voucher)) {

            FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));

            FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
        }

        $voucherHead['voucher_no'] = $mainTable->return_no;

        $voucherHead['voucher_date'] = $mainTable->return_date;

        $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);

        $voucherHead['voucher_type'] = $vouchertype;

        // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

        $voucherHead['reference_no'] = $mainTable->reference_no;

        $voucherHead['header_table_id'] = $mainTable->id;

        $voucherHead['due_date'] = $mainTable->return_date;

        $voucherHead['outlet'] = $mainTable->outlet;

        $voucherHead['created_by'] = $mainTable->created_by;

        // $voucherHead['due_date'] = date('Y-m-d', strtotime($mainTable->invoice_date . ' + ' . (int) $mainTable->paymentTerm->no_of_days . ' days'));

        $valid = $this->isPostable($mainTable->return_date);



        $lastSavedid = $valid ? $this->addVoucherhead($voucherHead) : 0;



        $total_creditor_amount = $mainTable->grand_total;

        $total_purchase = $mainTable->total_amount;

        $total_tax_amount = $mainTable->tax_total;

        $total_excise_amount = $mainTable->excise_total;

        $total_discount_amount = $mainTable->discount;

        $total_received_amount = $mainTable->paid;



        if ($total_creditor_amount > 0) {

            //Creditor Cr

            $credit_item_purchase = $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2), //2-Creditors 1- debtors

                'narration' => 'Purchase Return #' . $mainTable->return_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->pr_vendor->state,

                'amount' => (float) $total_creditor_amount,

                'outlet' => $mainTable->outlet

            ));

            if ($total_received_amount > 0) {

                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="CA" AND outlet=' . $outlet))->id;

                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                $voucherHead['voucher_date'] = $mainTable->return_date;

                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);

                $voucherHead['voucher_type'] = $vouchertype;

                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                $voucherHead['reference_no'] = $mainTable->reference_no;

                $voucherHead['header_table_id'] = $mainTable->id;

                $voucherHead['due_date'] = $mainTable->return_date;

                $voucherHead['outlet'] = $mainTable->outlet;

                $voucherHead['created_by'] = $mainTable->created_by;

                $lastSavedid_payment_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;



                $credit_item_payment = $this->addVoucheritems($lastSavedid_payment_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),

                    'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2), //2-Creditors 1- debtors

                    'narration' => 'Purchase Return #' . $mainTable->return_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->pr_vendor->state,

                    'amount' => -1 * $total_received_amount,

                    'outlet' => $mainTable->outlet

                ));



                $this->addVoucheritems($lastSavedid_payment_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('cash_account'),

                    'subledger_id' => MasUsers::model()->findByPk($mainTable->created_by)->subledger_id,

                    'narration' => 'Purchase Return #' . $mainTable->return_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->pr_vendor->state,

                    'amount' => (float) $total_received_amount,

                    'outlet' => $mainTable->outlet

                ));

                FinanceVoucherHead::model()->updatebypk($lastSavedid_payment_voucher, array('total_voucher_amount' => ($total_creditor_amount), 'cheque_cleared' => 'Y')); //$netTotal

                //Auto Allocation

                $allocation = new FinanceAllocation;

                $allocation->allocation_date = $mainTable->return_date;

                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('creditors');

                $allocation->subledger_id = $this->getSublegder($mainTable->vendor_id, 2);

                $allocation->amount = (float) $total_received_amount;

                $allocation->created_by = $mainTable->created_by;

                $allocation->created_date_time = date('Y-m-d h:i:s');

                $allocation->outlet = $mainTable->outlet;

                $allocation->save();



                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid;

                $allocation_items->voucher_item_id = $credit_item_purchase;

                $allocation_items->amount = (float) $total_received_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save();

                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid_payment_voucher;

                $allocation_items->voucher_item_id = $credit_item_payment;

                $allocation_items->amount = -1 * $total_received_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save();

                FinanceVoucherHead::model()->updatebypk($lastSavedid_payment_voucher, array('is_allocated' => 'Y'));
            }

            // Discount Start

            if ($total_discount_amount > 0) {

                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="JV" AND outlet=' . $outlet))->id;

                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                $voucherHead['voucher_date'] = $mainTable->return_date;

                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);

                $voucherHead['voucher_type'] = 3;

                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                $voucherHead['reference_no'] = $mainTable->reference_no;

                $voucherHead['header_table_id'] = $mainTable->id;

                $voucherHead['due_date'] = $mainTable->return_date;

                $voucherHead['outlet'] = $mainTable->outlet;

                $voucherHead['created_by'] = $mainTable->created_by;

                $lastSavedid_discount_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;



                $debit_item_discount = $this->addVoucheritems($lastSavedid_discount_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),

                    'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2),

                    'narration' => 'Purchase Return #' . $mainTable->return_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->pr_vendor->state,

                    'amount' => $total_discount_amount,

                    'outlet' => $mainTable->outlet

                ));



                $this->addVoucheritems($lastSavedid_discount_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('discount'),

                    'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2),

                    'narration' => 'Purchase Return #' . $mainTable->return_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->pr_vendor->state,

                    'amount' => (float) $total_discount_amount,

                    'outlet' => $mainTable->outlet

                ));



                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('total_voucher_amount' => ($total_discount_amount), 'cheque_cleared' => 'Y')); //$netTotal

                //Auto Allocation

                $allocation = new FinanceAllocation;

                $allocation->allocation_date = $mainTable->return_date;

                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('creditors');

                $allocation->subledger_id = $this->getSublegder($mainTable->vendor_id, 2);

                $allocation->amount = (float) $total_discount_amount;

                $allocation->created_by = $mainTable->created_by;

                $allocation->created_date_time = date('Y-m-d h:i:s');

                $allocation->outlet = $mainTable->outlet;

                $allocation->save(false);

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid;

                $allocation_items->voucher_item_id = $credit_item_purchase;

                $allocation_items->amount = (float) $total_discount_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid_discount_voucher;

                $allocation_items->voucher_item_id = $debit_item_discount;

                $allocation_items->amount = -1 * $total_discount_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('is_allocated' => 'Y'));
            }

            // END Discount

        }



        if ($total_purchase > 0) {

            //Purchase Accounts Dr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('purchase'),

                // 'brand_id' => $mainTable->order_id,

                // 'subledger_id' => $this->getSublegder($mainTable->lead_owner_id, 3),

                'narration' => 'Purchase Return #' . $mainTable->return_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->pr_vendor->state,

                'amount' => -1 * $total_purchase,

                'outlet' => $mainTable->outlet

            ));
        }

        if ($total_tax_amount > 0) {

            //VAT Dr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('purchase_vat'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => 0,

                'narration' => 'Purchase Return #' . $mainTable->return_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->pr_vendor->state,

                'amount' => -1 * $total_tax_amount,

                'outlet' => $mainTable->outlet

            ));
        }



        if ($total_excise_amount > 0) {

            //VAT Dr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('excise_tax'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => 0,

                'narration' => 'Purchase Return #' . $mainTable->return_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->pr_vendor->state,

                'amount' => -1 * $total_excise_amount,

                'outlet' => $mainTable->outlet

            ));
        }



        FinanceVoucherHead::model()->updatebypk($lastSavedid, array('total_voucher_amount' => ($mainTable->grand_total), 'cheque_cleared' => 'Y')); //$netTotal

        $mainTable->posted = 'Y';

        $mainTable->save();
    }





    function isPostable($date)

    {

        $last_closed_year = FinanceAuditClose::lastClosed();

        $voucherDate_array = explode('-', $date);

        $voucherYear = $voucherDate_array[0];

        return ($voucherYear <= $last_closed_year) ? false : true;
    }



    public function addVoucherhead($arr_items)

    {

        $model = new FinanceVoucherHead;

        $model->voucher_type = $arr_items['voucher_type'];

        $model->voucher_no = $arr_items['voucher_no'];

        $model->voucher_date = $arr_items['voucher_date'];

        $model->related_subledger = $arr_items['related_subledger'];

        $model->emp_subledger = $arr_items['emp_subledger'];

        $model->due_date = (isset($arr_items['due_date'])) ? $arr_items['due_date'] : $model->voucher_date;

        $model->header_table_id = $arr_items['header_table_id'];

        $model->reference_no = $arr_items['reference_no'];

        $model->is_posted = (isset($arr_items['is_posted'])) ? $arr_items['is_posted'] : 'Y';

        $model->created_by = $arr_items['created_by'];

        $model->created_datetime = date('Y-m-d h:i:s');

        $model->cheque_no = $arr_items['cheque_no'];

        $model->outlet = $arr_items['outlet'];

        $model->payment_method = $arr_items['payment_method'];

        return ($model->save(false)) ? $model->id : 0; //exception

    }



    public function addVoucheritems($headerId, $arr_items)

    {

        $model = new FinanceVoucherItems;

        $model->header_id = $headerId;

        $model->ledger_id = $arr_items['ledger_id'];

        $model->brand_id = (int) $arr_items['brand_id'];

        $model->emirate_id = $arr_items['emirate_id'];

        $model->subledger_id = $arr_items['subledger_id'];

        $model->narration = $arr_items['narration'];

        $model->amount = $arr_items['amount'];

        $model->currency_id = $arr_items['currency'] > 0 ? $arr_items['currency'] : FinanceLegder::baseCurrency_id();

        $model->exchange_rate = $arr_items['exchange_rate'] > 0 ? $arr_items['exchange_rate'] : 1;

        $model->amount = $arr_items['amount'];

        $model->reconciled_date = $arr_items['reconciled_date'];

        $cleared = $arr_items['opening_cheque_cleared'];

        if ($cleared == '')

            $cleared = 'N';

        $model->opening_cheque_cleared = $cleared;

        $reconciled = $arr_items['reconciled'];

        if ($reconciled == '')

            $reconciled = 'N';

        $model->reconciled = $reconciled;

        $model->outlet = $arr_items['outlet'];

        $model->save(false);

        return $model->id > 0 ? $model->id : 0;
    }



    function getSublegder($parnet_id, $subledger_type)

    {

        return FinanceSubledger::model()->find(array('condition' => 'parent_id=' . (int) $parnet_id . ' AND subledger_type_id=' . (int) $subledger_type))->id;
    }









    function salesreturnPosting($invoice_id)

    {

        $mainTable = SalesReturn::model()->findByPk((int) $invoice_id);

        $outlet = $mainTable->outlet;

        $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=10 AND header_table_id=' . $mainTable->id));

        if (!empty($fin_voucher)) {

            FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));

            FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
        }

        $voucherHead['voucher_no'] = $mainTable->return_no;

        $voucherHead['voucher_date'] = $mainTable->return_date;

        $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="CN" AND outlet=' . $outlet))->id;

        $voucherHead['voucher_type'] = $vouchertype;

        // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

        $voucherHead['reference_no'] = $mainTable->reference_no;

        $voucherHead['header_table_id'] = $mainTable->id;

        $voucherHead['due_date'] = $mainTable->return_date;

        $voucherHead['outlet'] = $mainTable->outlet;

        $voucherHead['created_by'] = $mainTable->created_by;

        // $voucherHead['due_date'] = date('Y-m-d', strtotime($mainTable->invoice_date . ' + ' . (int) $mainTable->paymentTerm->no_of_days . ' days'));

        $valid = $this->isPostable($mainTable->return_date);



        $lastSavedid = $valid ? $this->addVoucherhead($voucherHead) : 0;



        $total_debtor_amount = $mainTable->grand_total;

        $total_sales = $mainTable->total_amount;

        $total_tax_amount = $mainTable->tax_total;

        $total_discount_amount = $mainTable->discount;

        $total_received_amount = $mainTable->paid;

        if ($total_debtor_amount > 0) {

            //Debtor Dr

            $debit_item_sales = $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => $this->getSublegder($mainTable->customer_id, 1), //2-Creditors 1- debtors

                'narration' => 'Sales Return #' . $mainTable->return_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->sr_customer->state,

                'amount' => -1 * $total_debtor_amount,

                'outlet' => $mainTable->outlet

            ));



            if ($total_received_amount > 0) {

                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PV" AND outlet=' . $outlet))->id;

                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                $voucherHead['voucher_date'] = $mainTable->return_date;

                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

                $voucherHead['voucher_type'] = $vouchertype;

                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                $voucherHead['reference_no'] = $mainTable->reference_no;

                $voucherHead['header_table_id'] = $mainTable->id;

                $voucherHead['due_date'] = $mainTable->return_date;

                $voucherHead['outlet'] = $mainTable->outlet;

                $voucherHead['created_by'] = $mainTable->created_by;

                $lastSavedid_receipt_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;



                $debit_item_receipt = $this->addVoucheritems($lastSavedid_receipt_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                    'narration' => 'Sales Return #' . $mainTable->return_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->sr_customer->state,

                    'amount' => (float) $total_received_amount,

                    'outlet' => $mainTable->outlet

                ));



                $this->addVoucheritems($lastSavedid_receipt_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('cash_account'),

                    'subledger_id' => MasUsers::model()->findByPk($mainTable->created_by)->subledger_id,

                    'narration' => 'Sales Return #' . $mainTable->return_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->sr_customer->state,

                    'amount' => -1 * $total_received_amount,

                    'outlet' => $mainTable->outlet

                ));

                FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('total_voucher_amount' => ($total_received_amount), 'cheque_cleared' => 'Y')); //$netTotal

                //Auto Allocation

                $allocation = new FinanceAllocation;

                $allocation->allocation_date = $mainTable->return_date;

                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');

                $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);

                $allocation->amount = (float) $total_received_amount;

                $allocation->created_by = $mainTable->created_by;

                $allocation->created_date_time = date('Y-m-d h:i:s');

                $allocation->outlet = $mainTable->outlet;

                $allocation->save(false);

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid;

                $allocation_items->voucher_item_id = $debit_item_sales;

                $allocation_items->amount = (float) $total_received_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid_receipt_voucher;

                $allocation_items->voucher_item_id = $debit_item_receipt;

                $allocation_items->amount = -1 * $total_received_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('is_allocated' => 'Y'));
            }

            // Discount Start

            if ($total_discount_amount > 0) {

                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="DA" AND outlet=' . $outlet))->id;

                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                $voucherHead['voucher_date'] = $mainTable->return_date;

                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

                $voucherHead['voucher_type'] = $vouchertype;

                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                $voucherHead['reference_no'] = $mainTable->reference_no;

                $voucherHead['header_table_id'] = $mainTable->id;

                $voucherHead['due_date'] = $mainTable->return_date;

                $voucherHead['outlet'] = $mainTable->outlet;

                $voucherHead['created_by'] = $mainTable->created_by;

                $lastSavedid_discount_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;



                $debit_item_discount = $this->addVoucheritems($lastSavedid_discount_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                    'narration' => 'Sales Return #' . $mainTable->return_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->sr_customer->state,

                    'amount' => (float) $total_discount_amount,

                    'outlet' => $mainTable->outlet

                ));



                $this->addVoucheritems($lastSavedid_discount_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('discount_allowed'),

                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                    'narration' => 'Sales Return #' . $mainTable->return_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->sr_customer->state,

                    'amount' => -1 * $total_discount_amount,

                    'outlet' => $mainTable->outlet

                ));



                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('total_voucher_amount' => ($total_discount_amount), 'cheque_cleared' => 'Y')); //$netTotal

                //Auto Allocation

                $allocation = new FinanceAllocation;

                $allocation->allocation_date = $mainTable->return_date;

                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');

                $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);

                $allocation->amount = (float) $total_discount_amount;

                $allocation->created_by = $mainTable->created_by;

                $allocation->created_date_time = date('Y-m-d h:i:s');

                $allocation->outlet = $mainTable->outlet;

                $allocation->save(false);

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid;

                $allocation_items->voucher_item_id = $debit_item_sales;

                $allocation_items->amount = -1 * $total_discount_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid_discount_voucher;

                $allocation_items->voucher_item_id = $debit_item_discount;

                $allocation_items->amount = (float) $total_discount_amount;

                $allocation_items->outlet = $mainTable->outlet;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('is_allocated' => 'Y'));
            }

            // END Discount

        }



        if ($total_sales > 0) {

            //Sales Accounts Cr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales'),

                // 'brand_id' => $mainTable->order_id,

                // 'subledger_id' => $this->getSublegder($mainTable->lead_owner_id, 3),

                'narration' => 'Sales Return #' . $mainTable->return_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->sr_customer->state,

                'amount' => (float) $total_sales,

                'outlet' => $mainTable->outlet

            ));
        }

        if ($total_tax_amount > 0) {

            //VAT Cr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales_vat'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => 0,

                'narration' => 'Sales Return #' . $mainTable->return_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->sr_customer->state,

                'amount' => (float) $total_tax_amount,

                'outlet' => $mainTable->outlet

            ));
        }



        FinanceVoucherHead::model()->updatebypk($lastSavedid, array('total_voucher_amount' => ($mainTable->grand_total), 'cheque_cleared' => 'Y')); //$netTotal

        $mainTable->posted = 'Y';

        $mainTable->save();
    }





    public function actionGetSalesDetailsFromInvoiceId()

    {



        try {

            $data = [];

            $other = [];

            $valid = true;

            $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);

            $userModel = MasUsers::model()->findBytoken($token);

            $input = file_get_contents('php://input');

            $variables = json_decode($input, true);

            if ($userModel->id > 0) {

                $invoice_no = $variables['invoice_id'];

                $userModel->db();





                if ((int) $invoice_no > 0) {

                    $modelInvoice = new SalesInvoice();

                    $modelInvoice = $modelInvoice->find(array('condition' => 'id=' . (int) $invoice_no));

                    if (!empty($modelInvoice)) {



                        $modelInvoiceItem = new SalesInvoiceItems();

                        $modelInvoiceItem = $modelInvoiceItem->model()->findAll(array('condition' => 'invoice_id="' . (int) $modelInvoice['id'] . '"'));



                        $company_name    = $modelInvoice->sales_outlet->companyDetails->name;

                        $company_address = trim($modelInvoice->sales_outlet->companyDetails->billing_address);

                        $company_phone   = $modelInvoice->sales_outlet->companyDetails->phone;





                        $item_list = [];

                        $total_discount = 0;

                        $total_wo_vat = 0;

                        $total_amount = 0;

                        $item_count = 0;

                        foreach ($modelInvoiceItem as $eachItem) {

                            $item_count++;



                            $item_list[] = [

                                "invoice_item_id"   => $eachItem['id'],

                                "product_id"        => $eachItem['product_id'],

                                "part_number"       => $eachItem['product']['part_number'],

                                "description"       => $eachItem['description'],

                                "bar_code"          => $eachItem['product']['barcode'],

                                "quantity"          => $eachItem['quantity'],

                                "rate"              => $eachItem['rate'],

                                "amount"            => $eachItem['amount'],

                                "excise_percentage" => $eachItem['excise_percentage'],

                                "excise_amount"     => $eachItem['excise_amount'],

                                "tax_percentage"    => $eachItem['tax_percentage'],

                                "tax_amount"        => $eachItem['tax_amount'],

                                "net_amount"        => $eachItem['net_amount'],

                                "unit"              => $eachItem['unit'],

                                "unit_name"         => $eachItem['units']['unit_name'],

                            ];
                        }







                        if ($valid) {



                            $data['status']            = "success";

                            $data['company_name']      = $company_name;

                            $data['company_address']   = $company_address;

                            $data['company_phone']     = $company_phone;

                            $data['id']                = $modelInvoice['id'];

                            $data['invoice_no']        = $modelInvoice['invoice_no'];

                            $data['invoice_date']      = date("d/m/Y", strtotime($modelInvoice['invoice_date']));

                            $data['customer_name']     = $modelInvoice['customer']['customer_name'];

                            $data['customer_address']  = $modelInvoice['customer']['address'];

                            $data['customer_trn_no']   = $modelInvoice['customer']['trn_no'];

                            $data['customer_phone_no'] = $modelInvoice['customer']['phone'];

                            $data['sales_man']         = $modelInvoice['si_salesman']['full_name'];

                            $data['salesman_phone']    = $modelInvoice['si_salesman']['phone_no'];

                            $data['payment_term_id']      = $modelInvoice['pay_term']['id'];

                            $data['payment_term']      = $modelInvoice['pay_term']['payment_term_name'];

                            $data['total_amount']      =  number_format((float)$modelInvoice['total_amount'], 3, '.', '');  

                            $data['excise_total']      =  number_format((float)$modelInvoice['excise_total'], 3, '.', ''); 

                            $data['tax_total']         = number_format((float)$modelInvoice['tax_total'], 3, '.', '');  

                            $data['grand_total']       =  number_format((float)$modelInvoice['grand_total'], 3, '.', '');

                            $data['posted']            = $modelInvoice['posted'];

                            $data['invoice_type']      = ($modelInvoice['invoice_type'] == 1) ? 'Tax Invoice' : 'Export Invoice';

                            $data['created_datetime']  =  date("d/m/Y", strtotime($modelInvoice['created_time']));

                            $data['invoice_item_list'] = $item_list;

                            $data['total_items']       = $item_count;
                        } else {

                            $err_msg = implode(',', $other);

                            $data = ['status' => "failed", "msg" => $err_msg];
                        }
                    } else {

                        $data = array('status' => "failed", "msg" => "Invoice not Found");
                    }
                } else {

                    $data = array('status' => "failed", "msg" => "Invoice ID not Given");
                }
            } else {

                $this->_401;
            }
        } catch (Exception $e) {

            header("HTTP/1.1 404 not found");

            header('Content-Type: application/json');

            $data = array('status' => "failed", "msg" => "Unexpected Server error");
        }





        echo json_encode($data);
    }







    public function actionOrderConvert()

    {



        // try {

        $data = [];

        $other = [];

        $valid = true;

        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);

        $userModel = MasUsers::model()->findBytoken($token);

        $input = file_get_contents('php://input');

        $variables = json_decode($input, true);

        if ($userModel->id > 0) {

            $invoice_no = $variables['invoice_id'];

            $order_id = $variables['order_id'];

            $userModel->db();





            if ((int) $order_id > 0) {

                $ordermodel = new OrderCollect();

                $modelorder = $ordermodel->findByPk($order_id);

                if (!empty($modelorder)) {



                    $modelOrderItems = OrderCollectItem::model()->findAll(array('condition' => 'order_id="' . $order_id . '"'));



                    $company_name    = $modelorder->oc_outlet_det->companyDetails->name;

                    $company_address = trim($modelorder->oc_outlet_det->companyDetails->billing_address);

                    $company_phone   = $modelorder->oc_outlet_det->companyDetails->phone;





                    $item_list = [];

                    $total_discount = 0;

                    $total_wo_vat = 0;

                    $total_amount = 0;

                    $item_count = 0;

                    foreach ($modelOrderItems as $eachItem) {

                        $item_count++;





                        $storemodel = Inventory::model()->find(array('select' => 't.id,t.part_number,t.description,t.rate,t.tax,t.unit,t.excise_tax', 'condition' => 'id=' . $eachItem->product_id));

                        $consider_previous_sprice = MasOutlets::model()->findByPk($modelorder->outlet)->consider_previous_sprice;

                        if ($consider_previous_sprice == 'Y' && $eachItem->rate == 0) {

                            $mod_pre_his = StockLedger::model()->with('sales_det')->find(array('condition' => 't.type ="SI" and sales_det.customer_id =' . $modelorder->customer_id . ' AND product_id =' . $eachItem->product_id, 'order' => 't.id DESC'));

                            if (empty($mod_pre_his))

                                $rate = $storemodel->rate;

                            else {

                                $rate = $mod_pre_his->rate / $mod_pre_his->unit_exchange_rate * $storemodel->unit_exchange_rate;
                            }
                        } else {

                            $rate = $eachItem->rate;
                        }

                        $cost = StockLedger::getAvgPurchaseRate($eachItem->product_id, '', $modelorder->outlet);

                        $excise_percentage  = $storemodel->excise_tax;

                        if ($eachItem->oc_unit->unit_exchange_rate > 0) {

                            $unit_price = $eachItem->rate / $eachItem->oc_unit->unit_exchange_rate;

                            $unit_cost = $cost / $eachItem->oc_unit->unit_exchange_rate;

                            $unit_exchange = $eachItem->oc_unit->unit_exchange_rate;
                        } else {

                            $unit_cost = $cost / $storemodel->unit_exchange_rate;

                            $unit_exchange = $storemodel->unit_exchange_rate;

                            $unit_price = $rate / $storemodel->unit_exchange_rate;
                        }





                        $item_list[] = [

                            "invoice_item_id"   => $eachItem['id'],

                            "product_id"        => $eachItem['product_id'],

                            "part_number"       => $eachItem['oc_product']['part_number'],

                            "description"       => $eachItem['description'],

                            "bar_code"          => $eachItem['oc_product']['barcode'],

                            "quantity"          => $eachItem['quantity'],

                            "rate"              => $eachItem['rate'],

                            "amount"            => $eachItem['amount'],

                            "excise_percentage" => $excise_percentage,

                            "tax_percentage"    => $eachItem['tax_percentage'],

                            "tax_amount"        => $eachItem['tax_amount'],

                            "net_amount"        => $eachItem['net_amount'],

                            "unit"              => $eachItem['unit_id'],

                            "unit_name"         => $eachItem['oc_unit']['unit_name'],

                            "unit_price"        => $unit_price,

                            "unit_cost"         => $unit_cost,

                            "unit_exchange"     => $unit_exchange,

                        ];
                    }







                    if ($valid) {



                        $data['status']            = "success";

                        $data['order_collect_id']  = $order_id;

                        $data['invoice_date']      = date("d/m/Y", strtotime($modelorder['order_date']));

                        $data['customer_id']     = $modelorder['customer_id'];

                        $data['customer_name']     = $modelorder['oc_customer_det']['customer_name'];

                        $data['salesman_id']         = $modelorder['salesman_id'];

                        $data['sales_man_name']    = $modelorder['oc_salesman_det']['full_name'];

                        $data['outlet']            = $modelorder['outlet'];

                        $data['invoice_type']     = ($modelorder['invoice_type'] == 1) ? true : false;

                        $data['invoice_item_list'] = $item_list;

                        $data['total_items']       = $item_count;
                    } else {

                        $err_msg = implode(',', $other);

                        $data = ['status' => "failed", "msg" => $err_msg];
                    }
                } else {

                    $data = array('status' => "failed", "msg" => "Order not Found");
                }
            } else {

                $data = array('status' => "failed", "msg" => "Order ID not Given");
            }
        } else {

            $this->_401;
        }

        /* } catch (Exception $e) {

            header("HTTP/1.1 404 not found");

            header('Content-Type: application/json');

            $data = array('status' => "failed", "msg" => "Unexpected Server error");

        }*/





        echo json_encode($data);
    }





    public function actionSave()

    {

        $input = file_get_contents('php://input');

        error_log('save_sales');

        error_log($input);

        $variables = json_decode($input, true);

        $valid = true;

        $invoice_date = trim($variables['invoice_date']);

        $id = trim($variables['id']);

        $customer = trim($variables['customer']);

        $sales_man = trim($variables['salesman']); //new

        $lpo = trim($variables['lpo']);

        $currency = trim($variables['currency']);

        $payment_term = (int) trim($variables['payment_term']);

        $credit_days = trim($variables['credit_days']);

        $order_collect_id = (int) trim($variables['order_collect_id']);

        $taxable = $variables['taxable'] == true ? true : false;

        $cash_paid = $variables['cash_paid'] == true ? true : false;

        $amount_paid = (float) $variables['amount_paid'];

        $amount_discount = (float) $variables['discount_amount'];

        $exclude_tax = $variables['exclude_tax'];

        $invoiceItems = $variables['items'];

        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);

        $userModel = MasUsers::model()->findBytoken($token);

        $total_tax_amount = 0;

        $other = [];

        if ($userModel->id > 0) {



            $userModel->db();



            if ($currency > 0) {

                $currency_id = $currency;

                $exchange_rate = MasCurrency::getCurrencyDetails($currency)->exchange_rate;
            } else {

                $currency_id =  MasCurrency::base_currency_id();

                $exchange_rate =  MasCurrency::base_exchange_rate();
            }

            if ($customer > 0) {

                $model = new SalesInvoice();

                $modelformmaster = FormMaster::model()->find(array('condition' => 'outlet=' . $userModel->outlet_id . ' AND code="SI"'));

                if ($taxable == true) {

                    $modelformmaster = FormMaster::model()->find(array('condition' => 'outlet=' . $userModel->outlet_id . ' AND code="TSI"'));

                    if (empty($modelformmaster)) {

                        $modelformmaster = FormMaster::model()->find(array('condition' => 'outlet=' . $userModel->outlet_id . ' AND code="SI"'));
                    }
                }

                if ($id > 0) {

                    $model = $model->findBypk($id);

                    $scene = 'update';

                    $change_type = 'UPDATED';

                    if ($userModel->outletDetails->voucher_edit == "N") {

                        $other[] = 'Edit Not Pssible';

                        $valid = false;
                    }
                } else {

                    $model->created_by = $userModel->id;

                    $model->created_time = date('Y-m-d H:i:s');

                    $scene = 'new';

                    $change_type = 'CREATED';

                    if (!empty($modelformmaster)) {

                        $model->invoice_no = $modelformmaster->next_number;
                    } else {

                        $model->invoice_no = 1;
                    }
                }



                $model->order_collect_id = $order_collect_id;

                $model->updated_by = $userModel->id;

                $model->updated_time = date('Y-m-d H:i:s');

                $model->invoice_date = count(explode('-', $invoice_date)) == 3 ? $invoice_date : date('Y-m-d');

                $model->customer_id = $customer;

                $model->payment_term = (int) $payment_term;

                $model->total_amount = 0;

                $model->reference_no = $lpo;

                $model->posted = "Y";

                $model->callback_from = 'app';

                $model->excise_total = 0;

                $model->tax_total = 0;

                $model->grand_total = 0;

                $model->currency = $currency_id;

                $model->exchange_rate = $exchange_rate;

                $model->outlet = $userModel->outlet_id;

                $model->sales_man = ($sales_man > 0) ? $sales_man : $userModel->id;

                $model->received = $amount_paid;

                $model->discount = (float)$amount_discount;

                $model->exclude_tax = $exclude_tax == true ? "Y" : "N";

                $model->taxable = $taxable == true ? "Y" : "N";

                $model->invoice_type = $taxable == true ? "1" : "2"; // here we consider  $taxable as  invoice_type
                
                $duplicate_item_save = MasOutlets::model()->findByPk($userModel->outlet_id)->duplicate_item_save;
                
                $i = 0;

                $total_vat = 0;

                $total_excise_amount = 0;

                $grand_total = 0;

                $total_sales = 0;

                $total_discount = 0;



                $groups = array();
                $arr_pdts = array();



                $reversedInvoiceItems = array_reverse($invoiceItems);





                foreach ($reversedInvoiceItems as $each) {

                    if ($each['product_id'] > 0) {



                        $productModel = Inventory::model()->findBypk($each['product_id']);

                        $items[$i] = new SalesInvoiceItems;

                        $items[$i]->product_id = $each['product_id'];

                        $items[$i]->description = $productModel->description;

                        $items[$i]->quantity = (float) $each['quantity'];

                        //                        $items[$i]->rate = (float) $each['rate'];

                      

                        if($model->exclude_tax =='N'){ 

                            $each['price'] =  (((float) $each['price'] *100) / ($each['tax_percentage']+100));
                        }else{
                            $each['price'] = (float) $each['price'];
                        }

                       // print_r($each['price']); exit;

                        $items[$i]->rate = (float) $each['price'];
                        
                        $items[$i]->unit = $each['unit'];

                        //Amount

                        $amount = round(((float) $each['quantity'] * (float) $each['price']), 6);

                        $items[$i]->amount = round($amount, 6);

                        $items[$i]->invoice_id = 0;



                        $items[$i]->tax_percentage =  $each['tax_percentage'];  //$productModel->taxDetails->tax_percentage;

                        $items[$i]->tax_amount = $taxable ? round((($amount * $each['tax_percentage']) / 100), 6) : 0;

                        $items[$i]->net_amount = $items[$i]->tax_amount + round($amount, 6);

                        if ($each['unit'] > 0) {

                            $unit = MasUnit::model()->findByPk($each['unit']);

                            $unit_exchange = $unit->unit_exchange_rate;
                        } else {

                            $items[$i]->unit = $productModel->unit;

                            $unit_exchange = 1;
                        }

                        $mini_selling_price = 'N';

                        if ($userModel->outlet_id > 0) {

                            $mod_mas_outlet = MasOutlets::model()->findByPk($userModel->outlet_id);

                            $consider_sp_not_less_cp = $mod_mas_outlet->consider_sp_not_less_cp;

                            $mini_selling_price = $mod_mas_outlet->mini_selling_price;
                        }

                        // ------------------dupilcate--------------------------------

                        $unit = MasUnit::model()->findByPk($each['unit']);

                        // Construct the composite key using product_id and unit

                        $compositeKey = $each['product_id'] . '-' . $each['unit'];



                        // Check if the composite key already exists

                        if (in_array($compositeKey, $arr_pdts)) {
                            if ($duplicate_item_save == 'N') {
                                $valid = false; // Mark validation as failed
                                $other[] = 'Product ' . $productModel->part_number . ' with Unit ' . $unit->label . ' is duplicated ,Line No:-' . ($i + 1);
                            }
                        } else {

                            // Add the composite key to the array

                            $arr_pdts[] = $compositeKey;
                        }

                        // --------------------------------------------------

                        if ($consider_sp_not_less_cp == "Y") {

                            $cost = StockLedger::getAvgPurchaseRate($each['product_id'], '', $userModel->outlet_id);

                            if ($unit_exchange > 0) {

                                $unit_price = (float) $each['price'] / $unit_exchange;

                                $unit_cost = $cost / $unit_exchange;
                            }





                            if ($unit_price < $unit_cost) {

                                $product = Inventory::model()->findByPk($each['product_id']);

                                $other[] = $product->part_number . ' rate should be greater than cost price';

                                $valid = false;
                            }
                        }

                        if ($mini_selling_price == "Y") {

                            $product = Inventory::model()->findByPk($each['product_id']);

                            if ($each['price']  < $product->rate_b) {

                                $other[] = $product->part_number . ' rate should be greater than Sales Price A' . $product->rate_a;

                                $valid = false;
                            }
                        }

                        // --------------------------------------------------



                        $key = $each['product_id'];

                        if (!array_key_exists($key, $groups)) {

                            $groups[$key] = array(

                                'id' => $each['product_id'],

                                'quantity' => $each['quantity'] * $unit_exchange,

                            );
                        } else {

                            $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['quantity'] * $unit_exchange;
                        }



                        $total_amount += $amount;

                        $grand_total_amount += $amount;

                        $total_vat += round((float) $items[$i]->tax_amount, 6);

                        $grand_total += round((float) $items[$i]->tax_amount, 6);

                        $grand_total += round((float) $amount, 6);



                        if ($productModel->type == 'I') {

                            $total_sales += round(((float) $each['quantity'] * (float) $each['price']), 6);
                        }







                        $i++;
                    }
                }







                // QTY Checking

                if (!empty($groups)) {

                    foreach ($groups as $key => $eachProduct) {

                        $product = Inventory::model()->findByPk($key);

                        if ($product->type != 'S') {

                            $qty = Yii::app()->db->createCommand("select SUM(quantity*U.unit_exchange_rate) from {{sales_invoice_items}} S INNER JOIN {{master_unit}} U ON S.unit=U.id where invoice_id='" . $model->id . "' AND product_id='" . $key . "'")->queryScalar();

                            $bal = $eachProduct['quantity'] - $qty;

                            $in_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='" . $key . "' AND outlet=" . $userModel->outlet_id . " AND created_by=" . $model->sales_man . " AND transaction_date<='" . $model->invoice_date . "'")->queryScalar();

                            $out_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='" . $key . "' AND outlet=" . $userModel->outlet_id . " AND created_by=" . $model->sales_man . " AND transaction_date<='" . $model->invoice_date . "'")->queryScalar();

                            $current_stock = $in_qty - $out_qty;

                            if ($bal > 0 && $current_stock < $bal) {

                                $other[] = $product->part_number . ' maximum sellable qty : ' . ($current_stock + $qty) . ' ' . $product->units->unit_name;

                                $valid = false;
                            }
                        }
                    }
                }



                if (date('Y-m-d') != $model->invoice_date && $userModel->access_type == 'SL' && $userModel->outletDetails->date_edit_salesman == "N") {

                    $other[] = 'Date Should Be Current Date.';

                    $valid = false;
                }



                $model->total_amount = $total_amount;

                $model->excise_total = $total_excise_amount;

                $model->tax_total = $total_vat;

                $model->grand_total = $grand_total;

                $creditlimit = Customer::model()->findByPK($model->customer_id)->credit_limit;

                $customer_subledger = $this->getSublegder($model->customer_id, 1);

                $customer_ledger = FinanceSystemAccountsMapping::getSystemdefault('debtors');

                $current_credit = Yii::app()->db->createCommand("select SUM(I.amount) from erp_finance_voucher_items I INNER JOIN erp_finance_voucher_head H ON H.id=I.header_id where H.is_posted='Y' AND ledger_id='$customer_ledger' AND subledger_id='$customer_subledger'")->queryScalar();

                $creditlimit -= $current_credit;

                //add code for getting finance credit here and add it with creditlimit

                if ($creditlimit < ($grand_total - ($model->received + $model->discount))) {

                    $other[] = 'Customer credit limit exceeded ';

                    $valid = false;
                }

                if (($model->received + $model->discount) > round($grand_total, 2)) {

                    $other[] = 'Received amount can not greater than invoice amount';

                    $valid = false;
                }

                /*if (($model->received + $model->discount) < round($grand_total,2)) {

                //$model->payment_term = 2;

            } else if (($model->received + $model->discount) == round($grand_total,2)) {

                $model->payment_term = 1;

            }*/



                $closing_date = MasClosing::getClosingDate();

                if ($closing_date >= $model->invoice_date) {

                    $other[] = 'Date should be greater than closing date (' . date('d-m-Y', strtotime($closing_date)) . ')';

                    $valid = false;
                }



                if ($valid && $model->validate() && is_array($items)) {



                    $model->callback_from = 'app';

                    $model->save();

                    if ((int)$model->order_collect_id > 0) {

                        OrderCollect::model()->updateByPk((int)$model->order_collect_id, array('is_invoiced' => 'Y'));
                    }

                    if ($scene == 'new') {

                        $next_no = $model->invoice_no + 1;

                        if ($modelformmaster->id > 0) {

                            FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
                        } else {

                            $modelform = new FormMaster();

                            $modelform->next_number = $next_no;

                            $modelform->outlet = $userModel->outlet_id;

                            $modelform->code = "SI";

                            $modelform->title = "Sales Invoice";

                            $modelform->save(false);
                        }
                    }



                    Yii::app()->db->createCommand("delete from {{stock_ledger}} where transaction_type='OUT' AND type='SI' AND header_id='" . $model->id . "' AND outlet=" . $userModel->outlet_id)->execute();

                    Yii::app()->db->createCommand("delete from {{sales_invoice_items}} where invoice_id='" . $model->id . "'")->execute();

                    $total_amount = 0;

                    $total_tax_amount = 0;

                    $total_excise_amount = 0;

                    $grand_total = 0;

                    foreach ($items as $eachItem) {

                        $eachItem->invoice_id = $model->id;

                        $total_amount += $eachItem->amount;

                        $total_tax_amount += $eachItem->tax_amount;

                        $total_excise_amount += $eachItem->excise_amount;

                        $eachItem->save(false);

                        $grand_total += $eachItem->net_amount;



                        $stockledger = new StockLedger;

                        $stockledger->transaction_date = $model->invoice_date;

                        $stockledger->transaction_type = 'OUT';

                        $stockledger->type = 'SI';

                        $stockledger->customer_vendor_id = $model->customer_id;

                        $stockledger->header_id = $model->id;

                        $stockledger->item_id = $eachItem->id;

                        $stockledger->product_id = $eachItem->product_id;

                        $stockledger->rate = $eachItem->rate;

                        $stockledger->currency = 1;

                        $stockledger->exchange_rate = 1;

                        $stockledger->quantity = $eachItem->quantity;

                        $stockledger->unit = $eachItem->unit;

                        $stockledger->default_product_unit = $eachItem->units->base_unit_id;

                        $stockledger->unit_exchange_rate = $eachItem->units->unit_exchange_rate;

                        $stockledger->outlet = $userModel->outlet_id;

                        $stockledger->created_by = $model->sales_man;

                        $stockledger->created_time = date('Y-m-d H:i:s');

                        $stockledger->save(false);
                    }

                    // inserting to audit log

                    AuditLog::saveApiAuditLogs(

                        $userModel->outlet_id,

                        $modelformmaster->id,

                        $userModel->id,

                        $change_type,

                        " with ID - {$model->id} and grandtotal -{$grand_total} "

                    );

                    // end audit log

                    $model->total_amount = $total_amount;

                    $model->excise_total = $total_excise_amount;

                    $model->tax_total = $total_tax_amount;

                    $model->grand_total = $grand_total;

                    $model->save();

                    $this->invoicePosting($model->id);

                    $this->responseBody['status'] = 'success';

                    $this->responseBody['voucher_id'] = $model->id;

                    $this->_bind;
                } else {

                    $this->responseBody['status'] = 'failed';

                    $error1 = json_decode(CActiveForm::validate($model, '', false), true);

                    if (!empty($items))

                        $error2 = json_decode(CActiveForm::validateTabular($items, '', false), true);

                    else

                        $error2[] = "Please add atleast one line item";

                    $error = array_merge_recursive($error1, $error2, $other);

                    $arr_err = $other;

                    foreach ($error as $key => $errval) {

                        $arr_err[] = $errval[0];
                    }

                    $err_msg = implode(',', $arr_err);

                    $this->responseBody['msg'] = $err_msg;

                    $this->_400;
                }
            } else {

                $this->responseBody['status'] = 'failed';

                $this->responseBody['msg'] = 'Invalid Customer';

                $this->_400;
            }
        } else { //usermodel

            $this->_401;
        }
    }
}
