<?php


class ApilistController extends Controller
{

    public $method = '_stream';
    public $round_off = '2';
    public $db_main = MasCompany::MAIN_DB;
    public $outlet_id;
    public $responseBody = array(
        'status' => 'success',
        'msg' => '',
        'count' => 0,
        'data' => array(),
    );
    public $permissions = array(
        'view_cost_price' => true,
    );


    public function accessRules()
    {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array(
                    'GetReceiptvoucherlist', 'GetPaymentvoucherlist', 'GetExpenseLedgerslist', 'GetExpenseSubledgerslist', 'testfun'

                ),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array(),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters()
    {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    public function save_request($request)
    {
        // if ($request != '') {
        //     Yii::app()->response->createCommand("INSERT INTO response (app_response) VALUES('" . $request . "')")->execute();
        // }
        return true;
    }

    public function get_401()
    {
        header("HTTP/1.1 401 Unauthorized");
        header('Content-Type: application/json');
        $this->responseBody['status'] = 'failed';
        $this->responseBody['msg'] = 'Unauthorized user';
        echo json_encode($this->responseBody);
    }

    public function get_400()
    {
        header("HTTP/1.1 400 Bad Request");
        header('Content-Type: application/json');
        echo json_encode($this->responseBody);
    }

    public function get_403()
    {
        header("HTTP/1.1 403  Forbidden");
        header('Content-Type: application/json');
        $this->responseBody['status'] = 'failed';
        $this->responseBody['msg'] = 'Forbidden user';
        echo json_encode($this->responseBody);
    }

    public function get_bind()
    {
        header("HTTP/1.1 200 OK");
        header('Content-Type: application/json');
        echo json_encode($this->responseBody);
    }

    public function format_currency($value)
    {
        return number_format(round((float) $value, $this->round_off), $this->round_off, '.', '');
    }

    public function get_set_permissions()
    {
        $this->responseBody['permissions']['have_purchase'] = true;
        $this->responseBody['permissions']['consider_min_sales_price'] = true;
        $this->responseBody['permissions']['have_financial_reports'] = true;
        $this->responseBody['permissions']['have_stock_adjustment'] = true;
        $this->responseBody['permissions']['view_cost_price'] = $this->permissions['view_cost_price'];
    }

    public function convert_date($date = null)
    {

        $date_converted = date('Y-m-d');

        if ($date != null) {
            //yyyy-mm-dd
            $arr_date = explode('-', $date);
            //mm/dd/yyyy
            if (checkdate($arr_date[1], $arr_date[2], $arr_date[0])) {
                $date_converted = date('Y-m-d', strtotime(str_replace('/', '-', $date)));
            }
        }
        return $date_converted;
    }

    public function actionHave_session()
    {
        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);
        $userModel = MasUsers::model()->with('outletDetails')->find(array('condition' => 't.token="' . $token . '" AND t.is_active="Y" AND t.access_type IN("SL", "CA","SM", "OM") AND outletDetails.is_active="Y"'));
        if ((int) $userModel->id > 0) {
            $this->responseBody['status'] = 'success';
            $this->responseBody['msg'] = 'Session is valid';
            $this->_bind;
        } else {
            $this->_401;
        }
    }

    public function connectMainDB($company_db_name)
    {
        Yii::app()->db->setActive(false);
        if (empty($company_db_name)) {
            $company_db_name = '=bluesell_new_main';
        }
        Yii::app()->db->connectionString = 'mysql:host=e-sell.me;dbname=bluesell_new_main';
        Yii::app()->db->username = 'bluesell_newadmn';
        Yii::app()->db->password = 'DKe=?ok*+KD}';
        Yii::app()->db->tablePrefix = 'erp_';
        Yii::app()->db->setActive(true);
    }


    //changed


    // ------------------------------ Receipt voucher list-------------------------------------------------------------------------

    public function actionGetReceiptvoucherlist()
    {
        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);
        $userModel = MasUsers::model()->findBytoken($token);
        $input     = file_get_contents('php://input');
        $variables = json_decode($input, true);
        $date      = trim($variables['date']);
        if ($date == '') {
            $date = date('Y-m-d');
        }

        if ($userModel->id > 0) {
            $userModel->db();

            $modelVT = new FinanceVoucherType();
            $modelVT = $modelVT->find(array('condition' => 'code="CA"'));
            if (!empty($modelVT)) {
                $vt_id = $modelVT->id;
                $condition = 'H.voucher_type_id="' . $vt_id . '" AND H.outlet="' . $userModel->outlet_id . '"   ';
                $model = Yii::app()->db->createCommand('SELECT H.voucher_no,H.voucher_date,H.ledger,H.voucher_no,H.subledger,
                H.reference_no,H.narration,H.total_voucher_amount,H.is_posted,H.is_allocated
                 FROM {{finance_voucher_head_list}}  H WHERE ' . $condition . '')->queryAll();

                $count = 0;
                foreach ($model as $i => $each) {
                    $this->responseBody['data'][$i]['voucher_no']             = $each['voucher_no'];
                    $this->responseBody['data'][$i]['voucher_date']           = date("d/m/Y", strtotime($each['voucher_date']));
                    $this->responseBody['data'][$i]['ledger']                 = nl2br(str_replace(',', PHP_EOL, $each['ledger']));
                    $this->responseBody['data'][$i]['subledger']              = nl2br(str_replace(',', PHP_EOL, $each['subledger']));
                    $this->responseBody['data'][$i]['reference_no']           = $each['reference_no'];
                    $this->responseBody['data'][$i]['narration']              = $each['narration'];
                    $this->responseBody['data'][$i]['total_voucher_amount']   = $each['total_voucher_amount'];
                    $this->responseBody['data'][$i]['is_posted']              = $each['is_posted'];
                    $this->responseBody['data'][$i]['is_allocated']           = $each['is_allocated'];
                    $count++;
                }
                $this->responseBody['count'] = $count;
                $this->_bind;
            } else {
                $this->responseBody['msg'] = 'Receipt Not found';
                $this->responseBody['status'] = 'failed';
                $this->_400;
            }
        } else {
            $this->_401;
        }
    }


    // ---------------------------Payment list-----------------------------------

    public function actionGetPaymentvoucherlist()
    {
        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);
        $userModel = MasUsers::model()->findBytoken($token);
        $input = file_get_contents('php://input');
        $variables = json_decode($input, true);
        $date   = trim($variables['date']);
        if ($date == '') {
            $date = date('Y-m-d');
        }

        if ($userModel->id > 0) {
            $userModel->db();

            $modelVT = new FinanceVoucherType();
            $modelVT = $modelVT->find(array('condition' => 'code="PV"'));
            if (!empty($modelVT)) {
                $vt_id = $modelVT->id;
                $condition = 'H.voucher_type_id="' . $vt_id . '" AND H.outlet="' . $userModel->outlet_id . '"   ';
                $model = Yii::app()->db->createCommand('SELECT H.voucher_no,H.voucher_date,H.ledger,H.voucher_no,H.subledger,
                H.reference_no,H.narration,H.total_voucher_amount,H.is_posted,H.is_allocated
                 FROM {{finance_voucher_head_list}}  H WHERE ' . $condition . '')->queryAll();
                $count = 0;
                foreach ($model as $i => $each) {
                    $this->responseBody['data'][$i]['voucher_no']             = $each['voucher_no'];
                    $this->responseBody['data'][$i]['voucher_date']           = date("d/m/Y", strtotime($each['voucher_date']));
                    $this->responseBody['data'][$i]['ledger']                 = nl2br(str_replace(',', PHP_EOL, $each['ledger']));
                    $this->responseBody['data'][$i]['subledger']              = nl2br(str_replace(',', PHP_EOL, $each['subledger']));
                    $this->responseBody['data'][$i]['reference_no']           = $each['reference_no'];
                    $this->responseBody['data'][$i]['narration']              = $each['narration'];
                    $this->responseBody['data'][$i]['total_voucher_amount']   = $each['total_voucher_amount'];
                    $this->responseBody['data'][$i]['is_posted']              = $each['is_posted'];
                    $this->responseBody['data'][$i]['is_allocated']           = $each['is_allocated'];
                    $count++;
                }
                $this->responseBody['count'] = $count;
                $this->_bind;
            } else {
                $this->responseBody['msg'] = 'Payment Not found';
                $this->responseBody['status'] = 'failed';
                $this->_400;
            }
        } else {
            $this->_401;
        }
    }

    // ---------------------------Expense Ledger  list-----------------------------------

    public function actionGetExpenseLedgerslist()
    {
        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);

        $userModel = MasUsers::model()->findBytoken($token);
        $input     = file_get_contents('php://input');
        $variables = json_decode($input, true);
        if ($userModel->id > 0) {
            $userModel->db();
            $expense_accounts = FinanceLegder::model()->findAll(array('condition' => 'main_account_type="E" AND isParent="N"', 'order' => 'description'));

            if (!empty($expense_accounts)) {
                $count = 0;
                foreach ($expense_accounts as $i => $each) {
                    $this->responseBody['data'][$i]['id']           = $each['id'];
                    $this->responseBody['data'][$i]['description']  = $each['description'];
                    $count++;
                }
                $this->responseBody['count'] = $count;
                $this->_bind;
            } else {
                $this->responseBody['msg'] = 'No Ledgers found';
                $this->responseBody['status'] = 'failed';
                $this->_400;
            }
        } else {
            $this->_401;
        }
    }

    // ---------------------------Expense Subledgers list-----------------------------------

    public function actionGetExpenseSubledgerslist()
    {
        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);
        $userModel = MasUsers::model()->findBytoken($token);
        $input     = file_get_contents('php://input');
        $variables = json_decode($input, true);
        $ledger      = trim($variables['ledger']);
        $searchTerm  = trim($variables['term']);

        if ($userModel->id > 0) {
            $userModel->db();
            if ((int)$ledger > 0) {
                $modelFinanceLegder       = new FinanceLegder();
                $legderModel          = $modelFinanceLegder->findBypk($ledger);

                $subledger_types      = $legderModel->subledger_types;
                $subledger_types_list = explode(',', $subledger_types);

                if (!empty(array_filter($subledger_types_list, 'strlen'))) {

                    foreach ($subledger_types_list as $key => $row) {
                        $condition  = '(description LIKE "%' . $searchTerm . '%" OR description LIKE "%' . $searchTerm . '%")';
                        $condition .= 'AND subledger_type_id IN (' . $row . ')';
                        $limit      = 50;
                        $query = 'SELECT * FROM {{finance_subledger}} WHERE ' . $condition . ' ORDER BY description LIMIT ' . $limit;
                        $model = Yii::app()->db->createCommand($query)->queryAll();
                        $count = 0;
                        foreach ($model as $i => $each) {
                            $this->responseBody['data'][$i]['id']           = $each['id'];
                            $this->responseBody['data'][$i]['description']  = $each['description'];
                            $count++;
                        }
                    }
                    $this->responseBody['count'] = $count;
                    $this->_bind;
                } else {
                    $this->responseBody['msg'] = 'No subledger was found';
                    $this->responseBody['status'] = 'failed';
                    $this->_400;
                }
            } else {
                $this->responseBody['msg'] = 'Please Select Ledger First';
                $this->responseBody['status'] = 'failed';
                $this->_400;
            }
        } else {
            $this->_401;
        }
    }
    public function actiontestfun()
    {
        $input = file_get_contents('php://input');
        $variables = json_decode($input, true);
        $ledgertype = $variables['type'];
        $ledgerData = $variables['data'];
        $token     = '292-1689688517';
        $userModel = MasUsers::model()->findBytoken($token);
        if ($userModel->id > 0) {
            $ledgerData['credit_limit']=2900;
            $outlet_id = $userModel->outlet_id;
            $credit_limit = 0;
            if ((int)$outlet_id > 0) {
                $modelMasOutlets = new MasOutlets();
                $credit_limit_edit_salesman = $modelMasOutlets->findByPK($outlet_id)->credit_limit_edit_salesman;
                $credit_limit = ($credit_limit_edit_salesman == 'Y') ? (float) $ledgerData['credit_limit'] : 0;
            }

            print_r($credit_limit);
            exit;
        }
    }
    //end

}
