<?php
// modified by binzy.b.s 20/4/2022
// e-sell reports
class CostofsaleController extends Controller
{

    public function accessRules()
    {

        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array(
                    'Brandwise_Sales', 'Cost_html', 'Invoice_cost_html', 'PrintReportItemsPDF', 'PrintReportItemsExcel', 'PrintReportInvoicePDF', 'PrintReportInvoiceExcel', 'ItemSales_summary', 'Items_sales_summary_html', 'PrintReportsalesPDF', 'PrintReportsalesExcel', 'Itempurchase_summary', 'Items_Purchase_summary_html', 'PrintReportpurchasePDF','PrintReportpurchaseExcel','Sales_Summary_report', 'Sales_summary_html', 'PrintSalesSummaryPDF', 'PrintSalesSummaryExcel', 'Customer_Sales', 'statement_html', 'Statement_pdf', 'Statement_excel',
                ),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters()
    {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    public function actionBrandwise_Sales()
    {
        $this->render('cost_report');   // filter page in views
    }
    public function actionItemSales_summary()
    {
        $this->render('items_salesreport'); // filter page in views
    }
    public function actionItempurchase_summary()
    {
        $this->render('items_purchasereport'); // filter page in views
    }
    public function actionSales_Summary_report()
    {
        $this->render('sales_summaryreport'); // filter page in views
    }
    public function actionCustomer_Sales()
    {
        $this->render('customer_report');
    }
    /* Sales&Purchase-Brandwise Sales Items report*/
    public function actionCost_html()
    {
        set_time_limit(1000);
        $outlet = (int) $_POST['outlet'];
        $payment_term = (int) $_POST['payment_term'];
        $customer_id = (int) $_POST['salesinvoice_customer_id'];
        $created_user = (int) $_POST['created_user'];
        $brand_id = (int) $_POST['brand_id'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = ' active="Y" AND invoice_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        if ($outlet > 0) {
            $condition .= ' AND outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        if ((int)$customer_id > 0) {
            $condition .= ' AND customer_id=' . $customer_id;
        }
        if ((int)$created_user > 0) {
            $condition .= ' AND sales_man=' . $created_user;
        }
        if ((int)$payment_term > 0) {
            $condition .= ' AND payment_term=' . $payment_term;
        }
        if ((int) $brand_id > 0) {
            $condition .= ' AND brand=' . (int) $brand_id;
        }
        /* $SQL = ' Select H.invoice_no,C.customer_name,I.description,I.net_amount,P.payment_term_name,I.quantity,I.rate,H.invoice_date,I.product_id,I.tax_amount,H.id AS invoice_id,I.id AS item_id,B.brand_name 
        from erp_sales_invoice H 
        INNER JOIN erp_sales_invoice_items I ON H.id=I.invoice_id 
        INNER JOIN erp_inventory S ON S.id=I.product_id 
        INNER JOIN erp_master_payment_terms P ON H.payment_term =P.id
        INNER JOIN erp_master_brand B ON B.id=S.brand
        INNER JOIN erp_customer C ON H.customer_id=C.id ' . $condition . ' order by H.id';*/

        $SQL = "SELECT * FROM view_invoice_list WHERE " . $condition . " order by invoice_no";
        //echo $SQL;
        //exit;
        $all = Yii::app()->db->createCommand($SQL)->queryAll();
        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:5%">No</th>
                            <th style="width:6%">Date</th>
                            <th style="width:6%">Invoice No</th>
                            <th style="width:20%">Customer</th>
                            <th style="width:15%">Part No.</th>
                            <th style="width:10%">Brand</th>
                            <th style="width:10%">Payment</th>
                            <th style="width:5%">Qty</th>
                            <th style="width:8%">Rate</th>
                            <th style="width:8%">Total</th>
                            <th style="width:5%">Tax</th>
                            <th style="width:5%">Net Total</th>
                        </tr>
                    </thead>
                <tbody>';
        $total_cost = 0;
        $total_profit = 0;
        $net = 0;
        $total_tax = 0;
        $total = 0;
        $k = 0;
        foreach ($all as $each) {
            $total = ($each['quantity'] * $each['rate']);
            $table .= '<tr>
         <td>' . ($k + 1) . '</td>
         <td>' . date("d-m-Y", strtotime($each['invoice_date'])) . '</td>
         <td>' . $each['invoice_no'] . '</td><td>' . $each['customer_name'] . '</td>
         <td>' . $each["product_id"] . '/' . $each['description'] . '</td>
         <td>' . $each['brand_name'] . '</td><td>' . $each['payment_term_name'] . '</td>
         <td>' . $each['quantity'] . '</td>
         <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['rate'], "") . '</td>
         <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</td>
         <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['tax_amount'], "") . '</td>
         <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['net_amount'], "") . '</td>
         </tr>';

            $tot += $total;
            //$total_cost += $qty * $current_in_rate;
            //$total_profit += $profit;
            $net += $each['net_amount'];
            $total_tax += $each['tax_amount'];

            $k++;
        }


        $table .= '<tr>
        <td colspan="9" style="text-align:right !important;"><b>Total</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot, " ") . '</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_tax, " ") . '</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($net, " ") . '</b></td></tr>';
        $table .= '</tbody>
                </table>';
        echo $table;
    }
    /* Sales&Purchase-Brandwise Sales Invoice report*/
    public function actionInvoice_cost_html()
    {
        $payment_term = (int) $_POST['payment_term'];
        $outlet = (int) $_POST['outlet'];
        $customer_id = (int) $_POST['salesinvoice_customer_id'];
        $created_user = (int) $_POST['created_user'];
        $brand_id = (int) $_POST['brand_id'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = 'H.active="Y" AND H.invoice_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        if ($outlet > 0) {
            $condition .= ' AND H.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        if ((int)$customer_id > 0) {
            $condition .= ' AND H.customer_id=' . $customer_id;
        }
        if ((int)$payment_term > 0) {
            $condition .= ' AND H.payment_term=' . $payment_term;
        }
        if ((int)$created_user > 0) {
            $condition .= ' AND H.sales_man=' . $created_user;
        }
        if ((int) $brand_id > 0) {
            $condition .= ' AND S.brand=' . (int) $brand_id;
        }

        // ---------------------------------


        $SQL = 'SELECT H.invoice_no, C.customer_name, I.description, I.net_amount, I.quantity, H.invoice_date, I.product_id, I.tax_amount, I.amount, ';
        $SQL .= 'CASE WHEN H.payment_term <> 0 THEN P.payment_term_name ELSE "-" END AS payment_term_name ';
        $SQL .= 'FROM erp_sales_invoice H ';
        $SQL .= 'INNER JOIN erp_sales_invoice_items I ON H.id = I.invoice_id ';
        $SQL .= 'INNER JOIN erp_inventory S ON S.id = I.product_id ';
        $SQL .= 'INNER JOIN erp_master_brand B ON B.id = S.brand ';
        $SQL .= 'INNER JOIN erp_customer C ON H.customer_id = C.id ';
        $SQL .= 'LEFT JOIN erp_master_payment_terms P ON H.payment_term = P.id AND H.payment_term <> 0 ';
        $SQL .= 'WHERE ' . $condition;
        $SQL .= ' ORDER BY H.id';

        //  echo ($SQL);
        $all = Yii::app()->db->createCommand($SQL)->queryAll();

        // -----------------
        /*  $SQL = ' Select H.invoice_no,C.customer_name,I.description,P.payment_term_name,I.net_amount,I.quantity,H.invoice_date,I.product_id,I.tax_amount,I.amount from erp_sales_invoice H 
       INNER JOIN erp_sales_invoice_items I ON H.id=I.invoice_id 
       INNER JOIN erp_inventory S ON S.id=I.product_id 
       INNER JOIN erp_master_payment_terms P ON H.payment_term =P.id
       INNER JOIN erp_master_brand B ON B.id=S.brand 
       INNER JOIN erp_customer C ON H.customer_id=C.id ' . $condition . ' order by H.id';
        $all = Yii::app()->db->createCommand($SQL)->queryAll();*/

        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:10%">Date</th>
                            <th style="width:10%">Invoice No</th>
                            <th style="width:25%">Customer</th>
                            <th style="width:10%">Payment</th>
                            <th style="width:5%">Total</th>
                            <th style="width:5%">Tax</th>
                            <th style="width:5%">Net Total</th>
                        </tr>
                    </thead>
                <tbody>';
        $total_cost = 0;
        $total_profit = 0;
        $total_sales = 0;
        $total_tax = 0;
        $inv_no = 0;
        $invoice_date = '';
        $customer_name = '';
        $net_amount = 0;
        $tax_amount = 0;
        $inv_cost = 0;
        $inv_profit = 0;
        $inv_profit_percent = 0;
        $inv_count = 1;
        $amount = 0;
        foreach ($all as $i => $each) {

            $current_in_rate = Yii::app()->db->createCommand('SELECT CASE
        WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
        FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND product_id=' . $each["product_id"] . ' AND transaction_date <= "' . $each['invoice_date'] . '" ' . $conditions)->queryScalar();

            $avg_cost = StockLedger::getAvgPurchaseRate($each["product_id"], $each['invoice_date'], $outlet);
            $profit = $each['net_amount'] - $each['tax_amount'] - ($each['quantity'] * $avg_cost);
            $cost = ($each['quantity'] * $avg_cost);
            if ($each['invoice_no'] != $inv_no && $i > 0) {
                if ($inv_cost != 0) {
                    $inv_profit_percent = $inv_profit / ($inv_cost) * 100;
                }

                $table .= '<tr><td>' . date("d-m-Y", strtotime($invoice_date)) . '</td><td>' . $inv_no . '</td><td>' . $customer_name . '</td><td>' . $payment_term_name . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($amount, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($tax_amount, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($net_amount, " ") . '</td></tr>';
                $inv_no = $each['invoice_no'];
                $invoice_date = $each['invoice_date'];
                $customer_name = $each['customer_name'];
                $payment_term_name = $each['payment_term_name'];
                $net_amount = $each['net_amount'];
                $amount = $each['amount'];
                $tax_amount = $each['tax_amount'];
                $inv_cost = $cost;
                $inv_profit = $profit;
                $inv_count = 1;
            } else {
                $inv_no = $each['invoice_no'];
                $invoice_date = $each['invoice_date'];
                $customer_name = $each['customer_name'];
                $payment_term_name = $each['payment_term_name'];
                $net_amount += $each['net_amount'];
                $amount += $each['amount'];
                $tax_amount += $each['tax_amount'];
                $inv_cost += $cost;
                $inv_profit += $profit;
                $inv_count++;
            }
            $tot += $each['amount'];
            $total_cost += $each['quantity'] * $avg_cost;
            $total_profit += $profit;
            $total_sales += $each['net_amount'];
            $total_tax += $each['tax_amount'];
        }
        if ($inv_cost != 0) {
            $inv_profit_percent = $inv_profit / ($inv_cost) * 100;
        }
        $table .= '<tr><td>' . date("d-m-Y", strtotime($invoice_date)) . '</td><td>' . $inv_no . '</td><td>' . $customer_name . '</td>
        <td>' . $payment_term_name . '</td>
        <td style="text-align:right !important;">' . $amount . '</td>
        <td style="text-align:right !important;">' . $tax_amount . '</td>
        <td style="text-align:right !important;">' . $net_amount . '</td></tr>';
        $percent = 0;
        if ($total_cost != 0) {
            $percent = ($total_sales - $total_cost) / $total_cost * 100;
        }

        $table .= '<tr>
        <td colspan="3" style="text-align:right !important;"><b>Total</b></td>
        <td></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot, " ") . '</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_tax, " ") . '</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_sales, " ") . '</b></td>
        
        </tr>';
        $table .= '</tbody>
                </table>';
        echo $table;
    }
    /* Inventory-Items Sales Summary report */
    public function actionItems_sales_summary_html()
    {
        $payment_term = (int) $_POST['payment_term'];
        $customer_id = (int) $_POST['customer_id'];
        $salesman = (int) $_POST['salesman'];
        $brand_id = (int) $_POST['brand_id'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = 'SL.type="SI" AND SL.transaction_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        $sr_condition = 'SL.type="SR" AND SL.transaction_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ';
        if ($customer_id) {
            $condition .= ' AND SL.customer_vendor_id =' . $customer_id;
            $sr_condition .= ' AND SL.customer_vendor_id =' . $customer_id;
        }
        if ($salesman) {
            $condition .= ' AND SL.created_by=' . $salesman;
            $sr_condition .= ' AND SL.created_by=' . $salesman;
        }
        if ((int) $brand_id > 0) {
            $condition .= ' AND P.brand=' . (int) $brand_id;
            $sr_condition .= ' AND P.brand=' . (int) $brand_id;
        }
        if ($payment_term) {
            $condition .= ' AND I.payment_term=' . $payment_term;
        }
        //echo $condition;

        $SQL = ' SELECT SL.id AS sl_id,"Sales Invoice" AS transaction_type,SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number,P.description,B.brand_name, SL.product_id, SL.customer_vendor_id, SL.created_by, I.invoice_no, C.customer_name, U.full_name, SL.quantity,SUM(SL.quantity*SL.unit_exchange_rate) as default_qty, SL.outlet,MU.label as unit_label,DU.label as default_unit_label,SUM(SL.rate*SL.exchange_rate*SL.quantity*SL.unit_exchange_rate) AS total_amount
FROM {{stock_ledger}} SL 
LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
INNER JOIN erp_master_brand B ON B.id=P.brand 
LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
LEFT JOIN {{sales_invoice}} I ON I.id=SL.header_id 
LEFT JOIN {{customer}} C ON C.id=SL.customer_vendor_id 
LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by 
WHERE ' . $condition . ' GROUP BY  SL.product_id  ';
        $all = Yii::app()->db->createCommand($SQL)->queryAll();
        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:6%">SL</th>
                            <th style="width:10%">Part No.</th>
                            <th style="width:15%">Description</th>
                            <th style="width:5%">Unit</th>
                            <th style="width:10%">Brand</th>
                            <th style="width:10%">Customer</th>
                             <th style="width:5%">Sales Qty</th>
                            <th style="width:5%">Return Qty</th>
                            <th style="width:5%">Total Qty</th>
                            <th style="width:5%">Total Amount</th>
                            <th style="width:5%">Avg Price</th>
    
                        </tr>
                    </thead>
                <tbody>';
        $sl = 1;
        $tot = 0;
        $total = 0;

        foreach ($all as $each) {

            $srsql = 'SELECT  SUM(SL.quantity*MU.unit_exchange_rate) as default_qty, SUM(SL.rate*SL.exchange_rate*SL.quantity*SL.unit_exchange_rate) AS total_amount
                FROM {{stock_ledger}} SL 
                LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit
                WHERE ' . $sr_condition . ' AND  SL.product_id=  ' . $each['product_id'];
            $sr_array = Yii::app()->db->createCommand($srsql)->queryRow();
            $default_qty = $each['default_qty'] - $sr_array['default_qty'];
            $amount = $each['total_amount'] - $sr_array['total_amount'];
            if ($default_qty != 0) {
                $avg = $amount / $default_qty;
            } else {
                $avg = 0;
            }

            $tot += $amount;
            $total += $avg;
            $tot_qty += $default_qty;
            if ($customer_id > 0) {
                $customer_name = $each['customer_name'];
            } else {
                $customer_name = 'ALL';
            }


            $table .= '<tr><td>' . $sl . '</td>
            <td>' . $each['part_number'] . '</td>
            <td>' . $each['description'] . '</td><td>' . $each['unit_label'] . '</td>
            <td>' . $each['brand_name'] . '</td><td>' . $customer_name . '</td>
            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['default_qty'], "") . '</td>
            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($sr_array['default_qty'], "") . '</td>
            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($default_qty, "") . '</td>
            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($amount, " ") . '</td>
            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($avg, "") . '</td>
            </tr>';
            $sl++;
        }

        $table .= '<tr>
        <td colspan="8" style="text-align:right !important;"><b>Total</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_qty, " ") . '</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot, " ") . '</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</b></td>
        </tr>';
        $table .= '</tbody>
                </table>';
        echo $table;
    }
    /* Inventory-Items Purchase Summary report */
    public function actionItems_Purchase_summary_html()
    {
        $vendor_id = (int) $_POST['vendor_id'];
        $salesman = (int) $_POST['salesman'];
        $brand_id = (int) $_POST['brand_id'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = 'SL.type="PI" AND SL.transaction_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        $sr_condition = 'SL.type="PR" AND SL.transaction_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ';
        if ($vendor_id) {
            $condition .= ' AND SL.customer_vendor_id =' . $vendor_id;
            $sr_condition .= ' AND SL.customer_vendor_id =' . $vendor_id;
        }
        if ($salesman) {
            $condition .= ' AND SL.created_by=' . $salesman;
            $sr_condition .= ' AND SL.created_by=' . $salesman;
        }
        if ((int) $brand_id > 0) {
            $condition .= ' AND P.brand=' . (int) $brand_id;
            $sr_condition .= ' AND P.brand=' . (int) $brand_id;
        }
        //echo $condition;


        $SQL = ' SELECT SL.id AS sl_id,"Purchase Invoice" AS transaction_type,SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number,P.description,B.brand_name, SL.product_id, SL.customer_vendor_id, SL.created_by, I.invoice_no, C.vendor_name, U.full_name, SL.quantity,SUM(SL.quantity*SL.unit_exchange_rate) as default_qty, SL.outlet,MU.label as unit_label,DU.label as default_unit_label,SUM(SL.rate*SL.exchange_rate*SL.quantity*SL.unit_exchange_rate) AS total_amount

FROM {{stock_ledger}} SL 
LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
INNER JOIN erp_master_brand B ON B.id=P.brand 
LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
LEFT JOIN {{sales_invoice}} I ON I.id=SL.header_id 
LEFT JOIN {{vendor}} C ON C.id=SL.customer_vendor_id 
LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by 
WHERE ' . $condition . ' GROUP BY  SL.product_id  ';
        $all = Yii::app()->db->createCommand($SQL)->queryAll();
        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:6%">SL</th>
                            <th style="width:10%">Part No.</th>
                            <th style="width:15%">Description</th>
                            <th style="width:5%">Unit</th>
                            <th style="width:10%">Brand</th>
                            <th style="width:10%">Vendor</th>
                            <th style="width:5%">Purchase Qty</th>
                            <th style="width:5%">Total Amount</th>
                            <th style="width:5%">Avg Price</th>
    
                        </tr>
                    </thead>
                <tbody>';
        $sl = 1;
        $tot = 0;
        $total = 0;

        foreach ($all as $each) {

            $srsql = 'SELECT  SUM(SL.quantity*SL.unit_exchange_rate) as default_qty, SUM(SL.rate*SL.exchange_rate*SL.quantity*SL.unit_exchange_rate) AS total_amount
                FROM {{stock_ledger}} SL 
                LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
         
                WHERE ' . $sr_condition . ' AND  SL.product_id=  ' . $each['product_id'];
            $sr_array = Yii::app()->db->createCommand($srsql)->queryRow();
            $default_qty = $each['default_qty'] - $sr_array['default_qty'];
            $amount = $each['total_amount'] - $sr_array['total_amount'];
            if ($default_qty != 0) {
                $avg = $amount / $default_qty;
            } else {
                $avg = 0;
            }

            $tot += $amount;
            $total += $avg;
            $tot_qty += $default_qty;
            if ($vendor_id > 0) {
                $vendor_name = $each['vendor_name'];
            } else {
                $vendor_name = 'ALL';
            }


            $table .= '<tr><td>' . $sl . '</td><td>' . $each['part_number'] . '</td><td>' . $each['description'] . '</td><td>' . $each['unit_label'] . '</td><td>' . $each['brand_name'] . '</td><td>' . $vendor_name . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($default_qty, "") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($amount, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($avg, "") . '</td></tr>';
            $sl++;
        }

        $table .= '<tr>
        <td colspan="6" style="text-align:right !important;"><b>Total</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_qty, " ") . '</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot, " ") . '</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</b></td>
        </tr>';
        $table .= '</tbody>
                </table>';
        echo $table;
    }
    public function actionSales_summary_html()
    {
        /* Inventory- Sales Summary report */
        $customer_id = (int) $_POST['customer_id'];
        $salesman = (int) $_POST['salesman'];
        $sale_type =  $_POST['sale_type'];
        $month = (int) $_POST['month'];
        $year = (int) $_POST['year'];
        $day = (int) $_POST['day'];
        $condition = '1=1';
        if ($month != '') {
            $condition .= ' AND MONTH(transaction_date)=' . $month;
        }
        if ($year > 0) {
            $condition .= ' AND YEAR(transaction_date)=' . $year;
        }
        if ($day != '') {
            $condition .= ' AND DAY(transaction_date)=' . $day;
        }
        if ($customer_id != '') {
            $condition .= ' AND customer_vendor_id ="' . $customer_id . '"';
        }
        if ($salesman != '') {
            $condition .= ' AND created_by ="' . $salesman . '"';
        }
        if ($sale_type == 'M') {
            $SQL = ' SELECT YEAR(transaction_date) as y, MONTH(transaction_date) as m,  DAY(transaction_date) as d,COUNT(id) as TOTAL_COUNT,(SUM(rate*quantity)) AS TOTAL_AMT 
        FROM {{stock_ledger }} 
        
        WHERE ' . $condition . ' GROUP BY MONTH(transaction_date)';
        } else if ($sale_type == 'D') {
            $SQL = ' SELECT header_id,YEAR(transaction_date) as y, MONTH(transaction_date) as m,  DAY(transaction_date) as d,COUNT(id) as TOTAL_COUNT,(SUM(rate*quantity)) AS TOTAL_AMT 
        FROM {{stock_ledger }} 
        
        WHERE ' . $condition . ' GROUP BY DAY(transaction_date) ORDER BY MONTH(transaction_date)';
        }
        //echo $condition;
        $all = Yii::app()->db->createCommand($SQL)->queryAll();
        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:6%">YEAR</th>
                            <th style="width:10%">MONTH</th>
                            <th style="width:10%">DAY</th>
                            <th style="width:5%">TOTAL#INV</th>
                            <th style="width:10%">INV.AMOUNT</th>
                            <th style="width:10%">PAID</th>
                            <th style="width:5%">BALANCE</th>
                        </tr>
                    </thead>
                <tbody>';
        $grand_total = 0;
        $month_array = array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
        if (count($all) > 0) {
            foreach ($all as $each) {
                if ($month > 0) {
                    $month_name = $month_array[$each['m'] - 1];
                } else {
                    $month_name = 'ALL';
                }
                if ($sale_type == 'D') {
                    $day_name = $each['d'];
                } else {
                    $day_name = 'ALL';
                }
                if ($SQL->id > 0) {
                    $received_amount = Yii::app()->db->createCommand('select sum(amount)  from erp_finance_allocation_items where header_id=' . $each['header_id'])->queryScalar();
                } else {
                    $received_amount = 0;
                }
                $BAL = $each['TOTAL_AMT'] - $received_amount;
                $total += $each['TOTAL_AMT'];
                $rec_total += $received_amount;
                $bal_total += $BAL;
                $table .= '<tr><td>' .   $each['y'] . '</td><td>' . $month_array[$each['m'] - 1] . '</td><td>' . $day_name . '</td><td>' . $each['TOTAL_COUNT'] . '</td>
                <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['TOTAL_AMT'], " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($received_amount, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($BAL, " ") . '</td></tr>';
            }

            $table .= '<tr>
        <td colspan="4" style="text-align:right !important;"><b>Total</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($rec_total, " ") . '</b></td>
        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($bal_total, " ") . '</b></td>
        </tr>';
        } else {
            $table .= '<tr><td colspan="7" class="text-center">' . 'No Data found' . '</td> </tr>';
        }
        $table .= '</tbody>
                </table>';
        echo $table;
    }
    public function actionStatement_html()
    {

        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');

        $ledger_id = (int) $_POST['ledger_id'];
        if ($_POST['subledger_id'] > 0) {
            $subledger_id = implode(',', $_POST['subledger_id']);
        }
        $currency = (int) $_POST['currency'];
        $outlet = (int) $_POST['outlet'];
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;
        $amountType = 'VI.amount > 0';
        $paidType = 'VI.amount < 0';
        if ($_POST['type'] == 'customer') {
            $amountType = 'VI.amount > 0';
            $paidType = 'VI.amount < 0';
        }
        function generateUrl($childModel)
        {
            $url = '#';
            $code = $childModel->parent->vtype->code;
            if ($code == 'SI') {
                $headModel = $childModel->parent->vtype->header_table;
                $vat_field = $childModel->parent->vtype->vat_value;
                $inv = $headModel::model()->findBypk($childModel->parent->header_table_id);
                $tax = $inv->$vat_field;
                $taxType = ($tax > 0) ? 'tax' : 'taxnil';
                $url = "window.open($('#liveSite').val()+'index.php?r=salesinvoice/PrintPDF&id=" . $childModel->parent->header_table_id . "&frm=" . $taxType . "&type=1', '_blank');";
            } else if ($code == 'PI') {
                $url = "window.open($('#liveSite').val()+'index.php?r=purchaseinvoice/PrintInvoiceReportPDF&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'DN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=debitnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'CN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=creditnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else {
                $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $childModel->header_id . "', '_blank');";
            }
            return $url;
        }
        $items = array();
        $table = '<table class="table table-hover table-fixed table-bordered" id="gl_table">
                    <thead>
                        <tr>
                            <th style="width:10%">Date</th>
                             <th style="width:10%"> Type </th>
                            <th style="width:10%">Voucher #</th>
                            <th style="width:10%">Due Date</th>
                            <th style="width:10%">Customer name</th>
                            <th style="width:10%">Over Due</th>
                            <th style="width:10%">Ref</th>
                            <th style="width:10%">Voucher value</th>
                            <th style="width:10%">Paid</th>
                            <th style="width:10%">Balance</th>
                        </tr>
                    </thead>
                    <tbody>';
        $condition = 'subledger_id IN (' . $subledger_id . ')';
        $condition_for_opening = '';
        if ($outlet > 0) {
            $condition .= ' AND V.outlet=' . $outlet;
            $condition_for_opening .= ' AND V.outlet=' . $outlet;
        }
        $query = 'CREATE OR REPLACE VIEW {{finance_statement}} AS (SELECT
    VT.description AS voucher_type,
    V.id AS voucher_id,
    V.voucher_date AS voucher_date,
    V.due_date AS due_date,
    V.reference_no AS reference_no,
    VI.narration AS narration,
    VI.id AS voucher_item_id,
    V.voucher_no,
    C.description,
    ROUND(ABS(VI.amount*VI.exchange_rate), 4) AS amount,
    ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS allocated,
    ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS balance
FROM {{finance_voucher_items}} VI
LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
LEFT JOIN {{finance_voucher_type}} VT ON VT.id = V.voucher_type
LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
LEFT JOIN {{finance_subledger}} C ON C.id= VI.subledger_id
WHERE V.is_posted ="Y" AND V.voucher_date<="' . $to_date . '"  AND ' . $amountType . '  AND VI.ledger_id = ' . $ledger_id . ' AND   ' . $condition . ' GROUP BY VI.id)
UNION
(SELECT
    VT.description AS voucher_type,
    V.id AS voucher_id,
    V.voucher_date AS voucher_date,
    V.due_date AS due_date,
    V.reference_no AS reference_no,
    VI.narration AS narration,
    VI.id AS voucher_item_id,
    V.voucher_no,
    C.description,
    -(ROUND(ABS(VI.amount*VI.exchange_rate), 4)) AS amount,
    -(ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS allocated,
    -(ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS balance
FROM {{finance_voucher_items}} VI
LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
LEFT JOIN {{finance_voucher_type}} VT ON VT.id = V.voucher_type
LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
LEFT JOIN {{finance_subledger}} C ON C.id= VI.subledger_id
WHERE V.is_posted ="Y" AND V.voucher_date<="' . $to_date . '"  AND ' . $paidType . ' AND VI.ledger_id = ' . $ledger_id . ' AND  ' . $condition . '
GROUP BY VI.id)';
        if ($ledger_id > 0 && $subledger_id > 0) {
            Yii::app()->db->createCommand($query)->execute();
            $items = Yii::app()->db->createCommand('SELECT * FROM {{finance_statement}} order by voucher_date')->queryAll();
        }
        $amount = 0;
        $allocated = 0;
        $balanced = 0;
        if (!empty($items)) {
            foreach ($items as $each) {
                //var_dump($items);
                if (round($each['balance'], 2) != 0) {
                    if ($_POST['type'] == 'customer') {
                        $vouchreformat = '<a href="#" onclick="' . generateUrl(FinanceVoucherItems::model()->findBypk((int) $each['voucher_item_id'])) . '">' . $each['voucher_no'] . '</a>';

                        $head = FinanceVoucherHead::model()->findByPk($each['voucher_id']);
                        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="SI" AND outlet=' . $outlet))->id;
                        if ($head->voucher_type == $vouchertype) {
                            $ref = PurchaseInvoice::model()->findByPk($head->voucher_no)->reference_no;
                        } else {
                            $ref = $each['reference_no'];
                        }
                        if (empty($ref)) {
                            $ref = $head->voucher_no;
                        }
                        $vouchreformat = '<a href="#" onclick="' . generateUrl(FinanceVoucherItems::model()->findBypk((int) $each['voucher_item_id'])) . '">' .  $each['voucher_no'] . '</a>';
                    } else {
                        $head = FinanceVoucherHead::model()->findByPk($each['voucher_id']);
                        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PI" AND outlet=' . $outlet))->id;
                        if ($head->voucher_type == $vouchertype) {
                            $ref = PurchaseInvoice::model()->findByPk($head->header_table_id)->reference_no;
                        } else {
                            $ref = $each['reference_no'];
                        }
                        if (empty($ref)) {
                            $ref = $head->voucher_no;
                        }
                        $vouchreformat = '<a href="#" onclick="' . generateUrl(FinanceVoucherItems::model()->findBypk((int) $each['voucher_item_id'])) . '">' . $each['voucher_no']  . '</a>';
                    }
                    $now = time(); // or your date as well
                    $your_date = strtotime($each['due_date']);
                    $datediff = $now - $your_date;
                    $over_due = round($datediff / (60 * 60 * 24));
                    if ($over_due <= 0) {
                        $over_due = 0;
                    }
                    $amount += $each['amount'] / $exchange_rate;
                    $allocated += $each['allocated'] / $exchange_rate;
                    $balanced += $each['balance'] / $exchange_rate;
                    $table .= '<tr>
                            <td>' . date("d/m/Y", strtotime($each['voucher_date'])) . '</td>
                            <td>' . $each['voucher_type'] . '</td>
                            <td>' . $vouchreformat . '</td>
                            <td>' . date("d/m/Y", strtotime($each['due_date'])) . '</td>
                             <td>' . $each['description'] . '</td>
                            <td>' . $over_due . ' Days</td>
                            <td>' . $ref . '</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($each['amount'] / $exchange_rate), " ") . '</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($each['allocated'] / $exchange_rate), " ") . '</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($each['balance'] / $exchange_rate), " ") . '</td>
                        </tr>';
                }
            }
            $table .= '<tr>
                            <td style="text-align:right !important;" colspan="7"><b>Total</b></td>
                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(($amount / $exchange_rate), " ") . '</b></td>
                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(($allocated / $exchange_rate), " ") . '</b></td>
                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(($balanced / $exchange_rate), " ") . '</b></td>
                        </tr>';
        } else {
            $table .= '<tr>
                            <td colspan="7" style="text-align:center !important;">No Data Found</td>
                      </tr>';
        }
        echo $table;
    }
    public function actionstatement_excel()
    {
        $from = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-01');
        $to = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');

        $ledger = (int) Yii::app()->request->getParam('ledger_id');
        $subledger =  Yii::app()->request->getParam('subledger_id');
        $type = Yii::app()->request->getParam('type');
        $currency = (int) Yii::app()->request->getParam('currency');
        $outlet = (int) Yii::app()->request->getParam('outlet');
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;

        $subledgerModel = FinanceSubledger::model()->findBypk((int) $subledger);

        $amountType = 'VI.amount > 0';
        $paidType = 'VI.amount < 0';
        if ($type == 'customer') {
            $amountType = 'VI.amount > 0';
            $paidType = 'VI.amount < 0';
        }
        $condition = '';
        $condition_for_opening = '';
        if ($outlet > 0) {
            $condition .= ' AND V.outlet=' . $outlet;
            $condition_for_opening .= ' AND V.outlet=' . $outlet;
        }
        $items = array();

        $query = 'CREATE OR REPLACE VIEW {{finance_statement}} AS (SELECT
                                    VT.description AS voucher_type,
                                    V.id AS voucher_id,
                                    V.voucher_date AS voucher_date,
                                    V.due_date AS due_date,
                                    V.reference_no AS reference_no,
                                    VI.narration AS narration,
                                    VI.id AS voucher_item_id,
                                    V.voucher_no,
                                    C.description,
                                    ROUND(ABS(VI.amount*VI.exchange_rate), 4) AS amount,
                                    ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS allocated,
                                    ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS balance
                                FROM {{finance_voucher_items}} VI
                                LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
                                LEFT JOIN {{finance_subledger}} C ON C.id= VI.subledger_id
                                LEFT JOIN {{finance_voucher_type}} VT ON VT.id = V.voucher_type
                                LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
                                WHERE V.is_posted ="Y" AND V.voucher_date<="' . $to . '"  AND ' . $amountType . ' AND VI.ledger_id = ' . $ledger . ' AND VI.subledger_id IN (' . $subledger . ')
                                GROUP BY VI.id)
                                UNION
                                (SELECT
                                    VT.description AS voucher_type,
                                    V.id AS voucher_id,
                                    V.voucher_date AS voucher_date,
                                    V.due_date AS due_date,
                                    V.reference_no AS reference_no,
                                    VI.narration AS narration,
                                    VI.id AS voucher_item_id,
                                    V.voucher_no,
                                    C.description,
                                    -(ROUND(ABS(VI.amount*VI.exchange_rate), 4)) AS amount,
                                    -(ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS allocated,
                                    -(ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS balance
                                FROM {{finance_voucher_items}} VI
                                LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
                                LEFT JOIN {{finance_subledger}} C ON C.id= VI.subledger_id
                                LEFT JOIN {{finance_voucher_type}} VT ON VT.id = V.voucher_type
                                LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
                                WHERE V.is_posted ="Y" AND V.voucher_date<="' . $to . '"  AND ' . $paidType . ' AND VI.ledger_id = ' . $ledger . ' AND VI.subledger_id IN (' . $subledger . ')
                                GROUP BY VI.id)';
        if ($ledger > 0 && $subledger > 0) {
            Yii::app()->db->createCommand($query)->execute();
            $items = Yii::app()->db->createCommand('SELECT * FROM {{finance_statement}} order by voucher_date')->queryAll();
        }

        Yii::import('ext.PHPExcel.PHPExcel');

        $excel = new PHPExcel();
        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Statement of Account")
            ->setSubject("Statement of Account")
            ->setDescription("Statement of Account Upto : $to")
            ->setKeywords("Statement of Account")
            ->setCategory("Financial Report");

        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);

        $excel->setActiveSheetIndex(0)->mergeCells('A1:F1');
        $excel->getActiveSheet()->getStyle('A1:F1')->getFont()->setBold(true)->setSize(14);
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Statement Upto : ' . date("d/m/Y", strtotime($to)));

        $rowId = 3;
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A' . $rowId, 'Date')
            ->setCellValue('B' . $rowId, 'Invoice No')
            ->setCellValue('C' . $rowId, 'Customer Name')
            ->setCellValue('D' . $rowId, 'Due Date')
            ->setCellValue('E' . $rowId, 'Invoice value')
            ->setCellValue('F' . $rowId, 'Paid')
            ->setCellValue('G' . $rowId, 'Balance');

        $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setBold(true)->setSize(14);
        $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));

        $totalValue = 0;
        $balanceTotal = 0;
        $totalPaid = 0;
        $rowId++;
        //        $excel->setActiveSheetIndex(0)->mergeCells('A' . $rowId . ':C' . $rowId);
        //        $excel->setActiveSheetIndex(0)
        //            ->setCellValue('A' . $rowId, 'Opening Balance');
        //        $excel->setActiveSheetIndex(0)
        //            ->setCellValue('D' . $rowId, $currency_code.Yii::app()->numberFormatter->formatCurrency(($opening_bal/$exchange_rate), " "))
        //            ->setCellValue('E' . $rowId, $currency_code.Yii::app()->numberFormatter->formatCurrency((0/$exchange_rate), " "))
        //            ->setCellValue('F' . $rowId, $currency_code.Yii::app()->numberFormatter->formatCurrency(($opening_bal/$exchange_rate), " "));
        //        $rowId++;
        //        $totalValue += $opening_bal;
        //        $balanceTotal += $opening_bal;
        $totalPaid += 0;
        foreach ($items as $each) {
            if (round($each['balance'], 2) != 0) :
                $totalValue += $each['amount'];
                $balanceTotal += $each['balance'];
                $totalPaid += $each['allocated'];
                // if ($_REQUEST['type'] == 'customer') {
                $vouchreformat = $each['voucher_no'];
                //     }
                //     else {
                //     $head=FinanceVoucherHead::model()->findByPk($each['voucher_id']);
                //    if($head->voucher_type==8)
                //    {
                //    $ref=PurchaseInvoice::model()->findByPk($head->voucher_no)->invoice_no;    
                //    }
                //    else {
                //    $ref=$each['reference_no'];    
                //    }
                //    $vouchreformat = $ref;
                //    }
                //    if(empty($ref))
                //    {
                //    $ref=$head->voucher_no;    
                //    }
                $excel->setActiveSheetIndex(0)
                    ->setCellValue('A' . $rowId, date("d/m/Y", strtotime($each['voucher_date'])))
                    ->setCellValue('B' . $rowId, $vouchreformat)
                    ->setCellValue('C' . $rowId, $each['description'])
                    ->setCellValue('D' . $rowId, date("d/m/Y", strtotime($each['due_date'])))
                    ->setCellValue('E' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($each['amount'] / $exchange_rate), " "))
                    ->setCellValue('F' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($each['allocated'] / $exchange_rate), " "))
                    ->setCellValue('G' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($each['balance'] / $exchange_rate), " "));
                $rowId++;
            endif;
        }

        $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setBold(true)->setSize(14);
        $excel->getActiveSheet(0)->getStyle('A' . $rowId . ':G' . $rowId)->applyFromArray(array(
            'borders' => array(
                'top' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        ));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $rowId . ':D' . $rowId);
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A' . $rowId, 'Total in AED');
        $excel->setActiveSheetIndex(0)
            ->setCellValue('E' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($totalValue / $exchange_rate), " "))
            ->setCellValue('F' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($totalPaid / $exchange_rate), " "))
            ->setCellValue('G' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($balanceTotal / $exchange_rate), " "));

        $excel->getActiveSheet()->getStyle('D2:G' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="statement.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }
    public function actionPrintReportItemsPDF()
    {
        $from_date = Yii::app()->request->getParam('from_date');
        $to_date = Yii::app()->request->getParam('to_date');
        $brand_id = Yii::app()->request->getParam('brand_id');
        $outlet = Yii::app()->request->getParam('outlet');
        $created_user = Yii::app()->request->getParam('created_user');
        $payment_term = Yii::app()->request->getParam('payment_term');
        $customer_id = Yii::app()->request->getParam('customer_id');
        $param = array(
            'brand_id' => $brand_id,
            'from_date' => $from_date,
            'to_date' => $to_date,
            'created_user' => $created_user,
            'outlet' => $outlet, 'payment_term' => $payment_term, 'customer_id' => $customer_id
        );
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('application.views.front.costofsale.pdf.print_costsale_items_pdf', $param, true));
        $mpdf->Output("ItemsReport.pdf", 'I');
    }

    public function actionPrintReportInvoicePDF()
    {
        $from_date = Yii::app()->request->getParam('from_date');
        $to_date = Yii::app()->request->getParam('to_date');
        $brand_id = Yii::app()->request->getParam('brand_id');
        $created_user = Yii::app()->request->getParam('created_user');
        $payment_term = Yii::app()->request->getParam('payment_term');
        $outlet = Yii::app()->request->getParam('outlet');
        $customer_id = Yii::app()->request->getParam('customer_id');
        $param = array(
            'brand_id'     => $brand_id,
            'from_date'    => $from_date,
            'to_date'      => $to_date,
            'created_user' => $created_user,
            'payment_term' => $payment_term,
            'customer_id'  => $customer_id,
            'outlet'       => $outlet
        );
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('application.views.front.costofsale.pdf.print_costsale_invoice_pdf', $param, true));
        $mpdf->Output("ItemsReport.pdf", 'I');
    }
    public function actionPrintReportsalesPDF()
    {
        $from_date = Yii::app()->request->getParam('from_date');
        $to_date = Yii::app()->request->getParam('to_date');
        $brand_id = Yii::app()->request->getParam('brand_id');
        $salesman = Yii::app()->request->getParam('salesman');
        $customer_id = Yii::app()->request->getParam('customer_id');
        $payment_term = Yii::app()->request->getParam('payment_term');
        $param = array(
            'brand_id' => $brand_id,
            'from_date' => $from_date,
            'to_date' => $to_date,
            'customer_id' => $customer_id,
            'payment_term' => $payment_term,
            'salesman' => $salesman
        );
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('application.views.front.costofsale.pdf.print_sales_items_pdf', $param, true));
        $mpdf->Output("ItemsReport.pdf", 'I');
    }
    public function actionPrintReportpurchasePDF()
    {
        $from_date = Yii::app()->request->getParam('from_date');
        $to_date = Yii::app()->request->getParam('to_date');
        $brand_id = Yii::app()->request->getParam('brand_id');
        $salesman = Yii::app()->request->getParam('salesman');
        $vendor_id = Yii::app()->request->getParam('vendor_id');
        $param = array(
            'brand_id' => $brand_id,
            'from_date' => $from_date,
            'to_date' => $to_date,
            'vendor_id' => $vendor_id,
            'salesman' => $salesman
        );
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('application.views.front.costofsale.pdf.print_purchase_items_pdf', $param, true));
        $mpdf->Output("ItemsReport.pdf", 'I');
    }
    public function actionPrintSalesSummaryPDF()
    {
        $year = Yii::app()->request->getParam('year');
        $month = Yii::app()->request->getParam('month');
        $day = Yii::app()->request->getParam('day');
        $customer_id = Yii::app()->request->getParam('customer_id');
        $salesman = Yii::app()->request->getParam('salesman');
        $sale_type = Yii::app()->request->getParam('sale_type');
        $param = array(
            'customer_id' => $customer_id,
            'year' => $year,
            'month' => $month,
            'day' => $day,
            'salesman' => $salesman,
            'sale_type' => $sale_type
        );
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('application.views.front.costofsale.pdf.print_sales_summary_pdf', $param, true));
        $mpdf->Output("ItemsReport.pdf", 'I');
    }
    public function actionstatement_pdf()
    {
        $from = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-01');
        $to = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');

        $ledger = (int) Yii::app()->request->getParam('ledger_id');
        $subledger =  Yii::app()->request->getParam('subledger_id');
        //echo $subledger;
        $layout = (int) Yii::app()->request->getParam('layout');
        $type = Yii::app()->request->getParam('type');
        $currency = Yii::app()->request->getParam('currency');
        $outlet = Yii::app()->request->getParam('outlet');
        $param = array(
            'ledger' => $ledger,
            'subledger' => $subledger,
            'type' => $type,
            'from' => $from,
            'to' => $to,
            'currency' => $currency,
            'outlet' => $outlet
        );

        $mode = 'A4';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = $layout == 1 ? 'pdf_statement_base' : 'pdf_statement_voucher';
        $mpdf->WriteHTML($this->renderPartial($view, $param, true));
        $mpdf->Output("statement" . date("d-m-Y") . ".pdf", 'I');
    }

    // -------------added by indhu 03_07_2023-------------------------------------------
    public function actionPrintReportInvoiceExcel()
    {
        $from_date    = Yii::app()->request->getParam('from_date');
        $to_date      = Yii::app()->request->getParam('to_date');
        $brand_id     = Yii::app()->request->getParam('brand_id');
        $created_user = Yii::app()->request->getParam('created_user');
        $payment_term = Yii::app()->request->getParam('payment_term');
        $outlet       = Yii::app()->request->getParam('outlet');
        $customer_id  = Yii::app()->request->getParam('customer_id');
        $param = array(
            'brand_id'     => $brand_id,
            'from_date'    => $from_date,
            'to_date'      => $to_date,
            'created_user' => $created_user,
            'payment_term' => $payment_term,
            'customer_id'  => $customer_id,
            'outlet'       => $outlet
        );

        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'Brandwise_Sales_Excel.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('application.views.front.costofsale.excel.print_costsale_invoice_Excel', $param, false, true);
        Yii::app()->end();
    }

    public function actionPrintReportItemsExcel()
    {
        $from_date    = Yii::app()->request->getParam('from_date');
        $to_date      = Yii::app()->request->getParam('to_date');
        $brand_id     = Yii::app()->request->getParam('brand_id');
        $outlet       = Yii::app()->request->getParam('outlet');
        $created_user = Yii::app()->request->getParam('created_user');
        $payment_term = Yii::app()->request->getParam('payment_term');
        $customer_id  = Yii::app()->request->getParam('customer_id');
        $param = array(
            'brand_id'     => $brand_id,
            'from_date'    => $from_date,
            'to_date'      => $to_date,
            'created_user' => $created_user,
            'outlet'       => $outlet, 'payment_term' => $payment_term, 'customer_id' => $customer_id
        );

        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'print_costsale_items_Excel.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('application.views.front.costofsale.excel.print_costsale_items_Excel', $param, false, true);
        Yii::app()->end();
    }


    public function actionPrintReportsalesExcel()
    {
        $from_date    = Yii::app()->request->getParam('from_date');
        $to_date      = Yii::app()->request->getParam('to_date');
        $brand_id     = Yii::app()->request->getParam('brand_id');
        $salesman     = Yii::app()->request->getParam('salesman');
        $customer_id  = Yii::app()->request->getParam('customer_id');
        $payment_term = Yii::app()->request->getParam('payment_term');
        $param = array(
            'brand_id'     => $brand_id,
            'from_date'    => $from_date,
            'to_date'      => $to_date,
            'customer_id'  => $customer_id,
            'payment_term' => $payment_term,
            'salesman'     => $salesman
        );

        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'item_sales_summary_Excel.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('application.views.front.costofsale.excel.item_sales_summary_Excel', $param, false, true);
        Yii::app()->end();
    }

    public function actionPrintSalesSummaryExcel()
    {
        $year = Yii::app()->request->getParam('year');
        $month = Yii::app()->request->getParam('month');
        $day = Yii::app()->request->getParam('day');
        $customer_id = Yii::app()->request->getParam('customer_id');
        $salesman = Yii::app()->request->getParam('salesman');
        $sale_type = Yii::app()->request->getParam('sale_type');
        $param = array(
            'customer_id' => $customer_id,
            'year' => $year,
            'month' => $month,
            'day' => $day,
            'salesman' => $salesman,
            'sale_type' => $sale_type
        );

        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'sales_summary_Excel.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('application.views.front.costofsale.excel.sales_summary_Excel', $param, false, true);
        Yii::app()->end();
    }

    public function actionPrintReportpurchaseExcel()
    {
        $from_date = Yii::app()->request->getParam('from_date');
        $to_date   = Yii::app()->request->getParam('to_date');
        $brand_id  = Yii::app()->request->getParam('brand_id');
        $salesman  = Yii::app()->request->getParam('salesman');
        $vendor_id = Yii::app()->request->getParam('vendor_id');
        $param = array(
            'brand_id'  => $brand_id,
            'from_date' => $from_date,
            'to_date'   => $to_date,
            'vendor_id' => $vendor_id,
            'salesman'  => $salesman
        );

        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'purchase_items_excel.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('application.views.front.costofsale.excel.purchase_items_excel', $param, false, true);
        Yii::app()->end();
    }
    //end

}
