<?php

class GoodsissueController extends Controller {

    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index','GetList', 'Create','Save','PrintPDF','getSimilarUnits','CancelIssue'),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex() {
        $this->render('index');
    }
    /*
     * ajax function to list all goodsissue datatable
     * modified by jisha on 22-6-20. 
     */

      public function actionGetList() {
        $model  = new GoodsIssue();
        $draw   = $_POST['draw'];
        $offset = $_POST['start'];
        $limit  = $_POST['length'];
        $outlet = $_POST['outlet'];
        $created_user = $_POST['created_user'];
        $from = $_POST['from'];
        $to = $_POST['to'];
        $columns = array(
            // datatable column index  => database column name
            0 => 't.issue_no',
            1 => 't.issue_date',
            2 => 't.reference',
            3 => 't.notes',
            4 => 't.outlet',
            5 => 't.id',
            6 => 't.outlet'
        );
        $filterColumn   = $columns[$_POST['order'][0]['column']];
        $filterOrder    = $_POST['order'][0]['dir'];
        $orderBy        = $filterColumn . " " . $filterOrder;
        $condition      = '1=1';
        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            $condition.=" AND (t.issue_no LIKE '%" . $searchString . "%' OR t.reference LIKE '%" . $searchString . "%'  OR t.notes LIKE '%" . $searchString . "%' )";
        }
        if($outlet>0){
            $condition.=" AND t.outlet=".$outlet;
        }
        if($from!='' && $from!='00/00/0000')
        {
            $from = str_replace('/', '-',$from);
            $from=date("Y-m-d", strtotime($from));
            $condition.=' AND t.issue_date>="'.$from.'"';    
        }
        if($to!='' && $to!='00/00/0000')
        {
            $to = str_replace('/', '-',$to);
            $to=date("Y-m-d",strtotime($to));
            $condition.=' AND t.issue_date<="'.$to.'"';    
        }
        if($created_user >0)
        {
            $condition.=' AND (t.sales_man='.$created_user.')';    
        }
        $count          = $model->with('gi_outlet')->count(array('condition' => $condition));
        $model          = $model->with('gi_outlet')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));
        $recordsTotal   = $count;
        $recordsFiltered        = $count;
        $data['draw']   = $draw;
        $data['recordsTotal']   = $recordsTotal;
        $data['recordsFiltered']= $recordsFiltered;
        $rowData                = array();
        foreach ($model as $row)
        {
            $div= '<div class="text-center">';
            if($row['active']=='Y'){
                if(Yii::app()->user->user_access_type != 'DEV'&& Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM'){ 
                    $div.= ' <button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'goodsissue/create&id='.$row['id'].'\',\'Edit - '.$row['issue_no'].'\',\'lg\')"><i class="fa fa-edit" aria-hidden="true"></i></button>';
                    $div.= ' <button class="btn btn-danger btn-xs" title ="Cancel" onclick="cancelissue('.$row['id'].')"><i class="fa fa-ban" aria-hidden="true"></i></button>';
                }
            }
            $div .= ' <a class="btn btn-primary btn-xs" title="Print Goods Issue" target="_blank" href="index.php?r=goodsissue/PrintPDF&id=' . $row['id'] .'"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>';
            $div .= ' </div>';
            $rowData[]  = array($row['issue_no'],date('d/m/Y', strtotime($row['issue_date'])),$row['reference'], $row['notes'],$row['gi_outlet']['outlet_name'],$div,$row['active']);
        }
        $data['data'] = $rowData;
        echo json_encode($data);
    }
    /*
     * function to create goodsissue details
     * modified by jisha on 22-6-20. 
     */
    public function actionCreate() {
       $id = (int) Yii::app()->request->getParam('id');
        $model = new GoodsIssue;
        $modelItems     = array(new GoodsIssueItems);
        if ($id > 0) {
            $model = $model->findByPk($id);
            $modelItems = GoodsIssueItems::model()->findAll(array('condition' => 'issue_id="' . $id . '"','order'=>'id ASC'));
            if (empty($modelItems)) {
                $modelItems = array(new GoodsIssueItems());
            }
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model, 'modelItems' => $modelItems));
    }
    public function actionSave() {
        $model          = new GoodsIssue();
        date_default_timezone_set("Asia/Dubai");
        $valid = true;
        $groups = $other=array();
        if (isset($_POST['GoodsIssue'])) {

            if ($_POST['GoodsIssue']['id'] > 0) {
                $id =  $_POST['GoodsIssue']['id'];
                $model = $model->findByPK($id);
                $scene = 'update';
                $change_type = 'UPDATED';
            } else {
                $model->created_by = Yii::app()->user->id;
                $model->created_time = date('Y-m-d H:i:s');
                $scene = 'new';
                $change_type = 'CREATED';                
            }
            $modelformmaster=FormMaster::model()->find(array('condition'=>'outlet='.Yii::app()->user->outlet_id.' AND code="GI"'));
            $model->updated_by = Yii::app()->user->id;
            $model->updated_time =date('Y-m-d H:i:s');
            $model->attributes = $_POST['GoodsIssue'];
            $model->outlet=Yii::app()->user->outlet_id;
            //$model->active='Y';
            if($scene =='new'){
                $model->issue_no=$modelformmaster->next_number;
            }
            if($_POST['GoodsIssue']['issue_date']!='')
            {
                $model->issue_date = str_replace('/', '-', $_POST['GoodsIssue']['issue_date']);
                $model->issue_date= date("Y-m-d", strtotime($model->issue_date));
            }
            $valid=$model->validate();
            if(is_array($_POST['GoodsIssueItems'])){
                $j=0;
                foreach($_POST['GoodsIssueItems'] as $i => $each ){
                    if($each['product_id']>0){    
                        $modelItems[$j] = new GoodsIssueItems();
                        $modelItems[$j]->attributes = $each;
                        $modelItems[$j]->issue_id = 0;
                        $valid = $valid && $modelItems[$j]->validate(); 
                        $j++;
                        // Product Grouping
                        if($each['unit']>0)
                        {
                            $unit=MasUnit::model()->findByPk($each['unit']);
                            $unit_exchange=$unit->unit_exchange_rate;
                        }
                        else {
                            $unit_exchange=0;    
                        }
                        $key = $each['product_id'];
                        if (!array_key_exists($key, $groups)) {
                            $groups[$key] = array(
                            'id' => $each['product_id'],
                            'quantity' => $each['quantity']*$unit_exchange,
                            );
                        } 
                        else 
                        {
                            $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['quantity']*$unit_exchange;
                        } 
                        
                    }
                }
            } 
        }
        // QTY Checking
        if(!empty($groups))
        {
            foreach($groups as $key=>$eachProduct)  
            {
                $product=Inventory::model()->findByPk($key);
                if($product->type!='S'){
                    $qty=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*U.unit_exchange_rate),0) from {{goods_issue_items}} GI INNER JOIN {{master_unit}} U ON GI.unit=U.id where issue_id='".$model->id."' AND product_id='".$key."'")->queryScalar();
                    $bal=$eachProduct['quantity']-$qty;
                    $in_qty=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='IN' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->sales_man)->queryScalar();
                    $out_qty=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='OUT' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->sales_man)->queryScalar();
                    $in_qty_on_date=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='".$model->issue_date."' AND transaction_type='IN' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->sales_man)->queryScalar();
                    $out_qty_on_date=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='".$model->issue_date."' AND transaction_type='OUT' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->sales_man)->queryScalar();
                    $current_stock=$in_qty-$out_qty;
                    $stock_on_date =$in_qty_on_date-$out_qty_on_date;
                    if((($current_stock+$qty) < $eachProduct['quantity'] )|| (($stock_on_date+$qty) < $eachProduct['quantity']))
                    {
                        $available_stock = (($current_stock>$stock_on_date)?$stock_on_date:$current_stock)+$qty;
                        $other[]=$product->part_number.' maximum sellable qty : '.($available_stock).' '.$product->units->unit_name;
                        $valid=false;
                    }
                }
            }  
        }
        $closing_date=MasClosing::getClosingDate();
        if($closing_date>=$model->issue_date)
        {
        $other[]='Date should be greater than closing date ('.date('d-m-Y',strtotime($closing_date)).')'; 
        $valid=false;    
        }
        if($valid && ($modelItems[0]->product_id > 0)){
            $model->save();
            GoodsIssueItems::model()->deleteAll('issue_id ='.$model->id);
            StockLedger::model()->deleteAll('header_id='.$model->id.' AND  transaction_type="OUT" AND type= "GI" AND outlet='.Yii::app()->user->outlet_id);
            if($scene =='new'){
                $next_no=$model->issue_no+1;
                FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
            }
            foreach($modelItems as $each){
                $each->issue_id = $model->id;
                $each->save();
                    $model_stockledger = new StockLedger();
                    $model_stockledger->transaction_date=date('Y-m-d H:i:s');
                    $model_stockledger->transaction_type ='OUT';
                    $model_stockledger->type ='GI';
                    $model_stockledger->customer_vendor_id=0;
                    $model_stockledger->header_id=$model->id;
                    $model_stockledger->item_id=$each->id;
                    $model_stockledger->product_id=$each->product_id;
                    $model_stockledger->currency=1;
                    $model_stockledger->exchange_rate=1;
                    $model_stockledger->quantity=$each->quantity;
                    $model_stockledger->unit=$each->unit;
                    $model_stockledger->default_product_unit=$each->gi_unit_details->base_unit_id;
                    $model_stockledger->unit_exchange_rate=$each->gi_unit_details->unit_exchange_rate;
                    $model_stockledger->created_by= $model->sales_man;
                    $model_stockledger->created_time=date('Y-m-d H:i:s');
                    $model_stockledger->outlet=Yii::app()->user->outlet_id;
                    $model_stockledger->save(false);
            }
            
                // inserting to audit log
                AuditLog::saveAuditLogs(
                    $modelformmaster->id,
                    Yii::app()->user->id,
                    $change_type,
                    " with ID - {$model->id} "
                );
                // end audit log
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
        }else {
            $error1=$error2=array();
            $error1 = json_decode(CActiveForm::validate($model, '', false), true);
            if ($modelItems[0]->product_id > 0)
                $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
            else
                $error2[] = "Please add atleast one line item";
            $error = CJSON::encode(array_merge_recursive($error1,$error2,$other));
            if ($error != '[]'){
                echo $error;    
            }
        }
    }
    public function actionPrintPDF(){
        $id = Yii::app()->request->getParam('id');
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $model          = GoodsIssue::model()->findByPk($id);
        if($model->active=='N'){
            $mPDF1->SetWatermarkText('CANCELLED');
            $mPDF1->showWatermarkText = true;
        }
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.goods_issue_print', array('id' => $id, 'title' => $title),true));
        $mPDF1->Output($htmlTemplate, 'I');
    }
    public function actionGetSimilarUnits(){
        $unit_id=$_POST['unit'];
        $i=$_POST['row_field'];
        $arr_units=MasUnit::getSimilarUnits($unit_id);
        $modelItems=new GoodsIssueItems();
        $modelItems->unit=$unit_id;
        $data['unit']=CHtml::activeDropDownList($modelItems, "[" . $i . "]unit",$arr_units, array("class" =>"go cell-center text-center"));
        echo CJSON::encode($data);
    }
    public function actionCancelIssue(){
        $id     = $_POST['id'];
        $valid  = true;
        $model  = GoodsIssue::model()->findByPk($id);
        $closing_date=MasClosing::getClosingDate();
        if($closing_date>=$model->issue_date)
        {
        $jsonData['error_note']='Date should be greater than closing date ('.date('d-m-Y',strtotime($closing_date)).')'; 
        $jsonData['status']='error';    
        }
        else {
        StockLedger::model()->deleteAll('header_id='.$model->id.' AND  transaction_type="OUT" AND type= "GI" AND outlet='.Yii::app()->user->outlet_id);
        $model->active='N';
        $model->save(false);
        $jsonData['status']='success';
        }
        echo CJSON::encode($jsonData);
    }
}
