<?php

class GoodstransferController extends Controller
{

    public function accessRules()
    {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index', 'GetList', 'Create', 'GetDropdownToUser', 'Save', 'PrintPDF', 'GetDropdownToUser', 'GetSimilarUnits', 'CancelTransfer', 'PrintPos'),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex()
    {
        $this->render('index');
    }
    /*
     * ajax function to list all goodstransfer datatable
     * modified by jisha on 03-07-20. 
     */

    public function actionGetList()
    {
        $model  = new GoodsTransfer();
        $draw   = $_POST['draw'];
        $offset = $_POST['start'];
        $limit  = $_POST['length'];
        $outlet = $_POST['outlet'];
        $created_user = $_POST['created_user'];
        $from = $_POST['from'];
        $to = $_POST['to'];
        $columns = array(
            // datatable column index  => database column name
            0 => 't.transfer_no',
            1 => 't.transfer_date',
            2 => 'gt_from_user.full_name',
            3 => 'gt_to_user.full_name',
            4 => 't.notes',
            5 => 't.outlet',
            6 => 't.id',
            7 => 't.active'
        );
        $filterColumn   = $columns[$_POST['order'][0]['column']];
        $filterOrder    = $_POST['order'][0]['dir'];
        $orderBy        = $filterColumn . " " . $filterOrder;
        $condition      = '1=1';
        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            $condition .= " AND (t.transfer_no LIKE '%" . $searchString . "%'  OR t.notes LIKE '%" . $searchString . "%'  OR gt_from_user.full_name LIKE '%" . $searchString . "%'  OR gt_to_user.full_name LIKE '%" . $searchString . "%' )";
        }
        if ($from != '' && $from != '00/00/0000') {
            $from = str_replace('/', '-', $from);
            $from = date("Y-m-d", strtotime($from));
            $condition .= ' AND t.transfer_date>="' . $from . '"';
        }
        if ($to != '' && $to != '00/00/0000') {
            $to = str_replace('/', '-', $to);
            $to = date("Y-m-d", strtotime($to));
            $condition .= ' AND t.transfer_date<="' . $to . '"';
        }
        if ($outlet > 0) {
            $condition .= " AND t.outlet=" . $outlet;
        }
        if ($created_user > 0) {
            $condition .= ' AND (t.from_user_id=' . $created_user . ')';
        }
        $count          = $model->with('gt_outlet', 'gt_from_user', 'gt_to_user')->count(array('condition' => $condition));
        $model          = $model->with('gt_outlet', 'gt_from_user', 'gt_to_user')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));
        $recordsTotal   = $count;
        $recordsFiltered        = $count;
        $data['draw']   = $draw;
        $data['recordsTotal']   = $recordsTotal;
        $data['recordsFiltered'] = $recordsFiltered;
        $rowData                = array();
        foreach ($model as $row) {
            $div = '<div class="text-center">';
            if ($row['active'] == 'Y') {
                if (Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM') {
                    $div .= ' <button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'goodstransfer/create&id=' . $row['id'] . '\',\'Edit - ' . $row['transfer_no'] . '\',\'xl\')"><i class="fa fa-edit" aria-hidden="true"></i></button>';
                    $div .= ' <button class="btn btn-danger btn-xs" title ="Cancel" onclick="canceltransfer(' . $row['id'] . ')"><i class="fa fa-ban" aria-hidden="true"></i></button>';
                }
            }
            $div .= ' <a class="btn btn-primary btn-xs" title="Print Goods Transfer" target="_blank" href="index.php?r=goodstransfer/PrintPDF&id=' . $row['id'] . '"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>';
            $div .= ' <a class="btn btn-primary btn-xs" title="POS Goods Transfer" target="_blank" href="index.php?r=goodstransfer/PrintPos&id=' . $row['id'] . '"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>';

            $div .= ' </div>';
            $rowData[]  = array($row['transfer_no'], date('d/m/Y', strtotime($row['transfer_date'])), $row['gt_from_user']['full_name'], $row['gt_to_user']['full_name'], $row['notes'], $row['gt_outlet']['outlet_name'], $div, $row['active']);
        }
        $data['data'] = $rowData;
        echo json_encode($data);
    }
    /*
     * function to create goodstransfer details
     * modified by jisha on 22-6-20. 
     */
    public function actionCreate()
    {
        $id = (int) Yii::app()->request->getParam('id');
        $purchase_invoice_id = (int) Yii::app()->request->getParam('purchase_invoice_id');
        $order_date = Yii::app()->request->getParam('order_date');
        $salesman_id = Yii::app()->request->getParam('salesman_id');
        $frm = Yii::app()->request->getParam('frm');
        $model = new GoodsTransfer;
        $modelItems     = array(new GoodsTransferItems);
        if ($id > 0) {
            $model = $model->findByPk($id);
            $modelItems = GoodsTransferItems::model()->findAll(array('condition' => 'transfer_id="' . $id . '"', 'order' => 'id asc'));
            if (empty($modelItems)) {
                $modelItems = array(new GoodsTransferItems());
            }
        } else if ($frm == 'order') {
            $model->transfer_date = $order_date;
            $model->from_user_id = Yii::app()->user->id;
            $model->to_user_id = $salesman_id;
            if (!empty($order_date)) {
                $str_order_date = str_replace('/', '-', $order_date);
                $str_order_date = date("Y-m-d", strtotime($str_order_date));
            }

            $condition = "is_invoiced='N' AND active='Y' AND order_date='" . $str_order_date . "'";
            if ($salesman_id > 0) {
                $condition .= " AND salesman_id=" . $salesman_id;
            }
            $SQL = "SELECT GROUP_CONCAT(order_id) as order_ids,SUM(base_unit_qty) as quantity,part_number,product_id,base_unit_id as unit,full_name,active,description,salesman_id,SUM((base_unit_qty/sec_factor)) AS secondary_qty,secondary_unit_symbol as secondary_unit FROM view_order_collect WHERE  " . $condition . " GROUP BY product_id,salesman_id ORDER BY salesman_id";
            $arr_list = Yii::app()->db->createCommand($SQL)->queryAll();
            if (!empty($arr_list)) {
                foreach ($arr_list as $i => $each) {
                    $modelItems[$i] = new GoodsTransferItems();
                    $modelItems[$i]->product_id = $each['product_id'];
                    $modelItems[$i]->order_ids = $each['order_ids'];
                    $modelItems[$i]->part_no = $each['part_number'];
                    $modelItems[$i]->description = $each['description'];
                    $modelItems[$i]->unit = $each['unit'];
                    $modelItems[$i]->quantity = $each['quantity'];
                }
            } else {
                $modelItems = array(new GoodsTransferItems());
            }
        } else if ($purchase_invoice_id > 0) {
            $modelpurchaseItems = PurchaseInvoiceItems::model()->findAll(array('condition' => 'invoice_id="' . $purchase_invoice_id . '"', 'order' => 'id'));
            foreach ($modelpurchaseItems as $i => $each) {
                $modelItems[$i]     = new GoodsTransferItems;
                $modelItems[$i]->product_id = $each->product_id;
                $modelItems[$i]->quantity = $each->quantity;
                $modelItems[$i]->description = $each->description;
                $modelItems[$i]->unit = $each->unit;
            }
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model, 'frm' => $frm, 'modelItems' => $modelItems, 'purchase_invoice_id' => $purchase_invoice_id));
    }

    public function actionGetDropdownToUser()
    {
        $selectedUser = $_POST['selectedUser'];
        $arr_users = MasOutlets::salesmans_without_user($selectedUser);
        $model = new GoodsTransfer();
        $data['user'] = CHtml::activeDropDownList($model, 'to_user_id', $arr_users, array('empty' => '-select-', 'data-label' => 'To User <span style="color:red;">*</span>'));
        echo CJSON::encode($data);
    }
    public function actionSave()
    {
        $model          = new GoodsTransfer();
        date_default_timezone_set("Asia/Dubai");
        $valid = true;
        $groups = $other = array();
        if (isset($_POST['GoodsTransfer'])) {

            if ($_POST['GoodsTransfer']['id'] > 0) {
                $id =  $_POST['GoodsTransfer']['id'];
                $model = $model->findByPK($id);
                $scene = 'update';
                $change_type = 'UPDATED';
            } else {
                $model->created_by = Yii::app()->user->id;
                $model->created_time = date('Y-m-d H:i:s');
                $scene = 'new';
                $change_type = 'CREATED';
            }
            $modelformmaster = FormMaster::model()->find(array('condition' => 'outlet=' . Yii::app()->user->outlet_id . ' AND code="GT"'));
            $model->updated_by = Yii::app()->user->id;
            $model->updated_time = date('Y-m-d H:i:s');
            $model->attributes = $_POST['GoodsTransfer'];
            $model->outlet = Yii::app()->user->outlet_id;
            //$model->active='Y';
            if ($scene == 'new') {
                if (empty($modelformmaster)) {
                    $model->transfer_no = 90000;
                } else
                    $model->transfer_no = $modelformmaster->next_number;
            }
            if ($_POST['GoodsTransfer']['transfer_date'] != '') {
                $model->transfer_date = str_replace('/', '-', $_POST['GoodsTransfer']['transfer_date']);
                $model->transfer_date = date("Y-m-d", strtotime($model->transfer_date));
            }
            $valid = $model->validate();
            if (is_array($_POST['GoodsTransferItems'])) {
                $j = 0;
                foreach ($_POST['GoodsTransferItems'] as $i => $each) {
                    if ($each['product_id'] > 0) {
                        $modelItems[$j] = new GoodsTransferItems();
                        $modelItems[$j]->attributes = $each;
                        $modelItems[$j]->transfer_id = 0;
                        $modelItems[$j]->order_ids = $each['order_ids'];
                       

                        $valid = $valid && $modelItems[$j]->validate();
                        $j++;
                        // Product Grouping
                        if ($each['unit'] > 0) {
                            $unit = MasUnit::model()->findByPk($each['unit']);
                            $unit_exchange = $unit->unit_exchange_rate;
                        } else {
                            $unit_exchange = 0;
                        }
                        $key = $each['product_id'];
                        if (!array_key_exists($key, $groups)) {
                            $groups[$key] = array(
                                'id' => $each['product_id'],
                                'quantity' => $each['quantity'] * $unit_exchange,
                            );
                        } else {
                            $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['quantity'] * $unit_exchange;
                        }
                    }
                }
            }
        }
        // QTY Checking
        if (!empty($groups)) {
            foreach ($groups as $key => $eachProduct) {
                $product = Inventory::model()->findByPk($key);
                if ($product->type != 'S') {
                    $condt = " AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $model->from_user_id;
                    if ((int)$model->id > 0) {
                        $condt .= " AND header_id!=" . $model->id;
                        $condt1 = " AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $model->to_user_id;
                        $qty = Yii::app()->db->createCommand("select SUM(P.quantity*U.unit_exchange_rate) from {{goods_transfer_items}} P INNER JOIN {{master_unit}} U ON P.unit=U.id where transfer_id='" . $model->id . "' AND product_id='" . $key . "'")->queryScalar();
                        $in_qty1 = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='IN' " . $condt1)->queryScalar();
                        $out_qty1 = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='OUT' " . $condt1)->queryScalar();
                        $in_qty_on_date1 = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='" . $model->transfer_date . "' AND transaction_type='IN' " . $condt1)->queryScalar();
                        $out_qty_on_date1 = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='" . $model->transfer_date . "' AND transaction_type='OUT' " . $condt1)->queryScalar();
                        $bal = $qty - $eachProduct['quantity'];

                        $current_stock1 = $in_qty1 - $out_qty1;
                        $stock_on_date1 = $in_qty_on_date1 - $out_qty_on_date1;
                        $current_stock1 = round($current_stock1, 3);
                        $stock_on_date1 = round($stock_on_date1, 3);
                        $product_qty1 = round($eachProduct['quantity'], 3);
                        //                    echo "select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='IN' ".$condt1;die;
                        if (($bal > $current_stock1)) {
                            $available_stock1 = (($current_stock1 > $stock_on_date1) ? $stock_on_date1 : $current_stock1);
                            $other[] = $product->part_number . ' minimum transfer qty : ' . ($available_stock1) . ' ' . $product->units->unit_name;
                            $valid = false;
                        }
                    }

                    $in_qty = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='IN' " . $condt)->queryScalar();

                    $out_qty = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='OUT' " . $condt)->queryScalar();

                    $in_qty_on_date = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='" . $model->transfer_date . "' AND transaction_type='IN' " . $condt)->queryScalar();

                    $out_qty_on_date = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='" . $model->transfer_date . "' AND transaction_type='OUT' " . $condt)->queryScalar();

                    $current_stock = $in_qty - $out_qty;

                    $stock_on_date = $in_qty_on_date - $out_qty_on_date;

                    $current_stock = round($current_stock, 3);

                    $stock_on_date = round($stock_on_date, 3);

                    $product_qty = round($eachProduct['quantity'], 3);

                    if (($current_stock < $product_qty) || ($stock_on_date < $product_qty)) {
                        $available_stock = (($current_stock > $stock_on_date) ? $stock_on_date : $current_stock);
                        $other[] = $product->part_number . ' maximum transfer qty : ' . ($available_stock) . ' ' . $product->units->unit_name;
                        $valid = false;
                    }
                }
            }
        }

        $closing_date = MasClosing::getClosingDate();
        if ($closing_date >= $model->transfer_date) {
            $other[] = 'Date should be greater than closing date (' . date('d-m-Y', strtotime($closing_date)) . ')';
            $valid = false;
        }
        if ($valid && ($modelItems[0]->product_id > 0)) {
            $model->save();
            if (isset($_POST['Purchase_invoice_id'])) {
                if ((int)$_POST['Purchase_invoice_id'] > 0)
                    PurchaseInvoice::model()->updateByPk((int)$_POST['Purchase_invoice_id'], array('is_transfered' => 'Y'));
            }
            GoodsTransferItems::model()->deleteAll('transfer_id =' . $model->id);
            StockLedger::model()->deleteAll('header_id=' . $model->id . ' AND  type= "GT" AND outlet=' . Yii::app()->user->outlet_id);
            if ($scene == 'new') {
                $next_no = $model->transfer_no + 1;
                if (!empty($modelformmaster)) {
                    FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
                } else {
                    $modelformmaster = new FormMaster();
                    $modelformmaster->code = 'GT';
                    $modelformmaster->next_number = $next_no;
                    $modelformmaster->outlet = Yii::app()->user->outlet_id;
                    $modelformmaster->save(false);
                }
            }
            foreach ($modelItems as $each) {
                $each->transfer_id = $model->id;
                $each->save();

                 // ---------------------
                 $order_ids = $each['order_ids'];
                 if (!empty($order_ids)) {
                    $sqlorder ="UPDATE `erp_order_collect` SET direct_transfer='Y'  WHERE `id` IN (".$order_ids.")"; 
                    $command = Yii::app()->db->createCommand($sqlorder);
                    $command->execute();
                 }
                 // ---------------------
                $model_stockledger = new StockLedger();
                $model_stockledger->transaction_date = $model->transfer_date;
                $model_stockledger->transaction_type = 'OUT';
                $model_stockledger->type = 'GT';
                $model_stockledger->customer_vendor_id = 0;
                $model_stockledger->header_id = $model->id;
                $model_stockledger->item_id = $each->id;
                $model_stockledger->product_id = $each->product_id;
                $model_stockledger->currency = 1;
                $model_stockledger->exchange_rate = 1;
                $model_stockledger->quantity = $each->quantity;
                $model_stockledger->unit = $each->unit;
                $model_stockledger->default_product_unit = $each->gt_unit_details->base_unit_id;
                $model_stockledger->unit_exchange_rate = $each->gt_unit_details->unit_exchange_rate;
                $model_stockledger->created_by = $model->from_user_id;
                $model_stockledger->created_time = date('Y-m-d H:i:s');
                $model_stockledger->outlet = Yii::app()->user->outlet_id;
                $model_stockledger->save(false);

                $model_stockledger = new StockLedger();
                $model_stockledger->transaction_date = $model->transfer_date;
                $model_stockledger->transaction_type = 'IN';
                $model_stockledger->type = 'GT';
                $model_stockledger->customer_vendor_id = 0;
                $model_stockledger->header_id = $model->id;
                $model_stockledger->item_id = $each->id;
                $model_stockledger->product_id = $each->product_id;
                $model_stockledger->currency = 1;
                $model_stockledger->exchange_rate = 1;
                $model_stockledger->quantity = $each->quantity;
                $model_stockledger->unit = $each->unit;
                $model_stockledger->default_product_unit = $each->gt_unit_details->base_unit_id;
                $model_stockledger->unit_exchange_rate = $each->gt_unit_details->unit_exchange_rate;
                $model_stockledger->created_by = $model->to_user_id;
                $model_stockledger->created_time = date('Y-m-d H:i:s');
                $model_stockledger->outlet = Yii::app()->user->outlet_id;
                $model_stockledger->save(false);
            }

            // inserting to audit log
            AuditLog::saveAuditLogs(
                $modelformmaster->id,
                Yii::app()->user->id,
                $change_type,
                " with ID - {$model->id} "
            );
            // end audit log
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
        } else {
            $error1 = $error2 = array();
            $error1 = json_decode(CActiveForm::validate($model, '', false), true);
            if ($modelItems[0]->product_id > 0)
                $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
            else
                $error2[] = "Please add atleast one line item";
            $error = CJSON::encode(array_merge_recursive($error1, $error2, $other));
            if ($error != '[]') {
                echo $error;
            }
        }
    }
    public function actionPrintPDF()
    {
        $id = Yii::app()->request->getParam('id');
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $model          = GoodsTransfer::model()->findByPk($id);
        if ($model->active == 'N') {
            $mPDF1->SetWatermarkText('CANCELLED');
            $mPDF1->showWatermarkText = true;
        }
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.goods_transfer_print', array('id' => $id, 'title' => $title), true));
        $mPDF1->Output($htmlTemplate, 'I');
    }
    public function actionGetSimilarUnits()
    {
        $unit_id = $_POST['unit'];
        $i = $_POST['row_field'];
        $arr_units = MasUnit::getSimilarUnits($unit_id);
        $modelItems = new GoodsTransferItems();
        $modelItems->unit = $unit_id;
        $data['unit'] = CHtml::activeDropDownList($modelItems, "[" . $i . "]unit", $arr_units, array("class" => "go cell-center text-center"));
        echo CJSON::encode($data);
    }
    public function actionCancelTransfer()
    {
        $id     = $_POST['id'];
        $valid  = true;
        $other = array();
        $model  = GoodsTransfer::model()->findByPk($id);
        $modelItems = GoodsTransferItems::model()->findAll(array('condition' => 'transfer_id="' . $id . '"', 'order' => 'id ASC'));
        $groups = array();
        foreach ($modelItems as $each) {
            if ($each['unit'] > 0) {
                $unit = MasUnit::model()->findByPk($each['unit']);
                $unit_exchange = $unit->unit_exchange_rate;
            } else {
                $unit_exchange = 1;
            }
            $key = $each['product_id'];
            if (!array_key_exists($key, $groups)) {
                $groups[$key] = array(
                    'id' => $each['product_id'],
                    'quantity' => $each['quantity'] * $unit_exchange,
                );
            } else {
                $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['quantity'] * $unit_exchange;
            }
        }
        if (!empty($groups)) {
            foreach ($groups as $key => $eachProduct) {
                $product = Inventory::model()->findByPk($key);
                if ($product->type != 'S') {
                    $condt = " AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $model->to_user_id;
                    $in_qty = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='IN' " . $condt)->queryScalar();
                    $out_qty = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='OUT' " . $condt)->queryScalar();
                    $in_qty_on_date = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='" . $model->transfer_date . "' AND transaction_type='IN' " . $condt)->queryScalar();
                    $out_qty_on_date = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='" . $model->transfer_date . "' AND transaction_type='OUT' " . $condt)->queryScalar();
                    $current_stock = $in_qty - $out_qty;
                    $stock_on_date = $in_qty_on_date - $out_qty_on_date;
                    if ($current_stock < $eachProduct['quantity']) {
                        $other[] = $product->part_number . ' available quantity mismatch';
                        $valid = false;
                    }
                    if ($stock_on_date < $eachProduct['quantity']) {
                        $product = Inventory::model()->findByPk($key);
                        $other[] = $product->part_number . ' available quantity mismatch on' . $model->transfer_date;
                        $valid = false;
                    }
                }
            }
        }
        $closing_date = MasClosing::getClosingDate();
        if ($closing_date >= $model->transfer_date) {
            $other[] = 'Date should be greater than closing date (' . date('d-m-Y', strtotime($closing_date)) . ')';
            $valid = false;
        }
        if ($valid) {
            StockLedger::model()->deleteAll('header_id=' . $model->id . ' AND  type= "GT" AND outlet=' . Yii::app()->user->outlet_id);
            $model->active = 'N';
            $model->save(false);
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
        } else {
            $error = CJSON::encode(array_merge_recursive($other));
            if ($error != '[]') {
                echo $error;
            }
        }
    }

    // -------------added by indhu 03_07_2023------------------------------------
    public function actionPrintPos()
    {
        $id = Yii::app()->request->getParam('id');
        $this->layout = false;
        $this->renderPartial('application.views.front.pdf.goodstransfer_pos_print', array('id' => $id));
    }
    //end

}
