<?php

class MenuController extends Controller {
    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('index', 'SalesMenu','PurchaseMenu','InventoryMenu','FinanceMenu','ReportMenu','MasterMenu'),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionSalesMenu() {
        $this->render('sales_menu');
    }
    public function actionPurchaseMenu() {
        $this->render('purchase_menu');
    }
    public function actionInventoryMenu() {
        $this->render('inventory_menu');
    }
    public function actionFinanceMenu() {
        $this->render('finance_menu');
    }
    public function actionReportMenu() {
        $this->render('report_menu');
    }
    public function actionMasterMenu() {
        $this->render('master_menu');
    }
    
}
