<?php

class PurchaseinvoiceController extends Controller
{

    public function accessRules()
    {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array(
                    'Index',
                    'GetList',
                    'Create',
                    'Save',
                    'GetSimilarUnits',
                    'CancelPurchase',
                    'PrintPDF',
                    'BulkInvoicePosting',
                    'ConvertFromOrder'
                ),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex()
    {
        $this->render('index');
    }
    /*
     * ajax function to list all purchaseinvoice datatable
     * modified by jisha on 19-6-20. 
     */

    public function actionGetList()
    {
        $model  = new PurchaseInvoice();
        $draw   = $_POST['draw'];
        $offset = $_POST['start'];
        $limit  = $_POST['length'];
        $outlet = $_POST['outlet'];
        $from = $_POST['from'];
        $to = $_POST['to'];
        $vendor = $_POST['vendor_id'];
        $columns = array(
            0 => 't.invoice_no',
            1 => 't.reference_no',
            2 => 't.invoice_date',
            3 => 'vendor.vendor_name',
            4 => 't.total_amount',
            5 => 't.tax_total',
            6 => 't.grand_total',
            7 => 'user.full_name',
            8 => 'purchase_outlet.outlet_name',
            9 => 't.invoice_no',
            10 => 't.active'
        );
        $filterColumn   = $columns[$_POST['order'][0]['column']];
        $filterOrder    = $_POST['order'][0]['dir'];
        $filterColumn1   = $columns[$_POST['order'][1]['column']];
        $filterOrder1    = $_POST['order'][1]['dir'];
        if ($filterColumn1 != '' && $filterOrder1 != '') {
            $second_sort = "," . $filterColumn1 . " " . $filterOrder1;
        } else {
            $second_sort = "";
        }
        $orderBy        = $filterColumn . " " . $filterOrder . $second_sort;
        $condition      = '1=1';
        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            $condition .= " AND (t.invoice_no LIKE '%" . $searchString . "%' OR t.grand_total LIKE '%" . $searchString . "%' )";
        }
        if ($outlet > 0) {
            $condition .= " AND t.outlet=" . $outlet;
        }
        if ($from != '' && $from != '00/00/0000') {
            $from = str_replace('/', '-', $from);
            $from = date("Y-m-d", strtotime($from));
            $condition .= ' AND t.invoice_date>="' . $from . '"';
        }
        if ($to != '' && $to != '00/00/0000') {
            $to = str_replace('/', '-', $to);
            $to = date("Y-m-d", strtotime($to));
            $condition .= ' AND t.invoice_date<="' . $to . '"';
        }
        if ($vendor > 0) {
            $condition .= ' AND t.vendor_id=' . $vendor;
        }
        $count          = $model->count(array('condition' => $condition));
        $model          = $model->with('vendor', 'purchase_outlet', 'user')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));
        $recordsTotal   = $count;
        $recordsFiltered        = $count;
        $data['draw']   = $draw;
        $data['recordsTotal']   = $recordsTotal;
        $data['recordsFiltered'] = $recordsFiltered;
        $rowData                = array();
        foreach ($model as $row) {
            $div = '<div class="text-center">';
            $outlet = $row['purchase_outlet']['id'];
            $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PI" AND outlet=' . $outlet))->id;
            $posted_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $row['id']));
            $model_purchase_return = StockLedger::model()->with('purchasereturn_det')->findAll(array('condition' => 'purchasereturn_det.invoice_id=' . $row['id']));

            $div .= ' <a class="btn btn-primary btn-xs" title="Print Purchase Invoice" target="_blank" href="index.php?r=purchaseinvoice/PrintPDF&id=' . $row['id'] . '"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>';
            if ($posted_voucher > 0) {
                $allocated_voucher = FinanceAllocationItems::model()->find(array('condition' => 'voucher_id=' . $posted_voucher->id));
            }
            if (!empty($allocated_voucher)) {
                $div .= ' <a class="btn btn-primary btn-xs" title="Print Allocation" target="_blank" href="index.php?r=finance/core/printallocation&voucher_id=' . $posted_voucher->id . '"><i class="fa fa-print" aria-hidden="true"></i></a>';
                //            $div .= ' <a class="btn btn-primary btn-xs" title="Print Purchase Invoice" target="_blank" href="index.php?r=purchaseinvoice/PrintPDF&id=' . $row['id'] .'"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>';
            } else {
                if ($row['active'] == 'Y' && empty($model_purchase_return)) {
                    if (Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU') {
                        $div .= '<button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'purchaseinvoice/create&id=' . $row['id'] . '\',\'Edit - ' . $row['invoice_no'] . '\',\'xl\')"><i class="fa fa-edit" aria-hidden="true"></i></button>';
                        $div .= ' <button class="btn btn-danger btn-xs" title ="Cancel" onclick="CancelPurchase(' . $row['id'] . ')"><i class="fa fa-ban" aria-hidden="true"></i></button>';
                    }
                }
            }
            if ($row['active'] == 'Y' && Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU') {
                $div .= ' <button class="btn btn-theme btn-xs" title ="Return" onclick="loadPopupModal(\'purchasereturn/create&invoice_id=' . $row['id'] . '\',\'Return - ' . $row['invoice_no'] . '\',\'xl\')"><i class="fa fa-undo" aria-hidden="true"></i></button>';
            }
            if (Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM' && $row['is_transfered'] != 'Y') {
                $div .= ' <button class="btn btn-primary btn-xs" title ="Transfer" onclick="loadPopupModal(\'goodstransfer/create&purchase_invoice_id=' . $row['id'] . '\',\'New Goods Transfer \',\'lg\')"><i class="fa fa-truck"></i></button>';
            }
            $div .= ' </div>';
            if ($row['posted'] == 'Y') {
                $creditor = FinanceSystemAccountsMapping::getSystemdefault('creditors');
                $outlet = $row['outlet'];
                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PI" AND outlet=' . $outlet))->id;
                $inv = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $row['id']));
                if ($inv->id > 0) {
                    $inv_item = FinanceVoucherItems::model()->find(array('condition' => 'ledger_id=' . $creditor . ' AND header_id=' . $inv->id . ' AND outlet=' . $outlet));
                    $inv_amount = -1 * $inv_item->amount;
                }
                if ($inv_item->id > 0)
                    $received_amount = -1 * (Yii::app()->db->createCommand('select sum(amount) from erp_finance_allocation_items where voucher_item_id=' . $inv_item->id)->queryScalar());
            }else{
                $received_amount =0;
                $inv_amount = $row['grand_total'];
            }

            $rowData[]  = array($row['invoice_no'], $row['reference_no'], date("d/m/Y", strtotime($row['invoice_date'])), $row['vendor']['vendor_name'], Yii::app()->numberFormatter->formatCurrency($row['total_amount'], ''), Yii::app()->numberFormatter->formatCurrency($row['tax_total'], ''), Yii::app()->numberFormatter->formatCurrency($row['grand_total'], ''), Yii::app()->numberFormatter->formatCurrency(($inv_amount - $received_amount), ''), $row['user']['full_name'], $row['purchase_outlet']['outlet_name'], $div, $row['active']);
        }
        $data['data'] = $rowData;
        echo json_encode($data);
    }
    /*
     * function to create purchaseinvoice details
     * modified by jisha on 17-6-20. 
     */
    public function actionCreate()
    {
        $id = (int) Yii::app()->request->getParam('id');
        $model = new PurchaseInvoice;
        $modelItems     = array(new PurchaseInvoiceItems);
        if ($id > 0) {
            $model = $model->findByPk($id);
            $modelItems = PurchaseInvoiceItems::model()->findAll(array('condition' => 'invoice_id="' . $id . '"', 'order' => 'id'));
            if (empty($modelItems)) {
                $modelItems = array(new PurchaseInvoiceItems());
            }
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model, 'modelItems' => $modelItems));
    }
    public function actionSave()
    {
        $model = new PurchaseInvoice();
        if (isset($_POST['PurchaseInvoice'])) {

            $total_amount = 0;
            $total_tax_amount = 0;
            $total_excise_amount = 0;
            $grand_total = 0;
            $grand_total_amount = 0;
            $other = array();
            if ($_POST['PurchaseInvoice']['id'] > 0) {
                $id =  $_POST['PurchaseInvoice']['id'];
                $model = $model->findByPK($id);
                $scene = 'update';
                $change_type = 'UPDATED';
            } else {
                $model->created_by = Yii::app()->user->id;
                $model->created_time = date('Y-m-d H:i:s');
                $scene = 'new';
                $change_type = 'CREATED';
            }
            $modelformmaster = FormMaster::model()->find(array('condition' => 'outlet=' . Yii::app()->user->outlet_id . ' AND code="PI"'));
            $model->updated_by = Yii::app()->user->id;
            $model->updated_time = date('Y-m-d H:i:s');
            $model->attributes = $_POST['PurchaseInvoice'];
            $model->outlet = Yii::app()->user->outlet_id;
            if ($scene == 'new') {
                $model->invoice_no = $modelformmaster->next_number;
            }
            $valid = true;
            $groups = array();
            if (is_array($_POST['PurchaseInvoiceItems'])) {
                foreach ($_POST['PurchaseInvoiceItems'] as $i => $each) {
                    if ($each['product_id'] > 0) {
                        $modelItems[$i] = new PurchaseInvoiceItems();
                        $modelItems[$i]->attributes = $each;

                        // ---------------added on 08-01-2025-------------------
                        if ((int)$each['product_id'] > 0) {
                            $store_selling_price   = (float)$each['store_selling_price'];
                            $store_selling_price_a = (float)$each['store_selling_price_a'];
                            $store_selling_price_b = (float)$each['store_selling_price_b'];
                            $store  = Inventory::model()->findByPk($each['product_id']);
                            if ($store_selling_price > 0) {
                                $store->rate = $store_selling_price;
                            }
                            if ($store_selling_price_a > 0) {
                                $store->rate_a = $store_selling_price_a;
                            }
                            if ($store_selling_price_b > 0) {
                                $store->rate_b = $store_selling_price_b;
                            }
                            $store->save(false);
                        }
                        // -----------------------------------------------------

                        $modelItems[$i]->invoice_id = 0;
                        $grand_total_amount += round($each['net_amount'], 2);
                        $valid = $valid && $modelItems[$i]->validate();
                        // Product Grouping
                        if ($each['unit'] > 0) {
                            $unit = MasUnit::model()->findByPk($each['unit']);
                            $unit_exchange = $unit->unit_exchange_rate;
                        } else {
                            $unit_exchange = 0;
                        }

                        $key = $each['product_id'];
                        if (!array_key_exists($key, $groups)) {
                            $groups[$key] = array(
                                'id' => $each['product_id'],
                                'quantity' => $each['quantity'] * $unit_exchange,
                            );
                        } else {
                            $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['quantity'] * $unit_exchange;
                        }
                    }
                }
            }
            // QTY Checking
            if (!empty($groups)) {
                foreach ($groups as $key => $eachProduct) {
                    $product = Inventory::model()->findByPk($key);
                    if ($product->type != 'S') {
                        $qty = Yii::app()->db->createCommand("select SUM(P.quantity*U.unit_exchange_rate) from {{purchase_invoice_items}} P INNER JOIN {{master_unit}} U ON P.unit=U.id where invoice_id='" . $model->id . "' AND product_id='" . $key . "'")->queryScalar();
                        $in_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND transaction_date<='" . $model->invoice_date . "'")->queryScalar();
                        $out_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND transaction_date<='" . $model->invoice_date . "'")->queryScalar();
                        $current_stock_on_date = $in_qty - $out_qty + $qty;
                        $bal = $qty - $eachProduct['quantity'];
                        if ($bal > 0 && $current_stock_on_date < $eachProduct['quantity']) {
                            $product = Inventory::model()->findByPk($key);
                            $other[] = $product->part_number . ' available quantity on ' . $model->invoice_date . ' mismatch';
                            $valid = false;
                        }
                        $in_qty1 = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " ")->queryScalar();
                        $out_qty1 = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " ")->queryScalar();
                        $current_stock = $in_qty1 - $out_qty1 + $qty;
                        if ($bal > 0 && $current_stock < $eachProduct['quantity']) {
                            $product = Inventory::model()->findByPk($key);
                            $other[] = $product->part_number . ' available quantity mismatch';
                            $valid = false;
                        }
                    }
                    /*$in_qty=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND transaction_date<='".$model->invoice_date."'")->queryScalar();
                $out_qty=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND transaction_date<='".$model->invoice_date."'")->queryScalar();
                $current_stock=$in_qty-$out_qty;
                if($bal>0 && $current_stock<$bal)
                {
                $product=Inventory::model()->findByPk($key);
                $other[]=$product->part_number.' available quantity mismatch'; 
                $valid=false;
                }*/
                }
            }
            $grand_total_amount = round($grand_total_amount, 2);
            $model->total_amount = $total_amount;
            $model->excise_total = $total_excise_amount;
            $model->tax_total = $total_tax_amount;
            $model->grand_total = $grand_total_amount;
            if (($model->received + $model->discount) > $grand_total_amount) {
                $other[] = 'Paid amount can not greater than invoice amount';
                $valid = false;
            }
            /* Commented on 28-9-22 //as requested by alarab
        if(($model->received+$model->discount)<$grand_total_amount)
        {
        $model->payment_term=2;    
        }
        else if(($model->received+$model->discount)==$grand_total_amount)
        {
        $model->payment_term=1;    
        }*/
            $model->payment_term = $_POST['PurchaseInvoice']['payment_term'];

            $model->invoice_date = str_replace('/', '-', $_POST['PurchaseInvoice']['invoice_date']);
            $model->invoice_date = date("Y-m-d", strtotime($model->invoice_date));
            $closing_date = MasClosing::getClosingDate();
            if ($closing_date >= $model->invoice_date) {
                $other[] = 'Date should be greater than closing date (' . date('d-m-Y', strtotime($closing_date)) . ')';
                $valid = false;
            }
            if ($valid && $model->validate() && is_array($modelItems)) {
                if ($_POST['PurchaseInvoice']['invoice_date'] != '00/00/0000') {
                    $model->invoice_date = str_replace('/', '-', $_POST['PurchaseInvoice']['invoice_date']);
                    $model->invoice_date = date("Y-m-d", strtotime($model->invoice_date));
                }

                $model->save();
                if ($scene == 'new') {
                    $next_no = $model->invoice_no + 1;
                    FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
                }

                Yii::app()->db->createCommand("delete from {{stock_ledger}} where transaction_type='IN' AND type='PI' AND header_id='" . $model->id . "' AND outlet=" . Yii::app()->user->outlet_id)->execute();
                Yii::app()->db->createCommand("delete from {{purchase_invoice_items}} where invoice_id='" . $model->id . "'")->execute();

                foreach ($modelItems as $eachItem) {
                    $eachItem->invoice_id = $model->id;
                    $total_amount += $eachItem->amount;
                    $total_tax_amount += $eachItem->tax_amount;
                    $total_excise_amount += $eachItem->excise_amount;
                    $eachItem->save(false);
                    $grand_total += $eachItem->net_amount;

                    $stockledger = new StockLedger;
                    $stockledger->transaction_date = $model->invoice_date;
                    $stockledger->transaction_type = 'IN';
                    $stockledger->type = 'PI';
                    $stockledger->customer_vendor_id = $model->vendor_id;
                    $stockledger->header_id = $model->id;
                    $stockledger->item_id = $eachItem->id;
                    $stockledger->product_id = $eachItem->product_id;
                    $stockledger->rate = $eachItem->rate;
                    $stockledger->currency = 1;
                    $stockledger->exchange_rate = 1;
                    $stockledger->quantity = $eachItem->quantity;
                    $stockledger->unit = $eachItem->unit;
                    $stockledger->default_product_unit = $eachItem->units->base_unit_id;
                    $stockledger->unit_exchange_rate = $eachItem->units->unit_exchange_rate;
                    $stockledger->outlet = Yii::app()->user->outlet_id;
                    $stockledger->created_by = Yii::app()->user->id;
                    $stockledger->created_time = date('Y-m-d H:i:s');
                    $stockledger->save(false);
                }
                // inserting to audit log
                AuditLog::saveAuditLogs(
                    $modelformmaster->id,
                    Yii::app()->user->id,
                    $change_type,
                    " with ID - {$model->id} "
                );
                // end audit log
                $model->total_amount = $total_amount;
                $model->excise_total = $total_excise_amount;
                $model->tax_total = $total_tax_amount;
                $model->grand_total = $grand_total;
                $model->save();
                $this->invoicePosting($model->id);
                $jsonData['status'] = 'success';
                if ($_POST['print'] == 'on') {
                    $jsonData['generate_print'] = 'Y';
                    $jsonData['id'] = $model->id;
                }
                echo CJSON::encode($jsonData);
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                if (!empty($modelItems))
                    $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
                else
                    $error2[] = "Please add atleast one line item";
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $other));
                if ($error != '[]') {
                    echo $error;
                }
            }
        }
    }

    public function actionGetSimilarUnits()
    {
        $unit_id = $_POST['unit'];
        $i = $_POST['row_field'];
        $arr_units = MasUnit::getSimilarUnits($unit_id);
        $modelItems = new PurchaseInvoiceItems();
        $modelItems->unit = $unit_id;
        $data['unit'] = CHtml::activeDropDownList($modelItems, "[" . $i . "]unit", $arr_units, array("class" => "go cell-center text-center"));
        echo CJSON::encode($data);
    }


    function invoicePosting($invoice_id)
    {
        $mainTable = PurchaseInvoice::model()->findByPk((int)$invoice_id);
        $outlet = Yii::app()->user->outlet_id;
        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PI" AND outlet=' . $outlet))->id;
        $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $mainTable->id));
        if (!empty($fin_voucher)) {
            FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));
            FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
        }
        $voucherHead['voucher_no'] = $mainTable->invoice_no;
        $voucherHead['voucher_date'] = $mainTable->invoice_date;
        $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);
        $outlet = Yii::app()->user->outlet_id;
        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PI" AND outlet=' . $outlet))->id;

        $voucherHead['voucher_type'] = $vouchertype;
        // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
        $voucherHead['reference_no'] = $mainTable->reference_no;
        $voucherHead['header_table_id'] = $mainTable->id;
        $voucherHead['due_date'] = $mainTable->invoice_date;
        $voucherHead['outlet'] = $mainTable->outlet;
        $voucherHead['costcenter'] = $mainTable->invoice_type;
        // $voucherHead['due_date'] = date('Y-m-d', strtotime($mainTable->invoice_date . ' + ' . (int) $mainTable->paymentTerm->no_of_days . ' days'));
        $valid = $this->isPostable($mainTable->invoice_date);

        $lastSavedid = $valid ? $this->addVoucherhead($voucherHead) : 0;

        $total_creditor_amount = $mainTable->grand_total;
        $total_purchase = $mainTable->total_amount;
        $total_tax_amount = $mainTable->tax_total;
        $total_excise_amount = $mainTable->excise_total;
        $total_discount_amount = $mainTable->discount;
        $total_received_amount = $mainTable->received;

        if ($total_creditor_amount > 0) {
            //Creditor Cr
            $credit_item_purchase = $this->addVoucheritems($lastSavedid, array(
                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),
                // 'brand_id' => $mainTable->order_id,
                'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2), //2-Creditors 1- debtors
                'narration' => 'Purchase #' . $mainTable->invoice_no,
                'currency' => $mainTable->currency,
                'exchange_rate' => $mainTable->exchange_rate,
                'emirate_id' => (int) $mainTable->vendor->state,
                'amount' => -1 * $total_creditor_amount,
                'outlet' => $mainTable->outlet
            ));
            if ($total_received_amount > 0) {
                $outlet = Yii::app()->user->outlet_id;
                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PV" AND outlet=' . $outlet))->id;
                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);
                $voucherHead['voucher_date'] = $mainTable->invoice_date;
                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);
                $voucherHead['voucher_type'] = $vouchertype;
                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
                $voucherHead['reference_no'] = $mainTable->reference_no;
                $voucherHead['header_table_id'] = $mainTable->id;
                $voucherHead['due_date'] = $mainTable->invoice_date;
                $voucherHead['outlet'] = $mainTable->outlet;
                $lastSavedid_payment_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;

                $credit_item_payment = $this->addVoucheritems($lastSavedid_payment_voucher, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),
                    'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2), //2-Creditors 1- debtors
                    'narration' => 'Purchase #' . $mainTable->invoice_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->vendor->state,
                    'amount' => (float) $total_received_amount,
                    'outlet' => $mainTable->outlet
                ));

                $this->addVoucheritems($lastSavedid_payment_voucher, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('cash_account'),
                    'subledger_id' => MasUsers::model()->findByPk($mainTable->created_by)->subledger_id,
                    'narration' => 'Purchase #' . $mainTable->invoice_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->vendor->state,
                    'amount' => -1 * $total_received_amount,
                    'outlet' => $mainTable->outlet
                ));
                FinanceVoucherHead::model()->updatebypk($lastSavedid_payment_voucher, array('total_voucher_amount' => ($total_creditor_amount), 'cheque_cleared' => 'Y')); //$netTotal
                //Auto Allocation
                $allocation = new FinanceAllocation;
                $allocation->allocation_date = $mainTable->invoice_date;
                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('creditors');
                $allocation->subledger_id = $this->getSublegder($mainTable->vendor_id, 2);
                $allocation->amount = (float) $total_received_amount;
                $allocation->created_by = Yii::app()->user->id;
                $allocation->created_date_time = date('Y-m-d h:i:s');
                $allocation->outlet = Yii::app()->user->outlet_id;
                $allocation->save();

                $allocation_items = new FinanceAllocationItems;
                $allocation_items->header_id = $allocation->id;
                $allocation_items->voucher_id = $lastSavedid;
                $allocation_items->voucher_item_id = $credit_item_purchase;
                $allocation_items->amount = -1 * $total_received_amount;
                $allocation_items->outlet = Yii::app()->user->outlet_id;
                $allocation_items->save();
                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));
                $allocation_items = new FinanceAllocationItems;
                $allocation_items->header_id = $allocation->id;
                $allocation_items->voucher_id = $lastSavedid_payment_voucher;
                $allocation_items->voucher_item_id = $credit_item_payment;
                $allocation_items->amount = (float) $total_received_amount;
                $allocation_items->outlet = Yii::app()->user->outlet_id;
                $allocation_items->save();
                FinanceVoucherHead::model()->updatebypk($lastSavedid_payment_voucher, array('is_allocated' => 'Y'));
            }
            // Discount Start
            if ($total_discount_amount > 0) {
                $outlet = Yii::app()->user->outlet_id;
                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="JV" AND outlet=' . $outlet))->id;
                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);
                $voucherHead['voucher_date'] = $mainTable->invoice_date;
                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);

                $voucherHead['voucher_type'] = $vouchertype;
                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
                $voucherHead['reference_no'] = $mainTable->reference_no;
                $voucherHead['header_table_id'] = $mainTable->id;
                $voucherHead['due_date'] = $mainTable->invoice_date;
                $voucherHead['outlet'] = $mainTable->outlet;
                $lastSavedid_discount_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;

                $debit_item_discount = $this->addVoucheritems($lastSavedid_discount_voucher, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),
                    'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2),
                    'narration' => 'Purchase #' . $mainTable->invoice_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->vendor->state,
                    'amount' => $total_discount_amount,
                    'outlet' => $mainTable->outlet
                ));

                $this->addVoucheritems($lastSavedid_discount_voucher, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('discount'),
                    'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2),
                    'narration' => 'Purchase #' . $mainTable->invoice_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->vendor->state,
                    'amount' =>  -1 * $total_discount_amount,
                    'outlet' => $mainTable->outlet
                ));

                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('total_voucher_amount' => ($total_discount_amount), 'cheque_cleared' => 'Y')); //$netTotal
                //Auto Allocation
                $allocation = new FinanceAllocation;
                $allocation->allocation_date = $mainTable->invoice_date;
                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('creditors');
                $allocation->subledger_id = $this->getSublegder($mainTable->vendor_id, 2);
                $allocation->amount = (float) $total_discount_amount;
                $allocation->created_by = Yii::app()->user->id;
                $allocation->created_date_time = date('Y-m-d h:i:s');
                $allocation->outlet = Yii::app()->user->outlet_id;
                $allocation->save(false);
                $allocation_items = new FinanceAllocationItems;
                $allocation_items->header_id = $allocation->id;
                $allocation_items->voucher_id = $lastSavedid;
                $allocation_items->voucher_item_id = $credit_item_purchase;
                $allocation_items->amount = -1 * $total_discount_amount;
                $allocation_items->outlet = Yii::app()->user->outlet_id;
                $allocation_items->save(false);
                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));
                $allocation_items = new FinanceAllocationItems;
                $allocation_items->header_id = $allocation->id;
                $allocation_items->voucher_id = $lastSavedid_discount_voucher;
                $allocation_items->voucher_item_id = $debit_item_discount;
                $allocation_items->amount = (float) $total_discount_amount;
                $allocation_items->outlet = Yii::app()->user->outlet_id;
                $allocation_items->save(false);
                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('is_allocated' => 'Y'));
            }
            // END Discount
        }

        if ($total_purchase > 0) {
            //Purchase Accounts Dr
            $this->addVoucheritems($lastSavedid, array(
                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('purchase'),
                // 'brand_id' => $mainTable->order_id,
                // 'subledger_id' => $this->getSublegder($mainTable->lead_owner_id, 3),
                'narration' => 'Purchase #' . $mainTable->invoice_no,
                'currency' => $mainTable->currency,
                'exchange_rate' => $mainTable->exchange_rate,
                'emirate_id' => (int) $mainTable->vendor->state,
                'amount' => (float) $total_purchase,
                'outlet' => $mainTable->outlet
            ));
        }
        if ($total_tax_amount > 0) {
            //VAT Dr
            $this->addVoucheritems($lastSavedid, array(
                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('purchase_vat'),
                // 'brand_id' => $mainTable->order_id,
                'subledger_id' => 0,
                'narration' => 'Purchase #' . $mainTable->invoice_no,
                'currency' => $mainTable->currency,
                'exchange_rate' => $mainTable->exchange_rate,
                'emirate_id' => (int) $mainTable->vendor->state,
                'amount' => (float) $total_tax_amount,
                'outlet' => $mainTable->outlet
            ));
        }

        if ($total_excise_amount > 0) {
            //VAT Dr
            $this->addVoucheritems($lastSavedid, array(
                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('excise_tax'),
                // 'brand_id' => $mainTable->order_id,
                'subledger_id' => 0,
                'narration' => 'Purchase #' . $mainTable->invoice_no,
                'currency' => $mainTable->currency,
                'exchange_rate' => $mainTable->exchange_rate,
                'emirate_id' => (int) $mainTable->vendor->state,
                'amount' => (float) $total_excise_amount,
                'outlet' => $mainTable->outlet
            ));
        }

        FinanceVoucherHead::model()->updatebypk($lastSavedid, array('total_voucher_amount' => ($mainTable->grand_total), 'cheque_cleared' => 'Y')); //$netTotal
        $mainTable->posted = 'Y';
        $mainTable->save();
    }
    function isPostable($date)
    {
        $last_closed_year = FinanceAuditClose::lastClosed();
        $voucherDate_array = explode('-', $date);
        $voucherYear = $voucherDate_array[0];
        return ($voucherYear <= $last_closed_year) ? false : true;
    }
    public function addVoucherhead($arr_items)
    {
        $model = new FinanceVoucherHead;
        $model->voucher_type = $arr_items['voucher_type'];
        $model->voucher_no = $arr_items['voucher_no'];
        $model->voucher_date = $arr_items['voucher_date'];
        $model->related_subledger = $arr_items['related_subledger'];
        $model->emp_subledger = $arr_items['emp_subledger'];
        $model->due_date = (isset($arr_items['due_date'])) ? $arr_items['due_date'] : $model->voucher_date;
        $model->header_table_id = $arr_items['header_table_id'];
        $model->reference_no = $arr_items['reference_no'];
        $model->is_posted = (isset($arr_items['is_posted'])) ? $arr_items['is_posted'] : 'Y';
        $model->created_by = Yii::app()->user->id;
        $model->created_datetime = date('Y-m-d h:i:s');
        $model->cheque_no = $arr_items['cheque_no'];
        $model->outlet = $arr_items['outlet'];
        $model->costcenter = $arr_items['costcenter'];
        return ($model->save(false)) ? $model->id : 0; //exception
    }
    public function addVoucheritems($headerId, $arr_items)
    {
        $model = new FinanceVoucherItems;
        $model->header_id = $headerId;
        $model->ledger_id = $arr_items['ledger_id'];
        $model->brand_id = (int) $arr_items['brand_id'];
        $model->emirate_id = $arr_items['emirate_id'];
        $model->subledger_id = $arr_items['subledger_id'];
        $model->narration = $arr_items['narration'];
        $model->amount = $arr_items['amount'];
        $model->currency_id = $arr_items['currency'] > 0 ? $arr_items['currency'] : FinanceLegder::baseCurrency_id();
        $model->exchange_rate = $arr_items['exchange_rate'] > 0 ? $arr_items['exchange_rate'] : 1;
        $model->amount = $arr_items['amount'];
        $model->reconciled_date = $arr_items['reconciled_date'];
        $cleared = $arr_items['opening_cheque_cleared'];
        if ($cleared == '')
            $cleared = 'N';
        $model->opening_cheque_cleared = $cleared;
        $reconciled = $arr_items['reconciled'];
        if ($reconciled == '')
            $reconciled = 'N';
        $model->reconciled = $reconciled;
        $model->outlet = $arr_items['outlet'];
        $model->save(false);
        return $model->id > 0 ? $model->id : 0;
    }
    function getSublegder($parnet_id, $subledger_type)
    {
        return FinanceSubledger::model()->find(array('condition' => 'parent_id=' . (int) $parnet_id . ' AND subledger_type_id=' . (int) $subledger_type))->id;
    }
    public function actionCancelPurchase()
    {
        $id     = $_POST['id'];
        $valid  = true;
        $other = array();
        $model  = PurchaseInvoice::model()->findByPk($id);

        $modelItems = PurchaseInvoiceItems::model()->findAll(array('condition' => 'invoice_id="' . $id . '"', 'order' => 'id ASC'));
        $groups = array();
        foreach ($modelItems as $each) {
            if ($each['unit'] > 0) {
                $unit = MasUnit::model()->findByPk($each['unit']);
                $unit_exchange = $unit->unit_exchange_rate;
            } else {
                $unit_exchange = 1;
            }
            $key = $each['product_id'];
            if (!array_key_exists($key, $groups)) {
                $groups[$key] = array(
                    'id' => $each['product_id'],
                    'quantity' => $each['quantity'] * $unit_exchange,
                );
            } else {
                $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['quantity'] * $unit_exchange;
            }
        }
        if (!empty($groups)) {
            foreach ($groups as $key => $eachProduct) {
                $product = Inventory::model()->findByPk($key);
                if ($product->type != 'S') {
                    $in_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND transaction_date<='" . $model->invoice_date . "'")->queryScalar();
                    $out_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND transaction_date<='" . $model->invoice_date . "'")->queryScalar();
                    $current_stock = $in_qty - $out_qty;
                    if ($current_stock < $eachProduct['quantity']) {
                        $product = Inventory::model()->findByPk($key);
                        $other[] = $product->part_number . ' available quantity mismatch';
                        $valid = false;
                    }
                }
            }
        }
        $closing_date = MasClosing::getClosingDate();
        if ($closing_date >= $model->invoice_date) {
            $other[] = 'Date should be greater than closing date (' . date('d-m-Y', strtotime($closing_date)) . ')';
            $valid = false;
        }
        if ($valid) {
            $outlet = Yii::app()->user->outlet_id;
            $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PI" AND outlet=' . $outlet))->id;
            $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $model->id));
            if (!empty($fin_voucher)) {
                FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));
                FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
            }
            StockLedger::model()->deleteAll('header_id=' . $model->id . ' AND  transaction_type="IN" AND type= "PI" AND outlet=' . Yii::app()->user->outlet_id);
            $model->active = 'N';
            $model->posted = 'N';
            $model->save(false);
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
        } else {
            $error = CJSON::encode(array_merge_recursive($other));
            if ($error != '[]') {
                echo $error;
            }
        }
    }
    public function actionPrintPDF()
    {
        $id = Yii::app()->request->getParam('id');
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $model          = PurchaseInvoice::model()->findByPk($id);
        if ($model->active == 'N') {
            $mPDF1->SetWatermarkText('CANCELLED');
            $mPDF1->showWatermarkText = true;
        }
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.purchase_invoice_print', array('id' => $id, 'title' => $title), true));
        $mPDF1->Output($htmlTemplate, 'I');
    }
    public function actionBulkInvoicePosting1()
    {
        $PurchaseInvoice = PurchaseInvoice::model()->findAll(array('condition' => 'active="Y"'));
        foreach ($PurchaseInvoice as $EachPurchaseInvoice) {
            $invoice_id = $EachPurchaseInvoice->id;
            $mainTable = PurchaseInvoice::model()->findByPk((int)$invoice_id);
            $outlet = Yii::app()->user->outlet_id;
            $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PI" AND outlet=' . $outlet))->id;
            $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $mainTable->id));
            if (!empty($fin_voucher)) {
                FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));
                FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
            }
            $voucherHead['voucher_no'] = $mainTable->invoice_no;
            $voucherHead['voucher_date'] = $mainTable->invoice_date;
            $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);
            $outlet = Yii::app()->user->outlet_id;
            $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PI" AND outlet=' . $outlet))->id;

            $voucherHead['voucher_type'] = $vouchertype;
            // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
            $voucherHead['reference_no'] = $mainTable->reference_no;
            $voucherHead['header_table_id'] = $mainTable->id;
            $voucherHead['due_date'] = $mainTable->invoice_date;
            $voucherHead['outlet'] = $mainTable->outlet;
            // $voucherHead['due_date'] = date('Y-m-d', strtotime($mainTable->invoice_date . ' + ' . (int) $mainTable->paymentTerm->no_of_days . ' days'));
            $valid = $this->isPostable($mainTable->invoice_date);

            $lastSavedid = $valid ? $this->addVoucherhead($voucherHead) : 0;

            $total_creditor_amount = round($mainTable->grand_total, 2);
            $total_purchase = round($mainTable->total_amount, 2);
            $total_tax_amount = round($mainTable->tax_total, 2);
            $total_excise_amount = round($mainTable->excise_total, 2);
            $total_discount_amount = round($mainTable->discount, 2);
            $total_received_amount = round($mainTable->received, 2);

            if ($total_creditor_amount > 0) {
                //Creditor Cr
                $credit_item_purchase = $this->addVoucheritems($lastSavedid, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),
                    // 'brand_id' => $mainTable->order_id,
                    'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2), //2-Creditors 1- debtors
                    'narration' => 'Purchase #' . $mainTable->invoice_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->vendor->state,
                    'amount' => -1 * $total_creditor_amount,
                    'outlet' => $mainTable->outlet
                ));
                if ($total_received_amount > 0) {
                    $outlet = Yii::app()->user->outlet_id;
                    $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PV" AND outlet=' . $outlet))->id;
                    $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);
                    $voucherHead['voucher_date'] = $mainTable->invoice_date;
                    $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);

                    $voucherHead['voucher_type'] = $vouchertype;
                    // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
                    $voucherHead['reference_no'] = $mainTable->reference_no;
                    $voucherHead['header_table_id'] = $mainTable->id;
                    $voucherHead['due_date'] = $mainTable->invoice_date;
                    $voucherHead['outlet'] = $mainTable->outlet;
                    $lastSavedid_payment_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;

                    $credit_item_payment = $this->addVoucheritems($lastSavedid_payment_voucher, array(
                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),
                        'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2), //2-Creditors 1- debtors
                        'narration' => 'Purchase #' . $mainTable->invoice_no,
                        'currency' => $mainTable->currency,
                        'exchange_rate' => $mainTable->exchange_rate,
                        'emirate_id' => (int) $mainTable->vendor->state,
                        'amount' => (float) $total_received_amount,
                        'outlet' => $mainTable->outlet
                    ));

                    $this->addVoucheritems($lastSavedid_payment_voucher, array(
                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('cash_account'),
                        'subledger_id' => MasUsers::model()->findByPk($mainTable->created_by)->subledger_id,
                        'narration' => 'Purchase #' . $mainTable->invoice_no,
                        'currency' => $mainTable->currency,
                        'exchange_rate' => $mainTable->exchange_rate,
                        'emirate_id' => (int) $mainTable->vendor->state,
                        'amount' => -1 * $total_received_amount,
                        'outlet' => $mainTable->outlet
                    ));
                    FinanceVoucherHead::model()->updatebypk($lastSavedid_payment_voucher, array('total_voucher_amount' => ($total_creditor_amount), 'cheque_cleared' => 'Y')); //$netTotal
                    //Auto Allocation
                    $allocation = new FinanceAllocation;
                    $allocation->allocation_date = $mainTable->invoice_date;
                    $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('creditors');
                    $allocation->subledger_id = $this->getSublegder($mainTable->vendor_id, 2);
                    $allocation->amount = (float) $total_received_amount;
                    $allocation->created_by = Yii::app()->user->id;
                    $allocation->created_date_time = date('Y-m-d h:i:s');
                    $allocation->outlet = $mainTable->outlet;
                    $allocation->save();

                    $allocation_items = new FinanceAllocationItems;
                    $allocation_items->header_id = $allocation->id;
                    $allocation_items->voucher_id = $lastSavedid;
                    $allocation_items->voucher_item_id = $credit_item_purchase;
                    $allocation_items->amount = -1 * $total_received_amount;
                    $allocation_items->outlet = $mainTable->outlet;
                    $allocation_items->save();
                    FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));
                    $allocation_items = new FinanceAllocationItems;
                    $allocation_items->header_id = $allocation->id;
                    $allocation_items->voucher_id = $lastSavedid_payment_voucher;
                    $allocation_items->voucher_item_id = $credit_item_payment;
                    $allocation_items->amount = (float) $total_received_amount;
                    $allocation_items->outlet = $mainTable->outlet;
                    $allocation_items->save();
                    FinanceVoucherHead::model()->updatebypk($lastSavedid_payment_voucher, array('is_allocated' => 'Y'));
                }
                // Discount Start
                if ($total_discount_amount > 0) {
                    $outlet = Yii::app()->user->outlet_id;
                    $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="JV" AND outlet=' . $outlet))->id;
                    $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);
                    $voucherHead['voucher_date'] = $mainTable->invoice_date;
                    $voucherHead['related_subledger'] = $this->getSublegder($mainTable->vendor_id, 2);
                    $voucherHead['voucher_type'] = $vouchertype;
                    // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
                    $voucherHead['reference_no'] = $mainTable->reference_no;
                    $voucherHead['header_table_id'] = $mainTable->id;
                    $voucherHead['due_date'] = $mainTable->invoice_date;
                    $voucherHead['outlet'] = $mainTable->outlet;
                    $lastSavedid_discount_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;

                    $debit_item_discount = $this->addVoucheritems($lastSavedid_discount_voucher, array(
                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('creditors'),
                        'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2),
                        'narration' => 'Purchase #' . $mainTable->invoice_no,
                        'currency' => $mainTable->currency,
                        'exchange_rate' => $mainTable->exchange_rate,
                        'emirate_id' => (int) $mainTable->vendor->state,
                        'amount' => $total_discount_amount,
                        'outlet' => $mainTable->outlet
                    ));

                    $this->addVoucheritems($lastSavedid_discount_voucher, array(
                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('discount'),
                        'subledger_id' => $this->getSublegder($mainTable->vendor_id, 2),
                        'narration' => 'Purchase #' . $mainTable->invoice_no,
                        'currency' => $mainTable->currency,
                        'exchange_rate' => $mainTable->exchange_rate,
                        'emirate_id' => (int) $mainTable->vendor->state,
                        'amount' =>  -1 * $total_discount_amount,
                        'outlet' => $mainTable->outlet
                    ));

                    FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('total_voucher_amount' => ($total_discount_amount), 'cheque_cleared' => 'Y')); //$netTotal
                    //Auto Allocation
                    $allocation = new FinanceAllocation;
                    $allocation->allocation_date = $mainTable->invoice_date;
                    $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('creditors');
                    $allocation->subledger_id = $this->getSublegder($mainTable->vendor_id, 2);
                    $allocation->amount = (float) $total_discount_amount;
                    $allocation->created_by = Yii::app()->user->id;
                    $allocation->created_date_time = date('Y-m-d h:i:s');
                    $allocation->outlet = $mainTable->outlet;
                    $allocation->save(false);
                    $allocation_items = new FinanceAllocationItems;
                    $allocation_items->header_id = $allocation->id;
                    $allocation_items->voucher_id = $lastSavedid;
                    $allocation_items->voucher_item_id = $credit_item_purchase;
                    $allocation_items->amount = -1 * $total_discount_amount;
                    $allocation_items->outlet = $mainTable->outlet;
                    $allocation_items->save(false);
                    FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));
                    $allocation_items = new FinanceAllocationItems;
                    $allocation_items->header_id = $allocation->id;
                    $allocation_items->voucher_id = $lastSavedid_discount_voucher;
                    $allocation_items->voucher_item_id = $debit_item_discount;
                    $allocation_items->amount = (float) $total_discount_amount;
                    $allocation_items->outlet = $mainTable->outlet;
                    $allocation_items->save(false);
                    FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('is_allocated' => 'Y'));
                }
                // END Discount
            }

            if ($total_purchase > 0) {
                //Purchase Accounts Dr
                $this->addVoucheritems($lastSavedid, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('purchase'),
                    // 'brand_id' => $mainTable->order_id,
                    // 'subledger_id' => $this->getSublegder($mainTable->lead_owner_id, 3),
                    'narration' => 'Purchase #' . $mainTable->invoice_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->vendor->state,
                    'amount' => (float) $total_purchase,
                    'outlet' => $mainTable->outlet
                ));
            }
            if ($total_tax_amount > 0) {
                //VAT Dr
                $this->addVoucheritems($lastSavedid, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('purchase_vat'),
                    // 'brand_id' => $mainTable->order_id,
                    'subledger_id' => 0,
                    'narration' => 'Purchase #' . $mainTable->invoice_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->vendor->state,
                    'amount' => (float) $total_tax_amount,
                    'outlet' => $mainTable->outlet
                ));
            }

            if ($total_excise_amount > 0) {
                //VAT Dr
                $this->addVoucheritems($lastSavedid, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('excise_tax'),
                    // 'brand_id' => $mainTable->order_id,
                    'subledger_id' => 0,
                    'narration' => 'Purchase #' . $mainTable->invoice_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->vendor->state,
                    'amount' => (float) $total_excise_amount,
                    'outlet' => $mainTable->outlet
                ));
            }

            FinanceVoucherHead::model()->updatebypk($lastSavedid, array('total_voucher_amount' => (round($mainTable->grand_total, 2)), 'cheque_cleared' => 'Y')); //$netTotal
            $mainTable->posted = 'Y';
            $mainTable->save();
        }
    }
    public function actionConvertFromOrder()
    {
        $model = new PurchaseInvoice();
        $order_id = Yii::app()->request->getParam('order_id');
        $modelItems     = array(new PurchaseInvoiceItems);
        if ($order_id > 0) {
            $ordermodel = new PurchaseOrder();
            $modelorder = $ordermodel->findByPk($order_id);
            $model->vendor_id = $modelorder->vendor_id;
            $model->outlet = $modelorder->outlet;
            $modelOrderItems = PurchaseOrderItems::model()->findAll(array('condition' => 'order_id="' . $order_id . '"'));
            if (!empty($modelOrderItems)) {
                foreach ($modelOrderItems as $i => $eachitem) {
                    $modelItems[$i] = new PurchaseInvoiceItems();
                    $modelItems[$i]->product_id = $eachitem->product_id;
                    $modelItems[$i]->description = $eachitem->description;
                    $modelItems[$i]->quantity = $eachitem->quantity;
                    $modelItems[$i]->unit = $eachitem->unit;
                    $modelItems[$i]->rate = $eachitem->rate;
                    $modelItems[$i]->amount = $eachitem->amount;
                    $modelItems[$i]->tax_percentage = $eachitem->tax_percentage;
                    $modelItems[$i]->excise_percentage = $eachitem->excise_percentage;
                    $modelItems[$i]->tax_amount = $eachitem->tax_amount;
                    $modelItems[$i]->net_amount = $eachitem->net_amount;
                }
            }
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model, 'modelItems' => $modelItems));
    }
}
