<?php

class PurchaseorderController extends Controller {

    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index','GetList', 'Create','Save','GetSimilarUnits',
                'CancelPurchase','PrintPDF'),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex() {
        $this->render('index');
    }

    public function actionGetList() {
        $model  = new PurchaseOrder();
        $draw   = $_POST['draw'];
        $offset = $_POST['start'];
        $limit  = $_POST['length'];
        $outlet = $_POST['outlet'];
        $from = $_POST['from'];
        $to = $_POST['to'];
        $vendor = $_POST['vendor_id'];
        $columns = array(
            0 => 't.order_no',
            1 => 't.reference_no',
            2 => 't.order_date',
            3 => 'vendor.vendor_name',
            4 => 't.total_amount',
            5 => 't.tax_total',
            6 => 't.grand_total',
            7 => 'user.full_name',
            8 => 'purchase_outlet.outlet_name',
            9 => 't.order_no',
            10=>'t.active'
        );
        $filterColumn   = $columns[$_POST['order'][0]['column']];
        $filterOrder    = $_POST['order'][0]['dir'];
        $filterColumn1   = $columns[$_POST['order'][1]['column']];
        $filterOrder1    = $_POST['order'][1]['dir'];
        if($filterColumn1!='' && $filterOrder1!='')
        {
        $second_sort=",".$filterColumn1 . " " . $filterOrder1;
        }
        else {
        $second_sort="";    
        }
        $orderBy        = $filterColumn . " " . $filterOrder.$second_sort;
        $condition      = '1=1';
        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            $condition.=" AND (t.order_no LIKE '%" . $searchString . "%' OR t.grand_total LIKE '%" . $searchString . "%' )";
        }
        if($outlet>0){
            $condition.=" AND t.outlet=".$outlet;
        }
        if($from!='' && $from!='00/00/0000')
        {
        $from = str_replace('/', '-',$from);
        $from=date("Y-m-d", strtotime($from));
        $condition.=' AND t.order_date>="'.$from.'"';    
        }
        if($to!='' && $to!='00/00/0000')
        {
        $to = str_replace('/', '-',$to);
        $to=date("Y-m-d",strtotime($to));
        $condition.=' AND t.order_date<="'.$to.'"';    
        }
        if($vendor>0)
        {
        $condition.=' AND t.vendor_id='.$vendor;    
        }
        $count          = $model->count(array('condition' => $condition));
        $model          = $model->with('vendor','purchase_outlet','user')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));
        $recordsTotal   = $count;
        $recordsFiltered        = $count;
        $data['draw']   = $draw;
        $data['recordsTotal']   = $recordsTotal;
        $data['recordsFiltered']= $recordsFiltered;
        $rowData                = array();
        foreach ($model as $row)
        {
            $div= '<div class="text-center">';
            $outlet=$row['purchase_outlet']['id'];
            
            $div .= ' <a class="btn btn-primary btn-xs" title="Print Purchase Order" target="_blank" href="index.php?r=purchaseorder/PrintPDF&id=' . $row['id'] .'"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>&nbsp;';
           
            if($row['active']=='Y'&& empty($model_purchase_return)){
                if(Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU'){
                    $div .= '<button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'purchaseorder/create&id='.$row['id'].'\',\'Edit - '.$row['order_no'].'\',\'xl\')"><i class="fa fa-edit" aria-hidden="true"></i></button>';
                    $div .= ' <button class="btn btn-primary btn-xs" title="Convert to Invoice" onclick="loadPopupModal(\'purchaseinvoice/ConvertFromOrder&order_id=' . $row['id'] . '\',\' New Purchase Invoice \',\'xl\')"><i class="fa fa-retweet"></i></button> ';
            
//                    $div .= ' <button class="btn btn-danger btn-xs" title ="Cancel" onclick="CancelPurchase('.$row['id'].')"><i class="fa fa-ban" aria-hidden="true"></i></button>';
                }
            }
            $div .= ' </div>';
            
            $rowData[]  = array($row['order_no'],$row['reference_no'],date("d/m/Y",strtotime($row['order_date'])),$row['vendor']['vendor_name'],Yii::app()->numberFormatter->formatCurrency($row['total_amount'],''),Yii::app()->numberFormatter->formatCurrency($row['tax_total'],''),Yii::app()->numberFormatter->formatCurrency($row['grand_total'],''),$row['user']['full_name'],$row['purchase_outlet']['outlet_name'],$div,$row['active']);
        } 
        $data['data'] = $rowData;
        echo json_encode($data);
    }
    /*
     * function to create purchaseorder details
     * modified by jisha on 17-6-20. 
     */
    public function actionCreate() {
       $id = (int) Yii::app()->request->getParam('id');
        $model = new PurchaseOrder;
        $modelItems     = array(new PurchaseOrderItems);
        if ($id > 0) {
            $model = $model->findByPk($id);
            $modelItems = PurchaseOrderItems::model()->findAll(array('condition' => 'order_id="' . $id . '"','order'=>'id'));
            if (empty($modelItems)) {
                $modelItems = array(new PurchaseOrderItems());
            }
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model, 'modelItems' => $modelItems));
    }
    public function actionSave() {
        $model = new PurchaseOrder();
        if (isset($_POST['PurchaseOrder'])) {
        
            $total_amount=0;
            $total_tax_amount=0;
            $total_excise_amount=0;
            $grand_total=0;
            $grand_total_amount=0;
            $other=array();
            if ($_POST['PurchaseOrder']['id'] > 0) {
                $id =  $_POST['PurchaseOrder']['id'];
                $model = $model->findByPK($id);
                $scene = 'update';
                $change_type = 'UPDATED';
            } else {
                $model->created_by = Yii::app()->user->id;
                $model->created_time = date('Y-m-d H:i:s');
                $scene = 'new';
                $change_type = 'CREATED';                
            }
            $modelformmaster=FormMaster::model()->find(array('condition'=>'outlet='.Yii::app()->user->outlet_id.' AND code="PO"'));
            $model->updated_by = Yii::app()->user->id;
            $model->updated_time =date('Y-m-d H:i:s');
            $model->attributes = $_POST['PurchaseOrder'];
            $model->outlet=Yii::app()->user->outlet_id;
            if($scene =='new'){
            $model->order_no=$modelformmaster->next_number;
            }
            $valid = true;
            $groups = array();
            if(is_array($_POST['PurchaseOrderItems'])){
                foreach($_POST['PurchaseOrderItems'] as $i => $each ){
                    if($each['product_id']>0) {    
                        $modelItems[$i] = new PurchaseOrderItems();
                        $modelItems[$i]->attributes = $each;
                        $modelItems[$i]->order_id = 0;
                        $grand_total_amount+=round($each['net_amount'],2);
                        $valid = $valid && $modelItems[$i]->validate(); 
                        // Product Grouping
                        if($each['unit']>0)
                        {
                        $unit=MasUnit::model()->findByPk($each['unit']);
                        $unit_exchange=$unit->unit_exchange_rate;
                        }
                        else {
                        $unit_exchange=0;    
                        }
                        
                        $key = $each['product_id'];
                        if (!array_key_exists($key, $groups)) {
                            $groups[$key] = array(
                            'id' => $each['product_id'],
                            'quantity' => $each['quantity']*$unit_exchange,
                            );
                        } 
                        else 
                        {
                        $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['quantity']*$unit_exchange;
                        }   
                    }
                }
            }
        $grand_total_amount=round($grand_total_amount,2);
        $model->total_amount=$total_amount; 
        $model->excise_total=$total_excise_amount;
        $model->tax_total=$total_tax_amount;
        $model->grand_total=$grand_total_amount;
        
        $model->order_date = str_replace('/', '-', $_POST['PurchaseOrder']['order_date']);
        $model->order_date= date("Y-m-d", strtotime($model->order_date));
        $closing_date=MasClosing::getClosingDate();
        if($closing_date>=$model->order_date)
        {
        $other[]='Date should be greater than closing date ('.date('d-m-Y',strtotime($closing_date)).')'; 
        $valid=false;    
        }
        if($valid && $model->validate() && is_array($modelItems)){
            if($_POST['PurchaseOrder']['order_date']!='00/00/0000')
            {
            $model->order_date = str_replace('/', '-', $_POST['PurchaseOrder']['order_date']);
            $model->order_date= date("Y-m-d", strtotime($model->order_date));
            }
            
            $model->save();
            if($scene =='new'){
                $next_no=$model->order_no+1;
                FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
            }
            Yii::app()->db->createCommand("delete from {{purchase_order_items}} where order_id='".$model->id."'")->execute();
            foreach ($modelItems as $eachItem) {
                $eachItem->order_id = $model->id;
                $total_amount+=$eachItem->amount;
                $total_tax_amount+=$eachItem->tax_amount;
                $total_excise_amount+=$eachItem->excise_amount;
                $eachItem->save(false);
                $grand_total+=$eachItem->net_amount;
            }
                // inserting to audit log
                AuditLog::saveAuditLogs(
                    $modelformmaster->id,
                    Yii::app()->user->id,
                    $change_type,
                    " with ID - {$model->id} "
                );
                // end audit log
            $model->total_amount=$total_amount; 
            $model->excise_total=$total_excise_amount;
            $model->tax_total=$total_tax_amount;
            $model->grand_total=$grand_total;
            $model->save();
            $jsonData['status'] = 'success';
//            if($_POST['print']=='on')
//             {
//              $jsonData['generate_print']='Y';  
//              $jsonData['id']=$model->id;  
//              }
            echo CJSON::encode($jsonData);
        }else {
            $error1 = json_decode(CActiveForm::validate($model, '', false), true);
            if (!empty($modelItems))
            $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
            else
            $error2[] = "Please add atleast one line item";
            $error = CJSON::encode(array_merge_recursive($error1,$error2,$other));
            if ($error != '[]'){
                echo $error;    
            }
        }
    }
    }
    
    public function actionGetSimilarUnits(){
        $unit_id=$_POST['unit'];
        $i=$_POST['row_field'];
        $arr_units=MasUnit::getSimilarUnits($unit_id);
        $modelItems=new PurchaseOrderItems();
        $modelItems->unit=$unit_id;
        $data['unit']=CHtml::activeDropDownList($modelItems, "[" . $i . "]unit",$arr_units, array("class" =>"go cell-center text-center"));
        echo CJSON::encode($data);
    }
    function getSublegder($parnet_id, $subledger_type)
    {
    return FinanceSubledger::model()->find(array('condition' => 'parent_id=' . (int) $parnet_id . ' AND subledger_type_id=' . (int) $subledger_type))->id;
    }
    public function actionPrintPDF(){
        $id = Yii::app()->request->getParam('id');
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $model          = PurchaseOrder::model()->findByPk($id) ;
        if($model->active=='N'){
            $mPDF1->SetWatermarkText('CANCELLED');
            $mPDF1->showWatermarkText = true;
        }
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.purchase_order_print', array('id' => $id, 'title' => $title),true));
        $mPDF1->Output($htmlTemplate, 'I');
    }
}
