<?php



class SalesinvoiceController extends Controller

{



    public function accessRules()

    {

        return array(

            array(

                'allow', // allow all users to perform 'index' and 'view' actions

                'actions' => array('login', 'error', 'logout'),

                'users' => array('*'),

            ),

            array(

                'allow', // allow authenticated user to perform 'create' and 'update' actions

                'actions' => array(

                    'Index',
                    'GetList',
                    'Create',
                    'Save',
                    'GetSimilarUnits',
                    'CancelSales',
                    'PrintPDF',
                    'ConvertFromOrder',

                    'BulkInvoicePosting',
                    'viewInvoice',
                    'viewInvoiceImg',
                    'ChangeCashSales',
                    'PrintPos',
                    'GetItemHistory',
                    'GetItemHistoryNew'

                ),

                'expression' => '$user->isMember()',

            ),

            array(

                'deny', // deny all users

                'users' => array('*'),

            ),

        );
    }



    public function actionIndex()

    {

        $outlet = Yii::app()->user->outlet_id;

        $modelOutlet = MasOutlets::model()->findBypk($outlet);

        if ($modelOutlet->subscription_end_date < date('Y-m-d')) {

            $this->redirect(array('site/logout'));
        } else {

            $this->render('index');
        }
    }



    public function actionGetList()

    {

        $model  = new SalesInvoice();

        $draw   = $_POST['draw'];

        $offset = $_POST['start'];

        $limit  = $_POST['length'];

        $outlet = $_POST['outlet'];

        $from = $_POST['from'];

        $to = $_POST['to'];

        $customer = $_POST['customer_id'];

        $created_user = $_POST['created_user'];

        $columns = array(

            0 => 't.invoice_no',

            1 => 't.invoice_date',

            2 => 'customer.customer_name',

            3 => 'pay_term.payment_term_name',

            4 => 't.total_amount',

            5 => 't.tax_total',

            6 => 't.grand_total',

            7 => 'si_salesman.full_name',

            8 => 'sales_outlet.outlet_name',

            9 => 't.invoice_no',

            10 => 't.active'

        );

        $filterColumn   = $columns[$_POST['order'][0]['column']];

        $filterOrder    = $_POST['order'][0]['dir'];

        $filterColumn1   = $columns[$_POST['order'][1]['column']];

        $filterOrder1    = $_POST['order'][1]['dir'];

        if ($filterColumn1 != '' && $filterOrder1 != '') {

            $second_sort = "," . $filterColumn1 . " " . $filterOrder1;
        } else {

            $second_sort = "";
        }

        $orderBy        = $filterColumn . " " . $filterOrder . $second_sort;



        

        $condition      = '1=1';

        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {

            $searchString = $_POST['search']['value'];

            $condition .= " AND (t.invoice_no LIKE '%" . $searchString . "%' OR t.grand_total LIKE '%" . $searchString . "%' )";
        }

        if ($outlet > 0) {

            $condition .= " AND t.outlet=" . $outlet;
        }

        if ($from != '' && $from != '00/00/0000') {

            $from = str_replace('/', '-', $from);

            $from = date("Y-m-d", strtotime($from));

            $condition .= ' AND t.invoice_date>="' . $from . '"';
        }

        if ($to != '' && $to != '00/00/0000') {

            $to = str_replace('/', '-', $to);

            $to = date("Y-m-d", strtotime($to));

            $condition .= ' AND t.invoice_date<="' . $to . '"';
        }

        if ($customer > 0) {

            $condition .= ' AND t.customer_id=' . $customer;
        }

        if ($created_user > 0) {

            $condition .= ' AND (t.sales_man=' . $created_user . ')';
        }

       // echo $condition;

        $count          = $model->count(array('condition' => $condition));

        $model          = $model->with('customer', 'sales_outlet', 'si_salesman', 'pay_term')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));

        $recordsTotal   = $count;

        $recordsFiltered        = $count;

        $data['draw']   = $draw;

        $data['recordsTotal']   = $recordsTotal;

        $data['recordsFiltered'] = $recordsFiltered;

        $rowData                = array();

        foreach ($model as $row) {

            $received_amount = 0;

            $div = '<div class="text-center">';

            $outlet = $row['sales_outlet']['id'];

            $modelOutlet = MasOutlets::model()->findBypk($outlet);

            $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="SI" AND outlet=' . $outlet))->id;

            $posted_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $row['id']));

            $model_sales_return = StockLedger::model()->with('salesreturn_det')->findAll(array('condition' => 'salesreturn_det.invoice_id=' . $row['id']));

            if ($posted_voucher > 0) {

                $allocated_voucher = FinanceAllocationItems::model()->find(array('condition' => 'voucher_id=' . $posted_voucher->id));
            }

            if (!empty($allocated_voucher)) {

                $div .= ' <a class="btn btn-primary btn-xs" title="Print Allocation" target="_blank" href="index.php?r=finance/core/printallocation&voucher_id=' . $posted_voucher->id . '"><i class="fa fa-print" aria-hidden="true"></i></a>';
            } else {

                if (($row['active'] == 'Y') && empty($model_sales_return) && (Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM')) {

                    $div .= '<button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'salesinvoice/create&id=' . $row['id'] . '\',\'Edit - ' . $row['invoice_no'] . '\',\'xl\')"><i class="fa fa-edit" aria-hidden="true"></i></button>';

                    $div .= ' <button class="btn btn-danger btn-xs" title ="Cancel" onclick="cancelsales(' . $row['id'] . ')"><i class="fa fa-ban" aria-hidden="true"></i></button>';
                }
            }

            if ($row['active'] == 'Y' && (Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM')) {

                $div .= ' <button class="btn btn-theme btn-xs" title ="Return" onclick="loadPopupModal(\'salesreturn/create&invoice_id=' . $row['id'] . '\',\'Return - ' . $row['invoice_no'] . '\',\'xl\')"><i class="fa fa-undo" aria-hidden="true"></i></button>';
            }

            $div .= ' <a class="btn btn-primary btn-xs" title="Print Sales Invoice" target="_blank" href="index.php?r=salesinvoice/PrintPDF&id=' . $row['id'] . '"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>';



            $div .= ' <a class="btn btn-primary btn-xs" title="POS Print" target="_blank" href="index.php?r=salesinvoice/PrintPos&id=' . $row['id'] . '"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>';



            if ($modelOutlet->change_payment_terms == "Y" && $row['payment_term'] == 2) {

                $div .= ' <button class="btn btn-danger btn-xs" title ="Change To Cash" onclick="changepaymenttermstocash(' . $row['id'] . ')"><i class="fa fa-eye" aria-hidden="true"></i></button>';
            }

            $div .= ' </div>';

            if ($row['posted'] == 'Y') {

                $outlet = $row['sales_outlet']['id'];

                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="SI" AND outlet=' . $outlet))->id;

                $inv = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $row['id']));

                $debtor = FinanceSystemAccountsMapping::getSystemdefault('debtors');

                if ($inv->id > 0) {

                    $inv_item = FinanceVoucherItems::model()->find(array('condition' => 'ledger_id=' . $debtor . ' AND header_id=' . $inv->id));

                    $inv_amount = $inv_item->amount;
                } else {

                    $inv_amount = 0;
                }

                if ($inv_item->id > 0) {

                    $received_amount = Yii::app()->db->createCommand('select sum(amount) from erp_finance_allocation_items where voucher_item_id=' . $inv_item->id)->queryScalar();
                } else {

                    $received_amount = 0;
                }
            }else{
                $received_amount =0;
                $inv_amount = $row['grand_total'];
            }

            $rowData[]  = array(
                $row['invoice_no'], //0
                date("d/m/Y", strtotime($row['invoice_date'])), //1
                $row['customer']['customer_name'], //2
                $row['pay_term']['payment_term_name'],  //3
                Yii::app()->numberFormatter->formatCurrency($row['total_amount'], ''), //4
                Yii::app()->numberFormatter->formatCurrency($row['tax_total'], ''),  //5
                Yii::app()->numberFormatter->formatCurrency($row['grand_total'], ''),  //6
                Yii::app()->numberFormatter->formatCurrency(($inv_amount - $received_amount), ''), //7
                $row['si_salesman']['full_name'], //8
                $row['sales_outlet']['outlet_name'], //9
                $div, //10
                $row['active'], //11
                $row['id'] //12
            );
        }

        $data['data'] = $rowData;

        echo json_encode($data);
    }



    public function actionCreate()

    {

        $id = (int) Yii::app()->request->getParam('id');

        $model = new SalesInvoice;

        $modelItems     = array(new SalesInvoiceItems);

        if ($id > 0) {

            $model = $model->findByPk($id);

            $modelItems = SalesInvoiceItems::model()->findAll(array('condition' => 'invoice_id="' . $id . '"', 'order' => 'id'));

            if (empty($modelItems)) {

                $modelItems = array(new SalesInvoiceItems());
            }
        }

        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);

        $this->render('create', array('model' => $model, 'modelItems' => $modelItems));
    }



    public function actionSave()

    {

        $model = new SalesInvoice();

        if (isset($_POST['SalesInvoice'])) {
            $total_amount = 0;
            $total_tax_amount = 0;
            $total_excise_amount = 0;
            $grand_total = 0;
            $grand_total_amount = 0;
            $other = array();
            if ($_POST['SalesInvoice']['id'] > 0) {
                $id =  $_POST['SalesInvoice']['id'];
                $model = $model->findByPK($id);
                $scene = 'update';
                $change_type = 'UPDATED';
            } else {
                $model->created_by = Yii::app()->user->id;
                $model->created_time = date('Y-m-d H:i:s');
                $scene = 'new';
                $change_type = 'CREATED';
            }

            $model->updated_by = Yii::app()->user->id;
            $model->updated_time = date('Y-m-d H:i:s');
            $model->attributes = $_POST['SalesInvoice'];

            $model->total_discount_amount = $_POST['SalesInvoice']['total_discount_amount'];

            // -------------------------invoice_no updation----------------------------------

            $invoice_type = $_POST['SalesInvoice']['invoice_type'];

            if ($invoice_type == 2) { //Export
                $modelformmaster = FormMaster::model()->find(array('condition' => 'outlet=' . Yii::app()->user->outlet_id . ' AND code="SI"'));
            } else {
                //if 1 = Taxable
                $modelformmaster = FormMaster::model()->find(array('condition' => 'outlet=' . Yii::app()->user->outlet_id . ' AND code="TSI"'));
            }
            if (empty($modelformmaster)) {
                $modelformmaster = FormMaster::model()->find(array('condition' => 'outlet=' . Yii::app()->user->outlet_id . ' AND code="SI"'));
            }

            if ($scene == 'new') {
                $model->invoice_no = $modelformmaster->next_number;
            }

            // -----------------------------------------------------------

            $model->order_collect_id = $_POST['SalesInvoice']['order_collect_id'];
            $model->outlet = Yii::app()->user->outlet_id;
            if ($_POST['SalesInvoice']['invoice_date'] != '00/00/0000') {
                $model->invoice_date = str_replace('/', '-', $_POST['SalesInvoice']['invoice_date']);
                $model->invoice_date = date("Y-m-d", strtotime($model->invoice_date));
            }

            $duplicate_item_save = MasOutlets::model()->findByPk(Yii::app()->user->outlet_id)->duplicate_item_save;

            $valid = true;
            $groups = array();
            $arr_pdts = array();

            if (is_array($_POST['SalesInvoiceItems'])) {

                foreach ($_POST['SalesInvoiceItems'] as $i => $each) {

                    if ($each['product_id'] > 0) {
                        $modelItems[$i] = new SalesInvoiceItems();
                        $modelItems[$i]->attributes = $each;
                        $modelItems[$i]->deduction_amount = $each['deduction_amount'];
                        $modelItems[$i]->invoice_id = 0;
                        $grand_total_amount += round($each['net_amount'], 2);
                        $valid = $valid && $modelItems[$i]->validate();
                        $unit = MasUnit::model()->findByPk($each['unit']);
                        // Construct the composite key using product_id and unit
                        $compositeKey = $each['product_id'] . '-' . $each['unit'];
                        // Check if the composite key already exists

                        if (in_array($compositeKey, $arr_pdts)) {
                            if ($duplicate_item_save == 'N') {
                                $valid = false; // Mark validation as failed
                                $other[] = 'Product ' . $each['part_no'] . ' with Unit ' . $unit->label . ' is duplicated ,Line No:-' . ($i + 1);
                            }
                        } else {
                            // Add the composite key to the array
                            $arr_pdts[] = $compositeKey;
                        }
                        // --------------------------------------------------
                        // Product Grouping
                        if ($each['unit'] > 0) {
                            $unit = MasUnit::model()->findByPk($each['unit']);
                            $unit_exchange = $unit->unit_exchange_rate;
                        } else {
                            $unit_exchange = 0;
                        }

                        $key = $each['product_id'];
                        if (!array_key_exists($key, $groups)) {

                            $groups[$key] = array(
                                'id' => $each['product_id'],
                                'quantity' => $each['quantity'] * $unit_exchange,
                            );
                        } else {
                            $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['quantity'] * $unit_exchange;
                        }
                    }
                }
            }

            // QTY Checking

            if (!empty($groups)) {

                foreach ($groups as $key => $eachProduct) {
                    $product = Inventory::model()->findByPk($key);
                    if ($product->type != 'S') {
                        $qty = Yii::app()->db->createCommand("select SUM(quantity*U.unit_exchange_rate) from {{sales_invoice_items}} S INNER JOIN {{master_unit}} U ON S.unit=U.id where invoice_id='" . $model->id . "' AND product_id='" . $key . "'")->queryScalar();

                        $bal = $eachProduct['quantity'] - $qty;

                        $in_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $model->sales_man . " AND transaction_date<='" . $model->invoice_date . "'")->queryScalar();

                        $out_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $model->sales_man . " AND transaction_date<='" . $model->invoice_date . "'")->queryScalar();

                        $current_stock = $in_qty - $out_qty;

                        $available_in_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $model->sales_man)->queryScalar();

                        $available_out_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $model->sales_man)->queryScalar();

                        $available_stock = $available_in_qty - $available_out_qty;

                        $qty_check = true;

                        if ($bal > 0 && $current_stock < $bal) {
                            $other[] = $product->part_number . ' maximum sellable qty : ' . ($current_stock + $qty) . ' ' . $product->units->unit_name;
                            $valid = false;
                            $qty_check = false;
                        }

                        if ($qty_check) {
                            if ($bal > 0 && $available_stock < $bal) {
                                $other[] = $product->part_number . ' maximum sellable qty : ' . ($available_stock + $qty) . ' ' . $product->units->unit_name . '(Available Stock)';
                                $valid = false;
                            }
                        }
                    }
                }
            }

            $grand_total_amount = round($grand_total_amount, 2);
            $model->total_amount = $total_amount;
            $model->excise_total = $total_excise_amount;
            $model->tax_total = $total_tax_amount;
            $model->grand_total = $grand_total_amount;
            $creditlimit = Customer::model()->findByPK($model->customer_id)->credit_limit;
            $customer_subledger = $this->getSublegder($model->customer_id, 1);
            $customer_ledger = FinanceSystemAccountsMapping::getSystemdefault('debtors');
            $current_credit = Yii::app()->db->createCommand("select SUM(I.amount) from erp_finance_voucher_items I INNER JOIN erp_finance_voucher_head H ON H.id=I.header_id where H.is_posted='Y' AND ledger_id='$customer_ledger' AND subledger_id='$customer_subledger'")->queryScalar();

            $creditlimit -= $current_credit;
            //add code for getting finance credit here and add it with creditlimit

            if ($creditlimit < ($grand_total_amount - ($model->received + $model->discount))) {
                $other[] = 'Customer credit limit exceeded ';
                $valid = false;
            }

            if (($model->received + $model->discount) > $grand_total_amount) {
                $other[] = 'Received amount can not greater than invoice amount';
                $valid = false;
            }
            $model->payment_term = $_POST['SalesInvoice']['payment_term'];

            /*if(($model->received+$model->discount)<$grand_total_amount)

        {

        $model->payment_term=2;    

        }

        else if(($model->received+$model->discount)==$grand_total_amount)

        {

        $model->payment_term=1;    

        }*/



            $closing_date = MasClosing::getClosingDate();

            if ($closing_date >= $model->invoice_date) {
                $other[] = 'Date should be greater than closing date (' . date('d-m-Y', strtotime($closing_date)) . ')';
                $valid = false;
            }


            if ($change_type == 'CREATED') {
                if ((int)$model->order_collect_id > 0) {
                    $mod_OrderCollect = OrderCollect::model()->find(array('condition' => 'id =' . $model->order_collect_id . ' '));
                    if (!empty($mod_OrderCollect->active == 'N')) {
                        $other[] = 'Convert Failed!This order has already Unactivated.';
                        $valid = false;
                    } else

                    if (!empty($mod_OrderCollect->is_invoiced == 'Y')) {
                        $other[] = 'Convert Failed!This order has already been converted to an invoice.';
                        $valid = false;
                    }
                }
            }



            if ($valid && $model->validate() && is_array($modelItems)) {

                if ($_POST['SalesInvoice']['invoice_date'] != '00/00/0000') {
                    $model->invoice_date = str_replace('/', '-', $_POST['SalesInvoice']['invoice_date']);
                    $model->invoice_date = date("Y-m-d", strtotime($model->invoice_date));
                }



                $model->save();

                if ($model->order_collect_id > 0) {
                    OrderCollect::model()->updateByPk($model->order_collect_id, array('is_invoiced' => 'Y'));
                }

                if ($scene == 'new') {
                    $next_no = $model->invoice_no + 1;
                    FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
                }

                Yii::app()->db->createCommand("delete from {{stock_ledger}} where transaction_type='OUT' AND type='SI' AND header_id='" . $model->id . "' AND outlet=" . Yii::app()->user->outlet_id)->execute();

                Yii::app()->db->createCommand("delete from {{sales_invoice_items}} where invoice_id='" . $model->id . "'")->execute();


                foreach ($modelItems as $eachItem) {

                    $eachItem->invoice_id = $model->id;
                    $total_amount += $eachItem->amount;
                    $total_tax_amount += $eachItem->tax_amount;
                    $total_excise_amount += $eachItem->excise_amount;
                    $eachItem->save(false);
                    $grand_total += (float)$eachItem->net_amount;


                    $stockledger = new StockLedger;
                    $stockledger->transaction_date = $model->invoice_date;
                    $stockledger->transaction_type = 'OUT';
                    $stockledger->type = 'SI';
                    $stockledger->customer_vendor_id = $model->customer_id;
                    $stockledger->header_id = $model->id;
                    $stockledger->item_id = $eachItem->id;
                    $stockledger->product_id = $eachItem->product_id;
                    $stockledger->rate = $eachItem->rate;
                    $stockledger->currency = 1;
                    $stockledger->exchange_rate = 1;
                    $stockledger->quantity = $eachItem->quantity;
                    $stockledger->unit = $eachItem->unit;
                    $stockledger->default_product_unit = $eachItem->units->base_unit_id;
                    $stockledger->unit_exchange_rate = $eachItem->units->unit_exchange_rate;
                    $stockledger->outlet = Yii::app()->user->outlet_id;
                    $stockledger->created_by = $model->sales_man;
                    $stockledger->created_time = date('Y-m-d H:i:s');
                    $stockledger->save(false);
                }

                // inserting to audit log

                AuditLog::saveAuditLogs(
                    $modelformmaster->id,
                    Yii::app()->user->id,
                    $change_type,
                    " with ID - {$model->id} and grandtotal -{$grand_total} "
                );

                // end audit log

                $model->total_amount = $total_amount;
                $model->excise_total = $total_excise_amount;
                $model->tax_total = $total_tax_amount;
                $model->grand_total = $grand_total;
                $model->save();

                $this->invoicePosting($model->id);

                $jsonData['status'] = 'success';

                if ($_POST['print'] == 'on') {
                    $invoice_default_print = MasOutlets::model()->findByPk(Yii::app()->user->outlet_id)->invoice_default_print;

                    // if (in_array(Yii::app()->user->outlet_id, [128, 129])) {
                    if ($invoice_default_print == 1) {
                        $jsonData['generate_print2'] = 'Y';
                    } else {
                        $jsonData['generate_print'] = 'Y';
                    }
                    $jsonData['id'] = $model->id;
                }
                echo CJSON::encode($jsonData);
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                if (!empty($modelItems))
                    $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
                else
                    $error2[] = "Please add atleast one line item";
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $other));
                if ($error != '[]') {
                    echo $error;
                }
            }
        }
    }

    public function actionGetSimilarUnits()

    {

        $unit_id = $_POST['unit'];

        $i = $_POST['row_field'];

        $arr_units = MasUnit::getSimilarUnits($unit_id);

        $modelItems = new SalesInvoiceItems();

        $modelItems->unit = $unit_id;

        $data['unit'] = CHtml::activeDropDownList($modelItems, "[" . $i . "]unit", $arr_units, array("class" => "go cell-center text-center", 'onchange' => 'getPriceOnUnitChange(this.id)'));

        echo CJSON::encode($data);
    }

    function invoicePosting($invoice_id)

    {

        $mainTable = SalesInvoice::model()->findByPk((int)$invoice_id);

        $outlet = Yii::app()->user->outlet_id;

        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="SI" AND outlet=' . $outlet))->id;

        $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $mainTable->id));

        if (!empty($fin_voucher)) {

            FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));

            FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
        }

        $voucherHead['voucher_no'] = $mainTable->invoice_no;

        $voucherHead['voucher_date'] = $mainTable->invoice_date;

        $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

        $outlet = Yii::app()->user->outlet_id;

        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="SI" AND outlet=' . $outlet))->id;

        $voucherHead['voucher_type'] = $vouchertype;

        // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

        $voucherHead['reference_no'] = $mainTable->reference_no;

        $voucherHead['header_table_id'] = $mainTable->id;

        $voucherHead['costcenter'] = $mainTable->invoice_type;



        $customer_days = $mainTable->customer->credit_days;

        $voucherHead['due_date'] = date('Y-m-d', strtotime($mainTable->invoice_date . "+$customer_days day"));

        //        $voucherHead['due_date'] = $mainTable->invoice_date;

        $voucherHead['outlet'] = $mainTable->outlet;

        $voucherHead['created_by'] = $mainTable->sales_man;

        // $voucherHead['due_date'] = date('Y-m-d', strtotime($mainTable->invoice_date . ' + ' . (int) $mainTable->paymentTerm->no_of_days . ' days'));

        $valid = $this->isPostable($mainTable->invoice_date);



        $lastSavedid = $valid ? $this->addVoucherhead($voucherHead) : 0;



        $total_debtor_amount = $mainTable->grand_total;

        $total_sales = $mainTable->total_amount;

        $total_sales_discount_amount = $mainTable->total_discount_amount;

        $total_tax_amount = $mainTable->tax_total;

        $total_discount_amount = $mainTable->discount;

        $total_received_amount = $mainTable->received;

        if ($total_debtor_amount > 0) {

            //Debtor Dr

            $debit_item_sales = $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => $this->getSublegder($mainTable->customer_id, 1), //2-Creditors 1- debtors

                'narration' => 'Sales #' . $mainTable->invoice_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->customer->state,

                'amount' => (float)$total_debtor_amount,

                'outlet' => $mainTable->outlet

            ));

            if ($total_received_amount > 0) {

                $outlet = Yii::app()->user->outlet_id;

                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="CA" AND outlet=' . $outlet))->id;

                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                $voucherHead['voucher_date'] = $mainTable->invoice_date;

                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

                $voucherHead['voucher_type'] = $vouchertype;

                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                $voucherHead['reference_no'] = $mainTable->reference_no;

                $voucherHead['header_table_id'] = $mainTable->id;

                $voucherHead['due_date'] = $mainTable->invoice_date;

                $voucherHead['outlet'] = $mainTable->outlet;

                $voucherHead['payment_method'] = $mainTable->payment_mode_id;

                $lastSavedid_receipt_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;

                $paymentMode_ledger_id = FinancePaymentMode::model()->findBypk((int)$mainTable->payment_mode_id)->ledger_id;


                $debit_item_receipt = $this->addVoucheritems($lastSavedid_receipt_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                    'narration' => 'Sales #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->customer->state,

                    'amount' => -1 * $total_received_amount,

                    'outlet' => $mainTable->outlet

                ));

                $cash_ledger = ((int)$paymentMode_ledger_id > 0) ? $paymentMode_ledger_id : FinanceSystemAccountsMapping::getSystemdefault('cash_account');



                $this->addVoucheritems($lastSavedid_receipt_voucher, array(

                    'ledger_id' => $cash_ledger,

                    //  'subledger_id' => MasUsers::model()->findByPk($mainTable->created_by)->subledger_id, 

                    'subledger_id' => $this->getSublegder($mainTable->sales_man, 3),

                    'narration' => 'Sales #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->customer->state,

                    'amount' =>  (float) $total_received_amount,

                    'outlet' => $mainTable->outlet

                ));

                FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('total_voucher_amount' => ($total_received_amount), 'cheque_cleared' => 'Y')); //$netTotal

                //Auto Allocation

                $allocation = new FinanceAllocation;

                $allocation->allocation_date = $mainTable->invoice_date;

                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');

                $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);

                $allocation->amount = (float) $total_received_amount;

                $allocation->created_by = Yii::app()->user->id;

                $allocation->created_date_time = date('Y-m-d h:i:s');

                $allocation->outlet = Yii::app()->user->outlet_id;

                $allocation->save(false);

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid;

                $allocation_items->voucher_item_id = $debit_item_sales;

                $allocation_items->amount = (float) $total_received_amount;

                $allocation_items->outlet = Yii::app()->user->outlet_id;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid_receipt_voucher;

                $allocation_items->voucher_item_id = $debit_item_receipt;

                $allocation_items->amount = -1 * $total_received_amount;

                $allocation_items->outlet = Yii::app()->user->outlet_id;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('is_allocated' => 'Y'));
            }

            // Discount Start

            if ($total_discount_amount > 0) {

                $outlet = Yii::app()->user->outlet_id;

                $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="DA" AND outlet=' . $outlet))->id;

                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                $voucherHead['voucher_date'] = $mainTable->invoice_date;

                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

                $voucherHead['voucher_type'] = $vouchertype;

                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                $voucherHead['reference_no'] = $mainTable->reference_no;

                $voucherHead['header_table_id'] = $mainTable->id;

                $voucherHead['due_date'] = $mainTable->invoice_date;

                $voucherHead['outlet'] = $mainTable->outlet;

                $lastSavedid_discount_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;



                $debit_item_discount = $this->addVoucheritems($lastSavedid_discount_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                    'narration' => 'Sales #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->customer->state,

                    'amount' => -1 * $total_discount_amount,

                    'outlet' => $mainTable->outlet

                ));



                $this->addVoucheritems($lastSavedid_discount_voucher, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('discount_allowed'),

                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                    'narration' => 'Sales #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->customer->state,

                    'amount' =>  (float) $total_discount_amount,

                    'outlet' => $mainTable->outlet

                ));



                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('total_voucher_amount' => ($total_discount_amount), 'cheque_cleared' => 'Y')); //$netTotal

                //Auto Allocation

                $allocation = new FinanceAllocation;

                $allocation->allocation_date = $mainTable->invoice_date;

                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');

                $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);

                $allocation->amount = (float) $total_discount_amount;

                $allocation->created_by = Yii::app()->user->id;

                $allocation->created_date_time = date('Y-m-d h:i:s');

                $allocation->outlet = Yii::app()->user->outlet_id;

                $allocation->save(false);

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid;

                $allocation_items->voucher_item_id = $debit_item_sales;

                $allocation_items->amount = (float) $total_discount_amount;

                $allocation_items->outlet = Yii::app()->user->outlet_id;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                $allocation_items = new FinanceAllocationItems;

                $allocation_items->header_id = $allocation->id;

                $allocation_items->voucher_id = $lastSavedid_discount_voucher;

                $allocation_items->voucher_item_id = $debit_item_discount;

                $allocation_items->amount = -1 * $total_discount_amount;

                $allocation_items->outlet = Yii::app()->user->outlet_id;

                $allocation_items->save(false);

                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('is_allocated' => 'Y'));
            }

            // END Discount

        }



        if ($total_sales > 0) {

            //Sales Accounts Cr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales'),

                // 'brand_id' => $mainTable->order_id,

                // 'subledger_id' => $this->getSublegder($mainTable->lead_owner_id, 3),

                'narration' => 'Sales #' . $mainTable->invoice_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->customer->state,

                'amount' => -1 * ((float)$total_sales),

                'outlet' => $mainTable->outlet

            ));
        }
        if ($total_sales_discount_amount > 0) {

            //Sales Accounts Cr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales_discount'),

                // 'brand_id' => $mainTable->order_id,

                // 'subledger_id' => $this->getSublegder($mainTable->lead_owner_id, 3),

                'narration' => 'Sales #' . $mainTable->invoice_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->customer->state,

                'amount' => $total_sales_discount_amount,

                'outlet' => $mainTable->outlet

            ));
        }

        if ($total_tax_amount > 0) {

            //VAT Cr

            $this->addVoucheritems($lastSavedid, array(

                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales_vat'),

                // 'brand_id' => $mainTable->order_id,

                'subledger_id' => 0,

                'narration' => 'Sales #' . $mainTable->invoice_no,

                'currency' => $mainTable->currency,

                'exchange_rate' => $mainTable->exchange_rate,

                'emirate_id' => (int) $mainTable->customer->state,

                'amount' => -1 * $total_tax_amount,

                'outlet' => $mainTable->outlet

            ));
        }



        FinanceVoucherHead::model()->updatebypk($lastSavedid, array('total_voucher_amount' => ($mainTable->grand_total), 'cheque_cleared' => 'Y')); //$netTotal

        $mainTable->posted = 'Y';

        $mainTable->save();
    }

    function isPostable($date)

    {

        $last_closed_year = FinanceAuditClose::lastClosed();

        $voucherDate_array = explode('-', $date);

        $voucherYear = $voucherDate_array[0];

        return ($voucherYear <= $last_closed_year) ? false : true;
    }

    public function addVoucherhead($arr_items)

    {

        $model = new FinanceVoucherHead;

        $model->voucher_type = $arr_items['voucher_type'];

        $model->voucher_no = $arr_items['voucher_no'];

        $model->voucher_date = $arr_items['voucher_date'];

        $model->related_subledger = $arr_items['related_subledger'];

        $model->emp_subledger = $arr_items['emp_subledger'];

        $model->due_date = (isset($arr_items['due_date'])) ? $arr_items['due_date'] : $model->voucher_date;

        $model->header_table_id = $arr_items['header_table_id'];

        $model->reference_no = $arr_items['reference_no'];

        $model->is_posted = (isset($arr_items['is_posted'])) ? $arr_items['is_posted'] : 'Y';

        $model->created_by = $arr_items['created_by'];

        $model->created_datetime = date('Y-m-d h:i:s');

        $model->cheque_no = $arr_items['cheque_no'];

        $model->outlet = $arr_items['outlet'];

        $model->payment_method = $arr_items['payment_method'];

        $model->costcenter = $arr_items['costcenter'];

        return ($model->save(false)) ? $model->id : 0; //exception

    }

    public function addVoucheritems($headerId, $arr_items)

    {

        $model = new FinanceVoucherItems;

        $model->header_id = $headerId;

        $model->ledger_id = $arr_items['ledger_id'];

        $model->brand_id = (int) $arr_items['brand_id'];

        $model->emirate_id = $arr_items['emirate_id'];

        $model->subledger_id = $arr_items['subledger_id'];

        $model->narration = $arr_items['narration'];

        $model->amount = $arr_items['amount'];

        $model->currency_id = $arr_items['currency'] > 0 ? $arr_items['currency'] : FinanceLegder::baseCurrency_id();

        $model->exchange_rate = $arr_items['exchange_rate'] > 0 ? $arr_items['exchange_rate'] : 1;

        $model->amount = $arr_items['amount'];

        $model->reconciled_date = $arr_items['reconciled_date'];

        $cleared = $arr_items['opening_cheque_cleared'];

        if ($cleared == '')

            $cleared = 'N';

        $model->opening_cheque_cleared = $cleared;

        $reconciled = $arr_items['reconciled'];

        if ($reconciled == '')

            $reconciled = 'N';

        $model->reconciled = $reconciled;

        $model->outlet = $arr_items['outlet'];

        $model->save(false);

        return $model->id > 0 ? $model->id : 0;
    }

    function getSublegder($parnet_id, $subledger_type)

    {

        return FinanceSubledger::model()->find(array('condition' => 'parent_id=' . (int) $parnet_id . ' AND subledger_type_id=' . (int) $subledger_type))->id;
    }



    public function actionCancelSales()

    {

        $id     = $_POST['id'];

        $valid  = true;

        $model  = SalesInvoice::model()->findByPk($id);

        $closing_date = MasClosing::getClosingDate();

        if ($closing_date >= $model->invoice_date) {

            $jsonData['error_note'] = 'Date should be greater than closing date (' . date('d-m-Y', strtotime($closing_date)) . ')';

            $jsonData['status'] = 'error';
        } else {

            $outlet = Yii::app()->user->outlet_id;

            $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="SI" AND outlet=' . $outlet))->id;

            $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $model->id));

            if (!empty($fin_voucher)) {

                FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));

                FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
            }

            StockLedger::model()->deleteAll('header_id=' . $model->id . ' AND  transaction_type="OUT" AND type= "SI" AND outlet=' . Yii::app()->user->outlet_id);

            $model->active = 'N';

            $model->posted = 'N';

            $model->save(false);

            $jsonData['status'] = 'success';
        }

        echo CJSON::encode($jsonData);
    }

    public function actionPrintPDF()

    {

        $id = Yii::app()->request->getParam('id');

        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');

        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');

        $model          = SalesInvoice::model()->findByPk($id);

        if ($model->active == 'N') {

            $mPDF1->SetWatermarkText('CANCELLED');

            $mPDF1->showWatermarkText = true;
        }

        $mPDF1->WriteHTML($stylesheet, 1);

        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.sales_invoice_print', array('id' => $id, 'title' => $title), true));

        $mPDF1->Output($htmlTemplate, 'I');
    }

    public function actionConvertFromOrder()

    {

        $model = new SalesInvoice();

        $order_id = Yii::app()->request->getParam('order_id');

        $modelItems     = array(new SalesInvoiceItems);

        if ($order_id > 0) {

            $model->order_collect_id = $order_id;

            $ordermodel = new OrderCollect();

            $modelorder = $ordermodel->findByPk($order_id);

            $model->customer_id = $modelorder->customer_id;

            $model->sales_man = $modelorder->salesman_id;

            $model->outlet = $modelorder->outlet;

            $model->invoice_type = $modelorder->invoice_type;

            $model->notes = $modelorder->notes;

            $modelOrderItems = OrderCollectItem::model()->findAll(array('condition' => 'order_id="' . $order_id . '"'));

            if (!empty($modelOrderItems)) {

                foreach ($modelOrderItems as $i => $eachitem) {

                    $modelItems[$i] = new SalesInvoiceItems();

                    $modelItems[$i]->product_id = $eachitem->product_id;

                    $modelItems[$i]->description = $eachitem->description;

                    $modelItems[$i]->quantity = $eachitem->quantity;

                    $modelItems[$i]->rate = $eachitem->rate;

                    $modelItems[$i]->amount = $eachitem->amount;

                    $modelItems[$i]['tax_percentage'] = $eachitem->tax_percentage;

                    $modelItems[$i]->tax_amount = $eachitem->tax_amount;

                    $modelItems[$i]->net_amount = $eachitem->net_amount;

                    $modelItems[$i]->unit = $eachitem->unit_id;

                    $storemodel = Inventory::model()->find(array('select' => 't.id,t.part_number,t.description,t.rate,t.tax,t.unit,t.excise_tax', 'condition' => 'id=' . $eachitem->product_id));

                    $consider_previous_sprice = MasOutlets::model()->findByPk($modelorder->outlet)->consider_previous_sprice;

                    if ($consider_previous_sprice == 'Y' && $eachitem->rate == 0) {

                        $mod_pre_his = StockLedger::model()->with('sales_det')->find(array('condition' => 't.type ="SI" and sales_det.customer_id =' . $modelorder->customer_id . ' AND product_id =' . $eachitem->product_id, 'order' => 't.id DESC'));

                        if (empty($mod_pre_his))

                            $rate = $storemodel->rate;

                        else {

                            $rate = $mod_pre_his->rate / $mod_pre_his->unit_exchange_rate * $storemodel->unit_exchange_rate;
                        }
                    } else {

                        $rate = $eachitem->rate;
                    }

                    $cost = StockLedger::getAvgPurchaseRate($eachitem->product_id, '', $modelorder->outlet);

                    $modelItems[$i]['excise_percentage'] = $storemodel->excise_tax;

                    if ($eachitem->oc_unit->unit_exchange_rate > 0) {

                        $modelItems[$i]['unit_price'] = $eachitem->rate / $eachitem->oc_unit->unit_exchange_rate;

                        $modelItems[$i]['unit_cost'] = $cost / $eachitem->oc_unit->unit_exchange_rate;

                        $modelItems[$i]['unit_exchange'] = $eachitem->oc_unit->unit_exchange_rate;
                    } else {

                        $modelItems[$i]['unit_cost'] = $cost / $storemodel->unit_exchange_rate;

                        $modelItems[$i]['unit_exchange'] = $storemodel->unit_exchange_rate;

                        $modelItems[$i]['unit_price'] = $rate / $storemodel->unit_exchange_rate;
                    }
                }
            }
        }

        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);

        $this->render('create', array('model' => $model, 'modelItems' => $modelItems));
    }

    public function actionviewInvoice()

    {

        $this->render('create_invoice');
    }

    public function actionviewInvoiceImg()

    {

        $this->render('create_invoice_image');
    }

    function actionBulkInvoicePosting1()

    {

        $SalesInvoice = SalesInvoice::model()->findAll(array('condition' => 'active="Y"'));



        foreach ($SalesInvoice as $EachSalesInvoice) {

            $invoice_id = $EachSalesInvoice->id;

            $mainTable = SalesInvoice::model()->findByPk((int)$invoice_id);

            $outlet = Yii::app()->user->outlet_id;

            $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="SI" AND outlet=' . $outlet))->id;

            $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $mainTable->id));

            if (!empty($fin_voucher)) {

                FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));

                FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
            }

            $voucherHead['voucher_no'] = $mainTable->invoice_no;

            $voucherHead['voucher_date'] = $mainTable->invoice_date;

            $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

            $outlet = Yii::app()->user->outlet_id;

            $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="SI" AND outlet=' . $outlet))->id;

            $voucherHead['voucher_type'] = $vouchertype;

            // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

            $voucherHead['reference_no'] = $mainTable->reference_no;

            $voucherHead['header_table_id'] = $mainTable->id;

            $voucherHead['due_date'] = $mainTable->invoice_date;

            $voucherHead['outlet'] = $mainTable->outlet;

            // $voucherHead['due_date'] = date('Y-m-d', strtotime($mainTable->invoice_date . ' + ' . (int) $mainTable->paymentTerm->no_of_days . ' days'));

            $valid = $this->isPostable($mainTable->invoice_date);



            $lastSavedid = $valid ? $this->addVoucherhead($voucherHead) : 0;



            $total_debtor_amount = round($mainTable->grand_total, 2);

            $total_sales = round($mainTable->total_amount, 2);

            $total_tax_amount = round($mainTable->tax_total, 2);

            $total_discount_amount = round($mainTable->discount, 2);

            $total_received_amount = round($mainTable->received, 2);

            if ($total_debtor_amount > 0) {

                //Debtor Dr

                $debit_item_sales = $this->addVoucheritems($lastSavedid, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                    // 'brand_id' => $mainTable->order_id,

                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1), //2-Creditors 1- debtors

                    'narration' => 'Sales #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->customer->state,

                    'amount' => (float)$total_debtor_amount,

                    'outlet' => $mainTable->outlet

                ));

                if ($total_received_amount > 0) {

                    $outlet = Yii::app()->user->outlet_id;

                    $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="CA" AND outlet=' . $outlet))->id;

                    $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                    $voucherHead['voucher_date'] = $mainTable->invoice_date;

                    $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

                    $voucherHead['voucher_type'] = $vouchertype;

                    // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                    $voucherHead['reference_no'] = $mainTable->reference_no;

                    $voucherHead['header_table_id'] = $mainTable->id;

                    $voucherHead['due_date'] = $mainTable->invoice_date;

                    $voucherHead['outlet'] = $mainTable->outlet;

                    $lastSavedid_receipt_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;



                    $debit_item_receipt = $this->addVoucheritems($lastSavedid_receipt_voucher, array(

                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                        'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                        'narration' => 'Sales #' . $mainTable->invoice_no,

                        'currency' => $mainTable->currency,

                        'exchange_rate' => $mainTable->exchange_rate,

                        'emirate_id' => (int) $mainTable->customer->state,

                        'amount' => -1 * $total_received_amount,

                        'outlet' => $mainTable->outlet

                    ));



                    $this->addVoucheritems($lastSavedid_receipt_voucher, array(

                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('cash_account'),

                        'subledger_id' => MasUsers::model()->findByPk($mainTable->created_by)->subledger_id,

                        'narration' => 'Sales #' . $mainTable->invoice_no,

                        'currency' => $mainTable->currency,

                        'exchange_rate' => $mainTable->exchange_rate,

                        'emirate_id' => (int) $mainTable->customer->state,

                        'amount' =>  (float) $total_received_amount,

                        'outlet' => $mainTable->outlet

                    ));

                    FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('total_voucher_amount' => ($total_received_amount), 'cheque_cleared' => 'Y')); //$netTotal

                    //Auto Allocation

                    $allocation = new FinanceAllocation;

                    $allocation->allocation_date = $mainTable->invoice_date;

                    $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');

                    $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);

                    $allocation->amount = (float) $total_received_amount;

                    $allocation->created_by = Yii::app()->user->id;

                    $allocation->created_date_time = date('Y-m-d h:i:s');

                    $allocation->outlet = $mainTable->outlet;

                    $allocation->save(false);

                    $allocation_items = new FinanceAllocationItems;

                    $allocation_items->header_id = $allocation->id;

                    $allocation_items->voucher_id = $lastSavedid;

                    $allocation_items->voucher_item_id = $debit_item_sales;

                    $allocation_items->amount = (float) $total_received_amount;

                    $allocation->outlet = $mainTable->outlet;

                    $allocation_items->save(false);

                    FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                    $allocation_items = new FinanceAllocationItems;

                    $allocation_items->header_id = $allocation->id;

                    $allocation_items->voucher_id = $lastSavedid_receipt_voucher;

                    $allocation_items->voucher_item_id = $debit_item_receipt;

                    $allocation_items->amount = -1 * $total_received_amount;

                    $allocation->outlet = $mainTable->outlet;

                    $allocation_items->save(false);

                    FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('is_allocated' => 'Y'));
                }

                // Discount Start

                if ($total_discount_amount > 0) {

                    $outlet = Yii::app()->user->outlet_id;

                    $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="JV" AND outlet=' . $outlet))->id;

                    $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);

                    $voucherHead['voucher_date'] = $mainTable->invoice_date;

                    $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);

                    $outlet = Yii::app()->user->outlet_id;

                    $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="JV" AND outlet=' . $outlet))->id;

                    $voucherHead['voucher_type'] = $vouchertype;

                    // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);

                    $voucherHead['reference_no'] = $mainTable->reference_no;

                    $voucherHead['header_table_id'] = $mainTable->id;

                    $voucherHead['due_date'] = $mainTable->invoice_date;

                    $voucherHead['outlet'] = $mainTable->outlet;

                    $lastSavedid_discount_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;



                    $debit_item_discount = $this->addVoucheritems($lastSavedid_discount_voucher, array(

                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),

                        'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                        'narration' => 'Sales #' . $mainTable->invoice_no,

                        'currency' => $mainTable->currency,

                        'exchange_rate' => $mainTable->exchange_rate,

                        'emirate_id' => (int) $mainTable->customer->state,

                        'amount' => -1 * $total_discount_amount,

                        'outlet' => $mainTable->outlet

                    ));



                    $this->addVoucheritems($lastSavedid_discount_voucher, array(

                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('discount'),

                        'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),

                        'narration' => 'Sales #' . $mainTable->invoice_no,

                        'currency' => $mainTable->currency,

                        'exchange_rate' => $mainTable->exchange_rate,

                        'emirate_id' => (int) $mainTable->customer->state,

                        'amount' =>  (float) $total_discount_amount,

                        'outlet' => $mainTable->outlet

                    ));



                    FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('total_voucher_amount' => ($total_discount_amount), 'cheque_cleared' => 'Y')); //$netTotal

                    //Auto Allocation

                    $allocation = new FinanceAllocation;

                    $allocation->allocation_date = $mainTable->invoice_date;

                    $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');

                    $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);

                    $allocation->amount = (float) $total_discount_amount;

                    $allocation->created_by = Yii::app()->user->id;

                    $allocation->created_date_time = date('Y-m-d h:i:s');

                    $allocation->outlet = $mainTable->outlet;

                    $allocation->save(false);

                    $allocation_items = new FinanceAllocationItems;

                    $allocation_items->header_id = $allocation->id;

                    $allocation_items->voucher_id = $lastSavedid;

                    $allocation_items->voucher_item_id = $debit_item_sales;

                    $allocation_items->amount = (float) $total_discount_amount;

                    $allocation_items->outlet = $mainTable->outlet;

                    $allocation_items->save(false);

                    FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));

                    $allocation_items = new FinanceAllocationItems;

                    $allocation_items->header_id = $allocation->id;

                    $allocation_items->voucher_id = $lastSavedid_discount_voucher;

                    $allocation_items->voucher_item_id = $debit_item_discount;

                    $allocation_items->amount = -1 * $total_discount_amount;

                    $allocation_items->outlet = $mainTable->outlet;

                    $allocation_items->save(false);

                    FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('is_allocated' => 'Y'));
                }

                // END Discount

            }



            if ($total_sales > 0) {

                //Sales Accounts Cr

                $this->addVoucheritems($lastSavedid, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales'),

                    // 'brand_id' => $mainTable->order_id,

                    // 'subledger_id' => $this->getSublegder($mainTable->lead_owner_id, 3),

                    'narration' => 'Sales #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->customer->state,

                    'amount' => -1 * $total_sales,

                    'outlet' => $mainTable->outlet

                ));
            }

            if ($total_tax_amount > 0) {

                //VAT Cr

                $this->addVoucheritems($lastSavedid, array(

                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales_vat'),

                    // 'brand_id' => $mainTable->order_id,

                    'subledger_id' => 0,

                    'narration' => 'Sales #' . $mainTable->invoice_no,

                    'currency' => $mainTable->currency,

                    'exchange_rate' => $mainTable->exchange_rate,

                    'emirate_id' => (int) $mainTable->customer->state,

                    'amount' => -1 * $total_tax_amount,

                    'outlet' => $mainTable->outlet

                ));
            }



            FinanceVoucherHead::model()->updatebypk($lastSavedid, array('total_voucher_amount' => (round($mainTable->grand_total, 2)), 'cheque_cleared' => 'Y')); //$netTotal

            $mainTable->posted = 'Y';

            $mainTable->save();
        }
    }

    public function actionChangeCashSales()

    {

        $id     = $_POST['id'];

        $valid  = true;

        $model  = SalesInvoice::model()->findByPk($id);

        $model->payment_term = 1;

        $model->save(false);

        $jsonData['status'] = 'success';

        echo CJSON::encode($jsonData);
    }



    public function actionPrintPos()

    {

        $model = new SalesInvoice();

        $id = Yii::app()->request->getParam('id');

        $this->layout = false;

        $this->renderPartial('application.views.front.pdf.sales_invoice_pos_print', array('model' => $model, 'id' => $id));
    }



    public function actionGetItemHistory()

    {

        $product_id = $_POST['product_id'];

        $customer_id = $_POST['customer_id'];

        $sales_man = $_POST['sales_man'];



        $available_in_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='" . $product_id . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $sales_man)->queryScalar();

        $available_out_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='" . $product_id . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $sales_man)->queryScalar();

        $available_stock = $available_in_qty - $available_out_qty;

        $availble_qty = (!empty($available_stock)) ? $available_stock : 0;



        $last_purchase_rate = StockLedger::getlastPurchaseRate($product_id, 0, Yii::app()->user->outlet_id);

        $modelStockLedger = new StockLedger();

        $modelSalesInvoiceItems = new SalesInvoiceItems();

        // $array_getLastFivePurchaseRates = $modelStockLedger->getLastFivePurchaseRates($product_id,0,Yii::app()->user->outlet_id);  

        $array_getLastFivePurchaseRates = $modelSalesInvoiceItems->getLastFiveSalesRates($product_id, Yii::app()->user->outlet_id);

        $costrate = (!empty($last_purchase_rate)) ? $last_purchase_rate : 0;

        $SalesPriceA =   Inventory::model()->findByPk($product_id)->rate_a;
        $SalesPriceB = Inventory::model()->findByPk($product_id)->rate_b;

        $table = '<table class="table table-sm table-theme table-bordered">

                              <thead>

                               <tr>

                               <th>Available Qty</th>

                               <th>' . $availble_qty . '</td>

                               </tr>
                               <tr>

                               <th>Sales Price A</th>

                               <th>' . Yii::app()->numberFormatter->formatCurrency($SalesPriceA, " ")   . '</td>

                               </tr>
                               <tr>

                               <th>Sales Price B</th>

                               <th>' . Yii::app()->numberFormatter->formatCurrency($SalesPriceB, " ") . '</td>

                               </tr>

                               <tr>

                               <th>Last Cost</th>

                               <th>' . Yii::app()->numberFormatter->formatCurrency($costrate, " ") . '</td>

                               </tr>                               

                              </thead>

                              <tbody>';

        $table .= '<table class="table table-sm table-theme table-bordered">

                  <thead>

                    <tr>

                      <th class="text-center" colspan="6">Last Five Selling Prices</th>

                    </tr>

                  </thead>

                  <tbody>';

        if (!empty($array_getLastFivePurchaseRates)) {

            foreach ($array_getLastFivePurchaseRates as $getLastFivePurchaseRate) {

                $table .= '<tr>

                                         <td>' . Yii::app()->numberFormatter->formatCurrency($getLastFivePurchaseRate, " ") . '</td>

                                       </tr>';
            }
        } else {

            $table .= '<tr>

                                     <td>Empty</td>

                                   </tr>';
        }





        $table .= '</tbody></table>';

        $jsonData['table'] = $table;

        echo CJSON::encode($jsonData);
    }



    public function actionGetItemHistoryNew()
    {
        $product_id = $_POST['product_id'];
        $customer_id = $_POST['customer_id'];
        $sales_man = $_POST['sales_man'];

        // Retrieve available stock quantity and sales prices
        $available_in_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='" . $product_id . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $sales_man)->queryScalar();
        $available_out_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='" . $product_id . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $sales_man)->queryScalar();

        $available_stock = $available_in_qty - $available_out_qty;
        $available_qty = (!empty($available_stock)) ? $available_stock : 0;

        // Retrieve last purchase rate and last five sales rates
        $last_purchase_rate = StockLedger::getlastPurchaseRate($product_id, 0, Yii::app()->user->outlet_id);
        $modelSalesInvoiceItems = new SalesInvoiceItems();
        $array_getLastFiveSalesRates = $modelSalesInvoiceItems->getLastFiveSalesRates($product_id, Yii::app()->user->outlet_id, (int)$customer_id);

        $cost_rate = (!empty($last_purchase_rate)) ? $last_purchase_rate : 0;
        $SalesPriceA = Inventory::model()->findByPk($product_id)->rate_a;
        $SalesPriceB = Inventory::model()->findByPk($product_id)->rate_b;

        // Construct user-friendly formatted list using divs for two-column layout with borders
        $list = "<div style='font-family: Arial, sans-serif; width: 100%; border: 1px solid #ddd;font-size:12px;'>";   // Added border around the entire content

        // Available Quantity
        $list .= "<div style='display: flex; padding: 2px; border-bottom: 1px solid #ddd; background-color: #d2e8ff;font-size:12px;'>";  // Added border for each row
        $list .= "<div style='flex: 1; font-weight: bold;'>Available Qty  :</div>";
        $list .= "<div style='flex: 1;'>" . $available_qty . "</div>";
        $list .= "</div>";

        // Sales Price A
        $list .= "<div style='display: flex; padding: 2px; border-bottom: 1px solid #ddd; background-color: #d2e8ff;font-size:12px;'>";  // Added border for each row
        $list .= "<div style='flex: 1; font-weight: bold;'>Sales Price A  :</div>";
        $list .= "<div style='flex: 1;'>" . Yii::app()->numberFormatter->formatCurrency($SalesPriceA, " ") . "</div>";
        $list .= "</div>";

        // Sales Price B
        $list .= "<div style='display: flex; padding: 2px; border-bottom: 1px solid #ddd; background-color: #d2e8ff;font-size:12px;'>";  // Added border for each row
        $list .= "<div style='flex: 1; font-weight: bold;'>Sales Price B  :</div>";
        $list .= "<div style='flex: 1;'>" . Yii::app()->numberFormatter->formatCurrency($SalesPriceB, " ") . "</div>";
        $list .= "</div>";

        // Last Cost
        $list .= "<div style='display: flex; padding: 2px; border-bottom: 1px solid #ddd; background-color: #d2e8ff;font-size:12px;'>";  // Added border for each row
        $list .= "<div style='flex: 1; font-weight: bold;'>Last Cost &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:</div>";
        $list .= "<div style='flex: 1;'>" . Yii::app()->numberFormatter->formatCurrency($cost_rate, " ") . "</div>";
        $list .= "</div>";

        // Last Five Selling Prices Section (like table header)
        $list .= "<div style='font-weight: bold; padding: 2px; background-color: #f5fca9; margin-top: 10px; border-bottom: 1px solid #ddd;'>"; // Border at the header
        $list .= "Last Five Selling Prices</div>";




        // Add header row
        $list .= "<div style='display: flex; font-weight: bold; padding: 5px; background-color: #2b77c7; color: white; border-bottom: 2px solid #ddd;'>";
        $list .= "<div style='flex: 1;'>Price</div>";
        $list .= "<div style='flex: 1; padding-left: 9px;'>Invoice No</div>";
        $list .= "<div style='flex: 1; padding-left: 10px;'>Date</div>";
        $list .= "</div>";

        // Listing last five selling prices or empty message
        if (!empty($array_getLastFiveSalesRates)) {
            foreach ($array_getLastFiveSalesRates as $sale) {

                $list .= "<div style='display: flex; padding: 5px; border-bottom: 1px solid #ddd; background-color: #d2e8ff;'>";
                $list .= "<div style='flex: 1;'>" . Yii::app()->numberFormatter->formatCurrency($sale['rate'], "") . "</div>";
                $list .= "<div style='flex: 1; padding-left: 10px;'>" . CHtml::encode($sale['invoice_no']) . "</div>";
                $list .= "<div style='flex: 1; padding-left: 10px;'>" . date('d/m/Y', strtotime($sale['invoice_date'])) . "</div>";
                $list .= "</div>";
            }
        } else {
            $list .= "<div style='display: flex; padding: 2px; border-bottom: 1px solid #ddd;background-color: #d2e8ff;'>";  // Added border for each row
            $list .= "<div style='flex: 1;'>No recent sales prices available.</div>";
            $list .= "</div>";
        }

        $list .= "</div>";

        // Return the formatted list as JSON response
        $jsonData['list'] = $list;
        echo CJSON::encode($jsonData);
    }
}
