<?php
class SiteController extends Controller
{
    /**
     * Declares class-based actions.
     */
    public function actions()
    {
        return array(
            // captcha action renders the CAPTCHA image displayed on the contact page
            'captcha' => array(
                'class' => 'CCaptchaAction',
                'backColor' => 0xFFFFFF,
            ),
            // page action renders "static" pages stored under 'protected/views/site/pages'
            // They can be accessed via: index.php?r=site/page&view=FileName
            'page' => array(
                'class' => 'CViewAction',
            ),
        );
    }
    public function accessRules()
    {

        return array(

            array('allow', // allow all users to perform 'index' and 'view' actions

                'actions' => array('login', 'error', 'logout'),

                'users' => array('*'),

            ),

            array('allow', // allow authenticated user to perform 'create' and 'update' actions

                'actions' => array('Index', 'Updatepayment', 'payments', 'validateKey', 'ChangePassword', 'UpdatePassword', 'Payment', 'updatepaymentMobile', 'paymentsuccess','changeOutletUsers'),

                'expression' => '$user->isMember()',

            ),

            array('deny', // deny all users

                'users' => array('*'),

            ),

        );

    }

    public function actionChangePassword() {

        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.min.js' => false);
        $this->render('changepassword');
    }

    public function actionUpdatePassword() {
        $userModel= MasUsers::model()->findByPk( (int) Yii::app()->user->id );
        $salt       = '$2a$10$1qAz2wSx3eDc4rFv5tGb5t';
        $password   = crypt($_POST['user_current_password'], $_POST['user_current_password']);
        if($userModel->password == $password){
            $new_password   = crypt($_POST['user_new_password'], $_POST['user_new_password']);
            $userModel->password=$new_password;
            $userModel->save(false);
            $json['status'] = "success";
        }
        else
        {  
            $json['status'] = "fail";
        }
        echo CJSON::encode($json);
    }

    public function actionIndex()
    {
        if (isset(Yii::app()->user->is_valid_login) && !Yii::app()->user->is_valid_login) {
            $this->redirect('index.php?r=site/payments');
        } else {
            $view = 'salesman';
            if (Yii::app()->user->user_access_type == 'CA') {
                $view = 'outlet';
            }
            if (Yii::app()->user->user_access_type == 'SM') {
                $view = 'outlet';
            }
            if (Yii::app()->user->user_access_type == 'OM') {
                $view = 'outlet';
            }
            if (Yii::app()->user->user_access_type == 'PM') {
                $view = 'outlet';
            }
            if (Yii::app()->user->user_access_type == 'SU') {
                $view = 'company';
            }
            if (Yii::app()->user->user_access_type == 'GA') {
                $view = 'company';
            } 
            $this->render($view);
        }
    }

    public function actionError()
    {
        $this->render('error');
    }
    public function actionchangeOutletUsers(){
        $outlet_id = $_POST['outlet_id'];
        $user_id = $_POST['user_id'];
        $outlet = $_POST['outlet'];
        if($outlet_id=='gr_outlet'){
            $data['drop']=  CHtml::dropdownlist($user_id,'',MasUsers::get_outlet_salesandadmin($outlet), array('class'=>'form-control','data-label'=>'User','prompt' => 'All Users',  'onchange' => 'reloadTable("#tbl_goods_receipt");')); 
        }else if($outlet_id=='gi_outlet'){
            $data['drop']=  CHtml::dropdownlist($user_id,'',MasUsers::get_outlet_salesandadmin($outlet), array('class'=>'form-control','data-label'=>'User','prompt' => 'All Users',  'onchange' => 'reloadTable("#tbl_goods_issue");')); 
        }else if($outlet_id=='gt_outlet'){
            $data['drop']=  CHtml::dropdownlist($user_id,'',MasUsers::get_outlet_salesandadmin($outlet), array('class'=>'form-control','data-label'=>'User','prompt' => 'All Users',  'onchange' => 'reloadTable("#tbl_goods_transfer");')); 
        }else
            $data['drop']=  CHtml::dropdownlist($user_id,'',MasUsers::get_outlet_salesandadmin($outlet), array('class'=>'form-control','data-label'=>'User','prompt' => 'All Users')); 
        echo json_encode($data);
    }
    public function actionUpdatepayment()
    {
        $paymentReference = file_get_contents('php://input');
        $model = new VsPaypalOrders;
        $model->outlet_id = Yii::app()->user->outlet_id;
        $model->order_reference = $paymentReference;
        $model->created_by = Yii::app()->user->id;
        $model->created_date_time = date('Y-m-d h:i:s');
        $model->save(false);

        $modelOutlet = MasOutlets::model()->updateBypk( $model->outlet_id, array( 'subscription_end_date' => date('Y-m-d', strtotime(date('Y-m-d'). ' + 365 days'))));
        echo json_encode( array('status' => 'success') );
    }

    public function actionPayments()
    {
        $this->layout = 'payment';
        $this->render('payments');
    }

    public function actionValidateKey()
    {
        $ac_code  = $_POST['ac_code'];
        $outlet_id = (int) Yii::app()->user->outlet_id;
        $modelOutlet = MasOutlets::model()->findBypk( $outlet_id );
        $statusArray = array( 'status' => 'failed' );

        if( $modelOutlet->id > 0 ){
            if( $modelOutlet->activation_code == $ac_code ){
                $statusArray['status'] = 'success';
                $modelOutlet->subscription_end_date = date('Y-m-d', strtotime(date('Y-m-d'). ' + 365 days')); 
                $modelOutlet->save(false);
            }
        }

        echo json_encode( $statusArray );
    }

    public function actionPayment(){
        $this->layout = 'mobile_payment';
        $user_id = (int) $_GET['user_id'];
        $userModel = MasUsers::model()->findBypk( $user_id );
        $is_new_user =  $userModel->id > 0 ? false : true;
        $userAmount = !$is_new_user ?  170 : 1000;
        $this->render('mobile_payment', array('userModel' => $userModel, 'is_new_user' => $is_new_user, 'userAmount' => $userAmount ));
    }

    public function actionUpdatepaymentmobile(){

        $paymentReference = file_get_contents('php://input');
        $request_data = json_decode( $paymentReference , true);
        $userModel = MasUsers::model()->findBypk( (int) $request_data['user'] );

        $model = new VsPaypalOrders;
        $model->outlet_id = $userModel->outlet_id;
        $model->order_reference = json_encode($request_data['paypal_data']);
        $model->name = $request_data['name'];
        $model->phone = $request_data['phone'];
        $model->created_by =$userModel->id;
        $model->created_date_time = date('Y-m-d h:i:s');
        $model->save(false);

        if(  $model->outlet_id > 0 )
            $modelOutlet = MasOutlets::model()->updateBypk( $model->outlet_id, array( 'subscription_end_date' => date('Y-m-d', strtotime(date('Y-m-d'). ' + 365 days'))));
        echo json_encode( array('status' => 'success') );

    }

    public function actionPaymentsuccess(){
        //$this->layout = '';
        $this->render('payment_success');
    }
}
