<?php

class UserController extends Controller {

    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index','GetList', 'Create','Save','Download_backup'),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex() {
        $this->render('index');
    }
    /*
     * ajax function to list all user datatable
     * modified by jisha on 19-6-20. 
     */

      public function actionGetList() {
        $model  = new MasUsers();
        $draw   = $_POST['draw'];
        $offset = $_POST['start'];
        $limit  = $_POST['length'];
        $outlet = $_POST['outlet'];
        $columns = array(
            // datatable column index  => database column name
            0 => 't.id',
            1 => 't.username',
            2 => 't.full_name',
            3 => 't.phone_no',
            4 => 'outletDetails.outlet_name',
            5 => 't.id',
            6 => 't.is_active'
        );
        $filterColumn   = $columns[$_POST['order'][0]['column']];
        $filterOrder    = $_POST['order'][0]['dir'];
        $orderBy        = $filterColumn . " " . $filterOrder;
        $condition      = '(access_type!="DEV" AND access_type!="SU") AND t.company_id='.Yii::app()->user->company_id;
        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            $condition.=" AND (t.full_name LIKE '%" . $searchString . "%' OR t.username LIKE '%" . $searchString . "%' OR t.phone_no LIKE '%" . $searchString . "%'  OR outletDetails.outlet_name LIKE '%" . $searchString . "%')";
        }
        if($outlet>0){
            $condition.=" AND t.outlet_id=".$outlet;
        }
        $count          = $model->with('outletDetails')->count(array('condition' => $condition));
        $model          = $model->with('outletDetails')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));
        $recordsTotal   = $count;
        $recordsFiltered        = $count;
        $data['draw']   = $draw;
        $data['recordsTotal']   = $recordsTotal;
        $data['recordsFiltered']= $recordsFiltered;
        $rowData                = array();
        $m=1;
        foreach ($model as $row)
        {
            if( Yii::app()->user->user_access_type != 'SL'){
                $div= '<div class="text-center"><button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'user/create&id='.$row['id'].'\',\'Edit - '.$row['full_name'].'\',\'lg\')"><i class="fa fa-edit" aria-hidden="true"></i></button></div>';
            }
            $rowData[]  = array($m,$row['username'],$row['full_name'],$row->phone_no,$row['outletDetails']['outlet_name'],$div,$row['is_active']);
            $m++;
        } 
        $data['data'] = $rowData;
        echo json_encode($data);
    }
    /*
     * function to create user details
     * modified by jisha on 19-6-20. 
     */
    public function actionCreate() {
       $id = (int) Yii::app()->request->getParam('id');
        $model = new MasUsers;
        if ($id > 0) {
            $model = $model->findByPk($id);
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model));
    }
    public function actionSave() {
        $model = new MasUsers();
        $valid = true;$other=array();
        if (isset($_POST['MasUsers'])) {
            if ($_POST['MasUsers']['id'] > 0) {
                $id =  $_POST['MasUsers']['id'];
                $model = $model->findByPK($id);
                $model->username = $_POST['MasUsers']['username'];
                $model->full_name = $_POST['MasUsers']['full_name'];
                $model->phone_no = $_POST['MasUsers']['phone_no'];
                $model->is_active = $_POST['MasUsers']['is_active'];
                if($model->password!=$_POST['MasUsers']['password'])
                {
                $model->password   = crypt($_POST['MasUsers']['password'], $_POST['MasUsers']['password']);
                $model->token=rand();
                }
                $valid = $model->validate();
                if($valid){
                    $model->save();
                    // ------------------------------------------
                        $subledger = FinanceSubledger::model()->find(array('condition' => 'subledger_type_id=3 AND parent_id=' . $model->id));
                        if (empty($subledger)) {
                            $newItem = new FinanceSubledger;
                        } else {
                            $newItem = FinanceSubledger::model()->findByPk($subledger->id);
                        }
                        $newItem->description = $model->full_name;
                        $newItem->account_no = $model->id;
                        // if ($model->address != '') {
                        //     $newItem->address = $model->address;
                        // }
                        if ($model->phone_no != '') {
                            $newItem->phone = $model->phone_no;
                        }
                        $newItem->subledger_type_id = 3;
                        $newItem->parent_id = $model->id;
                        $newItem->created_by = Yii::app()->user->id;
                        $newItem->outlet = $model->outlet_id;
                        $newItem->save(false);
                    // ------------------------------------------
                    $jsonData['status'] = 'success';
                    echo CJSON::encode($jsonData);
                }else{
                    $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                    $error = CJSON::encode(array_merge_recursive($error1,$other));
                    if ($error != '[]'){
                        echo $error;    
                    }
                }
            } else{
                echo 'add error';
            }
        }else{
            echo 'error';
        }
    }
    public function actionDownload_backup() {
       $id = (int) Yii::app()->request->getParam('id');
        $model = new MasUsers;
        if ($id > 0) {
            $model = $model->findByPk($id);
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('download_backup', array('model' => $model));
    }
}
