<?php
class Inventory extends CActiveRecord
{
public $cost;
	public function tableName()
	{
		return '{{inventory}}';
	}
	public function rules()
	{
		return array(
                                                               array('part_number', 'filter', 'filter'=>'trim'),
                                                               array('description', 'filter', 'filter'=>'trim'),
                                                               array('barcode', 'filter', 'filter'=>'trim'),
			array('part_number,description,generic_id,brand,unit,type,outlet,tax_code', 'required'),
			array('brand,unit,generic_id,created_by,updated_by,outlet,sec_unit_id', 'numerical', 'integerOnly'=>true),
			array('rate,excise_tax,rate_a,rate_b', 'numerical'),
			array('part_number,barcode', 'length', 'max'=>100),
			array('description', 'length', 'max'=>255),
			array('part_number,description,unit,type,outlet,tax_code,tax', 'safe', 'on'=>'search'),
			array('part_number', 'checkUniqueness'),
                                                              array('barcode', 'barcodeUniqueness'),
		);
	}
	public function checkUniqueness($attribute,$params)
                                {
			if($this->id>0)
			{
			$model = Inventory::model()->find('part_number = "'.$this->part_number.'" AND id!='.$this->id.' AND outlet='.$this->outlet);
			}
                                else {
			$model = Inventory::model()->find('part_number = "'.$this->part_number.'" AND outlet='.$this->outlet);	
			}
			if(count($model)>0)	
			{
			$this->addError('id','This Part Number already exist'); 
			}
                            }
                            	public function barcodeUniqueness($attribute,$params)
                                                            {
			if($this->id>0)
			{
			$model = Inventory::model()->find('barcode = "'.$this->barcode.'" AND id!='.$this->id.' AND outlet='.$this->outlet);
			}
                                else {
			$model = Inventory::model()->find('barcode = "'.$this->barcode.'" AND outlet='.$this->outlet);	
			}
			if(count($model)>0)	
			{
			$this->addError('id','This barcode already exist'); 
			}
                                                            }

	public function relations()
	{
		return array(
		'units' => array(self::BELONGS_TO, 'MasUnit', 'unit'),
		'sec_unit_det' => array(self::BELONGS_TO, 'MasUnit', 'sec_unit_id'),
		'brands' => array(self::BELONGS_TO, 'MasBrand', 'brand'),
		'taxDetails'=> array(self::BELONGS_TO, 'MasTax', 'tax_code'),
		'generic'=> array(self::BELONGS_TO, 'MasGeneric', 'generic_id'),
		);
	}

	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'part_number' => 'Part Number',
			'description' => 'Description',
			'brand' => 'Brand',
			'generic_id' => 'Generic',
			'created_by' => 'Created By',
			'created_time' => 'Created Time',
			'updated_by' => 'Updated By',
			'updated_time' => 'Updated Time',
			'active' => 'N: No, Y: Yes',
			'outlet' => 'Outlet',
		);
	}
	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
	public function getunit_exchange_rate()
	{
		return $this->units->unit_exchange_rate;
	}
	public function getUnit_symbol()

    {

        return $this->units->label;
    }
}
