<?php
class MasCompany extends CActiveRecord
{
	const MAIN_DB = 'bluesell_new_main';

	public function tableName()
	{
		 return MasCompany::MAIN_DB.'.{{company}}';
	}
	public function rules()
	{
		return array(
			array('currency, name, trn_no, billing_address, phone, po_box, logo, vat_return, pdf_logo, pdf_footer, ', 'required'),
			array('currency', 'numerical', 'integerOnly'=>true),
			array('name, trn_no, master_key', 'length', 'max'=>255),
			array('is_active', 'length', 'max'=>1),
			array('id, currency, name, trn_no, billing_address, is_active, master_key', 'safe', 'on'=>'search'),
		);
	}

	public function relations()
	{
		return array(
		);
	}

	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'currency' => 'Currency',
			'name' => 'Name',
			'trn_no' => 'Trn No',
			'billing_address' => 'Billing Address',
			'is_active' => 'Is Active',
			'master_key' => 'Master Key',
		);
	}
	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('currency',$this->currency);
		$criteria->compare('name',$this->name,true);
		$criteria->compare('trn_no',$this->trn_no,true);
		$criteria->compare('billing_address',$this->billing_address,true);
		$criteria->compare('is_active',$this->is_active,true);
		$criteria->compare('master_key',$this->master_key,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public static function get_companies(){
		$model = self::model()->findAll( array('order' => 'name' ) );
        return CHtml::listdata($model, 'id', 'name');
	}
}
