<?php
class Production extends CActiveRecord
{   
                    public $part_no;
	public function tableName()
	{
		return '{{production}}';
	}
	public function rules()
	{
		return array(
			array('production_no, production_date, reference,outlet,product_id,description,quantity,rate,amount,unit', 'required'),
			array('production_no, created_by, updated_by, outlet', 'numerical', 'integerOnly'=>true),
			array('reference', 'length', 'max'=>255),
			array('notes', 'length', 'max'=>2225),
			array('active, posted', 'length', 'max'=>1),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id, production_no, production_date, reference, notes, active, created_by, created_time, updated_by, updated_time, posted, outlet', 'safe', 'on'=>'search'),
		);
	}
	public function relations()
	{
		return array(
		    'pr_outlet'   => array(self::BELONGS_TO, 'MasOutlets', 'outlet'),
		    'pr_user'     => array(self::BELONGS_TO, 'MasUsers', 'created_by'),
                                             'pr_product_details'     => array(self::BELONGS_TO, 'Inventory', 'product_id'),
                                             'pr_unit_details'        => array(self::BELONGS_TO, 'MasUnit', 'unit'),
        );
	}
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'production_no' => 'Production No',
			'production_date' => 'Production Date',
			'sales_man'  => 'Sales Man',
			'reference' => 'Reference',
			'notes' => 'Notes',
			'active' => 'Active',
			'created_by' => 'Created By',
			'created_time' => 'Created Time',
			'updated_by' => 'Updated By',
			'updated_time' => 'Updated Time',
			'posted' => 'Posted',
			'outlet' => 'Outlet',
		);
	}

	public function search()
	{

		$criteria=new CDbCriteria;
		$criteria->compare('id',$this->id);
		$criteria->compare('production_no',$this->production_no);
		$criteria->compare('production_date',$this->production_date,true);
		$criteria->compare('reference',$this->reference,true);
		$criteria->compare('notes',$this->notes,true);
		$criteria->compare('active',$this->active,true);
		$criteria->compare('created_by',$this->created_by);
		$criteria->compare('created_time',$this->created_time,true);
		$criteria->compare('updated_by',$this->updated_by);
		$criteria->compare('updated_time',$this->updated_time,true);
		$criteria->compare('outlet',$this->outlet);
		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
