<?php
class PurchaseOrder extends CActiveRecord
{
    public $vendor_name;
	public function tableName()
	{
		return '{{purchase_order}}';
	}
	public function rules()
	{
		return array(
			array('order_date,order_no, vendor_id, payment_term, total_amount, excise_total, tax_total, grand_total, currency, exchange_rate, outlet', 'required'),
			array('order_no, vendor_id, payment_term, currency, created_by, updated_by, outlet', 'numerical', 'integerOnly'=>true),
			array('prefix, reference_no', 'length', 'max'=>50),
			array('total_amount, excise_total, tax_total, grand_total, exchange_rate', 'numerical'),
			array('active', 'length', 'max'=>1),
			array('order_date, created_time, updated_time', 'safe'),
			array('notes', 'length', 'max'=>2225),
			array('id, prefix, order_no, reference_no, order_date, vendor_id, payment_term, total_amount, excise_total, tax_total, grand_total, currency, exchange_rate, created_by, created_time, updated_by, updated_time, active, outlet', 'safe', 'on'=>'search'),
		);
	}
	public function relations()
	{
            return array(
		    'purchase_outlet' => array(self::BELONGS_TO, 'MasOutlets', 'outlet'),
                    'purchase_cur' => array(self::BELONGS_TO, 'MasCurrency', 'currency'),
                    'vendor' => array(self::BELONGS_TO, 'Vendor', 'vendor_id'),
                    'pay_term' => array(self::BELONGS_TO, 'MasPaymentTerms', 'payment_term'),
                    'user' => array(self::BELONGS_TO, 'MasUsers', 'created_by'),
		);
	}
        
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'prefix' => 'Prefix',
			'order_no' => 'Order No',
			'reference_no' => 'Customer Order No',
			'order_date' => 'Order Date',
			'vendor_id' => 'Vendor',
			'payment_term' => 'Payment Term',
			'total_amount' => 'W/O Tax',
			'excise_total' => 'Excise Total',
			'tax_total' => 'Tax Total',
			'grand_total' => 'Grand Total',
			'currency' => 'Currency',
			'exchange_rate' => 'Exchange Rate',
			'created_by' => 'Created By',
			'created_time' => 'Created Time',
			'updated_by' => 'Updated By',
			'updated_time' => 'Updated Time',
			'active' => 'N : No, Y : Yes',
			'outlet' => 'Outlet',
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;
		$criteria->compare('id',$this->id);
		$criteria->compare('prefix',$this->prefix,true);
		$criteria->compare('order_no',$this->order_no);
		$criteria->compare('reference_no',$this->reference_no,true);
		$criteria->compare('order_date',$this->order_date,true);
		$criteria->compare('vendor_id',$this->vendor_id);
		$criteria->compare('payment_term',$this->payment_term);
		$criteria->compare('total_amount',$this->total_amount,true);
		$criteria->compare('excise_total',$this->excise_total,true);
		$criteria->compare('tax_total',$this->tax_total,true);
		$criteria->compare('grand_total',$this->grand_total,true);
		$criteria->compare('currency',$this->currency);
		$criteria->compare('exchange_rate',$this->exchange_rate,true);
		$criteria->compare('created_by',$this->created_by);
		$criteria->compare('created_time',$this->created_time,true);
		$criteria->compare('updated_by',$this->updated_by);
		$criteria->compare('updated_time',$this->updated_time,true);
		$criteria->compare('active',$this->active,true);
		$criteria->compare('outlet',$this->outlet);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
