
<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("deleteAllocation",  "function deleteAllocation(id){
    var r = confirm('Are you sure to delete this?');
    if(r==true)
        jQuery.ajax({
            'type'  : 'post',
            'data'  : {'id' : id},
            'url'  : $('#liveSite').val()+'index.php?r=finance/core/deleteallocation',
            'cache': false,
            'success':function(data){
                if(data=='success'){
                    t8.success('Done!');
                    reloadTable('#fin_table_allocation');
                }else{
                    t8.error(data);
                }
            }
        });
};", CClientScript::POS_HEAD);

$cs->registerScript("load", 
                '$(document).ready(function() {
                    var table_id ="#fin_table_allocation";
                    var table = $(table_id).on("preXhr.dt", function (e, settings, data) {
                        data.from_date = $("#start_date").val();
                        data.to_date = $("#end_date").val();
                        data.voucher_type = $("#voucher_type").val();
                        data.outlet = $("#voucher_outlet").val();
                        return data;
                    }).DataTable({
                    scrollY         : "450px",
                    pageLength      : 100,
                    columns: [
                        {className: "sl col-max-2"},
                        {className: "sl col-max-3"},
                        {className: "sl col-max-4"},
                        {className: "sl col-max-4"},
                        {className: "sl col-max-3"},
                        {className: "sl col-max-3"},
                        {className: "sl col-max-2"},
                    ],
                    ajax: {
                        url: "' . Yii::app()->createUrl('finance/core/getallocationlist') . '",
                        type: "POST",
                        cache : false,
                    },
                    serverSide:     true,
                    fixedColumns:   true,
                    processing: true,
                    order: [[ 2, "desc" ]],
                });
                $(".dataTables_scrollFoot").hide();
            });', CClientScript::POS_HEAD);

  ?>
    <section class="panel">
        <header class="panel-heading clearfix panel-theame">
            <i class="fa fa-code-fork"></i> Allocation
            <div class="pull-right" style="display: flex;">
                <?php echo CHtml::textfield('start_date',date('01/01/Y'),array('class' => 'datepicker form-control', 'style' => 'margin-right:10px; width:120px;')); ?>
                <?php echo CHtml::textfield('end_date',date('t/m/Y'),array('class' => 'datepicker form-control', 'style' => 'margin-right:10px; width:120px;')); ?><?php 
                    if(Yii::app()->user->user_access_type == 'DEV' || Yii::app()->user->user_access_type == 'SU')
                    {
                    $array=array('class'=>'form-control','data-label'=>'Outlet','prompt' => 'All Outlets',  'onchange' => 'reloadTable("#fin_table_allocation");');
                    }
                    else if(Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SL')
                    {
                    $array=array('class'=>'form-control','data-label'=>'Outlet',  'onchange' => 'reloadTable("#fin_table_allocation");');
                    }
                    echo CHtml::dropdownlist('voucher_outlet',Yii::app()->user->outlet_id, MasOutlets::getAllOutlets(), $array); ?>     
               
                <button class="btn btn-sm btn-theme" style="margin-right: 10px;" title="Reload" onclick="reloadTable('#fin_table_allocation');"><i class="fa fa-retweet"></i> Load</button>
                <button class="btn btn-sm btn-theme" title= "Allocate" onclick="loadPopupModal('finance/vouchers/allocate','Allocation','xl')"><i class="fa fa-code-fork"></i> New</button>
            </div>
        </header>
        <div class="panel-body">
            <div class="custom-data-table">
                <table class="table table-hover table-bordered personal-task" id="fin_table_allocation">
                    <thead>
                        <tr>
                            <th>#</th>
                            <th>Date</th>
                            <th>A/C</th>
                            <th>Subledger</th>
                            <th>Amount</th>
                            <th>Outlet</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                    <tfoot>
                        <tr>
                            <th>#</th>
                            <th>Date</th>
                            <th>A/C</th>
                            <th>Subledger</th>
                            <th>Amount</th>
                            <th>Outlet</th>
                            <th>Actions</th>
                        </tr>
                    </tfoot>
                </table>
            </div>
        </div>
    </section>
