<script src="js/jquery.aCollapTable.js"></script>

<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("loadPage", "function loadPage(){
                $('#loader').show();
                jQuery.ajax({
                    'type': 'post',
                    'url': '" . Yii::app()->createUrl('finance/reports/gl_summary_html') . "',
                    'data' : { 'ledger_id' : $('#ledger_id').val(), 'from' : $('#fn_report_from').val(), 'to' : $('#fn_report_to').val(), 'brand' : 0, 'outlet' : $('#outlet').val(),'salesman' : $('#salesman').val() },
                    'success': function(data) {
                        $('#data_div').show();
                        $('#gl_report_li').hide();
                        $('#gl_report_tab').empty();
                        $('#gl_summary_li').show();
                        $('#gl_summary_li').addClass('active');
                        $('#gl_summary_tab').addClass('active');
                        $('#gl_summary_tab').html(data);
                        $('#loader').hide();
                    }
                });
        }", CClientScript::POS_HEAD);
        $cs->registerScript("load_gl_report", "function load_gl_report(ledger_id, subledger_id, from_date, to_date, outlet){
            $('#loader').show();
            jQuery.ajax({
                'type': 'post',
                'url': '" . Yii::app()->createUrl('finance/reports/gl_html') . "',
                'data' : { 'ledger_id' : ledger_id, 'subledger_id' : subledger_id, 'from' : from_date, 'to' : to_date, 'brand' : 0, 'currency' : 1, 'outlet' : outlet },
                'success': function(data) {
                    $('#gl_report_li').show();
                    $('#gl_report_tab').html(data);
                    $('#gl_summary_li').removeClass('active');
                    $('#gl_summary_tab').removeClass('active');
                    $('#gl_report_li').addClass('active');
                    $('#gl_report_tab').addClass('active');
                    $('#loader').hide();
                    $('#gl_table').aCollapTable({
                        startCollapsed: true,
                        addColumn: false,
                        plusButton: '<i class=\"fa fa-plus\"></i>&nbsp;', 
                        minusButton: '<i class=\"fa fa-minus\"></i>&nbsp;' 
                    });
                }
            });
        }", CClientScript::POS_HEAD);
        
?>

<style>
table {
  font-family: arial, sans-serif !important;
  border-collapse: collapse !important;
  width: 100% !important;
}

td, th {
  border: 1px solid #dddddd !important;
  text-align: left !important;
  padding: 8px !important;
}

table th{
	padding-top: 12px;
    padding-bottom: 12px;
    text-align: left;
    background-color: #1f67b2;
    color: white;
}

tr:nth-child(even) {
  background-color: #f2f2f2 !important;
}
</style>
<div class="row">
    <div class="col-sm-12">
        <section class="panel">
            <header class="panel-heading clearfix">
                <ul class="clearfix form-ul material">
                <li class="col-sm-2">
                        <?php echo CHtml::textField('fn_report_from', date('d/m/Y'), array('class' => 'datepicker tooltipster', 'data-label' => 'From')); ?>
                    </li>
                    <li class="col-sm-2">
                        <?php echo CHtml::textField('fn_report_to', date('d/m/Y'), array('class' => 'datepicker tooltipster', 'data-label' => 'To')); ?>
                    </li>
                    <li class="col-sm-3">
                        <?php echo CHtml::dropdownlist("ledger_id", '', FinanceLegder::getChilds(), array('class' => 'tooltipster', 'data-label' => 'Ledgers', 'data-search' => true)); //getAll  ?>
                    </li>
                    <?php if( Yii::app()->user->user_access_type != 'SL' ) {  ?>
                        <li class="col-sm-2">
                            <?php echo CHtml::dropdownlist('salesman', '', MasOutlets::salesmans(), array('class' => 'tooltipster', 'data-label' => 'Salesman', 'prompt' => 'All','data-search'=>true)); ?>
                        </li>
                    <?php } else{
                        echo CHtml::hiddenField('salesman',Yii::app()->user->id);
                    }?>
                    <li class="col-sm-1">
                    <?php 
                    if(Yii::app()->user->user_access_type == 'DEV' || Yii::app()->user->user_access_type == 'SU')
                    {
                    $array=array('class'=>'tooltipster','data-label'=>'Outlet','prompt' => 'All Outlets');
                    }
                    else if(Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SL')
                    {
                    $array=array('class'=>'tooltipster','data-label'=>'Outlet');
                    }
                    echo CHtml::dropdownlist('outlet',Yii::app()->user->outlet_id, MasOutlets::getAllOutlets(), $array); ?>     
                    </li>
                    <div class="btn-wrap text-center">
                        <a type="button" class="btn btn-theme" onclick="loadPage();">HTML</a>
                        <a type="button" class="btn btn-theme" onclick="window.open($('#liveSite').val()+'index.php?r=finance/reports/gl_summary_pdf&from_date='+$('#fn_report_from').val()+'&to_date='+$('#fn_report_to').val()+'&ledger='+$('#ledger_id').val()+'&brand='+$('#brand_id').val()+'&outlet='+$('#outlet').val()+'&salesman='+$('#salesman').val(), '_blank'); ">PDF</a>
                        <a type="button" class="btn btn-theme" onclick="window.open($('#liveSite').val()+'index.php?r=finance/reports/gl_summary_excel&from_date='+$('#fn_report_from').val()+'&to_date='+$('#fn_report_to').val()+'&ledger='+$('#ledger_id').val()+'&brand='+$('#brand_id').val()+'&outlet='+$('#outlet').val()+'&salesman='+$('#salesman').val(), '_blank');">XLS</a>
                    </div>
                </ul>
            </header>
            <div class="panel-body" id="data_div" style="display:none;" >
                <ul class="nav nav-tabs company-nav-tabs nav-tab-theme">
                    <li id="gl_summary_li" style="display:none;"><a href="#gl_summary_tab" data-toggle="tab" >Ledger Summary </a></li>
                    <li id="gl_report_li" style="display:none;"><a href="#gl_report_tab" data-toggle="tab" >General Ledger <i onclick="$('#gl_summary_li').addClass('active'); $('#gl_summary_tab').addClass('active');  $('#gl_report_li').hide();$('#gl_report_tab').empty();" class="fa fa-remove"></i></a></li>
                </ul>
                <div class="tab-content">
                    <div class="tab-pane" id="gl_summary_tab">
                    </div>
                    <div class="tab-pane" id="gl_report_tab">
                    </div>
                </div>
            </div>
        </section>
    </div>
</div>
