<?php
     $form = $this->beginWidget('CActiveForm', array(
            'id' => 'voucher-form',
            'enableAjaxValidation' => false,
            'enableClientValidation' => false,
        ));
        $cs = Yii::app()->getClientScript();
        $cs->registerScript("updatetextfield", "function updatetextfield(field_id,value){
            var arr_field_id = field_id.split('_');
            var no = arr_field_id[1];
            jQuery.ajax({
                'type': 'post',
                'url': '" . Yii::app()->createUrl('finance/core/havesubledger') . "',
                'data' : {'account' : value},
                'success': function(data) { 
                    if( data == 'true' ){
                        $('#FinanceVoucherItems_'+no+'_subledger_name').attr( 'readonly', false );
                        $('#FinanceVoucherItems_'+no+'_subledger_id').val('');
                    }else{
                        $('#FinanceVoucherItems_'+no+'_subledger_name').attr( 'readonly', true );
                        $('#FinanceVoucherItems_'+no+'_subledger_name').val('');
                        $('#FinanceVoucherItems_'+no+'_subledger_id').val('');
                    }
                }
            });
        }", CClientScript::POS_HEAD);
        $cs->registerScript("loadtemplate", "function loadtemplate(){
            var voucher_type = $('#FinanceVoucherHead_voucher_type').val(); 
            var payment_method = $('#FinanceVoucherHead_payment_method').val(); 
            
            jQuery.ajax({
                'type': 'post',
                'url': '" . Yii::app()->createUrl('finance/vouchers/loadtemplate') . "',
                'data' : {'voucher_type' : voucher_type, 'payment_method' : payment_method},
                'success': function(data) { 
                    $('#template_div').html(data);
                }
            });
            
        }", CClientScript::POS_HEAD);
        $cs->registerScript("getSublegders", "function getSublegders(field_id)
        {
            var arr_field_id = field_id.split('_');
            var i = arr_field_id[1];
            var account_id = $('#FinanceVoucherItems_'+i+'_ledger_id').val();
            
            if( account_id > 0 ){
                var url = '" . Yii::app()->createUrl('finance/vouchers/subledgerlist') . "&ledger='+account_id;
                $('#'+field_id).autocomplete({
                    minLength   : 1,
                    source      : function (request, response) { autoCompleteSource(request, response, url) },
                    focus       : function( event, ui ) {},
                    select          : function( event, ui ) {
                        event.preventDefault();
                        $('#FinanceVoucherItems_'+i+'_subledger_name').val(ui.item.label);
                        $('#FinanceVoucherItems_'+i+'_subledger_id').val(ui.item.value);
                    }
                })
            }else{
                t8.error('Choose Ledger First!');
                $('#FinanceVoucherItems_'+i+'_subledger_name').val('');
                return false;
            }
        }", CClientScript::POS_HEAD); 
        $cs->registerScript('calculateTotal', 'function calculateTotal(){
            var creditTotal = 0;
            var debitTotal = 0;
            $("#voucher_entries").find("tr:gt(0)").each(function() {
                if( parseFloat($(this).find("[id $=_debit]").val()) > 0 )
                    debitTotal += parseFloat($(this).find("[id $=_debit]").val());
                if( parseFloat($(this).find("[id $=_credit]").val()) > 0 )
                    creditTotal += parseFloat($(this).find("[id $=_credit]").val());
            });
            $("#debit_total").val( Number(debitTotal).toFixed(2));
            $("#credit_total").val( Number(creditTotal).toFixed(2));
        }', CClientScript::POS_HEAD);
        $cs->registerScript("nextline" ,"function nextline(event)
        {
            if (event.keyCode == 13) {
                event.preventDefault();
                newVoucher($('#voucher_entries'));
                return false;
            }
        }", CClientScript::POS_HEAD);
        $cs->registerScript("newVoucher", " function newVoucher(jQtable) {
            formId              =   jQtable.attr('id');
            formIdStarter       =   jQtable.attr('id').split(/_(.+)?/)[0];
            lastId = jQtable.find('tr:last input:first').attr('id');
            thenum = lastId.match(/\d+/g);
            var narration = $('#FinanceVoucherItems_'+thenum+'_narration').val();
            newId = Number(thenum) + 1;
            newrow= jQtable.find('tr:last').clone();
            newrow.find('label:first').html(newId+1);
            newrow.attr('class',newId);
            newrow.find('.hasDatepicker').removeClass('hasDatepicker');
            newrow.find('.datetimepicker').siblings().remove();
            newrow.find('.datetimepicker').datetimepicker( 'destroy' );
            newrow.find('div,input,textarea,checkbox,td,select,.errorMessage,a').each(function() {
                this.id= this.id.replace(/\d+/,newId);
                if(!$(this).is(':checkbox'))
                    this.value  = '';
                else
                    $(this).prop('checked', false);
                (this.name!==undefined) ? this.name= this.name.replace(/\d+/,newId) : this.style = '';
            });
            jQtable.append(newrow);
            $('#FinanceVoucherItems_'+newId+'_narration').val(narration);
            $('#FinanceVoucherItems_'+newId+'_debit').attr( 'readonly', false );
            $('#FinanceVoucherItems_'+newId+'_credit').attr( 'readonly', false );
        }", CClientScript::POS_HEAD);
        $cs->registerScript("changeDiv" ,"function changeDiv(value)
        {
            var payment_method = $('#FinanceVoucherHead_voucher_type').val();
            if( value == 2 ){
                $('#cheque_div').show();
                $('#card_div').hide();
                if( payment_method == 2 )
                    $('#bank_name_div').show();
                else
                    $('#bank_name_div').hide();
            }else if(value == 4 ){
                $('#cheque_div').hide();
                $('#card_div').show();
                $('#bank_name_div').hide();
            }else if( value == 3 ){
                if( payment_method == 2 )
                    $('#bank_name_div').show();
                else
                    $('#bank_name_div').hide();
                $('#cheque_div').hide();
                $('#card_div').hide();
            }else{
                $('#cheque_div').hide();
                $('#card_div').hide();
                $('#bank_name_div').hide();
            }
            loadtemplate();
        }", CClientScript::POS_HEAD);

        $debitTotal = 0;
        $creditTotal = 0;

        $expenseModel = Expense::model()->findBypk($expense_id);
        $model->voucher_date = date('d/m/Y', strtotime($expenseModel->created_datetime));
        $model->reference_no = $expenseModel->id;
        $model->expense_id = $expense_id;
        
        $items  = array();
        for($i=0; $i < 2; $i++) :
            if( $i == 0 ) {
                //Debit
                $items[$i] = new FinanceVoucherItems;
                $items[$i]->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');
                $subledgerModel = FinanceSubledger::model()->find( array( 'condition' => 'subledger_type_id=1 AND parent_id='.$expenseModel->customer_id ) );
                $items[$i]->subledger_id = $subledgerModel->id;
                $items[$i]->subledger_name = $subledgerModel->description;
                $items[$i]->amount = $expenseModel->amount;
                $items[$i]->narration = $expenseModel->narration;
                $items[$i]->is_readonly = FinanceLegder::is_subledger_account($items[$i]->ledger_id);
            }else{
                //Credit
                $items[$i] = new FinanceVoucherItems;
                $items[$i]->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('cash_account');
                $items[$i]->subledger_id = 0;
                $items[$i]->amount = -1*$expenseModel->amount;
                $items[$i]->narration = $expenseModel->narration;
                $items[$i]->is_readonly = FinanceLegder::is_subledger_account($items[$i]->ledger_id);
            }
        endfor;

?>

<div class="tab-content">
    <div class="tab-pane active">
        <ul class="clearfix form-ul material">
            <li class="col-sm-3">
                <?php echo $form->dropdownlist($model, 'voucher_type', FinanceVoucherType::getTypes(false), array('data-label'=>'Voucher Type', 'onChange' => 'if(this.value == 1 || this.value == 2){ $("#voucherDifference_div").show(); if( this.value == 1 ){ $("#bank_name_div").hide(); } }else{ $("#voucherDifference_div").hide(); } loadtemplate(); ')); // receipt or Payment ?>
                <?php echo $form->hiddenField($model, 'id'); ?>
                <?php echo $form->hiddenField($model, 'expense_id'); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->textField($model,'voucher_date',array('data-label'=>'Voucher Date', 'class' => 'datepicker' )); ?>
            </li>
            <div id="voucherDifference_div" style="display:<?php echo (in_array($model->voucher_type, array(1, 2))) ? 'block' : 'none' ?>">
                <li class="col-sm-3">
                    <?php echo $form->textField($model,'reference_no',array('data-label'=>'Reference', 'class' => 'tooltipster' )); ?>
                </li>
                <li class="col-sm-3">
                    <?php echo $form->textField($model,'paid_or_received',array('data-label'=>'Paid to/ Received from', 'class' => 'tooltipster' )); ?>
                </li>
                <li class="col-sm-3">
                    <?php echo $form->dropdownlist($model, 'payment_method', array( 1=> 'Cash', 2 => 'Cheque', 3 => 'Bank', 4 => 'Card'), array('data-label'=>'Payment method', 'onChange' => 'changeDiv(this.value);')); ?>
                </li>
                <li class="col-sm-3" id="bank_name_div" style="display:<?php echo (in_array($model->payment_method, array(2, 3)) && $model->voucher_type == 2 ) ? 'block' : 'none' ?>">
                        <?php echo $form->textField($model,'bank_name',array('data-label'=>'Bank', 'class' => 'tooltipster' )); ?>
                </li>
                <div id="cheque_div" style="display:<?php echo (in_array($model->payment_method, array(2))) ? 'block' : 'none' ?>">
                   
                    <li class="col-sm-2">
                        <?php echo $form->textField($model,'cheque_no',array('data-label'=>'Cheque No', 'class' => 'tooltipster' )); ?>
                    </li>
                    <li class="col-sm-2">
                        <?php $model->cheque_date = ( $model->isNewRecord ) ? date('d/m/Y') : date('d/m/Y', strtotime( $model->cheque_date )) ?>
                        <?php echo $form->textField($model,'cheque_date',array('data-label'=>'Cheque Date', 'class' => 'tooltipster datepicker' )); ?>
                    </li>
                    <li class="col-sm-2">
                        <?php $model->realisation_date = ( $model->isNewRecord ) ? date('d/m/Y') : date('d/m/Y', strtotime( $model->realisation_date )) ?>
                        <?php echo $form->textField($model,'realisation_date',array('data-label'=>'Realisation date', 'class' => 'tooltipster datepicker' )); ?>
                    </li>
                </div>
                <div id="card_div" style="display:<?php echo (in_array($model->payment_method, array(4))) ? 'block' : 'none' ?>">
                    <li class="col-sm-3">
                        <?php echo $form->textField($model,'card_no',array('data-label'=>'Card No', 'class' => 'tooltipster' )); ?>
                    </li>
                    <li class="col-sm-3">
                        <?php echo $form->textField($model,'cvv_no',array('data-label'=>'CVV', 'class' => 'tooltipster' )); ?>
                    </li>
                </div>
            </div>
        </ul>
      
            <table class="table table-bordered" id="voucher_entries" >        
                    <thead>
                        <tr>
                            <th style="width:1%">No</th>            
                            <th style="width:15%">Ledger</th>
                            <th style="width:15%">Subledger</th>     
                            <th style="width:10%">Dr</th>           
                            <th style="width:10%">Cr</th>   
                            <th style="width:30%">Narration</th>       
                            <th style="width:1%"class="text-center"><a class="btn btn-xs btn-theme " href="javascript:void(0);" onclick="newVoucher($('#voucher_entries'));"><i class="fa fa-plus"></i></a></th>                          
                        </tr>
                    </thead>
                    <tbody id="template_div">
                        <?php  foreach( $items as $i => $each ): ?>
                                <tr>
                                    <td><label><?php echo $i+1; ?></label></td>
                                    <td>
                                        <?php echo $form->hiddenField($each, "[".$i."]id"); ?>
                                        <?php echo $form->dropdownlist($each, "[".$i."]ledger_id", FinanceLegder::getChilds(), array('class'=>'form-control', 'onChange' => 'js:updatetextfield(this.id,this.value)', 'prompt' => '-select-')); ?>
                                    </td>
                                    <td id="debit_<?php echo $i ?>">
                                        <?php echo $form->hiddenField($each, "[".$i."]subledger_id"); ?>
                                        <?php $each->subledger_name = ( $each->subledger_id > 0 ) ? $each->subledger->description : ''; ?>
                                        <?php echo $form->textField($each, "[".$i."]subledger_name",array('data-label'=>'Subledger', 'class' => 'form-control', 'onKeyup' => 'js:getSublegders(this.id);', 'readonly' => ( !$each->is_readonly ) ? true : false )); ?>
                                    </td>              
                                    <?php 
                                        if ( $each->amount  > 0 ){
                                            $each->debit = $each->amount;
                                            $debitTotal += $each->debit;
                                        } 

                                        if ( $each->amount  < 0 ){
                                            $each->credit = abs($each->amount);
                                            $creditTotal += $each->credit;
                                        } 
                                    ?>
                                    
                                    <td>
                                        <?php echo $form->textField($each, "[".$i."]debit",array('data-label'=>'Debit', 'class' => 'form-control text-right' , 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateTotal();', 'onkeydown' => 'nextline(event)')); ?>
                                    </td>
                                    <td>
                                        <?php echo $form->textField($each, "[".$i."]credit",array('data-label'=>'Credit', 'class' => 'form-control text-right' , 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateTotal();', 'onkeydown' => 'nextline(event)')); ?>
                                    </td>
                                    <td>
                                        <?php echo $form->textField($each, "[".$i."]narration",array('data-label'=>'Narration', 'class' => 'form-control' )); ?>
                                    </td>
                                    <td class="text-center nw" width="1%"><?php echo CHtml::link('<i class="fa fa-times"></i>', 'javascript:void(0);', array('class'=>'btn btn-xs btn-danger','onclick' => 'removeTableRow($(\'#voucher_entries\'),this)', 'title' => 'Remove this item')); ?></td>
                                </tr>
                            <?php endforeach; ?>    
                        </tbody>
                </table>
                <table class="table table-hover table-bordered personal-task"  > 
                    <tr>
                        <th colspan="4" class="text-right" style="width: 38.25%;"><b>Total</b></th>
                        <th style="width: 11.65%;text-align:right !important;"><?php echo CHtml::textfield('debit_total', $debitTotal,array('class' => 'form-control text-bold', 'readonly' => true )); ?></th>
                        <th style="width: 11.85%;text-align:right !important;"><?php echo CHtml::textfield('credit_total', $creditTotal,array('class' => 'form-control text-bold' , 'readonly' => true)); ?></th>
                        <th></th>
                    </tr>
                </table>
                <ul class="clearfix form-ul material">
                    <li class="col-sm-12">
                        <?php echo CHtml::textArea('general_narration','',array('data-label'=>'Narration', 'class' => 'tooltipster' )); ?>
                    </li>
                </ul>
            </div>
        </div>
        <div class="modal-footer">
    <button type="button" class="btn btn-danger" id="cust_close" data-dismiss="modal">Close</button>
    <?php
        
        echo CHtml::ajaxSubmitButton('Save', Yii::app()->createUrl('finance/vouchers/savevoucher'), array(
            'dataType' => 'json',
            'type' => 'post',
            'success' => 'function(data) {
                            $("#loader").hide();
                            if(data.status=="success"){  
                                t8.success("Done!");
                                $(".x.close").click();
                                reloadTable("#tbl_shift_details");
                            }else{ 
                                $.each(data, function(key, val) {
                                    t8.error(""+val+""); 
                                }); 
                            } 
                        }',
                        'beforeSend' => 'function(){
                            
                            var creditTotal = 0;
                            var debitTotal = 0;
                            $("#voucher_entries").find("tr:gt(0)").each(function() {
                                if( parseFloat($(this).find("[id $=_debit]").val()) > 0 )
                                    debitTotal += parseFloat($(this).find("[id $=_debit]").val());
                                if( parseFloat($(this).find("[id $=_credit]").val()) > 0 )
                                    creditTotal += parseFloat($(this).find("[id $=_credit]").val());
                            });
                            if( ( debitTotal == creditTotal && debitTotal > 0 && creditTotal > 0 ) || ( $("#FinanceVoucherHead_voucher_type").val() == 5  && ( debitTotal > 0 || creditTotal > 0 ) ) )
                                $("#loader").show();
                            else{
                                t8.error("Totals are not matching!");
                                return false;
                            }
                        }',
            ), array('id' => 'mybtn' . rand(), 'class' => 'btn btn-theme'));
           
    ?>
    </div>
<?php $this->endWidget(); ?>