<!DOCTYPE html>
<html>
<head>
<style>
.table thead {display: table-header-group;}
</style>
    <title><?php echo date('dmYhis'); ?></title>
</head>
<body>
    <div class="">
        <div class="col-6">
                <div class="input-block">
                    <b><?php echo 'GL Report'; ?></b>
                </div>
                <br>
                <table class="table" style="width:100%">
                <tr>
                    <td class="bc-tl">From </td>
                    <td>
                        <?php echo $from_date;?>
                    </td>
                </tr>
                <tr>
                    <td>To</td>
                    <td>
                        <?php echo $to_date;?>
                    </td>
                </tr>
                <tr>
                    <td>Ledger</td>
                    <td>
                        <?php echo FinanceLegder::model()->findBypk( (int) $ledger )->description;?>
                    </td>
                </tr>
                <tr>
                    <td>Subledger</td>
                    <td>
                        <?php echo FinanceSubledger::model()->findBypk( (int) $subledger )->description;?>
                    </td>
                </tr>
            </table>
        </div>
        <div class="col-5 offset-1" style="color:#101010;">
            <div class="text-right">
                <img src="<?php echo 'images/logo/'.Yii::app()->user->pdf_company_logo; ?>" class="logo">
            </div>
        </div>
    </div>
    <br>
    <div class="col-md-12">
        <table id="tbl_reorder_level_table" class="table table-fixed table-bordered table-primary dataTable">
            <thead>
				  <tr>
                    <th>Date</th>
                    <th>VO #</th>
                    <?php if( (int) $ledger == 0 ) : ?>
                        <th>Ledger</th>
                    <?php endif; ?>
                    <?php if( (int) $subledger == 0 ) : ?>
                        <th>Subledger</th>
                    <?php endif; ?>
                    <th class="text-right">Dr</th> 
                    <th class="text-right">Cr</th> 
                    <th class="text-right">Balance</th>  
                    <th>Narration</th> 
                </tr>
                
            </thead>
            <?php 
                                $from_date = ( count(explode('/',$from_date)) == 3 ) ? date("Y-m-d", strtotime(str_replace('/', '-', $from_date)))  : date('Y-m-d');
                                $to_date = ( count(explode('/',$to_date)) == 3 ) ? date("Y-m-d", strtotime(str_replace('/', '-', $to_date)))  : date('Y-m-d');
                
                                $condition = 'parent.is_posted = "Y" AND parent.voucher_date BETWEEN "'.$from_date.'" AND "'.$to_date.'"';
                                $condition_for_opening = 'H.is_posted = "Y" AND H.voucher_date < "'.$from_date.'"';
                
                                if( $ledger > 0 ){
                                    $condition .= ' AND t.ledger_id='.$ledger;
                                    $condition_for_opening .= ' AND I.ledger_id='.$ledger;
                                }
                                if( $subledger > 0 ){
                                    $condition .= ' AND t.subledger_id='.$subledger;
                                    $condition_for_opening .= ' AND I.subledger_id='.$subledger;
                                }
                
                                $openingBalance = Yii::app()->db->createCommand('SELECT SUM(I.amount*H.exchange_rate) AS amount FROM crm_finance_voucher_items I LEFT JOIN crm_finance_voucher_head H ON I.header_id = H.id WHERE '.$condition_for_opening.' ')->queryScalar();
                                $items = FinanceVoucherItems::model()->with('parent')->findAll( array( 'condition' => $condition, 'order' => 'parent.voucher_date ASC' ) );
                
                                $previousBalance = $openingBalance;
                                $closingBalance = $openingBalance;
                                $symbol = ( $previousBalance > 0 ) ? 'Dr' : 'Cr';


                                //colspan adjustment
                                $colspanAdjust = 4;
                                if( (int) $ledger > 0 ) 
                                    $colspanAdjust -= 1;
                                if( (int) $subledger > 0 ) 
                                    $colspanAdjust -= 1;
            ?>
                <tbody>       
                        <tr>
                            <td colspan="<?php echo $colspanAdjust ?>" class="text-right"><b>Opening Balance</b></td>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency( ( ( $previousBalance > 0  ) ? abs($previousBalance) : '' )," ");?></td>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency( ( ( $previousBalance < 0  ) ? abs($previousBalance) : '' )," ");?></td>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency(abs($previousBalance)," ").' '.$symbol;?></td>
                            <td></td>
                        </tr>
            <?php 
            $total_debit = 0;
            $total_credit = 0;
            foreach ( $items as $each ){
                        
                        $debit = ($each->amount > 0) ? $each->amount*$each->parent->exchange_rate : '';
                        $credit = ($each->amount < 0) ? abs($each->amount*$each->parent->exchange_rate) : '';
                        $running = $debit - $credit + $previousBalance;
                        $previousBalance = $running;
                        $symbol = ( $running > 0 ) ? 'Dr' : 'Cr';
                        $closingBalance +=  ( $debit - $credit );

                        $total_debit += $debit;
                        $total_credit += $credit;

                        $subledgerName = ( $each->subledger_id > 0 ) ? $each->subledger->description : '';
                        ?>
                        <tr>      
                            <td><?php echo date("d/m/Y",strtotime($each->parent->voucher_date)); ?></td>
                            <td><?php echo $each->parent->fullvoucher; ?></td>
                            <?php if( (int) $ledger == 0 ) : ?>
                                <td><?php echo $each->ledger->description; ?></td>
                            <?php endif; ?>
                            <?php if( (int) $subledger == 0 ) : ?>
                                <td><?php echo $subledgerName; ?></td>
                            <?php endif; ?>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($debit," "); ?></td>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($credit," "); ?></td>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency(abs($running)," ")." ".$symbol; ?></td>
                            <td><?php echo $each->narration; ?></td>
                        </tr>
                        <?php } 
                            
                            $symbol = ( $closingBalance > 0 ) ? 'Dr' : 'Cr';
                        ?>
                           <tr>
                            <td colspan="<?php echo $colspanAdjust ?>" class="text-right"><b>Total</b></td>
                            <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency(abs($total_debit)," "); ?></b></td>
                            <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency(abs($total_credit)," "); ?></b></td>
                            <td class="text-right"></td>
                            <td></td>
                        </tr>
                        <?php 
                            //colspan adjustment
                            $colspanAdjust = 6;
                            if( (int) $ledger > 0 ) 
                                $colspanAdjust -= 1;
                            if( (int) $subledger > 0 ) 
                                $colspanAdjust -= 1;
                        ?>
                        <tr>
                            <td colspan="<?php echo $colspanAdjust ?>" class="text-right"><b>Closing Balance</b></td>
                            <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency(abs($closingBalance)," ").' '.$symbol;?></b></td>
                            <td></td>
                        </tr>
                </tbody>
            </table>
            </div>
    
    <htmlpagefooter name="myfooter">
    <div style="text-align:center;width:100%;font-size:10px"><?= Yii::app()->user->footer_autogenerated; ?>
        <?php
                  date_default_timezone_set("Asia/Dubai");
                 echo date('d/m/Y')." ".date("h:i:sa"); ?>
    </div>

    
        <div style="border-top: 1px dotted #000000; font-size: 12px; text-align: center; padding-top: 10px; background-color: #d7faeb;">
             <div style="text-align:center;width:100%">
                <b><?= Yii::app()->user->footer_line_1 ?></b><br>
                <?= Yii::app()->user->footer_line_2 ?>
            </div>
            <div style="text-align:center;width:100%">Page {PAGENO} of {nb} </div>
        </div>
    </htmlpagefooter>
</body>

</html>

