<div class="row">
    <div class="col-sm-12">
        <section class="panel">
            <header class="text-center panel-heading clearfix">
                <h4><b> SALES SUMMARY REPORT </b></h4>
            </header>
            <header class="panel-heading clearfix">
                <ul class="clearfix form-ul material">
                    <li class="col-sm-2">
                        <?php echo CHtml::dropdownlist('year', '', array("2019" => "2019", "2020" => "2020", "2021" => "2021", "2022" => "2022", "2023" => "2023", "2024" => "2024", "2025" => "2025"), array('class' => 'tooltipster', 'data-label' => 'Year')); ?>
                    </li>

                    <li class="col-sm-2">
                        <?php echo CHtml::dropdownlist('month', '', array(
                            "1" => "January", "2" => "February", "3" => "March", "4" => "April", "5" => "May", "6" => "June",
                            "7" => "July", "8" => "August", "9" => "September", "10" => "October", "11" => "Novemeber", "12" => "December"
                        ), array('class' => 'tooltipster', 'data-label' => 'Month', 'prompt' => 'All', 'data-search' => true)); ?>
                    </li>
                    <li class="col-sm-2">
                        <?php echo CHtml::dropdownlist('day', '', array(
                            "1" => "1", "2" => "2", "3" => "3", "4" => "4", "5" => "5", "6" => "6",
                            "7" => "7", "8" => "8", "9" => "9", "10" => "10", "11" => "11", "12" => "12", "13" => "13", "14" => "14", "15" => "15", "16" => "16", "17" => "17", "18" => "18", "19" => "19", "20" => "20", "21" => "21", "22" => "22", "23" => "23", "24" => "24", "25" => "25", "26" => "26", "27" => "27", "28" => "28", "29" => "29", "30" => "30", "31" => "31",
                        ), array('class' => 'tooltipster', 'data-label' => 'Day', 'prompt' => 'All', 'data-search' => true)); ?>
                    </li>
                    <li class="col-sm-2">
                        <? php // echo CHtml::hiddenField('customer_id'); 
                        ?>

                        <?php echo CHtml::dropdownlist('customer_id', '', Customer::getCustomer(), array('class' => 'tooltipster', 'data-label' => 'Customer', 'prompt' => 'All', 'data-search' => true)); ?>
                    </li>
                    <?php if (Yii::app()->user->user_access_type != 'SL') {  ?>
                        <li class="col-sm-2">
                            <?php echo CHtml::dropdownlist('salesman', '', MasOutlets::salesmans(), array('class' => 'tooltipster', 'data-label' => 'Salesman', 'prompt' => 'All', 'data-search' => true)); ?>
                        </li>
                    <?php } else {
                        echo CHtml::hiddenField('salesman', Yii::app()->user->id);
                    } ?>
                    <li class="col-sm-2">
                        <div class="material">
                            <?php echo CHtml::dropDownList('sale_type', 'sale_type', array('M' => 'Month', 'D' => 'Day'), array('class' => 'tooltipster', 'data-label' => 'Type')); ?>
                        </div>
                    </li>
                    <div class="btn-wrap text-center">
                        <a type="button" class="btn btn-sm btn-theme" onclick="loadPage();">Load</a>
                        <a type="button" class="btn btn-sm btn-theme" onclick="window.open($('#liveSite').val()+'index.php?r=costofsale/PrintSalesSummaryPDF&year=' + $('#year').val() + '&day=' + $('#day').val() + '&month=' + $('#month').val() + '&salesman=' + $('#salesman').val() + '&sale_type=' + $('#sale_type').val(), '_blank')"><i class="fa fa-download"></i> PDF</a>
                        <a type="button" class="btn btn-sm btn-theme" onclick="window.open($('#liveSite').val()+'index.php?r=costofsale/PrintSalesSummaryExcel&year=' + $('#year').val() + '&day=' + $('#day').val() + '&month=' + $('#month').val() + '&salesman=' + $('#salesman').val() + '&sale_type=' + $('#sale_type').val(), '_blank')"><i class="fa fa-download"></i> EXCEL</a>

                        <!--<a type="button" class="btn btn-sm btn-theme" onclick="window.open($('#liveSite').val()+'index.php?r=reportexcel/CustomerList&outlet='+$('#cuslist_outlet').val()+'&customer_id='+$('#cuslist_customer_id').val()+'&salesman='+$('#cuslist_salesman').val());">XLS</a>-->
                    </div>
                </ul>
            </header>
            <div class="panel-body" id="data_div" style="display:none;">
                <div class="tab-content">
                    <div class="tab-pane main-li-data active" id="gl_tab">
                    </div>
                </div>
            </div>
        </section>
    </div>
</div>
<?php

$cs = Yii::app()->getClientScript();

$cs->registerScript("customers", "function customers(field_id)
    {
        $('#customer_id').val('');
        var url = '" . Yii::app()->createUrl('reports/get_customers') . "';
        $('#customer_id').val('');
        $('#'+field_id).autocomplete({
            minLength   : 1,
            source      : function (request, response) { autoCompleteSource(request, response, url) },
            focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },
            select      : function( event, ui ) {
                event.preventDefault();
                $('#customer_id').val(ui.item.value);
                $('#customer').val(ui.item.label);
            }
        });
    }", CClientScript::POS_HEAD);
$cs->registerScript("loadPage", "function loadPage(){
        $('#loader').show();
        jQuery.ajax({
            'type': 'post',
            'url': '" . Yii::app()->createUrl('costofsale/Sales_summary_html') . "',
            'data' : { 'year' : $('#year').val(),'day' : $('#day').val(),'month' : $('#month').val(), 'customer_id' : $('#customer_id').val(), 'salesman' : $('#salesman').val(),'sale_type' : $('#sale_type').val(), },
            'success': function(data) {
                $('#data_div').show();
                $('.main-li-data').html(data);
                $('#loader').hide();
            }
        });
    }", CClientScript::POS_HEAD);
?>