<?php
$form = $this->beginWidget('CActiveForm', array(
    'id' => 'customer-form',
    'enableAjaxValidation' => false,
    'enableClientValidation' => false,
    ));
?>

    <div class="tab-pane active">
        <ul class="clearfix form-ul material">
            <li class="col-sm-6">
                <?php echo $form->textField($model, 'customer_name', array('data-label' => 'Name <span style="color:red;">*</span>')); ?>
                <?php echo $form->hiddenField($model, 'id'); ?>
                
                <?php echo $form->hiddenField($model, 'customer_no'); ?>
            </li>
            <?php if(Yii::app()->user->user_access_type == 'SL' || (int)$model->id==0){ ?>
            <li class="col-sm-6">
                <?php echo $form->textField($model, 'contact_person', array('data-label' => 'Contact Person')); ?>
                <?php echo $form->hiddenField($model, 'accessed_by'); ?>
            </li>
            <?php }else{ ?>
            <li class="col-sm-3">
                <?php echo $form->textField($model, 'contact_person', array('data-label' => 'Contact Person')); ?>
            </li>
            <li class="col-sm-3">
                <?php 
                $outlet_id=(int)Yii::app()->user->outlet_id;
                $arr_sales_man=MasUsers::get_outlet_salesandadmin($outlet_id);
                if($model->id>0){
                    $model->accessed_by = explode(',',$model->accessed_by);
                }
                echo $form->dropdownList($model, 'accessed_by',$arr_sales_man, array('data-label' => 'Access To','multiple'=>true)); ?>
            </li>
            <?php } ?>
                
             <li class="col-sm-4">
                <?php echo $form->textField($model, 'phone', array('data-label' => 'Phone No <span style="color:red;">*</span>')); ?>
            </li>
            <li class="col-sm-4">
                <?php echo $form->textField($model, 'mobile', array('data-label' => 'Mobile No')); ?>
            </li>
            <li class="col-sm-4">
                <?php echo $form->textField($model, 'email', array('data-label' => 'Email')); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->textField($model, 'trn_no', array('data-label' => 'TRN No  <span style="color:red;">*</span>')); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->dropdownList($model, 'payment_term',MasPaymentTerms::getActivePaymentTerms(), array('data-label' => 'Payment Term <span style="color:red;">*</span>')); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->textField($model, 'credit_days', array('data-label' => 'Credit Days')); ?>
            </li>
            <li class="col-sm-3">
                <?php 
                ((int)$model->id==0)?$model->credit_limit=99999999:'';
                echo $form->textField($model, 'credit_limit', array('data-label' => 'Credit Limit <span style="color:red;">*</span>')); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->textField($model, 'location', array('data-label' => 'Location')); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->dropdownList($model, 'state', MasState::getActiveStates(),array('data-label' => 'State <span style="color:red;">*</span>')); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->dropdownList($model, 'country',MasCountry::getActiveCountry(),array('data-label' => 'Country <span style="color:red;">*</span>')); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->dropdownList($model, 'invoice_barcode_show',array('N'=>'NO','Y'=>'YES'),array('data-label' => 'Barcode Visibility')); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->textField($model, 'latitude', array('data-label' => 'Latitude')); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->textField($model, 'longitude', array('data-label' => 'Longitude')); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->dropdownList($model, 'tax_type',array('E'=>'Exclude Tax','I'=>'Include Tax'),array('data-label' => 'Tax Type')); ?>
            </li>
            
            <li class="col-sm-3">
                <?php echo $form->dropdownList($model, 'sales_price_type',array('1'=>'Sales Price','2'=>'Sales Price A','3'=>'Sales Price B'), array('data-label' => 'Sales Price Type')); ?>
            </li>
            
            <li class="col-sm-12">
                <?php echo $form->textArea($model, 'address', array('data-label' => 'Address')); ?>
            </li>
            
           
            
        </ul>
    </div>
</div>

<div class="modal-footer">
    <button type="button" class="btn btn-default" id="cust_close" data-dismiss="modal">Close</button>
    <?php 
                $url = Yii::app()->createUrl('customer/Save');
                echo CHtml::ajaxSubmitButton('Save', $url, array(
                            'dataType' => 'json',
                            'type' => 'post',
                            'success' => 'function(data) {
                                if(data.status=="success"){  
                                    $("#cust_close").click();                                        
                                    t8.success("Customer Details Saved Successfully!");
                                    reloadTable("#tbl_customers");
                                } else { 
                                    $("#customer-form .customer-save-btn").prop("disabled", false);
                                    $("#customer-form .customer-save-btn").addClass("btn-theme").removeClass("btn_loading");
                                    $.each(data, function(key, val) {
                                        $("#customer-form #"+key+"_em_").text(val).show(); 
                                        t8.error(""+val+""); 
                                    }); 
                                } 
                            }',
                            'beforeSend' => 'function(){
                                $(".toast8-error").hide(); 
                                $("#loader").show();
                                $("#customer-form .customer-save-btn").prop("disabled", true);                                
                                $("#customer-form .customer-save-btn").addClass("btn_loading").removeClass("btn-theme");
                                
                            }',
                            'complete' => 'function(){
                                $("#loader").hide();
                                $("#customer-form .customer-save-btn").prop("disabled", false);                                
                                $("#customer-form .customer-save-btn").addClass("btn-theme").removeClass("btn_loading");
                            }'
                                
                    ), array('id' => 'mybtn' . rand(), 'class' => 'customer-save-btn btn btn-theme'));
           
    ?>
</div>
<?php $this->endWidget(); ?>
