<div class="tab-content">
    <div class="tab-pane active" id="customers_sec">
        <section class="panel">
            <header class="panel-heading clearfix panel-theame">
                <i class="fa fa-users"></i> Customers
                <?php if(Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM'){ ?>
                <button class="btn btn-sm btn-theme" onclick="loadPopupModal('customer/create', 'New Customer', 'lg')"><i class="fa fa-plus"></i> ADD</button>
                <?php } ?>
                <div class="pull-right"  style="display:inline-flex">
                    <?php 
                    if(Yii::app()->user->user_access_type == 'DEV' || Yii::app()->user->user_access_type == 'SU')
                    {
                    $array=array('class'=>'form-control','data-label'=>'Outlet','prompt' => 'All Outlets',  'onchange' => 'reloadTable("#tbl_customers");');
                    }
                    else if(Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SL' || Yii::app()->user->user_access_type == 'SM' || Yii::app()->user->user_access_type == 'OM')
                    {
                    $array=array('class'=>'form-control','data-label'=>'Outlet',  'onchange' => 'reloadTable("#tbl_customers");');
                    }
                    echo CHtml::dropdownlist('cus_outlet',Yii::app()->user->outlet_id, MasOutlets::getAllOutlets(), $array); 
                    ?>                   
                    <?php echo CHtml::dropdownlist('cus_state', '', MasState::getActiveStates(), array('empty' => 'State', 'onchange' => 'reloadTable("#tbl_customers");')); ?>
                </div>
            </header>   
            <div class="panel-body">
                <div class="custom-data-table">
                    <table class="table table-hover table-bordered personal-task" id="tbl_customers">
                        <thead>
                            <tr>
                                <th>#</th>
                                <th>Name</th>
                                <th>Location</th>
                                <th>State</th>
                                <th>Phone</th>
                                <th>Mobile</th>
                                <th>TRN #</th>
                                <th>Outlet</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </section>
    </div>
</div>
<script>
    $(document).ready(function () {
        var table_details_id = "#tbl_customers";
        table_details = $(table_details_id).on("preXhr.dt", function (e, settings, data) {
        data.outlet = $("#cus_outlet").val();
        data.state = $("#cus_state").val();
        return data;
    }).DataTable({
            scrollY: "550px",
            "bAutoWidth": true,
            pageLength: 50,
            ajax: {
                url: "index.php?r=customer/getlist",
                type: "POST",
                cache: false,
            },
            serverSide: true,
            fixedColumns: true,
            processing: true,
            order: [[1, "asc"]],
            aoColumnDefs: [
              { "bSortable": false, "aTargets": [ 8,9] },
              {
                 "targets": [9],
                 "visible": false,
              },
            ],
            "fnRowCallback": function (nRow, aData, iDisplayIndex, iDisplayIndexFull) {

                if (aData[9] == "N") {
                    $("td", nRow).addClass("bg-danger");
                }
            }
        });
        $(".dataTables_scrollFoot").hide();

    });
    function block(id, status){
        var r = confirm((status == "1") ? 'Are you sure to Block this Customer?' : 'Are you sure to Unblock this Customer?');
        if (r == true)
        {
            jQuery.ajax({
                'type'  : 'post',
                'datatype' :'json',
                'data'  : 'id=' + id + "&status=" + status,
                'url'  : $('#liveSite').val() + 'index.php?r=Customer/EnableDisable',
                'cache': false,
                'success':function(data){
                    if (data.status == 'fail'){
                        t8.error('Please Try Later');
                    } else {
                        t8.info('Customer Status Updated');
                        reloadTable("#tbl_customers");
                    }
                }
            });
        }
    }
</script>