<?php

function calculateAvailableStock($product_id, $user_id, $transfer_date, $exclude_header_id, $outlet_id)
{
    if ((int)$exclude_header_id > 0) {
        $common_condt = " AND product_id = '{$product_id}'  AND outlet = {$outlet_id}  AND created_by = {$user_id}  AND header_id != {$exclude_header_id}";
    } else {
        $common_condt = " AND product_id = '{$product_id}'  AND outlet = {$outlet_id}  AND created_by = {$user_id} ";
    }

    $in_qty = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}} WHERE transaction_type = 'IN' $common_condt ")->queryScalar();

    $out_qty = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}}  WHERE transaction_type = 'OUT' $common_condt ")->queryScalar();

    $date_condt = $common_condt . " AND transaction_date <= '{$transfer_date}'";

    $in_qty_on_date = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}}  WHERE transaction_type = 'IN' $date_condt")->queryScalar();

    $out_qty_on_date = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}}  WHERE transaction_type = 'OUT' $date_condt ")->queryScalar();

    $current_stock = round($in_qty - $out_qty, 3);
    $stock_on_date = round($in_qty_on_date - $out_qty_on_date, 3);

    return max($current_stock, $stock_on_date);
}


$form = $this->beginWidget('CActiveForm', array(
    'id' => 'goodstransfer-form',
    'enableAjaxValidation' => false,
    'enableClientValidation' => false,
));
?>
<div class="tab-content">
    <ul class="clearfix form-ul material">
        <li class="col-sm-4">
            <?php


            if ($model->id > 0) {
                if ($model->transfer_date != '0000-00-00') {
                    $model->transfer_date = date('d/m/Y', strtotime($model->transfer_date));
                }
            } else {
                $model->transfer_date = date('d/m/Y');
            }
            echo $form->textField($model, 'transfer_date', array('data-label' => 'Transfer Date <span style="color:red;">*</span>', 'class' => 'datepicker')); ?>
            <?php echo $form->hiddenField($model, 'id'); ?>
            <?php echo $form->hiddenField($model, 'transfer_no'); ?>
            <!--transfer from purchase invoice start-->
            <input type="hidden" name="Purchase_invoice_id" value="<?php echo $purchase_invoice_id; ?>">
            <!--transfer from purchase invoice end-->
        </li>
        <li class="col-sm-4">
            <?php
            $outlet_id = (int)Yii::app()->user->outlet_id;
            $model->from_user_id = $model->isNewRecord ? (int) Yii::app()->user->id :  (int) $model->from_user_id;
            if (Yii::app()->user->user_access_type == 'SL') {
                $arr_sales_man = MasUsers::get_outlet_salesandadmin($outlet_id, (int) $model->from_user_id);
            } else {
                $arr_sales_man = MasUsers::get_outlet_salesandadmin($outlet_id);
            }
            ?>
            <?php echo $form->dropdownlist($model, 'from_user_id', $arr_sales_man, array('empty' => '-select-', 'data-label' => 'From User  <span style="color:red;">*</span>', 'onChange' => 'updateDropdown(this.value);clearitemTableInputs(this.value,"fromuser");')); ?>
        </li>
        <li class="col-sm-4">
            <div id="to_user_div">
                <?php echo $form->dropdownlist($model, 'to_user_id', MasOutlets::salesmans_without_user($model->from_user_id), array('empty' => '-select-', 'onChange' => 'clearitemTableInputs(this.value,"touser");', 'data-label' => 'To User <span style="color:red;">*</span>'));  ?>
            </div>
        </li>
        <li class="col-sm-12">
            <?php echo $form->textArea($model, 'notes', array('data-label' => 'Notes')); ?>
        </li>
    </ul>
    <div id="div_goodstransfer_details">
        <div class="table-responsive">
            <table class="table table-hover table-bordered personal-task" id="goodstransfer_items_table">

                <thead>

                    <tr>

                        <th style="width:1%">No</th>

                        <th style="width:15%">Item</th>

                        <th style="width:12%">Description</th>

                        <th style="width:12%">From User Available Qty</th>

                        <th style="width:12%">To User Available Qty</th>

                        <th style="width:12%">Quantity</th>

                        <th style="width:12%">UOM</th>

                        <th style="width:2%"><a class="btn btn-xs btn-theme " href="javascript:void(0);" onclick="addTableRow($('#goodstransfer_items_table'));"><i class="fa fa-plus"></i></a></th>
                        </th>
                    </tr>

                </thead>

                <?php
                foreach ($modelItems as $i => $modelItems) {

                    if ((int) $modelItems->id > 0) {
                        // ------------------------------- From Available Quantity ------------------------------------------
                        $modelItems->from_available_qty = calculateAvailableStock(
                            $modelItems->product_id,
                            $model->from_user_id,
                            $model->transfer_date,
                            (int)$model->id,
                            Yii::app()->user->outlet_id
                        );

                        // ------------------------------- To Available Quantity ------------------------------------------
                        $modelItems->to_available_qty = calculateAvailableStock(
                            $modelItems->product_id,
                            $model->to_user_id,
                            $model->transfer_date,
                            (int)$model->id,
                            Yii::app()->user->outlet_id
                        );
                    }

                    if ($frm == 'order') {

                        // ------------------------------- From Available Quantity ------------------------------------------

                        $modelItems->from_available_qty = calculateAvailableStock(
                            $modelItems->product_id,
                            $model->from_user_id,
                            $model->transfer_date,
                            0,
                            Yii::app()->user->outlet_id
                        );

                        // ------------------------------- To Available Quantity ------------------------------------------
                        $modelItems->to_available_qty = calculateAvailableStock(
                            $modelItems->product_id,
                            $model->to_user_id,
                            $model->transfer_date,
                            0,
                            Yii::app()->user->outlet_id
                        );
                    }

                ?>
                    <tr>
                        <td><label><?php echo $i + 1; ?></label></td>
                        <td>

                            <?php
                            $modelItems->part_no = $modelItems->gt_product_details->part_number;
                            echo $form->textField($modelItems, "[" . $i . "]part_no", array(
                                'class' => 'tooltipster go',
                                'oninput' => 'js:trackPasteEvent(this);',
                                'onkeydown' => 'js:handleEnterWithPaste(event, this);',
                                'onKeypress' => 'js:autoCompleteProduct(this.id);'
                            )); ?>


                            <?php
                            // $modelItems->part_no = $modelItems->gt_product_details->part_number;
                            //  echo $form->textField($modelItems, "[" . $i . "]part_no", array('class' => 'tooltipster go', 'onKeypress' => 'js:autoCompleteProduct(this.id);')); 
                            ?>
                            <?php echo $form->hiddenField($modelItems, "[" . $i . "]product_id"); ?>
                            <?php echo $form->hiddenField($modelItems, "[" . $i . "]id"); ?>
                            <?php echo $form->hiddenField($modelItems, "[" . $i . "]order_ids"); ?>
                        </td>
                        <td>
                            <?php echo $form->textArea($modelItems, "[" . $i . "]description", array('class' => 'tooltipster desc go en-text-area'));  ?>
                        </td>
                        <td>
                            <?php echo $form->textField($modelItems, "[" . $i . "]from_available_qty", array('class' => 'qty go cell-center text-right', 'onkeypress' => 'return isNumberKey(event)', 'readonly' => true)); ?>

                        </td>
                        <td>
                            <?php echo $form->textField($modelItems, "[" . $i . "]to_available_qty", array('class' => 'qty go cell-center text-right', 'onkeypress' => 'return isNumberKey(event)', 'readonly' => true)); ?>

                        </td>
                        <td>
                            <?php echo $form->textField($modelItems, "[" . $i . "]quantity", array('onkeyup' => 'calculatequantity($("#goodstransfer_items_table"),this.id)','onkeydown' => 'moveToNextCell(event, this)', 'class' => 'qty go cell-center text-right', 'onkeypress' => 'return isNumberKey(event)')); ?>
                        </td>
                        <td>
                            <div id=<?php echo "unitdiv_" . $i; ?>><?php echo $form->dropdownList($modelItems, "[" . $i . "]unit", MasUnit::getSimilarUnits($modelItems->unit), array('class' => 'go cell-center text-center')); ?></div>
                        </td>
                        <td class="text-center nw" width="1%">
                            <?php echo CHtml::link('<i class="fa fa-times"></i>', 'javascript:void(0);', array('class' => 'btn btn-xs btn-danger', 'onclick' => 'removeTableRow($(\'#goodstransfer_items_table\'),this)', 'title' => 'Remove this item', 'id' => 'material_' . $i)); ?>
                        </td>
                    </tr>
                <?php } ?>
            </table>
        </div>
    </div>
</div>


<div class="modal-footer">
    <button type="button" class="btn btn-default" id="gt_close" data-dismiss="modal">Close</button>
    <?php
    $url = Yii::app()->createUrl('goodstransfer/Save');
    echo CHtml::ajaxSubmitButton('Save', $url, array(
        'dataType' => 'json',
        'type' => 'post',
        'success' => 'function(data) {
                                if(data.status=="success"){  
                                    $("#gt_close").click();                                        
                                    t8.success("Goods Transfer Details Saved Successfully!");
                                    reloadTable("#tbl_goods_transfer");

                                } else { 
                                    $("#goodstransfer-form .goodstransfer-save-btn").prop("disabled", false);
                                    $("#goodstransfer-form .goodstransfer-save-btn").addClass("btn-theme").removeClass("btn_loading");
                                    $.each(data, function(key, val) {
                                        $("#goodstransfer-form #"+key+"_em_").text(val).show(); 
                                        t8.error(""+val+""); 
                                    }); 
                                } 
                            }',
        'beforeSend' => 'function(){
                                $(".toast8-error").hide(); 
                                $("#loader").show();
                                $("#goodstransfer-form .goodstransfer-save-btn").prop("disabled", true);                                
                                $("#goodstransfer-form .goodstransfer-save-btn").addClass("btn_loading").removeClass("btn-theme");
                                
                            }',
        'complete' => 'function(){
                                $("#loader").hide();
                                $("#goodstransfer-form .goodstransfer-save-btn").prop("disabled", false);                                
                                $("#goodstransfer-form .goodstransfer-save-btn").addClass("btn-theme").removeClass("btn_loading");
                            }'

    ), array('id' => 'mybtn' . rand(), 'class' => 'goodstransfer-save-btn btn btn-theme'));

    ?>
</div>
<?php $this->endWidget(); ?>


<script>
    let isPasted = false; // Flag to track if a paste event occurred

    function trackPasteEvent(inputElement) {
        // Triggered on any input change, sets the flag to true for paste detection
        isPasted = true;
    }

    function handleEnterWithPaste(event, inputElement) {
        if (event.key === 'Enter') {
            event.preventDefault(); // Prevent default form submission
            if (isPasted) {
                // If paste event occurred and Enter is pressed, call AJAX function
                autoLoadAjaxFunction(inputElement);
                isPasted = false; // Reset the flag after processing
            } else {
                // If no paste occurred, fall back to auto-complete logic
                autoCompleteProduct(inputElement.id);

            }
        }
    }

    function autoLoadAjaxFunction(inputElement) {


        var transfer_date = $('#GoodsTransfer_transfer_date').val();
        var from_user_id = $('#GoodsTransfer_from_user_id').val();
        var to_user_id = $('#GoodsTransfer_to_user_id').val();

        // Parse input element's ID to extract row field
        var arr_fields = inputElement.id.split('_');
        var model_name = arr_fields[0];
        var row_field = arr_fields[1];
        $.ajax({
            url: "<?php echo Yii::app()->createUrl('inventory/GetProductByBarcode'); ?>", // Generate and escape URL
            dataType: 'json',
            type: 'post',
            data: {
                barcode: inputElement.value,
                transfer_date: transfer_date,
                from_user_id: from_user_id,
                to_user_id: to_user_id,
                frm: 'GR'
            },
            success: function(response) {
                //  console.log('AJAX response:', response);

                if (response && response.value) {

                    var product_id = response.value;
                    var desc = response.description;
                    var part_number = response.part_number;
                    var rate = response.cost;
                    var unit = response.uom;
                    var unit_exchange = response.unit_exchange;
                    var from_available_qty = response.from_available_qty;
                    var to_available_qty = response.to_available_qty;
                    if (unit_exchange > 0)
                        var unitprice = rate / unit_exchange;
                    else
                        var unitprice = 0;


                    // Populate the fields with the response data
                    $('#GoodsTransferItems_' + row_field + '_description').val(desc);
                    $('#GoodsTransferItems_' + row_field + '_product_id').val(product_id);
                    $('#GoodsTransferItems_' + row_field + '_part_no').val(part_number);
                    $('#GoodsTransferItems_' + row_field + '_quantity').val(1);
                    $('#GoodsTransferItems_' + row_field + '_from_available_qty').val(from_available_qty);
                    $('#GoodsTransferItems_' + row_field + '_to_available_qty').val(to_available_qty);
                    addTableRow($('#goodstransfer_items_table'));
                    var next_line_id = parseInt(row_field) + 1;
                    $('#GoodsTransferItems_' + row_field + '_quantity').select();                 

                    // Fetch similar units
                    $.ajax({
                        data: {
                            unit: unit,
                            row_field: row_field
                        },
                        dataType: 'json',
                        type: 'post',
                        url: "<?php echo Yii::app()->createUrl('goodstransfer/getSimilarUnits'); ?>",
                        success: function(data) {
                            $('#unitdiv_' + row_field).html(data.unit);
                        }
                    });
                } else {
                    t8.error('Cannot find product!');
                }
            },
            error: function(xhr, status, error) {
                console.log('AJAX error:', error);
            }
        });

    }
    
     function moveToNextCell(event, element) {


        if (event.key === "Enter") {

            event.preventDefault(); // Prevent default form submission

            addTableRow($('#goodstransfer_items_table'));

        }

    }
</script>

<?php
$cs = Yii::app()->getClientScript();


$cs->registerScript("calculatequantity", "
function calculatequantity(jQtable, from = '') { 
    var arr_fields = from.split('_');
    var model_name = arr_fields[0];
    var index = arr_fields[1];

    var formIdStarter = jQtable.attr('id').split(/_(.+)?/)[0];
    var qty, from_available_qty;

    jQtable.find('tr:gt(0)').each(function() {
        var row_id = $(this).find('[id $=_id]').attr('id')?.split('_')[1];
        if (!row_id) return; // Safeguard in case row_id is not found
        
        from_available_qty = $(this).find('[id $=_from_available_qty]').val();
        qty = $(this).find('[id $=_quantity]').val();
        
        // Ensure numeric comparison
        var availableQty = Number(from_available_qty || 0);
        var quantity = Number(qty || 0);
        
        // Highlight invalid quantity
        if (quantity > availableQty) {
            $(this).find('[id $=_quantity]').addClass('bg-danger');
        } else {
            $(this).find('[id $=_quantity]').removeClass('bg-danger');
        }
    });
}
", CClientScript::POS_HEAD);


$cs->registerScript("clearitemTableInputs", "function clearitemTableInputs(user,userfrom) { 

    if($('#GoodsTransferItems_0_product_id').val() > 0){
    var r = confirm('Are you sure you want to change From User? If you change From User,  the below table content will be lose');
          if(r==true)
          {
            $('#goodstransfer_items_table').find(':input').each(function() {
                          $(this).val('');
                   });
          }
                if(userfrom=='fromuser'){
                    $('#GoodsTransfer_to_user_id').val('');
                }else{
                 //  $('#GoodsTransfer_from_user_id').val('');
                }    
        }
    else{
            if(userfrom=='fromuser'){
                    $('#GoodsTransfer_from_user_id').val(user);                
            }else{
                    $('#GoodsTransfer_to_user_id').val(user);
            }  

    }

}", CClientScript::POS_HEAD);

$cs->registerScript("autoCompleteProduct", "function autoCompleteProduct(field_id)
{
    var transfer_date =  $('#GoodsTransfer_transfer_date').val();
    
    var from_user_id =  $('#GoodsTransfer_from_user_id').val();
    
    var to_user_id =  $('#GoodsTransfer_to_user_id').val();
 
    //var url = '" . Yii::app()->createUrl('inventory/GetProducts') . "'+'&frm=GR';
    
    var url = '" . Yii::app()->createUrl('inventory/GetProducts') . "' + '&frm=GR&from_user_id=' + from_user_id + '&to_user_id=' + to_user_id + '&transfer_date=' + transfer_date;

    $('#'+field_id).autocomplete({
        minLength   : 1,
        source      : function (request, response) { autoCompleteSource(request, response,url) },
        focus       : function( event, ui ) { $(this).val((ui.item.label)); return false;},
        select          : function( event, ui ) {
            event.preventDefault();
            trigger_target_id   =   $(event.target).attr('id');
            var product_id=ui.item.value;
            var desc=ui.item.description;
            var part_number=ui.item.part_number;
            var unit = ui.item.uom;
            var arr_fields= field_id.split('_');
            var model_name   = arr_fields[0];
            var row_field  = arr_fields[1];
            $('#GoodsTransferItems_'+row_field+'_description').val(desc);
            $('#GoodsTransferItems_'+row_field+'_product_id').val(product_id);
            $('#GoodsTransferItems_'+row_field+'_part_no').val(part_number);
            $('#GoodsTransferItems_'+row_field+'_quantity').val(1);
            $('#GoodsTransferItems_'+row_field+'_from_available_qty').val(ui.item.from_available_qty);
            $('#GoodsTransferItems_'+row_field+'_to_available_qty').val(ui.item.to_available_qty);
            addTableRow($('#goodstransfer_items_table'));
            var next_line_id=parseInt(row_field)+1;
            $('#GoodsTransferItems_'+row_field+'_quantity').select();
            jQuery.ajax({
                'data' :{'unit':unit,'row_field':row_field},
                'dataType' : 'json',
                'type':'post',
                'url': '" . Yii::app()->createUrl('goodstransfer/getSimilarUnits') . "',
                'success': function(data) {
                    $('#unitdiv_'+row_field).html(data.unit);
                }
            });
        }
    });
}
function updateDropdown(selectedUser = 0) {
        jQuery.ajax({
            'data': {
                'selectedUser': selectedUser
            },
            'dataType' : 'json',
            'type': 'post',
            'url': 'index.php?r=goodstransfer/getDropdownToUser',
            'success': function(data) {
                $('#to_user_div').html(data.user);
            }

        });
    }
", CClientScript::POS_HEAD); ?>