<?php
$form = $this->beginWidget('CActiveForm', array(
    'id' => 'inventory-form',
    'enableAjaxValidation' => false,
    'enableClientValidation' => false,
    ));
?>

<div class="tab-content">
    <div class="tab-pane active">
        <ul class="clearfix form-ul material">
            <li class="col-sm-6">
                <?php echo $form->hiddenField($model, 'id'); ?> 
                <?php echo $form->textField($model, 'part_number', array('data-label' => 'Part Number <span style="colour:red;">*</span>')); ?>
            </li>
            <li class="col-sm-6">
                <?php echo $form->textField($model, 'description', array('data-label' => 'Description <span style="colour:red;">*</span>')); ?>
            </li>
             <li class="col-sm-2">
             <?php 
            $stype_readonly =false;
            if($model->id>0){
                $mod_stockledger = StockLedger::model()->findAll(array('condition'=>'product_id='.$model->id.' AND type!="OB"'));
                if(!empty($mod_stockledger)){
                    $stype_readonly=true;
                }
            }
            if($stype_readonly){
                echo $form->dropdownlist($model,'type',array('I'=>'Inventory','S'=>'Service'), array('class' => 'tooltipster', 'data-label' => 'Type<span style="colour:red;">*</span>','disabled'=>true));
                echo $form->hiddenField($model,'type');
            }else{
                echo $form->dropdownlist($model,'type',array('I'=>'Inventory','S'=>'Service'), array('class' => 'tooltipster', 'data-label' => 'Type<span style="colour:red;">*</span>'));
            }?>
            </li>
            <li class="col-sm-2">
            <?php echo $form->dropdownlist($model,'brand',MasBrand::getAllBrands(), array('class' => 'tooltipster', 'data-label' => 'Brand'));?>
            </li>
            <li class="col-sm-2">
            <?php echo $form->dropdownlist($model,'generic_id',MasGeneric::getAllGeneric(), array('class' => 'tooltipster', 'data-label' => 'Generic'));?>
            </li>
            <li class="col-sm-2">
            <?php if($stype_readonly){
                echo $form->dropdownlist($model,'unit',MasUnit::getAllBaseUnits(), array('class' => 'tooltipster', 'data-label' => 'Unit<span style="colour:red;">*</span>','disabled'=>true));
                echo $form->hiddenField($model,'unit');
            }else{
                echo $form->dropdownlist($model,'unit',MasUnit::getAllBaseUnits(), array('class' => 'tooltipster', 'data-label' => 'Unit'));
            }?>
            </li>
            <li class="col-sm-2">
                <?php echo $form->textField($model, 'rate', array('data-label' => 'Sales Price','onkeypress'=>'return isNumberKey(event)')); ?>
            </li>
            <li class="col-sm-2">
                <?php echo $form->textField($model, 'rate_a', array('data-label' => 'Sales Price A','onkeypress'=>'return isNumberKey(event)')); ?>
            </li>
            <li class="col-sm-2">
                <?php echo $form->textField($model, 'rate_b', array('data-label' => 'Sales Price B','onkeypress'=>'return isNumberKey(event)')); ?>
            </li>
            <li class="col-sm-2">
             <?php echo $form->dropdownlist($model,'tax_code',MasTax::getAllTax(), array('class' => 'tooltipster', 'data-label' => 'Tax<span style="colour:red;">*</span>'));?>
            </li>
            <li class="col-sm-2">
                <?php echo $form->textField($model, 'excise_tax', array('data-label' => 'Excise Duty(%)','onkeypress'=>'return isNumberKey(event)')); ?>
            </li><li class="col-sm-4"> 
                <?php echo $form->textField($model, 'barcode', array('data-label' => 'Bar Code')); ?>
            </li>
            <li class="col-sm-4">
               <?php echo $form->dropdownlist($model,'sec_unit_id',MasUnit::getSimilarUnits($model->unit), array('class' => 'tooltipster', 'data-label' => 'Preferred Secondary Unit'));?>
            </li>
        </ul>
    </div>
</div>

<div class="modal-footer">
    <button type="button" class="btn btn-default" id="inv_close" data-dismiss="modal">Close</button>
    <?php 
                $url = Yii::app()->createUrl('inventory/Save');
                echo CHtml::ajaxSubmitButton('Save', $url, array(
                            'dataType' => 'json',
                            'type' => 'post',
                            'success' => 'function(data) {
                                if(data.status=="success"){  
                                    $("#inv_close").click();                                        
                                    t8.success("Inventory Details Saved Successfully!");
                                    reloadTable("#tbl_inventory");
                                } else { 
                                    $("#inventory-form .customer-save-btn").prop("disabled", false);
                                    $("#inventory-form .customer-save-btn").addClass("btn-theme").removeClass("btn_loading");
                                    $.each(data, function(key, val) {
                                        $("#inventory-form #"+key+"_em_").text(val).show(); 
                                        t8.error(""+val+""); 
                                    }); 
                                } 
                            }',
                            'beforeSend' => 'function(){
                                $(".toast8-error").hide(); 
                                $("#loader").show();
                                $("#inventory-form .customer-save-btn").prop("disabled", true);                                
                                $("#inventory-form .customer-save-btn").addClass("btn_loading").removeClass("btn-theme");
                                
                            }',
                            'complete' => 'function(){
                                $("#loader").hide();
                                $("#inventory-form .customer-save-btn").prop("disabled", false);                                
                                $("#inventory-form .customer-save-btn").addClass("btn-theme").removeClass("btn_loading");
                            }'
                                
                    ), array('id' => 'mybtn' . rand(), 'class' => 'customer-save-btn btn btn-theme'));
           
    ?>
</div>
<?php $this->endWidget(); ?>
