<div class="tab-content">
    <div class="tab-pane active" id="inventory">
        <section class="panel">
            <header class="panel-heading clearfix panel-theame">
                <i class="fa fa-users"></i> Inventory
                <?php if( Yii::app()->user->user_access_type == 'CA' ){?>
                <button class="btn btn-sm btn-theme" onclick="loadPopupModal('inventory/create', 'New Inventory', 'lg')"><i class="fa fa-plus"></i> ADD</button>
                <?php } ?>
                <div class="pull-right" style="display:inline-flex">
                &NonBreakingSpace;
                
                <?php 
                if(Yii::app()->user->user_access_type == 'DEV' || Yii::app()->user->user_access_type == 'SU')
                {
                $array=array('class'=>'form-control','data-label'=>'Outlet','prompt' => 'All Outlets',  'onchange' => 'changeOutletUsers(this.id,"created_user","div_created_user");');
                }
                else if(Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SL')
                {
                $array=array('class'=>'form-control','data-label'=>'Outlet');
                }
                echo CHtml::dropdownlist('outlet','', MasOutlets::getAllOutlets(),$array); 
                ?>
                &NonBreakingSpace;
                <div id="div_created_user" style="width:100%">
                <?php 
                if(Yii::app()->user->user_access_type == 'DEV' || Yii::app()->user->user_access_type == 'SU'|| Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SM' || Yii::app()->user->user_access_type == 'OM')
                {
                    $uarray=array('class'=>'form-control','data-label'=>'User','prompt' => 'All Users');
                }
                else if( Yii::app()->user->user_access_type == 'SL')
                {
                    $uarray=array('class'=>'form-control','data-label'=>'User');
                }
                $outlet=(int) Yii::app()->user->outlet_id;
                echo CHtml::dropdownlist('created_user','',MasUsers::get_outlet_salesandadmin($outlet), $uarray); ?>
                </div>
                &NonBreakingSpace;
                <?php echo CHtml::dropdownlist('type','',array('I'=>'Inventory','S'=>'Service'), array('class'=>'form-control','data-label'=>'Type','prompt' => 'All Types')); ?>
                &NonBreakingSpace;
                <?php echo CHtml::dropdownlist('brand','',MasBrand::getAllBrands(), array('class'=>'form-control','data-label'=>'Brand','prompt' => 'All Brands')); ?>
                &NonBreakingSpace;
                <?php echo CHtml::dropdownlist('stock','',array(1=>'Available',2=>'Empty'), array('class'=>'form-control','data-label'=>'Stock','prompt' => 'Stock(All)')); ?>
                &NonBreakingSpace;
                <button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_inventory');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>   
            <div class="panel-body">
                <div class="custom-data-table">
                    <table class="table table-hover table-bordered personal-task datatable" id="tbl_inventory">
                        <thead>
                            <tr>
                                <th>#</th>
                                <th>Part No</th>
                                <th>Description</th>
                                <th>Type</th>
                                <th>Brand</th>
                                <th>Base Qty</th>
                                <th>Base Unit</th>
                                <th>Sec Qty</th>
                                <th>Sec Unit</th>
                                <th>Cost</th>
                                <th>Price</th>
                                <th>Tax(%)</th>
                                <th>Outlet</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </section>
    </div>
</div>
<script>
    $(document).ready(function () {
        //document ready

        var table_details_id = "#tbl_inventory";
        table_details = $(table_details_id).on("preXhr.dt", function (e, settings, data) {

        data.outlet = $("#outlet").val();
        data.type = $("#type").val();
        data.brand = $("#brand").val();
        data.stock = $("#stock").val();
        data.created_user = $("#created_user").val();
        return data;

}).DataTable({
            scrollY: "550px",
            "bAutoWidth": true,
            pageLength: 50,
            columns: [
                {className: ""},
                {className: ""},
                {className: ""}, 
                {className: ""},
                {className: ""},               
                {className: "text-right" },
                {className: "text-center"},
                {className: "text-right" },
                {className: "text-center"},
                {className: "text-right" },
                {className: "text-right" },
                {className: "text-center" },
                {className: ""},
                {className: ""},
            ],
            ajax: {
                url: "index.php?r=inventory/getlist",
                type: "POST",
                cache: false,
            },
            serverSide: true,
            fixedColumns: true,
            processing: true,
            order: [[1, "asc"]],
            "fnRowCallback": function (nRow, aData, iDisplayIndex, iDisplayIndexFull) {

                if (aData[3] == "Service") {
                    $("td", nRow).addClass("bg-success");
                }
                if (aData[12] == "N") {
                    $("td", nRow).addClass("bg-danger");
                }
            }
        });
        $(".dataTables_scrollFoot").hide();

    });
    function block(id, status){
        var r = confirm((status == "1") ? 'Are you sure to Block this Item?' : 'Are you sure to Unblock this Item?');
        if (r == true)
        {
            jQuery.ajax({
                'type'  : 'post',
                'datatype' :'json',
                'data'  : 'id=' + id + "&status=" + status,
                'url'  : $('#liveSite').val() + 'index.php?r=Inventory/EnableDisable',
                'cache': false,
                'success':function(data){
                    if (data.status == 'fail'){
                        t8.error('Please Try Later');
                    } else {
                        t8.info('Item Status Updated');
                        reloadTable("#tbl_inventory");
                    }
                }
            });
        }
    }
</script>