<?php 

$cs = Yii::app()->getClientScript();

$cs->registerScript("loadPage", "function loadPage(){
        $('#loader').show();
        jQuery.ajax({
            'type': 'post',
            'url': '" . Yii::app()->createUrl('financial/ledger_summary_html') . "',
            'data' : { 'ledger_head_id' : $('#ledger_head_id').val(), 'salesman' : $('#salesman').val(), 'outlet' : $('#outlet').val(), 'to' : $('#to').val() },
            'success': function(data) {
                $('#data_div').show();
                $('.main-li-data').html(data);
                $('#loader').hide();
            }
        });
    }", CClientScript::POS_HEAD);
?>

<div class="row">
    <div class="col-sm-12">
        <section class="panel">
            <header class="text-center panel-heading clearfix"><h4><b><?php echo $from != 'salesman' ? 'Customer Vendor Summary' : 'Customer Summary' ?></b></h4></header>
            <header class="panel-heading clearfix">
                <ul class="clearfix form-ul material">
                    <?php if( Yii::app()->user->user_access_type == 'SU' ) :  ?>
                        <li class="col-sm-3">
                            <?php echo CHtml::dropdownlist('outlet', '', VanOutlets::get_outlets(), array('class' => 'tooltipster', 'data-label' => 'Outlet')); ?>
                        </li>
                    <?php endif; ?>
                    <li class="col-sm-3">
                        <?php 
                            $filter = array( VanLedgers::get_parent_id(VanLedgers::CUSTOMER_PARENT) => 'Customer' );
                            if( $from != 'salesman')
                            $filter[ VanLedgers::get_parent_id(VanLedgers::VENDOR_PARENT) ] = 'Vendor';
                        ?>
                        <?php echo CHtml::dropdownlist('ledger_head_id', '', $filter, array('class' => 'tooltipster', 'data-label' => 'Type')); ?>
                    </li>
                    <li class="col-sm-2">
                        <?php echo CHtml::textField('to', date('d/m/Y'), array('class' => 'datepicker tooltipster', 'data-label' => 'As on date')); ?>
                    </li>
                    <?php if( Yii::app()->user->user_access_type == 'CA' ) :  ?>
                        <li class="col-sm-3">
                            <?php echo CHtml::dropdownlist('salesman', '', VanOutlets::salesmans(), array('class' => 'tooltipster', 'data-label' => 'Salesman', 'prompt' => 'All')); ?>
                        </li>
                    <?php endif; ?>
                     <div class="btn-wrap text-center">
                        <a type="button" class="btn btn-sm btn-theme" onclick="loadPage();">VIEW</a>
                        <a type="button" class="btn btn-sm btn-theme" onclick="window.open($('#liveSite').val()+'index.php?r=reportpdf/ledger_summary&outlet='+$('#outlet').val()+'&to='+$('#to').val()+'&salesman='+$('#salesman').val()+'&ledger_head_id='+$('#ledger_head_id').val(), '_blank'); ">PDF</a>
                        <a type="button" class="btn btn-sm btn-theme" onclick="window.open($('#liveSite').val()+'index.php?r=reportexcel/ledger_summary&outlet='+$('#outlet').val()+'&to='+$('#to').val()+'&salesman='+$('#salesman').val()+'&ledger_head_id='+$('#ledger_head_id').val());">XLS</a>
                    </div>
                </ul>
            </header>
            <div class="panel-body" id="data_div" style="display:none;" >
                <div class="tab-content">
                <div class="tab-pane main-li-data active" id="gl_tab">
                </div>
            </div>
        </section>
    </div>
</div>
