<?php  
$cs = Yii::app()->getClientScript(); 
$cs->registerScript("getUsers", " function getUsers(outlet_id) {
        jQuery.ajax({
            'type': 'post',
            'url': '" . Yii::app()->createUrl('ledger/getuserdrop') . "',
            'data': {'outlet_id':outlet_id },
            'cache': false,
            'success': function(data) {
                $('#user_div').html(data);
            }
        });
}", CClientScript::POS_HEAD);


?>
<?php
    $form = $this->beginWidget('CActiveForm', array(
        'id' => 'group-form',
        'enableAjaxValidation' => false,
        'enableClientValidation' => false,
    ));
?>

<div class="tab-content">
    <div class="tab-pane active">
        <ul class="clearfix form-ul material">
            <li class="col-sm-6">
                <?php echo $form->textField($model, 'name',array('data-label'=>  $model->ledger_type == 'inventory' ? 'Part No *' : 'Name *', 'readonly' =>  $model->ledger_type == 'inventory' && !$model->isNewRecord ? true : false  )); ?>
                <?php echo $form->hiddenField($model, 'id'); ?>
                <?php echo $form->hiddenField($model, 'ledger_type'); ?>
                <?php echo $form->hiddenField($model, 'view_type'); ?>
            </li>
            <li class="col-sm-6">
                <?php echo $form->textField($model, 'alias',array('data-label'=> $model->ledger_type == 'inventory' ? 'Description *' : 'Alias')); ?>
            </li>
            <?php if( $model->ledger_type == 'customers' || $model->ledger_type == 'vendors' ) : ?>
                <li class="col-sm-4">
                    <?php echo $form->textField($model, 'phone_no',array('data-label'=>'Phone No')); ?>
                </li>
                <li class="col-sm-4">
                    <?php echo $form->dropdownlist($model, 'country', VanCountries::all(), array('data-label'=>'Country *')); ?>
                </li>
                <li class="col-sm-4">
                    <?php echo $form->dropdownlist($model, 'emirate', $model->seven_emirates, array('data-label'=>'Emirate *')); ?>
                </li>
                <li class="col-sm-4">
                    <?php echo $form->dropdownlist($model, 'is_barcode_visible', array('N' => 'No', 'Y' => 'Yes'), array('data-label'=>'Barcode Visibility')); ?>
                </li>
            <?php endif; ?>
            <?php if( $model->ledger_type == 'ledger' ) : ?>
                <li class="col-sm-4">
                    <?php echo $form->dropdownlist($model, 'parent_id', VanLedgers::get_parents(0), array('data-label'=>'Group *', 'data-search' => true)); ?>
                </li>
            <?php endif; ?>
            <?php if( $model->ledger_type == 'expenses' ) : ?>
                <li class="col-sm-4">
                    <?php echo CHtml::hiddenField('VanLedgers[goods_or_service]', 'S'); ?>
                    <?php echo $form->dropdownlist($model, 'parent_id', CHtml::listdata(VanLedgers::model()->get_pl_groups(0), 'id', 'withparents'), array('data-label'=>'Group *', 'data-search' => true)); ?>
                </li>
            <?php endif; ?>
            <?php if( $model->ledger_type == 'inventory' ) : ?>
                <li class="col-sm-4">
                    <?php echo $form->textField($model, 'barcode',array('data-label'=>'Barcode')); ?>
                </li>
                <li class="col-sm-4">
                    <?php echo $form->dropdownlist($model, 'parent_id',  CHtml::listdata($model->_product_heads, 'id', 'name'), array('data-label'=>'Generic *', 'data-search' => true)); ?>
                </li>
                <li class="col-sm-2">
                    <?php echo $form->dropdownlist($model, 'uom', VanUnit::all(), array('data-label'=>'Uom *')); ?>
                </li>
                <li class="col-sm-2">
                    <?php echo $form->textField($model, 'min_sales_price',array('data-label'=>'Min. Rate')); ?>
                </li>
                <li class="col-sm-2">
                    <?php echo $form->textField($model, 'default_sales_price',array('data-label'=>'Default Rate')); ?>
                </li>
                <li class="col-sm-2">
                    <?php echo $form->textField($model, 'discount_percentage',array('data-label'=>'Disc(%)')); ?>
                </li>
                <li class="col-sm-2">
                    <?php echo CHtml::textField('total_quantity', $model->current_stock, array('data-label'=>'Stock in Hand', 'readonly' => true)); ?>
                </li>
                <li class="col-sm-2">
                    <?php echo CHtml::textField('cost_rate', Yii::app()->numberFormatter->formatCurrency(VanLedgers::cost_rate_on_date(null, $model->id, array(), false), " "), array('data-label'=>'Cost/Item', 'readonly' => true)); ?>
                </li>
            <?php endif; ?>
            <?php if( $model->ledger_type == 'inventory' || $model->ledger_type == 'expenses' ) : ?>
            <li class="col-sm-2">
                <?php echo $form->dropdownlist($model, 'tax_percentage', VanTax::all(), array('data-label'=>'Tax *')); ?>
                <?php echo CHtml::hiddenField('VanLedgers[currency]', VanCurrency::model()->base_currency); ?>
            </li>
            <li class="col-sm-2">
                <?php echo $form->dropdownlist($model, 'excise_tax', VanTax::all(), array('data-label'=>'Excise Tax', 'prompt' => 'None')); ?>
            </li>
            <?php endif; ?>
            <?php if( $model->ledger_type != 'inventory' && $model->ledger_type != 'expenses' ) : ?>
            <li class="col-sm-4">
                    <?php echo $form->dropdownlist($model, 'currency', VanCurrency::all(), array('data-label'=>'Currency *')); ?>
            </li>
            <?php endif; ?>
            <?php if( $model->ledger_type == 'customers' || $model->ledger_type == 'vendors' ) : ?>
                <li class="col-sm-4">
                    <?php echo $form->textField($model, 'trn_no',array('data-label'=>'TRN No')); ?>
                </li>
                <li class="col-sm-4">
                    <?php echo $form->textArea($model, 'billing_address',array('data-label'=>'Address')); ?>
                </li>
                <li class="col-sm-2">
                    <?php echo $form->textField($model, 'payment_terms',array('data-label'=>'Credit days')); ?>
                </li>
                <li class="col-sm-2">
                    <?php echo $form->textField($model, 'credit_limit',array('data-label'=>'Credit Limit')); ?>
                </li>
            <?php endif; ?>
            <?php //if( $model->ledger_type != 'inventory' && $model->ledger_type != 'expenses' && !$model->is_opening_allocated ) : ?>
            <!-- <li class="col-sm-3">
                <?php //echo CHtml::hiddenField('opening_balance_head', $model->opening_voucher_id ); ?>
                <?php //echo CHtml::textField('opening_balance', (float) $model->opening_balance, array('data-label'=>'Opening Balance' , 'onkeypress' => 'return isNumberKey(event)')); ?>
            </li> -->
            <!-- <li class="col-sm-2">
                <?php //$opening_date = $model->opening_date != '' ? date('d/m/Y', strtotime( $model->opening_date )) : date('01/m/Y') ?>
                <?php //echo CHtml::textField('opening_date', $opening_date, array('class' => 'datepicker', 'data-label'=>'Date')); ?>
            </li> -->
            <?php //endif; ?>
            <?php if( Yii::app()->user->user_access_type == 'CA' && $model->ledger_type == 'customers' ) : ?>
                <!-- <li class="col-sm-4">
                    <?php //echo $form->dropdownlist($model, 'outlet_id', VanOutlets::get_outlets(), array('data-label'=>'Outlet *', 'data-search' => true, 'prompt' => 'None', 'onChange' => 'getUsers(this.value);')); ?>
                </li> -->
                <li class="col-sm-4" id="user_div">
                    <?php echo $form->dropdownlist($model, 'user_id', VanUsers::get_outlet_salesmen((int) $model->outlet_id), array('data-label'=>'Salesman *', 'prompt' => 'None')); ?>
                </li>
            <?php endif; ?>
        </ul>
    </div>
</div>

<div class="modal-footer">
    <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
    <?php 
        if( Yii::app()->user->user_access_type == 'CA' || ( Yii::app()->user->user_access_type == 'SL' && ( $model->ledger_type == 'customers' || $model->ledger_type == 'vendors' ) ) )
            echo CHtml::ajaxSubmitButton('Save',  Yii::app()->createUrl('ledger/saveledger'), array(
                'dataType' => 'json',
                'type' => 'post',
                'success' => 'function(data) {
                    $("#loader").hide();
                    if(data.status=="success"){  
                        t8.success("Saved!");
                        $(".x.close").click();
                        reloadTable("#tbl_customers");
                        reloadTable("#tbl_vendors");
                        reloadTable("#tbl_accounts");
                        reloadTable("#tbl_products");
                        reloadTable("#tbl_services");
                    } else { 
                        $.each(data, function(key, val) {
                            t8.error(""+val+""); 
                        }); 
                    } 
                }',
                'beforeSend' => 'function(){
                    $(".errorMessage").hide(); 
                    $("#loader").show();
                }'
            ), array('id' => 'mybtn' . rand(), 'class' => 'btn btn-theme'));

           

    ?>

    </div>

<?php $this->endWidget(); ?>










