<!DOCTYPE html>
<html>
    <head>
        <title>Purchase Invoice</title>
    </head>
    <body>

        <div class="">
            <div class="col-6">
                <br>
                <div class="h3" style="margin-top: 0;margin-bottom: 0;">PURCHASE INVOICE</div>
                <div class="input-block">
                    <b><?php echo $model->number; ?></b>
                </div>
                <b><?php echo strtoupper($model->partyDetails->name); ?></b>
                <br/>
                <small><?php echo nl2br($model->billing_address); ?></small><br/>
            </div>
            <div class="col-5 offset-1" style="color:#101010;">
                <div class="text-right">
                    <img src="<?php echo 'images/' . $userModel->companyDetails->pdf_logo; ?>" class="logo">
                </div>
                <br>
                <table class="table" style="width:100%">
                     <tr>
                        <td>Vendor Invoice No</td>
                        <td><?php echo $model->reference_no; ?></td>
                    </tr>
                    <tr>
                        <td>Invoice Date</td>
                        <td>
                            <?php echo date('d/m/Y', strtotime($model->date)); ?>
                        </td>
                    </tr>
                    <tr>
                        <td>Due Date</td>
                        <td>
                            <?php echo date('d/m/Y', strtotime($model->due_date)); ?>
                        </td>
                    </tr>
                    <tr>
                        <td>Currency</td>
                        <td>
                            <?php echo $model->voucher_currency_code; ?>
                        </td>
                    </tr>
                    <tr> 
                        <td>Outlet</td>
                        <td><?php echo $model->outletDetails->name; ?></td>
                    </tr>
                    <tr> 
                        <td>Salesman/Phone</td>
                        <td><?php echo nl2br($model->userDetails->full_name.'/<br>'.$model->userDetails->phone_no); ?></td>
                    </tr>
                </table>
            </div>
        </div>
        <br>
        <div class="col-md-12">
            <table id="" class="table">
                <thead>
                    <tr>
                        <th style="width:4%">#</th>
                        <th style="width:15%">Part No.</th>
                        <th style="width:30%">Description</th>
                        <th style="width:8%">UOM</th>
                        <th style="width:9%">Qty</th>
                        <th style="width:9%">Rate</th>
                        <th style="width:9%">Discount</th>
                        <!-- <th style="width:10%">VAT</th> -->
                        <th style="width:13%">Net (Incl. VAT)</th>
                    </tr>
                </thead>
                <tbody>
                    <?php
                        foreach ($model->items as $i => $eachItem) {
                            ?>
                            <tr>
                                <td><?php echo $i+1; ?></td>
                                <td><?php echo $eachItem->ledger->name; ?></td>
                                <td><?php echo nl2br($eachItem->description); ?></td>
                                <td style="text-align:center;"><?php echo $eachItem->unitDetails->symbol; ?></td>
                                <td><?php echo abs($eachItem->quantity); ?></td>
                                <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($eachItem->rate, " "); ?></td>
                                <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($eachItem->discount_value, " "); ?></td>
                                <!-- <td class="text-right"><?php //echo Yii::app()->numberFormatter->formatCurrency($eachItem->tax_value, " "); ?></td> -->
                                <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($eachItem->Net_amount, " "); ?>
                                </td>
                            </tr>
                            <?php                   
                        }
                        ?>
                    <tr>
                        <td class="text-right" colspan="7"><b>Net Total without VAT </b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->Grand_total_wo_vat, " "); ?></b></td>
                    </tr>
                    <tr>
                        <td class="text-right" colspan="7"><b>VAT  </b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->Total_vat, " "); ?></b></td>
                    </tr>
                    <tr>
                        <td class="text-right total bc-bl" colspan="7"><b>Grand Total  </b></td>
                        <td class="text-right total bc-br"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->Grand_total, " "); ?></b></td>
                    </tr>
                    <tr>
                        <td class="text-right" colspan="8"><b><?php echo $model->voucher_currency_code . " " . ucfirst($this->widget('ext.NumtoWord.NumtoWord', array('num' => floatval($model->Grand_total)))->result) . ' only'; ?></b></td>
                    </tr>
                </tbody>
            </table>
        </div>
        <br/>
        <?php if($model->other_references!=''){ ?>
        <div class="box" style="width:100%">
            <h5>Notes</h5>
            <div class="h5sub-details">
                <?php echo nl2br ($model->other_references); ?>
            </div>
        </div>
            
        <?php } ?>

    
        <htmlpagefooter name="myfooter">
            <div style="text-align:center;width:100%;font-size:10px">
            </div>
            <div style="border-top: 1px dotted #000000; font-size: 12px; text-align: center; background-color: #ffffff">
                <div class="col-12">
                    <div class="col-6">
                        <p style="text-align:left;font-size:10px;padding-left:17px;">
                            Generated by : <?php echo $userModel->full_name; ?>
                        </p>
                    </div>
                    <div class="col-6">
                        <p style="text-align:right;font-size:10px;padding-right:17px;">
                        <?php
                                date_default_timezone_set("Asia/Dubai");
                                echo date('l, F j, Y h:i a', strtotime($model->created_date_time))
                        ?>
                        </p>
                    </div>
                </div>
                <div style="text-align:center;width:100%;padding-top:-22px;">
                    <p style="text-align:center;font-size:9.5px">Page {PAGENO} of {nb}</p> 
                </div>
            </div>
        </htmlpagefooter> 

</body>

</html>
