<!DOCTYPE html>
<html>

<head>
    <title>INVOICE</title>
</head>

<body>

    <div class="">
        <div class="col-12">
            <div class="text-center">
                <img src="<?php echo 'images/' . $userModel->companyDetails->pdf_logo; ?>" class="logo">
            </div>
            <div class="text-center">
                <small><?php echo $userModel->companyDetails->billing_address ?></small>
            </div>
        </div>
        <div class="col-12">
            <br>
            <div class="text-center">
                <div class="h3" style="margin-top: 0;margin-bottom: 0;"><?php echo $model->Total_vat > 0 ? ' فاتورة ضريبية <br>TAX INVOICE' : 'INVOICE' ?></div>
            </div>
        </div>
        <div class="col-6">
            <br>
            <b><?php echo strtoupper($model->partyDetails->name); ?></b><br>
            <small><?php echo nl2br($model->billing_address); ?></small><br><br>
            <?php if ($model->Total_vat > 0) : ?>
                <small><b>TRN :</b> <?php echo $model->partyDetails->trn_no; ?></small>
            <?php endif; ?>
        </div>
        <div class="col-5 offset-1" style="color:#101010;">
            <br>
            <table class="table" style="width:100%">
                <tr>
                    <td>Invoice No</td>
                    <td><?php echo $model->number ?></td>
                </tr>
                <tr>
                    <td>Invoice Date</td>
                    <td>
                        <?php echo date('d/m/Y', STRTOTIME($model->date)); ?>
                    </td>
                </tr>
                <!-- <tr>
                    <td>Due Date</td>
                    <td>
                        <?php //echo date('d/m/Y', STRTOTIME($model->due_date)); 
                        ?>
                    </td>
                </tr> -->
                <!-- <tr>
                    <td>Currency</td>
                    <td>
                        <?php //echo $model->voucher_currency_code; 
                        ?>
                    </td>
                </tr> -->
                <tr>
                    <td>LPO</td>
                    <td>
                        <?php echo $model->reference_no; ?>
                    </td>
                </tr>
                <?php if ($model->Total_vat > 0) : ?>
                    <tr>
                        <td>Our TRN</td>
                        <td><?php echo $userModel->companyDetails->trn_no ?></td>
                    </tr>
                <?php endif; ?>
                <tr>
                    <td>Outlet</td>
                    <td><?php echo $model->outletDetails->name; ?></td>
                </tr>
                <tr>
                    <td>Salesman/Phone</td>
                    <td><?php echo nl2br($model->userDetails->full_name . '/<br>' . $model->userDetails->phone_no); ?></td>
                </tr>
            </table>
        </div>
    </div>
    <br>
    <?php

    $bar_codeVisibility = $model->partyDetails->is_barcode_visible == 'Y' ? true : false;
    ?>
    <div class="col-md-12">
        <table class="table">
            <thead>
                <tr>
                    <th style="width:4%">#</th>
                    <th style="width:15%">المنتج<br>Part No.</th>
                    <th style="width:30%">تفاصيل<br>Description</th>
                    <th style="width:9%">كمية<br>Qty</th>
                    <th style="width:8%">UOM</th>
                    <th style="width:9%">معدل<br>Rate</th>
                    <?php if ($model->Total_excise > 0) : ?>
                        <th style="width:5%">Excise(%)</th>
                    <?php endif; ?>
                    <th style="width:9%">خصم<br>Disc.</th>
                    <?php if ($model->Total_vat > 0) : ?>
                        <th style="width:5%">VAT</th>
                    <?php endif; ?>
                    <th style="width:14%">الإجمالي<br>Amount</th>
            </thead>
            <tbody>
                <?php
                foreach ($model->items as $i => $eachItem) {
                ?>
                    <tr>
                        <td><?php echo $i + 1; ?></td>
                        <td>
                            <?php echo $eachItem->ledger->name; ?>
                            <?php
                            if ($bar_codeVisibility) {
                                echo $eachItem->ledger->barcode != '' ? '<small>(' . $eachItem->ledger->barcode . ')</small>' : '';
                            }
                            ?>
                        </td>
                        <td><?php echo nl2br($eachItem->description); ?></td>
                        <td><?php echo abs($eachItem->quantity); ?></td>
                        <td style="text-align:center;"><?php echo $eachItem->unitDetails->symbol; ?></td>
                        <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($eachItem->rate, " "); ?></td>
                        <?php if ($model->Total_excise > 0) : ?>
                            <td class="text-right"><?php echo $eachItem->excise_percentage; ?></td>
                        <?php endif; ?>
                        <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($eachItem->discount_value, " "); ?></td>
                        <?php if ($model->Total_vat > 0) : ?>
                            <td class="text-right"><?php echo $eachItem->tax_percentage; ?></td>
                        <?php endif; ?>
                        <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($eachItem->Net_amount, " "); ?></td>
                    </tr>
                <?php
                }

                $rowSpan = 7;
                if ($model->Total_excise > 0)
                    $rowSpan++;
                if ($model->Total_vat)
                    $rowSpan++;
                ?>
                <?php if ($model->Total_excise > 0) : ?>
                    <tr>
                        <td class="text-right" colspan="<?php echo $rowSpan; ?>"><b>Excise Tax/ الضريبة</b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->Total_excise, " "); ?></b></td>
                    </tr>
                <?php endif; ?>
                <?php if ($model->Total_vat > 0) : ?>
                    <tr>
                        <td class="text-right" colspan="<?php echo $rowSpan; ?>"><b>Total (Ex. VAT)/ الإجمالي</b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->Grand_total_wo_vat, " "); ?></b></td>
                    </tr>
                    <tr>
                        <td class="text-right" colspan="<?php echo $rowSpan; ?>"><b>VAT/ ضريبة القيمة المضافة </b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->Total_vat, " "); ?></b></td>
                    </tr>
                <?php endif; ?>
                <tr>
                    <td class="text-right total bc-bl" colspan="<?php echo $rowSpan; ?>"><b>Grand Total/ الإجمالي</b></td>
                    <td class="text-right total bc-br"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->Grand_total, " "); ?></b></td>
                </tr>
                <tr>
                    <td class="text-right" colspan="<?php echo $rowSpan + 1; ?>"><b><?php echo $model->voucher_currency_code . " " . ucfirst($this->widget('ext.NumtoWord.NumtoWord', array('num' => floatval($model->Grand_total)))->result) . ' only'; ?></b></td>
                </tr>
            </tbody>
        </table>

        <?php if ($userModel->outletDetails->bank_details != '') {
        ?>
            <div class="box" style="width:100%">
                <h5>Bank Details</h5>
                <div class="h5sub-details"><?php echo nl2br($userModel->outletDetails->bank_details); ?> </div>
            </div>
        <?php } ?>
        <br>
        <?php if ($model->other_references != '') {
        ?>
            <div class="box" style="width:100%">
                <h5>Notes</h5>
                <div class="h5sub-details"><?php echo nl2br($model->other_references); ?> </div>
            </div>
        <?php } ?>   
        <br><br><br>
        <div style="position:relative;width:100%;">
            <div style="float:left; width: 40%;text-align: center;">
                _______________________________________ <br>
                <span style="text-align: center;"><small>Received By / Signature</small></span>
            </div>
            <div style="width: 20%;"></div>
            <div style="width: 40%;float: right;text-align: center;">
                _______________________________________ <br>
                <span style="text-align: center;"><small>Authorized signatory</small></span>
            </div>
        </div>
        <br>

    </div>
    <br />


    <htmlpagefooter name="myfooter">
        <div style="text-align:center;width:100%;font-size:10px">
        </div>
        <div style="border-top: 1px dotted #000000; font-size: 12px; text-align: center; background-color: #ffffff">
            <div class="col-12">
                <div class="col-6">
                    <p style="text-align:left;font-size:10px;padding-left:17px;">
                        Generated by : <?php echo $userModel->full_name; ?>
                    </p>
                </div>
                <div class="col-6">
                    <p style="text-align:right;font-size:10px;padding-right:17px;">
                        <?php
                        date_default_timezone_set("Asia/Dubai");
                        echo date('l, F j, Y h:i a', strtotime($model->created_date_time))
                        ?>
                    </p>
                </div>
            </div>
            <div style="text-align:center;width:100%;padding-top:-22px;">
                <p style="text-align:center;font-size:9.5px">Page {PAGENO} of {nb}</p>
            </div>
        </div>
    </htmlpagefooter>
</body>

</html>