<?php

$form = $this->beginWidget('CActiveForm', array(

    'id' => 'voucher-form' . rand(),

    'enableAjaxValidation' => false,

    'enableClientValidation' => false,

));

$cs = Yii::app()->getClientScript();



$cs->registerScript("getLedgers", "function getLedgers(field_id)

{

    var arr_field_id = field_id.split('_');

    var i = arr_field_id[1];

    

    $('#VanTransactions_'+i+'_ledger_id').val('');

    $('#VanTransactions_'+i+'_description').val('');

    

    var url = '" . Yii::app()->createUrl('ledger/goods_and_services') . "&from=sales&service_flag=off';

    $('#'+field_id).autocomplete({

        minLength   : 1,

        source      : function (request, response) { autoCompleteSource(request, response, url) },

        focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },

        select      : function( event, ui ) {

            event.preventDefault();

            $('#VanTransactions_'+i+'_ledger_name').val(ui.item.name);

            $('#VanTransactions_'+i+'_description').val(ui.item.description);

            $('#VanTransactions_'+i+'_ledger_id').val(ui.item.value);

            $('#VanTransactions_'+i+'_uom').val(ui.item.uom);

            $('#unit_drop_'+i).text(ui.item.uom_symbol);

            $('#VanTransactions_'+i+'_quantity').focus();

        }

    });

}", CClientScript::POS_HEAD);





?>

<?php echo $form->hiddenField($model, "id"); ?>

<div class="tab-content">

    <div class="tab-pane active">

        <ul class="clearfix form-ul material">

            <li class="col-sm-3">

                <?php $model->date = $model->isNewRecord ? date('d/m/Y') : date('d/m/Y', strtotime($model->date)) ?>

                <?php echo $form->textField($model, 'date', array('data-label' => 'Voucher Date', 'class' => 'datepicker tooltipster')); ?>

            </li>

            <li class="col-sm-2">

                <?php echo $form->checkBoxList($model, 'printable',array('Y' => 'Print Voucher'),array('title'=>'View')); ?>

            </li>

            <li class="col-sm-12">

                <?php echo $form->textArea($model, 'other_references', array('data-label' => 'Narration', 'class' => 'tooltipster')); ?>

            </li>

        </ul>

        <table class="table table-bordered" id="voucher_entries" >

            <thead>

                <tr>

                    <th class="bg-success" style="width:10%">From Item</th>

                    <th class="bg-success" style="width:20%">Description</th>

                    <th class="bg-success" style="width:8%">Quantity</th>

                    <th class="bg-success" style="width:1%">UOM</th>

                    <th class="bg-danger" style="width:10%">To Item</th>

                    <th class="bg-danger" style="width:20%">Description</th>

                    <th class="bg-danger" style="width:8%">Quantity</th>

                    <th class="bg-danger" style="width:1%">UOM</th>

                </tr>

            </thead>

            <tbody>

                <tr>

                    <?php 

                        $fromItemModel = $model->isNewRecord ?  new VanTransactions  : $model->fromProductDetails;

                        $toItemModel = $model->isNewRecord ?  new VanTransactions  : $model->toProductDetails;

                    ?>

                        <td class="bg-success" >

                       

                            <?php echo $form->hiddenField($fromItemModel, "[0]ledger_id"); ?>

                            <?php $fromItemModel->ledger_name = $fromItemModel->ledger->name; ?>

                            <?php echo $form->textField($fromItemModel, "[0]ledger_name", array('class' => 'form-control', 'onKeypress' => 'js:getLedgers(this.id);')); ?>

                        </td>

                        <td class="bg-success" >

                            <?php echo $form->textField($fromItemModel, "[0]description", array( 'class' => 'form-control' , 'readonly' => true)); ?>

                        </td>

                        

                        <td class="bg-success" >

                            <?php $fromItemModel->quantity = abs($fromItemModel->quantity); ?>

                            <?php echo $form->textField($fromItemModel, "[0]quantity", array('class' => 'go txt-10 text-right', 'onkeypress' => 'return isNumberKey(event)',  'onkeydown' => 'nextline(event)')); ?>

                            <?php echo $form->hiddenField($fromItemModel, "[0]uom"); ?>

                        </td>

                        <td class="bg-success" id="unit_drop_0">

                            <?php echo $fromItemModel->unitDetails->symbol; ?>

                        </td>

                        <td class="bg-danger">



                            <?php echo $form->hiddenField($toItemModel, "[1]ledger_id"); ?>

                            <?php $toItemModel->ledger_name = $toItemModel->ledger->name; ?>

                            <?php echo $form->textField($toItemModel, "[1]ledger_name", array('class' => 'form-control', 'onKeypress' => 'js:getLedgers(this.id);')); ?>

                        </td>

                        <td class="bg-danger">

                            <?php echo $form->textArea($toItemModel, "[1]description", array( 'class' => 'form-control', 'readonly' => true )); ?>

                        </td>

                        

                        <td class="bg-danger">

                            <?php $toItemModel->quantity = abs($toItemModel->quantity); ?>

                            <?php echo $form->textField($toItemModel, "[1]quantity", array('class' => 'go txt-10 text-right', 'onkeypress' => 'return isNumberKey(event)',  'onkeydown' => 'nextline(event)')); ?>

                            <?php echo $form->hiddenField($toItemModel, "[1]uom"); ?>

                        </td>

                        <td class="bg-danger" id="unit_drop_1">

                            <?php echo $toItemModel->unitDetails->symbol; ?>

                        </td>

                        

                    </tr>

                </tbody>

                </table>

            </div>

        </div>

        <div class="modal-footer">

    <button type="button" class="btn btn-danger" data-dismiss="modal">Close</button>

    <?php



echo CHtml::ajaxSubmitButton('Save', Yii::app()->createUrl('voucher/saveconversion'), array(

    'dataType' => 'json',

    'type' => 'post',

    'success' => 'function(data) {

            $("#loader").hide();

            if(data.status=="success"){

                t8.success("Done!");

                $(".x.close").click();

                reloadTable("#tbl_issues");

                if( data.generate_print )

                    window.open("index.php?r=voucher/print&id="+data.id);

                }else{

                    $.each(data, function(key, val) {

                        t8.error(""+val+"");

                    });

                }

            }',

            'beforeSend' => 'function(){

                 $("#loader").show();

            }',

), array('id' => 'mybtn' . rand(), 'class' => 'voucher-submit btn btn-theme'));



?>

    </div>

<?php $this->endWidget();?>



    <script>

        $(function() {

            lastId = $('#voucher_entries').find('tr:last input:first').attr('id');

            thenum = lastId.match(/\d+/g);

            setTimeout(function() {

                $('#VanTransactions_'+thenum+'_ledger_name').focus();

            }, 500);

        });

        function roundToTwo(num) {    

            return +(Math.round(num + "e+2")  + "e-2");

        }

    </script>