<?php

$form = $this->beginWidget('CActiveForm', array(

    'id' => 'voucher-form' . rand(),

    'enableAjaxValidation' => false,

    'enableClientValidation' => false,

));

$cs = Yii::app()->getClientScript();



$cs->registerScript("getExchange", "function getExchange(field_id, currency){

    var arr_field_id = field_id.split('_');

    var i = arr_field_id[1];

    jQuery.ajax({

        'type': 'post',

        'url': '" . Yii::app()->createUrl('voucher/getexchange_rate') . "',

        'data' : {'currency' : currency},

            'success': function(data) {

                $('#VanTransactions_'+i+'_exchange_rate').val(data);

                calculateTotal(true)

            }

        });

    }", CClientScript::POS_HEAD);



$cs->registerScript("sub_fields", "function sub_fields( mode_of_receipt ){



        jQuery.ajax({

            'type': 'post',

            'dataType' : 'json',

            'url': '" . Yii::app()->createUrl('voucher/get_templates') . "',

            'data' : { 'mode_of_receipt' : mode_of_receipt },

                'success': function(data) {

                    $('#div_mode_of_payment').html(data.fields);

                    $('#date_field').html(data.drop);

                }

            });

        }", CClientScript::POS_HEAD);



$cs->registerScript("getLedgers", "function getLedgers(field_id)

{

    var arr_field_id = field_id.split('_');

    var i = arr_field_id[1];



    $('#VanTransactions_'+i+'_ledger_id').val('');



    var ledger_ids = [];

    $('#voucher_entries').find('tr:gt(0)').each(function() {

        if( $(this).find('[id $=_ledger_id]').val() > 0 )

            ledger_ids.push( $(this).find('[id $=_ledger_id]').val() );

    });



    var url = '" . Yii::app()->createUrl('ledger/ledgerlist') . "&existing='+ledger_ids.toString();

    $('#'+field_id).autocomplete({

        minLength   : 1,

        source      : function (request, response) { autoCompleteSource(request, response, url) },

        focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },

        select      : function( event, ui ) {

            event.preventDefault();

            $('#VanTransactions_'+i+'_ledger_name').val(ui.item.description);

            $('#VanTransactions_'+i+'_ledger_id').val(ui.item.value);

            $('#VanTransactions_'+i+'_classification').val(ui.item.classification);



            var count =0;

            $('#voucher_entries').find('tr:gt(0)').each(function() {

                if( $(this).find('[id $=_classification]').val() == '" . VanLedgers::CUSTOMER . "' )

                    count++;

            });



            jQuery.ajax({

                'type': 'post',

                'dataType' : 'json',

                'url': '" . Yii::app()->createUrl('voucher/get_allocation_data') . "',

                'data' : { 'ledger_id' : ui.item.value, 'retrieve' :  'debit' },

                    'success': function(data) {

                        if( data.allocatable && count == 1 ){

                            $('#alloc_li').show();

                            $('#alloc_data_body').html(data.table);

                        }else if( count != 1 ){

                            $('#alloc_li').hide();

                            $('#alloc_data_body').html('<tr><td colspan=\"8\" class=\"text-center\"> No Data</td></tr>');

                        }

                    }

            });

        }

    });

}", CClientScript::POS_HEAD);



$cs->registerScript('calculateTotal', 'function calculateTotal( flag ){

            var creditTotal = 0;

            var credit =0;

            var ex_rate =0;

            $("#voucher_entries").find("tr:gt(0)").each(function() {

                ex_rate = parseFloat($(this).find("[id $=_exchange_rate]").val() );

                credit = parseFloat($(this).find("[id $=_credit]").val().replace(/,/g, "") );

                if( parseFloat($(this).find("[id $=_credit]").val().replace(/,/g, "") ) > 0 )

                    creditTotal += roundToTwo(( credit * ex_rate ));

            });

            var formatted_value_credit = creditTotal > 0 ? parseFloat(creditTotal)

            .toFixed(2)

            .toString()

            .replace(/\B(?=(\d{3})+(?!\d))/g, ",") : 0.00;



            $("#credit_total").val( formatted_value_credit );

            $(".alloc_received").text( formatted_value_credit);



            if( flag )

                $("#allocation_table").find("tr:gt(0)").each(function() {

                $(this).find("[id $=_amount]").val("");

                $(this).find("[id $=_check]").prop("checked", false);

                });



            calculateValue();

        }', CClientScript::POS_HEAD);



$cs->registerScript('calculateValue', 'function calculateValue(){

            var totalAlloc = 0;

            var totalValue = $("#credit_total").val().replace(/,/g, "");

            var balance = 0;



            $("#allocation_table").find("tr:gt(0)").each(function() {

                if( parseFloat( $(this).find("[id $=_amount]").val() ) > 0 )

                    totalAlloc += parseFloat( $(this).find("[id $=_amount]").val() );

            });



            balance = Number(totalValue) - Number(totalAlloc);



            var formatted_value_alloc = totalAlloc > 0 ? parseFloat(totalAlloc)

                .toFixed(2)

                .toString()

                .replace(/\B(?=(\d{3})+(?!\d))/g, ",") : 0.00;



            var formatted_value_bal = balance > 0 ? parseFloat(balance)

                .toFixed(2)

                .toString()

                .replace(/\B(?=(\d{3})+(?!\d))/g, ",") : 0.00;



            $(".alloc_allocated").text( formatted_value_alloc );

            $(".alloc_bal").text( formatted_value_bal );

        }', CClientScript::POS_HEAD);



$cs->registerScript("copyValue", "function copyValue(event, field_id){



            var totalValue = $('#credit_total').val().replace(/,/g, '');

            var totalAlloc = 0;



            $('#allocation_table').find('tr:gt(0)').each(function() {

                if( parseFloat( $(this).find('[id $=_amount]').val() ) > 0 )

                    totalAlloc += parseFloat( $(this).find('[id $=_amount]').val() );

            });



            var balance = Number(totalValue) - Number(totalAlloc);

            balance= roundToTwo(balance);

            var arr_field_id = field_id.split('_');

            var i = arr_field_id[1];



            if( $(event).prop('checked') ){

                var pastable = $('#Allocate_'+i+'_balance').val() > balance ? balance : $('#Allocate_'+i+'_balance').val();

                $('#Allocate_'+i+'_amount').val( pastable );

            }else{

                $('#Allocate_'+i+'_amount').val(0);

            }

        }", CClientScript::POS_HEAD);



$cs->registerScript('validateAmount', 'function validateAmount(maximum, field_id, value){



            var totalValue = $("#credit_total").val().replace(/,/g, "");

            var totalAlloc = 0;



            $("#allocation_table").find("tr:gt(0)").each(function() {

                if( parseFloat( $(this).find("[id $=_amount]").val() ) > 0 )

                    totalAlloc += parseFloat( $(this).find("[id $=_amount]").val() );

            });



            if( value > Number(maximum) || value < 0 || Number(totalAlloc) > Number(totalValue) ){

                $("#"+field_id).val("");

            }



        }', CClientScript::POS_HEAD);



$cs->registerScript("nextline", "function nextline(event)

        {

            if ( event.keyCode == 13 || event.keyCode == 9 ) {

                event.preventDefault();

                newVoucher($('#voucher_entries'));

                return false;

            }

        }", CClientScript::POS_HEAD);

$cs->registerScript("newVoucher", " function newVoucher(jQtable) {

            formId              =   jQtable.attr('id');

            formIdStarter       =   jQtable.attr('id').split(/_(.+)?/)[0];

            lastId = jQtable.find('tr:last input:first').attr('id');

            thenum = lastId.match(/\d+/g);

            newId = Number(thenum) + 1;

            newrow= jQtable.find('tr:last').clone();

            newrow.find('label:first').html(newId+1);

            newrow.attr('class',newId);

            newrow.find('div,input,textarea,checkbox,td,select,.errorMessage,a').each(function() {

                this.id= this.id.replace(/\d+/,newId);

                if(!$(this).is(':checkbox'))

                    this.value  = '';

                else

                    $(this).prop('checked', false);

                (this.name!==undefined) ? this.name= this.name.replace(/\d+/,newId) : this.style = '';

            });

            jQtable.append(newrow);

            $('#VanTransactions_'+newId+'_ledger_name').focus();

            $('#VanTransactions_'+newId+'_currency_id').val(1); //AED

            $('#VanTransactions_'+newId+'_exchange_rate').val(1); //AED

        }", CClientScript::POS_HEAD);



$cs->registerScript("format_currency", "function format_currency(field_id)

{

    var currency = $('#'+field_id).val().replace(/,/g, '') > 0 ?  $('#'+field_id).val().replace(/,/g, '') : 0;

    var formatted_value = currency > 0 ? parseFloat(currency.replace(/,/g, ''))

    .toFixed(2)

    .toString()

    .replace(/\B(?=(\d{3})+(?!\d))/g, ',') : 0.00;

    $('#'+field_id).val(formatted_value);

}", CClientScript::POS_HEAD);



$debitTotal = 0;

$creditTotal = 0;



?>



<ul class="nav nav-tabs company-nav-tabs nav-tab-theme">

    <li class="active"><a href="#general_tab" data-toggle="tab">General</a></li>

    <li><a href="#alloc_tab" id="alloc_li" style="<?php echo !$model->isNewRecord && $model->count_of_customers() == 1 ? 'display:block;' : 'display:none;' ?>" data-toggle="tab"> Allocate</a></li>

</ul>

    <div class="tab-content">

        <div class="tab-pane active" id="general_tab">

            <ul class="clearfix form-ul material">

                <li class="col-sm-2">

                    <?php echo $form->hiddenField($model, "id"); ?>

                    <?php echo $form->dropdownlist($model, 'method', array('CA' => 'Cash Receipt', 'BT' => 'Bank Receipt', 'CHQ' => 'CDC/PDC'), array('data-label' => 'Mode of Receipt', 'onChange' => 'sub_fields(this.value);')); ?>

                </li>

                <li class="col-sm-2" id="date_field">

                    <?php $model->date = $model->isNewRecord ? date('d/m/Y') : date('d/m/Y', strtotime($model->date))?>

                    <?php echo $form->textField($model, 'date', array('data-label' => $model->method == 'CHQ' ? 'Cheque Date' : 'Voucher Date', 'class' => 'datepicker tooltipster')); ?>

                </li>

                <div id="div_mode_of_payment">

                    <li class="col-sm-2">

                        <?php

                            $data = array('"' . VanLedgers::CASH . '"');

                            if ($model->method == 'BT') {

                                $data = array('"' . VanLedgers::BANK . '"');

                            } else if ($model->method == 'CHQ') {

                                $data = array('"' . VanLedgers::BANK . '"');

                            }

                        ?>

                        <?php $mainEntry = VanTransactions::model()->find(array('condition' => 'entry_type="PCASH"'));?>

                        <?php echo CHtml::hiddenField("debit_entry_id", $mainEntry->id); ?>

                        <?php echo CHtml::dropdownlist('receipt_ledger', $mainEntry->ledger_id, VanLedgers::get_mode_of_accounts($data), array('data-label' => 'Receipt Account')); ?>

                    </li>

                    <?php if ($model->method == 'CHQ') {?>

                        <li class="col-sm-2">

                            <?php $collected = $model->isNewRecord ? date('d/m/Y') : date('d/m/Y', strtotime($model->cheque_date))?>

                            <?php echo CHtml::textField('collected_date', $collected, array('data-label' => 'Collected Date', 'class' => 'datepicker tooltipster')); ?>

                        </li>

                        <li class="col-sm-2">

                            <?php echo CHtml::textField('cheque_no', $model->cheque_no, array('data-label' => 'CHQ No', 'class' => 'tooltipster')); ?>

                        </li>



                    <?php }?>

                </div>
                <li class="col-sm-2">

                    <?php echo CHtml::textField('reference_no', $model->reference_no, array('data-label' => 'Reference', 'class' => 'tooltipster')); ?>

                </li>

                <li class="col-sm-2">

                    <?php echo $form->checkBoxList($model, 'printable', array('Y' => 'Print Voucher'), array('title' => 'View')); ?>

                </li>
               
                <li class="col-sm-12">

                    <?php echo $form->textArea($model, 'other_references', array('data-label' => 'Narration', 'class' => 'tooltipster')); ?>

                </li>

            </ul>

            <table class="table table-bordered" id="voucher_entries" >

                <thead>

                    <tr>

                        <th style="width:1%">No</th>

                        <th style="width:50%">Particular</th>

                        <th style="width:20%">Amount</th>

                        <th style="width:25%">Currency</th>

                        <th style="width:1%"class="text-center"><a class="btn btn-xs btn-theme " href="javascript:void(0);" onclick="newVoucher($('#voucher_entries'));"><i class="fa fa-plus"></i></a></th>

                    </tr>

                </thead>

                <tbody id="template_div">

                    <?php foreach ((!$model->isNewrecord) ? $model->creditItems : array(new VanTransactions) as $i => $each): ?>

                        <tr>

                            <td><label><?php echo $i + 1; ?></label></td>



                            <td>

                                <?php echo $form->hiddenField($each, "[" . $i . "]id"); ?>

                                <?php echo $form->hiddenField($each, "[" . $i . "]ledger_id"); ?>

                                <?php echo $form->hiddenField($each, "[" . $i . "]classification"); ?>

                                <?php $each->ledger_name = $each->ledger->name;?>

                                <?php echo $form->textField($each, "[" . $i . "]ledger_name", array('class' => 'form-control', 'onKeypress' => 'js:getLedgers(this.id);')); ?>

                            </td>



                            <?php

                                if ($each->amount < 0) {

                                    $each->credit = Yii::app()->numberFormatter->formatCurrency(abs($each->amount), " ");

                                    $creditTotal += round(abs($each->amount * $each->exchange_rate), 2);

                                }

                            ?>



                            <td class="nw">

                                <?php echo $form->textField($each, "[" . $i . "]credit", array('data-label' => 'Credit', 'class' => 'go txt-10 text-right', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateTotal(true)', 'onBlur' => 'format_currency(this.id);')); ?>

                            </td>



                            <td class="nw">

                                <?php $each->exchange_rate = $each->isNewRecord ? 1 : $each->exchange_rate;?>

                                <?php echo $form->dropdownlist($each, "[" . $i . "]currency_id", VanCurrency::all_codes(), array('class' => 'txt-6 go exception', 'onChange' => 'getExchange(this.id, this.value);')) . ' ' . $form->textField($each, "[" . $i . "]exchange_rate", array('class' => 'txt-6 go exception text-right', 'onkeyup' => 'calculateTotal(true)', 'onkeydown' => 'nextline(event)', 'readonly' => true)); ?>

                            </td>



                            <td class="text-center nw" width="1%"><?php echo CHtml::link('<i class="fa fa-times"></i>', 'javascript:void(0);', array('tabindex' => '-1', 'class' => 'btn btn-xs btn-danger', 'onclick' => 'removeTableRow($(\'#voucher_entries\'),this)', 'title' => 'Remove this item')); ?></td>

                        </tr>

                    <?php endforeach;?>

                            </tbody>

                    </table>

                    <table class="table table-hover table-bordered personal-task"  >

                        <tr>

                            <th colspan="4" class="text-right" style="width: 52.25%;"><b>Total (<?php echo VanCurrency::base_currency_code() ?>)</b></th>

                            <th style="width: 19.85%;text-align:right !important;"><?php echo CHtml::textfield('credit_total', Yii::app()->numberFormatter->formatCurrency($creditTotal, " "), array('tabindex' => '-1', 'class' => 'form-control text-bold text-right', 'readonly' => true)); ?></th>

                            <th></th>

                        </tr>

                    </table>



            </div>

            <div class="tab-pane" id="alloc_tab">

                <table class="table table-bordered" id="allocation_table">

                    <thead>

                        <tr>

                            <th style="width:1%">#</th>

                            <th style="width:5%">Date</th>

                            <th style="width:15%">Type</th>

                            <th style="width:10%">Inv #</th>

                            <th style="width:15%">Total</th>

                            <th style="width:15%">Allocated</th>

                            <th style="width:15%">Balance</th>

                            <th style="width:20%">Amount</th>

                        </tr>

                    </thead>

                    <?php

                                    $query = 'SELECT

                                        V.id AS voucher_id,

                                        VT.name AS voucher_type,

                                        V.number AS voucher_no,

                                        V.date AS voucher_date,

                                        T.id AS voucher_item_id,

                                        T.ledger_id AS ledger_id,

                                        ABS(ROUND((T.amount*T.exchange_rate), 6)) AS voucher_value

                                    FROM {{transactions}} T

                                    LEFT JOIN {{vouchers}} V ON V.id = T.voucher_id

                                    LEFT JOIN {{voucher_types}} VT ON V.type = VT.id

                                    WHERE V.is_posted="Y" AND T.amount > 0 AND T.ledger_id=' . (int) $model->customer_transaction_model()->ledger_id . '

                                    GROUP BY T.id ORDER BY V.date ASC';



$items = !$model->isNewRecord && $model->count_of_customers() == 1 ? Yii::app()->db->createCommand($query)->queryAll() : array();

?>

                    <tbody id="alloc_data_body">

                        <?php

if (!empty($items)) {

    foreach ($items as $i => $each) {

        $returnsValue = (float) VanVouchers::model()->findBypk($each['voucher_id'])->returns_total;

        $voucherValue = (float) $each['voucher_value'] - $returnsValue;

        $allocatedValue = Yii::app()->db->createCommand('SELECT IFNULL(ROUND(SUM(A.amount), 6), 0) AS amount FROM {{allocation}} A LEFT JOIN {{vouchers}} V ON V.id = A.parent_voucher_id WHERE V.is_posted="Y" AND A.child_id=' . (int) $each['voucher_item_id'])->queryScalar();

        $balance = (float) $voucherValue - (float) $allocatedValue;



        if (round($balance,2) > 0) {

            echo '<tr>

                <td>' . CHtml::CheckBox('Allocate[' . $i . '][check]', '', array('value' => $each['voucher_item_id'], 'onChange' => 'copyValue(this, this.id); calculateValue();')) . '</td>

                <td>' . date('d/m/Y', strtotime($each['voucher_date'])) . '</td>

                <td>' . $each['voucher_type'] . '</td>

                <td>' . $each['voucher_no'] . '</td>

                <td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($voucherValue, " ") . '</td>

                <td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($allocatedValue, " ") . '</td>

                <td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($balance, " ") . '</td>

                <td>' . CHtml::hiddenfield('Allocate[' . $i . '][voucher_id]', $each['voucher_id']) .

                CHtml::hiddenfield('Allocate[' . $i . '][voucher_item_id]', $each['voucher_item_id']) .

                CHtml::hiddenfield('Allocate[' . $i . '][balance]', round($balance, 2)) .

                CHtml::hiddenfield('Allocate[' . $i . '][ledger_id]', $each['ledger_id']) .

                CHtml::textfield('Allocate[' . $i . '][amount]', 0, array('class' => 'form-control text-right', 'onkeyup' => 'validateAmount("' . round($balance, 2) . '", this.id, this.value); calculateValue();')) . '</td>

                                                                                </tr>';

        }



    }

} else {

    echo '<tr>

            <td colspan="8" class="text-center"> No Data</td>

        </tr>';

}

?>

                    </tbody>

                </table>

                <table class="table table-hover table-bordered table-nexted quotes_total">

                    <tr class="bg-total">

                        <td width="70%" class="text-right table_total_title">

                            <h2>Received (<?php echo VanCurrency::base_currency_code() ?>)</h2>

                        </td>

                        <td width="30%" class="text-right table_total ">

                            <h2 class="text-right alloc_received"><?php echo Yii::app()->numberFormatter->formatCurrency($total, " "); ?></h2>

                        </td>

                    </tr>

                </table>

                <table class="table table-hover table-bordered table-nexted quotes_total">

                    <tr class="bg-total">

                        <td width="70%" class="text-right table_total_title">

                            <h2>Allocated (<?php echo VanCurrency::base_currency_code() ?>)</h2>

                        </td>

                        <td width="30%" class="text-right table_total ">

                            <h2 class="text-right alloc_allocated"><?php echo Yii::app()->numberFormatter->formatCurrency($total, " "); ?></h2>

                        </td>

                    </tr>

                </table>

                <table class="table table-hover table-bordered table-nexted quotes_total">

                    <tr class="bg-total">

                        <td width="70%" class="text-right table_total_title">

                            <h2>Balance (<?php echo VanCurrency::base_currency_code() ?>)</h2>

                        </td>

                        <td width="30%" class="text-right table_total ">

                            <h2 class="text-right alloc_bal"><?php echo Yii::app()->numberFormatter->formatCurrency($total, " "); ?></h2>

                        </td>

                    </tr>

                </table>

            </div>

        </div>

<div class="modal-footer">

    <button type="button" class="btn btn-danger" id="cust_close" data-dismiss="modal">Close</button>

    <?php



echo CHtml::ajaxSubmitButton('Save', Yii::app()->createUrl('voucher/savereceipt'), array(

    'dataType' => 'json',

    'type' => 'post',

    'success' => 'function(data) {

            $("#loader").hide();

            if(data.status=="success"){

                t8.success("Done!");

                if( data.load_new )

                    loadPopupModal("voucher/create&type=receipt","New Receipt","xl");

                else

                    $(".x.close").click();

                    reloadTable("#tbl_receipts");

                if( data.generate_print )

                    window.open("index.php?r=voucher/print&id="+data.id);

                }else{

                    $.each(data, function(key, val) {

                        t8.error(""+val+"");

                    });

                }

            }',

    'beforeSend' => 'function(){

                $("#loader").show();

            }',

), array('id' => 'mybtn' . rand(), 'class' => 'voucher-submit btn btn-theme'));



?>

    </div>

<?php $this->endWidget();?>



    <script>

        $(function() {

            lastId = $('#voucher_entries').find('tr:last input:first').attr('id');

            thenum = lastId.match(/\d+/g);

            setTimeout(function() {

                $('#VanTransactions_'+thenum+'_ledger_name').focus();

                calculateTotal(false);

            }, 500);

        });

        function roundToTwo(num) {

            return +(Math.round(num + "e+2")  + "e-2");

        }

    </script>