<?php

$form = $this->beginWidget('CActiveForm', array(

    'id' => 'voucher-form' . rand(),

    'enableAjaxValidation' => false,

    'enableClientValidation' => false,

));

$cs = Yii::app()->getClientScript();



$cs->registerScript("getLegders", "function getLedgers(field_id)

{

    var arr_field_id = field_id.split('_');

    var i = arr_field_id[1];

    

    $('#VanTransactions_'+i+'_ledger_id').val('');

    

    var url = '" . Yii::app()->createUrl('ledger/goods_and_services') . "&from=sales&service_flag=off';

    $('#'+field_id).autocomplete({

        minLength   : 1,

        source      : function (request, response) { autoCompleteSource(request, response, url) },

        focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },

        select      : function( event, ui ) {

            event.preventDefault();

            $('#VanTransactions_'+i+'_ledger_name').val(ui.item.name);

            $('#VanTransactions_'+i+'_description').val(ui.item.description);

            $('#VanTransactions_'+i+'_ledger_id').val(ui.item.value);

            $('#VanTransactions_'+i+'_uom').val(ui.item.uom);

            $('#unit_drop_'+i).text(ui.item.uom_symbol);

            $('#VanTransactions_'+i+'_quantity').focus();

        }

    });

}", CClientScript::POS_HEAD);



$cs->registerScript("nextline", "function nextline(event)

        {

            if ( event.keyCode == 13 || event.keyCode == 9 ) {

                event.preventDefault();

                newVoucher($('#voucher_entries'));

                return false;

            }

        }", CClientScript::POS_HEAD);

$cs->registerScript("newVoucher", " function newVoucher(jQtable) {

            formId              =   jQtable.attr('id');

            formIdStarter       =   jQtable.attr('id').split(/_(.+)?/)[0];

            lastId = jQtable.find('tr:last input:first').attr('id');

            thenum = lastId.match(/\d+/g);

            newId = Number(thenum) + 1;

            newrow= jQtable.find('tr:last').clone();

            newrow.find('label:first').html(newId+1);

            newrow.attr('class',newId);

            newrow.find('div,input,textarea,checkbox,td,select,.errorMessage,a').each(function() {

                this.id= this.id.replace(/\d+/,newId);

                if(!$(this).is(':checkbox'))

                    this.value  = '';

                else

                    $(this).prop('checked', false);

                (this.name!==undefined) ? this.name= this.name.replace(/\d+/,newId) : this.style = '';

            });

            jQtable.append(newrow);

            $('#VanTransactions_'+newId+'_ledger_name').focus();

        }", CClientScript::POS_HEAD);







?>

<?php echo $form->hiddenField($model, "id"); ?>

<div class="tab-content">

    <div class="tab-pane active">

        <table class="table table-bordered" id="voucher_entries">

            <thead>

                <tr>

                    <th style="width:1%">No</th>

                    <th style="width:20%">Item</th>

                    <th style="width:30%">Description</th>

                    <th style="width:15%">Quantity</th>

                    <th style="width:1%">UOM</th>

                    <th style="width:1%" class="text-center"><a class="btn btn-xs btn-theme " href="javascript:void(0);" onclick="newVoucher($('#voucher_entries'));"><i class="fa fa-plus"></i></a></th>

                </tr>

            </thead>

            <tbody id="template_div">

                <?php foreach ($transferItems as $i => $each) : ?>

                    <tr>

                        <td><label><?php echo $i + 1; ?></label></td>



                        <td>

                            <?php echo $form->hiddenField($each, "[" . $i . "]id"); ?>

                            <?php echo $form->hiddenField($each, "[" . $i . "]ledger_id"); ?>

                            <?php $each->ledger_name = $each->ledger->name; ?>

                            <?php echo $form->textField($each, "[" . $i . "]ledger_name", array('class' => 'form-control', 'onKeypress' => 'js:getLedgers(this.id);')); ?>

                        </td>

                        <td>

                            <?php echo $form->textField($each, "[" . $i . "]description", array('class' => 'form-control')); ?>

                        </td>



                        <td>

                            <?php $each->quantity = abs($each->quantity); ?>

                            <?php echo $form->textField($each, "[" . $i . "]quantity", array('class' => 'go txt-10 text-right', 'onkeypress' => 'return isNumberKey(event)',  'onkeydown' => 'nextline(event)')); ?>

                            <?php echo $form->hiddenField($each, "[" . $i . "]uom"); ?>

                        </td>

                        <td id="unit_drop_<?php echo $i; ?>">

                            <?php echo $each->unitDetails->symbol; ?>

                        </td>



                        <td class="text-center nw" width="1%"><?php echo CHtml::link('<i class="fa fa-times"></i>', 'javascript:void(0);', array('tabindex' => '-1', 'class' => 'btn btn-xs btn-danger', 'onclick' => 'removeTableRow($(\'#voucher_entries\'),this)', 'title' => 'Remove this item')); ?></td>

                    </tr>

                <?php endforeach; ?>

            </tbody>

        </table>



        <ul class="clearfix form-ul material">

            <li class="col-sm-3">

                <?php $model->date = $model->isNewRecord ? date('d/m/Y') : date('d/m/Y', strtotime($model->date)) ?>

                <?php echo $form->textField($model, 'date', array('data-label' => 'Voucher Date', 'class' => 'datepicker tooltipster')); ?>

            </li>

            <li class="col-sm-3">

                <?php $model->from_user = $model->isNewRecord ? (int) Yii::app()->user->id :  (int) $model->user_id; ?>

                <?php echo $form->dropdownlist($model, 'from_user', VanOutlets::salesmans_without_user(0), array('data-label' => 'From User', 'class' => 'tooltipster', 'onChange' => 'updateDropdown(this.value)')); ?>


            </li>


            <li class="col-sm-3">
                    <div id="to_user_div">
                        <?php echo $form->dropdownlist($model, 'to_user', VanOutlets::salesmans_without_user($model->from_user), array('data-label' => 'To User', 'class' => 'tooltipster')); ?>
                    </div>

                <?php echo $form->hiddenField($model, "transfer_parent"); ?>

            </li>

            <li class="col-sm-2">

                <?php echo $form->checkBoxList($model, 'printable', array('Y' => 'Print Voucher'), array('title' => 'View')); ?>

            </li>

            <li class="col-sm-12">

                <?php echo $form->textArea($model, 'other_references', array('data-label' => 'Narration', 'class' => 'tooltipster')); ?>

            </li>

        </ul>

    </div>

</div>

<div class="modal-footer">

    <button type="button" class="btn btn-danger" id="cust_close" data-dismiss="modal">Close</button>

    <?php



    echo CHtml::ajaxSubmitButton('Save', Yii::app()->createUrl('voucher/savetransfer'), array(

        'dataType' => 'json',

        'type' => 'post',

        'success' => 'function(data) {

            $("#loader").hide();

            if(data.status=="success"){

                t8.success("Done!");

                $(".x.close").click();

                reloadTable("#tbl_transfer");
                reloadTable("#tbl_purchase");

                if( data.generate_print )

                    window.open("index.php?r=voucher/print&id="+data.id);

                }else{

                    $.each(data, function(key, val) {

                        t8.error(""+val+"");

                    });

                }

            }',

        'beforeSend' => 'function(){

                 $("#loader").show();

            }',

    ), array('id' => 'mybtn' . rand(), 'class' => 'voucher-submit btn btn-theme'));



    ?>

</div>

<?php $this->endWidget(); ?>



<script>
    $(function() {

        lastId = $('#voucher_entries').find('tr:last input:first').attr('id');

        thenum = lastId.match(/\d+/g);

        setTimeout(function() {

            $('#VanTransactions_' + thenum + '_ledger_name').focus();

        }, 500);

    });

    function roundToTwo(num) {

        return +(Math.round(num + "e+2") + "e-2");

    }

    function updateDropdown(selectedUser = 0) {
        jQuery.ajax({
            'type': 'post',
            'url': 'index.php?r=voucher/get_drop_to_user',
            'data': {
                'selectedUser': selectedUser
            },
            'success': function(data) {

                $('#to_user_div').html(data);

            }

        });
    }
</script>