<?php

$cs = Yii::app()->getClientScript();

$cs->registerScript("cancel_voucher", "function cancel_voucher(id){

    var r = confirm('Are you sure to cancel the voucher? This cant be reverted!!');

    if(r==true)

        jQuery.ajax({

            'type'  : 'post',

            'data'  : {'id' : id},

            'url'  : $('#liveSite').val()+'index.php?r=voucher/cancelvoucher',

            'cache': false,

            'success':function(data){

                if(data=='success'){

                    t8.success('Done!');

                    reloadTable('#tbl_journal');

                    reloadTable('#tbl_receipts');

                    reloadTable('#tbl_payments');

                    reloadTable('#tbl_purchase');

                    reloadTable('#tbl_sales');

                    reloadTable('#tbl_purchase_rtn');

                    reloadTable('#tbl_sales_rtn');

                }else{

                    t8.error(data);

                }

            }

        });

};", CClientScript::POS_HEAD);

$cs->registerScript("remove_allocation", "function remove_allocation(id){

    var r = confirm('Do you want to remove allocation!!');

    if(r==true)

        jQuery.ajax({

            'type'  : 'post',

            'data'  : {'id' : id},

            'url'  : $('#liveSite').val()+'index.php?r=voucher/removeallocation',

            'cache': false,

            'success':function(data){

                if(data=='success'){

                    t8.success('Done!');

                    reloadTable('#tbl_journal');

                    reloadTable('#tbl_receipts');

                    reloadTable('#tbl_payments');

                    reloadTable('#tbl_purchase');

                    reloadTable('#tbl_sales');

                    reloadTable('#tbl_purchase_rtn');

                    reloadTable('#tbl_sales_rtn');

                }else{

                    t8.error(data);

                }

            }

        });

};", CClientScript::POS_HEAD);



$cs->registerScript("load", '

        $(document).ready(function() {

            

            $("#tbl_journal").on("preXhr.dt", function (e, settings, data) {

                data.type = "journal";
                data.from = $("#journal_from").val();
                data.to = $("#journal_to").val();

                return data;

            }).DataTable({

                "sScrollY": "auto",

                pageLength      : 50,

                columns: [

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-5"},

                    {className: "nw sl col-max-3 text-right"},

                    {className: "nw sl col-max-1"},

                ],

                "oLanguage": {

                    "sSearch": "Voucher No:"

                },

                ajax: {

                    url: "' . Yii::app()->createUrl('voucher/getvouchers') . '",

                    type: "POST",

                    cache : false,

                },

                serverSide:     true,

                fixedColumns:   true,

                processing: true,

                order: [[ 1, "DESC" ]],

            });





            $("#tbl_receipts").on("preXhr.dt", function (e, settings, data) {

                data.type = "receipts";
                data.from = $("#receipt_from").val();
                data.to = $("#receipt_to").val();

                return data;

            }).DataTable({

                "sScrollY": "auto",

                pageLength      : 50,

                columns: [

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-3"},

                    {className: "nw sl col-max-1 text-right"},

                    {className: "nw sl col-max-1"},

                ],

                "oLanguage": {

                    "sSearch": "Voucher No:"

                },

                ajax: {

                    url: "' . Yii::app()->createUrl('voucher/getvouchers') . '",

                    type: "POST",

                    cache : false,

                },

                serverSide:     true,

                fixedColumns:   true,

                processing: true,

                order: [[ 1, "DESC" ]],

            });





            $("#tbl_payments").on("preXhr.dt", function (e, settings, data) {

                data.type = "payments";
                data.from = $("#payment_from").val();
                data.to = $("#payment_to").val();


                return data;

            }).DataTable({

                "sScrollY": "auto",

                pageLength      : 50,

                columns: [

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-3"},

                    {className: "nw sl col-max-1 text-right"},

                    {className: "nw sl col-max-1"},

                ],

                "oLanguage": {

                    "sSearch": "Voucher No:"

                },

                ajax: {

                    url: "' . Yii::app()->createUrl('voucher/getvouchers') . '",

                    type: "POST",

                    cache : false,

                },

                serverSide:     true,

                fixedColumns:   true,

                processing: true,

                order: [[ 1, "DESC" ]],

            });

            

    });', CClientScript::POS_HEAD);

?>



<!--ul start-->

<ul class="nav nav-tabs company-nav-tabs nav-tab-theme">

    <li onclick="reloadTable('#tbl_journal')" class="active"><a href="#journal_sec" data-toggle="tab"><i class="fa fa-cogs"></i> Journals</a></li>

    <li onclick="reloadTable('#tbl_receipts')"><a href="#receipts_sec" data-toggle="tab"> <i class="fa fa-cogs"></i> Receipts</a></li> 

    <li onclick="reloadTable('#tbl_payments')"><a href="#payments_sec" data-toggle="tab"> <i class="fa fa-cogs"></i> Payments</a></li>    

</ul>

<!--ul end-->





<div class="tab-content">

    <!--Journal section start-->

    <div class="tab-pane active" id="journal_sec">

        <section class="panel">
            <header class="panel-heading clearfix">
                <div class="pull-right" style="display:inline-flex">
                    <input type="text" name="journal_from" id="journal_from" class="datepicker form-control" value="<?php echo date('01/m/Y') ?>">&NonBreakingSpace;<input type="text" name="journal_to" id="journal_to" class="datepicker form-control" value="<?php echo date('d/m/Y') ?>">&NonBreakingSpace;<button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_journal');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>
            <div class="panel-body">

                <div class="custom-data-table">

                    <table class="table table-hover table-bordered personal-task" id="tbl_journal">

                        <thead>

                            <tr>

                                <th>Date</th>

                                <th>Voucher No</th>

                                <th>Particulars</th>

                                <th>Value</th>

                                <th>Actions</th>

                            </tr>

                        </thead>

                    </table>

                </div>

            </div>

        </section>

    </div>

    <!--Journal section end-->



    <!--Receipts section start-->

    <div class="tab-pane" id="receipts_sec">

        <section class="panel">
            <header class="panel-heading clearfix">
                <div class="pull-right" style="display:inline-flex">
                    <input type="text" name="receipt_from" id="receipt_from" class="datepicker form-control" value="<?php echo date('01/m/Y') ?>">&NonBreakingSpace;<input type="text" name="receipt_to" id="receipt_to" class="datepicker form-control" value="<?php echo date('d/m/Y') ?>">&NonBreakingSpace;<button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_receipts');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>

            <div class="panel-body">

                <div class="custom-data-table">

                    <table class="table table-hover table-bordered personal-task" id="tbl_receipts">

                        <thead>

                            <tr>

                                <th>Date</th>

                                <th>Voucher No</th>

                                <th>Particulars</th>

                                <th>Value</th>

                                <th>Actions</th>

                            </tr>

                        </thead>

                    </table>

                </div>

            </div>

        </section>

    </div>

    <!--Receipts end-->



    <!--payments section start-->

    <div class="tab-pane" id="payments_sec">

        <section class="panel">
            <header class="panel-heading clearfix">
                <div class="pull-right" style="display:inline-flex">
                    <input type="text" name="payment_from" id="payment_from" class="datepicker form-control" value="<?php echo date('01/m/Y') ?>">&NonBreakingSpace;<input type="text" name="payment_to" id="payment_to" class="datepicker form-control" value="<?php echo date('d/m/Y') ?>">&NonBreakingSpace;<button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_payments');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>
            <div class="panel-body">

                <div class="custom-data-table">

                    <table class="table table-hover table-bordered personal-task" id="tbl_payments">

                        <thead>

                            <tr>

                                <th>Date</th>

                                <th>Voucher No</th>

                                <th>Particulars</th>

                                <th>Value</th>

                                <th>Actions</th>

                            </tr>

                        </thead>

                    </table>

                </div>

            </div>

        </section>

    </div>

    <!--payments end-->

</div>

