<?php

$cs = Yii::app()->getClientScript();

$cs->registerScript("cancel_voucher", "function cancel_voucher(id){

    var r = confirm('Are you sure to cancel the voucher? This cant be reverted!!');

    if(r==true)

        jQuery.ajax({

            'type'  : 'post',

            'data'  : {'id' : id},

            'url'  : $('#liveSite').val()+'index.php?r=voucher/cancelvoucher',

            'cache': false,

            'success':function(data){

                if(data=='success'){

                    t8.success('Done!');

                    reloadTable('#tbl_receipts');

                    reloadTable('#tbl_issues');

                    reloadTable('#tbl_transfer');

                    reloadTable('#tbl_conversion');

                }else{

                    t8.error(data);

                }

            }

        });

};", CClientScript::POS_HEAD);



$cs->registerScript("load", '

        $(document).ready(function() {

            $("#tbl_receipts").on("preXhr.dt", function (e, settings, data) {

                data.type = "receipts";
                data.from = $("#receipt_from").val();
                data.to = $("#receipt_to").val();

                return data;

            }).DataTable({

                "sScrollY": "auto",

                pageLength      : 50,

                columns: [

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-5"},

                    {className: "nw sl col-max-1"},

                ],

                "oLanguage": {

                    "sSearch": "Voucher No:"

                },

                ajax: {

                    url: "' . Yii::app()->createUrl('voucher/get_inventory_vouchers') . '",

                    type: "POST",

                    cache : false,

                },

                serverSide:     true,

                fixedColumns:   true,

                processing: true,

                order: [[ 1, "DESC" ]],

            });





            $("#tbl_issues").on("preXhr.dt", function (e, settings, data) {

                data.type = "issues";
                data.from = $("#issue_from").val();
                data.to = $("#issue_to").val();

                return data;

            }).DataTable({

                "sScrollY": "auto",

                pageLength      : 50,

                columns: [

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-5"},

                    {className: "nw sl col-max-1"},

                ],

                "oLanguage": {

                    "sSearch": "Voucher No:"

                },

                ajax: {

                    url: "' . Yii::app()->createUrl('voucher/get_inventory_vouchers') . '",

                    type: "POST",

                    cache : false,

                },

                serverSide:     true,

                fixedColumns:   true,

                processing: true,

                order: [[ 1, "DESC" ]],

            });



            $("#tbl_transfer").on("preXhr.dt", function (e, settings, data) {

                data.type = "transfer";
                data.from = $("#transfer_from").val();
                data.to = $("#transfer_to").val();

                return data;

            }).DataTable({

                "sScrollY": "auto",

                pageLength      : 50,

                columns: [

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                ],

                "oLanguage": {

                    "sSearch": "Voucher No:"

                },

                ajax: {

                    url: "' . Yii::app()->createUrl('voucher/get_inventory_vouchers') . '",

                    type: "POST",

                    cache : false,

                },

                serverSide:     true,

                fixedColumns:   true,

                processing: true,

                order: [[ 2, "DESC" ]],

            });



            $("#tbl_conversion").on("preXhr.dt", function (e, settings, data) {

                data.type = "conversion";
                data.from = $("#conversion_from").val();
                data.to = $("#conversion_to").val();

                return data;

            }).DataTable({

                "sScrollY": "auto",

                pageLength      : 50,

                "oLanguage": {

                    "sSearch": "Voucher No:"

                },

                ajax: {

                    url: "' . Yii::app()->createUrl('voucher/get_inventory_vouchers') . '",

                    type: "POST",

                    cache : false,

                },

                serverSide:     true,

                fixedColumns:   true,

                processing: true,

                order: [[ 1, "DESC" ]],

            });





    });', CClientScript::POS_HEAD);



    

?>



<!--ul start-->

<ul class="nav nav-tabs company-nav-tabs nav-tab-theme">

    <li class="active" onclick="reloadTable('#tbl_transfer')"><a href="#transfer_sec" data-toggle="tab"> <i class="fa fa-cogs"></i> Goods Transfer</a></li>

    <?php if( Yii::app()->user->user_access_type == 'CA' ): ?>

        <li onclick="reloadTable('#tbl_receipts')"><a href="#receipts_sec" data-toggle="tab"> <i class="fa fa-cogs"></i> Goods Receipts</a></li> 

        <li onclick="reloadTable('#tbl_issues')"><a href="#issues_sec" data-toggle="tab"> <i class="fa fa-cogs"></i> Goods Issues</a></li>  

        <li onclick="reloadTable('#tbl_conversion')"><a href="#conversion_sec" data-toggle="tab"> <i class="fa fa-cogs"></i> Material Conversion</a></li>  

    <?php endif; ?>

</ul>

<!--ul end-->





<div class="tab-content">





    <!--Receipts section start-->

    <div class="tab-pane" id="receipts_sec">

        <section class="panel">
            <header class="panel-heading clearfix">
                <div class="pull-right" style="display:inline-flex">
                    <input type="text" name="receipt_from" id="receipt_from" class="datepicker form-control" value="<?php echo date('01/m/Y') ?>">&NonBreakingSpace;<input type="text" name="receipt_to" id="receipt_to" class="datepicker form-control" value="<?php echo date('d/m/Y') ?>">&NonBreakingSpace;<button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_receipts');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>

            <div class="panel-body">

                <div class="custom-data-table">

                    <table class="table table-hover table-bordered personal-task" id="tbl_receipts">

                        <thead>

                            <tr>

                                <th>Voucher No</th>

                                <th>Date</th>

                                <th>Remarks</th>

                                <th>Actions</th>

                            </tr>

                        </thead>

                    </table>

                </div>

            </div>

        </section>

    </div>

    <!--Receipts end-->



    <!--payments section start-->

    <div class="tab-pane" id="issues_sec">

        <section class="panel">
            <header class="panel-heading clearfix">
                <div class="pull-right" style="display:inline-flex">
                    <input type="text" name="issue_from" id="issue_from" class="datepicker form-control" value="<?php echo date('01/m/Y') ?>">&NonBreakingSpace;<input type="text" name="issue_to" id="issue_to" class="datepicker form-control" value="<?php echo date('d/m/Y') ?>">&NonBreakingSpace;<button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_issues');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>

            <div class="panel-body">

                <div class="custom-data-table">

                    <table class="table table-hover table-bordered personal-task" id="tbl_issues">

                        <thead>

                            <tr>

                                <th>Voucher No</th>

                                <th>Date</th>

                                <th>Remarks</th>

                                <th>Actions</th>

                            </tr>

                        </thead>

                    </table>

                </div>

            </div>

        </section>

    </div>

    <!--payments end-->

    

    <!--transfers section start-->

    <div class="tab-pane active" id="transfer_sec">

        <section class="panel">
            <header class="panel-heading clearfix">
                <div class="pull-right" style="display:inline-flex">
                    <input type="text" name="transfer_from" id="transfer_from" class="datepicker form-control" value="<?php echo date('01/m/Y') ?>">&NonBreakingSpace;<input type="text" name="transfer_to" id="transfer_to" class="datepicker form-control" value="<?php echo date('d/m/Y') ?>">&NonBreakingSpace;<button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_transfer');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>


            <div class="panel-body">

                <div class="custom-data-table">

                    <table class="table table-hover table-bordered personal-task" id="tbl_transfer">

                        <thead>

                            <tr>

                                <th>Issue #</th>

                                <th>Receipt #</th>

                                <th>Date</th>

                                <th>To User</th>

                                <th>Remarks</th>

                                <th>Actions</th>

                            </tr>

                        </thead>

                    </table>

                </div>

            </div>

        </section>

    </div>

    <!--transfers end-->



    <!--transfers section start-->

    <div class="tab-pane" id="conversion_sec">

        <section class="panel">
            <header class="panel-heading clearfix">
                <div class="pull-right" style="display:inline-flex">
                    <input type="text" name="conversion_from" id="conversion_from" class="datepicker form-control" value="<?php echo date('01/m/Y') ?>">&NonBreakingSpace;<input type="text" name="conversion_to" id="conversion_to" class="datepicker form-control" value="<?php echo date('d/m/Y') ?>">&NonBreakingSpace;<button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_conversion');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>

            <div class="panel-body">

                <div class="custom-data-table">

                    <table class="table table-hover table-bordered personal-task" id="tbl_conversion">

                        <thead>

                            <tr>

                                <th rowspan="2">Voucher No</th>

                                <th rowspan="2">Date</th>

                                <th colspan="2" class="text-center">From Item</th>

                                <th colspan="2" class="text-center">To Item</th>

                                <th rowspan="2" >Actions</th>

                            </tr>

                            <tr>

                                <th>Part No</th>

                                <th>Quantity</th>

                                <th>Part No</th>

                                <th>Quantity</th>

                            </tr>

                        </thead>

                    </table>

                </div>

            </div>

        </section>

    </div>

    <!--transfers end-->



</div>

