<!DOCTYPE html>
<html>

<head>
    <title>Sales Invoice</title>
</head>

<body>
    <?php
    $model = SalesInvoice::model()->findByPk($id);
    $modelItems = SalesInvoiceItems::model()->findAll(array('condition' => 'invoice_id=' . $id, 'order' => 'id ASC'));
    if ((int)$user_id > 0) {
        $userModel = MasUsers::model()->findByPk((int) $user_id);
    } else {
        $userModel = MasUsers::model()->findByPk((int) Yii::app()->user->id);
    }

    ?>
    <div class="">

        <?php if ($model->tax_total > 0) {



        ?>
            <div class="col-12">
                <div class="text-center">
                    <img src="<?php echo 'images/' . $userModel->companyDetails->pdf_logo; ?>" class="logo">
                </div>
            </div>
        <?php } ?>

        <div class="col-12">
            <br>
            <div class="text-center">
                <div class="h3" style="margin-top: 0;margin-bottom: 0;"><?php echo $model->tax_total > 0 ? ' فاتورة ضريبية <br>TAX INVOICE' : 'INVOICE' ?></div>
            </div>
        </div>
        <div class="col-6">
            <br>
            Customer : <br>
            <b><?php echo strtoupper($model->customer->customer_name); ?></b><br>
            <!--<small>-->
            <?php echo preg_replace("/(<br \/>\s*){2,}/", '<br /><br />', nl2br($model->customer->address)) ?>
            <!--</small>-->
            <br>
            <?php if ($model->tax_total > 0) : ?>
                <small><b>TRN :</b> <?php echo $model->customer->trn_no; ?></small>
            <?php endif; ?>
        </div>
        <div class="col-5 offset-1" style="color:#101010;">
            <br>
            <table class="table" style="width:100%">
                <tr>
                    <td>Invoice No</td>
                    <td><?php
                        if ($model->taxable == 'N') {
                            $prefix = FormMaster::model()->find(array('condition' => 'outlet=' . $userModel->outlet_id . ' AND code="SI"'))->prefix;
                        } else {
                            $prefix = FormMaster::model()->find(array('condition' => 'outlet=' . $userModel->outlet_id . ' AND code="TSI"'))->prefix;
                        }
                        if ($prefix != '') {
                            echo $prefix . '/';
                        }
                        echo $model->invoice_no ?></td>
                </tr>
                <tr>
                    <td>Invoice Date</td>
                    <td>
                        <?php echo date('d/m/Y', STRTOTIME($model->invoice_date)); ?>
                    </td>
                </tr>
                <?php if ($model->sales_outlet->invoice_credit_terms_print == 'Y') { ?>
                    <tr>
                        <td>Payment Terms</td>
                        <td>
                            <?php
                            echo $model->pay_term->payment_term_name;
                            if ($model->pay_term->payment_term_name == 'Credit' && $model->customer->credit_days > 0) {
                                echo ' - ' . $model->customer->credit_days . ' Days ';
                            }
                            ?>
                        </td>
                    </tr>
                <?php } ?>
                <tr>
                    <td>LPO</td>
                    <td>
                        <?php echo $model->reference_no; ?>
                    </td>
                </tr>
                <?php if ($model->tax_total > 0) : ?>
                    <tr>
                        <td>Our TRN</td>
                        <td><?php echo $model->sales_outlet->trn_no ?></td>
                    </tr>


                    <tr>
                        <td>Salesman/Phone</td>
                        <td><?php echo nl2br($model->si_salesman->full_name . '/<br>' . $model->si_salesman->phone_no); ?></td>
                    </tr>
                <?php endif; ?>
            </table>
        </div>
    </div>
    <br>
    <div class="col-md-12">
        <table class="table">
            <thead>
                <tr>
                    <th style="width:4%">#</th>
                    <th style="width:15%">المنتج<br>Part No.</th>
                    <th style="width:30%">تفاصيل<br>Description</th>
                    <th style="width:9%">كمية<br>Qty</th>
                    <th style="width:8%">وحدة<br>Unit</th>
                    <th style="width:9%">السعر<br>Price</th>
                    <?php if ($model->excise_total > 0) : ?>
                        <th style="width:5%">Excise(%)</th>
                    <?php endif; ?>
                    <?php if ($model->tax_total > 0) : ?>
                        <th style="width:7%">VAT</th>
                    <?php endif; ?>
                    <?php if ($model->total_discount_amount > 0) : ?>
                        <th style="width:10%">تخفيض<br>Discount</th>
                    <?php endif; ?>
                    <th style="width:10%">الإجمالي<br>Amount</th>
            </thead>
            <tbody>
                <?php
                foreach ($modelItems as $i => $eachItem) {
                ?>
                    <tr>
                        <td><?php echo $i + 1; ?></td>
                        <td>
                            <?php echo $eachItem->product->part_number; ?>
                            <?php
                            if ($model->customer->invoice_barcode_show == 'Y') {
                                echo $eachItem->product->barcode != '' ? '<small>(' . $eachItem->product->barcode . ')</small>' : '';
                            }
                            ?>
                        </td>
                        <td><?php echo nl2br($eachItem->description); ?></td>
                        <td><?php echo abs($eachItem->quantity); ?></td>
                        <td style="text-align:center;"><?php echo $eachItem->units->label; ?></td>
                        <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($eachItem->rate, " "); ?></td>
                        <?php if ($model->excise_total > 0) : ?>
                            <td class="text-right"><?php echo $eachItem->excise_percentage; ?></td>
                        <?php endif; ?>
                        <?php if ($model->tax_total > 0) : ?>
                            <td class="text-right"><?php echo $eachItem->tax_percentage; ?></td>
                        <?php endif; ?>                        
                        <?php if ($eachItem->deduction_amount > 0) : ?>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($eachItem->deduction_amount, " ");   ?></td>
                        <?php endif; ?>
                        <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($eachItem->net_amount, " "); ?></td>
                    </tr>
                <?php

                }

                $rowSpan = 6;
                 if ($model->total_discount_amount > 0) 
                 $rowSpan =   $rowSpan+1;
                if ($model->excise_total > 0)
                    $rowSpan++;
                if ($model->tax_total > 0)
                    $rowSpan++;
                ?>
                <tr>
                    <td class="text-right" colspan="<?php echo $rowSpan; ?>"><b>Total (Ex. VAT)/ الإجمالي</b></td>
                    <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->total_amount, " "); ?></b></td>
                </tr>
                <?php if ($model->excise_total > 0) : ?>
                    <tr>
                        <td class="text-right" colspan="<?php echo $rowSpan; ?>"><b>Excise Tax/ الضريبة</b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->excise_total, " "); ?></b></td>
                    </tr>
                <?php endif; ?>
                <?php if ($model->tax_total > 0) : ?>
                    <tr>
                        <td class="text-right" colspan="<?php echo $rowSpan; ?>"><b>VAT/ ضريبة القيمة المضافة </b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->tax_total, " "); ?></b></td>
                    </tr>
                <?php endif; ?>
                <?php if ($model->total_discount_amount > 0) : ?>
                    <tr>
                        <td class="text-right" colspan="<?php echo $rowSpan; ?>"><b>Discount/ تخفيض</b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->total_discount_amount, " "); ?></b></td>
                    </tr>
                <?php endif; ?>
                
                <tr>
                    <td class="text-right total bc-bl" colspan="<?php echo $rowSpan; ?>"><b>Grand Total/ الإجمالي</b></td>
                    <td class="text-right total bc-br"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->grand_total, " "); ?></b></td>
                </tr>
                <tr>
                    <td class="text-left" colspan="<?php echo $rowSpan + 1; ?>"><b><?php //echo $model->currency . " " . 
                                                                                    echo ucfirst($this->widget('ext.NumtoWord.NumtoWord', array('num' => floatval($model->grand_total)))->result) . ' only'; ?></b></td>
                </tr>
            </tbody>
        </table>

        <?php
        $customer_subledger = $this->getSublegder($model->customer_id, 1);
        $customer_ledger = FinanceSystemAccountsMapping::getSystemdefault('debtors');
        $current_credit = Yii::app()->db->createCommand("select SUM(I.amount) from erp_finance_voucher_items I INNER JOIN erp_finance_voucher_head H ON H.id=I.header_id where H.is_posted='Y' AND ledger_id='$customer_ledger' AND subledger_id='$customer_subledger'")->queryScalar();
        if ($userModel->outletDetails->invoice_show_balance == 'Y') //$model->received>0
        {
        ?>
            <div class="box" style="width:100%">
                <div class="h5sub-details"><?php echo "Outstanding Amount : " . Yii::app()->numberFormatter->formatCurrency($current_credit + $model->received, " "); ?> </div>
                <div class="h5sub-details"><?php echo "Received Amount&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; : " . Yii::app()->numberFormatter->formatCurrency($model->received, " "); ?> </div>
                <div class="h5sub-details"><?php echo "Balance Amount&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; : " . Yii::app()->numberFormatter->formatCurrency($current_credit, " "); ?> </div>
            </div>
        <?php }
        if ($userModel->outletDetails->bank_details != '') {
        ?>
            <!--                <div class="box" style="width:100%">
                    <h5>Bank Details</h5>
                    <div class="h5sub-details"><?php //echo nl2br($userModel->outletDetails->bank_details); 
                                                ?> </div>
                </div>-->
        <?php } ?>
        <br>
        <?php if ($model->notes != '') {
        ?>
            <div class="box" style="width:100%">
                <h5>Notes</h5>
                <div class="h5sub-details"><?php echo nl2br($model->notes); ?> </div>
            </div>
        <?php } ?>
        <br><br>
        <div style="position:relative;width:100%;">
            <div style="float:left; width: 40%;text-align: center;">
                _______________________________________ <br>
                <span style="text-align: center;"><small>Received By / Signature</small></span>
            </div>
            <div style="width: 20%;"></div>
            <div style="width: 40%;float: right;text-align: center;">
                _______________________________________ <br>
                <span style="text-align: center;"><small>For <?php  echo ($model->tax_total > 0) ? $userModel->outletDetails->name:''; ?></small></span>
            </div>
        </div>
        <br>


    </div>
    <br />


    <htmlpagefooter name="myfooter">
        <div style="text-align:center;width:100%;font-size:10px">
        </div>
        <div style="border-top: 1px dotted #000000; font-size: 12px; text-align: center; background-color: #ffffff">
            <div class="col-12">
                <div class="col-6">
                    <p style="text-align:left;font-size:10px;padding-left:17px;">
                        Generated by : <?php echo $userModel->full_name; ?>
                        <?php
                        date_default_timezone_set("Asia/Dubai");
                        echo ' On ' . date('d-m-Y h:i a');
                        ?>
                    </p>
                </div>
                <div class="col-6">
                    <p style="text-align:right;font-size:10px;padding-right:17px;">
                        Created by : <?php echo $model->user->full_name; ?>
                        <?php
                        date_default_timezone_set("Asia/Dubai");
                        echo ' On ' . date('d-m-Y h:i a', strtotime($model->created_time))
                        ?>
                    </p>
                </div>
            </div>
            <div style="text-align:center;width:100%;padding-top:-22px;">
                <p style="text-align:center;font-size:9.5px">Page {PAGENO} of {nb}</p>
            </div>
        </div>
    </htmlpagefooter>
</body>

</html>