<div class="table-responsive">
    <table class="table table-hover table-striped table-bordered ">

        <thead>
            <tr>
                <th style="width:3%">Sl No.</th>
                <th style="width:7%">Inv No.</th>
                <th style="width:10%">Date</th>
                <th style="width:25%">Customer</th>
                <th style="width:10%">Amount</th>
                <th style="width:10%">Receipt Amount</th>
                <th style="width:10%">Balance</th>
            </tr>
        </thead>
        <tbody>
            <?php
            $condition_sales .= "1=1 AND active='Y'";
            $condition_sales_return .= "1=1 AND active='Y'";

            if ($outlet > 0) {
                $condition_sales .= " AND outlet=" . $outlet;
                $condition_sales_return .= " AND outlet=" . $outlet;
            }
            if ($created_user > 0) {
                $condition_sales .= " AND sales_man=" . $created_user;
                $condition_sales_return .= " AND created_by=" . $created_user;
            }
            if ($customer_id > 0) {
                $condition_sales .= " AND customer_id=" . $customer_id;
                $condition_sales_return .= " AND customer_id=" . $customer_id;
            }
            if ($daybook_date != '' && $daybook_date != '00/00/0000') {
                $daybook_date = str_replace('/', '-', $daybook_date);
                $daybook_date = date("Y-m-d", strtotime($daybook_date));
                $condition_sales .= ' AND invoice_date="' . $daybook_date . '"';
                $condition_sales_return .= ' AND return_date="' . $daybook_date . '"';
            }
            //Sales
            $model = SalesInvoice::model()->findAll(array('condition' => $condition_sales));
            $grand_total = 0;
            $received_total = 0;
            foreach ($model as $i => $row) {
                if ($row['posted'] == 'Y') {
                    $outlet = $row->outlet;
                    $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="SI" AND outlet=' . $outlet))->id;
                    $inv = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type=' . $vouchertype . ' AND header_table_id=' . $row->id));
                    $debtor = FinanceSystemAccountsMapping::getSystemdefault('debtors');
                    if ($inv->id > 0) {
                        $inv_item = FinanceVoucherItems::model()->find(array('condition' => 'ledger_id=' . $debtor . ' AND header_id=' . $inv->id));
                        $inv_amount = $inv_item->amount;
                    } else {
                        $inv_amount = 0;
                    }
                    if ($inv_item->id > 0) {
                        $received_amount = Yii::app()->db->createCommand('select sum(amount) from erp_finance_allocation_items where voucher_item_id=' . $inv_item->id)->queryScalar();
                    } else {
                        $received_amount = 0;
                    }
                }
            ?>
                <tr>
                    <td style="text-align:center !important;"><?php echo ($i + 1); ?></td>
                    <td style="text-align:left !important;"><?php echo $row->invoice_no; ?></td>
                    <td style="text-align:left !important;"><?php echo date('d/m/Y', strtotime($row->invoice_date)); ?></td>
                    <td style="text-align:left !important;"><?php echo $row->customer->customer_name; ?></td>
                    <td style="text-align:right !important;"><?php echo Yii::app()->numberFormatter->formatCurrency($row->grand_total, ""); ?></td>
                    <td style="text-align:right !important;"><?php echo Yii::app()->numberFormatter->formatCurrency($received_amount, ""); ?></td>
                    <td style="text-align:right !important;"><?php echo Yii::app()->numberFormatter->formatCurrency($row->grand_total - $received_amount, ""); ?></td>
                </tr>
            <?php
                $grand_total += $row->grand_total;
                $received_total += $received_amount;
            }
            $total_sales = $grand_total;
            ?>
            <tr>
                <td style="text-align:right !important;" colspan="4"><b>Total</b></td>
                <td style="text-align:right !important;"><b><?php echo Yii::app()->numberFormatter->formatCurrency($grand_total, ""); ?></b></td>
                <td style="text-align:right !important;"><b><?php echo Yii::app()->numberFormatter->formatCurrency($received_total, ""); ?></b></td>
                <td style="text-align:right !important;"><b><?php echo Yii::app()->numberFormatter->formatCurrency($grand_total - $received_total, ""); ?></b></td>
            </tr>
        </tbody>
    </table>
    <table class="table table-hover table-striped table-bordered ">
        <thead>
            <tr>
                <th style="width:3%">Sl No.</th>
                <th style="width:7%">Cn. No.</th>
                <th style="width:10%">Cn. Date</th>
                <th style="width:25%">Customer</th>
                <th style="width:7%">Inv. No.</th>
                <th style="width:10%">Inv. Date</th>
                <th style="width:10%">Inv. Amt.</th>
                <th style="width:10%">Cn. Amt.</th>
                <th style="width:10%">Balance</th>
            </tr>
        </thead>
        <tbody>
            <?php
            //Sales Return
            $model = SalesReturn::model()->findAll(array('condition' => $condition_sales_return));
            $grand_total = 0;
            $cn_total = 0;
            foreach ($model as $i => $row) {
            ?>
                <tr>
                    <td style="text-align:center !important;"><?php echo ($i + 1); ?></td>
                    <td style="text-align:left !important;"><?php echo $row->return_no; ?></td>
                    <td style="text-align:left !important;"><?php echo date('d/m/Y', strtotime($row->return_date)); ?></td>
                    <td style="text-align:left !important;"><?php echo $row->sr_customer->customer_name; ?></td>
                    <td style="text-align:left !important;"><?php echo $row->sr_invoice->invoice_no; ?></td>
                    <td style="text-align:left !important;"><?php echo date('d/m/Y', strtotime($row->sr_invoice->invoice_date)); ?></td>
                    <td style="text-align:right !important;"><?php echo Yii::app()->numberFormatter->formatCurrency($row->grand_total, ""); ?></td>
                    <td style="text-align:right !important;"><?php echo Yii::app()->numberFormatter->formatCurrency($row->sr_invoice->grand_total, ""); ?></td>
                    <td style="text-align:right !important;"><?php echo Yii::app()->numberFormatter->formatCurrency($row->grand_total - $row->sr_invoice->grand_total, ""); ?></td>
                </tr>
            <?php
                $grand_total += $row->sr_invoice->grand_total;
                $cn_total += $row->grand_total;
            }
            $total_sales_return = $cn_total;
            ?>
            <tr>
                <td style="text-align:right !important;" colspan="6"><b>Total</b></td>
                <td style="text-align:right !important;"><b><?php echo Yii::app()->numberFormatter->formatCurrency($grand_total, ""); ?></b></td>
                <td style="text-align:right !important;"><b><?php echo Yii::app()->numberFormatter->formatCurrency($cn_total, ""); ?></b></td>
                <td style="text-align:right !important;"><b><?php echo Yii::app()->numberFormatter->formatCurrency($grand_total - $cn_total, ""); ?></b></td>
            </tr>
        </tbody>
    </table>
    <table class="table table-hover table-striped table-bordered ">
        <thead>
            <tr>
                <th style="width:3%">Sl No.</th>
                <th style="width:7%">Voucher No.</th>
                <th style="width:10%">Voucher Date</th>
                <th style="width:25%">Customer</th>
                <!--                <th style="width:7%">Inv No.</th>
                <th style="width:10%">Inv. Date</th>
                <th style="width:10%">Inv. Amount</th>-->
                <th style="width:10%">Receipt Amount</th>
                <!--                <th style="width:10%">Discount</th>
                <th style="width:10%">Balance</th>-->
            </tr>
        </thead>
        <tbody>
            <?php
            $CashAccount = FinanceSystemAccountsMapping::getSystemdefault('cash_account');
            $condition_expense = "1=1 AND H.is_posted='Y' AND H.is_posted='Y' AND amount<0 AND ledger_id=" . $CashAccount;
            $condition_cash = "1=1 AND H.is_posted='Y' AND H.is_posted='Y' AND amount>0 AND ledger_id=" . $CashAccount;

            if ($outlet > 0) {
                $condition_expense .= " AND I.outlet=" . $outlet;
                $condition_cash .= " AND I.outlet=" . $outlet;
            }
            /*   if ($created_user > 0) {
                $condition_expense .= " AND H.created_by=" . $created_user;
                $condition_cash .= " AND H.created_by=" . $created_user;
            } */

            if ($created_user > 0) {

                $subledger_id = FinanceSubledger::model()->find(array('condition' => 'subledger_type_id=3 AND parent_id=' . $created_user))->id;
                if ((int)$subledger_id > 0) {
                    $condition_expense .= " AND I.subledger_id=" . $subledger_id;
                    $condition_cash .= " AND I.subledger_id=" . $subledger_id;
                }
            }
            if ($daybook_date != '' && $daybook_date != '00/00/0000') {
                $daybook_date = str_replace('/', '-', $daybook_date);
                $daybook_date = date("Y-m-d", strtotime($daybook_date));
                $condition_expense .= ' AND H.voucher_date="' . $daybook_date . '"';
                $condition_cash .= ' AND H.voucher_date="' . $daybook_date . '"';
            }
            //Expense & Cash
            $grand_total = 0;
            $received_total = 0;
            $discount_tot = 0;


            $expenses = Yii::app()->db->createCommand("SELECT H.voucher_no,H.id,I.id AS voucher_item_id,H.voucher_date,I.amount FROM {{finance_voucher_items}} I INNER JOIN {{finance_voucher_head}} H ON H.id=I.header_id where $condition_cash")->queryAll();
            foreach ($expenses as $i => $row) {
                if ($customer_id > 0) {
                    $subledger = FinanceSubledger::model()->find(array('condition' => 'subledger_type_id=1 AND parent_id=' . $customer_id));
                }
                $voucher = FinanceVoucherItems::model()->find(array('condition' => 'amount<0 AND header_id=' . $row['id']));
                if ($voucher->id > 0) {
                    $id = $voucher->id;
                    $invoice = SalesInvoice::model()->findByPk($voucher->parent->header_table_id);
                    //                    $received_amount=-1*Yii::app()->db->createCommand('select sum(amount) from erp_finance_allocation_items where voucher_item_id='.$voucher->id)->queryScalar();
                } else {
                    $id = 0;
                    //                    $received_amount=0;
                }
            ?>
                <?php if ($customer_id > 0) {
                    if ($voucher->subledger_id == $subledger->id) {
                        $allocations = FinanceAllocationItems::model()->findAll(array('condition' => 'voucher_item_id=' . $id));
                        $tot_alloc_amount = 0;
                        foreach ($allocations as $eachAllocations) {
                            $allocs = FinanceAllocationItems::model()->findAll(array('condition' => 'header_id=' . $eachAllocations->header_id));
                            foreach ($allocs as $eachAllocs) {
                                if ($eachAllocs->amount > 0) {
                                    $tot_alloc_amount += $eachAllocs->amount;
                                }
                            }
                        }
                        if ($invoice->invoice_no > 0) {
                            $grand_total1 = $invoice->grand_total;
                        } else {
                            $grand_total1 = $tot_alloc_amount;
                        }
                ?>
                        <tr>
                            <td style="text-align:center !important;"><?php echo ($i + 1); ?></td>
                            <td style="text-align:left !important;"><a onclick="loadPopupModal('finance/vouchers/AllocateVoucherDetails&voucher_id=<?php echo $id; ?>', 'Allocation', 'lg')"><?php echo $row['voucher_no']; ?></a></td>
                            <td style="text-align:left !important;"><?php echo date('d/m/Y', strtotime($row['voucher_date'])); ?></td>
                            <td style="text-align:left !important;"><?php echo $voucher->subledger->description; ?></td>
                            <!--<td style="text-align:left !important;"><?php // echo $invoice->invoice_no; 
                                                                        ?></td>-->
                            <!--<td style="text-align:left !important;"><?php // if($invoice->invoice_no>0) { echo date('d/m/Y',strtotime($invoice->invoice_date)); } 
                                                                        ?></td>-->
                            <!--<td style="text-align:right !important;"><?php // echo Yii::app()->numberFormatter->formatCurrency($grand_total1,""); 
                                                                            ?></td>-->
                            <td style="text-align:right !important;"><?php echo Yii::app()->numberFormatter->formatCurrency($row['amount'], ""); ?></td>
                            <!--<td style="text-align:right !important;"><?php // echo Yii::app()->numberFormatter->formatCurrency($invoice->discount,""); 
                                                                            ?></td>-->
                            <!--<td style="text-align:right !important;"><?php // echo Yii::app()->numberFormatter->formatCurrency($grand_total1-$row['amount']-$invoice->discount,""); 
                                                                            ?></td>-->
                        </tr>
                    <?php
                        $grand_total += $grand_total1;
                        $received_total += 1 * $row['amount'];
                        $discount_tot += $invoice->discount;
                    }
                } else {
                    if ($voucher->subledger->description != '') {
                        $allocations = FinanceAllocationItems::model()->findAll(array('condition' => 'voucher_item_id=' . $id));
                        $tot_alloc_amount = 0;
                        foreach ($allocations as $eachAllocations) {
                            $allocs = FinanceAllocationItems::model()->findAll(array('condition' => 'header_id=' . $eachAllocations->header_id));
                            foreach ($allocs as $eachAllocs) {
                                if ($eachAllocs->amount > 0) {
                                    $tot_alloc_amount += $eachAllocs->amount;
                                }
                            }
                        }
                        if ($invoice->invoice_no > 0) {
                            $grand_total1 = $invoice->grand_total;
                        } else {
                            $grand_total1 = $tot_alloc_amount;
                        }
                    ?>
                        <tr>
                            <td style="text-align:center !important;"><?php echo ($i + 1); ?></td>
                            <td style="text-align:left !important;"><a onclick="loadPopupModal('finance/vouchers/AllocateVoucherDetails&voucher_id=<?php echo $id; ?>', 'Allocation', 'lg')"><?php echo $row['voucher_no']; ?></a></td>
                            <td style="text-align:left !important;"><?php echo date('d/m/Y', strtotime($row['voucher_date'])); ?></td>
                            <td style="text-align:left !important;"><?php echo $voucher->subledger->description; ?></td>
                            <!--<td style="text-align:left !important;"><?php // echo $invoice->invoice_no; 
                                                                        ?></td>-->
                            <!--<td style="text-align:left !important;"><?php // if($invoice->invoice_no>0) { echo date('d/m/Y',strtotime($invoice->invoice_date)); } 
                                                                        ?></td>-->
                            <!--<td style="text-align:right !important;"><?php // echo Yii::app()->numberFormatter->formatCurrency($grand_total1,""); 
                                                                            ?></td>-->
                            <td style="text-align:right !important;"><?php echo Yii::app()->numberFormatter->formatCurrency($row['amount'], ""); ?></td>
                            <!--<td style="text-align:right !important;"><?php // echo Yii::app()->numberFormatter->formatCurrency($invoice->discount,""); 
                                                                            ?></td>-->
                            <!--<td style="text-align:right !important;"><?php // echo Yii::app()->numberFormatter->formatCurrency($grand_total1-$row['amount']-$invoice->discount,""); 
                                                                            ?></td>-->
                        </tr>
            <?php
                        $grand_total += $grand_total1;
                        $received_total += 1 * $row['amount'];
                        $discount_tot += $invoice->discount;
                    }
                }
            }
            $cash_collected = $received_total;
            ?>
            <tr>
                <td style="text-align:right !important;" colspan="4"><b>Total</b></td>
                <!--<td style="text-align:right !important;"><b><?php // echo Yii::app()->numberFormatter->formatCurrency($grand_total,""); 
                                                                ?></b></td>-->
                <td style="text-align:right !important;"><b><?php echo Yii::app()->numberFormatter->formatCurrency($received_total, ""); ?></b></td>
                <!--<td style="text-align:right !important;"><b><?php // echo Yii::app()->numberFormatter->formatCurrency($discount_tot,""); 
                                                                ?></b></td>-->
                <!--<td style="text-align:right !important;"><b><?php // echo Yii::app()->numberFormatter->formatCurrency($grand_total-$received_total-$discount_tot,""); 
                                                                ?></b></td>-->
            </tr>
        </tbody>
    </table>
    <table class="table table-hover table-striped table-bordered ">
        <thead>
            <tr>
                <th style="width:25%">Total Sales</th>
                <th style="width:25%">Total Creditnote</th>
                <th style="width:25%">Total Cash Collected</th>
                <th style="width:25%">Total Discount Allowed</th>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td style="text-align:right !important;"><b><?php echo Yii::app()->numberFormatter->formatCurrency($total_sales, ""); ?></b></td>
                <td style="text-align:right !important;"><b><?php echo Yii::app()->numberFormatter->formatCurrency($total_sales_return, ""); ?></b></td>
                <td style="text-align:right !important;"><b><?php echo Yii::app()->numberFormatter->formatCurrency($cash_collected, ""); ?></b></td>
                <td style="text-align:right !important;"><b><?php echo Yii::app()->numberFormatter->formatCurrency($discount_tot, ""); ?></b></td>
            </tr>
        </tbody>
    </table>
</div>