
<?php if($product_id>0)
    {
        $pdt_model= Inventory::model()->findByPk($product_id);
        $default_unit=$pdt_model->Unit_symbol;
    }?>
<div class="table-responsive">
    <table class="table table-hover table-striped table-bordered ">
        <thead>
            <tr>
                <th style="width:5%">Date</th>
                <th style="width:8%">Transaction No</th>
                <th style="width:10%">Type</th>
                 <th style="width:5%">Salesman</th>
                <th style="width:20%">Customer/Vendor</th>
                <?php if(Yii::app()->user->user_access_type != 'SL'){ ?>
                <th style="width:5%">Cost/Item</th>
                <?php } ?>
                <th style="width:5%">Rate/Item</th>
                <th style="width:5%">Quantity</th>
                <th style="width:5%">Unit</th>
               
                <th style="width:10%">Balance(in <?php echo $default_unit;?>)</th>
            </tr>
        </thead>
        <tbody>
            <?php  $model  = new StockLedger();
            $condition      = '1=1';
            if($outlet>0){
                $condition.=" AND t.outlet=".$outlet;
            }
            if($from!='' && $from!='00/00/0000')
            {
                $from = str_replace('/', '-',$from);
                $from=date("Y-m-d", strtotime($from));
                $condition.=' AND t.transaction_date>="'.$from.'"';    
            }
            if($to!='' && $to!='00/00/0000')
            {
                $to = str_replace('/', '-',$to);
                $to=date("Y-m-d",strtotime($to));
                $condition.=' AND t.transaction_date<="'.$to.'"';    
            }
            if($product_id>0)
            {
                $condition.=' AND t.product_id='.$product_id;    
            }
            if($salesman >0)
            {
                $condition.=' AND (t.created_by='.$salesman.')';    
            }
            //echo $condition;
            $transaction_view_sql='CREATE OR REPLACE VIEW view_stockledger AS 
                (SELECT SL.id AS sl_id,"Sales Invoice" AS transaction_type,SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number, SL.product_id, SL.customer_vendor_id, SL.created_by, I.invoice_no, C.customer_name, U.full_name, SL.quantity,SL.quantity*SL.unit_exchange_rate as default_qty, SL.outlet,MU.label as unit_label,DU.label as default_unit_label,SL.rate*SL.exchange_rate AS rate 
                    FROM {{stock_ledger}} SL 
                    LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                    LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
                    LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
                    LEFT JOIN {{sales_invoice}} I ON I.id=SL.header_id 
                    LEFT JOIN {{customer}} C ON C.id=SL.customer_vendor_id 
                    LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by WHERE SL.type="SI"
                )
                UNION ALL
                (SELECT SL.id AS sl_id,"Sales Return" AS transaction_type,SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number, SL.product_id, SL.customer_vendor_id, SL.created_by, I.return_no AS invoice_no, C.customer_name, U.full_name, SL.quantity,SL.quantity*SL.unit_exchange_rate as default_qty, SL.outlet,MU.label as unit_label,DU.label as default_unit_label,SL.rate*SL.exchange_rate AS rate 
                    FROM {{stock_ledger}} SL 
                    LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                    LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
                    LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
                    LEFT JOIN {{sales_return}} I ON I.id=SL.header_id 
                    LEFT JOIN {{customer}} C ON C.id=SL.customer_vendor_id 
                    LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by WHERE SL.type="SR")
                UNION ALL
                (SELECT SL.id AS sl_id,"Purchase Invoice" AS transaction_type,SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number, SL.product_id, SL.customer_vendor_id, SL.created_by, I.invoice_no, V.vendor_name AS customer_name, U.full_name, SL.quantity,SL.quantity*SL.unit_exchange_rate as default_qty, SL.outlet,MU.label as unit_label ,DU.label as default_unit_label,SL.rate*SL.exchange_rate AS rate
                    FROM {{stock_ledger}} SL 
                    LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                    LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
                    LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
                    LEFT JOIN {{purchase_invoice}} I ON I.id=SL.header_id 
                    LEFT JOIN {{vendor}} V ON V.id=SL.customer_vendor_id 
                    LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by WHERE SL.type="PI")
                UNION ALL
                (SELECT SL.id AS sl_id,"Purchase Return" AS transaction_type,SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number, SL.product_id, SL.customer_vendor_id, SL.created_by, I.return_no AS invoice_no, V.vendor_name AS customer_name, U.full_name, SL.quantity,SL.quantity*SL.unit_exchange_rate as default_qty, SL.outlet,MU.label as unit_label ,DU.label as default_unit_label,SL.rate*SL.exchange_rate AS rate
                    FROM {{stock_ledger}} SL 
                    LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                    LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
                    LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
                    LEFT JOIN {{sales_return}} I ON I.id=SL.header_id 
                    LEFT JOIN {{vendor}} V ON V.id=SL.customer_vendor_id 
                    LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by WHERE SL.type="PR")
                UNION ALL
                (SELECT SL.id AS sl_id,"Goods Receipt" AS transaction_type, SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number, SL.product_id, SL.customer_vendor_id, SL.created_by, I.receipt_no AS invoice_no, "-" AS customer_name, U.full_name, SL.quantity,SL.quantity*SL.unit_exchange_rate as default_qty, SL.outlet,MU.label as unit_label ,DU.label as default_unit_label,SL.rate*SL.exchange_rate AS rate
                    FROM {{stock_ledger}} SL 
                    LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                    LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
                    LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
                    LEFT JOIN {{goods_receipt}} I ON I.id=SL.header_id 
                    LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by WHERE SL.type="GR")
                UNION ALL
                (SELECT SL.id AS sl_id,"Goods Issue" AS transaction_type, SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number, SL.product_id, SL.customer_vendor_id, SL.created_by, I.issue_no AS invoice_no, "-" AS customer_name, U.full_name, SL.quantity,SL.quantity*SL.unit_exchange_rate as default_qty, SL.outlet,MU.label as unit_label ,DU.label as default_unit_label,SL.rate*SL.exchange_rate AS rate
                    FROM {{stock_ledger}} SL 
                    LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                    LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
                    LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
                    LEFT JOIN {{goods_issue}} I ON I.id=SL.header_id 
                    LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by WHERE SL.type="GI")
                UNION ALL
                (SELECT SL.id AS sl_id,"Goods Transfer IN" AS transaction_type, SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number, SL.product_id, SL.customer_vendor_id, SL.created_by, I.transfer_no AS invoice_no, "-" AS customer_name, U.full_name, SL.quantity,SL.quantity*SL.unit_exchange_rate as default_qty, SL.outlet,MU.label as unit_label ,DU.label as default_unit_label,SL.rate*SL.exchange_rate AS rate
                    FROM {{stock_ledger}} SL 
                    LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                    LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
                    LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
                    LEFT JOIN {{goods_transfer}} I ON I.id=SL.header_id 
                    LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by WHERE SL.type="GT" and SL.transaction_type="IN")
                UNION ALL
                (SELECT SL.id AS sl_id,"Goods Transfer OUT" AS transaction_type, SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number, SL.product_id, SL.customer_vendor_id, SL.created_by, I.transfer_no AS invoice_no, "-" AS customer_name, U.full_name, SL.quantity,SL.quantity*SL.unit_exchange_rate as default_qty, SL.outlet,MU.label as unit_label ,DU.label as default_unit_label,SL.rate*SL.exchange_rate AS rate
                    FROM {{stock_ledger}} SL 
                    LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                    LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
                    LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
                    LEFT JOIN {{goods_transfer}} I ON I.id=SL.header_id 
                    LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by WHERE SL.type="GT" AND SL.transaction_type="OUT")
                UNION ALL
                (SELECT SL.id AS sl_id,"Opening Balance" AS transaction_type, SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number, SL.product_id, SL.customer_vendor_id, SL.created_by, "-" AS invoice_no, "-" AS customer_name, U.full_name, SL.quantity,SL.quantity*SL.unit_exchange_rate as default_qty, SL.outlet,MU.label as unit_label ,DU.label as default_unit_label,SL.rate*SL.exchange_rate AS rate
                    FROM {{stock_ledger}} SL 
                    LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                    LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
                    LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
                    LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by WHERE SL.type="OB")
                UNION ALL
                (SELECT SL.id AS sl_id,"Material to Material Transfer" AS transaction_type, SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number, SL.product_id, SL.customer_vendor_id, SL.created_by, I.conversion_no AS invoice_no, "-" AS customer_name, U.full_name, SL.quantity,SL.quantity*SL.unit_exchange_rate as default_qty, SL.outlet,MU.label as unit_label ,DU.label as default_unit_label,SL.rate*SL.exchange_rate AS rate
                    FROM {{stock_ledger}} SL 
                    LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                    LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
                    LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
                    LEFT JOIN {{material_conversion}} I ON I.id=SL.header_id 
                    LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by WHERE SL.type="MTM")
                UNION ALL
                (SELECT SL.id AS sl_id,"Production" AS transaction_type, SL.transaction_type  as in_out, SL.type,SL.transaction_date,P.part_number, SL.product_id, SL.customer_vendor_id, SL.created_by, I.conversion_no AS invoice_no, "-" AS customer_name, U.full_name, SL.quantity,SL.quantity*SL.unit_exchange_rate as default_qty, SL.outlet,MU.label as unit_label ,DU.label as default_unit_label,SL.rate*SL.exchange_rate AS rate
                    FROM {{stock_ledger}} SL 
                    LEFT JOIN {{inventory}} P ON P.id=SL.product_id 
                    LEFT JOIN {{master_unit}} MU ON MU.id=SL.unit 
                    LEFT JOIN {{master_unit}} DU ON DU.id=SL.default_product_unit 
                    LEFT JOIN {{material_conversion}} I ON I.id=SL.header_id 
                    LEFT JOIN bluesell_new_main.{{users}} U ON U.id=SL.created_by WHERE SL.type="PRO")';
            
            Yii::app()->db->createCommand($transaction_view_sql)->execute(); 
            $transaction_sql = 'SELECT * FROM view_stockledger t 
                    WHERE ' . $condition . ' ORDER BY transaction_date,in_out asc';
            $arr_transactions = Yii::app()->db->createCommand($transaction_sql)->queryAll();
            $open_cond = 'product_id='.$product_id;
            if($outlet>0){
                $open_cond.=" AND t.outlet=".$outlet;
            }
            if($from!='' && $from!='00/00/0000')
            {
                $open_cond.=' AND t.transaction_date<"'.$from.'"';    
            }
            if($salesman >0)
            {
                $open_cond.=' AND (t.created_by='.$salesman.')';    
            }
            $open_bal_in_sql = 'SELECT SUM(default_qty) AS in_qty FROM view_stockledger t 
                    WHERE '.$open_cond.' AND in_out="IN" ';
            $open_bal_out_sql = 'SELECT SUM(default_qty) AS in_qty FROM view_stockledger t 
                    WHERE '.$open_cond.' AND in_out="OUT" ';
            $opening_in_qty = Yii::app()->db->createCommand($open_bal_in_sql)->queryScalar();        
            $opening_out_qty = Yii::app()->db->createCommand($open_bal_out_sql)->queryScalar(); 
            $balance = $opening_in_qty-$opening_out_qty;
                    ?>
            <tr>
                <?php if(Yii::app()->user->user_access_type != 'SL'){ ?>
                <th colspan="9" class="text-right">Opening Balance</th>
                <?php }else { ?>
                <th colspan="8" class="text-right">Opening Balance</th>
                <?php } ?>
                <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($balance,'');?></td>
            </tr>
            
            <?php if(!empty($arr_transactions)){
                foreach ($arr_transactions as $row)
                { 
                    $cost_per_item=$rate_per_item=0;
                    if($row['in_out']=='IN'){
                        $balance+=$row['default_qty'];
                    }else{
                        $balance-=$row['default_qty'];
                    }
                    if($row['type']=='SI'||$row['type']=='SR'||$row['type']=='GR'||$row['type']=='PI'||$row['type']=='PR'){
                    $rate_per_item=$row['rate'];
                    }
                    if($row['type']=='PI'||$row['type']=='PR'||$row['type']=='MTM'){
                        $cost_per_item=$row['rate'];
                    }else{
                        $cost_per_item=StockLedger::getAvgPurchaseRate($row['product_id'],$row['transaction_date'],$outlet);
                    }
                    ?>
                <tr>
                   <td><?php echo date("d/m/Y",strtotime($row['transaction_date']));?></td> 
                   <td><?php echo $row['invoice_no'];?></td> 
                   <td><?php echo $row['transaction_type'];?></td> 
                     <td ><?php echo $row['full_name'];?></td> 
                   <td><?php echo $row['customer_name'];?></td> 
                   <?php if(Yii::app()->user->user_access_type != 'SL'){ ?>
                    <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($cost_per_item,'');?></td>
                   <?php } ?>
                    <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($rate_per_item,'');?></td>
                   <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($row['quantity'],'');?></td> 
                   <td ><?php echo $row['unit_label'];?></td> 
                 
                   <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($balance,'');?></td> 
                    
                </tr>
                <?php } ?>
                <tr>
                    <?php if(Yii::app()->user->user_access_type != 'SL'){ ?>
                        <th colspan="9" class="text-right bg-info">Closing Balance</th>
                <?php }else { ?>
                    <th colspan="8" class="text-right bg-info">Closing Balance</th>
                <?php } ?>
                    <th class="text-right bg-info"><?php echo Yii::app()->numberFormatter->formatCurrency($balance,'');?></th>
                </tr>
            <?php }else{?>
            <tr>
                    <?php if(Yii::app()->user->user_access_type != 'SL'){ ?>
                       <th colspan="10" class="text-center bg-info">No Details Found</th>
                <?php }else { ?>
                    <th colspan="9" class="text-center bg-info">No Details Found</th>
                <?php } ?>
            </tr>
            <?php }?>
        </tbody>
    </table>
</div>