<?php

Yii::setPathOfAlias('bootstrap', dirname(__FILE__) . '/../extensions/bootstrap');
Yii::setPathOfAlias('editable', dirname(__FILE__) . '/../extensions/editable');
return array(
    'basePath' => dirname(__FILE__) . DIRECTORY_SEPARATOR . '..',
    'name' => 'Cumulus ERP',
    'preload' => array('log'),
    // autoloading model and component classes
    'import' => array(
        'application.extensions.*',
        'application.models.*',
        'application.modules.finance.models.*',
        'editable.*',
        'application.components.*',
        'application.extensions.yii-mail.YiiMailMessage',
    ),
    'modules' => array(
        // uncomment the following to enable the Gii tool

        'gii' => array(
            'class' => 'system.gii.GiiModule',
            'password' => '@manu',
            // If removed, Gii defaults to localhost only. Edit carefully to taste.
            'ipFilters' => array('*'),
        ),
        'finance',
    ),
    // application components
    'components' => array(
        'clientScript' => array(
            'packages' => array(
                'jquery' => array(
                    'baseUrl' => '',
                    'js' => array('js/jquery.min.js'),
                    'coreScriptPosition' => CClientScript::POS_HEAD,
                ),
                'jquery.ui' => array(
                    'baseUrl' => '',
                    'js' => array('js/jquery-ui.min.js'),
                    'depends' => array('jquery'),
                    'coreScriptPosition' => CClientScript::POS_END,
                ),
            ),
        ),
        'ePdf' => array(
            'class' => 'ext.yii-pdf.EYiiPdf',
            'params' => array(
                'mpdf' => array(
                    'librarySourcePath' => 'application.vendors.mpdf.*',
                    'constants' => array(
                        '_MPDF_TEMP_PATH' => Yii::getPathOfAlias('application.runtime'),
                    ),
                    'class' => 'mpdf',
                ),
            ),
        ),
        'session' => array(
            'autoStart' => true,
        ),
        'phpThumb' => array(
            'class' => 'ext.EPhpThumb.EPhpThumb',
        ),
        'dateTimePicker' => array(
            'class' => 'ext.CJuiDateTimePicker.CJuiDateTimePicker',
        ),
        'timePicker' => array(
            'class' => 'ext.timepicker.timepicker',
        ),
        'mail' => array(
            'class' => 'application.extensions.yii-mail.YiiMail',
            'transportType' => 'smtp',
            'transportOptions' => array(
                'host' => 'cumuluscrm.us',
                'username' => 'noreply@cumuluscrm.us',
                'password' => 'peterpan122',
                'port' => 25,
            ),
            'viewPath' => 'application.views.mail',
            'logging' => true,
            'dryRun' => false,
        ),
        'user' => array(
            'class' => 'application.components.EWebUser',
            'loginRequiredAjaxResponse' => 'YII_LOGIN_REQUIRED',
            // enable cookie-based authentication
            'allowAutoLogin' => true,
        ),
        // uncomment the following to enable URLs in path-format
        /*  'urlManager' => array(
        'urlFormat' => 'path',
        'showScriptName' => false,
        'caseSensitive' => false,
        'rules' => array(
        '<controller:\w+>/<id:\d+>' => '<controller>/view',
        '<controller:\w+>/<action:\w+>/<id:\d+>' => '<controller>/<action>',
        '<controller:\w+>/<action:\w+>' => '<controller>/<action>',
        ),
        ), */
        /* 'db'=>array(
        'connectionString' => 'sqlite:'.dirname(__FILE__).'/../data/testdrive.db',
        ), */

        // uncomment the following to use a MySQL database
        'db' => array(
            'connectionString' => 'mysql:host=localhost;dbname=bluesell_new_main',
            'emulatePrepare' => true,
            'username' => 'bluesell_newadmn',
            'password' => 'DKe=?ok*+KD}',
            'charset' => 'utf8',
            'tablePrefix' => 'erp_',
        ),
        'db_migrate' => array(
            'class' => 'CDbConnection',
            'connectionString' => 'mysql:host=localhost;dbname=bluesell_new_demo',
            'emulatePrepare' => true,
                    'username' => 'bluesell_newadmn',
            'password' => 'DKe=?ok*+KD}',
            'charset' => 'utf8',
        ),
        'response' => array(
            'connectionString' => 'sqlite:' . dirname(__FILE__) . '/../../app_request.sqlite',
            'class' => 'CDbConnection',
        ),
        'errorHandler' => array(
            // use 'site/error' action to display errors
            'errorAction' => 'site/error',
        ),
        'log' => array(
            'class' => 'CLogRouter',
            'routes' => array(
                array(
                    'class' => 'CFileLogRoute',
                    'levels' => 'error, warning',
                ),
                // uncomment the following to show log messages on web pages
                /* array(
            'class' => 'CWebLogRoute',
            ), */
            ),
        ),
        //X-editable config
        'editable' => array(
            'class' => 'editable.EditableConfig',
            'form' => 'bootstrap', //form style: 'bootstrap', 'jqueryui', 'plain'
            'mode' => 'popup', //mode: 'popup' or 'inline'
            'defaults' => array( //default settings for all editable elements
                'emptytext' => 'Click to edit',
            ),
        ),
        'bootstrap' => array(
            'class' => 'bootstrap.components.Bootstrap',
        ),
    ),
    'params' => array(
        // this is used in contact page
        'adminEmail' => 'admin@cumuluscrm.us',
        'defaultPageSize' => 5,
    ),
    'behaviors' => array(
        'runEnd' => array(
            'class' => 'application.components.WebApplicationEndBehavior',
        ),
    ),
);
