<?php

class AdminController extends Controller {

    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('OutletIndex','GetList', 'Create','SaveOutlet',Upload),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionOutletIndex() {
        $this->render('index');
    }
    /*
     * ajax function to list all outlet datatable
     * modified by jisha on 19-6-20. 
     */

      public function actionGetList() {
        $model  = new MasOutlets();
        $draw   = $_POST['draw'];
        $offset = $_POST['start'];
        $limit  = $_POST['length'];
        $columns = array(
            // datatable column index  => database column name
            0 => 't.id',
            2 => 't.outletname',
            1 => 'companyDetails.name',
            3 => 't.name',
            4 => 't.entry_from',
            5 => 't.notify_days',
            6 => 't.subscription_end_date',
            7 => 't.notify_days',
            8 => 't.id',
            9 => 'is_active'
        );
        $filterColumn   = $columns[$_POST['order'][0]['column']];
        $filterOrder    = $_POST['order'][0]['dir'];
        $orderBy        = $filterColumn . " " . $filterOrder;
        $condition      = '1=1';
        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            //$condition.=" AND (t.full_name LIKE '%" . $searchString . "%' OR t.outletname LIKE '%" . $searchString . "%' OR t.phone_no LIKE '%" . $searchString . "%'  OR outletDetails.outlet_name LIKE '%" . $searchString . "%')";
        }
        if($outlet>0){
            $condition.=" AND t.outlet_id=".$outlet;
        }
        $count          = $model->with('companyDetails')->count(array('condition' => $condition));
        $model          = $model->with('companyDetails')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));
        $recordsTotal   = $count;
        $recordsFiltered        = $count;
        $data['draw']   = $draw;
        $data['recordsTotal']   = $recordsTotal;
        $data['recordsFiltered']= $recordsFiltered;
        $rowData                = array();
        $m=1;
        foreach ($model as $row)
        {
            $div= '';
            if( Yii::app()->user->user_access_type != 'SL'){
                $div= '<div class="text-center"><button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'admin/create&id='.$row['id'].'\',\'Edit - '.trim($row['outlet_name']).'\',\'xl\')"><i class="fa fa-edit" aria-hidden="true"></i></button></div>';
            }
            $d2 = strtotime($row['subscription_end_date']);
            $d1 = strtotime(date('Y-m-d'));
            $datediff = $d2 - $d1;
            $service_days = $datediff / (60*60*24)+1;
            if($service_days<0){
                $bg_color='background-color:red;color:black;width:auto;';
            }else if($service_days<=$row['notify_days']){
                $bg_color='background-color:orange;color:black;width:auto;';
            }else if($service_days>$row['notify_days']){
                $bg_color='background-color:lightgreen;color:black;width:auto;';
            }
            
            $status = "<div class='progress' style='".$bg_color."'>".$service_days."</div>";
            $rowData[]  = array($m,$row['companyDetails']['name'],$row['outlet_name'],$row['name'],date('d/m/Y', strtotime($row['entry_from'])),$row['notify_days'],date('d/m/Y', strtotime($row['subscription_end_date'])),$status,$div,$row['is_active']);
            $m++;
        } 
        $data['data'] = $rowData;
        echo json_encode($data);
    }
    /*
     * function to create outlet details
     * modified by jisha on 19-6-20. 
     */
    public function actionCreate() {
       $id = (int) Yii::app()->request->getParam('id');
        $model = new MasOutlets;
        if ($id > 0) {
            $model = $model->findByPk($id);
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model));
    }
    public function actionSaveOutlet() {
        $model = new MasOutlets();
        $valid = true;$other=array();
        if (isset($_POST['MasOutlets'])) {
            if ($_POST['MasOutlets']['id'] > 0) {
                $id =  $_POST['MasOutlets']['id'];
                $model = $model->findByPK($id);
                $scene = 'update';
            }else{
                $scene = 'new';
            }
            $model->name = $_POST['MasOutlets']['name'];
            $model->outlet_name = $_POST['MasOutlets']['outlet_name'];
            $model->mode = 'SC';
            $model->company_id = $_POST['MasOutlets']['company_id'];
            $model->phone_no = $_POST['MasOutlets']['phone_no'];
            $model->is_active = $_POST['MasOutlets']['is_active'];
            $valid = $model->validate();
            if($valid){
                $model->save();
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
            }else{
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1,$other));
                if ($error != '[]'){
                    echo $error;    
                }
            }
           
        }else{
            echo 'error';
        }
    }
}
