<?php

/**
 * Esell Sales Module
 * Author  : Jisha
 * Created :  27/07/2020
 */
class ApiSaveCashTransferController extends Controller {

    public $method = '_stream';
    public $round_off = '2';
    public $db_main = MasCompany::MAIN_DB;
    public $outlet_id;
    public $responseBody = array(
        'status' => 'success',
        'msg' => '',
        'count' => 0,
        'data' => array(),
    );
    public $permissions = array(
        'view_cost_price' => true,
    );

    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array("index"),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array(),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    public function save_request($request) {
        // if ($request != '') {
        //     Yii::app()->response->createCommand("INSERT INTO response (app_response) VALUES('" . $request . "')")->execute();
        // }
        return true;
    }

    public function get_401() {
        header("HTTP/1.1 401 Unauthorized");
        header('Content-Type: application/json');
        $this->responseBody['status'] = 'failed';
        $this->responseBody['msg'] = 'Unauthorized user';
        echo json_encode($this->responseBody);
    }

    public function get_400() {
        header("HTTP/1.1 400 Bad Request");
        header('Content-Type: application/json');
        echo json_encode($this->responseBody);
    }

    public function get_403() {
        header("HTTP/1.1 403  Forbidden");
        header('Content-Type: application/json');
        $this->responseBody['status'] = 'failed';
        $this->responseBody['msg'] = 'Forbidden user';
        echo json_encode($this->responseBody);
    }

    public function get_bind() {
        header("HTTP/1.1 200 OK");
        header('Content-Type: application/json');
        echo json_encode($this->responseBody);
    }

    public function format_currency($value) {
        return number_format(round((float) $value, $this->round_off), $this->round_off, '.', '');
    }

    public function get_set_permissions() {
        $this->responseBody['permissions']['have_purchase'] = true;
        $this->responseBody['permissions']['consider_min_sales_price'] = true;
        $this->responseBody['permissions']['have_financial_reports'] = true;
        $this->responseBody['permissions']['have_stock_adjustment'] = true;
        $this->responseBody['permissions']['view_cost_price'] = $this->permissions['view_cost_price'];
    }

    public function convert_date($date = null) {

        $date_converted = date('Y-m-d');

        if ($date != null) {
            //yyyy-mm-dd
            $arr_date = explode('-', $date);
            //mm/dd/yyyy
            if (checkdate($arr_date[1], $arr_date[2], $arr_date[0])) {
                $date_converted = date('Y-m-d', strtotime(str_replace('/', '-', $date)));
            }
        }
        return $date_converted;
    }
 
    public function connectMainDB($company_db_name) {
        Yii::app()->db->setActive(false);
        if (empty($company_db_name)) {
            $company_db_name = '=bluesell_new_main';
        }
        Yii::app()->db->connectionString = 'mysql:host=e-sell.me;dbname=bluesell_new_main';
        Yii::app()->db->username = 'bluesell_newadmn';
        Yii::app()->db->password = 'DKe=?ok*+KD}';
        Yii::app()->db->tablePrefix = 'erp_';
        Yii::app()->db->setActive(true);
    }
 
    
    
    public function actionIndex()
    {
        $other = array();
        $currency = 1;
        $exchange_rate = 1;
        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);
        $userModel = MasUsers::model()->findBytoken($token);

        $input = file_get_contents('php://input');
        $variables = json_decode($input, true);
        
         $transfer_date = trim($variables['transfer_date']);
         $amount = (float) trim($variables['amount']);
    if($userModel->id>0)
    {
    $userModel->db();     
    if($transfer_date=='')
    {
    $other[] = 'Please choose transfer date';      
    }
    if((float)$amount==0)
    {
    $other[] = 'Please check the amounts';        
    }
    
    function savableDate( $date ){
    $last_closed_year = FinanceAuditClose::lastClosed();
    $voucherDate_array = explode('-', $date);
    $voucherYear = $voucherDate_array[0];
    return ( $voucherYear <= $last_closed_year ) ? false : true;
    }
    if(savableDate($transfer_date)!=true)
    {
    $other[] = 'Year closed';    
    }
    $cash=FinanceSystemAccountsMapping::getSystemdefault('cash_account');
    $balance=Yii::app()->db->createCommand("select SUM(amount) AS amount from {{finance_voucher_items}} AS I LEFT JOIN {{finance_voucher_head}} AS H ON I.header_id=H.id where H.is_posted='Y' AND I.ledger_id=".$cash." AND H.outlet=".$userModel->outlet_id." AND H.created_by=".$userModel->id)->queryScalar();
    if($balance<$amount)
    {
    $other[] = 'Insufficient balance';    
    }
    if(empty($other))
    {  
    $model= new FinanceVoucherHead;
//    $model->voucher_type=21;
    $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="CAT" AND outlet='.$userModel->outlet_id))->id;
    $model->voucher_type=$vouchertype;
    $model->voucher_no = FinanceVoucherType::getVoucherno( $model->voucher_type, true);
    $model->voucher_date= (count(explode('/', $transfer_date)) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $transfer_date))) : date('Y-m-d');
    $model->due_date= (count(explode('/', $transfer_date)) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $transfer_date))) : date('Y-m-d');
    $model->total_voucher_amount=$amount;
//    $model->general_narration='Cash Transfer to Admin';
    $model->general_narration='Cash Transfer from '.$userModel->full_name.' to Admin';
    $model->is_posted='Y';
    $model->created_by=$userModel->id;
    $model->created_datetime = date('Y-m-d h:i:s');
    $model->outlet=$userModel->outlet_id;
    $model->save();
    $modelItems=new FinanceVoucherItems;    
    $modelItems->header_id=$model->id;
    $modelItems->ledger_id=FinanceSystemAccountsMapping::getSystemdefault('cash_account');
//    $modelItems->narration='Cash Transfer to Admin';
    $modelItems->narration='Cash Transfer from '.$userModel->full_name.' to Admin';
    $modelItems->amount=-($amount);
    $modelItems->currency_code=1;
    $modelItems->currency_id=1;
    $modelItems->exchange_rate=1;
    $modelItems->outlet=$userModel->outlet_id;
    $modelItems->save(false);
    // Debit Side
    $modelItems=new FinanceVoucherItems;    
    $modelItems->header_id=$model->id;
    $modelItems->ledger_id=FinanceSystemAccountsMapping::getSystemdefault('cash_transfer');
//    $modelItems->narration='Cash Transfer to Admin';
    $modelItems->narration='Cash Transfer from '.$userModel->full_name.' to Admin';
    $modelItems->amount=$amount;
    $modelItems->currency_code=1;
    $modelItems->currency_id=1;
    $modelItems->exchange_rate=1;
    $modelItems->outlet=$userModel->outlet_id;
    $modelItems->save(false);
    // Cash Transfer Account
    $model= new FinanceVoucherHead;
    $model->voucher_type=21;
    $model->voucher_no = FinanceVoucherType::getVoucherno( $model->voucher_type, true);
    $model->voucher_date= (count(explode('/', $transfer_date)) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $transfer_date))) : date('Y-m-d');
    $model->due_date= (count(explode('/', $transfer_date)) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $transfer_date))) : date('Y-m-d');
    $model->total_voucher_amount=$amount;
//    $model->general_narration='Cash Transfer to Admin';
    $model->general_narration='Cash Transfer from '.$userModel->full_name.' to Admin';
    $model->is_posted='Y';
    $model->created_by=MasUsers::get_outlet_admin($userModel->outlet_id);
    $model->created_datetime = date('Y-m-d h:i:s');
    $model->outlet=$userModel->outlet_id;
    $model->save();
    $modelItems=new FinanceVoucherItems;    
    $modelItems->header_id=$model->id;
    $modelItems->ledger_id=FinanceSystemAccountsMapping::getSystemdefault('cash_transfer');
//    $modelItems->narration='Cash Transfer to Admin';
    $modelItems->narration='Cash Transfer from '.$userModel->full_name.' to Admin';
    $modelItems->amount=-($amount);
    $modelItems->currency_code=1;
     $modelItems->currency_id=1;
    $modelItems->exchange_rate=1;
    $modelItems->outlet=$userModel->outlet_id;
    $modelItems->save(false);
    // Debit Side
    $modelItems=new FinanceVoucherItems;    
    $modelItems->header_id=$model->id;
    $modelItems->ledger_id=FinanceSystemAccountsMapping::getSystemdefault('cash_account');
//    $modelItems->narration='Cash Transfer to Admin';
    $modelItems->narration='Cash Transfer from '.$userModel->full_name.' to Admin';
    $modelItems->amount=$amount;
    $modelItems->currency_code=1;
     $modelItems->currency_id=1;
    $modelItems->exchange_rate=1;
    $modelItems->outlet=$userModel->outlet_id;
    $modelItems->save(false);
    
    $this->responseBody['status'] = 'success';
    $this->responseBody['voucher_id'] = $model->id;
    $this->_bind;
    }
    else {
            //$error = CJSON::encode(array_merge_recursive($other));
            $err_msg = implode(',', $other);
            $this->responseBody['msg'] = $err_msg;
            $this->responseBody['status'] = 'failed';
            $this->_400;
        }
    } 
    else {
    $this->responseBody['msg'] = 'Unauthorized user';
    $this->responseBody['status'] = 'failed';
        }
    }


}