<?php

/**
 * Esell Sales Module
 * Author  : Jisha
 * Created :  27/07/2020
 */
class ApiSavePaymentController extends Controller {

    public $method = '_stream';
    public $round_off = '2';
    public $db_main = MasCompany::MAIN_DB;
    public $outlet_id;
    public $responseBody = array(
        'status' => 'success',
        'msg' => '',
        'count' => 0,
        'data' => array(),
    );
    public $permissions = array(
        'view_cost_price' => true,
    );

    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('Savepayment'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array(),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    public function save_request($request) {
        // if ($request != '') {
        //     Yii::app()->response->createCommand("INSERT INTO response (app_response) VALUES('" . $request . "')")->execute();
        // }
        return true;
    }

    public function get_401() {
        header("HTTP/1.1 401 Unauthorized");
        header('Content-Type: application/json');
        $this->responseBody['status'] = 'failed';
        $this->responseBody['msg'] = 'Unauthorized user';
        echo json_encode($this->responseBody);
    }

    public function get_400() {
        header("HTTP/1.1 400 Bad Request");
        header('Content-Type: application/json');
        echo json_encode($this->responseBody);
    }

    public function get_403() {
        header("HTTP/1.1 403  Forbidden");
        header('Content-Type: application/json');
        $this->responseBody['status'] = 'failed';
        $this->responseBody['msg'] = 'Forbidden user';
        echo json_encode($this->responseBody);
    }

    public function get_bind() {
        header("HTTP/1.1 200 OK");
        header('Content-Type: application/json');
        echo json_encode($this->responseBody);
    }

    public function format_currency($value) {
        return number_format(round((float) $value, $this->round_off), $this->round_off, '.', '');
    }

    public function get_set_permissions() {
        $this->responseBody['permissions']['have_purchase'] = true;
        $this->responseBody['permissions']['consider_min_sales_price'] = true;
        $this->responseBody['permissions']['have_financial_reports'] = true;
        $this->responseBody['permissions']['have_stock_adjustment'] = true;
        $this->responseBody['permissions']['view_cost_price'] = $this->permissions['view_cost_price'];
    }

    public function convert_date($date = null) {

        $date_converted = date('Y-m-d');

        if ($date != null) {
            //yyyy-mm-dd
            $arr_date = explode('-', $date);
            //mm/dd/yyyy
            if (checkdate($arr_date[1], $arr_date[2], $arr_date[0])) {
                $date_converted = date('Y-m-d', strtotime(str_replace('/', '-', $date)));
            }
        }
        return $date_converted;
    }
 
    public function connectMainDB($company_db_name) {
        Yii::app()->db->setActive(false);
        if (empty($company_db_name)) {
            $company_db_name = '=bluesell_new_main';
        }
        Yii::app()->db->connectionString = 'mysql:host=e-sell.me;dbname=bluesell_new_main';
        Yii::app()->db->username = 'bluesell_newadmn';
        Yii::app()->db->password = 'DKe=?ok*+KD}';
        Yii::app()->db->tablePrefix = 'erp_';
        Yii::app()->db->setActive(true);
    }
  
   
    
    
    public function actionSavepayment() 
    {

    $other = array();   
    $currency=1;
    $exchange_rate=1;
    function savableDate( $date ){
    $last_closed_year = FinanceAuditClose::lastClosed();
    $voucherDate_array = explode('-', $date);
    $voucherYear = $voucherDate_array[0];
    return ( $voucherYear <= $last_closed_year ) ? false : true;
    }
        $token = filter_var($_SERVER['HTTP_TOKEN'], FILTER_SANITIZE_STRING);
        $userModel = MasUsers::model()->findBytoken($token);

        $input = file_get_contents('php://input');
        $variables = json_decode($input, true);
        
        
//        $myfile = fopen("payment_file.txt", "w") or die("Unable to open file!");
//        $txt = "json data $variables\n";
//        fwrite($myfile, $txt);
//        fclose($myfile);
        
        
        $payment_date = trim($variables['payment_date']);
        $payment_ledger = (int) trim($variables['payment_ledger']);
//        $mode_of_payment = trim($variables['mode']);
        $mode_of_payment = 'ca';
        $vendor = (int) trim($variables['ledger_id']);
        $id = (int) trim($variables['id']);
        $cheque_no = trim($variables['cheque_no']);
        $issued_date = trim($variables['issued_date']);
        $narration = trim($variables['narration']);
        $items = $variables['items'];
        if(trim($payment_date)=='')
        {
        $other[] = 'Please choose payment date ';     
        }
        if ($userModel->id > 0) {

            $userModel->db();

            $invoice = new PurchaseInvoice;
            if ($id > 0) {
            $invoice = $invoice->findBypk($id);
            }
            $total_amount=0;
            $total_received=0;
            $total_discount=0;
            foreach ($items as $each)
            {
            $total_received+=$each['allocated'];    
            $total_discount+=$each['discount'];
            }
            $total_amount=$total_received+$total_discount;
            if((float)$total_amount==0)
            {
            $other[] = 'Please check the amounts';        
            }
            if((int)$vendor==0)
            {
            $other[] = 'Please choose supplier';      
            }
            $model = new FinanceVoucherHead;
            $model->general_narration=$narration;
            $model->is_posted = 'Y';
            $model->created_by = $userModel->id;
            $model->created_datetime = date('Y-m-d h:i:s');
            $model->outlet = $userModel->outlet_id;
            $model->voucher_date = $payment_date;
            $model->due_date = $payment_date;
            $savableVoucher = savableDate($model->voucher_date);
            $voucherType =  FinanceVoucherType::getApiVoucherId("PV",$userModel->outlet_id);
            $model->total_voucher_amount = $total_amount;
            $voucherModel = FinanceVoucherType::model()->findBypk( (int) $voucherType );
            $model->voucher_type = $voucherType;
            $model->voucher_no = $voucherModel->last_voucher_no+1;
            switch($mode_of_payment)
            {
                case 'ca':
                {
                 $model->payment_method=1;    
                 break;
                }
                case 'chq':
                {
                $model->payment_method=2;    
                if(trim($issued_date)=='')
                {
                $other[] = 'Please choose cheque date ';     
                }
                if(trim($cheque_no)=='')
                {
                $cheque_no[] = 'Please add cheque number';      
                }
                 break;
                }
                case 'ba':
                {
                 $model->payment_method=3;    
                 break;
                }
                case 'cc':
                {
                 $model->payment_method=4;    
                 break;
                }
            }
            if( $model->payment_method == 4 ) //card
            $model->scenario = 'card';
            else if($model->payment_method == 2){ //cheque
            $model->scenario = 'chequepaid';
            $model->realisation_date = ( count( explode('/', $issued_date) ) == 3 ) ? date('Y-m-d', strtotime( str_replace('/', '-', $issued_date) )) : date('Y-m-d');
            $model->cheque_date = ( count( explode('/', $issued_date) ) == 3 ) ? date('Y-m-d', strtotime( str_replace('/', '-', $issued_date) )) : date('Y-m-d');
            $model->cheque_cleared = 'N';
            } else if($model->payment_method == 3)
            { 
            //Bank
            $model->scenario = 'bank'; 
            }else 
            { //Cash
            $model->scenario = 'cash';
            }
            $model->total_voucher_amount=$total_amount;
            if($savableVoucher!=true)
            {
            $other[] = 'Year Closed';    
            }
            if(empty($other))
            {
                $model->is_allocated='Y';
                $model->save(false);
                $voucherModel->last_voucher_no+=1;
                $voucherModel->save();
                $modelItems = new FinanceVoucherItems;
                $modelItems->outlet = $userModel->outlet_id;
                $modelItems->header_id = $model->id;
                switch($mode_of_payment)
                {
                case 'ca':
                {
                $modelItems->ledger_id=FinanceSystemAccountsMapping::getSystemdefault('cash_account'); 
                break;
                }
                case 'chq':
                {
                $modelItems->ledger_id=FinanceSystemAccountsMapping::getSystemdefault('pdc_i');    
                break;
                }
                case 'ba':
                {
                $modelItems->ledger_id=FinanceSystemAccountsMapping::getSystemdefault('bank');    
                break;
                }
                case 'cc':
                {
                $modelItems->ledger_id=FinanceSystemAccountsMapping::getSystemdefault('bank');      
                break;
                }
                }	
            $subledger=FinanceSubledger::model()->find(array('condition'=>'subledger_type_id=2 AND parent_id='.$vendor))->id;
            $modelItems->narration = $narration;
            $modelItems->amount = -1*$total_received;
            $modelItems->currency_id=$currency;
            $modelItems->exchange_rate=$exchange_rate;
            $modelItems->save(false);
            
            $modelItemsDiscount = new FinanceVoucherItems;
            $modelItemsDiscount->outlet = $userModel->outlet_id;
            $modelItemsDiscount->header_id = $model->id;
            $modelItemsDiscount->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('discount_allowed');
            $modelItemsDiscount->narration = $narration;
            $modelItemsDiscount->amount = -1*$total_discount;
            $modelItemsDiscount->currency_id=$currency;
            $modelItemsDiscount->exchange_rate=$exchange_rate;
            $modelItemsDiscount->save(false);
            
            $modelItemsCreditor = new FinanceVoucherItems;
            $modelItemsCreditor->outlet = $userModel->outlet_id;
            $modelItemsCreditor->header_id = $model->id;
            $modelItemsCreditor->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('creditors');
            $modelItemsCreditor->scenario = 'havesubledger';
            $modelItemsCreditor->subledger_id = $subledger;
            $modelItemsCreditor->narration = $narration;
            $modelItemsCreditor->amount = $total_amount;
            $modelItemsCreditor->currency_id=$currency;
            $modelItemsCreditor->exchange_rate=$exchange_rate;
            $modelItemsCreditor->save(false);

            $modelAllocation = new FinanceAllocation;
            $modelAllocation->allocation_date = date('Y-m-d');
            $modelAllocation->ledger_id=FinanceSystemAccountsMapping::getSystemdefault('creditors');  
            $modelAllocation->subledger_id=$subledger;
            $modelAllocation->amount=abs($total_amount);
            $modelAllocation->outlet=$userModel->outlet_id;
            $modelAllocation->created_by = $userModel->id;
            $modelAllocation->created_date_time = date('Y-m-d h:i:s');
            $modelAllocation->save();
            foreach ($items as $each)
            {
             if ($each['allocated'] != 0) 
             {
             $debitAllocation = new FinanceAllocationItems;
             $debitAllocation->header_id = $modelAllocation->id;
             $debitAllocation->voucher_id = $each['voucher_id'];
             $debitAllocation->voucher_item_id = $each['voucher_item_id'];
             $debitAllocation->amount = -1*($each['allocated']+$each['discount']);
             $debitAllocation->outlet = $userModel->outlet_id;
             $debitAllocation->save();
             }  
            }
            $creditAllocation = new FinanceAllocationItems;
            $creditAllocation->header_id = $modelAllocation->id;
            $creditAllocation->voucher_id = $model->id;
            $creditAllocation->voucher_item_id = $modelItemsCreditor->id;
            $creditAllocation->amount = $total_amount;
            $creditAllocation->outlet = $userModel->outlet_id;
            $creditAllocation->save();
            $this->responseBody['status'] = 'success';
            $this->responseBody['voucher_id'] = $model->id;
            $this->responseBody['type'] = 'payment';
            $this->_bind;
            }
            else {
            //$error = CJSON::encode(array_merge_recursive($other));
            $err_msg = implode(',', $other);
            $this->responseBody['msg'] = $err_msg;
            $this->responseBody['status'] = 'failed';
            $this->_400;
            }
        } else {
            $this->_401;
        }
    }

}