<?php
class ConfigController extends Controller
{
    public function accessRules()
    {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array(
                    'outletlist', 'Outletlist_data', 'Create_outlet', 'Saveoutlet', 'companyadminlist', 'Adminlist',
                    'Create_user', 'Saveuser', 'Salesmanlist', 'Getsalesmans', 'Company', 'Savecompany', 'Upload',
                    'Outletlist_dev', 'Migrate_data', 'Vendor_fields', 'Import_data', 'Get_company_outlets', 'Get_outlet_users',
                    'Customer_fields', 'Generic_fields', 'Product_fields', 'Purchase_fields', 'Import_vouchers', 'Purchase_rtns_fields', 'BuildChildren', 'BuildRoute', 'updateLevelLedgers', 'FixEntries'
                ),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function beforeAction($action)
    {
        if (isset(Yii::app()->user->is_valid_login) && !Yii::app()->user->is_valid_login) {
            $this->redirect('index.php?r=site/payments');
        }
        if (Yii::app()->request->isAjaxRequest) {
            $this->layout = false;
        }

        return parent::beforeAction($action);
    }

    public function actionOutletlist()
    {
        $this->render('outlets');
    }

    public function actionOutletlist_data()
    {

        $model = new MasOutlets();
        $draw = $_POST['draw'];
        $offset = $_POST['start'];
        $limit = $_POST['length'];

        $condition = '1=1';
        if (Yii::app()->user->user_access_type == 'SU')
            $condition .= ' AND company_id=' . Yii::app()->user->company_id;

        $count = $model->count(array('condition' => $condition));
        $model = $model->findAll(array('limit' => $limit, 'condition' => $condition, 'offset' => $offset, 'order' => 'subscription_end_date ASC'));

        $data['draw'] = $draw;
        $data['recordsTotal'] = $count;
        $data['recordsFiltered'] = $count;
        $rowData = array();

        foreach ($model as $row) {
            $div = '<button class="btn btn-theme btn-xs" title="Edit" onclick="loadPopupModal(\'config/create_outlet&id=' . $row['id'] . '\',\' ' . $row['name'] . ' \',\'lg\')"><i class="fa fa-edit"></i></button>';
            $eachRow = $_POST['dev'] ? array($row['name'], date('d/m/Y', strtotime($row['subscription_end_date'])), $row['activation_code'], '<div class="btn-wrap text-center">' . $div . '</div>') : array($row['name'], date('d/m/Y', strtotime($row['subscription_end_date'])), '<div class="btn-wrap text-center">' . $div . '</div>');

            $rowData[] = $eachRow;
        }
        $data['data'] = $rowData;
        echo json_encode($data);
    }

    public function actionCreate_outlet()
    {
        $id = (int) $_GET['id'];
        $model = new MasOutlets();

        if ($id > 0) {
            $model = $model->findBypk($id);
        }

        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.min.js' => false);
        $this->render('create_outlet', array('model' => $model));
    }

    public function actionSaveoutlet()
    {
        $model = new MasOutlets;
        if ($_POST['MasOutlets']['id'] > 0) {
            $model = $model->findBypk($_POST['MasOutlets']['id']);
        }

        $model->attributes = $_POST['MasOutlets'];
        $model->bank_details =  $_POST['MasOutlets']['bank_details'];
        $model->company_id = Yii::app()->user->company_id;
        if ($model->validate()) {
            $new_record = $model->isNewRecord;
            if ($new_record) {
                $model->entry_from = date('Y-m-d');
                $model->subscription_end_date = date('Y-m-d');
                $model->generate_activation_code();
            }

            $model->save();
            if ($new_record) {
                // $model->generate_related_party();
                $model->generate_users();
            }
            echo json_encode(array('status' => 'success'));
        } else {
            echo CActiveForm::validate($model, '', false);
        }
    }

    public function actionCompanyadminlist()
    {
        $this->render('company_admins');
    }

    public function actionAdminlist()
    {

        $model = new MasUsers();
        $draw = $_POST['draw'];
        $offset = $_POST['start'];
        $limit = $_POST['length'];

        $count = $model->count(array('condition' => 'access_type="CA" AND outlet_id=' . (int) Yii::app()->user->outlet_id));
        $model = $model->findAll(array('condition' => 'access_type="CA" AND outlet_id=' . (int) Yii::app()->user->outlet_id, 'limit' => $limit, 'offset' => $offset, 'order' => 'full_name ASC'));

        $data['draw'] = $draw;
        $data['recordsTotal'] = $count;
        $data['recordsFiltered'] = $count;
        $rowData = array();

        foreach ($model as $row) {
            $div = '<button class="btn btn-theme btn-xs" title="Edit" onclick="loadPopupModal(\'config/create_user&type=admin&id=' . $row['id'] . '\',\' ' . $row['full_name'] . ' \',\'lg\')"><i class="fa fa-edit"></i></button>';
            $eachRow = array($row['full_name'], $row['username'], $row['phone_no'], '<div class="btn-wrap text-center">' . $div . '</div>');

            $rowData[] = $eachRow;
        }
        $data['data'] = $rowData;
        echo json_encode($data);
    }

    public function actionCreate_user()
    {
        $id = (int) $_GET['id'];
        $type = $_GET['type'];
        $model = new MasUsers();

        if ($id > 0) {
            $model = $model->findBypk($id);
        }
        $model->access_type = $type == 'admin' ? 'CA' : 'SL';
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.min.js' => false);
        $this->render('create_user', array('model' => $model, 'type' => $type));
    }

    public function actionSaveuser()
    {
        $model = new MasUsers;
        if ($_POST['MasUsers']['id'] > 0) {
            $model = $model->findBypk($_POST['MasUsers']['id']);
        }

        $model->attributes = $_POST['MasUsers'];
        $model->hide_finance = $_POST['MasUsers']['hide_finance'];

        $model->outlet_id = Yii::app()->user->outlet_id;
        $model->company_id = Yii::app()->user->company_id;
        $password = trim($_POST['MasUsers']['password']);
        if ($password != '') {
            $model->password = crypt($password, $password);
        }
        if ($model->isNewRecord) {
            $model->scenario = 'new_user';
        }

        if ($model->validate()) {
            $model->save();
            $model->get_generate_token();
            echo json_encode(array('status' => 'success'));
        } else {
            echo CActiveForm::validate($model, '', false);
        }
    }

    public function actionSalesmanlist()
    {
        $this->render('salesmen');
    }

    public function actionGetsalesmans()
    {

        $model = new MasUsers();
        $draw = $_POST['draw'];
        $offset = $_POST['start'];
        $limit = $_POST['length'];

        $count = $model->count(array('condition' => 'access_type="SL" AND outlet_id=' . (int) Yii::app()->user->outlet_id));
        $model = $model->findAll(array('condition' => 'access_type="SL" AND outlet_id=' . (int) Yii::app()->user->outlet_id, 'limit' => $limit, 'offset' => $offset, 'order' => 'full_name ASC'));

        $data['draw'] = $draw;
        $data['recordsTotal'] = $count;
        $data['recordsFiltered'] = $count;
        $rowData = array();

        foreach ($model as $row) {
            $div = '<button class="btn btn-theme btn-xs" title="Edit" onclick="loadPopupModal(\'config/create_user&type=salesman&id=' . $row['id'] . '\',\' ' . $row['full_name'] . ' \',\'lg\')"><i class="fa fa-edit"></i></button>';
            $eachRow = array($row['full_name'], $row['username'], $row['phone_no'], '<div class="btn-wrap text-center">' . $div . '</div>');

            $rowData[] = $eachRow;
        }
        $data['data'] = $rowData;
        echo json_encode($data);
    }

    public function actionCompany()
    {
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.min.js' => false);
        $this->render('company_properties');
    }

    public function actionSavecompany()
    {
        $model = new MasCompany;
        if ($_POST['MasCompany']['id'] > 0) {
            $model = $model->findBypk($_POST['MasCompany']['id']);
        }

        $model->attributes = $_POST['MasCompany'];
        if ($model->validate()) {
            $model->save();
            echo json_encode(array('status' => 'success'));
        } else {
            echo CActiveForm::validate($model, '', false);
        }
    }

    public function actionOutletlist_dev()
    {
        $this->render('outlets_dev');
    }

    public function actionMigrate_data()
    {
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.min.js' => false);
        $this->render('migrate_data');
    }

    public function getFields($table)
    {
        $fields = array();
        $mysql_fields = Yii::app()->db_migrate->createCommand('SHOW COLUMNS FROM ' . $table)->queryAll();
        foreach ($mysql_fields as $each) {
            $fields[$each['Field']] = $each['Field'];
        }
        return $fields;
    }

    public function actionVendor_fields()
    {
        $fields = $_POST['table_name'] != '' ? $this->getFields($_POST['table_name']) : array();
        echo json_encode(array(
            'key_field' => CHtml::dropdownlist('vendor_primary_in', '', $fields, array('data-label' => 'Primary Key')),
            'name_field' => CHtml::dropdownlist('vendor_name_in', '', $fields, array('data-label' => 'Vendor Name')),
            'trn_field' => CHtml::dropdownlist('vendor_trn_in', '', $fields, array('data-label' => 'Vendor TRN', 'prompt' => 'Select')),
            'phone_field' => CHtml::dropdownlist('vendor_phone_in', '', $fields, array('data-label' => 'Vendor Phone', 'prompt' => 'Select')),
            'address_field' => CHtml::dropdownlist('vendor_adds_in', '', $fields, array('data-label' => 'Vendor Adds', 'prompt' => 'Select')),
        ));
    }

    public function actionCustomer_fields()
    {
        $fields = $_POST['table_name'] != '' ? $this->getFields($_POST['table_name']) : array();
        echo json_encode(array(
            'key_field' => CHtml::dropdownlist('customer_primary_in', '', $fields, array('data-label' => 'Primary Key')),
            'name_field' => CHtml::dropdownlist('customer_name_in', '', $fields, array('data-label' => 'Customer Name')),
            'trn_field' => CHtml::dropdownlist('customer_trn_in', '', $fields, array('data-label' => 'Customer TRN', 'prompt' => 'Select')),
            'phone_field' => CHtml::dropdownlist('customer_phone_in', '', $fields, array('data-label' => 'Customer Phone', 'prompt' => 'Select')),
            'address_field' => CHtml::dropdownlist('customer_adds_in', '', $fields, array('data-label' => 'Customer Adds', 'prompt' => 'Select')),
        ));
    }

    public function actionImport_data()
    {
        set_time_limit(0);

        $type = $_POST['type'];
        $company_id = $_POST['company_id'];
        $user_id = $_POST['user_id'];
        $outlet_id = $_POST['outlet_id'];

        $table = $_POST['table_name'];
        $primary_key = $_POST['primary_key'];

        $have_more = false;
        $records_imported = '';

        if ($type == 'vendor') {

            $name = $_POST['name_field'];
            $vendor_trn = $_POST['vendor_trn'];
            $vendor_phone = $_POST['vendor_phone'];
            $vendor_address = $_POST['vendor_address'];

            if ($name != '' && $primary_key != '') {

                //Fields
                $fields = array($primary_key, $name);
                //Limit
                $limit = 20;

                if ($vendor_trn != '') {
                    $fields[] = $vendor_trn;
                }

                if ($vendor_phone != '') {
                    $fields[] = $vendor_phone;
                }

                if ($vendor_address != '') {
                    $fields[] = $vendor_address;
                }

                $existing_fields = $this->getFields($table);
                //Update column
                if (!in_array('migrated_esell', $existing_fields)) {
                    Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $table . '  ADD migrated_esell ENUM("Y","N") NOT NULL DEFAULT "N"  AFTER ' . $primary_key)->execute();
                }
                if (!in_array('esell_ref', $existing_fields)) {
                    Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $table . '  ADD esell_ref INT NOT NULL AFTER migrated_esell')->execute();
                }

                $vendors = Yii::app()->db_migrate->createCommand('SELECT ' . implode(',', $fields) . ' FROM ' . $table . ' WHERE migrated_esell="N" AND ' . $name . '!="" LIMIT ' . $limit)->queryAll();

                foreach ($vendors as $each) {
                    $model = new MasLedgers;
                    $model->ledger_type = 'vendors';
                    $model->ledger_data['name'] = $each[$name];
                    $model->ledger_data['alias'] = $each[$name];
                    $model->ledger_data['phone_no'] = $each[$vendor_phone];
                    $model->ledger_data['trn_no'] = $each[$vendor_trn];
                    $model->ledger_data['billing_address'] = $each[$vendor_address];
                    $model->ledger_data['country'] = 1;
                    $model->ledger_data['currency'] = 1;
                    $model->ledger_data['emirate'] = 3;
                    $model->ledger_data['credit_limit'] = 0;
                    $model->ledger_data['payment_term'] = 30;
                    $model->company_id = $company_id;
                    $model->outlet_id = $outlet_id;
                    $model->user_id = $user_id;

                    $validaionResponse = $model->validate_ledger_data();
                    if ($validaionResponse['valid']) {
                        $model->inherit_parent();
                        $model->save(false);
                        // $model->reset_levels();

                        Yii::app()->db_migrate->createCommand('UPDATE ' . $table . ' SET migrated_esell = "Y", esell_ref="' . $model->id . '" WHERE ' . $primary_key . ' = ' . $each[$primary_key])->execute();
                    }
                }

                $all = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $primary_key . ') AS count_of FROM ' . $table)->queryScalar();
                $imported = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $primary_key . ') AS count_of FROM ' . $table . ' WHERE migrated_esell="Y"')->queryScalar();

                $have_more = $all - $imported > 0 ? true : false;
                $records_imported = $imported . ' out of ' . $all . ' are imported';
            }
        } else if ($type == 'customer') {

            $name = $_POST['name_field'];
            $customer_trn = $_POST['customer_trn'];
            $customer_phone = $_POST['customer_phone'];
            $customer_address = $_POST['customer_address'];

            if ($name != '' && $primary_key != '') {

                //Fields
                $fields = array($primary_key, $name);
                //Limit
                $limit = 20;

                if ($customer_trn != '') {
                    $fields[] = $customer_trn;
                }

                if ($customer_phone != '') {
                    $fields[] = $customer_phone;
                }

                if ($customer_address != '') {
                    $fields[] = $customer_address;
                }

                $existing_fields = $this->getFields($table);
                //Update column
                if (!in_array('migrated_esell', $existing_fields)) {
                    Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $table . '  ADD migrated_esell ENUM("Y","N") NOT NULL DEFAULT "N"  AFTER ' . $primary_key)->execute();
                }
                if (!in_array('esell_ref', $existing_fields)) {
                    Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $table . '  ADD esell_ref INT NOT NULL AFTER migrated_esell')->execute();
                }

                $vendors = Yii::app()->db_migrate->createCommand('SELECT ' . implode(',', $fields) . ' FROM ' . $table . ' WHERE migrated_esell="N" AND ' . $name . '!="" LIMIT ' . $limit)->queryAll();

                foreach ($vendors as $each) {
                    $model = new MasLedgers;
                    $model->ledger_type = 'customers';
                    $model->ledger_data['name'] = $each[$name];
                    $model->ledger_data['alias'] = $each[$name];
                    $model->ledger_data['phone_no'] = $each[$customer_phone];
                    $model->ledger_data['trn_no'] = $each[$customer_trn];
                    $model->ledger_data['billing_address'] = $each[$customer_address];
                    $model->ledger_data['country'] = 1;
                    $model->ledger_data['currency'] = 1;
                    $model->ledger_data['emirate'] = 3;
                    $model->ledger_data['credit_limit'] = 0;
                    $model->ledger_data['payment_term'] = 30;
                    $model->company_id = $company_id;
                    $model->outlet_id = $outlet_id;
                    $model->user_id = $user_id;

                    $validaionResponse = $model->validate_ledger_data();
                    if ($validaionResponse['valid']) {
                        $model->inherit_parent();
                        $model->save(false);
                        // $model->reset_levels();

                        Yii::app()->db_migrate->createCommand('UPDATE ' . $table . ' SET migrated_esell = "Y", esell_ref="' . $model->id . '" WHERE ' . $primary_key . ' = ' . $each[$primary_key])->execute();
                    }
                }

                $all = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $primary_key . ') AS count_of FROM ' . $table)->queryScalar();
                $imported = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $primary_key . ') AS count_of FROM ' . $table . ' WHERE migrated_esell="Y"')->queryScalar();

                $have_more = $all - $imported > 0 ? true : false;
                $records_imported = $imported . ' out of ' . $all . ' are imported';
            }
        } else if ($type == 'generic') {

            $name = $_POST['name_field'];

            if ($name != '' && $primary_key != '') {

                //Fields
                $fields = array($primary_key, $name);
                //Limit
                $limit = 5;

                $existing_fields = $this->getFields($table);
                //Update column
                if (!in_array('migrated_esell', $existing_fields)) {
                    Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $table . '  ADD migrated_esell ENUM("Y","N") NOT NULL DEFAULT "N"  AFTER ' . $primary_key)->execute();
                }
                if (!in_array('esell_ref', $existing_fields)) {
                    Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $table . '  ADD esell_ref INT NOT NULL AFTER migrated_esell')->execute();
                }

                $groups = Yii::app()->db_migrate->createCommand('SELECT ' . implode(',', $fields) . ' FROM ' . $table . ' WHERE migrated_esell="N" AND ' . $name . '!="" LIMIT ' . $limit)->queryAll();

                foreach ($groups as $each) {
                    $model = new MasLedgers;
                    $model->ledger_type = 'product_group';
                    $model->ledger_data['parent_id'] = 3; //Default - inventory
                    $model->ledger_data['name'] = $each[$name];
                    $model->company_id = $company_id;
                    $model->outlet_id = $outlet_id;

                    $validaionResponse = $model->validate_ledger_data();
                    if ($validaionResponse['valid']) {
                        $model->is_parent = 'Y';
                        $model->inherit_parent();
                        $model->save(false);
                        // $model->reset_levels();

                        Yii::app()->db_migrate->createCommand('UPDATE ' . $table . ' SET migrated_esell = "Y", esell_ref="' . $model->id . '" WHERE ' . $primary_key . ' = ' . $each[$primary_key])->execute();
                    }
                }

                $all = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $primary_key . ') AS count_of FROM ' . $table)->queryScalar();
                $imported = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $primary_key . ') AS count_of FROM ' . $table . ' WHERE migrated_esell="Y"')->queryScalar();

                $have_more = $all - $imported > 0 ? true : false;
                $records_imported = $imported . ' out of ' . $all . ' are imported';
            }
        } else if ($type == 'product') {

            $name = $_POST['name_field'];
            $description_field = $_POST['description_field'];
            $generic_field = $_POST['generic_field'];
            $generic_table = $_POST['generic_table'];
            $generic_key = $_POST['generic_key'];
            $defaultGeneric = 35; //None

            if ($name != '' && $primary_key != '' && $description_field != '') {

                //Limit
                $limit = 50;

                $existing_fields = $this->getFields($table);
                //Update column
                if (!in_array('migrated_esell', $existing_fields)) {
                    Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $table . '  ADD migrated_esell ENUM("Y","N") NOT NULL DEFAULT "N"  AFTER ' . $primary_key)->execute();
                }
                if (!in_array('esell_ref', $existing_fields)) {
                    Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $table . '  ADD esell_ref INT NOT NULL AFTER migrated_esell')->execute();
                }

                //Fields
                $fields = array($primary_key, $name, $description_field);
                if ($generic_field != '' && $generic_table != '') {
                    $fields[] = $generic_field;
                    $query = 'CREATE OR REPLACE VIEW
                                product_master AS
                                    SELECT
                                        S.' . $primary_key . ' AS product_id,
                                        G.' . $generic_key . ' AS generic_id,
                                        IFNULL(G.esell_ref, ' . $defaultGeneric . ') AS generic_ref,
                                        S.' . $name . ' AS name, S.' . $description_field . ' AS description
                                    FROM ' . $table . ' S
                                LEFT JOIN ' . $generic_table . ' G ON S.' . $generic_field . ' = G.' . $generic_key . ' WHERE S.migrated_esell="N" LIMIT ' . $limit;
                } else {
                    $query = 'CREATE OR REPLACE VIEW
                                product_master AS
                                    SELECT
                                        S.' . $primary_key . ' AS product_id,
                                        0 AS generic_id,
                                        ' . $defaultGeneric . ' AS generic_ref,
                                        S.' . $name . ' AS name, S.' . $description_field . ' AS description
                                    FROM ' . $table . ' S WHERE S.migrated_esell="N" LIMIT ' . $limit;
                }
                Yii::app()->db_migrate->createCommand($query)->execute();
                $products = Yii::app()->db_migrate->createCommand('SELECT * FROM product_master LIMIT ' . $limit)->queryAll();

                foreach ($products as $each) {
                    $model = new MasLedgers;
                    $model->ledger_type = 'inventory';
                    $model->ledger_data['name'] = $each['name'];
                    $model->ledger_data['alias'] = $each['description'];
                    $model->ledger_data['min_sales_rate'] = 0;
                    $model->ledger_data['default_sales_rate'] = 0;
                    $model->ledger_data['discount_percentage'] = 0;
                    $model->ledger_data['uom'] = 1; //Each
                    $model->ledger_data['tax_percentage'] = 1; //5% VAT
                    $model->ledger_data['product_group'] = (int) $each['generic_ref'] > 0 ? $each['generic_ref'] : $defaultGeneric;
                    $model->ledger_data['parent_id'] = (int) $each['generic_ref'] > 0 ? $each['generic_ref'] : $defaultGeneric;
                    $model->goods_or_service = 'G';
                    $model->company_id = $company_id;
                    $model->outlet_id = $outlet_id;
                    $model->user_id = $user_id;

                    $validaionResponse = $model->validate_ledger_data();
                    if ($validaionResponse['valid']) {
                        $model->inherit_parent();
                        $model->save(false);
                        //$model->reset_levels();

                        Yii::app()->db_migrate->createCommand('UPDATE ' . $table . ' SET migrated_esell = "Y", esell_ref="' . $model->id . '" WHERE ' . $primary_key . ' = ' . (int) $each['product_id'])->execute();
                    }
                }

                $all = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $primary_key . ') AS count_of FROM ' . $table)->queryScalar();
                $imported = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $primary_key . ') AS count_of FROM ' . $table . ' WHERE migrated_esell="Y"')->queryScalar();

                $have_more = $all - $imported > 0 ? true : false;
                $records_imported = $imported . ' out of ' . $all . ' are imported';
            }
        }
        echo json_encode(array('have_more' => $have_more, 'records_imported' => $records_imported));
    }

    public function actionGet_company_outlets()
    {
        echo CHtml::dropdownlist('outlet_id', '', MasOutlets::get_company_outlets((int) $_POST['company_id']), array('data-label' => 'Outlet', 'prompt' => 'Select', 'onChange' => 'js:get_users(this.value)'));
    }

    public function actionGet_outlet_users()
    {
        $array_of_data = MasOutlets::allusers((int) $_POST['outlet_id']);
        echo json_encode(array(
            'user_drop' => CHtml::dropdownlist('user_id', '', $array_of_data, array('data-label' => 'User')),
            'count' => count($array_of_data),
        ));
    }

    public function actionGeneric_fields()
    {
        $fields = $_POST['table_name'] != '' ? $this->getFields($_POST['table_name']) : array();
        echo json_encode(array(
            'key_field' => CHtml::dropdownlist('generic_primary_in', '', $fields, array('data-label' => 'Primary Key')),
            'name_field' => CHtml::dropdownlist('generic_name_in', '', $fields, array('data-label' => 'Group Name')),
        ));
    }

    public function actionProduct_fields()
    {
        $fields = $_POST['table_name'] != '' ? $this->getFields($_POST['table_name']) : array();
        echo json_encode(array(
            'key_field' => CHtml::dropdownlist('product_primary_in', '', $fields, array('data-label' => 'Primary Key')),
            'name_field' => CHtml::dropdownlist('product_name_in', '', $fields, array('data-label' => 'Part No')),
            'description_field' => CHtml::dropdownlist('product_description_in', '', $fields, array('data-label' => 'Description')),
            'generic_field' => CHtml::dropdownlist('product_generic_in', '', $fields, array('data-label' => 'Product Group', 'prompt' => 'Select')),
        ));
    }

    public function actionPurchase_fields()
    {
        $type = $_POST['type'];
        $fields = $_POST['table_name'] != '' ? $this->getFields($_POST['table_name']) : array();
        echo $type == 1 ? json_encode(array(
            'key_field' => CHtml::dropdownlist('purchase_primary_in', '', $fields, array('data-label' => 'Primary Key')),
            'date_field' => CHtml::dropdownlist('purchase_date_in', '', $fields, array('data-label' => 'Purchase Date')),
            'vendor_field' => CHtml::dropdownlist('purchase_vendor_in', '', $fields, array('data-label' => 'Purchase Vendor')),
            'invoice_no_field' => CHtml::dropdownlist('purchase_invno_in', '', $fields, array('data-label' => 'Purchase Inv No')),
            'old_invoice_field' => CHtml::dropdownlist('purchase_oldinvno_in', '', $fields, array('data-label' => 'Purchase Vdr Inv No')),
            'taxable_field' => CHtml::dropdownlist('purchase_taxable_in', '', $fields, array('data-label' => 'Taxable(Y/N)')),
        )) : json_encode(array(
            'key_field' => CHtml::dropdownlist('pur_product_primary_in', '', $fields, array('data-label' => 'Foreign Key')),
            'product_field' => CHtml::dropdownlist('pur_product_id_in', '', $fields, array('data-label' => 'Product Id')),
            'quantity_field' => CHtml::dropdownlist('pur_qty_in', '', $fields, array('data-label' => 'Quantity')),
            'rate_field' => CHtml::dropdownlist('pur_rate_in', '', $fields, array('data-label' => 'Rate')),
            'discount_field' => CHtml::dropdownlist('pur_disc_in', '', $fields, array('data-label' => 'Discount')),
        ));
    }

    public function actionImport_vouchers()
    {
        set_time_limit(0);

        $type = $_POST['type'];
        $company_id = $_POST['company_id'];
        $user_id = $_POST['user_id'];
        $outlet_id = $_POST['outlet_id'];

        if ($type == 'purchase') {

            //Queries used
            //ALTER TABLE `crm_direct_purchase_order_general` ADD `is_taxable` ENUM('Y','N') NOT NULL DEFAULT 'Y' AFTER `invoice_type`;
            //UPDATE  crm_direct_purchase_order_general SET is_taxable = 'N' WHERE invoice_type = 4

            $head_table = $_POST['head_table_name'];
            $head_table_primary = $_POST['head_primary_key'];
            $date_field = $_POST['date_field'];
            $vendor_field = $_POST['vendor_field'];
            $invoice_no_field = $_POST['invoice_no_field'];
            $old_invoice_field = $_POST['old_invoice_field'];
            $taxable_field = $_POST['taxable_field'];
            $vendor_table = $_POST['vendor_table'];
            $vendor_primary = $_POST['vendor_primary'];
            $products_table = $_POST['products_table'];
            $product_primary = $_POST['product_primary'];

            $item_table_name = $_POST['item_table_name'];
            $item_foreign_key = $_POST['item_foreign_key'];
            $product_field = $_POST['product_field'];
            $quantity_field = $_POST['quantity_field'];
            $rate_field = $_POST['rate_field'];
            $discount_field = $_POST['discount_field'];

            //limit
            $limit = 100;

            //Head table
            $existing_fields_head = $this->getFields($head_table);
            if (!in_array('migrated_esell', $existing_fields_head)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $head_table . '  ADD migrated_esell ENUM("Y","N") NOT NULL DEFAULT "N"  AFTER ' . $head_table_primary)->execute();
            }
            if (!in_array('esell_ref', $existing_fields_head)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $head_table . '  ADD esell_ref INT NOT NULL AFTER migrated_esell')->execute();
            }

            //Item table
            $existing_fields_items = $this->getFields($item_table_name);
            if (!in_array('migrated_esell', $existing_fields_items)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $item_table_name . '  ADD migrated_esell ENUM("Y","N") NOT NULL DEFAULT "N"  AFTER ' . $item_foreign_key)->execute();
            }
            if (!in_array('esell_ref', $existing_fields_items)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $item_table_name . '  ADD esell_ref INT NOT NULL AFTER migrated_esell')->execute();
            }

            Yii::app()->db_migrate->createCommand('CREATE OR REPLACE VIEW purchase_master AS SELECT
                                                        PI.' . $head_table_primary . ' AS head_id,
                                                        PI.' . $invoice_no_field . ' AS invoice_no,
                                                        PI.' . $old_invoice_field . ' AS vendor_invoice,
                                                        PI.' . $date_field . ' AS date,
                                                        V.esell_ref AS vendor_id,
                                                        PI.is_taxable,
                                                        S.esell_ref AS product_id,
                                                        II.' . $quantity_field . ' AS quantity,
                                                        II.' . $rate_field . ' AS rate,
                                                        II.' . $discount_field . ' AS discount_value,
                                                        II.id AS item_key
                                                  FROM ' . $item_table_name . ' II
                                                  LEFT JOIN ' . $head_table . ' PI ON PI.' . $head_table_primary . ' = II.' . $item_foreign_key . '
                                                  LEFT JOIN ' . $vendor_table . ' V ON V.' . $vendor_primary . ' = PI.' . $vendor_field . '
                                                  LEFT JOIN ' . $products_table . ' S ON S.' . $product_primary . ' = II.' . $product_field . '
                                                  WHERE PI.migrated_esell="N"
                                                  ORDER BY PI.' . $date_field . ', PI.' . $invoice_no_field . ' ASC')->execute();

            $purchases = Yii::app()->db_migrate->createCommand('SELECT head_id, invoice_no, vendor_invoice, date, vendor_id, is_taxable FROM purchase_master GROUP BY head_id LIMIT ' . $limit)->queryAll();
            foreach ($purchases as $eachHead) {
                $items = Yii::app()->db_migrate->createCommand('SELECT item_key, product_id, quantity, rate, discount_value FROM purchase_master WHERE head_id=' . (int) $eachHead['head_id'])->queryAll();

                $haveDebitnote = Yii::app()->db_migrate->createCommand('SELECT COUNT(id) As count_of FROM crm_purchasing_debit_note WHERE purchasing_order_id=' . (int) $eachHead['head_id'])->queryScalar() > 0 ? true : false;

                $model = new MasVouchers;
                $model->type = 1; //Purchase
                $model->company_id = $company_id;
                $model->outlet_id = $outlet_id;
                $model->user_id = $user_id;
                $model->party_ledger = $eachHead['vendor_id'];
                $model->date = $eachHead['date'];
                $model->due_date = $eachHead['date'];
                $model->payment_terms = 0;
                $model->reference_no = $eachHead['vendor_invoice'];
                $model->is_taxable = $eachHead['is_taxable'];
                $model->is_posted = "Y";
                $model->entries_from = 'app';
                $model->update_voucher_no();
                $model->save();

                //Temporary
                $model->billing_address = $model->partyDetails->billing_address;
                $model->update();

                $i = 0;
                $total_vat = 0;
                $grand_total = 0;

                foreach ($items as $each) {
                    if ($each['product_id'] > 0) {

                        $productModel = MasLedgers::model()->findBypk($each['product_id']);

                        $item = new MasTransactions;
                        $item->ledger_id = $each['product_id'];
                        $item->ledger_name = $productModel->name;
                        $item->description = $productModel->alias;
                        $item->goods_service = $productModel->goods_or_service;
                        $item->quantity = (float) $each['quantity'];
                        $item->rate = (float) $each['rate'];
                        $item->uom = $productModel->uom;
                        $item->currency_id = MasCurrency::getBase_currency();
                        $item->exchange_rate = MasCurrency::getBase_ex_rate();
                        $item->entry_type = 'INV';
                        //Amount
                        $amount = round(((float) $each['quantity'] * (float) $each['rate']), 2);
                        $item->discount_percentage = $each['discount_value'];
                        $item->discount_value = $each['discount_value'];
                        $item->tax_percentage = $productModel->taxDetails->percentage . '%';
                        $item->tax_value = $model->is_taxable == 'Y' ? round((($amount * $productModel->taxDetails->percentage) / 100), 2) : 0;
                        $item->amount = $amount;
                        $item->voucher_id = $model->id;
                        $item->save(false);

                        if ($haveDebitnote) {
                            Yii::app()->db_migrate->createCommand('UPDATE ' . $item_table_name . ' SET migrated_esell = "Y", esell_ref="' . $item->id . '" WHERE id = ' . (int) $each['item_key'])->execute();
                        }

                        $total_vat += (float) $item->tax_value;
                        $grand_total += ((float) $item->tax_value + (float) $item->amount);
                    }
                }

                if ($total_vat > 0) {
                    $vatModel = new MasTransactions;
                    $vatModel->voucher_id = $model->id;
                    $vatModel->ledger_id = MasLedgers::model()->get_parent_id(MasLedgers::PURCHASE_VAT);
                    $vatModel->entry_type = 'IVAT';
                    $vatModel->amount = $total_vat;
                    $vatModel->currency_id = MasCurrency::getBase_currency();
                    $vatModel->exchange_rate = MasCurrency::getBase_ex_rate();
                    $vatModel->save(false);
                }

                if ($grand_total > 0) {
                    $creditorEntry = new MasTransactions;
                    $creditorEntry->voucher_id = $model->id;
                    $creditorEntry->ledger_id = $eachHead['vendor_id'];
                    $creditorEntry->entry_type = 'CRE';
                    $creditorEntry->amount = -1 * $grand_total;
                    $creditorEntry->currency_id = MasCurrency::getBase_currency();
                    $creditorEntry->exchange_rate = MasCurrency::getBase_ex_rate();
                    $creditorEntry->save(false);
                }

                Yii::app()->db_migrate->createCommand('UPDATE ' . $head_table . ' SET migrated_esell = "Y", esell_ref="' . $model->id . '" WHERE ' . $head_table_primary . ' = ' . (int) $eachHead['head_id'])->execute();
            }

            $all = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $head_table_primary . ') AS count_of FROM ' . $head_table)->queryScalar();
            $imported = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $head_table_primary . ') AS count_of FROM ' . $head_table . ' WHERE migrated_esell="Y"')->queryScalar();

            $have_more = $all - $imported > 0 ? true : false;
            $records_imported = $imported . ' out of ' . $all . ' are imported';
        } else if ($type == 'purchase_return') {

            $head_table = 'crm_purchasing_debit_note';
            $item_table_name = 'crm_purchasing_debit_note_item';
            $head_table_primary = 'id';
            $item_foreign_key = 'purchasing_debitnote_id';

            //limit
            $limit = 10;

            //Head table
            $existing_fields_head = $this->getFields($head_table);
            if (!in_array('migrated_esell', $existing_fields_head)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $head_table . '  ADD migrated_esell ENUM("Y","N") NOT NULL DEFAULT "N"  AFTER ' . $head_table_primary)->execute();
            }
            if (!in_array('esell_ref', $existing_fields_head)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $head_table . '  ADD esell_ref INT NOT NULL AFTER migrated_esell')->execute();
            }

            //Item table
            $existing_fields_items = $this->getFields($item_table_name);
            if (!in_array('migrated_esell', $existing_fields_items)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $item_table_name . '  ADD migrated_esell ENUM("Y","N") NOT NULL DEFAULT "N"  AFTER ' . $item_foreign_key)->execute();
            }
            if (!in_array('esell_ref', $existing_fields_items)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $item_table_name . '  ADD esell_ref INT NOT NULL AFTER migrated_esell')->execute();
            }

            Yii::app()->db_migrate->createCommand('CREATE OR REPLACE VIEW purchase_return_master AS
                                                        SELECT
                                                            DN.id AS head_id,
                                                            PI.esell_ref AS parent_invoice,
                                                            DN.debit_note_no, DN.debited_date,
                                                            PI.is_taxable,
                                                            V.esell_ref AS vendor_id,
                                                            II.esell_ref AS parent_invoice_item,
                                                            S.esell_ref AS product_id,
                                                            DI.returned_quantity AS quantity,
                                                            II.rate,
                                                            DI.id AS item_key
                                                        FROM crm_purchasing_debit_note_item DI
                                                        LEFT JOIN crm_purchasing_debit_note DN ON DN.id = DI.purchasing_debitnote_id
                                                        LEFT JOIN crm_direct_purchase_order_items II ON II.id = DI.purchasing_materialreceipt_id
                                                        LEFT JOIN crm_direct_purchase_order_general PI ON PI.id = II.purchase_order_id
                                                        LEFT JOIN crm_store S ON S.id = DI.product_id
                                                        LEFT JOIN crm_vendor V ON V.id = DN.vendor_id
                                                    WHERE PI.esell_ref > 0 AND DN.migrated_esell="N" ORDER BY DN.debited_date ASC')->execute();

            $returns = Yii::app()->db_migrate->createCommand('SELECT * FROM purchase_return_master GROUP BY head_id LIMIT ' . $limit)->queryAll();
            foreach ($returns as $eachHead) {

                $invoiceModel = MasVouchers::model()->findBypk($eachHead['parent_invoice']);
                $items_response = Yii::app()->db_migrate->createCommand('SELECT * FROM purchase_return_master WHERE head_id=' . (int) $eachHead['head_id'])->queryAll();

                $model = new MasVouchers;
                $model->type = 2; //Debitnote
                $model->company_id = $company_id;
                $model->outlet_id = $outlet_id;
                $model->user_id = $user_id;
                $model->party_ledger = $invoiceModel->party_ledger;
                $model->date = $debitnote_date;
                $model->due_date = $debitnote_date;
                $model->payment_terms = 0;
                $model->return_parent = $invoiceModel->id;
                $model->reference_no = $invoiceModel->reference_no;
                $model->billing_address = $invoiceModel->billing_address;
                $model->is_taxable = $invoiceModel->is_taxable;
                $model->is_posted = "Y";
                $model->entries_from = 'app';
                $model->update_voucher_no();
                $model->save(false);

                $total_vat = 0;
                $grand_total = 0;

                foreach ($items_response as $each) {
                    if ($each['quantity'] > 0) {
                        $invoiceitemModel = MasTransactions::model()->findBypk((int) $each['parent_invoice_item']);

                        $item = new MasTransactions;
                        $item->ledger_id = $invoiceitemModel->ledger_id;
                        $item->description = $invoiceitemModel->description;
                        $item->quantity = -1 * $each['quantity'];
                        $item->rate = $invoiceitemModel->rate;
                        $item->uom = $invoiceitemModel->uom;
                        $item->description = $invoiceitemModel->description;
                        $item->returns_parent_id = $invoiceitemModel->id;
                        $item->voucher_id = 0;
                        $item->currency_id = $invoiceModel->voucher_currency;
                        $item->exchange_rate = $invoiceModel->voucher_exchange_rate;
                        $item->entry_type = 'INV';
                        $item->amount = round(((float) $each['quantity'] * (float) $invoiceitemModel->rate), 2);

                        if ($invoiceitemModel->discount_value > 0) {
                            $is_percentage = strpos($invoiceitemModel->discount_percentage, '%') !== false ? true : false;
                            $percentage = str_replace('%', '', $invoiceitemModel->discount_percentage);
                            if (!$is_percentage) {
                                $amount = abs($invoiceitemModel->quantity) * $invoiceitemModel->rate;
                                $ratio = $invoiceitemModel->discount_value / $amount;
                                $percentage = (round($ratio, 10) * 100);
                            }
                            $item->discount_percentage = $percentage . '%';
                            $item->discount_value = round(($item->amount * (float) $percentage), 2);
                            $item->amount -= $item->discount_value;
                        }

                        $item->tax_percentage = $invoiceitemModel->tax_percentage;
                        $item->tax_value = $invoiceModel->is_taxable == 'Y' ? round((($item->amount * $item->tax_percentage) / 100), 2) : 0;
                        $item->amount = -1 * $item->amount;
                        $item->voucher_id = $model->id;
                        $item->save(false);

                        $total_vat += (float) $item->tax_value;
                        $grand_total += abs($item->amount);
                        $grand_total += $item->tax_value;
                    }
                }

                if ($total_vat > 0) {
                    $vatModel = new MasTransactions;
                    $vatModel->voucher_id = $model->id;
                    $vatModel->ledger_id = MasLedgers::model()->get_parent_id(MasLedgers::PURCHASE_VAT);
                    $vatModel->entry_type = 'IVAT';
                    $vatModel->amount = -1 * $total_vat;
                    $vatModel->currency_id = $invoiceModel->voucher_currency;
                    $vatModel->exchange_rate = $invoiceModel->voucher_exchange_rate;
                    $vatModel->save(false);
                }

                if ($grand_total > 0) {
                    $creditorEntry = new MasTransactions;
                    $creditorEntry->voucher_id = $model->id;
                    $creditorEntry->ledger_id = $invoiceModel->party_ledger;
                    $creditorEntry->entry_type = 'CRE';
                    $creditorEntry->amount = $grand_total;
                    $creditorEntry->currency_id = $invoiceModel->voucher_currency;
                    $creditorEntry->exchange_rate = $invoiceModel->voucher_exchange_rate;
                    $creditorEntry->save(false);
                }

                Yii::app()->db_migrate->createCommand('UPDATE ' . $head_table . ' SET migrated_esell = "Y", esell_ref="' . $model->id . '" WHERE ' . $head_table_primary . ' = ' . (int) $eachHead['head_id'])->execute();
            }

            $all = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $head_table_primary . ') AS count_of FROM ' . $head_table)->queryScalar();
            $imported = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $head_table_primary . ') AS count_of FROM ' . $head_table . ' WHERE migrated_esell="Y"')->queryScalar();

            $have_more = $all - $imported > 0 ? true : false;
            $records_imported = $imported . ' out of ' . $all . ' are imported';
        } else if ($type == 'goods_receipt') {
            $head_table = 'crm_inventory_goods_receipt';
            $item_table_name = 'crm_inventory_goods_receipt_item';
            $head_table_primary = 'id';
            $item_foreign_key = 'inventory_goods_receipt_id';

            //limit
            $limit = 10;

            //Head table
            $existing_fields_head = $this->getFields($head_table);
            if (!in_array('migrated_esell', $existing_fields_head)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $head_table . '  ADD migrated_esell ENUM("Y","N") NOT NULL DEFAULT "N"  AFTER ' . $head_table_primary)->execute();
            }
            if (!in_array('esell_ref', $existing_fields_head)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $head_table . '  ADD esell_ref INT NOT NULL AFTER migrated_esell')->execute();
            }

            Yii::app()->db_migrate->createCommand('CREATE OR REPLACE VIEW goods_receipt_master AS
                                                    SELECT
                                                        G.id AS head_id,
                                                        G.goods_receipt_date,
                                                        S.esell_ref AS product_id,
                                                        S.description AS description,
                                                        GI.picked_qty AS quantity
                                                    FROM crm_inventory_goods_receipt_item GI
                                                    LEFT JOIN crm_inventory_goods_receipt G ON G.id = GI.inventory_goods_receipt_id
                                                    LEFT JOIN crm_store S ON S.id = GI.product_id
                                                    WHERE G.migrated_esell="N" ORDER BY G.goods_receipt_date ASC')->execute();

            $items = Yii::app()->db_migrate->createCommand('SELECT * FROM goods_receipt_master GROUP BY head_id LIMIT ' . $limit)->queryAll();
            foreach ($items as $eachHead) {
                $totalCost = 0;
                $all_items = Yii::app()->db_migrate->createCommand('SELECT * FROM goods_receipt_master WHERE head_id=' . (int) $eachHead['head_id'])->queryAll();

                $model = new MasVouchers;
                $model->type = 3; //Goods Receipt
                $model->company_id = $company_id;
                $model->outlet_id = $outlet_id;
                $model->user_id = $user_id;
                $model->date = $eachHead['goods_receipt_date'];
                $model->due_date = $eachHead['goods_receipt_date'];
                $model->other_references = 'Migrated';
                $model->is_posted = 'Y';
                $model->entries_from = 'app';
                $model->update_voucher_no();
                $model->save(false);

                foreach ($all_items as $each) {
                    $item = new MasTransactions;
                    $item->ledger_id = $each['product_id'];
                    $item->description = $each['description'];
                    $item->uom = 1;
                    $item->quantity = round((float) $each['quantity'], 2);

                    $cost_rate = MasLedgers::cost_rate_on_date_user($model->date, $item->ledger_id, array((int) $model->id), false, $user_id);
                    $item->rate = round((float) $cost_rate, 2);

                    $item->amount = round(((float) $item->quantity * $item->rate), 2);
                    $item->currency_id = MasCurrency::getBase_currency();
                    $item->exchange_rate = MasCurrency::getBase_ex_rate();
                    $item->entry_type = 'INV';
                    $item->voucher_id = $model->id;
                    $item->save(false);

                    $totalCost += $item->amount;
                }

                if ($totalCost > 0) {
                    $openingModel = new MasTransactions;
                    $openingModel->voucher_id = $model->id;
                    $openingModel->ledger_id = MasLedgers::model()->get_parent_id(MasLedgers::PL_OPENING);
                    $openingModel->entry_type = 'OSTK';
                    $openingModel->amount = -1 * $totalCost;
                    $openingModel->currency_id = MasCurrency::getBase_currency();
                    $openingModel->exchange_rate = MasCurrency::getBase_ex_rate();
                    $openingModel->save(false);
                }

                Yii::app()->db_migrate->createCommand('UPDATE ' . $head_table . ' SET migrated_esell = "Y", esell_ref="' . $model->id . '" WHERE ' . $head_table_primary . ' = ' . (int) $eachHead['head_id'])->execute();
            }

            $all = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $head_table_primary . ') AS count_of FROM ' . $head_table)->queryScalar();
            $imported = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $head_table_primary . ') AS count_of FROM ' . $head_table . ' WHERE migrated_esell="Y"')->queryScalar();

            $have_more = $all - $imported > 0 ? true : false;
            $records_imported = $imported . ' out of ' . $all . ' are imported';
        } else if ($type == 'sales') {

            $head_table = 'crm_direct_order';
            $item_table_name = 'crm_direct_order_item';
            $head_table_primary = 'id';
            $item_foreign_key = 'order_id';

            //limit
            $limit = 100;

            //Head table
            $existing_fields_head = $this->getFields($head_table);
            if (!in_array('migrated_esell', $existing_fields_head)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $head_table . '  ADD migrated_esell ENUM("Y","N") NOT NULL DEFAULT "N"  AFTER ' . $head_table_primary)->execute();
            }
            if (!in_array('esell_ref', $existing_fields_head)) {
                Yii::app()->db_migrate->createCommand('ALTER TABLE ' . $head_table . '  ADD esell_ref INT NOT NULL AFTER migrated_esell')->execute();
            }

            // /ALTER TABLE `crm_direct_order` ADD `is_taxable` ENUM('Y','N') NOT NULL DEFAULT 'Y' AFTER `invoice_type`;
            Yii::app()->db_migrate->createCommand('CREATE OR REPLACE VIEW sales_master AS SELECT 
                                                    I.id AS head_id, 
                                                    I.order_date, 
                                                    I.invoice_no, 
                                                    C.esell_ref AS customer_id, 
                                                    I.is_taxable, 
                                                    S.esell_ref As product_id,
                                                    S.description AS description,
                                                    II.quantity, 
                                                    II.rate, 
                                                    II.deduction_amount 
                                                FROM crm_direct_order_item II 
                                                LEFT JOIN crm_direct_order I ON I.id = II.order_id 
                                                LEFT JOIN crm_customer C ON C.id = I.customer_id 
                                                LEFT JOIN crm_store S ON S.id =II.product_id
                                                WHERE I.migrated_esell="N" ORDER BY I.order_date ASC')->execute();

            $items = Yii::app()->db_migrate->createCommand('SELECT * FROM sales_master GROUP BY head_id LIMIT ' . $limit)->queryAll();
            foreach ($items as $eachHead) {
                $all_items = Yii::app()->db_migrate->createCommand('SELECT * FROM sales_master WHERE head_id=' . (int) $eachHead['head_id'])->queryAll();

                $model = new MasVouchers;
                $model->type = 4; //Sales
                $model->company_id = $company_id;
                $model->outlet_id = $outlet_id;
                $model->user_id = $user_id;
                $model->party_ledger = $eachHead['customer_id'];
                $model->date = $eachHead['order_date'];
                $model->due_date = $eachHead['order_date'];
                $model->payment_terms = 0;
                $model->reference_no = $eachHead['invoice_no'];
                $model->is_taxable = $eachHead['is_taxable'];
                $model->is_posted = "Y";
                $model->entries_from = 'app';
                $model->update_voucher_no();
                $model->save(false);


                $i = 0;
                $total_vat = 0;
                $grand_total = 0;
                $total_sales = 0;
                $total_discount = 0;
                $cost_of_goods = 0;

                foreach ($all_items as $each) {
                    if ($each['product_id'] > 0) {

                        $productModel = MasLedgers::model()->findBypk($each['product_id']);

                        $item = new MasTransactions;
                        $item->ledger_id = $each['product_id'];
                        $item->ledger_name = $productModel->name;
                        $item->description = $productModel->alias;
                        $item->goods_service = $productModel->goods_or_service;
                        $item->quantity = -1 * (float) $each['quantity'];
                        $item->rate = (float) $each['rate'];
                        $item->uom = $productModel->uom;
                        $item->currency_id = MasCurrency::getBase_currency();
                        $item->exchange_rate = MasCurrency::getBase_ex_rate();
                        $item->entry_type = 'INV';
                        //Amount
                        $amount = round(((float) $each['quantity'] * (float) $each['rate']), 2);

                        if ($each['deduction_amount'] > 0) {
                            $item->discount_percentage = (float) $each['deduction_amount'];
                            $item->discount_value = (float) $each['deduction_amount'];
                            $amount -= $item->discount_value;
                        }
                        $item->tax_percentage = $productModel->taxDetails->percentage . '%';
                        $item->tax_value = $taxable ? round((($amount * $productModel->taxDetails->percentage) / 100), 2) : 0;
                        $item->voucher_id = $model->id;
                        //Cost rate
                        $exchange_rate = MasCurrency::getBase_ex_rate();
                        $cost_rate_bc = MasLedgers::cost_rate_on_date_app($model->date, $item->ledger_id, array((int) $model->id), false, $user_id);
                        $cost_rate = round(($cost_rate_bc / $exchange_rate), 4);

                        $total_cost = round((abs($item->quantity) * $cost_rate), 2);
                        $item->amount = -1 * $total_cost;
                        $item->save(false);

                        //COGS
                        $cost_of_goods += $total_cost;

                        $total_vat += (float) $item->tax_value;
                        $grand_total += (float) $item->tax_value;
                        $grand_total += (float) $amount;
                        $total_sales += round(((float) $each['quantity'] * (float) $each['rate']), 2);
                        $total_discount += (float) $item->discount_value;
                    }
                }

                if ($total_vat > 0) {
                    $vatModel = new MasTransactions;
                    $vatModel->voucher_id = $model->id;
                    $vatModel->ledger_id = MasLedgers::model()->get_parent_id(MasLedgers::SALES_VAT);
                    $vatModel->entry_type = 'OVAT';
                    $vatModel->amount = -1 * $total_vat;
                    $vatModel->currency_id = MasCurrency::getBase_currency();
                    $vatModel->exchange_rate = MasCurrency::getBase_ex_rate();
                    $vatModel->save(false);
                }

                if ($total_sales > 0) {
                    $salesModel = new MasTransactions;
                    $salesModel->voucher_id = $model->id;
                    $salesModel->ledger_id = MasLedgers::model()->get_parent_id(MasLedgers::SALES);
                    $salesModel->entry_type = 'SALE';
                    $salesModel->amount = -1 * $total_sales;
                    $salesModel->currency_id = MasCurrency::getBase_currency();
                    $salesModel->exchange_rate = MasCurrency::getBase_ex_rate();
                    $salesModel->save(false);
                }

                if ($total_discount > 0) {
                    $salesModel = new MasTransactions;
                    $salesModel->voucher_id = $model->id;
                    $salesModel->ledger_id = MasLedgers::model()->get_parent_id(MasLedgers::DISCOUNT_SALES);
                    $salesModel->entry_type = 'SADI';
                    $salesModel->amount = $total_discount;
                    $salesModel->currency_id = MasCurrency::getBase_currency();
                    $salesModel->exchange_rate = MasCurrency::getBase_ex_rate();
                    $salesModel->save(false);
                }

                if ($cost_of_goods > 0) {
                    $salesModel = new MasTransactions;
                    $salesModel->voucher_id = $model->id;
                    $salesModel->ledger_id = MasLedgers::model()->get_parent_id(MasLedgers::COST_OF_SALES);
                    $salesModel->entry_type = 'COG';
                    $salesModel->amount = $cost_of_goods;
                    $salesModel->currency_id = MasCurrency::getBase_currency();
                    $salesModel->exchange_rate = MasCurrency::getBase_ex_rate();
                    $salesModel->save(false);
                }

                if ($grand_total > 0) {
                    $debtorEntry = new MasTransactions;
                    $debtorEntry->voucher_id = $model->id;
                    $debtorEntry->ledger_id = $eachHead['customer_id'];
                    $debtorEntry->entry_type = 'DEB';
                    $debtorEntry->amount = $grand_total;
                    $debtorEntry->currency_id = MasCurrency::getBase_currency();
                    $debtorEntry->exchange_rate = MasCurrency::getBase_ex_rate();
                    $debtorEntry->save(false);
                }

                Yii::app()->db_migrate->createCommand('UPDATE ' . $head_table . ' SET migrated_esell = "Y", esell_ref="' . $model->id . '" WHERE ' . $head_table_primary . ' = ' . (int) $eachHead['head_id'])->execute();
            }

            $all = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $head_table_primary . ') AS count_of FROM ' . $head_table)->queryScalar();
            $imported = Yii::app()->db_migrate->createCommand('SELECT COUNT(' . $head_table_primary . ') AS count_of FROM ' . $head_table . ' WHERE migrated_esell="Y"')->queryScalar();

            $have_more = $all - $imported > 0 ? true : false;
            $records_imported = $imported . ' out of ' . $all . ' are imported';
        }

        echo json_encode(array('have_more' => $have_more, 'records_imported' => $records_imported));
    }

    public function actionPurchase_rtns_fields()
    {
        $type = $_POST['type'];
        $fields = $_POST['table_name'] != '' ? $this->getFields($_POST['table_name']) : array();
        echo $type == 1 ? json_encode(array(
            'key_field' => CHtml::dropdownlist('purchase_rtn_primary_in', '', $fields, array('data-label' => 'Primary Key')),
            'date_field' => CHtml::dropdownlist('purchase_rtn_date_in', '', $fields, array('data-label' => 'Return Date')),
            'return_no_field' => CHtml::dropdownlist('purchase_rtn_no_in', '', $fields, array('data-label' => 'Return No')),
            'invoice_field' => CHtml::dropdownlist('purchase_rtn_invoice_id', '', $fields, array('data-label' => 'Return Invoice Foreign')),

        )) : json_encode(array(
            'key_field' => CHtml::dropdownlist('pur_rtn_product_primary_in', '', $fields, array('data-label' => 'Foreign Key')),
            'inv_key_field' => CHtml::dropdownlist('pur_inv_item_key_in', '', $fields, array('data-label' => 'Inv Item Foreign Key')),
            'quantity_field' => CHtml::dropdownlist('pur_rtn_qty_in', '', $fields, array('data-label' => 'Quantity')),
        ));
    }


    public function actionBuildChildren()
    {

        //Child Ids
        function getChildren($id = 0)
        {
            $condition = 'FIND_IN_SET(parent_id, @pv)';

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{ledgers}}
                        WHERE ' . $condition . ' ) AS lv FROM {{ledgers}}
                        JOIN
                        (SELECT @pv:=' . $id . ') tmp
                        ) a';

            Yii::app()->db->createCommand('SET SESSION group_concat_max_len = 1000000')->execute();
            $ids = Yii::app()->db->createCommand($query)->queryRow();
            return $ids['child'];
        }

        foreach (MasLedgers::model()->findAll(array('select' => 'id, children')) as $each) {

            $each->children = getChildren($each->id);
            $each->update();
        }

        echo 'done';
    }

    public function actionBuildRoute()
    {
        foreach (MasLedgers::model()->findAll(array('select' => 'id, parent_id, route', 'order' => 'level ASC')) as $each) {
            $route = array();
            if ($each->parent_id > 0) {
                $parentRoute = $each->parentDetails->route;
                if ($parentRoute != NULL)
                    $route[] = $parentRoute;
                $route[] = $each->parent_id;
                $each->route = implode(',', $route);
                $each->save(false);
            }
        }
    }

    public function actionUpdateLevelLedgers(){
        foreach (MasLedgers::model()->findAll(array('select' => 'id, level, route')) as $each) {
            $ledgerLevel = $each->level;
            $routes = explode(',', $each->route);
            $fields = array(
                'lv1' => NULL,
                'lv2' => NULL,
                'lv3' => NULL,
                'lv4' => NULL,
                'lv5' => NULL,
                'lv6' => NULL
            );
            foreach ($routes as $i => $eachRoute) {
                $fieldName = 'lv' . ($i + 1);
                $fields[$fieldName] = $eachRoute;
            }
            $fieldName = 'lv' . $ledgerLevel;
            $fields[$fieldName] = $each->id;

            MasTransactions::model()->updateAll($fields, 'ledger_id = "' . $each->id . '"');
        }
    }

    public function actionFixEntries(){
        // $voucherIds = array(25,27,29,47,51,54,57,60,75,78,81,87,91,94,97,100,103,106,109,112,115,118,121,131,134,162,165,168,174,177,180,183,186,189,192,195,198,201,204,207,210,213,216,219,222,225,228,237,240,247,250,254,257,260,266,269,273,276,279,282,286,290,294,297,300,303,306,309,312,315,318,321,324,327,330,333,336,339,342,345,348,351,354,357,360,363,366,369,372,375,379,382,385,388,391,394,397,400,403,408,411,414,417,419,421,424,427,431,435,438,441,444,447,450,453,456,459,462,465,468,471,474,477,480,484,487,491,494,497,500,503,506,509,511,514,517,520,523,526,529,532,535,538,541,544,547,550,553,556,562,565,567,570,573,575,577,579,583,586,590,596,599,602,604,606,608,610,612,614,616,619,622,625,628,631,634,638,641,644,647,650,653,656,659,662,665,668,671,1151,1932);
        // $voucherIds =    array(26,28,30,48,52,55,58,61,76,79,82,88,92,95,98,101,104,107,110,113,116,119,122,132,135,163,166,169,175,178,181,184,187,190,193,196,199,202,205,208,211,214,217,220,223,226,229,238,241,248,251,255,258,261,267,270,274,277,280,283,287,291,295,298,301,304,307,310,313,316,319,322,325,328,331,334,337,340,343,346,349,352,355,358,361,364,367,370,373,376,380,383,386,389,392,395,398,401,404,409,412,415,418,420,422,425,428,432,436,439,442,445,448,451,454,457,460,463,466,469,472,475,478,481,485,488,492,495,498,501,504,507,510,512,515,518,521,524,527,530,533,536,539,542,545,548,551,554,557,563,566,568,571,574,576,578,580,584,587,591,597,600,603,605,607,609,611,613,615,617,620,623,626,629,632,635,639,642,645,648,651,654,657,660,663,666,669,672,1152,1933);
        // $voucherIds = array(5437,5438,5439,5440,5441,5442,5443,5444,5445,5446,5447,5448,5449,5450,5453,5454,5455,5458,5459,5462,5463,5464,5466,5469,5471,5472,5474,5475,5476,5477,5479,5480,5481,5493,5494,5495,5496,5498,5499,5500,5501,5502,5503,5504,5505,5508,5509,5511,5512,5514,5515,5516,5520,5522,5525,5526,5527,5530,5531,5532,5533,5553,5561,5566,5568,5569,5570,5572,5573,5574,5575,5577,5584,5587,5588,5590,5591,5592,5593,5594,5595,5598,5599,5658,5797,5819,5841,5879,5886,5893,5912,5927,5953,5954,5960,5964);
        $voucherIds = array(429,433,558,560,569,588,636,677,678,679,732,757,759,763,766,769,771,772,773,774,778,779,781,980,983,1024,1026,1071,1081,1086,1106,1108,1122,1143,1146,1149,1201,1207,1214,1317,1342,1502,1544,1665,1675,1763,1796,1804,1945,1953,2482,2502,2541,2547,2589,2655,2661,2900,3526,3610);
        
        foreach( $voucherIds as $each ){
            $voucherModel = MasVouchers::model()->findBypk($each);
            // $cost_of_goods = $voucherModel->credit_sum;
            // $cost_of_goods = $voucherModel->debit_sum;
            $cost_of_goods = $voucherModel->totalCogs;

            if( $cost_of_goods < 0 ){

                $cogsModel = new MasTransactions;
                $cogsModel->voucher_id = $each;
                $cogsModel->ledger_id = MasLedgers::model()->get_parent_id(MasLedgers::COST_OF_SALES); //MasLedgers::model()->get_parent_id(MasLedgers::PL_OPENING); // 
                $cogsModel->entry_type = 'COG'; //'OSTK'; 
                $cogsModel->amount =-1 * $cost_of_goods;
                $cogsModel->currency_id = MasCurrency::getBase_currency();
                $cogsModel->exchange_rate = MasCurrency::getBase_ex_rate();
                $cogsModel->save(false);
            }
        }
    }
}
