<?php

class CustomerController extends Controller {

    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index','GetList', 'Create','Save','GetCustomerDetails','AddCustomertoSalesman','SaveCustomerforSale','GetSalesmanCustomers','EnableDisable'),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex(){
        $this->render('index');
    }
    /*
     * ajax function to list all customers datatable
     * modified by jisha on 17-6-20. 
     */

      public function actionGetList() {
        $model  = new Customer();
        $draw   = $_POST['draw'];
        $offset = $_POST['start'];
        $limit  = $_POST['length'];
        $outlet = $_POST['outlet'];
        $state = $_POST['state'];
        $columns = array(
            // datatable column index  => database column name
            0 => 't.customer_no',
            1 => 't.customer_name',
            2 => 't.location',
            3 => 't.phone',
            4 => 't.mobile',
            5 => 't.trn_no',
            7 => 't.outlet',
            8 => 't.id',
            9 => 't.active'
        );
        $filterColumn   = $columns[$_POST['order'][0]['column']];
        $filterOrder    = $_POST['order'][0]['dir'];
        $orderBy        = $filterColumn . " " . $filterOrder;
        $condition      = '1=1';
        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            $condition.=" AND (t.customer_no LIKE '%" . $searchString . "%' OR t.customer_name LIKE '%" . $searchString . "%'  OR t.address LIKE '%" . $searchString . "%' OR t.phone LIKE '%" . $searchString . "%' OR t.location LIKE '%" . $searchString . "%'  OR t.email LIKE '%" . $searchString . "%' OR t.trn_no LIKE '%" . $searchString . "%' )";
        }
        if($outlet>0){
            $condition.=" AND t.outlet=".$outlet;
        }
        if($state>0){
            $condition.=" AND t.state=".$state;
        }
        if(Yii::app()->user->user_access_type == 'SL')
        {
            $condition.=" AND (t.created_by = ".Yii::app()->user->id." OR FIND_IN_SET(".Yii::app()->user->id.",accessed_by))";
        }
        $count          = $model->with('state_detail','outlet_detail')->count(array('condition' => $condition));
        $model          = $model->with('state_detail','outlet_detail')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));
        $recordsTotal   = $count;
        $recordsFiltered        = $count;
        $data['draw']   = $draw;
        $data['recordsTotal']   = $recordsTotal;
        $data['recordsFiltered']= $recordsFiltered;
        $rowData                = array();
        foreach ($model as $i=>$row)
        {
            $div= '<div class="text-center">';
            if(Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM'){
                if($row['active']=='Y'){
                    $div.= ' <button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'customer/create&id='.$row['id'].'\',\'Edit - '.$row['customer_name'].'\',\'lg\')"><i class="fa fa-edit" aria-hidden="true"></i></button>';
                    $div.= ' <button class="btn btn-danger btn-xs" title ="Block" onclick="block('.$row['id'].',1)"><i class="fa fa-ban" aria-hidden="true"></i></button>';
                }else{
                    $div.= ' <button class="btn btn-theme btn-xs" title ="UnBlock" onclick="block('.$row['id'].',2)"><i class="fa fa-unlock" aria-hidden="true"></i></button>';
                }
            $div.= ' <a target="_blank" class="btn btn-primary btn-xs" title ="Location" href="https://www.google.com/maps/place/'.$row->latitude.','.$row->longitude.'"><i class="fa fa-map" aria-hidden="true"></i></a>';
            }
                $div.= '</div>';
            $rowData[]  = array($row['customer_no'],$row['customer_name'], $row['location'],$row['state_detail']['state_name'],$row['phone'],$row['mobile'],$row['trn_no'],$row['outlet_detail']['outlet_name'],$div,$row['active']);
        } 
        $data['data'] = $rowData;
        echo json_encode($data);
    }
    /*
     * function to create customer details
     * modified by jisha on 17-6-20. 
     */
    public function actionCreate() {
       $id = (int) Yii::app()->request->getParam('id');
        $model = new Customer;
        if ($id > 0) {
            $model = $model->findByPk($id);
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model));
    }
    public function actionSave() {
        $model          = new Customer();
        if (isset($_POST['Customer'])) {

            if ($_POST['Customer']['id'] > 0) {
                $id =  $_POST['Customer']['id'];
                $model = $model->findByPK($id);
                $scene = 'update';
                $change_type = 'UPDATED';
            } else {
                $model->created_by = Yii::app()->user->id;
                $model->accessed_by = Yii::app()->user->id;
                $model->created_time = date('Y-m-d H:i:s');
                $scene = 'new';
                $change_type = 'CREATED';                
            }
            $modelformmaster=FormMaster::model()->find(array('condition'=>'outlet='.Yii::app()->user->outlet_id.' AND code="C"'));
            $model->attributes = $_POST['Customer'];
            $model->updated_by = Yii::app()->user->id;
            $model->updated_time =date('Y-m-d H:i:s');
            $model->outlet=Yii::app()->user->outlet_id;
            $model->active='Y';
            if($scene =='new'){
                $model->customer_no=$modelformmaster->next_number;
               /* $credit_limit = MasOutlets::model()->findByPk((int)Yii::app()->user->outlet_id)->customer_credit_limit;
                $model->credit_limit =(float)$credit_limit;*/
            }
            if(Yii::app()->user->user_access_type != 'SL' and $_POST['Customer']['accessed_by']!='')
            {
                $model->accessed_by = implode(',',$_POST['Customer']['accessed_by']);
            }
            else if(trim($model->accessed_by)==''){
                $model->accessed_by = $model->created_by;
            }
            $valid=$model->validate();
        }
        if($valid){
            $model->save();
            $subledger=FinanceSubledger::model()->find(array('condition'=>'subledger_type_id=1 AND parent_id='.$model->id));
            if(empty($subledger))
            {
            $newItem = new FinanceSubledger;
            }
            else {
            $newItem = FinanceSubledger::model()->findByPk($subledger->id);    
            }
            $newItem->description = $model->customer_name;
            $newItem->account_no = $model->customer_no;
            if($model->address != '') {
            $newItem->address = $model->address;
            }
            if($model->phone != '') {
            $newItem->phone = $model->phone;
            }
            $newItem->subledger_type_id = 1;
            $newItem->parent_id = $model->id;
            $newItem->created_by = $model->created_by;
            $newItem->outlet=Yii::app()->user->outlet_id;
            $newItem->save(false);

            if($scene =='new'){
                $next_no=$model->customer_no+1;
                FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
            }
                // inserting to audit log
                AuditLog::saveAuditLogs(
                    $modelformmaster->id,
                    Yii::app()->user->id,
                    $change_type,
                    " with ID - {$model->id} "
                );
                // end audit log
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
        }else {
            $error1 = json_decode(CActiveForm::validate($model, '', false), true);
            $error = CJSON::encode(array_merge_recursive($error1));
            if ($error != '[]'){
                echo $error;    
            }
        }
    }    
    public function actionGetCustomerDetails() {
        $from = $_GET['frm'];
        $searchTerm = $_GET['term'];
        $condition = 'customer_name LIKE "%' . $searchTerm . '%" AND t.active="Y"';
        if(Yii::app()->user->user_access_type == 'SL')
        {
            $condition.=" AND (t.created_by = ".Yii::app()->user->id." OR FIND_IN_SET(".Yii::app()->user->id.",accessed_by))";
        }
        if(Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SL')
        {
          $condition.=" AND t.outlet=".Yii::app()->user->outlet_id; 
        }
        $model = new Customer();
        $model = $model->findAll(array('select' => 't.id,t.customer_name,payment_term,address', 'condition' => $condition, 'limit' => 200));
        $i = 0;
        $data=array();
        foreach ($model as $eachModel) {
            $data[$i]['value'] = $eachModel->id;
            $data[$i]['label'] = $eachModel->customer_name.' : '.$eachModel->address;
            $data[$i]['payment_term'] = $eachModel->payment_term;
            $i++;
        }
        echo CJSON::encode($data);
        Yii::app()->end();
    }
    public function actionAddCustomertoSalesman(){
        $model  = new Customer();
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('addcustomertosalesman', array('model' => $model));
    }
    public function actionGetSalesmanCustomers(){
        $sale_id=$_POST['id'];
        $model  = new Customer();
        $arr_customers= Customer::model()->findAll(array('condition'=>'created_by='.$sale_id));
        $arr_sales_man=MasOutlets::salesmans_without_user($sale_id);
        $tab_data ='<table class="table table-primary" id="tab_saleman_cust">';
        $tab_data .='    <thead>
                <th>Customer</th>
                <th>'.CHtml::checkBox("Item_check_all",'',array('data-label'=>'All','class'=>"checkBoxClassAll","onclick"=>"checkall()")).'</th>
            </thead>';
        $tab_data .='<tbody>';
        foreach($arr_customers as $i=>$each){ 
        $tab_data .='        <tr>
                    <td>'.$each->customer_name.'</td>
                    <td>'.CHtml::hiddenField("update[".$i."][id]",$each['id']).CHtml::checkBox("Items[$i][checked]",'',array('class'=>"checkBoxClass")).'</td>
                </tr>';
        } 
        $tab_data .='</tbody>';
        $tab_data .='</table>';
        $tab_data .='<ul class="clearfix form-ul material"><li class="col-sm-4">';
        $tab_data .= CHtml::activedropdownList($model, 'accessed_by',$arr_sales_man, array('data-label'=>'Accessed By <span style="color:red;">*</span>'));
        $tab_data .='</li></ul>';
        $data['table_customers']=$tab_data;
        echo CJSON::encode($data);
    }
    public function actionSaveCustomerforSale(){
        $saleman    = $_POST['accessed_by'];
        $ids        = json_decode($_POST['ids']);
        $count_ids  = count($ids);
        $count  = 0;$accessed_by=array();
        if($count_ids > 0  && $saleman>0){
            foreach($ids as $selected){               
                $model = Customer::model()->findByPk($selected);
                $accessed_by =$model->accessed_by.','.$saleman;
                $model->accessed_by=$accessed_by;
                $model->save(false);
                $count++;
            }
            echo 'success';
        }else{
             echo 'fail';
        }
    }
    public function actionEnableDisable(){
        $id    = $_POST['id'];
        $status    = $_POST['status'];
        $model = Customer::model()->findByPk($id);
        if($status==1)
        $model->active ='N';
        else
        $model->active ='Y';
        $model->save(false);
        $data['status'] = 'success';
        echo CJSON::encode($data);
        Yii::app()->end();
    }
}
