<?php

class GoodsreceiptController extends Controller {

    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index','GetList', 'Create','Save','PrintPDF','getSimilarUnits','CancelReceipt'),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex() {
        $this->render('index');
    }
    /*
     * ajax function to list all goodsreceipt datatable
     * modified by jisha on 22-6-20. 
     */

      public function actionGetList() {
        $model  = new GoodsReceipt();
        $draw   = $_POST['draw'];
        $offset = $_POST['start'];
        $limit  = $_POST['length'];
        $outlet = $_POST['outlet'];
        $created_user = $_POST['created_user'];
        $from = $_POST['from'];
        $to = $_POST['to'];
        $columns = array(
            // datatable column index  => database column name
            0 => 't.receipt_no',
            1 => 't.receipt_date',
            2 => 't.reference',
            3 => 't.notes',
            4 => 't.outlet',
            5 => 't.id',
            6 => 't.outlet'
        );
        $filterColumn   = $columns[$_POST['order'][0]['column']];
        $filterOrder    = $_POST['order'][0]['dir'];
        $orderBy        = $filterColumn . " " . $filterOrder;
        $condition      = '1=1';
        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            $condition.=" AND (t.receipt_no LIKE '%" . $searchString . "%' OR t.reference LIKE '%" . $searchString . "%'  OR t.notes LIKE '%" . $searchString . "%' )";
        }
        if($from!='' && $from!='00/00/0000')
        {
            $from = str_replace('/', '-',$from);
            $from=date("Y-m-d", strtotime($from));
            $condition.=' AND t.receipt_date>="'.$from.'"';    
        }
        if($to!='' && $to!='00/00/0000')
        {
            $to = str_replace('/', '-',$to);
            $to=date("Y-m-d",strtotime($to));
            $condition.=' AND t.receipt_date<="'.$to.'"';    
        }
        if($outlet>0){
            $condition.=" AND t.outlet=".$outlet;
        }
        if($created_user >0)
        {
            $condition.=' AND (t.sales_man='.$created_user.')';    
        }

        $count          = $model->with('gr_outlet')->count(array('condition' => $condition));
        $model          = $model->with('gr_outlet')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));
        $recordsTotal   = $count;
        $recordsFiltered        = $count;
        $data['draw']   = $draw;
        $data['recordsTotal']   = $recordsTotal;
        $data['recordsFiltered']= $recordsFiltered;
        $rowData                = array();$div='';
        foreach ($model as $row)
        {
            $div= '<div class="text-center">';
            if($row['active']=='Y'){
                if(Yii::app()->user->user_access_type != 'DEV'&& Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM'){ 
                    $div.= ' <button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'goodsreceipt/create&id='.$row['id'].'\',\'Edit - '.$row['receipt_no'].'\',\'lg\')"><i class="fa fa-edit" aria-hidden="true"></i></button>';
                    $div.= ' <button class="btn btn-danger btn-xs" title ="Delete" onclick="cancelreceipt('.$row['id'].')"><i class="fa fa-ban" aria-hidden="true"></i></button>';
                }
            }
            $div .= ' <a class="btn btn-primary btn-xs" title="Print Goods Receipt" target="_blank" href="index.php?r=goodsreceipt/PrintPDF&id=' . $row['id'] .'"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>';
            $div .= ' </div>';
            $rowData[]  = array($row['receipt_no'], date('d/m/Y', strtotime($row['receipt_date'])),$row['reference'], $row['notes'],$row['gr_outlet']['outlet_name'],$div,$row['active']);
        } 
        $data['data'] = $rowData;
        echo json_encode($data);
    }
    /*
     * function to create goodsreceipt details
     * modified by jisha on 22-6-20. 
     */
    public function actionCreate() {
       $id = (int) Yii::app()->request->getParam('id');
        $model = new GoodsReceipt;
        $modelItems     = array(new GoodsReceiptItems);
        if ($id > 0) {
            $model = $model->findByPk($id);
            $modelItems = GoodsReceiptItems::model()->findAll(array('condition' => 'receipt_id="' . $id . '"','order'=>'id ASC'));
            if (empty($modelItems)) {
                $modelItems = array(new GoodsReceiptItems());
            }
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model, 'modelItems' => $modelItems));
    }
    public function actionSave() {
        date_default_timezone_set("Asia/Dubai");
        $model          = new GoodsReceipt();
        $valid = true;
        $groups = $other=array();
        if (isset($_POST['GoodsReceipt'])) {

            if ($_POST['GoodsReceipt']['id'] > 0) {
                $id =  $_POST['GoodsReceipt']['id'];
                $model = $model->findByPK($id);
                $scene = 'update';
                $change_type = 'UPDATED';
            } else {
                $model->created_by = Yii::app()->user->id;
                $model->created_time = date('Y-m-d H:i:s');
                $scene = 'new';
                $change_type = 'CREATED';                
            }
            $modelformmaster=FormMaster::model()->find(array('condition'=>'outlet='.Yii::app()->user->outlet_id.' AND code="GR"'));
            $model->updated_by = Yii::app()->user->id;
            $model->updated_time =date('Y-m-d H:i:s');
            $model->attributes = $_POST['GoodsReceipt'];
            $model->outlet=Yii::app()->user->outlet_id;
            if($_POST['GoodsReceipt']['receipt_date']!='')
            {
                $model->receipt_date = str_replace('/', '-', $_POST['GoodsReceipt']['receipt_date']);
                $model->receipt_date= date("Y-m-d", strtotime($model->receipt_date));
            }
           
            if($scene =='new'){
                $model->receipt_no=$modelformmaster->next_number;
            }
            $valid=$model->validate();
            if(is_array($_POST['GoodsReceiptItems'])){
                $j=0;
                foreach($_POST['GoodsReceiptItems'] as $i => $each ){
                    if($each['product_id']>0){    
                        $modelItems[$j] = new GoodsReceiptItems();
                        $modelItems[$j]->attributes = $each;
                        $modelItems[$j]->receipt_id = 0;
                        $valid = $valid && $modelItems[$j]->validate();  
                        // Product Grouping
                        if($scene =='update'){
                            if($each['unit']>0)
                            {
                                $unit=MasUnit::model()->findByPk($each['unit']);
                                $unit_exchange=$unit->unit_exchange_rate;
                            }
                            else {
                                $unit_exchange=1;    
                            }
                            
                            $key = $each['product_id'];
                            if (!array_key_exists($key, $groups)) {
                                $groups[$key] = array(
                                'id' => $each['product_id'],
                                'quantity' => $each['quantity']*$unit_exchange,
                                );
                            } 
                            else 
                            {
                            $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['quantity']*$unit_exchange;
                            }   
                        }
                        $j++;
                    }
                }
            } 
            // QTY Checking
            if($scene =='update'){
                if(!empty($groups))
                {
                    foreach($groups as $key=>$eachProduct)  
                    {
                        $product=Inventory::model()->findByPk($key);
                        if($product->type!='S'){
                            if($model->id>0)
                            {
                            $prev_saved_qty=Yii::app()->db->createCommand("select SUM(GR.quantity*U.unit_exchange_rate) from {{goods_receipt_items}} GR INNER JOIN {{master_unit}} U ON GR.unit=U.id where receipt_id='".$model->id."' AND product_id='".$key."'")->queryScalar();
                            $bal=$prev_saved_qty-$eachProduct['quantity'];
                            $in_qty=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->sales_man." AND transaction_date<='".$model->receipt_date."'")->queryScalar();
                            $out_qty=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->sales_man." AND transaction_date<='".$model->receipt_date."'")->queryScalar();
                            $current_stock_on_date=$in_qty-$out_qty;
                            if($bal>$current_stock_on_date)
                            {
                                $other[]=$product->part_number.' available quantity on '.$model->receipt_date.' mismatch'; 
                                $valid=false;
                            }
                            $in_qty1=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->sales_man." ")->queryScalar();
                            $out_qty1=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->sales_man." ")->queryScalar();
                            $current_stock=$in_qty1-$out_qty1;
                            if($bal>$current_stock)
                            {
                                $other[]=$product->part_number.' available quantity mismatch'; 
                                $valid=false;
                            }
                        }
                    }  
                }
            }
        }
        }
        $closing_date=MasClosing::getClosingDate();
        if($closing_date>=$model->receipt_date)
        {
        $other[]='Date should be greater than closing date ('.date('d-m-Y',strtotime($closing_date)).')'; 
        $valid=false;    
        }
        if($valid && ($modelItems[0]->product_id > 0)){
            $model->save();
            GoodsReceiptItems::model()->deleteAll('receipt_id ='.$model->id);
            StockLedger::model()->deleteAll('header_id='.$model->id.' AND  transaction_type="IN" AND type= "GR" AND outlet='.Yii::app()->user->outlet_id);
            if($scene =='new'){
                $next_no=$model->receipt_no+1;
                FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
            }
            if(!empty($modelItems)){
                foreach($modelItems as $each){
                        $each->receipt_id = $model->id;
                        $each->save();
                        $model_stockledger = new StockLedger();
                        $model_stockledger->transaction_date=$model->receipt_date;
                        $model_stockledger->transaction_type ='IN';
                        $model_stockledger->type ='GR';
                        $model_stockledger->customer_vendor_id=0;
                        $model_stockledger->header_id=$model->id;
                        $model_stockledger->item_id=$each->id;
                        $model_stockledger->product_id=$each->product_id;
                        $model_stockledger->rate=$each->rate;
                        $model_stockledger->currency=1;
                        $model_stockledger->exchange_rate=1;
                        $model_stockledger->quantity=$each->quantity;
                        $model_stockledger->unit=$each->unit;
                        $model_stockledger->default_product_unit=$each->gr_unit_details->base_unit_id;
                        $model_stockledger->unit_exchange_rate=$each->gr_unit_details->unit_exchange_rate;
                        $model_stockledger->created_by= $model->sales_man;
                        $model_stockledger->created_time=date('Y-m-d H:i:s');
                        $model_stockledger->outlet=Yii::app()->user->outlet_id;
                        $model_stockledger->save(false);
                }
            }
            
                // inserting to audit log
                AuditLog::saveAuditLogs(
                    $modelformmaster->id,
                    Yii::app()->user->id,
                    $change_type,
                    " with ID - {$model->id} "
                );
                // end audit log
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
        }else {
            $error1=$error2=array();
            $error1 = json_decode(CActiveForm::validate($model, '', false), true);
            if ($modelItems[0]->product_id > 0)
                $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
            else
                $error2[] = "Please add atleast one line item";
            $error = CJSON::encode(array_merge_recursive($error1,$error2,$other));
            if ($error != '[]'){
                echo $error;    
            }
        }
    }
    public function actionPrintPDF(){
        $id = Yii::app()->request->getParam('id');
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $model          = GoodsReceipt::model()->findByPk($id);
        if($model->active=='N'){
            $mPDF1->SetWatermarkText('CANCELLED');
            $mPDF1->showWatermarkText = true;
        }
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.goods_receipt_print', array('id' => $id, 'title' => $title),true));
        $mPDF1->Output($htmlTemplate, 'I');
    }
    public function actionGetSimilarUnits(){
        $unit_id=$_POST['unit'];
        $i=$_POST['row_field'];
        $arr_units=MasUnit::getSimilarUnits($unit_id);
        $modelItems=new GoodsReceiptItems();
        $modelItems->unit=$unit_id;
        $data['unit']=CHtml::activeDropDownList($modelItems, "[" . $i . "]unit",$arr_units, array("class" =>"go cell-center text-center",'onchange'=>'getPriceOnUnitChange(this.id)'));
        echo CJSON::encode($data);
    }
    public function actionCancelReceipt(){
        $id     = $_POST['id'];
        $valid  = true;
        $other=array();
        $model  = GoodsReceipt::model()->findByPk($id);
        $modelItems = GoodsReceiptItems::model()->findAll(array('condition' => 'receipt_id="' . $id . '"','order'=>'id ASC'));
        $groups = array();
        foreach($modelItems as $each){
            if($each['unit']>0)
            {
                $unit=MasUnit::model()->findByPk($each['unit']);
                $unit_exchange=$unit->unit_exchange_rate;
            }
            else {
                $unit_exchange=1;    
            }
            $key = $each['product_id'];
            if (!array_key_exists($key, $groups)) {
                $groups[$key] = array(
                    'id' => $each['product_id'],
                    'quantity' => $each['quantity']*$unit_exchange,
                );
            } 
            else 
            {
                $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['quantity']*$unit_exchange;
            }   
        }
        if(!empty($groups))
        {
            foreach($groups as $key=>$eachProduct)  
            {
                $product=Inventory::model()->findByPk($key);
                if($product->type!='S'){
                    $in_qty=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->sales_man)->queryScalar();
                    $out_qty=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->sales_man)->queryScalar();
                    $current_stock=$in_qty-$out_qty;
                    if($current_stock < $eachProduct['quantity'])
                    {
                        $other[]=$product->part_number.' available quantity mismatch'; 
                        $valid=false;
                    }
                }
            }  
        }
        $closing_date=MasClosing::getClosingDate();
        if($closing_date>=$model->receipt_date)
        {
        $other[]='Date should be greater than closing date ('.date('d-m-Y',strtotime($closing_date)).')'; 
        $valid=false;       
        }
        if($valid){
            StockLedger::model()->deleteAll('header_id='.$model->id.' AND  transaction_type="IN" AND type= "GR" AND outlet='.Yii::app()->user->outlet_id);
            $model->active='N';
            $model->save(false);
            $jsonData['status']='success';
            echo CJSON::encode($jsonData);
        }else{
            $error = CJSON::encode(array_merge_recursive($other));
            if ($error != '[]'){
                echo $error;    
            }
        }
        
    }
}
