<?php



class InventoryController extends Controller

{



    public function accessRules()

    {

        return array(

            array(

                'allow', // allow all users to perform 'index' and 'view' actions

                'actions' => array('login', 'error', 'logout'),

                'users' => array('*'),

            ),

            array(

                'allow', // allow authenticated user to perform 'create' and 'update' actions

                'actions' => array('Index', 'GetList', 'GetListSalesman', 'Create', 'Save', 'GetProducts', 'EnableDisable', 'EditCostRate', 'SaveCostRate','GetProductByBarcode'),

                'expression' => '$user->isMember()',

            ),

            array(

                'deny', // deny all users

                'users' => array('*'),

            ),

        );

    }



    public function actionIndex()

    {

        if (Yii::app()->user->user_access_type == 'SL') {

            $this->render('saleman_index');

        } else {

            $this->render('index');

        }

    }

    public function actionGetListSalesman()

    {

        $draw   = $_POST['draw'];

        $offset = $_POST['start'];

        $limit  = $_POST['length'];

        $outlet = $_POST['outlet'];

        $type = $_POST['type'];

        $brand = $_POST['brand'];

        $stock = $_POST['stock'];

        $created_user = $_POST['created_user'];

        $columns = array(

            // datatable column index  => database column name

            0 => 'part_number',

            1 => 'part_number',

            2 => 'description',

            3 => 'type',

            4 => 'brand_name',

            5 => 'qty',

            6 => 'unit_name',

            7 => 'rate',

            8 => 'tax',

            10 => 'active'

        );

        $filterColumn   = $columns[$_POST['order'][0]['column']];

        $filterOrder    = $_POST['order'][0]['dir'];

        $orderBy        = $filterColumn . " " . $filterOrder;

        $condition      = '1=1 ';

        if ($outlet > 0) {

            $condition .= ' AND I.outlet=' . $outlet;

        }

        if ($type != '') {

            $condition .= ' AND I.type="' . $type . '"';

        }

        if ($brand > 0) {

            $condition .= ' AND I.brand=' . $brand;

        }

        if ($created_user > 0) {

            $condition .= ' AND (S.created_by=' . $created_user . ' OR S.type="OB" )';

        } else if (Yii::app()->user->user_access_type == 'SL') {

            $condition .= ' AND (S.created_by=' . Yii::app()->user->id . ' OR S.type="OB" )';

        }

        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {

            $searchString = $_POST['search']['value'];

            $condition .= " AND (I.part_number LIKE '%" . $searchString . "%' OR I.description LIKE '%" . $searchString . "%')";

        }

        if ($stock == '') {

            $stockcondition = '1=1';

        } else {

            if ($stock == 2) {

                $stockcondition = 'A.qty=0';

            } else {

                $stockcondition = 'A.qty>0';

            }

        }

        $SQL = "CREATE OR REPLACE VIEW erp_inventory_list AS

        (SELECT I.id,I.part_number,I.description,I.active,B.brand_name,I.type,SUM(S.quantity*S.unit_exchange_rate) AS in_qty,

        0 AS out_qty,U.unit_name,CASE

        WHEN SUM(S.quantity*S.unit_exchange_rate) > 0 THEN SUM(S.quantity*S.rate)/SUM(S.quantity*S.unit_exchange_rate) ELSE 0 END AS avg_purchase_rate,0 AS avg_sales_rate,tax,O.name,O.outlet_name,I.rate 

        FROM erp_inventory I 

        LEFT JOIN erp_stock_ledger S ON I.id=S.product_id 

        LEFT JOIN erp_master_brand B ON I.brand=B.id 

        LEFT JOIN erp_master_unit U ON I.unit=U.id 

        LEFT JOIN bluesell_new_main.erp_outlets O ON I.outlet=O.id where $condition AND (S.transaction_type='IN' OR S.type='OB') group by I.id)

        UNION

        (SELECT I.id,I.part_number,I.description,I.active,B.brand_name,I.type,0 AS in_qty,SUM(S.quantity*S.unit_exchange_rate) AS out_qty,

        U.unit_name,0 AS avg_purchase_rate,CASE

        WHEN SUM(S.quantity*S.unit_exchange_rate) > 0 THEN SUM(S.quantity*S.rate)/SUM(S.quantity*S.unit_exchange_rate) ELSE 0 END AS avg_sales_rate,0 AS tax,O.name,O.outlet_name,I.rate 

        FROM erp_inventory I 

        LEFT JOIN erp_stock_ledger S ON I.id=S.product_id 

        LEFT JOIN erp_master_brand B ON I.brand=B.id 

        LEFT JOIN erp_master_unit U ON I.unit=U.id 

        LEFT JOIN bluesell_new_main.erp_outlets O ON I.outlet=O.id where $condition AND (S.transaction_type='OUT' OR S.type='OB')  group by I.id)";

        Yii::app()->db->createCommand($SQL)->execute();

        $model = Yii::app()->db->createCommand("SELECT * FROM(SELECT id,part_number,description,active,brand_name,type,SUM(in_qty) AS in_qty,SUM(out_qty) AS out_qty,SUM(in_qty)-SUM(out_qty) AS qty,

        unit_name,SUM(avg_purchase_rate) AS avg_purchase_rate,SUM(avg_sales_rate) AS avg_sales_rate,SUM(tax) AS tax,name,outlet_name,rate from erp_inventory_list group by id )A WHERE " . $stockcondition . " order by $orderBy limit $limit offset $offset")->queryAll();

        $counts = Yii::app()->db->createCommand("SELECT * FROM(SELECT id,part_number,description,active,brand_name,type,SUM(in_qty) AS in_qty,SUM(out_qty) AS out_qty,SUM(in_qty)-SUM(out_qty) AS qty,

        unit_name,SUM(avg_purchase_rate) AS avg_purchase_rate,SUM(avg_sales_rate) AS avg_sales_rate,SUM(tax) AS tax,name,outlet_name,rate from erp_inventory_list group by id )A WHERE " . $stockcondition . " order by $orderBy")->queryAll();

        $count          = count($counts);

        $rowData                = array();

        $recordsTotal   = $count;

        $recordsFiltered        = $count;

        $data['draw']   = $draw;

        $data['recordsTotal']   = $recordsTotal;

        $data['recordsFiltered'] = $recordsFiltered;

        $rowData                = array();

        foreach ($model as $i => $row) {



            $inv_type = ($row['type'] == 'I') ? "Inventory" : "Service";

            $cost = '';

            $qty = '';

            $avg_purchase_rate = StockLedger::getAvgPurchaseRate($row['id'], '', $outlet); //$avg_purchase_rate = $row['avg_purchase_rate']

            $div = '<div class="text-center">';

            if ($row['active'] == 'Y') {

                $div .= '<button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'inventory/create&id=' . $row['id'] . '\',\'Edit - ' . $row['part_number'] . '\',\'lg\')"><i class="fa fa-edit" aria-hidden="true"></i></button>';

                $div .= ' <button class="btn btn-danger btn-xs" title ="Block" onclick="block(' . $row['id'] . ',1)"><i class="fa fa-ban" aria-hidden="true"></i></button>';

            } else {

                $div .= ' <button class="btn btn-theme btn-xs" title ="UnBlock" onclick="block(' . $row['id'] . ',2)"><i class="fa fa-unlock" aria-hidden="true"></i></button>';

            }

            $div .= '</div>';

            $rowData[]  = array(($i + 1), $row['part_number'], $row['description'], $inv_type, $row['brand_name'], round($row['qty'], 3), $row['unit_name'], Yii::app()->numberFormatter->formatCurrency($row['rate'], " "), Yii::app()->numberFormatter->formatCurrency($row['tax'], " ") . '%', $div, $row['active']);

        }

        $data['data'] = $rowData;

        echo json_encode($data);

    }

    public function actionGetList()

    {

        $draw   = $_POST['draw'];

        $offset = $_POST['start'];

        $limit  = $_POST['length'];

        $outlet = $_POST['outlet'];

        $type = $_POST['type'];

        $brand = $_POST['brand'];

        $stock = $_POST['stock'];

        $created_user = $_POST['created_user'];

        $columns = array(

            // datatable column index  => database column name

            0 => 'part_number',

            1 => 'part_number',

            2 => 'description',

            3 => 'type',

            4 => 'brand_name',

            5 => 'qty',

            6 => 'unit_name',

            7 => 'avg_purchase_rate',

            8 => 'rate',

            9 => 'tax',

            10 => 'outlet',

            12 => 'active'

        );

        $filterColumn   = $columns[$_POST['order'][0]['column']];

        $filterOrder    = $_POST['order'][0]['dir'];

        $orderBy        = $filterColumn . " " . $filterOrder;

        $condition      = '1=1 ';

        // $sr_condition  ='active="Y"  AND outlet='.Yii::app()->user->outlet_id.' AND (base_unit_id='.$base_unit.' OR id='.$base_unit.')',;

        if ($outlet > 0) {

            $condition .= ' AND I.outlet=' . $outlet;

        }

        if ($type != '') {

            $condition .= ' AND I.type="' . $type . '"';

        }

        if ($brand > 0) {

            $condition .= ' AND I.brand=' . $brand;

        }

        if ($created_user > 0) {

            $condition .= ' AND (S.created_by=' . $created_user . ' OR S.type="OB" )';

        } else if (Yii::app()->user->user_access_type == 'SL') {

            $condition .= ' AND (S.created_by=' . Yii::app()->user->id . ' OR S.type="OB" )';

        }

        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {

            $searchString = $_POST['search']['value'];

            $condition .= " AND (I.part_number LIKE '%" . $searchString . "%' OR I.description LIKE '%" . $searchString . "%' OR I.barcode LIKE '%" . $searchString . "%')";

        }

        if ($stock == '') {

            $stockcondition = '1=1';

        } else {

            if ($stock == 2) {

                $stockcondition = 'A.qty=0';

            } else {

                $stockcondition = 'A.qty>0';

            }

        }

        $SQL = "CREATE OR REPLACE VIEW erp_inventory_list AS

        (SELECT I.id,I.part_number,I.description,I.active,B.brand_name,I.type,SUM(S.quantity*S.unit_exchange_rate) AS in_qty,

        0 AS out_qty,U.unit_name,I.sec_unit_id ,T.base_unit_id,U.unit_exchange_rate,CASE

        WHEN SUM(S.quantity*S.unit_exchange_rate) > 0 THEN SUM(S.quantity*S.rate)/SUM(S.quantity*S.unit_exchange_rate) ELSE 0 END AS avg_purchase_rate,0 AS avg_sales_rate,tax,O.name,O.outlet_name,I.rate 

        FROM erp_inventory I 

        LEFT JOIN erp_stock_ledger S ON I.id=S.product_id 

        LEFT JOIN erp_master_brand B ON I.brand=B.id 

        LEFT JOIN erp_master_unit U ON I.unit=U.id 

        LEFT JOIN erp_master_unit T ON I.sec_unit_id=T.id 

        LEFT JOIN bluesell_new_main.erp_outlets O ON I.outlet=O.id where $condition AND (S.transaction_type='IN' OR S.type='OB') group by I.id)

        UNION

        (SELECT I.id,I.part_number,I.description,I.active,B.brand_name,I.type,0 AS in_qty,SUM(S.quantity*S.unit_exchange_rate) AS out_qty,

        U.unit_name,I.sec_unit_id,T.base_unit_id,U.unit_exchange_rate,0 AS avg_purchase_rate,CASE

        WHEN SUM(S.quantity*S.unit_exchange_rate) > 0 THEN SUM(S.quantity*S.rate)/SUM(S.quantity*S.unit_exchange_rate) ELSE 0 END AS avg_sales_rate,0 AS tax,O.name,O.outlet_name,I.rate 

        FROM erp_inventory I 

        LEFT JOIN erp_stock_ledger S ON I.id=S.product_id 

        LEFT JOIN erp_master_brand B ON I.brand=B.id 

        LEFT JOIN erp_master_unit U ON I.unit=U.id 

        LEFT JOIN erp_master_unit T ON I.sec_unit_id=T.id                                                             

        LEFT JOIN bluesell_new_main.erp_outlets O ON I.outlet=O.id where $condition AND (S.transaction_type='OUT' OR S.type='OB')  group by I.id)";

        Yii::app()->db->createCommand($SQL)->execute();

        $model = Yii::app()->db->createCommand("SELECT * FROM(SELECT id,part_number,description,active,brand_name,type,SUM(in_qty) AS in_qty,SUM(out_qty) AS out_qty,SUM(in_qty)-SUM(out_qty) AS qty,unit_exchange_rate,

        unit_name,sec_unit_id,base_unit_id,SUM(avg_purchase_rate) AS avg_purchase_rate,SUM(avg_sales_rate) AS avg_sales_rate,SUM(tax) AS tax,name,outlet_name,rate from erp_inventory_list group by id)A WHERE " . $stockcondition . " order by $orderBy limit $limit offset $offset")->queryAll();

        $rowData                = array();



        $counts = Yii::app()->db->createCommand("SELECT * FROM(SELECT id,part_number,description,active,brand_name,type,SUM(in_qty) AS in_qty,SUM(out_qty) AS out_qty,SUM(in_qty)-SUM(out_qty) AS qty,

        unit_name,SUM(avg_purchase_rate) AS avg_purchase_rate,SUM(avg_sales_rate) AS avg_sales_rate,SUM(tax) AS tax,name,outlet_name,rate from erp_inventory_list group by id)A WHERE " . $stockcondition . " order by $orderBy")->queryAll();

        $count          = count($counts);

        foreach ($model as $i => $row) {



            $inv_type = ($row['type'] == 'I') ? "Inventory" : "Service";

            $cost = '';

            $qty = '';

            $avg_purchase_rate = StockLedger::getAvgPurchaseRate($row['id'], '', $outlet); //$avg_purchase_rate = $row['avg_purchase_rate']

            $div = '<div class="text-center">';

            if ($row['active'] == 'Y') {

                if (Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM') {

                    $div .= '<button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'inventory/create&id=' . $row['id'] . '\',\'Edit - ' . $row['part_number'] . '\',\'lg\')"><i class="fa fa-edit" aria-hidden="true"></i></button>';

                    $div .= ' <button class="btn btn-danger btn-xs" title ="Block" onclick="block(' . $row['id'] . ',1)"><i class="fa fa-ban" aria-hidden="true"></i></button>';

                }

            } else {

                $div .= ' <button class="btn btn-theme btn-xs" title ="UnBlock" onclick="block(' . $row['id'] . ',2)"><i class="fa fa-unlock" aria-hidden="true"></i></button>';

            }

            $cost_change = MasOutlets::model()->findByPk(Yii::app()->user->outlet_id)->cost_change;

            if ($cost_change == 'Y') {

                $div .= '<button class="btn btn-primary btn-xs" title ="Edit Cost Rate" onclick="loadPopupModal(\'inventory/EditCostRate&id=' . $row['id'] . '\',\'Edit Cost - ' . $row['part_number'] . '\',\'lg\')"><i class="fa fa-usd" aria-hidden="true"></i></button>';

            }

            $sec_unit_id = $row['sec_unit_id'];

            $mas_unit = MasUnit::model()->findByPk($sec_unit_id);



            if ($mas_unit['unit_exchange_rate'] > 0) {

                $sec_qty = $row['qty'] / $mas_unit['unit_exchange_rate'];

            } else {

                $sec_qty = 0;

            }

            $div .= '</div>';

            $rowData[]  = array(($i + 1), $row['part_number'], $row['description'], $inv_type, $row['brand_name'], round($row['qty'], 3), $row['unit_name'], round($sec_qty, 2), $mas_unit['unit_name'], Yii::app()->numberFormatter->formatCurrency($avg_purchase_rate, " "), Yii::app()->numberFormatter->formatCurrency($row['rate'], " "), Yii::app()->numberFormatter->formatCurrency($row['tax'], " ") . '%', $row['outlet_name'], $div, $row['active']);

        }

        $data['data'] = $rowData;

        $recordsTotal   = $count;

        $recordsFiltered  = $count;

        $data['draw']   = $draw;

        $data['recordsTotal']   = $recordsTotal;

        $data['recordsFiltered'] = $recordsFiltered;

        echo json_encode($data);

    }

    public function actionCreate()

    {

        $id = (int) Yii::app()->request->getParam('id');

        $model = new Inventory;

        if ($id > 0) {

            $model = $model->findByPk($id);

        }

        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);

        $this->render('create', array('model' => $model));

    }



    public function actionSave()

    {

        $model = new Inventory();

        if (isset($_POST['Inventory'])) {



            if ($_POST['Inventory']['id'] > 0) {

                $id =  $_POST['Inventory']['id'];

                $model = $model->findByPK($id);



                $model->updated_time = date('Y-m-d h:i:s');

                $scene = 'update';

            } else {

                $model->created_by = Yii::app()->user->id;

                $model->created_time = date('Y-m-d h:i:s');

                $scene = 'new';

            }

            $model->attributes = $_POST['Inventory'];

            if ($model->barcode == '') {

                $model->barcode = $model->part_number;

            }

            $model->outlet = Yii::app()->user->outlet_id;

            $valid = $model->validate();

            if ($valid) {

                $model->tax = MasTax::model()->findByPk($model->tax_code)->tax_percentage;

                $model->save();

                StockLedger::model()->deleteAll(array('condition' => 'product_id=' . $model->id . ' AND type="OB" AND transaction_type="IN" AND outlet=' . Yii::app()->user->outlet_id));

                $stockledger = new StockLedger;

                $stockledger->transaction_date = date('Y-m-d');

                $stockledger->transaction_type = 'IN';

                $stockledger->type = 'OB';

                $stockledger->customer_vendor_id = 0;

                $stockledger->header_id = 0;

                $stockledger->item_id = 0;

                $stockledger->product_id = $model->id;

                $stockledger->rate = 0;

                $stockledger->currency = 1;

                $stockledger->exchange_rate = 1;

                $stockledger->quantity = 0;

                $stockledger->unit = $model->unit;

                $stockledger->default_product_unit = $model->units->base_unit_id;

                $stockledger->unit_exchange_rate = $model->units->unit_exchange_rate;

                $stockledger->outlet = Yii::app()->user->outlet_id;

                $stockledger->created_by = Yii::app()->user->id;

                $stockledger->created_time = date('Y-m-d H:i:s');

                $stockledger->save(false);

                $jsonData['status'] = 'success';

                echo CJSON::encode($jsonData);

            } else {

                $error1 = json_decode(CActiveForm::validate($model, '', false), true);

                $error = CJSON::encode(array_merge_recursive($error1));

                if ($error != '[]')

                    echo $error;

            }

        }

    }

    public function actionGetProducts()

    {

        $from = $_GET['frm'];

        $customer_id = $_GET['customer_id'];

        $vendor_id = $_GET['vendor_id'];

        $searchTerm = $_GET['term'];

        $from_user_id = $_GET['from_user_id'];

        $to_user_id = $_GET['to_user_id'];

        $transfer_date = $_GET['transfer_date'];

        $sales_man_id = (int)$_GET['sales_man'];

        $outlet_id = Yii::app()->user->outlet_id;

        

        $consider_previous_sprice = MasOutlets::model()->findByPk($outlet_id)->consider_previous_sprice;



        if (Yii::app()->user->user_access_type == 'SU' || Yii::app()->user->user_access_type == 'DEV' ||  Yii::app()->user->user_access_type == 'SM' || Yii::app()->user->user_access_type == 'OM') {

            $condition = '(part_number LIKE "%' . $searchTerm . '%" OR description LIKE "%' . $searchTerm . '%")';

        } else

            $condition = '(part_number LIKE "%' . $searchTerm . '%" OR description LIKE "%' . $searchTerm . '%" OR barcode LIKE "%' . $searchTerm . '%")  AND t. outlet=' . $outlet_id;

       // if ($from == 'PI' || $from == 'GR') {

            $condition .= ' AND t.active="Y"';

      //  }

        $model = new Inventory();

        $model = $model->findAll(array('select' => 't.id,t.part_number,t.description,t.rate,t.rate_a,t.rate_b,t.tax,t.unit,t.excise_tax', 'condition' => $condition, 'limit' => 20));

        $i = 0;

        $data = array();



        $sales_price_type = 0;

        if ((int)$customer_id > 0) {

            $sales_price_type = Customer::model()->findByPk($customer_id)->sales_price_type;

        }



        function calculateAvailableStock($product_id, $user_id, $transfer_date, $exclude_header_id, $outlet_id)

        {

            $common_condt = " AND product_id = '{$product_id}'  AND outlet = {$outlet_id}  AND created_by = {$user_id}";
            $in_qty = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}} WHERE transaction_type = 'IN' $common_condt ")->queryScalar();

            $out_qty = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}}  WHERE transaction_type = 'OUT' $common_condt ")->queryScalar();

            $date_condt = $common_condt . " AND transaction_date <= '{$transfer_date}'";

            $in_qty_on_date = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}}  WHERE transaction_type = 'IN' $date_condt")->queryScalar();

            $out_qty_on_date = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}}  WHERE transaction_type = 'OUT' $date_condt ")->queryScalar();

            $current_stock = round($in_qty - $out_qty, 3);

            $stock_on_date = round($in_qty_on_date - $out_qty_on_date, 3);


            return max($current_stock, $stock_on_date);

        }
        function calculateSalesAvailableStock($product_id, $user_id, $outlet_id)

        {

            $common_condt = " AND product_id = '{$product_id}'  AND outlet = {$outlet_id}  AND created_by = {$user_id}";
            $in_qty = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}} WHERE transaction_type = 'IN' $common_condt ")->queryScalar();

            $out_qty = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}}  WHERE transaction_type = 'OUT' $common_condt ")->queryScalar();

            $current_stock = round($in_qty - $out_qty, 3);

            return  $current_stock;

        }



        foreach ($model as $eachModel) {

        //    --------------------------------------
                $sales_available_qty = 0;

                    if ((int)$sales_man_id > 0) {

                        $sales_available_qty = calculateSalesAvailableStock(

                            $eachModel->id,

                            $sales_man_id,  

                            Yii::app()->user->outlet_id

                        );

                    }
        //    --------------------------------------

            $data[$i]['value'] = $eachModel->id;

            $data[$i]['label'] = $eachModel->part_number . ' : ' . $eachModel->description;

            $data[$i]['part_number'] = $eachModel->part_number. ' -(Avl qty : ' . $sales_available_qty .')';

            $data[$i]['description'] = $eachModel->description;

            if ($consider_previous_sprice == 'Y' && $from == 'SI') {

                $mod_pre_his = StockLedger::model()->with('sales_det')->find(array('condition' => 't.type ="SI" and sales_det.customer_id =' . $customer_id . ' AND product_id =' . $eachModel->id, 'order' => 't.id DESC'));

               

                if (empty($mod_pre_his)){

                         if ($sales_price_type == 1) {

                            $rate = $eachModel->rate;

                        } else if ($sales_price_type == 2) {

                            $rate = $eachModel->rate_a;

                        } else if ($sales_price_type == 3) {

                            $rate = $eachModel->rate_b;

                        } else {

                            $rate = $eachModel->rate;

                        }

                    $data[$i]['rate'] = $rate;

                }else {

                    $qty = ($mod_pre_his->quantity * $mod_pre_his->unit_exchange_rate);

                    if ($qty > 0) {

                        $rate = $mod_pre_his->rate / $qty;

                    } else {

                        

                        if ($sales_price_type == 1) {

                            $rate = $eachModel->rate;

                        } else if ($sales_price_type == 2) {

                            $rate = $eachModel->rate_a;

                        } else if ($sales_price_type == 3) {

                            $rate = $eachModel->rate_b;

                        } else {

                            $rate = $eachModel->rate;

                        }

                    }

                    $data[$i]['rate'] = $rate;

                }

            } else {

                if ($from == 'PI') {

                    $mod_pre_his = StockLedger::model()->with('pur_det')->find(array('condition' => 't.type ="PI" and pur_det.vendor_id =' . $vendor_id . ' AND product_id =' . $eachModel->id, 'order' => 't.id DESC'));

                    if (empty($mod_pre_his))

                        $data[$i]['rate'] = 0;

                    else {

                        if ($mod_pre_his->unit_exchange_rate * $eachModel->unit_exchange_rate > 0) {

                            $data[$i]['rate'] = $mod_pre_his->rate / $mod_pre_his->unit_exchange_rate * $eachModel->unit_exchange_rate;

                        } else {

                            $data[$i]['rate'] = 0;

                        }

                    }

                    $data[$i]['store_selling_price'] = $eachModel->rate;

                    $data[$i]['store_selling_price_a'] = $eachModel->rate_a;

                    $data[$i]['store_selling_price_b'] = $eachModel->rate_b;

                } else {

                    

                    if ($sales_price_type == 1) {

                            $rate = $eachModel->rate;

                    } else if ($sales_price_type == 2) {

                            $rate = $eachModel->rate_a;

                    } else if ($sales_price_type == 3) {

                            $rate = $eachModel->rate_b;

                    } else {

                            $rate = $eachModel->rate;

                    }

                    $data[$i]['rate'] = $rate;



                    // ------------------------------- From Available Quantity ------------------------------------------

                    $from_available_qty = 0;

                    if ((int)$from_user_id > 0) {

                        $from_available_qty = calculateAvailableStock(

                            $eachModel->id,

                            $from_user_id,

                            $transfer_date,

                            0,

                            Yii::app()->user->outlet_id

                        );

                    }





                    // ------------------------------- To Available Quantity ------------------------------------------

                    $to_available_qty = 0;

                    if ((int)$to_user_id > 0) {

                        $to_available_qty = calculateAvailableStock(

                            $eachModel->id,

                            $to_user_id,

                            $transfer_date,

                            0,

                            Yii::app()->user->outlet_id

                        );

                    }



                    $data[$i]['from_available_qty'] = $from_available_qty;

                    $data[$i]['to_available_qty'] = $to_available_qty;



                    // ----------------------------------------------------------------------





                }

            }

            //$data[$i]['cost'] = Yii::app()->db->createCommand("SELECT avg_purchase_rate from erp_inventory_list WHERE id=".$eachModel->id." AND in_qty>0")->queryScalar();

            $data[$i]['cost'] = StockLedger::getAvgPurchaseRate($eachModel->id, '', Yii::app()->user->outlet_id);

            $data[$i]['uom'] = $eachModel->unit;

            $data[$i]['uom_symbol'] = $eachModel->units->label;

            $data[$i]['tax'] = $eachModel->tax;

            $data[$i]['excise_tax'] = $eachModel->excise_tax;

            

            $data[$i]['unit_exchange'] = $eachModel->unit_exchange_rate;

            // --------------------------------------------

            $qty_condt = " AND product_id = '{$eachModel->id}'  AND outlet = '".Yii::app()->user->outlet_id."'  AND created_by = '".$sales_man_id."' ";

            $in_qty_single = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}} WHERE transaction_type = 'IN' $qty_condt ")->queryScalar();

            $out_qty_single = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}}  WHERE transaction_type = 'OUT' $qty_condt ")->queryScalar();

            $base_qty = round($in_qty_single - $out_qty_single, 3);

            

            $data[$i]['base_qty'] = $base_qty;

            

            // --------------------------------------------

            $i++;

        }

        echo CJSON::encode($data);

        Yii::app()->end();

    }

    

    

    

   

    public function actionEnableDisable()

    {

        $id    = $_POST['id'];

        $status    = $_POST['status'];

        $model = Inventory::model()->findByPk($id);

        if ($status == 1)

            $model->active = 'N';

        else

            $model->active = 'Y';

        $model->save(false);

        $data['status'] = 'success';

        echo CJSON::encode($data);

        Yii::app()->end();

    }

    public function actionEditCostRate()

    {

        $id = (int) Yii::app()->request->getParam('id');

        $model = new Inventory;

        if ($id > 0) {

            $model = $model->findByPk($id);

        }

        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);

        $this->render('edit_cost_rate', array('model' => $model));

    }

    public function actionSaveCostRate()

    {

        $cost = abs($_POST['Inventory']['cost']);

        $product_id = $_POST['Inventory']['id'];

        $outlet = Yii::app()->user->outlet_id;

        if ($product_id > 0) {

            $model = Inventory::model()->findByPk($product_id);

            // inserting to audit log

            $change_type = 'UPDATED';

            AuditLog::saveAuditLogs(3, Yii::app()->user->id, $change_type, " Product ID : " . $product_id . " Product : " . $model->description . " Cost : " . $cost);

            // end audit log

            $SQL = "update erp_stock_ledger SET rate=$cost where product_id=$product_id AND outlet=$outlet AND (type='GR' OR type='MTM')";

            Yii::app()->db->createCommand($SQL)->execute();

        }

        $data['status'] = 'success';

        echo CJSON::encode($data);

        Yii::app()->end();

    }

    

    

       public function actionGetProductByBarcode()

    {

        $from = $_POST['frm'];

        $customer_id = $_POST['customer_id'];

        $vendor_id = $_POST['vendor_id'];

        $barcode = trim($_POST['barcode']);

        $sales_man_id = (int)$_POST['sales_man'];

        $outlet_id = Yii::app()->user->outlet_id;

        $consider_previous_sprice = MasOutlets::model()->findByPk($outlet_id)->consider_previous_sprice;



        $condition = ' t.barcode="' . $barcode . '"';



       // if ($from == 'PI' || $from == 'GR') {

            $condition .= ' AND t.active="Y"';

       // }

        $model = new Inventory();

        $model = $model->find(array('select' => 't.id,t.part_number,t.description,t.barcode,t.rate,t.rate_a,t.rate_b,t.tax,t.unit,t.excise_tax', 'condition' => $condition, 'limit' => 20));

        $i = 0;

        $data = array();



        $sales_price_type = 0;

        if ((int)$customer_id > 0) {

            $sales_price_type = Customer::model()->findByPk($customer_id)->sales_price_type;

        }

        $data = [];

        if (!empty($model)) {





            $data['value'] = $model->id;

            $data['label'] = $model->part_number . ' : ' . $model->description;

            $data['part_number'] = $model->part_number;

            $data['description'] = $model->description;

            if ($consider_previous_sprice == 'Y' && $from == 'SI') {

                $mod_pre_his = StockLedger::model()->with('sales_det')->find(array('condition' => 't.type ="SI" and sales_det.customer_id =' . $customer_id . ' AND product_id =' . $model->id, 'order' => 't.id DESC'));



                if (empty($mod_pre_his)) {

                    if ($sales_price_type == 1) {

                        $rate = $model->rate;

                    } else if ($sales_price_type == 2) {

                        $rate = $model->rate_a;

                    } else if ($sales_price_type == 3) {

                        $rate = $model->rate_b;

                    } else {

                        $rate = $model->rate;

                    }

                    $data['rate'] = $rate;

                } else {

                    $qty = ($mod_pre_his->quantity * $mod_pre_his->unit_exchange_rate);

                    if ($qty > 0) {

                        $rate = $mod_pre_his->rate / $qty;

                    } else {



                        if ($sales_price_type == 1) {

                            $rate = $model->rate;

                        } else if ($sales_price_type == 2) {

                            $rate = $model->rate_a;

                        } else if ($sales_price_type == 3) {

                            $rate = $model->rate_b;

                        } else {

                            $rate = $model->rate;

                        }

                    }

                    $data['rate'] = $rate;

                }

            } else {

                if ($from == 'PI') {

                    $mod_pre_his = StockLedger::model()->with('pur_det')->find(array('condition' => 't.type ="PI" and pur_det.vendor_id =' . $vendor_id . ' AND product_id =' . $model->id, 'order' => 't.id DESC'));

                    if (empty($mod_pre_his))

                        $data['rate'] = 0;

                    else {

                        if ($mod_pre_his->unit_exchange_rate * $model->unit_exchange_rate > 0) {

                            $data['rate'] = $mod_pre_his->rate / $mod_pre_his->unit_exchange_rate * $model->unit_exchange_rate;

                        } else {

                            $data['rate'] = 0;

                        }

                    }

                    $data['store_selling_price'] = $model->rate;

                    $data['store_selling_price_a'] = $model->rate_a;

                    $data['store_selling_price_b'] = $model->rate_b;

                } else {



                    if ($sales_price_type == 1) {

                        $rate = $model->rate;

                    } else if ($sales_price_type == 2) {

                        $rate = $model->rate_a;

                    } else if ($sales_price_type == 3) {

                        $rate = $model->rate_b;

                    } else {

                        $rate = $model->rate;

                    }

                    $data['rate'] = $rate;

                }

            }

            $data['cost'] = StockLedger::getAvgPurchaseRate($model->id, '', Yii::app()->user->outlet_id);

            $data['uom'] = $model->unit;

            $data['uom_symbol'] = $model->units->label;

            $data['tax'] = $model->tax;

            $data['excise_tax'] = $model->excise_tax;

            $data['unit_exchange'] = $model->unit_exchange_rate;

            

              $qty_condt = " AND product_id = '{$model->id}'  AND outlet = '".Yii::app()->user->outlet_id."'  AND created_by = '".$sales_man_id."' ";

            $in_qty_single = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}} WHERE transaction_type = 'IN' $qty_condt ")->queryScalar();

            $out_qty_single = Yii::app()->db->createCommand(" SELECT IFNULL(SUM(quantity * unit_exchange_rate), 0)  FROM {{stock_ledger}}  WHERE transaction_type = 'OUT' $qty_condt ")->queryScalar();

            $base_qty = round($in_qty_single - $out_qty_single, 3);

            

            $data['base_qty'] = $base_qty;

        }

        echo CJSON::encode($data);

        Yii::app()->end();

    }

    

    

}

