<?php

class MaterialconversionController extends Controller {

    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index', 'GetList', 'Create', 'Save','Cancel','PrintPDF'),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex() {
        $this->render('index');
    }
    
    public function actionCreate() {
        $id = (int) Yii::app()->request->getParam('id');
        $model = new MaterialConversion;
        if ($id > 0) {
            $model = $model->findByPk($id);
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model));
    }

    public function actionGetList() {
        $model  = new MaterialConversion();
        $draw   = $_POST['draw'];
        $offset = $_POST['start'];
        $limit  = $_POST['length'];
        $outlet = $_POST['outlet'];
        $from = $_POST['from'];
        $to = $_POST['to'];
        $customer = $_POST['customer_id'];
        $created_user = $_POST['created_user'];
        $columns = array(
            0 => 't.conversion_no',
            1 => 't.conversion_date',
            2 => 'conv_frm_pdt.part_number',
            3 => 't.from_quantity',
            4 => 'conv_frm_unit.label',
            5 => 'conv_to_pdt.part_number',
            6 => 't.to_quantity',
            7 => 'conv_to_unit.label',
            8 => 'conv_user.full_name',
            9 => 'conv_outlet.outlet_name',
            10 => 't.id',
            11 => 't.active'
        );
        $filterColumn   = $columns[$_POST['order'][0]['column']];
        $filterOrder    = $_POST['order'][0]['dir'];
        $filterColumn1   = $columns[$_POST['order'][1]['column']];
        $filterOrder1    = $_POST['order'][1]['dir'];
        if($filterColumn1!='' && $filterOrder1!='')
        {
        $second_sort=",".$filterColumn1 . " " . $filterOrder1;
        }
        else {
        $second_sort="";    
        }
        $orderBy        = $filterColumn . " " . $filterOrder.$second_sort;
        $condition      = '1=1';
        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            $condition.=" AND (t.conversion_no LIKE '%" . $searchString . "%' OR conv_frm_pdt.part_number LIKE '%" . $searchString . "%' )";
        }
        if($outlet>0){
            $condition.=" AND t.outlet=".$outlet;
        }
        if($from!='' && $from!='00/00/0000')
        {
            $from = str_replace('/', '-',$from);
            $from=date("Y-m-d", strtotime($from));
            $condition.=' AND t.conversion_date>="'.$from.'"';    
        }
        if($to!='' && $to!='00/00/0000')
        {
            $to = str_replace('/', '-',$to);
            $to=date("Y-m-d",strtotime($to));
            $condition.=' AND t.conversion_date<="'.$to.'"';    
        }
        if($created_user >0)
        {
            $condition.=' AND (t.created_by='.$created_user.')';    
        }
        $count          = $model->with('conv_frm_pdt','conv_to_pdt','conv_user','conv_to_unit','conv_frm_unit')->count(array('condition' => $condition));
        $model          = $model->with('conv_frm_pdt','conv_to_pdt','conv_user','conv_to_unit','conv_frm_unit')->findAll(array('condition' => $condition, 'limit' => $limit, 
        'offset' => $offset, 'order' => $orderBy));
        $recordsTotal   = $count;
        $recordsFiltered        = $count;
        $data['draw']   = $draw;
        $data['recordsTotal']   = $recordsTotal;
        $data['recordsFiltered']= $recordsFiltered;
        $rowData                = array();
        foreach ($model as $row)
        {
            $div= '<div class="text-center">';
            if($row['active']=='Y'){
                if(Yii::app()->user->user_access_type != 'DEV'&& Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM'){ 
                    $div.= ' <button class="btn btn-danger btn-xs" title ="Cancel" onclick="CancelConversion('.$row['id'].')"><i class="fa fa-ban" aria-hidden="true"></i></button>';
                }
            }
            /*$div .= '<button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'materialconversion/create&id='.$row['id'].'\',\'Edit - '.$row['conversion_no'].'\',\'xl\')">
            <i class="fa fa-edit" aria-hidden="true"></i></button>';*/
            $div .= ' <a class="btn btn-primary btn-xs" title="Print Material Conversion" target="_blank" href="index.php?r=materialconversion/PrintPDF&id=' . $row['id'] .'">
            <i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>';
            $div .= ' </div>';
            $rowData[]  = array($row['conversion_no'],date("d/m/Y",strtotime($row['conversion_date'])),$row['conv_frm_pdt']['part_number'],
            Yii::app()->numberFormatter->formatCurrency($row['from_quantity'],''),$row['conv_frm_unit']['label'],$row['conv_to_pdt']['part_number'],
            Yii::app()->numberFormatter->formatCurrency($row['to_quantity'],''),$row['conv_to_unit']['label'],$row['conv_user']['full_name'],$row['conv_outlet']['outlet_name'],$div,$row['active']);
        } 
        $data['data'] = $rowData;
        echo json_encode($data);
    }
    public function actionSave(){
        $model = new MaterialConversion();
        if (isset($_POST['MaterialConversion'])) {
            $other=array();
            if ($_POST['MaterialConversion']['id'] > 0) {
                $id =  $_POST['MaterialConversion']['id'];
                $model = $model->findByPK($id);
                $scene = 'update';
                $change_type = 'UPDATED';
            } else {
                $model->created_by = Yii::app()->user->id;
                $model->created_time = date('Y-m-d H:i:s');
                $scene = 'new';
                $change_type = 'CREATED';                
            }
            $modelformmaster=FormMaster::model()->find(array('condition'=>'outlet='.Yii::app()->user->outlet_id.' AND code="MTM"'));
            $model->updated_by = Yii::app()->user->id;
            $model->updated_time =date('Y-m-d H:i:s');
            $model->attributes = $_POST['MaterialConversion'];
            $model->outlet=Yii::app()->user->outlet_id;
            if($_POST['MaterialConversion']['conversion_date']!='00/00/0000')
            {
                $model->conversion_date = str_replace('/', '-', $_POST['MaterialConversion']['conversion_date']);
                $model->conversion_date= date("Y-m-d", strtotime($model->conversion_date));
            }
            if($scene =='new'){
                if(empty($modelformmaster)){
                    $model->conversion_no=9001;
                }else
                $model->conversion_no=$modelformmaster->next_number;
            }
            $valid = true;
            
            // QTY Checking
            $product=Inventory::model()->findByPk($model->from_product_id);
            $qty=Yii::app()->db->createCommand("select IFNULL(SUM(from_quantity*U.unit_exchange_rate),0) AS qty from {{material_conversion}} M INNER JOIN {{master_unit}} U ON M.from_unit=U.id 
            where M.id='".$model->id."' AND M.from_product_id='".$model->from_product_id."'")->queryScalar();
            $bal=$model->from_quantity-$qty;
            $in_qty=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='".$model->from_product_id."' 
            AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->created_by." AND transaction_date<='".$model->conversion_date."'")->queryScalar();
            $out_qty=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='".$model->from_product_id."'
             AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->created_by." AND transaction_date<='".$model->conversion_date."'")->queryScalar();
            $current_stock=$in_qty-$out_qty;
            if($bal>0 && $current_stock<$bal)
            {
                $other[]=$product->part_number.' maximum available qty : '.($current_stock+$qty).' '.$product->units->unit_name;
                $valid=false;
            }
            if($model->from_product_id==$model->to_product_id)
            {
                $other[]='From and To Product Cannot Be Same';
                $valid=false;
            }
            $closing_date=MasClosing::getClosingDate();
        if($closing_date>=$model->conversion_date)
        {
        $other[]='Date should be greater than closing date ('.date('d-m-Y',strtotime($closing_date)).')'; 
        $valid=false;    
        }
            if($valid && $model->validate()){
                if($_POST['MaterialConversion']['conversion_date']!='00/00/0000')
                {
                $model->conversion_date = str_replace('/', '-', $_POST['MaterialConversion']['conversion_date']);
                $model->conversion_date= date("Y-m-d", strtotime($model->conversion_date));
                }
                
                $model->save();
                if($scene =='new'){
                    $next_no=$model->conversion_no+1;
                    if(!empty($modelformmaster)){
                        FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
                    }else{
                        $modelformmaster= new FormMaster();
                        $modelformmaster->code='MTM';
                        $modelformmaster->title='Material To Material Transfer';
                        $modelformmaster->next_number=$next_no;
                        $modelformmaster->outlet=Yii::app()->user->outlet_id;
                        $modelformmaster->save(false);
                    }
                    
                }
    		Yii::app()->db->createCommand("delete from {{stock_ledger}} where type='MTM' AND header_id='".$model->id."' AND outlet=".Yii::app()->user->outlet_id)->execute();
                $rate=StockLedger::getAvgPurchaseRate($model->from_product_id,'',Yii::app()->user->outlet_id);	
    		$amount =$rate*$model->from_quantity;
                $stockledger = new StockLedger;
                $stockledger->transaction_date=$model->conversion_date;
                $stockledger->transaction_type='OUT';
                $stockledger->type='MTM';
                $stockledger->customer_vendor_id='-';
                $stockledger->header_id=$model->id;
                $stockledger->item_id=$model->id;
                $stockledger->product_id=$model->from_product_id;
                $stockledger->rate=$rate;
                $stockledger->currency=1;
                $stockledger->exchange_rate=1;
                $stockledger->quantity=$model->from_quantity;
                $stockledger->unit=$model->from_unit;
                $stockledger->default_product_unit=$model->conv_frm_unit->base_unit_id;
                $stockledger->unit_exchange_rate=$model->conv_frm_unit->unit_exchange_rate;
                $stockledger->outlet=Yii::app()->user->outlet_id;
                $stockledger->created_by=$model->created_by;
                $stockledger->created_time=date('Y-m-d H:i:s');
                $stockledger->save(false);
                $stockledger = new StockLedger;
                $stockledger->transaction_date=$model->conversion_date;
                $stockledger->transaction_type='IN';
                $stockledger->type='MTM';
                $stockledger->customer_vendor_id='-';
                $stockledger->header_id=$model->id;
                $stockledger->item_id=$model->id;
                $stockledger->product_id=$model->to_product_id;
                if($model->to_quantity>0)
                $stockledger->rate=$amount/$model->to_quantity;
                $stockledger->currency=1;
                $stockledger->exchange_rate=1;
                $stockledger->quantity=$model->to_quantity;
                $stockledger->unit=$model->to_unit;
                $stockledger->default_product_unit=$model->conv_to_unit->base_unit_id;
                $stockledger->unit_exchange_rate=$model->conv_to_unit->unit_exchange_rate;
                $stockledger->outlet=Yii::app()->user->outlet_id;
                $stockledger->created_by=$model->created_by;
                $stockledger->created_time=date('Y-m-d H:i:s');
                $stockledger->save(false);
                // inserting to audit log
                AuditLog::saveAuditLogs(
                    $modelformmaster->id,
                    Yii::app()->user->id,
                    $change_type,
                    " with ID - {$model->id}"
                );
                    // end audit log
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                $error = CJSON::encode(array_merge_recursive($error1,$other));
                if ($error != '[]'){
                    echo $error;    
                }
            }
        }
    }
    public function actionPrintPDF(){
        $id = Yii::app()->request->getParam('id');
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $model          = MaterialConversion::model()->findByPk($id);
        if($model->active=='N'){
            $mPDF1->SetWatermarkText('CANCELLED');
            $mPDF1->showWatermarkText = true;
        }
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.material_conversion_print', array('id' => $id, 'title' => $title),true));
        $mPDF1->Output($htmlTemplate, 'I');
    }
     public function actionCancel(){
        $id     = $_POST['id'];
        $valid  = true;$other=array();
        $model  = MaterialConversion::model()->findByPk($id);
        $condt =" AND product_id='".$model->to_product_id."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->created_by." AND header_id!=".$model->id;
    	$in_qty=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='IN' ".$condt)->queryScalar();
    	$out_qty=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='OUT' ".$condt)->queryScalar();
        $in_qty_on_date=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='".$model->conversion_date."' AND
            transaction_type='IN' ".$condt)->queryScalar();
	    $out_qty_on_date=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='".$model->conversion_date."' AND 
	        transaction_type='OUT' ".$condt)->queryScalar();
    	$current_stock=$in_qty-$out_qty;
    	$stock_on_date =$in_qty_on_date-$out_qty_on_date;  
    	$product=Inventory::model()->findByPk($model->to_product_id);
	        
    	if($current_stock < $model->to_quantity)
    	{
	        $other[]=$product->part_number.' available quantity mismatch'; 
	        $valid=false;
	    }
	    if($stock_on_date < $eachProduct['quantity'])
	    {
	        $other[]=$product->part_number.' available quantity mismatch on'.$model->conversion_date; 
	        $valid=false;
	    }      
            
        $closing_date=MasClosing::getClosingDate();
        if($closing_date>=$model->conversion_date)
        {
        $other[]='Date should be greater than closing date ('.date('d-m-Y',strtotime($closing_date)).')'; 
        $valid=false;    
        }
        if($valid){
            StockLedger::model()->deleteAll('header_id='.$model->id.' AND type= "MTM" AND outlet='.Yii::app()->user->outlet_id);
            $model->active='N';
            $model->save(false);
            $jsonData['status']='success';
            echo CJSON::encode($jsonData);
        }else{
            $error = CJSON::encode(array_merge_recursive($other));
            if ($error != '[]'){
                echo $error;    
            }
        }
        
    }
}
