<?php

class OrdercollectController extends Controller
{

    public function accessRules()
    {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index', 'GetList', 'Create', 'Save','GetSimilarUnits', 'DeleteItem', 'PrintOrderReportPDF', 'PrintOrderCollectPDF', 'OrderList',
                    'refreshOrderList','Convertfromquotes','CancelOrder'),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex()
    {
        $this->render('index');
    }

    public function filters()
    {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    public function actionGetList()
    {
        //for login salesman
        $login_user = Yii::app()->user->id;
        $salesman_id = $_POST['salesman'];

        $modelordercollect = new OrderCollect();
        $draw = $_POST['draw'];
        $offset = $_POST['start'];
        $limit = $_POST['length'];
        $from = $_POST['from'];
        $to = $_POST['to'];
        $columns = array(
            // datatable column index  => database column name
            0 => 'id',
            1 => 'oc_customer_det.customer_name',
            2 => 'order_date',
            3 => 'oc_salesman_det.full_name',
            4 => 't.id',
        );

        $filterColumn = $columns[$_POST['order'][0]['column']];
        $filterOrder = $_POST['order'][0]['dir'];
        $orderBy = $filterColumn . " " . $filterOrder;
        $date = count(explode('/', $_POST['date'])) == 3 ? date('Y-m-d', strtotime(str_replace('/', '-', $_POST['date']))) : date('Y-m-d');
       
       
      //  $condition = 't.is_invoiced="N" AND t.active="Y" AND t.order_date="' . $date . '"';
        
        $condition = 't.is_invoiced="N" AND t.active="Y"';
        
        
        
        if ($from != '' && $from != '00/00/0000') {

            $from = str_replace('/', '-', $from);

            $from = date("Y-m-d", strtotime($from));

            $condition .= ' AND t.order_date>="' . $from . '"';
        }

        if ($to != '' && $to != '00/00/0000') {

            $to = str_replace('/', '-', $to);

            $to = date("Y-m-d", strtotime($to));

            $condition .= ' AND t.order_date<="' . $to . '"';
        }
        

        if ($salesman_id>0) {
            $condition .= ' AND t.salesman_id = "' . $salesman_id . '" ';
        }

        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            $condition = "t.id LIKE '%" . $searchString . "%' OR oc_customer_det.customer_name LIKE '%" . $searchString . "%' OR oc_salesman_det.full_name LIKE '%" . $searchString . "%' OR t.order_date LIKE '%" . $searchString . "%'";
        }

        $count = $modelordercollect->with('oc_customer_det', 'oc_salesman_det')->count(array('condition' => $condition));
        $modelordercollect = $modelordercollect->with('oc_customer_det', 'oc_salesman_det')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => 't.id desc'));
        $recordsTotal = $count;
        $recordsFiltered = $count;
        $data['draw'] = $draw;
        $data['recordsTotal'] = $recordsTotal;
        $data['recordsFiltered'] = $recordsFiltered;
        $rowData = array();

        foreach ($modelordercollect as $i => $row) {

            $div = '';
            $div .= '<div class="text-center">';
            if ($row['is_invoiced'] == 'N') {
                $div .= '<button class="btn btn-primary btn-xs" title="Edit Order" onclick="loadPopupModal(\'ordercollect/create&id=' . $row['id'] . '\',\' Edit Order\',\'xl\')"><i class="fa fa-pencil"></i></button> ';
                $div .= ' <button class="btn btn-primary btn-xs" title="Convert to Invoice" onclick="loadPopupModal(\'salesinvoice/Convertfromorder&order_id=' . $row['id'] . '\',\' New Sales Invoice \',\'xl\')"><i class="fa fa-retweet"></i></button> ';
               if ($row['active'] == 'Y') {
                 $div .= ' <button class="btn btn-danger btn-xs" title ="Cancel" onclick="cancelorder(' . $row['id'] . ')"><i class="fa fa-ban" aria-hidden="true"></i></button>';
               }
            }
            $div .= ' <a class="btn btn-primary btn-xs" title="Print PDF" target="_blank" href="?r=ordercollect/PrintOrderReportPDF&id=' . $row['id'] . '"><i class="fa fa-file-pdf-o"></i></a>';
            $div .= ' </div>';
            $rowData[] = array($row['id'], $row['oc_customer_det']['customer_name'], date("d/m/Y", strtotime($row['order_date'])), $row['oc_salesman_det']['full_name'], $div);
        }
        $data['data'] = $rowData;
        echo json_encode($data);
    }

    public function actionCreate()
    {
        $model = new OrderCollect();
        $id = Yii::app()->request->getParam('id');
        $post = Yii::app()->request->getParam('type');
        $modelItems = array(new OrderCollectItem);
        if ($id > 0) {
            $model = $model->findByPk($id);
            $modelItems = OrderCollectItem::model()->findAll(array('condition' => 'order_id="' . $id . '"'));
            if (empty($modelItems)) {
                $modelItems = array(new OrderCollectItem());
            }
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, 'jquery-2.1.4.min.js' => false);
        $this->render('create', array('model' => $model, 'modelItems' => $modelItems));
    }

    public function actionSave()
    {
        if (isset($_POST['OrderCollect'])) {
            $modelOrder = new OrderCollect;
            $others = array();
            if ((int) $_POST['OrderCollect']['id'] > 0) {
                $modelOrder = $modelOrder->findByPK($_POST['OrderCollect']['id']);
                $modelOrder->updated_by = Yii::app()->user->id;
                $modelOrder->updated_date_time = date('Y-m-d H:i:s');
                 $change_type = 'UPDATED';
            } else {
                $modelOrder->created_by = Yii::app()->user->id;
                $modelOrder->created_date_time = date('Y-m-d H:i:s');
                 $change_type = 'CREATED';     
            }
            $modelOrder->attributes = $_POST['OrderCollect'];
            if ($_POST['OrderCollect']['order_date'] != '') {
                $modelOrder->order_date = str_replace('/', '-', $_POST['OrderCollect']['order_date']);
                $modelOrder->order_date = date("Y-m-d", strtotime($modelOrder->order_date));
            } else {
                $modelOrder->order_date = date("Y-m-d");
            }
            $modelOrder->salesman_id = $_POST['OrderCollect']['salesman_id'];
            $modelOrder->notes = $_POST['OrderCollect']['notes'];
            $modelOrder->outlet =(int) Yii::app()->user->outlet_id;
            $modelOrder->quote_collect_id= (int)$_POST['OrderCollect']['quote_collect_id'];
            $valid = $modelOrder->validate();
            $products_id = array();
            $arr_pdts =[];
            if (is_array($_POST['OrderCollectItem'])) {
                foreach ($_POST['OrderCollectItem'] as $i => $item) {
                    if ($item['product_id'] != '') {
                        $modelOrderItems[$i] = new OrderCollectItem;
                        $modelOrderItems[$i]->attributes = $item;
                        $modelOrderItems[$i]->order_id = 0;
                        $modelOrderItems[$i]->description = $item['description'];
                        $modelOrderItems[$i]->unit_id = $item['unit_id'];
                        if( $item['unit_id']>0){
                            $unit=MasUnit::model()->findByPk($item['unit_id']);
                            $modelOrderItems[$i]->unit_factor=$unit->unit_exchange_rate;
                            $modelOrderItems[$i]->base_unit_id=$unit->base_unit_id;
                            $modelOrderItems[$i]->base_unit_qty=$unit->unit_exchange_rate * $item['quantity'];
                        }
                        
                         // --------------------------------------------------
                        $unit = MasUnit::model()->findByPk($item['unit_id']);
                         // Construct the composite key using product_id and unit
                            $compositeKey = $item['product_id'] . '-' . $item['unit_id'];
                            
                            // Check if the composite key already exists
                            if (in_array($compositeKey, $arr_pdts)) {
                                $valid = false; // Mark validation as failed
                                $others[] = 'Product ' . $item['part_no'] . ' with Unit ' . $unit->label . ' is duplicated ,Line No:-'.($i+1);
                            } else {
                                // Add the composite key to the array
                                $arr_pdts[] = $compositeKey;
                            }
                        // --------------------------------------------------
                        

                        /*                         * **************** END Code added by jisha on 17/06/2019 for secondary unit calculation ******************** */

                        $valid = $modelOrderItems[$i]->validate() && $valid;
                    }
                }
            }
            
            if($modelOrder->is_invoiced=='Y'){
             $others[]='This order has already been converted to an invoice.'; 
             $valid=false; 
            }
            
            if($change_type == 'CREATED' ){
                $mod_Quotes = Quotes::model()->find(array('condition'=>'id ='.$modelOrder->quote_collect_id.' AND is_ordered="Y"'));
                if(!empty($mod_Quotes)){
                     $others[]='This Quotation has already been converted to an Order.'; 
                     $valid=false; 
                }
            }
            
            if ($valid && !empty($modelOrderItems)) {
                $modelOrder->save();

                OrderCollectItem::model()->deleteAll('order_id=:refer_id', array(':refer_id' => $modelOrder->id));
                if (!empty($modelOrderItems)) {
                    foreach ($modelOrderItems as $eachItem) {
                        $eachItem->order_id = $modelOrder->id;
                        $eachItem->save();
                    }
                }
                
                if($modelOrder->quote_collect_id>0){
                     Quotes::model()->updateByPk($modelOrder->quote_collect_id, array('is_ordered' => 'Y'));
                }

                $jsonData['status'] = 'success';

                echo CJSON::encode($jsonData);
            } else {
                $error1 = $error2 = $error3 = $error4 = array();
                $error1 = json_decode(CActiveForm::validate($modelOrder, '', false), true);
                if (!empty($modelOrderItems[0]->product_id)) {
                    $error2 = json_decode(CActiveForm::validateTabular($modelOrderItems, '', false), true);
                } else {
                    $error2[] = "Please add atleast one line item";
                }

                $error = CJSON::encode(array_merge_recursive($error1, $error2,$others));

                if ($error != '[]') {
                    echo $error;
                }

            }
        } else {
            echo 'error';
        }
    }
    public function actionGetSimilarUnits(){
        $unit_id=$_POST['unit'];
        $i=$_POST['row_field'];
        $arr_units=MasUnit::getSimilarUnits($unit_id);
        $modelItems=new OrderCollectItem();
        $modelItems->unit_id=$unit_id;
        $data['unit']=CHtml::activeDropDownList($modelItems, "[" . $i . "]unit_id",$arr_units, array("class" =>"go cell-center text-center",'onchange'=>'getPriceOnUnitChange(this.id)'));
        echo CJSON::encode($data);
    }
    /*public function actionDeleteItem()
    {
        $id = $_POST['id'];
        if ($id > 0) {
            OrderCollectItem::model()->deleteByPk($id);
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
        }
    }*/

    public function actionPrintOrderReportPDF()
    {
        $id = Yii::app()->request->getParam('id');
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.order_collect_print', array('model' => $model, 'id' => $id), true));
        $mPDF1->Output($htmlTemplate, 'I');
    }

    public function actionPrintOrderCollectPDF()
    {
        $frm = Yii::app()->request->getParam('frm');
        $salesman_id = (int) Yii::app()->request->getParam('salesman_id');
         $order_date = Yii::app()->request->getParam('order_date');
         $from = Yii::app()->request->getParam('from');
         $to = Yii::app()->request->getParam('to');

        //$created_date_time= Yii::app()->request->getParam('created_date_time');
        if (!empty($order_date)) {
            $str_order_date = str_replace('/', '-', $order_date);
            $str_order_date = date("Y-m-d ", strtotime($str_order_date));
        }
        
        if ($from != '' && $from != '00/00/0000') {

            $from = str_replace('/', '-', $from);

            $from = date("Y-m-d", strtotime($from));

            //$condition .= ' AND t.invoice_date>="' . $from . '"';
        }

        if ($to != '' && $to != '00/00/0000') {

            $to = str_replace('/', '-', $to);

            $to = date("Y-m-d", strtotime($to));

           // $condition .= ' AND t.invoice_date<="' . $to . '"';
        }
        
        
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mPDF1->WriteHTML($stylesheet, 1);
        if ($frm == 'salesman') {
            $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.print_order_collect_detailed', array('arr_list' => $arr_list, 'frm' => $frm, 'order_date' => $order_date,'from' => $from,'to' => $to, 'salesman_id' => $salesman_id, 'str_order_date'=> $str_order_date), true));
        } else {
            $sql="SELECT O.id AS order_id,O.order_date,O.salesman_id,O.customer_id,O.outlet,OI.product_id,I.part_number,OI.description,SUM(OI.base_unit_qty)/U.unit_exchange_rate AS quantity,OI.unit_id,OI.base_unit_id,SUM(OI.base_unit_qty) AS base_qty,OI.unit_factor,BU.unit_name as base_unit,U.unit_name as ordered_unit,U.unit_exchange_rate
                    FROM erp_order_collect_item OI
                    LEFT JOIN erp_order_collect O ON O.id=OI.order_id
                    LEFT JOIN erp_inventory I ON I.id=OI.product_id
                    LEFT JOIN erp_master_unit U ON U.id=I.sec_unit_id
                    LEFT JOIN erp_master_unit BU ON BU.id=OI.base_unit_id
                    LEFT JOIN bluesell_new_main.erp_users MU ON MU.id=O.salesman_id
                    WHERE O.order_date>= '".$from."' AND O.order_date<= '".$to."' AND  O.is_invoiced='N' AND O.outlet =".(int) Yii::app()->user->outlet_id."
                    GROUP BY I.id,O.order_date"   ; 
            
            //$SQL = "SELECT SUM(primary_unit_qty) as quantity,part_no,primary_unit_id as unit,salesman_name,description,salesman_id,SUM((primary_unit_qty/sec_factor)) AS secondary_qty,secondary_unit_symbol as secondary_unit, generic_name FROM view_order_collect WHERE is_invoiced='N' AND order_date='" . $str_order_date . "' GROUP BY product_id";
            $arr_list = Yii::app()->db->createCommand($sql)->queryAll();
            $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.print_order_collect_datewise', array('arr_list' => $arr_list, 'frm' => $frm,'from' => $from,'to' => $to, 'order_date' => $order_date), true));
        }
        $mPDF1->Output($htmlTemplate, 'I');
    }

    public function actionOrderList()
    {
        $this->render('orderlist');
    }
    public function actionrefreshOrderList()
    {
        $salesman_id = $_POST['salesman_id'];
        $order_date = $_POST['order_date'];
        $this->renderPartial('orderlisttbody', array('salesman_id' => $salesman_id, 'order_date' => $order_date));

    }
    
    public function actionConvertfromquotes()
    {
        $model = new OrderCollect();
        $quotes_id = Yii::app()->request->getParam('quotes_id');
        $modelItems     = array(new OrderCollectItem);
        if ($quotes_id > 0) {
            $model->quote_collect_id = $quotes_id;
            $quotesmodel = new Quotes();
            $quotesmodel = $quotesmodel->findByPk($quotes_id);
            $model->customer_id = $quotesmodel->customer_id;
            $model->salesman_id = $quotesmodel->salesman_id;
            $model->outlet =$quotesmodel->outlet_id;
            $modelQuotesItem = QuotesItem::model()->findAll(array('condition' => 'quotes_id="' . $quotes_id . '"'));
            if (!empty($modelQuotesItem)) {
                foreach ($modelQuotesItem as $i => $eachitem) {
                    $modelItems[$i] = new OrderCollectItem();
                    $modelItems[$i]->product_id = $eachitem->product_id;
                    $modelItems[$i]->description = $eachitem->description;
                    $modelItems[$i]->quantity = $eachitem->quantity;
                    $modelItems[$i]->rate = $eachitem->rate;
                    $modelItems[$i]->amount = $eachitem->amount;
                    $modelItems[$i]->tax_percentage = $eachitem->tax_percentage;
                    $modelItems[$i]->tax_amount = $eachitem->tax_amount;
                    $modelItems[$i]->net_amount = $eachitem->net_amount;
                    $modelItems[$i]->unit_id = $eachitem->unit_id;
                }
            }

        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model, 'modelItems' => $modelItems));
    }
    
      public function actionCancelOrder()
    {
        $id     = $_POST['id'];
        $valid  = true;
        $model  = OrderCollect::model()->findByPk($id);
        $closing_date = MasClosing::getClosingDate();
        if ($closing_date >= $model->order_date) {
            $jsonData['error_note'] = 'Date should be greater than closing date (' . date('d-m-Y', strtotime($closing_date)) . ')';
            $jsonData['status'] = 'error';
        } else if($model->is_invoiced=='Y'){
            $jsonData['error_note'] = 'Cannot cancel order, it has already been invoiced';
            $jsonData['status'] = 'error';
        }
        else {
            $model->active = 'N';
            $model->save(false);
            $jsonData['status'] = 'success';
        }
        echo CJSON::encode($jsonData);
    }
    
}
