<?php

class ProductionController extends Controller {

    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index','GetList', 'Create','Save','PrintPDF','getSimilarUnits','Cancelproduction','GetSimilarUnits1',),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex() {
        $this->render('index');
    }

      public function actionGetList() {
        $model  = new Production();
        $draw   = $_POST['draw'];
        $offset = $_POST['start'];
        $limit  = $_POST['length'];
        $outlet = $_POST['outlet'];
        $created_user = $_POST['created_user'];
        $from = $_POST['from'];
        $to = $_POST['to'];
        $columns = array(
            // datatable column index  => database column name
            0 => 't.id',
            1 => 't.production_date',
            2 => 't.production_no',
            3 => 't.reference',
        );
        $filterColumn   = $columns[$_POST['order'][0]['column']];
        $filterOrder    = $_POST['order'][0]['dir'];
        $orderBy        = $filterColumn . " " . $filterOrder;
        $condition      = '1=1';
        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            $condition.=" AND (t.production_no LIKE '%" . $searchString . "%' OR t.reference LIKE '%" . $searchString . "%'  OR t.notes LIKE '%" . $searchString . "%' )";
        }
        if($outlet>0){
            $condition.=" AND t.outlet=".$outlet;
        }
        if($from!='' && $from!='00/00/0000')
        {
            $from = str_replace('/', '-',$from);
            $from=date("Y-m-d", strtotime($from));
            $condition.=' AND t.production_date>="'.$from.'"';    
        }
        if($to!='' && $to!='00/00/0000')
        {
            $to = str_replace('/', '-',$to);
            $to=date("Y-m-d",strtotime($to));
            $condition.=' AND t.production_date<="'.$to.'"';    
        }
        if($created_user >0)
        {
            $condition.=' AND (t.sales_man='.$created_user.')';    
        }
        $count          = $model->with('pr_outlet')->count(array('condition' => $condition));
        $model          = $model->with('pr_outlet')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));
        $recordsTotal   = $count;
        $recordsFiltered        = $count;
        $data['draw']   = $draw;
        $data['recordsTotal']   = $recordsTotal;
        $data['recordsFiltered']= $recordsFiltered;
        $rowData                = array();
        foreach ($model as $i=>$row)
        {
            $div= '<div class="text-center">';
            if($row['active']=='Y'){
                if(Yii::app()->user->user_access_type != 'DEV'&& Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM'){ 
//                    $div.= ' <button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'production/create&id='.$row['id'].'\',\'Edit - '.$row['production_no'].'\',\'lg\')"><i class="fa fa-edit" aria-hidden="true"></i></button>';
                    $div.= ' <button class="btn btn-danger btn-xs" title ="Cancel" onclick="cancelproduction('.$row['id'].')"><i class="fa fa-ban" aria-hidden="true"></i></button>';
                }
            }
            $div .= ' <a class="btn btn-primary btn-xs" title="Print Production" target="_blank" href="index.php?r=production/PrintPDF&id=' . $row['id'] .'"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>';
            $div .= ' </div>';
            $rowData[]  = array(($i+1),date('d/m/Y', strtotime($row['production_date'])),$row['production_no'],$row['reference'], $row['description'],$row['quantity'],'',$div,$row['active']);
        }
        $data['data'] = $rowData;
        echo json_encode($data);
    }
    
    public function actionCreate() {
       $id = (int) Yii::app()->request->getParam('id');
        $model = new Production;
        $modelItems     = array(new ProductionItems);
        if ($id > 0) {
            $model = $model->findByPk($id);
            $modelItems = ProductionItems::model()->findAll(array('condition' => 'production_id="' . $id . '"','order'=>'id ASC'));
            if (empty($modelItems)) {
                $modelItems = array(new ProductionItems());
            }
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model, 'modelItems' => $modelItems));
    }
    public function actionSave() {
        $model          = new Production();
        date_default_timezone_set("Asia/Dubai");
        $valid = true;
        $groups = $other=array();
        if (isset($_POST['Production'])) {

            if ($_POST['Production']['id'] > 0) {
                $id =  $_POST['Production']['id'];
                $model = $model->findByPK($id);
                $scene = 'update';
                $change_type = 'UPDATED';
            } else {
                $model->created_by = Yii::app()->user->id;
                $model->created_time = date('Y-m-d H:i:s');
                $scene = 'new';
                $change_type = 'CREATED';                
            }
            $modelformmaster=FormMaster::model()->find(array('condition'=>'outlet='.Yii::app()->user->outlet_id.' AND code="PR"'));
            $model->updated_by = Yii::app()->user->id;
            $model->updated_time =date('Y-m-d H:i:s');
            $model->attributes = $_POST['Production'];
            $model->outlet=Yii::app()->user->outlet_id;
            //$model->active='Y';
            if($scene =='new'){
                $model->production_no=$modelformmaster->next_number;
            }
            if($_POST['Production']['production_date']!='')
            {
                $model->production_date = str_replace('/', '-', $_POST['Production']['production_date']);
                $model->production_date= date("Y-m-d", strtotime($model->production_date));
            }
            $model->product_id=$_POST['Production']['product_id'];
            $model->description=$_POST['Production']['description'];
            $model->quantity=$_POST['Production']['quantity'];
            $model->unit=$_POST['Production']['unit'];
            $model->wastage_percentage=$_POST['Production']['wastage_percentage'];
            $model->rate=0;
            $model->amount=0;
            $valid=$model->validate();
            if($model->product_id>0)
            {
                $product=Inventory::model()->findByPk($model->product_id);
                $qty=0;
                if($product->type!='S'){
                    if($model->id>0)
                    {
                    $qty=Yii::app()->db->createCommand("select SUM(P.quantity*U.unit_exchange_rate) from {{production}} P INNER JOIN {{master_unit}} U ON P.unit=U.id where P.id='".$model->id."' AND product_id='".$product->id."'")->queryScalar();
                    }
                    $in_qty=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='".$product->id."' AND outlet=".Yii::app()->user->outlet_id." AND transaction_date<='".$model->production_date."'")->queryScalar();
                    $out_qty=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='".$product->id."' AND outlet=".Yii::app()->user->outlet_id." AND transaction_date<='".$model->production_date."'")->queryScalar();
                    $current_stock_on_date=$in_qty-$out_qty+$qty;
                    $bal=$qty-$model['quantity'];
                    if($bal>0 && $current_stock_on_date < $model['quantity'])
                    {
                        $product=Inventory::model()->findByPk($key);
                        $other[]=$product->part_number.' available quantity on '.$model->invoice_date.' mismatch'; 
                        $valid=false;
                    }
                    $in_qty1=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='".$product->id."' AND outlet=".Yii::app()->user->outlet_id." ")->queryScalar();
                    $out_qty1=Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='".$product->id."' AND outlet=".Yii::app()->user->outlet_id." ")->queryScalar();
                    $current_stock=$in_qty1-$out_qty1+$qty;
                    if($bal>0 && $current_stock< $eachProduct['quantity'])
                    {
                        $product=Inventory::model()->findByPk($key);
                        $other[]=$product->part_number.' available quantity mismatch'; 
                        $valid=false;
                    }
                }
            }
            if(is_array($_POST['ProductionItems'])){
                $j=0;
                $total_cost=0;
                foreach($_POST['ProductionItems'] as $i => $each ){
                    if($each['product_id']>0){    
                        $modelItems[$j] = new ProductionItems();
                        $modelItems[$j]->attributes = $each;
                        $modelItems[$j]->production_id = 0;
                        $rate=StockLedger::getAvgPurchaseRateProduction($each['product_id'],'',Yii::app()->user->outlet_id);
                        $modelItems[$j]->rate=$rate;
                        $modelItems[$j]->amount=$rate*$each['quantity'];
                        $valid = $valid && $modelItems[$j]->validate(); 
                        $j++;
                        // Product Grouping
                        if($each['unit']>0)
                        {
                            $unit=MasUnit::model()->findByPk($each['unit']);
                            $unit_exchange=$unit->unit_exchange_rate;
                            $total_cost+=$rate*$each['quantity']*$unit_exchange;
                        }
                        else {
                            $unit_exchange=0;    
                        }
                        $key = $each['product_id'];
                        if (!array_key_exists($key, $groups)) {
                            $groups[$key] = array(
                            'id' => $each['product_id'],
                            'quantity' => $each['quantity']*$unit_exchange,
                            );
                        } 
                        else 
                        {
                            $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['quantity']*$unit_exchange;
                        } 
                        
                    }
                }
            }
        // QTY Checking
        if(!empty($groups))
        {
            foreach($groups as $key=>$eachProduct)  
            {
                $product=Inventory::model()->findByPk($key);
                if($product->type!='S'){
                    $qty=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*U.unit_exchange_rate),0) from {{production_items}} I INNER JOIN {{master_unit}} U ON I.unit=U.id where production_id='".$model->id."' AND product_id='".$key."'")->queryScalar();
                    $bal=$eachProduct['quantity']-$qty;
                    $in_qty=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='IN' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->created_by)->queryScalar();
                    $out_qty=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='OUT' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->created_by)->queryScalar();
                    $in_qty_on_date=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='".$model->production_date."' AND transaction_type='IN' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->created_by)->queryScalar();
                    $out_qty_on_date=Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_date <='".$model->production_date."' AND transaction_type='OUT' AND product_id='".$key."' AND outlet=".Yii::app()->user->outlet_id." AND created_by=".$model->created_by)->queryScalar();
                    $current_stock=$in_qty-$out_qty;
                    $stock_on_date =$in_qty_on_date-$out_qty_on_date;
                    if((($current_stock+$qty) < $eachProduct['quantity'] )|| (($stock_on_date+$qty) < $eachProduct['quantity']))
                    {
                        $available_stock = (($current_stock>$stock_on_date)?$stock_on_date:$current_stock)+$qty;
                        $other[]=$product->part_number.' maximum sellable qty : '.($available_stock).' '.$product->units->unit_name;
                        $valid=false;
                    }
                }
            }  
        }
        $closing_date=MasClosing::getClosingDate();
        if($closing_date>=$model->production_date)
        {
        $other[]='Date should be greater than closing date ('.date('d-m-Y',strtotime($closing_date)).')'; 
        $valid=false;    
        }
        if($valid && ($modelItems[0]->product_id > 0)){
            $model->rate=$total_cost/$model->quantity;
            $model->amount=$total_cost;
            $model->save();
            ProductionItems::model()->deleteAll('production_id ='.$model->id); 
            StockLedger::model()->deleteAll('header_id='.$model->id.' AND type= "PRO" AND outlet='.Yii::app()->user->outlet_id);
            if($scene =='new'){
                $next_no=$model->production_no+1;
                FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
            }
                
                    $model_stockledger = new StockLedger();
                    $model_stockledger->transaction_date=date('Y-m-d H:i:s');
                    $model_stockledger->transaction_type ='IN';
                    $model_stockledger->type ='PRO';
                    $model_stockledger->customer_vendor_id=0;
                    $model_stockledger->header_id=$model->id;
                    $model_stockledger->item_id=0;
                    $model_stockledger->product_id=$model->product_id;
                    $model_stockledger->currency=1;
                    $model_stockledger->exchange_rate=1;
                     $model_stockledger->rate=$total_cost/($model->quantity*$model->pr_unit_details->unit_exchange_rate);
                    $model_stockledger->quantity=$model->quantity;
                    $model_stockledger->unit=$model->unit;
                    $model_stockledger->default_product_unit=$model->pr_unit_details->base_unit_id;
                    $model_stockledger->unit_exchange_rate=$model->pr_unit_details->unit_exchange_rate;
                    $model_stockledger->created_by= $model->created_by;
                    $model_stockledger->created_time=date('Y-m-d H:i:s');
                    $model_stockledger->outlet=Yii::app()->user->outlet_id;
                    $model_stockledger->save(false);
                    
            foreach($modelItems as $each){
                $each->production_id = $model->id;
                $each->save();
                    
                    $model_stockledger = new StockLedger();
                    $model_stockledger->transaction_date=date('Y-m-d H:i:s');
                    $model_stockledger->transaction_type ='OUT';
                    $model_stockledger->type ='PRO';
                    $model_stockledger->customer_vendor_id=0;
                    $model_stockledger->header_id=$model->id;
                    $model_stockledger->item_id=$each->id;
                    $model_stockledger->product_id=$each->product_id;
                    $model_stockledger->currency=1;
                    $model_stockledger->exchange_rate=1;
                    $model_stockledger->quantity=$each->quantity;
                    $model_stockledger->unit=$each->unit;
                    $model_stockledger->default_product_unit=$each->pr_unit_details->base_unit_id;
                    $model_stockledger->unit_exchange_rate=$each->pr_unit_details->unit_exchange_rate;
                    $model_stockledger->created_by= $model->created_by;
                    $model_stockledger->created_time=date('Y-m-d H:i:s');
                    $model_stockledger->outlet=Yii::app()->user->outlet_id;
                    $model_stockledger->save(false);
            }
            
                // inserting to audit log
                AuditLog::saveAuditLogs(
                    $modelformmaster->id,
                    Yii::app()->user->id,
                    $change_type,
                    " with ID - {$model->id} "
                );
                // end audit log
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
        }else {
            $error1=$error2=array();
            $error1 = json_decode(CActiveForm::validate($model, '', false), true);
            if ($modelItems[0]->product_id > 0)
                $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
            else
                $error2[] = "Please add atleast one line item";
            $error = CJSON::encode(array_merge_recursive($error1,$error2,$other));
            if ($error != '[]'){
                echo $error;    
            }
        }
        }
    }
    public function actionPrintPDF(){
        $id = Yii::app()->request->getParam('id');
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $model          = Production::model()->findByPk($id);
        if($model->active=='N'){
            $mPDF1->SetWatermarkText('CANCELLED');
            $mPDF1->showWatermarkText = true;
        }
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.production_print', array('id' => $id, 'title' => 'Production'),true));
        $mPDF1->Output($htmlTemplate, 'I');
    }
    public function actionGetSimilarUnits1(){
        $unit_id=$_POST['unit'];
        $arr_units=MasUnit::getSimilarUnits($unit_id);
        $model=new Production();
        $model->unit=$unit_id;
        $data['unit']=CHtml::activeDropDownList($model, "unit",$arr_units, array('data-label' => 'Unit'));
        echo CJSON::encode($data);
    }
        public function actionGetSimilarUnits(){
        $unit_id=$_POST['unit'];
        $i=$_POST['row_field'];
        $arr_units=MasUnit::getSimilarUnits($unit_id);
        $model=new ProductionItems();
        $model->unit=$unit_id;
        $data['unit']=CHtml::activeDropDownList($model,  "[" . $i . "]unit",$arr_units, array('data-label' => 'Unit'));
        echo CJSON::encode($data);
    }
    public function actionCancelproduction()
        {
        $id     = $_POST['id'];
        $valid  = true;
        $model  = Production::model()->findByPk($id);
        $closing_date=MasClosing::getClosingDate();
        if($closing_date>=$model->production_date)
        {
        $jsonData['error_note']='Date should be greater than closing date ('.date('d-m-Y',strtotime($closing_date)).')'; 
        $jsonData['status']='error';    
        }
        else {
        StockLedger::model()->deleteAll('header_id='.$model->id.' AND type= "PRO" AND outlet='.Yii::app()->user->outlet_id);
        $model->active='N';
        $model->save(false);
        $jsonData['status']='success';
        }
        echo CJSON::encode($jsonData);
    }
}
