<?php

class ReportexcelController extends Controller
{

    public function accessRules()
    {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array(
                    'SalesInvoices', 'SalesReturns', 'PurchaseInvoices', 'PurchaseReturns', 'NetSales', 'NetPurchase',
                    'CustomerList', 'VendorList', 'CurrentStock', 'TransactionDetail', 'StockLedger', 'FocSales', 'NetSales_salesman',
                    'InventorySummaryExcel','ExcelTargetreport',
                ),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }
    public function actionSalesInvoices()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'SalesInvoices.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/salesinvoice_list', $_GET, false, true);
        Yii::app()->end();
    }
    public function actionSalesReturns()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'SalesInvoices.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/salesreturn_list', $_GET, false, true);
        Yii::app()->end();
    }
    public function actionPurchaseInvoices()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'SalesInvoices.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/purchaseinvoice_list', $_GET, false, true);
        Yii::app()->end();
    }
    public function actionPurchaseReturns()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'SalesInvoices.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/purchasereturn_list', $_GET, false, true);
        Yii::app()->end();
    }
    public function actionNetSales()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'NetSales.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/netsales_list', $_GET, false, true);
        Yii::app()->end();
    }

    public function actionNetSales_salesman()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'NetSales.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/netsales_salesmanwise_list', $_GET, false, true);
        Yii::app()->end();
    }
    public function actionNetPurchase()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'NetPurchase.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/netpurchase_list', $_GET, false, true);
        Yii::app()->end();
    }
    public function actionCustomerList()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'CustomerList.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/customer_list', $_GET, false, true);
        Yii::app()->end();
    }
    public function actionVendorList()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'VendorList.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/vendor_list', $_GET, false, true);
        Yii::app()->end();
    }
    public function actionCurrentStock()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'CurrentStock.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/currentstock_list', $_GET, false, true);
        Yii::app()->end();
    }
    public function actionTransactionDetail()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'TransactionDetail.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/transaction_detail', $_GET, false, true);
        Yii::app()->end();
    }
    public function actionStockLedger()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'StockLedger.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/stock_ledger_list', $_GET, false, true);
        Yii::app()->end();
    }

    public function actionFocSales()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'FocSales.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/foc_sales', $_GET, false, true);
        Yii::app()->end();
    }

    public function actionInventorySummaryExcel()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'InventorySummary.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/inventory_summary_report', $_GET, false, true);
        Yii::app()->end();
    }


    public function actionExcelTargetreport()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'Targetreport.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/excel_targetreport', $_GET, false, true);
        Yii::app()->end();
    }
}
