<?php

class ReportsController extends Controller
{

    public function accessRules()
    {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array(
                    'Index', 'get_customers', 'LoadMasterReportFilter', 'StockLedgerHtml',
                    'salesinvoices', 'Htmlsalesinvoices',
                    'salesreturns', 'Htmlsalesreturns',
                    'purchaseinvoices', 'Htmlpurchaseinvoices',
                    'purchasereturns', 'Htmlpurchasereturns',
                    'netsales', 'Htmlnetsales', 'netsales_salesmanwise', 'Htmlnetsales_salesmanwise',
                    'NetPurchase', 'HtmlNetPurchase',
                    'CustomerList', 'HtmlCustomerList',
                    'VendorList', 'HtmlVendorList',
                    'CurrentStock', 'HtmlCurrentStock', 'Pdfcurrentstock',
                    'TransactionDetail', 'HtmlTransactionDetail',
                    'DayBook', 'ChequeReport', 'HtmlDayBook',
                    'HtmlChequeReport', 'HtmlChequeReport',
                    'StockledgerReport', 'HtmlStockLedger', 'PdfStockLedger', 'DaySummary', 'DailyReport',
                    'HtmlDailyReport', 'PdfDailyReport', 'DailySalesReport', 'HtmlDailySalesReport', 'CashCollectionReport',
                    'HtmlCashCollectionReport', 'PdfCashCollectionReport', 'Pdfsalesinvoices', 'Pdfsalesreturn',
                    'Pdfpurchaseinvoices', 'Pdfpurchasereturns', 'Pdfnetsales', 'Pdfnetsales_salesmanwise', 'Pdfnetpurchase', 'PdfdailyReport', 'PdfdailyReport1',
                    'PdfdailysalesReport', 'PdfTransactionDetail', 'InventorySummaryReport', 'HtmlInventorySummary',
                    'DailySalesReport1', 'HtmlDailySalesReport1', 'PdfdailysalesReport1', 'focsales', 'Htmlfocsales', 'Pdffocsales',
                    'TargetReport', 'HtmlTargetreport', 'PdfTargetreport'
                ),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex()
    {
        if (Yii::app()->user->user_access_type == 'DEV' || Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SU' || Yii::app()->user->user_access_type == 'SM' || Yii::app()->user->user_access_type == 'OM') {
            $this->render('index');
        } else {
            throw new CHttpException(403, 'Access Denied.');
        }
    }

    public function actionget_customers()
    {
        $from = $_GET['frm'];
        $searchTerm = $_GET['term'];
        $condition = 'customer_name LIKE "%' . $searchTerm . '%"';
        if (Yii::app()->user->user_access_type == 'SL') {
            $condition .= " AND (t.created_by = " . Yii::app()->user->id . " OR FIND_IN_SET(" . Yii::app()->user->id . ",accessed_by))";
        }
        if (Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SL') {
            $condition .= " AND t.outlet=" . Yii::app()->user->outlet_id;
        }
        $model = new Customer();
        $model = $model->findAll(array('select' => 't.id,t.customer_name,payment_term', 'condition' => $condition, 'limit' => 200));
        $i = 0;
        $data = array();
        foreach ($model as $eachModel) {
            $data[$i]['value'] = $eachModel->id;
            $data[$i]['label'] = $eachModel->customer_name;
            $data[$i]['payment_term'] = $eachModel->payment_term;
            $i++;
        }
        echo CJSON::encode($data);
        Yii::app()->end();
    }
    function actionLoadMasterReportFilter()
    {
        $file_name = Yii::app()->request->getparam('report_from');
        if ($file_name == "") {
            $file_name = "blank";
        }
        $this->renderPartial('filter/' . $file_name, array('report_from' => $file_name), false, true);
    }
    //html files
    public function actionStockLedgerHtml()
    {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $this->render('html/stockledger_list', $_POST, false, true);
    }
    public function actionsalesinvoices()
    {
        $this->render('filter/salesinvoice_list');
    }
    public function actionHtmlsalesinvoices()
    {
        $this->render('html/salesinvoice_list', $_POST, false, true);
    }

    public function actionsalesreturns()
    {
        $this->render('filter/salesreturn_list');
    }
    public function actionHtmlsalesreturns()
    {
        $this->render('html/salesreturn_list', $_POST, false, true);
    }
    public function actionpurchaseinvoices()
    {
        $this->render('filter/purchaseinvoice_list');
    }
    public function actionHtmlpurchaseinvoices()
    {
        $this->render('html/purchaseinvoice_list', $_POST, false, true);
    }

    public function actionpurchasereturns()
    {
        $this->render('filter/purchasereturn_list');
    }
    public function actionHtmlpurchasereturns()
    {
        $this->render('html/purchasereturn_list', $_POST, false, true);
    }
    public function actionnetsales()
    {
        $this->render('filter/netsales_list');
    }
    public function actionHtmlnetsales()
    {
        $this->render('html/netsales_list', $_POST, false, true);
    }




    public function actionnetpurchase()
    {
        $this->render('filter/netpurchase_list');
    }
    public function actionHtmlnetpurchase()
    {
        $this->render('html/netpurchase_list', $_POST, false, true);
    }
    public function actionCustomerList()
    {
        $this->render('filter/customer_list');
    }
    public function actionHtmlCustomerList()
    {
        $this->render('html/customer_list', $_POST, false, true);
    }
    public function actionVendorList()
    {
        $this->render('filter/vendor_list');
    }
    public function actionHtmlVendorList()
    {
        $this->render('html/vendor_list', $_POST, false, true);
    }
    public function actionCurrentStock()
    {
        $this->render('filter/currentstock_list');
    }
    public function actionHtmlCurrentStock()
    {
        $this->render('html/currentstock_list', $_POST, false, true);
    }
    public function actionTransactionDetail()
    {
        $this->render('filter/transaction_detail');
    }
    public function actionHtmlTransactionDetail()
    {
        $this->render('html/transaction_detail', $_POST, false, true);
    }
    public function actionDayBook()
    {
        $this->render('filter/day_book_list');
    }
    public function actionChequeReport()
    {
        $this->render('filter/cheque_report_list');
    }
    public function actionHtmlDayBook()
    {
        $this->render('html/daybook_detail', $_POST, false, true);
    }
    public function actionHtmlChequeReport()
    {
        $this->render('html/chequereport_detail', $_POST, false, true);
    }
    public function actionStockledgerReport()
    {
        $this->render('filter/stockledger_list');
    }
    public function actionHtmlStockLedger()
    {
        $this->render('html/stockledger_list', $_POST, false, true);
    }
    // ---------------added by inshu 05_05_2023-------------------------------------
    public function actionnetsales_salesmanwise()
    {
        $this->render('filter/netsales_salesmanwise_list');
    }

    public function actionHtmlnetsales_salesmanwise()
    {
        $this->render('html/netsales_salesmanwise_list', $_POST, false, true);
    }
    // ----------------------------------------------------
    public function actionPdfStockLedger()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $salesman = $_REQUEST['salesman'];
        $product_id = $_REQUEST['product_id'];

        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/stockledger_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'salesman' => $salesman), true));
        $mpdf->Output("Stockledger Report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionDaySummary()
    {
        $this->render('filter/day_summary');
    }
    public function actionDailyReport()
    {
        $this->render('filter/daily_report');
    }
    public function actionHtmlDailyReport()
    {
        $this->render('html/daily_report_list', $_POST, false, true);
    }
    public function actionPdfDailyReport()
    {
        $this->render('pdf/daily_report_list', $_REQUEST, false, true);
    }
    public function actionDailySalesReport()
    {
        $this->render('filter/daily_sales_report');
    }
    public function actionHtmlDailySalesReport()
    {
        $this->render('html/daily_sales_report_list', $_POST, false, true);
    }
    public function actionCashCollectionReport()
    {
        $this->render('filter/cash_collection_report');
    }
    public function actionHtmlCashCollectionReport()
    {
        $this->render('html/cash_collection_report_list', $_POST, false, true);
    }
    public function actionPdfCashCollectionReport()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $customer_id = $_REQUEST['customer_id'];
        $salesman = $_REQUEST['salesman'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/cash_collection_report_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'customer_id' => $customer_id, 'salesman' => $salesman), true));
        $mpdf->Output("Cash Collection Report List" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionPdfsalesinvoices()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $customer_id = $_REQUEST['customer_id'];
        $salesman = $_REQUEST['salesman'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/sales_report_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'customer_id' => $customer_id, 'salesman' => $salesman), true));
        $mpdf->Output("Sales Report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionPdfsalesreturn()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $customer_id = $_REQUEST['customer_id'];
        $salesman = $_REQUEST['salesman'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/salesreturn_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'customer_id' => $customer_id, 'salesman' => $salesman), true));
        $mpdf->Output("Sales Return Report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionPdfpurchaseinvoices()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $vendor_id = $_REQUEST['vendor_id'];
        $salesman = $_REQUEST['salesman'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/purchaseinvoice_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'vendor_id' => $vendor_id, 'salesman' => $salesman), true));
        $mpdf->Output("Purchase Report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionPdfpurchasereturns()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $vendor_id = $_REQUEST['vendor_id'];
        $salesman = $_REQUEST['salesman'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/purchasereturn_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'vendor_id' => $vendor_id, 'salesman' => $salesman), true));
        $mpdf->Output("Purchase Return Report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionPdfnetsales()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $customer_id = $_REQUEST['customer_id'];
        $salesman = $_REQUEST['salesman'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/netsales_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'vendor_id' => $vendor_id, 'salesman' => $salesman), true));
        $mpdf->Output("Net Set Report" . date("d-m-Y") . ".pdf", 'I');
    }


    public function actionPdfnetsales_salesmanwise()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $customer_id = $_REQUEST['customer_id'];
        $salesman = $_REQUEST['salesman'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/netsales_salesmanwise_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'vendor_id' => $vendor_id, 'salesman' => $salesman), true));
        $mpdf->Output("Net Set Report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionPdfnetpurchase()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $vendor_id = $_REQUEST['vendor_id'];
        $salesman = $_REQUEST['salesman'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/netpurchase_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'vendor_id' => $vendor_id, 'salesman' => $salesman), true));
        $mpdf->Output("Net Purchase Report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionPdfdailyReport1()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        
        $daybook_to_date   = (count(explode('/', $_REQUEST['daybook_to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['daybook_to_date']))) : date('Y-m-d');
        $daybook_from_date = (count(explode('/', $_REQUEST['daybook_from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['daybook_from_date']))) : date('Y-m-d');
        
        $outlet = $_REQUEST['outlet'];
        $salesman = $_REQUEST['salesman']; 
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/daily_report_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'created_user' => $salesman,'daybook_to_date'=>$daybook_to_date,'daybook_from_date'=>$daybook_from_date), true));
        $mpdf->Output("Consolidated Report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionPdfdailysalesReport()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $salesman = $_REQUEST['salesman'];
        $customer_id = $_REQUEST['customer_id'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/daily_sales_report_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'salesman' => $salesman, 'customer_id' => $customer_id), true));
        $mpdf->Output("Daily Sales Report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionPdfcurrentstock()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $ctype = $_REQUEST['ctype'];
        $salesman = $_REQUEST['salesman'];
        $stock = $_REQUEST['stock'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/currentstock_list', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'salesman' => $salesman, 'stock' => $stock, 'ctype' => $ctype), true));
        $mpdf->Output("Current Stock Report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionPdfTransactionDetail()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $salesman = $_REQUEST['salesman'];
        $product_id = $_REQUEST['product_id'];
        $ctype  = $_REQUEST['ctype'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/transaction_detail', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'salesman' => $salesman, 'product_id' => $product_id, 'ctype' => $ctype), true));
        $mpdf->Output("Transaction Report" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionInventorySummaryReport()
    {
        $this->render('filter/inventory_summary_report');
    }
    public function actionHtmlInventorySummary()
    {
        $this->render('html/inventory_summary_report', $_POST, false, true);
    }
    public function actionDailySalesReport1()
    {
        $this->render('filter/daily_sales_report_new');
    }
    public function actionHtmlDailySalesReport1()
    {
        $this->render('html/daily_sales_report_list_new', $_POST, false, true);
    }
    public function actionPdfdailysalesReport1()
    {

        $from_date = (count(explode('/', $_REQUEST['daybook_from_date'])) == 3) ? date("Y-m-d H:i:s", strtotime(str_replace('/', '-', $_REQUEST['daybook_from_date']))) : date('Y-m-d H:i:s');
        $to_date = (count(explode('/', $_REQUEST['daybook_to_date'])) == 3) ? date("Y-m-d H:i:s", strtotime(str_replace('/', '-', $_REQUEST['daybook_to_date']))) : date('Y-m-d H:i:s');
        $outlet = $_REQUEST['outlet'];
        $salesman = $_REQUEST['salesman'];
        $customer_id = $_REQUEST['customer_id'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/daily_sales_report_list_new', array('daybook_from_date' => $from_date, 'daybook_to_date' => $to_date, 'outlet' => $outlet, 'salesman' => $salesman, 'customer_id' => $customer_id), true));
        $mpdf->Output("Daily Sales Report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionfocsales()
    {
        $this->render('filter/foc_sales');
    }
    public function actionHtmlfocsales()
    {
        $this->render('html/foc_sales', $_POST, false, true);
    }
    public function actionPdffocsales()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = $_REQUEST['outlet'];
        $customer_id = $_REQUEST['customer_id'];
        $salesman = $_REQUEST['salesman'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/foc_sales', array('from' => $from_date, 'to' => $to_date, 'outlet' => $outlet, 'customer_id' => $customer_id, 'salesman' => $salesman), true));
        $mpdf->Output("FOC Sales Report" . date("d-m-Y") . ".pdf", 'I');
    }

    // ----------added by indhu 21_07_2023----------------------------------
    public function actionTargetReport()
    {

        $this->render('filter/filter_targetreport');
    }
    public function actionHtmlTargetreport()
    {

        if (Yii::app()->request->isAjaxRequest) {
            $data               = Yii::app()->request->getPost('data'); // userlist
            $no_of_working_days = $_POST['no_of_working_days'];
            $days_passed        = $_POST['days_passed'];
            $target_by_date     = $_POST['target_by_date'];

            // ----------------------------------------------------
            $firstDateOfMonth = '00/00/0000';
            if ($target_by_date != '' && $target_by_date != '00/00/0000') {
                // Explode the date string into day, month, and year components
                $dateComponents = explode('/', $target_by_date);

                // Check if the date format is valid and contains three components

                if (count($dateComponents) === 3) {
                    // Extract day, month, and year from the components
                    $day = $dateComponents[0];
                    $month = $dateComponents[1];
                    $year = $dateComponents[2];

                    // Validate the date components
                    if (checkdate((int)$month, (int)$day, (int)$year)) {
                        // Create the DateTime object with the correct date format 'd/m/Y'
                        $dateTime = DateTime::createFromFormat('d/m/Y', $target_by_date);

                        // Set the day of the date to 1 (first day of the month)
                        $dateTime->setDate($dateTime->format('Y'), $dateTime->format('m'), 1);

                        // Format the date as desired
                        $firstDateOfMonth = $dateTime->format('d/m/Y');
                    }
                }
            }


            // -----------------------------------------------------

            $this->render('html/html_target_report', array('data' => $data, 'no_of_working_days' => $no_of_working_days, 'days_passed' => $days_passed, 'target_by_date' => $target_by_date, 'firstDateOfMonth' => $firstDateOfMonth));
        } else {
            // Handle non-AJAX requests if needed
        }
    }


    public function actionPdfTargetreport()
    {

        $target_by_date     = $_REQUEST['target_by_date'];
        $dataJson           = $_REQUEST['data'];
        $userlist           = json_decode($dataJson, true); //Decode the JSON data into a PHP array
        $no_of_working_days = $_REQUEST['no_of_working_days'];
        $days_passed        = $_REQUEST['days_passed'];
        $firstDateOfMonth   = $_REQUEST['firstDateOfMonth'];
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf/pdf_target_report', array('firstDateOfMonth' => $firstDateOfMonth, 'target_by_date' => $target_by_date, 'userlist' => $userlist, 'no_of_working_days' => $no_of_working_days, 'days_passed' => $days_passed), true));
        $mpdf->Output("Target Report" . date("d-m-Y") . ".pdf", 'I');
    }


    //end
}
