<?php

class SalesreturnController extends Controller {

    public function accessRules() {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('Index', 'GetList', 'Create', 'Save', 'GetSimilarUnits', 'PrintPDF', 'CancelReturn',
                    'BulkInvoicePosting', 'CreateConsolidated', 'getInvoices', 'consolidated_form','SaveConsolidated','GetInvoiceProducts'),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionIndex() {
        $this->render('index');
    }

    public function actionGetList() {
        $model = new SalesReturn();
        $draw = $_POST['draw'];
        $offset = $_POST['start'];
        $limit = $_POST['length'];
        $outlet = $_POST['outlet'];
        $from = $_POST['from'];
        $to = $_POST['to'];
        $customer = $_POST['customer_id'];
        $created_user = $_POST['created_user'];
        $columns = array(
            0 => 't.return_no',
            1 => 't.return_date',
            2 => 'sr_customer.customer_name',
            3 => 't.invoice_no',
            4 => 't.total_amount',
            5 => 't.tax_total',
            6 => 't.grand_total',
            7 => 'sr_user.full_name',
            8 => 'sr_outlet.outlet_name',
            9 => 't.id',
            10 => 't.active'
        );
        $filterColumn = $columns[$_POST['order'][0]['column']];
        $filterOrder = $_POST['order'][0]['dir'];
        $filterColumn1 = $columns[$_POST['order'][1]['column']];
        $filterOrder1 = $_POST['order'][1]['dir'];
        if ($filterColumn1 != '' && $filterOrder1 != '') {
            $second_sort = "," . $filterColumn1 . " " . $filterOrder1;
        } else {
            $second_sort = "";
        }
        $orderBy = $filterColumn . " " . $filterOrder . $second_sort;
        $condition = '1=1';
        if (isset($_POST['search']['value']) && $_POST['search']['value'] != "") {
            $searchString = $_POST['search']['value'];
            $condition.=" AND (t.return_no LIKE '%" . $searchString . "%' OR t.grand_total LIKE '%" . $searchString . "%' )";
        }
        if ($outlet > 0) {
            $condition.=" AND t.outlet=" . $outlet;
        }
        if ($from != '' && $from != '00/00/0000') {
            $from = str_replace('/', '-', $from);
            $from = date("Y-m-d", strtotime($from));
            $condition.=' AND t.return_date>="' . $from . '"';
        }
        if ($to != '' && $to != '00/00/0000') {
            $to = str_replace('/', '-', $to);
            $to = date("Y-m-d", strtotime($to));
            $condition.=' AND t.return_date<="' . $to . '"';
        }
        if ($customer > 0) {
            $condition.=' AND t.customer_id=' . $customer;
        }
        if ($created_user > 0) {
            $condition.=' AND sr_invoice.sales_man=' . $created_user;
        }
       //echo $condition;
        $count = $model->with('sr_invoice', 'sr_customer', 'sr_outlet', 'sr_user', 'sr_invoice.si_salesman')->count(array('condition' => $condition));
        $model = $model->with('sr_invoice', 'sr_customer', 'sr_outlet', 'sr_user', 'sr_invoice.si_salesman')->findAll(array('condition' => $condition, 'limit' => $limit, 'offset' => $offset, 'order' => $orderBy));
        $recordsTotal = $count;
        $recordsFiltered = $count;
        $data['draw'] = $draw;
        $data['recordsTotal'] = $recordsTotal;
        $data['recordsFiltered'] = $recordsFiltered;
        $rowData = array();
        foreach ($model as $row) {
            $div = '<div class="text-center">';
        $outlet=$row['outlet'];
        $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="CN" AND outlet='.$outlet))->id;
            $posted_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type='.$vouchertype.' AND voucher_no=' . $row['return_no']));

            if ($row['active'] == 'Y') {

                if ($posted_voucher->is_allocated == 'Y') {
                    $div .= ' <a class="btn btn-primary btn-xs" title="Print Allocation" target="_blank" href="index.php?r=finance/core/printallocation&voucher_id=' . $posted_voucher->id . '"><i class="fa fa-print" aria-hidden="true"></i></a>';
                } else {
                    if (Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM') {
                        if($row['is_multiple']=='N'){
                            $div .= '<button class="btn btn-primary btn-xs" title ="Edit" onclick="loadPopupModal(\'salesreturn/create&id=' . $row['id'] . '\',\'Edit - ' . $row['return_no'] . '\',\'xl\')"><i class="fa fa-edit" aria-hidden="true"></i></button>';
                        }
                        $div .= ' <button class="btn btn-danger btn-xs" title ="Cancel" onclick="cancelReturn(' . $row['id'] . ')"><i class="fa fa-ban" aria-hidden="true"></i></button>';
                    }
                }
            }
            $div .= ' <a class="btn btn-primary btn-xs" title="Print Sales Return" target="_blank" href="index.php?r=salesreturn/PrintPDF&id=' . $row['id'] . '"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>';

            $div .= ' </div>';
            $rowData[] = array($row['return_no'], date("d/m/Y", strtotime($row['return_date'])), $row['sr_customer']['customer_name'], $row->InvoiceNumbers , Yii::app()->numberFormatter->formatCurrency($row['total_amount'], ''), Yii::app()->numberFormatter->formatCurrency($row['tax_total'], ''), Yii::app()->numberFormatter->formatCurrency($row['grand_total'], ''), $row['sr_invoice']['si_salesman']['full_name'], $row['sr_outlet']['outlet_name'], $div, $row['active']);
        }
        $data['data'] = $rowData;
        echo json_encode($data);
    }

    public function actionCreate() {
        $invoice_id = (int) Yii::app()->request->getParam('invoice_id');
        $id = (int) Yii::app()->request->getParam('id');
        $model = new SalesReturn;
        $modelItems = array(new SalesReturnItems);
        if ($id > 0) {
            $model = $model->findByPk($id);
            $invoice_date = date('d/m/Y', strtotime($model->sr_invoice->invoice_date));
            $modelItems = SalesReturnItems::model()->findAll(array('condition' => 'return_id="' . $id . '"', 'order' => 'id ASC'));
            if (empty($modelItems)) {
                $modelItems = array(new SalesReturnItems());
            }
        } else if ($invoice_id > 0) {
            $invmodel = SalesInvoice::model()->findByPk($invoice_id);
            $invmodelItems = SalesInvoiceItems::model()->findAll(array('condition' => 'invoice_id="' . $invoice_id . '"', 'order' => 'id ASC'));
            $invoice_date = date('d/m/Y', strtotime($invmodel->invoice_date));
            $model->customer_id = $invmodel->customer_id;
            $model->currency = $invmodel->currency;
            $model->exchange_rate = $invmodel->exchange_rate;
            $model->invoice_id = $invmodel->id;
            $already_returned_qty = 0;
            $k = 0;
            foreach ($invmodelItems as $each) {
                $modelItems[$k] = new SalesReturnItems;
                $modelItems[$k]->product_id = $each->product_id;
                $modelItems[$k]->description = $each->description;
                $modelItems[$k]->invoice_id = $each->invoice_id;
                $modelItems[$k]->invoice_item_id = $each->id;
                $modelItems[$k]->invoiced_qty = $each->quantity;
                $modelItems[$k]->returned_quantity = 0;
                $modelItems[$k]->unit = $each->unit;
                $modelItems[$k]->rate = $each->rate;
                $modelItems[$k]->amount = $each->amount;
                $modelItems[$k]->excise_percentage = $each->excise_percentage;
                $modelItems[$k]->excise_amount = $each->excise_amount;
                $modelItems[$k]->tax_percentage = $each->tax_percentage;
                $modelItems[$k]->tax_amount = $each->tax_amount;
                $modelItems[$k]->net_amount = $each->net_amount;
                $k++;
            }
        }
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create', array('model' => $model, 'modelItems' => $modelItems, 'invoice_date' => $invoice_date));
    }

    public function actionSave() {
        $model = new SalesReturn();
        if (isset($_POST['SalesReturn'])) {

            $total_amount = 0;
            $total_tax_amount = 0;
            $total_excise_amount = 0;
            $grand_total = 0;
            $other = array();
            if ($_POST['SalesReturn']['id'] > 0) {
                $id = $_POST['SalesReturn']['id'];
                $model = $model->findByPK($id);
                $scene = 'update';
                $change_type = 'UPDATED';
            } else {
                $model->created_by = Yii::app()->user->id;
                $model->created_time = date('Y-m-d H:i:s');
                $scene = 'new';
                $change_type = 'CREATED';
            }
            $modelformmaster = FormMaster::model()->find(array('condition' => 'outlet=' . Yii::app()->user->outlet_id . ' AND code="SR"'));
            $model->updated_by = Yii::app()->user->id;
            $model->updated_time = date('Y-m-d H:i:s');
            $model->attributes = $_POST['SalesReturn'];
            $model->outlet = Yii::app()->user->outlet_id;
            if ($scene == 'new') {
                $model->return_no = $modelformmaster->next_number;
            }
            $model->total_amount = $total_amount;
            $model->excise_total = $total_excise_amount;
            $model->tax_total = $total_tax_amount;
            $model->grand_total = $grand_total;
            if ($_POST['SalesReturn']['return_date'] != '') {
                $model->return_date = str_replace('/', '-', $_POST['SalesReturn']['return_date']);
                $model->return_date = date("Y-m-d", strtotime($model->return_date));
            }

            $valid = $model->validate();
            $groups = array();
            $sales_man = SalesInvoice::model()->findByPk($model->invoice_id)->sales_man;
            if ((int) $sales_man == 0)
                $sales_man = Yii::app()->user->id;
            if (is_array($_POST['SalesReturnItems'])) {
                foreach ($_POST['SalesReturnItems'] as $i => $each) {
                    if ($each['product_id'] > 0) {
                        $modelItems[$i] = new SalesReturnItems();
                        $modelItems[$i]->attributes = $each;
                        $modelItems[$i]->return_id = 0;
                        $valid = $valid && $modelItems[$i]->validate();
                        // Product Grouping
                        if ($each['unit'] > 0) {
                            $unit = MasUnit::model()->findByPk($each['unit']);
                            $unit_exchange = $unit->unit_exchange_rate;
                        } else {
                            $unit_exchange = 0;
                        }
                        $key = $each['product_id'];
                        if (!array_key_exists($key, $groups)) {
                            $groups[$key] = array(
                                'id' => $each['product_id'],
                                'returned_quantity' => $each['returned_quantity'] * $unit_exchange,
                            );
                        } else {
                            $groups[$key]['returned_quantity'] = $groups[$key]['returned_quantity'] + $each['returned_quantity'] * $unit_exchange;
                        }
                    }
                }
            }
            // QTY Checking
            if (!empty($groups)) {
                foreach ($groups as $key => $eachProduct) {
                    $product = Inventory::model()->findByPk($key);
                    $qty = 0;
                    if ($model->id > 0) {
                        $qty = Yii::app()->db->createCommand("select IFNULL(SUM(returned_quantity*U.unit_exchange_rate),0) from {{sales_return_items}} S INNER JOIN {{master_unit}} U ON S.unit=U.id where return_id='" . $model->id . "' AND product_id='" . $key . "'")->queryScalar();
                    }
                    $bal = $eachProduct['returned_quantity'] - $qty;
                    $invoiced_qty = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0) from {{stock_ledger}} where type='SI' AND product_id='" . $key . "' AND header_id='" . $model->invoice_id . "'  AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $sales_man)->queryScalar();
                    $already_returned_qty = Yii::app()->db->createCommand("select IFNULL(SUM(S.quantity*S.unit_exchange_rate),0) from {{stock_ledger}} S LEFT JOIN {{sales_return_items}} R ON R.id=S.item_id where R.invoice_id='" . $model->invoice_id . "'  AND type='SR' AND S.product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id)->queryScalar();
                    $balance = $invoiced_qty - $already_returned_qty + $qty;
                    if ($eachProduct['returned_quantity'] > $balance) {
                        $other[] = $product->part_number . ' maximum quantities to be returned : ' . ($balance) . ' ' . $product->units->unit_name;
                        $valid = false;
                    } else if ($bal < 0 && $product->type != 'S') {
                        $in_qty = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='IN' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $sales_man)->queryScalar();
                        $out_qty = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0)  from {{stock_ledger}} where transaction_type='OUT' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $sales_man)->queryScalar();
                        $current_stock = $in_qty - $out_qty;
                        if ($current_stock < -($bal)) {
                            $other[] = $product->part_number . ' have not enough quantities : ' . -($current_stock + $bal) . ' ' . $product->units->unit_name;
                            $valid = false;
                        }
                    }
                }
            }

        
        $closing_date=MasClosing::getClosingDate();
        if($closing_date>=$model->return_date)
        {
        $other[]='Date should be greater than closing date ('.date('d-m-Y',strtotime($closing_date)).')'; 
        $valid=false;    
        }

            if ($valid && $model->validate() && is_array($modelItems)) {

                $model->save();

                if ($scene == 'new') {
                    $next_no = $model->return_no + 1;
                    FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
                }

                Yii::app()->db->createCommand("delete from {{stock_ledger}} where transaction_type='IN' AND type='SR' AND header_id='" . $model->id . "' AND outlet=" . Yii::app()->user->outlet_id)->execute();
                Yii::app()->db->createCommand("delete from {{sales_return_items}} where return_id='" . $model->id . "'")->execute();

                foreach ($modelItems as $eachItem) {
                    $eachItem->return_id = $model->id;
                    $total_amount+=$eachItem->amount;
                    $total_tax_amount+=$eachItem->tax_amount;
                    $total_excise_amount+=$eachItem->excise_amount;
                    $eachItem->save(false);
                    $grand_total+=$eachItem->net_amount;

                    $stockledger = new StockLedger;
                    $stockledger->transaction_date = $model->return_date;
                    $stockledger->transaction_type = 'IN';
                    $stockledger->type = 'SR';
                    $stockledger->customer_vendor_id = $model->customer_id;
                    $stockledger->header_id = $model->id;
                    $stockledger->item_id = $eachItem->id;
                    $stockledger->product_id = $eachItem->product_id;
                    $stockledger->rate = $eachItem->rate;
                    $stockledger->currency = 1;
                    $stockledger->exchange_rate = 1;
                    $stockledger->quantity = $eachItem->returned_quantity;
                    $stockledger->unit = $eachItem->unit;
                    $stockledger->default_product_unit = $eachItem->sr_units->base_unit_id;
                    $stockledger->unit_exchange_rate = $eachItem->sr_units->unit_exchange_rate;
                    $stockledger->outlet = Yii::app()->user->outlet_id;
                    $stockledger->created_by = $sales_man;
                    $stockledger->created_time = date('Y-m-d H:i:s');
                    $stockledger->save(false);
                }
                // inserting to audit log
                AuditLog::saveAuditLogs(
                        $modelformmaster->id, $sales_man, $change_type, " with ID - {$model->id} "
                );
                // end audit log
                $model->total_amount = $total_amount;
                $model->excise_total = $total_excise_amount;
                $model->tax_total = $total_tax_amount;
                $model->grand_total = $grand_total;
                $model->save();
                $this->salesreturnPosting($model->id);
                $jsonData['status'] = 'success';
                if($_POST['print']=='on')
                {
                $jsonData['generate_print']='Y';  
                $jsonData['id']=$model->id;  
                }
                echo CJSON::encode($jsonData);
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                if (!empty($modelItems))
                    $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
                else
                    $error2[] = "Please add atleast one line item";
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $other));
                if ($error != '[]') {
                    echo $error;
                }
            }
        }
    }

    public function actionGetSimilarUnits() {
        $unit_id = $_POST['unit'];
        $i = $_POST['row_field'];
        $arr_units = MasUnit::getSimilarUnits($unit_id);
        $modelItems = new SalesReturnItems();
        $modelItems->unit = $unit_id;
        $data['unit'] = CHtml::activeDropDownList($modelItems, "[" . $i . "]unit", $arr_units, array("class" => "go cell-center text-center"));
        echo CJSON::encode($data);
    }

    public function actionPrintPDF() {
        $id = Yii::app()->request->getParam('id');
        $mPDF1 = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $model = SalesReturn::model()->findByPk($id);
        if ($model->active == 'N') {
            $mPDF1->SetWatermarkText('CANCELLED');
            $mPDF1->showWatermarkText = true;
        }
        $mPDF1->WriteHTML($stylesheet, 1);
        $mPDF1->WriteHTML($this->renderPartial('application.views.front.pdf.sales_return_print', array('id' => $id, 'title' => $title), true));
        $mPDF1->Output($htmlTemplate, 'I');
    }

    public function actionCancelReturn() {
        $id = $_POST['id'];
        $valid = true;
        $model = SalesReturn::model()->findByPk($id);

        $modelItems = SalesReturnItems::model()->findAll(array('condition' => 'return_id="' . $id . '"', 'order' => 'id ASC'));
        $groups = array();
        foreach ($modelItems as $each) {
            if ($each['unit'] > 0) {
                $unit = MasUnit::model()->findByPk($each['unit']);
                $unit_exchange = $unit->unit_exchange_rate;
            } else {
                $unit_exchange = 1;
            }
            $key = $each['product_id'];
            if (!array_key_exists($key, $groups)) {
                $groups[$key] = array(
                    'id' => $each['product_id'],
                    'quantity' => $each['returned_quantity'] * $unit_exchange,
                );
            } else {
                $groups[$key]['quantity'] = $groups[$key]['quantity'] + $each['returned_quantity'] * $unit_exchange;
            }
        }
        if (!empty($groups)) {
            foreach ($groups as $key => $eachProduct) {
                $product = Inventory::model()->findByPk($key);
                if ($product->type != 'S') {
                    $in_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND transaction_date<='" . $model->return_date . "'")->queryScalar();
                    $out_qty = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " AND transaction_date<='" . $model->return_date . "'")->queryScalar();
                    $current_stock_on_date = $in_qty - $out_qty;
                    if ($current_stock_on_date < $eachProduct['quantity']) {
                        $other[] = $product->part_number . ' available quantity on ' . $model->return_date . ' mismatch';
                        $valid = false;
                    }
                    $in_qty1 = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='IN' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " ")->queryScalar();
                    $out_qty1 = Yii::app()->db->createCommand("select SUM(quantity*unit_exchange_rate) from {{stock_ledger}} where transaction_type='OUT' AND product_id='" . $key . "' AND outlet=" . Yii::app()->user->outlet_id . " ")->queryScalar();
                    $current_stock = $in_qty1 - $out_qty1;
                    if ($current_stock < $eachProduct['quantity']) {
                        $other[] = $product->part_number . ' available quantity mismatch';
                        $valid = false;
                    }
                }
            }
        }
        $closing_date=MasClosing::getClosingDate();
        if($closing_date>=$model->return_date)
        {
        $other[]='Date should be greater than closing date ('.date('d-m-Y',strtotime($closing_date)).')'; 
        $valid=false;       
        }
        if ($valid) {
        $outlet=Yii::app()->user->outlet_id;
        $mainTable=$model;
        $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="CN" AND outlet='.$outlet))->id;
            $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type='.$vouchertype.' AND header_table_id=' . $mainTable->id));
            if (!empty($fin_voucher)) {
                FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));
                FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
            }
            StockLedger::model()->deleteAll('header_id=' . $model->id . ' AND  transaction_type="IN" AND type= "SR" AND outlet=' . Yii::app()->user->outlet_id);
            $model->active = 'N';
            $model->posted = 'N';
            $model->save(false);
            $jsonData['status'] = 'success';
            echo CJSON::encode($jsonData);
        } else {
            $error = CJSON::encode(array_merge_recursive($other));
            if ($error != '[]') {
                echo $error;
            }
        }
    }

    function salesreturnPosting($invoice_id) {
        $mainTable = SalesReturn::model()->findByPk((int) $invoice_id);
        $outlet=Yii::app()->user->outlet_id;
        $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="CN" AND outlet='.$outlet))->id;
        $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type='.$vouchertype.' AND header_table_id=' . $mainTable->id));
        if (!empty($fin_voucher)) {
            FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));
            FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
        }
        $voucherHead['voucher_no'] = $mainTable->return_no;
        $voucherHead['voucher_date'] = $mainTable->return_date;
        $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);
        $outlet=Yii::app()->user->outlet_id;
        $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="CN" AND outlet='.$outlet))->id;
        $voucherHead['voucher_type'] = $vouchertype;
        // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
        $voucherHead['reference_no'] = $mainTable->reference_no;
        $voucherHead['header_table_id'] = $mainTable->id;
        $voucherHead['due_date'] = $mainTable->return_date;
        $voucherHead['outlet'] = $mainTable->outlet;
        $voucherHead['created_by'] = $mainTable->created_by;
        // $voucherHead['due_date'] = date('Y-m-d', strtotime($mainTable->invoice_date . ' + ' . (int) $mainTable->paymentTerm->no_of_days . ' days'));
        $valid = $this->isPostable($mainTable->return_date);

        $lastSavedid = $valid ? $this->addVoucherhead($voucherHead) : 0;

        $total_debtor_amount = $mainTable->grand_total;
        $total_sales = $mainTable->total_amount;
        $total_tax_amount = $mainTable->tax_total;
        $total_discount_amount = $mainTable->discount;
        $total_received_amount = $mainTable->paid;
        if ($total_debtor_amount > 0) {
            //Debtor Dr
            $debit_item_sales = $this->addVoucheritems($lastSavedid, array(
                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),
                // 'brand_id' => $mainTable->order_id,
                'subledger_id' => $this->getSublegder($mainTable->customer_id, 1), //2-Creditors 1- debtors
                'narration' => 'Sales Return #' . $mainTable->return_no,
                'currency' => $mainTable->currency,
                'exchange_rate' => $mainTable->exchange_rate,
                'emirate_id' => (int) $mainTable->sr_customer->state,
                'amount' => -1 * $total_debtor_amount,
                'outlet' => $mainTable->outlet
            ));

            if ($total_received_amount > 0) {
        $outlet=Yii::app()->user->outlet_id;
        $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="PV" AND outlet='.$outlet))->id;
                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);
                $voucherHead['voucher_date'] = $mainTable->return_date;
                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);
                $voucherHead['voucher_type'] = $vouchertype;
                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
                $voucherHead['reference_no'] = $mainTable->reference_no;
                $voucherHead['header_table_id'] = $mainTable->id;
                $voucherHead['due_date'] = $mainTable->return_date;
                $voucherHead['outlet'] = $mainTable->outlet;
                $lastSavedid_receipt_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;

                $debit_item_receipt = $this->addVoucheritems($lastSavedid_receipt_voucher, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),
                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),
                    'narration' => 'Sales Return #' . $mainTable->return_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->sr_customer->state,
                    'amount' => (float) $total_received_amount,
                    'outlet' => $mainTable->outlet
                ));

                $this->addVoucheritems($lastSavedid_receipt_voucher, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('cash_account'),
                    'subledger_id' => MasUsers::model()->findByPk($mainTable->created_by)->subledger_id,
                    'narration' => 'Sales Return #' . $mainTable->return_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->sr_customer->state,
                    'amount' => -1 * $total_received_amount,
                    'outlet' => $mainTable->outlet
                ));
                FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('total_voucher_amount' => ($total_received_amount), 'cheque_cleared' => 'Y')); //$netTotal
                //Auto Allocation
                $allocation = new FinanceAllocation;
                $allocation->allocation_date = $mainTable->return_date;
                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');
                $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);
                $allocation->amount = (float) $total_received_amount;
                $allocation->created_by = Yii::app()->user->id;
                $allocation->created_date_time = date('Y-m-d h:i:s');
                $allocation->outlet = Yii::app()->user->outlet_id;
                $allocation->save(false);
                $allocation_items = new FinanceAllocationItems;
                $allocation_items->header_id = $allocation->id;
                $allocation_items->voucher_id = $lastSavedid;
                $allocation_items->voucher_item_id = $debit_item_sales;
                $allocation_items->amount = (float) $total_received_amount;
                $allocation_items->outlet = Yii::app()->user->outlet_id;
                $allocation_items->save(false);
                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));
                $allocation_items = new FinanceAllocationItems;
                $allocation_items->header_id = $allocation->id;
                $allocation_items->voucher_id = $lastSavedid_receipt_voucher;
                $allocation_items->voucher_item_id = $debit_item_receipt;
                $allocation_items->amount = -1 * $total_received_amount;
                $allocation_items->outlet = Yii::app()->user->outlet_id;
                $allocation_items->save(false);
                FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('is_allocated' => 'Y'));
            }
            // Discount Start
            if ($total_discount_amount > 0) {
        $outlet=Yii::app()->user->outlet_id;
        $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="DA" AND outlet='.$outlet))->id;
                $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);
                $voucherHead['voucher_date'] = $mainTable->return_date;
                $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);
                $voucherHead['voucher_type'] = $vouchertype;
                // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
                $voucherHead['reference_no'] = $mainTable->reference_no;
                $voucherHead['header_table_id'] = $mainTable->id;
                $voucherHead['due_date'] = $mainTable->return_date;
                $voucherHead['outlet'] = $mainTable->outlet;
                $lastSavedid_discount_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;

                $debit_item_discount = $this->addVoucheritems($lastSavedid_discount_voucher, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),
                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),
                    'narration' => 'Sales Return #' . $mainTable->return_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->sr_customer->state,
                    'amount' => (float) $total_discount_amount,
                    'outlet' => $mainTable->outlet
                ));

                $this->addVoucheritems($lastSavedid_discount_voucher, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('discount'),
                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),
                    'narration' => 'Sales Return #' . $mainTable->return_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->sr_customer->state,
                    'amount' => -1 * $total_discount_amount,
                    'outlet' => $mainTable->outlet
                ));

                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('total_voucher_amount' => ($total_discount_amount), 'cheque_cleared' => 'Y')); //$netTotal
                //Auto Allocation
                $allocation = new FinanceAllocation;
                $allocation->allocation_date = $mainTable->return_date;
                $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');
                $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);
                $allocation->amount = (float) $total_discount_amount;
                $allocation->created_by = Yii::app()->user->id;
                $allocation->created_date_time = date('Y-m-d h:i:s');
                $allocation->outlet = Yii::app()->user->outlet_id;
                $allocation->save(false);
                $allocation_items = new FinanceAllocationItems;
                $allocation_items->header_id = $allocation->id;
                $allocation_items->voucher_id = $lastSavedid;
                $allocation_items->voucher_item_id = $debit_item_sales;
                $allocation_items->amount = -1 * $total_discount_amount;
                $allocation_items->outlet = Yii::app()->user->outlet_id;
                $allocation_items->save(false);
                FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));
                $allocation_items = new FinanceAllocationItems;
                $allocation_items->header_id = $allocation->id;
                $allocation_items->voucher_id = $lastSavedid_discount_voucher;
                $allocation_items->voucher_item_id = $debit_item_discount;
                $allocation_items->amount = (float) $total_discount_amount;
                $allocation_items->outlet = Yii::app()->user->outlet_id;
                $allocation_items->save(false);
                FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('is_allocated' => 'Y'));
            }
            // END Discount
        }

        if ($total_sales > 0) {
            //Sales Accounts Cr
            $this->addVoucheritems($lastSavedid, array(
                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales'),
                // 'brand_id' => $mainTable->order_id,
                // 'subledger_id' => $this->getSublegder($mainTable->lead_owner_id, 3),
                'narration' => 'Sales Return #' . $mainTable->return_no,
                'currency' => $mainTable->currency,
                'exchange_rate' => $mainTable->exchange_rate,
                'emirate_id' => (int) $mainTable->sr_customer->state,
                'amount' => (float) $total_sales,
                'outlet' => $mainTable->outlet
            ));
        }
        if ($total_tax_amount > 0) {
            //VAT Cr
            $this->addVoucheritems($lastSavedid, array(
                'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales_vat'),
                // 'brand_id' => $mainTable->order_id,
                'subledger_id' => 0,
                'narration' => 'Sales Return #' . $mainTable->return_no,
                'currency' => $mainTable->currency,
                'exchange_rate' => $mainTable->exchange_rate,
                'emirate_id' => (int) $mainTable->sr_customer->state,
                'amount' => (float) $total_tax_amount,
                'outlet' => $mainTable->outlet
            ));
        }

        FinanceVoucherHead::model()->updatebypk($lastSavedid, array('total_voucher_amount' => ($mainTable->grand_total), 'cheque_cleared' => 'Y')); //$netTotal
        $mainTable->posted = 'Y';
        $mainTable->save();
    }

    function isPostable($date) {
        $last_closed_year = FinanceAuditClose::lastClosed();
        $voucherDate_array = explode('-', $date);
        $voucherYear = $voucherDate_array[0];
        return ($voucherYear <= $last_closed_year) ? false : true;
    }

    function getSublegder($parnet_id, $subledger_type) {
        return FinanceSubledger::model()->find(array('condition' => 'parent_id=' . (int) $parnet_id . ' AND subledger_type_id=' . (int) $subledger_type))->id;
    }

    public function addVoucherhead($arr_items) {
        $model = new FinanceVoucherHead;
        $model->voucher_type = $arr_items['voucher_type'];
        $model->voucher_no = $arr_items['voucher_no'];
        $model->voucher_date = $arr_items['voucher_date'];
        $model->related_subledger = $arr_items['related_subledger'];
        $model->emp_subledger = $arr_items['emp_subledger'];
        $model->due_date = (isset($arr_items['due_date'])) ? $arr_items['due_date'] : $model->voucher_date;
        $model->header_table_id = $arr_items['header_table_id'];
        $model->reference_no = $arr_items['reference_no'];
        $model->is_posted = (isset($arr_items['is_posted'])) ? $arr_items['is_posted'] : 'Y';
        $model->created_by = $arr_items['created_by'];
        $model->created_datetime = date('Y-m-d h:i:s');
        $model->cheque_no = $arr_items['cheque_no'];
        $model->outlet = $arr_items['outlet'];
        return ($model->save(false)) ? $model->id : 0; //exception
    }

    public function addVoucheritems($headerId, $arr_items) {
        $model = new FinanceVoucherItems;
        $model->header_id = $headerId;
        $model->ledger_id = $arr_items['ledger_id'];
        $model->brand_id = (int) $arr_items['brand_id'];
        $model->emirate_id = $arr_items['emirate_id'];
        $model->subledger_id = $arr_items['subledger_id'];
        $model->narration = $arr_items['narration'];
        $model->amount = $arr_items['amount'];
        $model->currency_id = $arr_items['currency'] > 0 ? $arr_items['currency'] : FinanceLegder::baseCurrency_id();
        $model->exchange_rate = $arr_items['exchange_rate'] > 0 ? $arr_items['exchange_rate'] : 1;
        $model->amount = $arr_items['amount'];
        $model->reconciled_date = $arr_items['reconciled_date'];
        $model->outlet = $arr_items['outlet'];
        $cleared = $arr_items['opening_cheque_cleared'];
        if ($cleared == '')
            $cleared = 'N';
        $model->opening_cheque_cleared = $cleared;
        $reconciled = $arr_items['reconciled'];
        if ($reconciled == '')
            $reconciled = 'N';
        $model->reconciled = $reconciled;
        $model->outlet = Yii::app()->user->outlet_id;
        $model->save(false);
        return $model->id > 0 ? $model->id : 0;
    }

    function actionBulkInvoicePosting1() {
        $SalesInvoice = SalesReturn::model()->findAll(array('condition' => 'active="Y"'));
        foreach ($SalesInvoice as $EachSalesInvoice) {
            $invoice_id = $EachSalesInvoice->id;
            $mainTable = SalesReturn::model()->findByPk((int) $invoice_id);
        $outlet=Yii::app()->user->outlet_id;
        $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="CN" AND outlet='.$outlet))->id;
            $fin_voucher = FinanceVoucherHead::model()->find(array('condition' => 'voucher_type='.$vouchertype.' AND header_table_id=' . $mainTable->id));
            if (!empty($fin_voucher)) {
                FinanceVoucherItems::model()->deleteAll(array('condition' => 'header_id=' . $fin_voucher->id));
                FinanceVoucherHead::model()->deleteByPk($fin_voucher->id);
            }
            $voucherHead['voucher_no'] = $mainTable->return_no;
            $voucherHead['voucher_date'] = $mainTable->return_date;
            $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);
        $outlet=Yii::app()->user->outlet_id;
        $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="CN" AND outlet='.$outlet))->id;
            $voucherHead['voucher_type'] = $vouchertype;
            // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
            $voucherHead['reference_no'] = $mainTable->reference_no;
            $voucherHead['header_table_id'] = $mainTable->id;
            $voucherHead['due_date'] = $mainTable->return_date;
            $voucherHead['outlet'] = $mainTable->outlet;
            // $voucherHead['due_date'] = date('Y-m-d', strtotime($mainTable->invoice_date . ' + ' . (int) $mainTable->paymentTerm->no_of_days . ' days'));
            $valid = $this->isPostable($mainTable->return_date);

            $lastSavedid = $valid ? $this->addVoucherhead($voucherHead) : 0;

            $total_debtor_amount = round($mainTable->grand_total, 2);
            $total_sales = round($mainTable->total_amount, 2);
            $total_tax_amount = round($mainTable->tax_total, 2);
            $total_discount_amount = round($mainTable->discount, 2);
            $total_received_amount = round($mainTable->paid, 2);
            if ($total_debtor_amount > 0) {
                //Debtor Dr
                $debit_item_sales = $this->addVoucheritems($lastSavedid, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),
                    // 'brand_id' => $mainTable->order_id,
                    'subledger_id' => $this->getSublegder($mainTable->customer_id, 1), //2-Creditors 1- debtors
                    'narration' => 'Sales Return #' . $mainTable->return_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->sr_customer->state,
                    'amount' => -1 * $total_debtor_amount,
                    'outlet' => $mainTable->outlet
                ));

                if ($total_received_amount > 0) {
        $outlet=Yii::app()->user->outlet_id;
        $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="PV" AND outlet='.$outlet))->id;
                    $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);
                    $voucherHead['voucher_date'] = $mainTable->return_date;
                    $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);
                    $voucherHead['voucher_type'] = $vouchertype;
                    // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
                    $voucherHead['reference_no'] = $mainTable->reference_no;
                    $voucherHead['header_table_id'] = $mainTable->id;
                    $voucherHead['due_date'] = $mainTable->return_date;
                    $voucherHead['outlet'] = $mainTable->outlet;
                    $lastSavedid_receipt_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;

                    $debit_item_receipt = $this->addVoucheritems($lastSavedid_receipt_voucher, array(
                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),
                        'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),
                        'narration' => 'Sales Return #' . $mainTable->return_no,
                        'currency' => $mainTable->currency,
                        'exchange_rate' => $mainTable->exchange_rate,
                        'emirate_id' => (int) $mainTable->sr_customer->state,
                        'amount' => (float) $total_received_amount,
                        'outlet' => $mainTable->outlet
                    ));

                    $this->addVoucheritems($lastSavedid_receipt_voucher, array(
                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('cash_account'),
                        'subledger_id' => MasUsers::model()->findByPk($mainTable->created_by)->subledger_id,
                        'narration' => 'Sales Return #' . $mainTable->return_no,
                        'currency' => $mainTable->currency,
                        'exchange_rate' => $mainTable->exchange_rate,
                        'emirate_id' => (int) $mainTable->sr_customer->state,
                        'amount' => -1 * $total_received_amount,
                        'outlet' => $mainTable->outlet
                    ));
                    FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('total_voucher_amount' => ($total_received_amount), 'cheque_cleared' => 'Y')); //$netTotal
                    //Auto Allocation
                    $allocation = new FinanceAllocation;
                    $allocation->allocation_date = $mainTable->return_date;
                    $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');
                    $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);
                    $allocation->amount = (float) $total_received_amount;
                    $allocation->created_by = Yii::app()->user->id;
                    $allocation->created_date_time = date('Y-m-d h:i:s');
                    $allocation->outlet = $mainTable->outlet;
                    $allocation->save(false);
                    $allocation_items = new FinanceAllocationItems;
                    $allocation_items->header_id = $allocation->id;
                    $allocation_items->voucher_id = $lastSavedid;
                    $allocation_items->voucher_item_id = $debit_item_sales;
                    $allocation_items->amount = (float) $total_received_amount;
                    $allocation_items->outlet = $mainTable->outlet;
                    $allocation_items->save(false);
                    FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));
                    $allocation_items = new FinanceAllocationItems;
                    $allocation_items->header_id = $allocation->id;
                    $allocation_items->voucher_id = $lastSavedid_receipt_voucher;
                    $allocation_items->voucher_item_id = $debit_item_receipt;
                    $allocation_items->amount = -1 * $total_received_amount;
                    $allocation_items->outlet = $mainTable->outlet;
                    $allocation_items->save(false);
                    FinanceVoucherHead::model()->updatebypk($lastSavedid_receipt_voucher, array('is_allocated' => 'Y'));
                }
                // Discount Start
                if ($total_discount_amount > 0) {
        $outlet=Yii::app()->user->outlet_id;
        $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="DA" AND outlet='.$outlet))->id;
                    $voucherHead['voucher_no'] = FinanceVoucherType::getVoucherno($vouchertype, true);
                    $voucherHead['voucher_date'] = $mainTable->return_date;
                    $voucherHead['related_subledger'] = $this->getSublegder($mainTable->customer_id, 1);
                    $voucherHead['voucher_type'] = $vouchertype;
                    // $voucherHead['emp_subledger'] = getSublegder($mainTable->lead_owner_id, 3);
                    $voucherHead['reference_no'] = $mainTable->reference_no;
                    $voucherHead['header_table_id'] = $mainTable->id;
                    $voucherHead['due_date'] = $mainTable->return_date;
                    $voucherHead['outlet'] = $mainTable->outlet;
                    $lastSavedid_discount_voucher = $valid ? $this->addVoucherhead($voucherHead) : 0;

                    $debit_item_discount = $this->addVoucheritems($lastSavedid_discount_voucher, array(
                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('debtors'),
                        'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),
                        'narration' => 'Sales Return #' . $mainTable->return_no,
                        'currency' => $mainTable->currency,
                        'exchange_rate' => $mainTable->exchange_rate,
                        'emirate_id' => (int) $mainTable->sr_customer->state,
                        'amount' => (float) $total_discount_amount,
                        'outlet' => $mainTable->outlet
                    ));

                    $this->addVoucheritems($lastSavedid_discount_voucher, array(
                        'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('discount'),
                        'subledger_id' => $this->getSublegder($mainTable->customer_id, 1),
                        'narration' => 'Sales Return #' . $mainTable->return_no,
                        'currency' => $mainTable->currency,
                        'exchange_rate' => $mainTable->exchange_rate,
                        'emirate_id' => (int) $mainTable->sr_customer->state,
                        'amount' => -1 * $total_discount_amount,
                        'outlet' => $mainTable->outlet
                    ));

                    FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('total_voucher_amount' => ($total_discount_amount), 'cheque_cleared' => 'Y')); //$netTotal
                    //Auto Allocation
                    $allocation = new FinanceAllocation;
                    $allocation->allocation_date = $mainTable->return_date;
                    $allocation->ledger_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');
                    $allocation->subledger_id = $this->getSublegder($mainTable->customer_id, 1);
                    $allocation->amount = (float) $total_discount_amount;
                    $allocation->created_by = Yii::app()->user->id;
                    $allocation->created_date_time = date('Y-m-d h:i:s');
                    $allocation->outlet = $mainTable->outlet;
                    $allocation->save(false);
                    $allocation_items = new FinanceAllocationItems;
                    $allocation_items->header_id = $allocation->id;
                    $allocation_items->voucher_id = $lastSavedid;
                    $allocation_items->voucher_item_id = $debit_item_sales;
                    $allocation_items->amount = -1 * $total_discount_amount;
                    $allocation_items->outlet = $mainTable->outlet;
                    $allocation_items->save(false);
                    FinanceVoucherHead::model()->updatebypk($lastSavedid, array('is_allocated' => 'Y'));
                    $allocation_items = new FinanceAllocationItems;
                    $allocation_items->header_id = $allocation->id;
                    $allocation_items->voucher_id = $lastSavedid_discount_voucher;
                    $allocation_items->voucher_item_id = $debit_item_discount;
                    $allocation_items->amount = (float) $total_discount_amount;
                    $allocation_items->outlet = $mainTable->outlet;
                    $allocation_items->save(false);
                    FinanceVoucherHead::model()->updatebypk($lastSavedid_discount_voucher, array('is_allocated' => 'Y'));
                }
                // END Discount
            }

            if ($total_sales > 0) {
                //Sales Accounts Cr
                $this->addVoucheritems($lastSavedid, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales'),
                    // 'brand_id' => $mainTable->order_id,
                    // 'subledger_id' => $this->getSublegder($mainTable->lead_owner_id, 3),
                    'narration' => 'Sales Return #' . $mainTable->return_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->sr_customer->state,
                    'amount' => (float) $total_sales,
                    'outlet' => $mainTable->outlet
                ));
            }
            if ($total_tax_amount > 0) {
                //VAT Cr
                $this->addVoucheritems($lastSavedid, array(
                    'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('sales_vat'),
                    // 'brand_id' => $mainTable->order_id,
                    'subledger_id' => 0,
                    'narration' => 'Sales Return #' . $mainTable->return_no,
                    'currency' => $mainTable->currency,
                    'exchange_rate' => $mainTable->exchange_rate,
                    'emirate_id' => (int) $mainTable->sr_customer->state,
                    'amount' => (float) $total_tax_amount,
                    'outlet' => $mainTable->outlet
                ));
            }

            FinanceVoucherHead::model()->updatebypk($lastSavedid, array('total_voucher_amount' => (round($mainTable->grand_total, 2)), 'cheque_cleared' => 'Y')); //$netTotal
            $mainTable->posted = 'Y';
            $mainTable->save();
        }
    }

    public function actionCreateConsolidated() {
        $model = new SalesReturn;
        $modelItems = array(new SalesReturnItems);
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('create_consolidated', array('model' => $model, 'modelItems' => $modelItems));
    }

    public function actionGetInvoices() {
        $from_date = $_POST['from_date'];
        $to_date = $_POST['to_date'];
        $customer_id = $_POST['customer_id'];
        $created_user = $_POST['created_user'];
        $condition = 'active="Y" ';
        if ($from_date != '' && $from_date != '00/00/0000') {
            $from = str_replace('/', '-', $from_date);
            $from = date("Y-m-d", strtotime($from));
            $condition.=' AND t.invoice_date>="' . $from . '"';
        }
        if ($to_date != '' && $to_date != '00/00/0000') {
            $to = str_replace('/', '-', $to_date);
            $to = date("Y-m-d", strtotime($to));
            $condition.=' AND t.invoice_date<="' . $to . '"'; 
        }
        if ($customer_id > 0) {
            $condition.=' AND t.customer_id=' . $customer_id;
        }
        if ((int)$created_user>0){
            $condition.=' AND t.sales_man=' .$created_user;
        }
        $condition.=" AND outlet=". Yii::app()->user->outlet_id;
        $modelInvoices = SalesInvoice::model()->findAll(array('condition' => $condition, 'order' => 'id Desc'));
        $this->renderPartial('customer_invoices', array('modelItems' => $modelInvoices, 'customer_id' => $customer_id, 'sales_man_id' => $created_user));
    }

    public function actionConsolidated_form() {
        $invoice_ids = Yii::app()->request->getParam('invoice_ids');
        $customer_id = Yii::app()->request->getParam('customer_id');
        $user_id     = Yii::app()->request->getParam('user_id');
        $model = new SalesReturn;
        $modelItems = array(new SalesReturnItems);
        if ($invoice_ids != '') {
            $invmodelItems = SalesInvoiceItems::model()->findAll(array('condition' => 'invoice_id IN (' . $invoice_ids . ')', 'order' => 't.product_id'));
            $model->customer_id = $customer_id;
            /* $invoice_date=date('d/m/Y',strtotime($invmodel->invoice_date));
              $model->currency = $invmodel->currency;
              $model->exchange_rate = $invmodel->exchange_rate; */
            $model->invoice_id = $invoice_ids;
            $arr_ids=array();
            
            if($user_id>0)
                $sales_man=$user_id;
            else
                $sales_man=Yii::app()->user->id;
            
            $already_returned_qty = 0;
            $k = 0;
            foreach ($invmodelItems as $each) {
                $sql="select IFNULL(SUM(S.quantity*S.unit_exchange_rate),0) from {{stock_ledger}} S LEFT JOIN {{sales_return_items}} R ON R.id=S.item_id where R.invoice_id='" . $each->invoice_id . "'  AND type='SR' AND S.product_id='" . $each->product_id . "' AND outlet=" . Yii::app()->user->outlet_id;
                $already_returned_qty = Yii::app()->db->createCommand($sql)->queryScalar();
                $qty_returnable =$each->quantity-$already_returned_qty;
                if((int)$qty_returnable>0){
                    $modelItems[$k] = new SalesReturnItems;
                    $modelItems[$k]->product_id = $each->product_id;
                    $modelItems[$k]->description = $each->description;
                    $modelItems[$k]->invoice_id = $each->invoice_id;
                    $modelItems[$k]->invoice_item_id = $each->id;
                    $modelItems[$k]->invoiced_qty = $each->quantity;
                    $modelItems[$k]->returned_quantity = 0;
                    $modelItems[$k]->unit = $each->unit;
                    $modelItems[$k]->rate = $each->rate;
                    $modelItems[$k]->amount = 0.00;
                    $modelItems[$k]->excise_percentage = $each->excise_percentage;
                    $modelItems[$k]->excise_amount = 0.00;
                    $modelItems[$k]->tax_percentage = $each->tax_percentage;
                    $modelItems[$k]->tax_amount = 0.00;
                    $modelItems[$k]->net_amount = 0.00;
                    if (!in_array($each->invoice->invoice_no, $arr_ids)){
                        $arr_ids[]      = $each->invoice->invoice_no;
                    }
                    
                    $k++;
                }
            }
        }
        $model->invoice_no = implode(',',$arr_ids);
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false, '*jquery-2.1.4.min.js' => false, 'jquery-2.1.4.min.js' => false, '*.css' => false);
        $this->render('consolidated_form', array('model' => $model, 'modelItems' => $modelItems, 'invoice_date' => $invoice_date,'user_id'=>$user_id));
    }

    public function actionSaveConsolidated() {
        $model = new SalesReturn();
        if (isset($_POST['SalesReturn'])) {

            $total_amount = 0;
            $total_tax_amount = 0;
            $total_excise_amount = 0;
            $grand_total = 0;
            $other = array();
            $model->created_by = Yii::app()->user->id;
            $model->created_time = date('Y-m-d H:i:s');
            $scene = 'new';
            $change_type = 'CREATED';
            $modelformmaster = FormMaster::model()->find(array('condition' => 'outlet=' . Yii::app()->user->outlet_id . ' AND code="SR"'));
            $model->updated_by = Yii::app()->user->id;
            $model->updated_time = date('Y-m-d H:i:s');
            $model->attributes = $_POST['SalesReturn'];
            $model->outlet = Yii::app()->user->outlet_id;
            !empty($modelformmaster)?$next_number=$modelformmaster->next_number:$next_number=1;
            $model->return_no = $next_number;
            $model->total_amount = $total_amount;
            $model->excise_total = $total_excise_amount;
            $model->tax_total = $total_tax_amount;
            $model->grand_total = $grand_total;
            if ($_POST['SalesReturn']['return_date'] != '00/00/0000') {
                $model->return_date = str_replace('/', '-', $_POST['SalesReturn']['return_date']);
                $model->return_date = date("Y-m-d", strtotime($model->return_date));
            }
            $model->is_multiple='Y';
            $valid = $model->validate();
            $groups = array();
            if((int)$_POST['SalesReturn']['salesman_id']>0){
                $sales_man = (int)$_POST['SalesReturn']['salesman_id'];
            }else{
                $sales_man = Yii::app()->user->id;
            }
            if (is_array($_POST['SalesReturnItems'])) {
                foreach ($_POST['SalesReturnItems'] as $i => $each) {
                    if ($each['product_id'] > 0) {
                        $modelItems[$i] = new SalesReturnItems();
                        $modelItems[$i]->attributes = $each;
                        $modelItems[$i]->return_id = 0;
                        $valid = $valid && $modelItems[$i]->validate();
                        // Product Grouping
                        if ($each['unit'] > 0) {
                            $unit = MasUnit::model()->findByPk($each['unit']);
                            $unit_exchange = $unit->unit_exchange_rate;
                        } else {
                            $unit_exchange = 0;
                        }
                        $key = $each['product_id'].'_'.$each['invoice_id'];
                        if (!array_key_exists($key, $groups)) {
                            $groups[$key] = array(
                                'id' => $each['product_id'],
                                'returned_quantity' => $each['returned_quantity'] * $unit_exchange
                            );
                        } else {
                            $groups[$key]['returned_quantity'] = $groups[$key]['returned_quantity'] + $each['returned_quantity'] * $unit_exchange;
                        }
                    }
                }
            }
            // QTY Checking
            if (!empty($groups)) {
                foreach ($groups as $key => $eachProduct) {
                    $arr_key=explode('_',$key);
                    $pdt_id=$arr_key[0];
                    $inv_id=$arr_key[1];
                    $product = Inventory::model()->findByPk($pdt_id);
                    $bal = $eachProduct['returned_quantity'];
                    if(Yii::app()->user->user_access_type=='CA'){
                        $invoiced_qty = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0) from {{stock_ledger}} where type='SI' AND product_id='" . $pdt_id . "' AND header_id ='" . $inv_id . "'  AND outlet=" . Yii::app()->user->outlet_id)->queryScalar();
                    }else{
                        $invoiced_qty = Yii::app()->db->createCommand("select IFNULL(SUM(quantity*unit_exchange_rate),0) from {{stock_ledger}} where type='SI' AND product_id='" . $pdt_id . "' AND header_id ='" . $inv_id . "'  AND outlet=" . Yii::app()->user->outlet_id . " AND created_by=" . $sales_man)->queryScalar();
                    }
                    $already_returned_qty = Yii::app()->db->createCommand("select IFNULL(SUM(S.quantity*S.unit_exchange_rate),0) from {{stock_ledger}} S LEFT JOIN {{sales_return_items}} R ON R.id=S.item_id where R.invoice_id='" . $inv_id . "'  AND type='SR' AND S.product_id='" . $pdt_id . "' AND outlet=" . Yii::app()->user->outlet_id)->queryScalar();
                    $balance = $invoiced_qty - $already_returned_qty;
                    if ($eachProduct['returned_quantity'] > $balance) {
                        $other[] = $product->part_number . ' maximum quantities to be returned : ' . ($balance) . ' ' . $product->units->unit_name;
                        $valid = false;
                    } else if ($bal < 0 && $product->type != 'S') {
                        $other[] = $product->part_number . ' returned quantity should be greater than zero ' . $product->units->unit_name;
                        $valid = false;
                        
                    }
                }
            }


            if ($valid && is_array($modelItems)) {
                $model->save();
                $next_no = $model->return_no + 1;
                FormMaster::model()->updateByPk($modelformmaster->id, array('next_number' => $next_no));
                

                foreach ($modelItems as $eachItem) {
                    $eachItem->return_id = $model->id;
                    $total_amount+=$eachItem->amount;
                    $total_tax_amount+=$eachItem->tax_amount;
                    $total_excise_amount+=$eachItem->excise_amount;
                    $eachItem->save(false);
                    $grand_total+=$eachItem->net_amount;

                    $stockledger = new StockLedger;
                    $stockledger->transaction_date = $model->return_date;
                    $stockledger->transaction_type = 'IN';
                    $stockledger->type = 'SR';
                    $stockledger->customer_vendor_id = $model->customer_id;
                    $stockledger->header_id = $model->id;
                    $stockledger->item_id = $eachItem->id;
                    $stockledger->product_id = $eachItem->product_id;
                    $stockledger->rate = $eachItem->rate;
                    $stockledger->currency = 1;
                    $stockledger->exchange_rate = 1;
                    $stockledger->quantity = $eachItem->returned_quantity;
                    $stockledger->unit = $eachItem->unit;
                    $stockledger->default_product_unit = $eachItem->sr_units->base_unit_id;
                    $stockledger->unit_exchange_rate = $eachItem->sr_units->unit_exchange_rate;
                    $stockledger->outlet = Yii::app()->user->outlet_id;
                    $stockledger->created_by = $sales_man;
                    $stockledger->created_time = date('Y-m-d H:i:s');
                    $stockledger->save(false);
                }
                // inserting to audit log
                AuditLog::saveAuditLogs(
                        $modelformmaster->id, $sales_man, $change_type, " with ID - {$model->id} "
                );
                // end audit log
                $model->total_amount = $total_amount;
                $model->excise_total = $total_excise_amount;
                $model->tax_total = $total_tax_amount;
                $model->grand_total = $grand_total;
                $model->save();
                $this->salesreturnPosting($model->id);
                $jsonData['status'] = 'success';
                echo CJSON::encode($jsonData);
            } else {
                $error1 = json_decode(CActiveForm::validate($model, '', false), true);
                if (!empty($modelItems))
                    $error2 = json_decode(CActiveForm::validateTabular($modelItems, '', false), true);
                else
                    $error2[] = "Please add atleast one line item";
                $error = CJSON::encode(array_merge_recursive($error1, $error2, $other));
                if ($error != '[]') {
                    echo $error;
                }
            }
        }
    }
    public function actionGetInvoiceProducts(){
        $invoice_id = (int)Yii::app()->request->getParam('id');
        $invmodelItems = SalesInvoiceItems::model()->findAll(array('condition' => 'invoice_id = "' . $invoice_id . '"', 'order' => 't.product_id'));
        $table = '<table class="table table-primary">';
        foreach($invmodelItems as $each){
            $table .= '<tr>';
            $table .= '<td>'.$each->product->part_number.'</td>';
            $table .= '<td class="text-right">'.$each->quantity.'</td>';
            $table .= '</tr>';
        }
        echo $table;
    }
}
