<?php
class MasTax extends CActiveRecord
{
	public function tableName()
	{
		return '{{master_tax}}';
	}
	public function rules()
	{
		return array(
			array('tax_code,tax_percentage', 'required'),
			array('created_by, updated_by', 'numerical', 'integerOnly'=>true),
			array('tax_code', 'length', 'max'=>50),
			array('active,is_default', 'length', 'max'=>1),
			array('created_time, updated_time', 'safe'),
			array('tax_code', 'unique'),
			array('id, tax_code, created_by, created_time, updated_by, updated_time, active, outlet', 'safe', 'on'=>'search'),
		);
	}

	public function relations()
	{
		return array(
		);
	}
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'tax_code' => 'Tax Code',
			'created_by' => 'Created By',
			'created_time' => 'Created Time',
			'updated_by' => 'Updated By',
			'updated_time' => 'Updated Time',
			'active' => 'N : No, Y: Yes',
			'outlet' => 'Outlet',
		);
	}
	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('tax_code',$this->tax_code,true);
		$criteria->compare('created_by',$this->created_by);
		$criteria->compare('created_time',$this->created_time,true);
		$criteria->compare('updated_by',$this->updated_by);
		$criteria->compare('updated_time',$this->updated_time,true);
		$criteria->compare('active',$this->active,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
	public static function getAllTax(){
	return CHtml::listData(self::model()->findAll( array( 'condition' => 'active="Y"', 'order' => 'is_default ASC, tax_code ASC' ) ), 'id', 'tax_code'); 
	}
}
