<?php
class ProductionItems extends CActiveRecord
{
	public $part_no;
	public function tableName()
	{
		return '{{production_items}}';
	}

	public function rules()
	{
		return array(
			array('production_id, product_id, description, quantity, unit', 'required'),
			array('production_id, product_id,  unit', 'numerical', 'integerOnly'=>true),
			array('quantity', 'length', 'max'=>15),
			array('description', 'length', 'max'=>5000),
			array('id, production_id, product_id, description, quantity, unit', 'safe', 'on'=>'search'),
		);
	}
	public function relations()
	{
		return array(
		    'pr_product_details'     => array(self::BELONGS_TO, 'Inventory', 'product_id'),
                                             'pr_unit_details'        => array(self::BELONGS_TO, 'MasUnit', 'unit'),
                    );
	}
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'production_id' => 'Production',
			'product_id' => 'Product',
			'description' => 'Description',
			'quantity' => 'Quantity',
			'unit' => 'Unit',
		);
	}

	public function search()
	{

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('production_id',$this->production_id);
		$criteria->compare('product_id',$this->product_id);
		$criteria->compare('description',$this->description);
		$criteria->compare('quantity',$this->quantity,true);
		$criteria->compare('unit',$this->unit);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
