<?php
class SalesInvoice extends CActiveRecord
{
    public $customer_name;
    public $total_discount_percentage_amount;
    public $consider_sp_not_less_cp='N',$consider_previous_sprice='N';
	public function tableName()
	{
		return '{{sales_invoice}}';
	}
	public function rules()
	{
		return array(
			array('invoice_date,invoice_no, customer_id,invoice_type,payment_term, total_amount, excise_total, tax_total, grand_total, currency, exchange_rate, outlet,sales_man,taxable', 'required'),
			array('invoice_no, customer_id, payment_term, currency, created_by, updated_by, outlet,invoice_type', 'numerical', 'integerOnly'=>true),
			array('prefix, reference_no', 'length', 'max'=>50),
			array('callback_from', 'length', 'max'=>3),
			array('total_amount, excise_total, tax_total, grand_total, exchange_rate,received,discount,old_discount,total_discount_amount,total_discount_percentage', 'numerical'),
			array('active, posted', 'length', 'max'=>1),
			array('invoice_date, created_time, updated_time', 'safe'),
			array('notes', 'length', 'max'=>2225),
			array('id, prefix, invoice_no, reference_no,total_discount_percentage,total_discount_amount, invoice_date, customer_id, payment_term, total_amount, excise_total, tax_total, grand_total, currency, exchange_rate, created_by, created_time, updated_by, updated_time, active, posted, outlet', 'safe', 'on'=>'search'),
		);
	}
	public function relations()
	{
		return array(
		    'sales_outlet' => array(self::BELONGS_TO, 'MasOutlets', 'outlet'),
		    'sales_cur' => array(self::BELONGS_TO, 'MasCurrency', 'currency'),
            'customer' => array(self::BELONGS_TO, 'Customer', 'customer_id'),
            'pay_term' => array(self::BELONGS_TO, 'MasPaymentTerms', 'payment_term'),
            'user' => array(self::BELONGS_TO, 'MasUsers', 'created_by'),
            'si_salesman' => array(self::BELONGS_TO, 'MasUsers', 'sales_man'),
		);
	}

	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'prefix' => 'Prefix',
			'invoice_no' => 'Invoice No',
			'reference_no' => 'Customer Invoice No',
			'invoice_date' => 'Invoice Date',
			'sales_man'  => 'Sales Man',
			'customer_id' => 'Customer',
			'payment_term' => 'Payment Term',
			'total_amount' => 'W/O Tax',
			'excise_total' => 'Excise Total',
			'tax_total' => 'Tax Total',
			'grand_total' => 'Grand Total',
			'currency' => 'Currency',
			'exchange_rate' => 'Exchange Rate',
			'created_by' => 'Created By',
			'created_time' => 'Created Time',
			'updated_by' => 'Updated By',
			'updated_time' => 'Updated Time',
			'active' => 'N : No, Y : Yes',
			'posted' => 'N : No, Y : Yes',
			'outlet' => 'Outlet',
		);
	} 

	public function search()
	{
		$criteria=new CDbCriteria;
		$criteria->compare('id',$this->id);
		$criteria->compare('prefix',$this->prefix,true);
		$criteria->compare('invoice_no',$this->invoice_no);
		$criteria->compare('reference_no',$this->reference_no,true);
		$criteria->compare('invoice_date',$this->invoice_date,true);
		$criteria->compare('customer_id',$this->customer_id);
		$criteria->compare('payment_term',$this->payment_term);
		$criteria->compare('total_amount',$this->total_amount,true);
		$criteria->compare('excise_total',$this->excise_total,true);
		$criteria->compare('tax_total',$this->tax_total,true);
		$criteria->compare('grand_total',$this->grand_total,true);
		$criteria->compare('currency',$this->currency);
		$criteria->compare('exchange_rate',$this->exchange_rate,true);
		$criteria->compare('created_by',$this->created_by);
		$criteria->compare('created_time',$this->created_time,true);
		$criteria->compare('updated_by',$this->updated_by);
		$criteria->compare('updated_time',$this->updated_time,true);
		$criteria->compare('active',$this->active,true);
		$criteria->compare('posted',$this->posted,true);
		$criteria->compare('outlet',$this->outlet);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
