<?php

class CossaleController extends Controller {

    public function accessRules() {

        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
            'actions' => array('PrintReportItemsPDF','PrintReportInvoicePDF','Customer_Sales','statement_html','ExcelItems','ExcelInvoice'
                ),
                'expression' => '$user->isMember()',
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function filters() {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }
    public function actionCustomer_Sales() {
        $this->render('customer_report');
    } 
    public function actionStatement_html()
    {
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');

        echo $ledger_id = (int) $_POST['ledger_id'];
        $subledger_id = (int) $_POST['subledger_id'];
        $currency = (int) $_POST['currency'];
        $outlet = (int) $_POST['outlet'];
        $cur=MasCurrency::model()->findByPk($currency);
        $exchange_rate=$cur->exchange_rate;
        $currency_code=$cur->currency_code;
        $amountType = 'VI.amount < 0';
        $paidType = 'VI.amount > 0';
        if ($_POST['type'] == 'customer') {
            $amountType = 'VI.amount > 0';
            $paidType = 'VI.amount < 0';
        }

        function generateUrl($childModel)
        {
            $url = '#';
            $code = $childModel->parent->vtype->code;
            if ($code == 'SI') {
                $headModel = $childModel->parent->vtype->header_table;
                $vat_field = $childModel->parent->vtype->vat_value;
                $inv = $headModel::model()->findBypk($childModel->parent->header_table_id);
                $tax=$inv->$vat_field;
                $taxType = ($tax > 0) ? 'tax' : 'taxnil';
                $url = "window.open($('#liveSite').val()+'index.php?r=salesinvoice/PrintPDF&id=" . $childModel->parent->header_table_id."&frm=" . $taxType . "&type=1', '_blank');";
            } else if ($code == 'PI') {
                $url = "window.open($('#liveSite').val()+'index.php?r=purchaseinvoice/PrintInvoiceReportPDF&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'DN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=debitnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'CN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=creditnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else {
                $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $childModel->header_id . "', '_blank');";
            }
            return $url;
        }

        $items = array();
        $table = '<table class="table table-hover table-fixed table-bordered" id="gl_table">
                    <thead>
                        <tr>
                            <th style="width:10%">Date</th>
                             <th style="width:10%"> Type </th>
                            <th style="width:10%">Voucher #</th>
                            <th style="width:10%">Due Date</th>
                            <th style="width:10%">Over Due</th>
                            <th style="width:10%">Ref</th>
                            <th style="width:10%">Voucher value</th>
                            <th style="width:10%">Paid</th>
                            <th style="width:10%">Balance</th>
                        </tr>
                    </thead>
                    <tbody>';
        $condition='';
        $condition_for_opening='';
        if ($outlet > 0) {
            $condition .= ' AND V.outlet=' . $outlet;
            $condition_for_opening .= ' AND V.outlet=' . $outlet;
        }
        $query = 'CREATE OR REPLACE VIEW {{finance_statement}} AS (SELECT
    VT.description AS voucher_type,
    V.id AS voucher_id,
    V.voucher_date AS voucher_date,
    V.due_date AS due_date,
    V.reference_no AS reference_no,
    VI.narration AS narration,
    VI.id AS voucher_item_id,
    V.voucher_no,
    ROUND(ABS(VI.amount*VI.exchange_rate), 4) AS amount,
    ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS allocated,
    ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS balance
FROM {{finance_voucher_items}} VI
LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
LEFT JOIN {{finance_voucher_type}} VT ON VT.id = V.voucher_type
LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
WHERE V.is_posted ="Y" AND V.voucher_date<="'.$to_date.'"  AND ' . $amountType . ' AND VI.ledger_id = ' . $ledger_id . ' AND VI.subledger_id = ' . $subledger_id . ' '.$condition.'
GROUP BY VI.id)
UNION
(SELECT
    VT.description AS voucher_type,
    V.id AS voucher_id,
    V.voucher_date AS voucher_date,
    V.due_date AS due_date,
    V.reference_no AS reference_no,
    VI.narration AS narration,
    VI.id AS voucher_item_id,
    V.voucher_no,
    -(ROUND(ABS(VI.amount*VI.exchange_rate), 4)) AS amount,
    -(ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS allocated,
    -(ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS balance
FROM {{finance_voucher_items}} VI
LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
LEFT JOIN {{finance_voucher_type}} VT ON VT.id = V.voucher_type
LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
WHERE V.is_posted ="Y" AND V.voucher_date<="'.$to_date.'"  AND ' . $paidType . ' AND VI.ledger_id = ' . $ledger_id . ' AND VI.subledger_id = ' . $subledger_id. ' '.$condition.'
GROUP BY VI.id)';
        if ($ledger_id > 0 && $subledger_id > 0) {
            Yii::app()->db->createCommand($query)->execute();
            $items = Yii::app()->db->createCommand('SELECT * FROM {{finance_statement}} order by voucher_date')->queryAll();
        }
        $amount=0;
        $allocated=0;
        $balanced=0;
//        $table .= '<tr>
//                            <td colspan="3">Opening Balance</td>
//                            <td style="text-align:right !important;">'.Yii::app()->numberFormatter->formatCurrency(($opening_bal/$exchange_rate), " ") . '</td>
//                            <td style="text-align:right !important;">'.Yii::app()->numberFormatter->formatCurrency((0/$exchange_rate), " ") . '</td>
//                            <td style="text-align:right !important;">'.Yii::app()->numberFormatter->formatCurrency(($opening_bal/$exchange_rate), " ") . '</td>
//                        </tr>';
        $amount+=$opening_bal;
        $allocated+=0;
        $balanced+=$opening_bal;
        if (!empty($items)) {
            foreach ($items as $each) {
                if(round($each['balance'],2)!=0)
                {
                if ($_POST['type'] == 'customer') {
                $vouchreformat = '<a href="#" onclick="' . generateUrl(FinanceVoucherItems::model()->findBypk((int) $each['voucher_item_id'])) . '">' . $each['voucher_no'] . '</a>';
                
                $head=FinanceVoucherHead::model()->findByPk($each['voucher_id']);
                $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="SI" AND outlet='.$outlet))->id;
                if($head->voucher_type==$vouchertype)
                {
                $ref=PurchaseInvoice::model()->findByPk($head->voucher_no)->reference_no;    
                }
                else {
                $ref=$each['reference_no'];    
                }
                if(empty($ref))
                {
                $ref=$head->voucher_no;    
                }
                $vouchreformat = '<a href="#" onclick="' . generateUrl(FinanceVoucherItems::model()->findBypk((int) $each['voucher_item_id'])) . '">' .  $each['voucher_no'] . '</a>';
                }
                else {
                $head=FinanceVoucherHead::model()->findByPk($each['voucher_id']);
                $vouchertype=FinanceVoucherType::model()->find(array('condition'=>'code="PI" AND outlet='.$outlet))->id;
                if($head->voucher_type==$vouchertype)
                {
                $ref=PurchaseInvoice::model()->findByPk($head->header_table_id)->reference_no;    
                }
                else {
                $ref=$each['reference_no'];    
                }
                if(empty($ref))
                {
                $ref=$head->voucher_no;    
                }
                $vouchreformat = '<a href="#" onclick="' . generateUrl(FinanceVoucherItems::model()->findBypk((int) $each['voucher_item_id'])) . '">' . $each['voucher_no']  . '</a>';
                }
                $now = time(); // or your date as well
                $your_date = strtotime($each['due_date']);
                $datediff = $now - $your_date;
                $over_due = round($datediff / (60 * 60 * 24));
                if($over_due<=0)
                {
                $over_due=0;    
                }
                $table .= '<tr>
                            <td>' . date("d/m/Y", strtotime($each['voucher_date'])) . '</td>
                            <td>' . $each['voucher_type'] . '</td>
                            <td>' . $vouchreformat . '</td>
                            <td>' . date("d/m/Y", strtotime($each['due_date'])) . '</td>
                            <td>' . $over_due . ' Days</td>
                            <td>' . $ref . '</td>
                            <td style="text-align:right !important;">'.Yii::app()->numberFormatter->formatCurrency(($each['amount']/$exchange_rate), " ") . '</td>
                            <td style="text-align:right !important;">'.Yii::app()->numberFormatter->formatCurrency(($each['allocated']/$exchange_rate), " ") . '</td>
                            <td style="text-align:right !important;">'.Yii::app()->numberFormatter->formatCurrency(($each['balance']/$exchange_rate), " ") . '</td>
                        </tr>';
                        $amount+=$each['amount']/$exchange_rate;
                        $allocated+=$each['allocated']/$exchange_rate;
                        $balanced+=$each['balance']/$exchange_rate;
                }
            }
            $table .= '<tr>
                            <td style="text-align:right !important;" colspan="6"><b>Total</b></td>
                            <td style="text-align:right !important;"><b>'.Yii::app()->numberFormatter->formatCurrency(($amount/$exchange_rate), " ") . '</b></td>
                            <td style="text-align:right !important;"><b>'.Yii::app()->numberFormatter->formatCurrency(($allocated/$exchange_rate), " ") . '</b></td>
                            <td style="text-align:right !important;"><b>'.Yii::app()->numberFormatter->formatCurrency(($balanced/$exchange_rate), " ") . '</b></td>
                        </tr>';
        } else {
            $table .= '<tr>
                            <td colspan="6" style="text-align:center !important;">No Data</td>
                      </tr>';
        }
        echo $table;
    }

    public function actionPrintReportItemsPDF() {
        $from_date = Yii::app()->request->getParam('from_date');
        $to_date = Yii::app()->request->getParam('to_date');
        $brand_id = Yii::app()->request->getParam('brand_id');
        $outlet = Yii::app()->request->getParam('outlet');
        $created_user = Yii::app()->request->getParam('created_user');
        
        $customer_id = Yii::app()->request->getParam('customer_id');
         $param = array('brand_id' => $brand_id,
            'from_date' => $from_date,
            'to_date' => $to_date,
            'created_user'=>$created_user, 
            'outlet' => $outlet,'customer_id' => $customer_id);
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('application.modules.finance.views.reports.pdf.print_costsale_items_pdf', $param, true));
        $mpdf->Output("ItemsReport.pdf", 'I');
    }
    public function actionPrintReportInvoicePDF() {
        $from_date = Yii::app()->request->getParam('from_date');
        $to_date = Yii::app()->request->getParam('to_date');
        $brand_id = Yii::app()->request->getParam('brand_id');
        $outlet = Yii::app()->request->getParam('outlet');
        $customer_id = Yii::app()->request->getParam('customer_id');
         $param = array('brand_id' => $brand_id,
            'from_date' => $from_date,
            'to_date' => $to_date,
            'outlet' => $outlet,'customer_id' => $customer_id);
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('application.modules.finance.views.reports.pdf.print_costsale_invoice_pdf', $param, true));
        $mpdf->Output("ItemsReport.pdf", 'I');
    }
    public function actionExcelItems() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'CostSalesItems.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/cost_sales_item', $_GET, false, true);
        Yii::app()->end();
    }
    public function actionExcelInvoice() {
        Yii::app()->clientScript->scriptMap = array('*.js' => false, '*.min.js' => false, '*.css' => false);
        $filename = 'CostSalesInvoice.xls';
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=\"" . $filename . "\"");
        $this->renderPartial('//reports/excel/cost_sale_invoice', $_GET, false, true);
        Yii::app()->end();
    }





}