<!DOCTYPE html>
<html>

<head>
    <title>Trial Balance</title>
</head>

<body>
    <?php $model = GoodsTransfer::model()->findByPk($id);
    $modelItems = GoodsTransferItems::model()->findAll(array('condition' => 'transfer_id=' . $id, 'order' => 'id ASC'));
    if ((int)$user_id > 0) {
        $userModel = MasUsers::model()->findByPk((int) $user_id);
    } else {
        $userModel = MasUsers::model()->findByPk((int) Yii::app()->user->id);
    }
    ?>
    <div class="">
        <div class="col-12">
            <div class="text-center">
                <img src="<?php echo 'images/' . $userModel->companyDetails->pdf_logo; ?>" class="logo">
            </div>

        </div>
        <div class="col-12">
            <br>
            <div class="text-center">
                <!--<div class="h3" style="margin-top: 0;margin-bottom: 0;">Trial Balance</div>-->
            </div>
        </div>
        <div class="col-6">
            <br>
            <div class="input-block">
                <b>Trial Balance</b>
            </div>
            <br> <br>
            <table class="table" style="width:100%">

                <tr>
                    <td><b>From</b></td>
                    <td><?php echo date('d/m/Y', STRTOTIME($from_date)); ?></td>
                </tr>
                <tr>
                    <td><b>To</b></td>
                    <td><?php echo date('d/m/Y', STRTOTIME($to_date)); ?></td>
                </tr>

            </table>
        </div>
    </div>
    <br>
    <?php
    $condition = 'H.is_posted="Y" AND H.voucher_date >= "' . $from_date . '" AND H.voucher_date <= "' . $to_date . '"';

    $bs_condition = 'H.is_posted="Y" AND H.voucher_date <= "' . $to_date . '"';
    if ($outlet > 0) {
        $condition .= ' AND I.outlet=' . $outlet;
        $conditions .= ' AND outlet=' . $outlet;
        $purchase_conditions .= ' AND I.outlet=' . $outlet;
        $bs_condition .= ' AND I.outlet=' . $outlet;
    }

    $time = strtotime($end_date);
    $year = date("Y", $time);
    Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
    Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT I.ledger_id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $bs_condition . ' AND (A.main_account_type="A" OR A.main_account_type="L") group by A.id order by A.account_no)')->execute();
    Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT I.ledger_id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $condition . ' AND (A.main_account_type="I" OR A.main_account_type="E")  group by A.id order by A.account_no)')->execute();
    Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}})')->execute();
    $SQL = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
    $income = Yii::app()->db->createCommand($SQL)->queryAll();
    ?>

    <table class="table table-hover table-fixed table-bordered">
        <thead>
            <tr>
                <th style="width:50%">Accounts</th>
                <th style="width:25%">debit</th>
                <th style="width:25%">credit</th>
            </tr>
        </thead>
        <tbody>';
            <?php
            $totals = array();
            $total_debit = 0;
            $total_credit = 0;
            $Total_Income = 0;
            foreach ($income as $eachAccount) {
                $balance = 0;
                $debit = 0;
                $credit = 0;
                switch ($eachAccount['stage']) {
                    case 1:
                        $space = '&nbsp;&nbsp;&nbsp;';
                        break;
                    case 2:
                        $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                        break;
                    case 3:
                        $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                        break;
                    case 4:
                        $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                        break;
                    case 5:
                        $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                        break;
                }

                $accountName = $eachAccount['title'];
                if ($eachAccount['amount'] > 0) {
                    $debit = $eachAccount['amount'];
                    $total_debit += $debit;
                } else {
                    $credit = -1 * $eachAccount['amount'];
                    $total_credit += $credit;
                }
                if ($eachAccount['rollup_account'] == 'Y') {
                    $acc_id = $eachAccount['id']; ?>

                    <tr>
                        <td colspan="3"><b><?php echo $space . $accountName; ?></b><i class="fa fa-plus"></i></a></td>
                    </tr>

                    <?php  } else {
                    if ($eachAccount['id'] == 10005) {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                        $Total_Expense += $balance;
                        $accountName = 'Cost of Sale';

                        if ($balance > 0) {
                            $debit = abs($balance);
                            $credit = 0;
                        } else {
                            $credit = abs($balance);
                            $debit = 0;
                        }
                    ?>
                        <tr>
                            <td><?php echo $space . $accountName; ?></td>
                            <td style="text-align:right !important;" class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($debit, " "); ?></td>
                            <td style="text-align:right !important;" class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($credit, " "); ?></td>
                        </tr>

                    <?php
                    } else if ($eachAccount['id'] == 4114) {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                        $Total_Expense += $balance;
                        $accountName = 'Damage/stock clearing/expiry';

                        if ($balance > 0) {
                            $debit = abs($balance);
                            $credit = 0;
                        } else {
                            $credit = abs($balance);
                            $debit = 0;
                        }
                    ?>
                        <tr>
                            <td><?php echo $space . $accountName; ?></td>
                            <td style="text-align:right !important;" class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($debit, " "); ?></td>
                            <td style="text-align:right !important;" class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($credit, " "); ?></td>
                        </tr>
                    <?php    } else if ($eachAccount['id'] == 10020) {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS stock 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                        $goods_issue = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                        $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                        $Total_Income += - ($balance + $goods_issue);
                        $accountName = 'Current Stock';

                        $purchase = Yii::app()->db->createCommand('SELECT SUM(amount) AS purchase 
                FROM erp_finance_voucher_items AS I INNER JOIN erp_finance_voucher_head AS H ON I.header_id=H.id WHERE ledger_id=10005 AND voucher_date <= "' . $to_date . '"  ' . $purchase_conditions)->queryScalar();
                        $Total_Income += ($purchase + $goods_receipt);


                        $current_stock = ($purchase + $goods_receipt - $balance - $goods_issue);
                        if ($current_stock > 0) {
                            $debit = abs($current_stock);
                            $credit = 0;
                        } else {
                            $credit = abs($current_stock);
                            $debit = 0;
                        }
                        $total_debit += abs($current_stock);
                        $total_credit += abs($current_stock); ?>
                        <tr>
                            <td><?php echo $space . $accountName; ?></td>
                            <td style="text-align:right !important;" class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($debit, " "); ?></td>
                            <td style="text-align:right !important;" class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($credit, " "); ?></td>
                        </tr>
                        <?php $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                        $accountName = "Goods Receipt";
                        if ($goods_receipt > 0) {
                            $debit = abs($goods_receipt);
                            $credit = 0;
                        } else {
                            $credit = abs($goods_receipt);
                            $debit = 0;
                        }
                        ?>

                        <tr>
                            <td><?php echo $space . $accountName; ?></td>
                            <td style="text-align:right !important;" class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($debit, " "); ?></td>
                            <td style="text-align:right !important;" class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($credit, " "); ?></td>
                        </tr>
                        <?php      } else {
                        if ($debit != 0 || $credit != 0) { ?>
                            <tr>
                                <td><?php echo $space . $accountName; ?></td>
                                <td style="text-align:right !important;" class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($debit, " "); ?></td>
                                <td style="text-align:right !important;" class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($credit, " "); ?></td>
                            </tr>
            <?php
                        }
                    }
                }
            }

            $pl_condition = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date <= "' . $to_date . '"';

            $pl_income_balance = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="I")')->queryScalar();
            $pl_expense_balance = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="E")')->queryScalar();
            $pl_pre_balance = (float)$pl_income_balance + (float)$pl_expense_balance;

            $pl_condition_old = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date < "' . $from_date . '"';
            $pl_income_balance_old = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition_old . ' AND (A.main_account_type="I")')->queryScalar();
            $pl_expense_balance_old = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition_old . ' AND (A.main_account_type="E")')->queryScalar();
            $goods_receipt_opening_old = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();
            $cost_of_sale_old = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();
            $goods_issue_damage_old = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();

            $profit_and_loss_old = $pl_income_balance_old - $goods_receipt_opening_old + $pl_expense_balance_old + $cost_of_sale_old + $goods_issue_damage_old;

            $accountName = 'Accumulated P&L';

            if ($pl_pre_balance > 0) {
                $total_debit += abs($pl_pre_balance);
            } else {
                $total_credit += abs($pl_pre_balance);
            }

            if ($profit_and_loss_old > 0) {
            }
            $pl_condition = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date >= "' . $from_date . '" AND H.voucher_date <= "' . $to_date . '"';

            $pl_income_balance1 = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="I")')->queryScalar();
            $pl_expense_balance1 = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="E")')->queryScalar();
            $pl_balance = $pl_expense_balance1 + $pl_income_balance1;

            $goods_receipt_opening = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
            $cost_of_sale = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
            $goods_issue_damage = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();

            $profit_and_loss = $pl_income_balance1 - $goods_receipt_opening - $pl_expense_balance1 + $cost_of_sale + $goods_issue_damage;
            $accountName = 'Current P&L';
            if ($profit_and_loss > 0) {
            }

            if ($pl_balance > 0) {
                $total_credit += abs($pl_balance);
            } else {
                $total_debit += abs($pl_balance);
            }
            ?>

            <tr>
                <td style="color:#1F67B2;text-align:right !important;" class="text-right"><b>Total </b></td>
                <td style="color:#1F67B2;text-align:right !important;" class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " "); ?></b></td>
                <td style="color:#1F67B2;text-align:right !important;" class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " "); ?></b></td>
            </tr>

        </tbody>
    </table>
    <br />
    
    
    
    <htmlpagefooter name="myfooter">
        <div style="text-align:center;width:100%;font-size:10px"><?php echo $userModel->companyDetails->pdf_footer; ?>
            <?php
            date_default_timezone_set("Asia/Dubai");
            echo date('d/m/Y') . " " . date("h:i:sa");
            ?>
        </div>


        <div style="border-top: 1px dotted #000000; font-size: 12px; text-align: center; padding-top: 10px; background-color: #d7faeb;">
            <div style="text-align:center;width:100%">
            </div>
            <div style="text-align:center;width:100%">Page {PAGENO} of {nb} </div>
        </div>
    </htmlpagefooter>

</body>

</html>