<!DOCTYPE html>
<html>

<head>
    <title><?php echo date('dmYhis'); ?></title>
</head>

<body>

    <?php
    if ((int)$user_id > 0) {
        $userModel = MasUsers::model()->findByPk((int) $user_id);
    } else {
        $userModel = MasUsers::model()->findByPk((int) Yii::app()->user->id);
    }
    ?>

    <div class="col-12">
        <div class="text-center">
            <img src="<?php echo 'images/' . $userModel->companyDetails->pdf_logo; ?>" class="logo">
        </div>
        <div class="text-center">
            <small><?php echo $userModel->companyDetails->billing_address ?></small>
        </div>
    </div>
    <div style="width:100%;float: left;margin-top: 10px;font-size:12px;font-family:'Times New Roman', Times, serif;">
        <!--add New Template-->
        <div class="">
            <div class="col-6">
                <div class="input-block">
                    <b><?php echo 'GL Summary'; ?></b>
                </div>
                <br><br>
                <table class="table" style="width:100%">
                    <tr>
                        <td>As on Date</td>
                        <td>
                            <?php echo date('d/m/Y', strtotime($to_date)); ?>
                        </td>
                    <tr>
                        <td>Ledger</td>
                        <td>
                            <?php echo FinanceLegder::model()->findBypk((int) $ledger)->description; ?>
                        </td>
                    </tr>
                    </tr>
                </table>
            </div>

        </div>
        <br>
        <div class="col-md-12">
            <table id="tbl_reorder_level_table" class="table table-fixed table-bordered table-primary dataTable">
                <thead>
                    <tr>
                        <th>#</th>
                        <th>Subledger</th>
                        <th>Phone No</th>
                        <th class="text-right">Debit</th>
                        <th class="text-right">Credit</th>
                        <th class="text-right">Balance</th>
                    </tr>

                </thead>
                <tbody>

                    <?php

                    if ($salesman > 0) {
                        $summaryItems = Yii::app()->db->createCommand('SELECT S.* FROM {{finance_gl_summary}} AS S INNER JOIN {{customer}} AS C ON S.customer_id=C.id where accessed_by = "' . $salesman . '" OR accessed_by like "%,' . $salesman . ',%" OR accessed_by like "' . $salesman . ',%" OR accessed_by like "%,' . $salesman . '" ORDER BY S.subledger_name')->queryAll();
                    } else {
                        $summaryItems = Yii::app()->db->createCommand('SELECT * FROM {{finance_gl_summary}} ORDER BY subledger_name')->queryAll();
                    }
                    $totalDebit = $totalCredit = 0;

                    foreach ($summaryItems as $each) {

                        // $debit = ( $each['balance'] > 0 ) ? $each['balance'] : '';
                        // $credit = ( $each['balance'] < 0 ) ? abs($each['balance']) : '';

                        $debit = $each['debit'];
                        $credit = $each['credit'];
                        $phone_no = '-';
                        if ($each['subledger_id'] > 0) {
                            $FinanceSubledger = FinanceSubledger::model()->findByPk($each['subledger_id']);
                            $phone_no = $FinanceSubledger->phone;
                        }
                    ?>
                        <tr>
                            <td><?php echo $each['subledger_no']; ?></td>
                            <td><?php echo $each['subledger_name']; ?></td>>
                            <td><?php echo $phone_no; ?></td>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($debit, " "); ?></td>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($credit, " "); ?></td>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($credit - $debit, " "); ?></td>
                        </tr>
                    <?php
                        $totalDebit +=     $debit;
                        $totalCredit += $credit;
                    }  ?>
                    <tr>
                        <td colspan="3" class="text-right"><b>Total</b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($totalDebit, " "); ?></b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($totalCredit, " "); ?></b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($totalCredit - $totalDebit, " "); ?></b></td>
                    </tr>
                    <?php
                    $balance = $totalDebit - $totalCredit;
                    $debitBalance = ($balance > 0) ? $balance : 0;
                    $creditBalance = ($balance <= 0) ? abs($balance) : 0;
                    ?>
                    <tr>
                        <td colspan="3" class="text-right"><b>Balance</b></td>
                        <?php
                        if ($debitBalance < $creditBalance) {
                        ?>
                            <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency(0, " ") ?></b></td>
                            <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($creditBalance - $debitBalance, " ") ?></b></td>
                            <td class="text-right"></td>
                        <?php
                        } else {
                        ?>
                            <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($debitBalance - $creditBalance, " ") ?></b></td>
                            <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency(0, " ") ?></b></td>
                            <td class="text-right"></td>
                        <?php
                        }
                        ?>
                    </tr>
                </tbody>
            </table>
        </div>

        <htmlpagefooter name="myfooter">
            <div style="text-align:center;width:100%;font-size:10px"><?php echo $userModel->companyDetails->pdf_footer; ?>
                <?php
                date_default_timezone_set("Asia/Dubai");
                echo date('d/m/Y') . " " . date("h:i:sa"); ?>
            </div>


            <div style="border-top: 1px dotted #000000; font-size: 12px; text-align: center; padding-top: 10px; background-color: #d7faeb;">
                <div style="text-align:center;width:100%">
                </div>
                <div style="text-align:center;width:100%">Page {PAGENO} of {nb} </div>
            </div>
        </htmlpagefooter>
</body>

</html>