<?php
$form = $this->beginWidget('CActiveForm', array(
    'id' => 'outlet-form',
    'enableAjaxValidation' => false,
    'enableClientValidation' => false,
    ));
?>
<div class="tab-pane active">
    <ul class="clearfix form-ul material">
        <li class="col-sm-4">
            <?php echo $form->hiddenField($model, 'id'); ?>
            <?php 
            if($model->id>0){
                echo $form->hiddenField($model, 'company_id');
                echo $form->textField($model, 'company_name',array('data-label' => 'Company <span style="color:red;">*</span>','value'=>$model->companyDetails->name,"readonly"=>'true'));
            }else{
                echo $form->dropdownList($model,'company_id',MasCompany::get_companies(),array('data-label' => 'Company <span style="color:red;">*</span>'));
            }
             ?>
        </li>
        <li class="col-sm-4">
            <?php echo $form->textField($model, 'outlet_name', array('data-label' => 'Outlet <span style="color:red;">*</span>')); ?>
            
        </li>
        <li class="col-sm-4">
            <?php echo $form->textField($model, 'name', array('data-label' => 'Code <span style="color:red;">*</span>')); ?>
        </li>
        <li class="col-sm-4">
            <?php echo $form->textField($model, 'trn_no', array('data-label' => 'TRN NO <span style="color:red;">*</span>')); ?>
        </li>
        <li class="col-sm-4">
            <?php echo $form->textField($model, 'phone_no', array('data-label' => 'Phone No <span style="color:red;">*</span>')); ?>
        </li>
        
        <li class="col-sm-4">
            <?php echo $form->dropdownList($model, 'is_active', array('Y'=>'Yes','N'=>'No'),array('data-label' => 'Active <span style="color:red;">*</span>')); ?>
        </li>
        <li class="col-sm-4">
            <?php 
            if(!empty($model->entry_from)&&$model->entry_from!='0000-00-00'){
                $model->entry_from=date('d/m/Y',strtotime($model->entry_from));
            }else{
                $model->entry_from=date('d/m/Y');
            }
            echo $form->textField($model, 'entry_from', array('class'=>'datepicker','data-label' => 'Start Date <span style="color:red;">*</span>')); ?>
        </li>
        <li class="col-sm-4">
            <?php 
            if(!empty($model->subscription_end_date)&&$model->subscription_end_date!='0000-00-00'){
                $model->subscription_end_date=date('d/m/Y',strtotime($model->subscription_end_date));
            }else{
                $model->subscription_end_date=date('d/m/Y',strtotime('+ 1 year'));
            }
            echo $form->textField($model, 'subscription_end_date', array('class'=>'datepicker','data-label' => 'Subscription End Date <span style="color:red;">*</span>')); ?>
        </li>
        <li class="col-sm-4">
            <?php echo $form->textField($model, 'notify_days', array('data-label' => 'Notify Days <span style="color:red;">*</span>')); ?>
        </li>
        <li class="col-sm-4">
            <?php echo $form->textField($model, 'po_box', array('data-label' => 'PO BOX <span style="color:red;">*</span>')); ?>
        </li>
        <li class="col-sm-4">
            <?php echo $form->textArea($model, 'address', array('data-label' => 'Billing Address <span style="color:red;">*</span>')); ?>
        </li>
        <li class="col-sm-4">
            <?php echo $form->textArea($model, 'pdf_footer',array('data-label'=> 'Footer')); ?>
        </li> 
        <li class="col-sm-2">
                PDF Logo
                <?php
                    $allowedExtensions = array("png");
                    $this->widget('ext.EAjaxUpload.EAjaxUpload', array(
                        'id' => rand(),
                        'config' => array(
                            'action' => Yii::app()->createUrl(Yii::app()->controller->id . '/Upload', array('folder' => 'images')),
                            'multiple' => false,
                            'allowedExtensions' => $allowedExtensions,
                            'sizeLimit' => 1 * 1024 * 1024,
                            'onStart' => "js:function(){}",
                            'onComplete' => "js:function(id, fileName, responseJSON){
                                $('#MasOutlets_pdf_logo').val(responseJSON.filename);
                            }",
                        )
                    ));
                ?>
             <?php echo $form->hiddenField($model, 'pdf_logo'); ?>
            </li>
            <li class="col-sm-2">
                Logo
                <?php
                    $allowedExtensions = array("png");
                    $this->widget('ext.EAjaxUpload.EAjaxUpload', array(
                        'id' => rand(),
                        'config' => array(
                            'action' => Yii::app()->createUrl(Yii::app()->controller->id . '/Upload', array('folder' => 'images')),
                            'multiple' => false,
                            'allowedExtensions' => $allowedExtensions,
                            'sizeLimit' => 1 * 1024 * 1024,
                            'onStart' => "js:function(){}",
                            'onComplete' => "js:function(id, fileName, responseJSON){
                                $('#MasOutlets_logo').val(responseJSON.filename);
                            }",
                        )
                    ));
                ?>
             <?php echo $form->hiddenField($model, 'logo'); ?>
            </li>
    </ul>
    </div>
</div>

<div class="modal-footer">
    <button type="button" class="btn btn-default" id="outlet_close" data-dismiss="modal">Close</button>
    <?php 
    $url = Yii::app()->createUrl('admin/SaveOutlet');
    echo CHtml::ajaxSubmitButton('Save', $url, array(
                'dataType' => 'json',
                'type' => 'post',
                'success' => 'function(data) {
                    $("#loader").hide();
                    if(data.status=="success"){  
                        $("#outlet_close").click();                                        
                        t8.success("outlet Details Saved Successfully!");
                        reloadTable("#tbl_outlet");
                    } else { 
                        $("#outlet-form .outlet-save-btn").prop("disabled", false);
                        $("#outlet-form .outlet-save-btn").addClass("btn-theme").removeClass("btn_loading");
                        $.each(data, function(key, val) {
                            $("#outlet-form #"+key+"_em_").text(val).show(); 
                            t8.error(""+val+""); 
                        }); 
                    } 
                }',
                'beforeSend' => 'function(){
                    $(".toast8-error").hide(); 
                    $("#loader").show();
                    $("#outlet-form .outlet-save-btn").prop("disabled", true);                                
                    $("#outlet-form .outlet-save-btn").addClass("btn_loading").removeClass("btn-theme");
                    
                }',
                'complete' => 'function(){
                    $("#loader").hide();
                    $("#outlet-form .outlet-save-btn").prop("disabled", false);                                
                    $("#outlet-form .outlet-save-btn").addClass("btn-theme").removeClass("btn_loading");
                }'
                    
        ), array('id' => 'mybtn' . rand(), 'class' => 'outlet-save-btn btn btn-theme'));
           
    ?>
</div>
<?php $this->endWidget(); ?>
