<?php

$cs = Yii::app()->getClientScript();
$cs->registerScript("get_outlets", "function get_outlets( company_id ){
        jQuery.ajax({
            'type': 'post',
            'url': '" . Yii::app()->createUrl('config/get_company_outlets') . "',
            'data' : { 'company_id' : company_id },
                'success': function(data) {
                    $('#outlets_li').html(data);
                }
            });
        }", CClientScript::POS_HEAD);
$cs->registerScript("get_users", "function get_users( outlet_id ){
            jQuery.ajax({
                'type': 'post',
                'dataType' : 'json',
                'url': '" . Yii::app()->createUrl('config/get_outlet_users') . "',
                'data' : { 'outlet_id' : outlet_id },
                    'success': function(data) {
                        $('#users_li').html(data.user_drop);
                        if( data.count > 0 )
                            $('#vendor_ul').show();
                    }
                });
            }", CClientScript::POS_HEAD);
$cs->registerScript("get_field_names_vendor", "function get_field_names_vendor(){
        jQuery.ajax({
            'type': 'post',
            'dataType' : 'json',
            'url': '" . Yii::app()->createUrl('config/vendor_fields') . "',
            'data' : { 'table_name' : $('#vendor_table').val() },
                'success': function(data) {
                    $('#vendor_primary').html(data.key_field);
                    $('#vendor_name').html(data.name_field);
                    $('#vendor_trn').html(data.trn_field);
                    $('#vendor_phone').html(data.phone_field);
                    $('#vendor_address').html(data.address_field);
                    $('#vendor_import_btn').show();
                }
            });
        }", CClientScript::POS_HEAD);
$cs->registerScript("get_field_names_customer", "function get_field_names_customer(){
            jQuery.ajax({
                'type': 'post',
                'dataType' : 'json',
                'url': '" . Yii::app()->createUrl('config/customer_fields') . "',
                'data' : { 'table_name' : $('#customer_table').val() },
                    'success': function(data) {
                        $('#customer_primary').html(data.key_field);
                        $('#customer_name').html(data.name_field);
                        $('#customer_trn').html(data.trn_field);
                        $('#customer_phone').html(data.phone_field);
                        $('#customer_address').html(data.address_field);
                        $('#customer_import_btn').show();
                    }
                });
            }", CClientScript::POS_HEAD);

$cs->registerScript("get_field_names_generic", "function get_field_names_generic(){
                jQuery.ajax({
                    'type': 'post',
                    'dataType' : 'json',
                    'url': '" . Yii::app()->createUrl('config/generic_fields') . "',
                    'data' : { 'table_name' : $('#generic_table').val() },
                        'success': function(data) {
                            $('#generic_primary').html(data.key_field);
                            $('#generic_name').html(data.name_field);
                            $('#generic_import_btn').show();
                        }
                    });
                }", CClientScript::POS_HEAD);
$cs->registerScript("get_field_names_product", "function get_field_names_product(){
                    jQuery.ajax({
                        'type': 'post',
                        'dataType' : 'json',
                        'url': '" . Yii::app()->createUrl('config/product_fields') . "',
                        'data' : { 'table_name' : $('#product_table').val() },
                            'success': function(data) {
                                $('#product_primary').html(data.key_field);
                                $('#product_name').html(data.name_field);
                                $('#product_description').html(data.description_field);
                                $('#product_generic').html(data.generic_field);
                                $('#product_import_btn').show();
                            }
                        });
                    }", CClientScript::POS_HEAD);
$cs->registerScript("get_field_purchase", "function get_field_purchase(type){
                        jQuery.ajax({
                            'type': 'post',
                            'dataType' : 'json',
                            'url': '" . Yii::app()->createUrl('config/purchase_fields') . "',
                            'data' : { 'table_name' : type == 1 ? $('#pur_header_table').val() : $('#pur_item_table').val(), 'type' : type },
                                'success': function(data) {
                                    if( type == 1 ){
                                        $('#purchase_primary').html(data.key_field);
                                        $('#purchase_date').html(data.date_field);
                                        $('#purchase_vendor').html(data.vendor_field);
                                        $('#purchase_invoice_no').html(data.invoice_no_field);
                                        $('#purchase_old_no').html(data.old_invoice_field);
                                        $('#purchase_taxable').html(data.taxable_field);
                                    }else{
                                        $('#purchase_foreign').html(data.key_field);
                                        $('#purchase_product').html(data.product_field);
                                        $('#purchase_quantity').html(data.quantity_field);
                                        $('#purchase_rate').html(data.rate_field);
                                        $('#purchase_discount').html(data.discount_field);
                                        $('#purchase_import_btn').show();
                                    }
                                }
                            });
                        }", CClientScript::POS_HEAD);
$cs->registerScript("get_field_purchase_rtns", "function get_field_purchase_rtns(type){
                            jQuery.ajax({
                                'type': 'post',
                                'dataType' : 'json',
                                'url': '" . Yii::app()->createUrl('config/purchase_rtns_fields') . "',
                                'data' : { 'table_name' : type == 1 ? $('#pur_rtn_header_table').val() : $('#pur_rtn_item_table').val(), 'type' : type },
                                    'success': function(data) {
                                        if( type == 1 ){
                                            $('#purchase_rtn_primary').html(data.key_field);
                                            $('#purchase_rtn_date').html(data.date_field);
                                            $('#purchase_rtn_no').html(data.return_no_field);
                                            $('#purchase_rtn_invoice').html(data.invoice_field);
                                        }else{
                                            $('#purchase_rtn_foreign').html(data.key_field);
                                            $('#purchase_rtn_parent').html(data.inv_key_field);
                                            $('#purchase_rtn_quantity').html(data.quantity_field);
                                            $('#purchase_rtn_import_btn').show();
                                        }
                                    }
                                });
                            }", CClientScript::POS_HEAD);

$cs->registerScript("import_vendors", "function import_vendors(){
            if( confirm('Are you sure?') ){
                $('#loader').show();
                jQuery.ajax({
                    'type': 'post',
                    'dataType' : 'json',
                    'url': '" . Yii::app()->createUrl('config/import_data') . "',
                    'data' : { 'type' : 'vendor', 'company_id' : $('#company_id').val(), 'user_id' : $('#user_id').val(), 'outlet_id' : $('#outlet_id').val(),  'primary_key' : $('#vendor_primary_in').val(), 'table_name' : $('#vendor_table').val(), 'name_field' : $('#vendor_name_in').val(), 'vendor_trn' : $('#vendor_trn_in').val(), 'vendor_phone' : $('#vendor_phone_in').val(), 'vendor_address' : $('#vendor_adds_in').val() },
                        'success': function(data) {
                            $('#company_ul').hide();
                            if( data.have_more ){
                                $('#loader').hide();
                            }else{
                                t8.success('Vendors are Imported!');
                                $('#loader').hide();
                                $('#vendor_ul').hide();
                                $('#customer_ul').show();
                            }
                            $('#vendor_msg').text(data.records_imported);
                        }
                    });
            }
        }", CClientScript::POS_HEAD);

$cs->registerScript("import_customers", "function import_customers(){
            if( confirm('Are you sure?') ){
                $('#loader').show();
                jQuery.ajax({
                    'type': 'post',
                    'dataType' : 'json',
                    'url': '" . Yii::app()->createUrl('config/import_data') . "',
                    'data' : { 'type' : 'customer', 'company_id' : $('#company_id').val(), 'user_id' : $('#user_id').val(), 'outlet_id' : $('#outlet_id').val(),  'primary_key' : $('#customer_primary_in').val(), 'table_name' : $('#customer_table').val(), 'name_field' : $('#customer_name_in').val(), 'customer_trn' : $('#customer_trn_in').val(), 'customer_phone' : $('#customer_phone_in').val(), 'customer_address' : $('#customer_adds_in').val() },
                        'success': function(data) {
                            $('#company_ul').hide();
                            if( data.have_more ){
                                $('#loader').hide();
                            }else{
                                t8.success('Customers are Imported!');
                                $('#loader').hide();
                                $('#customer_ul').hide();
                                $('#generic_ul').show();
                            }
                            $('#customer_msg').text(data.records_imported);
                        }
                    });
            }
        }", CClientScript::POS_HEAD);
$cs->registerScript("import_generic", "function import_generic(){
            if( confirm('Are you sure?') ){
                $('#loader').show();
                jQuery.ajax({
                    'type': 'post',
                    'dataType' : 'json',
                    'url': '" . Yii::app()->createUrl('config/import_data') . "',
                    'data' : { 'type' : 'generic', 'company_id' : $('#company_id').val(), 'user_id' : $('#user_id').val(), 'outlet_id' : $('#outlet_id').val(),
                                'primary_key' : $('#generic_primary_in').val(), 'table_name' : $('#generic_table').val(),
                                'name_field' : $('#generic_name_in').val()
                            },
                        'success': function(data) {
                            $('#company_ul').hide();
                            if( data.have_more ){
                                $('#loader').hide();
                            }else{
                                t8.success('Product Groups are Imported!');
                                $('#loader').hide();
                                $('#generic_ul').hide();
                                $('#product_ul').show();
                            }
                            $('#generic_msg').text(data.records_imported);
                        }
                    });
            }
        }", CClientScript::POS_HEAD);
$cs->registerScript("import_product", "function import_product(){
            if( confirm('Are you sure?') ){
                $('#loader').show();
                jQuery.ajax({
                    'type': 'post',
                    'dataType' : 'json',
                    'url': '" . Yii::app()->createUrl('config/import_data') . "',
                    'data' : { 'type' : 'product', 'company_id' : $('#company_id').val(), 'user_id' : $('#user_id').val(), 'outlet_id' : $('#outlet_id').val(),
                                'primary_key' : $('#product_primary_in').val(), 'table_name' : $('#product_table').val(),
                                'name_field' : $('#product_name_in').val(), 'description_field' : $('#product_description_in').val(),
                                'generic_field' : $('#product_generic_in').val(), 'generic_table' : $('#generic_table').val(), 'generic_key' : $('#generic_primary_in').val()
                            },
                        'success': function(data) {
                            $('#company_ul').hide();
                            if( data.have_more ){
                                $('#loader').hide();
                            }else{
                                t8.success('Products are Imported!');
                                $('#loader').hide();
                                $('#product_ul').hide();
                                $('#purchase_ul').show();
                            }
                            $('#product_msg').text(data.records_imported);
                        }
                    });
            }
        }", CClientScript::POS_HEAD);
$cs->registerScript("import_purchase", "function import_purchase(){
            if( confirm('Are you sure?') ){
                $('#loader').show();
                jQuery.ajax({
                    'type': 'post',
                    'dataType' : 'json',
                    'url': '" . Yii::app()->createUrl('config/import_vouchers') . "',
                    'data' : { 'type' : 'purchase', 'company_id' : $('#company_id').val(), 'user_id' : $('#user_id').val(), 'outlet_id' : $('#outlet_id').val(),
                                'head_primary_key' : $('#purchase_primary_in').val(), 'head_table_name' : $('#pur_header_table').val(),
                                'date_field' : $('#purchase_date_in').val(), 'vendor_field' : $('#purchase_vendor_in').val(),
                                'invoice_no_field' : $('#purchase_invno_in').val(), 'old_invoice_field' : $('#purchase_oldinvno_in').val(),
                                'taxable_field' : $('#purchase_taxable_in').val(),
                                'vendor_table' : $('#vendor_table').val(), 'vendor_primary' : $('#vendor_primary_in').val(),
                                'products_table' : $('#product_table').val(), 'product_primary' : $('#product_primary_in').val(),
                                'item_foreign_key' : $('#pur_product_primary_in').val(), 'item_table_name' : $('#pur_item_table').val(), 'product_field' : $('#pur_product_id_in').val(),
                                'quantity_field' : $('#pur_qty_in').val(), 'rate_field' : $('#pur_rate_in').val(), 'discount_field' : $('#pur_disc_in').val()
                            },
                        'success': function(data) {
                            $('#company_ul').hide();
                            if( data.have_more ){
                                $('#loader').hide();
                            }else{
                                t8.success('Products are Imported!');
                                $('#loader').hide();
                                $('#purchase_ul').hide();
                                $('#purchase_rtn_ul').show();
                            }
                            $('#purchase_msg').text(data.records_imported);
                        }
                    });
            }
        }", CClientScript::POS_HEAD);
$cs->registerScript("import_purchase_rtns", "function import_purchase_rtns(){
            if( confirm('Are you sure?') ){
                $('#loader').show();
                jQuery.ajax({
                    'type': 'post',
                    'dataType' : 'json',
                    'url': '" . Yii::app()->createUrl('config/import_vouchers') . "',
                    'data' : { 'type' : 'purchase_return', 'company_id' : $('#company_id').val(), 'user_id' : $('#user_id').val(), 'outlet_id' : $('#outlet_id').val() },
                        'success': function(data) {
                            $('#company_ul').hide();
                            if( data.have_more ){
                                $('#loader').hide();
                            }else{
                                t8.success('Products are Imported!');
                                $('#loader').hide();
                                $('#purchase_rtn_ul').hide();
                                $('#goods_rcpt_ul').show();
                            }
                            $('#purchase_rtn_msg').text(data.records_imported);
                        }
                    });
            }
        }", CClientScript::POS_HEAD);
        $cs->registerScript("import_purchase_grcpt", "function import_purchase_grcpt(){
            if( confirm('Are you sure?') ){
                $('#loader').show();
                jQuery.ajax({
                    'type': 'post',
                    'dataType' : 'json',
                    'url': '" . Yii::app()->createUrl('config/import_vouchers') . "',
                    'data' : { 'type' : 'goods_receipt', 'company_id' : $('#company_id').val(), 'user_id' : $('#user_id').val(), 'outlet_id' : $('#outlet_id').val() },
                        'success': function(data) {
                            $('#company_ul').hide();
                            if( data.have_more ){
                                $('#loader').hide();
                            }else{
                                t8.success('Products are Imported!');
                                $('#loader').hide();
                                $('#goods_rcpt_ul').hide();
                                $('#sales_ul').show();
                            }
                            $('#goods_rcpt_msg').text(data.records_imported);
                        }
                    });
            }
        }", CClientScript::POS_HEAD);
        $cs->registerScript("import_sales", "function import_sales(){
            if( confirm('Are you sure?') ){
                $('#loader').show();
                jQuery.ajax({
                    'type': 'post',
                    'dataType' : 'json',
                    'url': '" . Yii::app()->createUrl('config/import_vouchers') . "',
                    'data' : { 'type' : 'sales', 'company_id' : $('#company_id').val(), 'user_id' : $('#user_id').val(), 'outlet_id' : $('#outlet_id').val() },
                        'success': function(data) {
                            $('#company_ul').hide();
                            if( data.have_more ){
                                $('#loader').hide();
                            }else{
                                t8.success('Products are Imported!');
                                $('#loader').hide();
                                $('#sales_ul').hide();
                                $('#sales_rtn_ul').show();
                            }
                            $('#sales_msg').text(data.records_imported);
                        }
                    });
            }
        }", CClientScript::POS_HEAD);

$mySql_tables = Yii::app()->db_migrate->createCommand('show tables')->queryAll();
$tables = array();
foreach ($mySql_tables as $each) {
    $tables[$each['Tables_in_skyblueu_esell_migrate']] = $each['Tables_in_skyblueu_esell_migrate'];
}
?>

<div class="tab-content">
    <div class="tab-pane active">

        <ul class="clearfix form-ul material" id="company_ul">
            <li class="col-sm-4">
                <?php echo CHtml::dropdownlist('company_id', '', VanCompany::get_companies(), array('data-label' => 'Company', 'onChange' => 'js:get_outlets(this.value)', 'prompt' => 'Select')); ?>
            </li>
            <li class="col-sm-4" id="outlets_li">
            </li>
            <li class="col-sm-4" id="users_li">
            </li>
        </ul>

        <ul class="clearfix form-ul material" id="vendor_ul" style="display:none;">
            <strong><u>Migrate Vendors</u> : <span id="vendor_msg">0 out of 0 migrated</span></strong><br>
            <li class="col-sm-4">
                <?php echo CHtml::dropdownlist('vendor_table', '', $tables, array('data-label' => 'Vendor Table', 'prompt' => 'Select', 'onChange' => 'js:get_field_names_vendor();')); ?>
            </li>
            <li class="col-sm-4" id="vendor_primary">
            </li>
            <li class="col-sm-4" id="vendor_name">
            </li>
            <li class="col-sm-4" id="vendor_trn">
            </li>
            <li class="col-sm-4" id="vendor_phone">
            </li>
            <li class="col-sm-4" id="vendor_address">
            </li>
            <li class="col-sm-4" id="vendor_import_btn" style="display:none;">
                <button type="button" class="btn btn-sm btn-theme" onclick="import_vendors();">Import</button>
            </li>
        </ul>

        <ul class="clearfix form-ul material" id="customer_ul" style="display:none;">
            <strong><u>Migrate Customers</u> : <span id="customer_msg">0 out of 0 migrated</span></strong><br>
            <li class="col-sm-4">
                <?php echo CHtml::dropdownlist('customer_table', '', $tables, array('data-label' => 'Customer Table', 'prompt' => 'Select', 'onChange' => 'js:get_field_names_customer();')); ?>
            </li>
            <li class="col-sm-4" id="customer_primary">
            </li>
            <li class="col-sm-4" id="customer_name">
            </li>
            <li class="col-sm-4" id="customer_trn">
            </li>
            <li class="col-sm-4" id="customer_phone">
            </li>
            <li class="col-sm-4" id="customer_address">
            </li>
            <li class="col-sm-4" id="customer_import_btn" style="display:none;">
                <button type="button" class="btn btn-sm btn-theme" onclick="import_customers();">Import</button>
            </li>
        </ul>

        <ul class="clearfix form-ul material" id="generic_ul" style="display:none;">
            <strong><u>Migrate Product Groups</u> : <span id="generic_msg">0 out of 0 migrated</span></strong><br>
            <li class="col-sm-4">
                <?php echo CHtml::dropdownlist('generic_table', '', $tables, array('data-label' => 'Product Group Table', 'prompt' => 'Select', 'onChange' => 'js:get_field_names_generic();')); ?>
            </li>
            <li class="col-sm-4" id="generic_primary">
            </li>
            <li class="col-sm-4" id="generic_name">
            </li>
            <li class="col-sm-4" id="generic_import_btn" style="display:none;">
                <button type="button" class="btn btn-sm btn-theme" onclick="import_generic();">Import</button>
            </li>
        </ul>

        <ul class="clearfix form-ul material" id="product_ul" style="display:none;">
            <strong><u>Migrate Products</u> : <span id="product_msg">0 out of 0 migrated</span></strong><br>
            <strong>All Products are taxable by default</strong><br>
            <li class="col-sm-4">
                <?php echo CHtml::dropdownlist('product_table', '', $tables, array('data-label' => 'Product Table', 'prompt' => 'Select', 'onChange' => 'js:get_field_names_product();')); ?>
            </li>
            <li class="col-sm-4" id="product_primary">
            </li>
            <li class="col-sm-4" id="product_name">
            </li>
            <li class="col-sm-4" id="product_description">
            </li>
            <li class="col-sm-4" id="product_generic">
            </li>
            <li class="col-sm-4" id="product_import_btn" style="display:none;">
                <button type="button" class="btn btn-sm btn-theme" onclick="import_product();">Import</button>
            </li>
        </ul>

        <ul class="clearfix form-ul material" id="purchase_ul" style="display:none;">
            <strong><u>Migrate Purchases</u> : <span id="purchase_msg">0 out of 0 migrated</span></strong><br>
            <li class="col-sm-4">
                <?php echo CHtml::dropdownlist('pur_header_table', '', $tables, array('data-label' => 'Header Table', 'prompt' => 'Select', 'onChange' => 'js:get_field_purchase(1);')); ?>
            </li>
            <li class="col-sm-4" id="purchase_primary">
            </li>
            <li class="col-sm-4" id="purchase_date">
            </li>
            <li class="col-sm-4" id="purchase_vendor">
            </li>
            <li class="col-sm-4" id="purchase_invoice_no">
            </li>
            <li class="col-sm-4" id="purchase_old_no">
            </li>
            <li class="col-sm-4" id="purchase_taxable">
            </li>
            <li class="col-sm-4">
                <?php echo CHtml::dropdownlist('pur_item_table', '', $tables, array('data-label' => 'Item Table', 'prompt' => 'Select', 'onChange' => 'js:get_field_purchase(2);')); ?>
            </li>
            <li class="col-sm-4" id="purchase_foreign">
            </li>
            <li class="col-sm-4" id="purchase_product">
            </li>
            <li class="col-sm-4" id="purchase_quantity">
            </li>
            <li class="col-sm-4" id="purchase_rate">
            </li>
            <li class="col-sm-4" id="purchase_discount">
            </li>
            <li class="col-sm-4" id="purchase_import_btn" style="display:none;">
                <button type="button" class="btn btn-sm btn-theme" onclick="import_purchase();">Import</button>
            </li>
        </ul>

        <ul class="clearfix form-ul material" id="purchase_rtn_ul" style="display:none;">
            <strong><u>Migrate Purchase Returns</u> : <span id="purchase_rtn_msg">0 out of 0 migrated</span></strong><br>

            <li class="col-sm-4" id="purchase_rtn_import_btn">
                <button type="button" class="btn btn-sm btn-theme" onclick="import_purchase_rtns();">Import</button>
            </li>
        </ul>

        <ul class="clearfix form-ul material" id="goods_rcpt_ul" style="display:none;">
            <strong><u>Migrate Goods RCPT </u> : <span id="goods_rcpt_msg">0 out of 0 migrated</span></strong><br>
            <li class="col-sm-4">
                <button type="button" class="btn btn-sm btn-theme" onclick="import_purchase_grcpt();">Import</button>
            </li>
        </ul>

        
        <ul class="clearfix form-ul material" id="sales_ul" style="display:none;">
            <strong><u>Migrate Sales </u> : <span id="sales_msg">0 out of 0 migrated</span></strong><br>
            <li class="col-sm-4">
                <button type="button" class="btn btn-sm btn-theme" onclick="import_sales();">Import</button>
            </li>
        </ul>

    </div>
</div>

<div class="modal-footer">
    <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
</div>










