<?php
$form = $this->beginWidget('CActiveForm', array(
    'id' => 'materialconversion-form',
    'enableAjaxValidation' => false,
    'enableClientValidation' => false,
    ));
?>
<div class="tab-content">
    <div class="tab-pane active">
        <ul class="clearfix form-ul material">
            <li class="col-sm-2">
                <?php echo $form->hiddenField($model, 'id'); ?> 
                <?php echo $form->hiddenField($model, 'conversion_no'); ?> 
                <?php 
                if(empty($model->conversion_date)){
                    $model->conversion_date=date('d/m/Y');
                }else{
                    $model->conversion_date=date('d/m/Y',strtotime($model->conversion_date));
                }
                echo $form->textField($model, 'conversion_date', array('data-label' => 'Conversion Date', 'class' => 'datepicker')); ?>
            </li>
            <li class="col-sm-10">
                <?php echo $form->textArea($model, 'narration', array('data-label' => 'Narration')); ?>
            </li>
        </ul>
        <table class="table table-bordered">
            <thead  class="thead-dark">
                <tr>
                    <th colspan="4" class="text-center">From</th>
                    <th colspan="4" class="text-center">To</th>
                </tr>
                <tr>
                    <th>Item</th>
                    <th>Description</th>
                    <th>Qty</th>
                    <th>Unit</th>
                    <th>Item</th>
                    <th>Description</th>
                    <th>Qty</th>
                    <th>Unit</th>

                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        <?php echo $form->hiddenField($model, 'from_product_id'); ?> 
                        <?php echo $form->textField($model, 'from_product', array('data-label' => 'Product','class'=>'tooltipster go','onKeypress' => 'js:autoCompleteConvProduct(this.id,"frm");','value'=>$model->conv_frm_pdt->part_number)); ?>
                    </td>
                    <td>
                        <?php echo $form->textArea($model, 'from_product_desc', array('data-label' => 'Description','class'=>'desc go en-text-area','readonly'=>'true','value'=>$model->conv_frm_pdt->description)); ?>
                    </td>
                    <td>
                        <?php echo $form->textField($model, 'from_quantity', array('data-label' => 'Qty','class'=>'go')); ?>
                    </td>
                    <td>
                        <?php echo $form->hiddenField($model, 'from_unit'); ?> 
                        <?php echo $form->textField($model, 'from_unit_name', array('data-label' => 'Unit','class'=>'go','readonly'=>'true','value'=>$model->conv_frm_unit->label)); ?>
                    </td>
                    <td>
                        <?php echo $form->hiddenField($model, 'to_product_id'); ?> 
                        <?php echo $form->textField($model, 'to_product', array('data-label' => 'Product','class'=>'tooltipster go','onKeypress' => 'js:autoCompleteConvProduct(this.id,"to");','value'=>$model->conv_to_pdt->part_number)); ?>
                    </td>
                    <td>
                        <?php echo $form->textArea($model, 'to_product_desc', array('data-label' => 'Description','class'=>'desc go en-text-area','readonly'=>'true','value'=>$model->conv_to_pdt->description)); ?>
                    </td>
                    <td>
                        <?php echo $form->textField($model, 'to_quantity', array('data-label' => 'Qty','class'=>'go')); ?>
                    </td>
                    <td>
                        <?php echo $form->hiddenField($model, 'to_unit'); ?> 
                        <?php echo $form->textField($model, 'to_unit_name', array('data-label' => 'Unit','class'=>'go','readonly'=>'true','value'=>$model->conv_to_unit->label)); ?>
                    </td>
                    
                </tr>
            </tbody>
        </table>
    </div>
</div>
<div class="modal-footer">
    <button type="button" class="btn btn-default" id="conv_close" data-dismiss="modal">Close</button>
    <?php 
                $url = Yii::app()->createUrl('materialconversion/Save');
                echo CHtml::ajaxSubmitButton('Save', $url, array(
                            'dataType' => 'json',
                            'type' => 'post',
                            'success' => 'function(data) {
                                if(data.status=="success"){  
                                    $("#conv_close").click();                                        
                                    t8.success("Conversion Details Saved Successfully!");
                                    reloadTable("#tbl_material_conversion");
                                } else { 
                                    $("#materialconversion-form .materialconversion-save-btn").prop("disabled", false);
                                    $("#materialconversion-form .materialconversion-save-btn").addClass("btn-theme").removeClass("btn_loading");
                                    $.each(data, function(key, val) {
                                        $("#materialconversion-form #"+key+"_em_").text(val).show(); 
                                        t8.error(""+val+""); 
                                    }); 
                                } 
                            }',
                            'beforeSend' => 'function(){
                                $(".toast8-error").hide(); 
                                $("#loader").show();
                                $("#materialconversion-form .materialconversion-save-btn").prop("disabled", true);                                
                                $("#materialconversion-form .materialconversion-save-btn").addClass("btn_loading").removeClass("btn-theme");
                            }',
                            'complete' => 'function(){
                                $("#loader").hide();
                                $("#materialconversion-form .materialconversion-save-btn").prop("disabled", false);                                
                                $("#materialconversion-form .materialconversion-save-btn").addClass("btn-theme").removeClass("btn_loading");
                            }'
                                
                    ), array('id' => 'mybtn' . rand(), 'class' => 'materialconversion-save-btn btn btn-theme'));
           
    ?>
</div>
<?php $this->endWidget(); ?>
<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("autoCompleteConvProduct", "function autoCompleteConvProduct(field_id,frm)
{
    var url = '" . Yii::app()->createUrl('inventory/GetProducts') . "'+'&frm='+frm;
    $('#'+field_id).autocomplete({
        minLength   : 1,
        source      : function (request, response) { autoCompleteSource(request, response,url) },
        focus       : function( event, ui ) { $(this).val((ui.item.label)); return false;},
        select          : function( event, ui ) {
            event.preventDefault();
            trigger_target_id   =   $(event.target).attr('id');
            var tax_val = 0;
            var product_id=ui.item.value;
            var desc=ui.item.description;
            var unit_name=ui.item.uom_symbol;
            var unit = ui.item.uom;
            if(frm=='frm'){
                $('#MaterialConversion_from_product_id').val(product_id);
                $('#MaterialConversion_from_product_desc').val(desc);
                $('#MaterialConversion_from_product').val(ui.item.part_number);
                $('#MaterialConversion_from_unit').val(unit);
                $('#MaterialConversion_from_unit_name').val(unit_name);
            
            }else{
                $('#MaterialConversion_to_product_id').val(product_id);
                $('#MaterialConversion_to_product_desc').val(desc);
                $('#MaterialConversion_to_product').val(ui.item.part_number);
                $('#MaterialConversion_to_unit').val(unit);
                $('#MaterialConversion_to_unit_name').val(unit_name);
            }
        }
    });
    
}", CClientScript::POS_HEAD);?>
