<?php 

$cs = Yii::app()->getClientScript();

$cs->registerScript("getLedgers", "function getLedgers(field_id)
{
    
    $('#ledger_id').val('');
    
    var url = '" . Yii::app()->createUrl('ledger/get_customers') . "';
    $('#'+field_id).autocomplete({
        minLength   : 1,
        source      : function (request, response) { autoCompleteSource(request, response, url) },
        focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },
        select      : function( event, ui ) {
            event.preventDefault();
            $('#ledger_name').val(ui.item.label);
            $('#ledger_id').val(ui.item.value);
        }
    });
}", CClientScript::POS_HEAD);

    $cs->registerScript("loadPage", "function loadPage(){
        if( $('#ledger_id').val() > 0 ){
            $('#loader').show();
            jQuery.ajax({
                'type': 'post',
                'url': '" . Yii::app()->createUrl('financial/customer_statement_html') . "',
                'data' : { 'ledger_id' : $('#ledger_id').val() },
                'success': function(data) {
                    $('#data_div').show();
                    $('.main-li-data').html(data);
                    $('#loader').hide();
                }
            });
        }else{
            t8.error('Choose customer first!');
            return false;
        }
    }", CClientScript::POS_HEAD);
?>

<div class="row">
    <div class="col-sm-12">
        <section class="panel">
            <header class="text-center panel-heading clearfix"><h4><b>INVOICE OUTSTANDING (SALES)</b></h4></header>
            <header class="panel-heading clearfix">
                <ul class="clearfix form-ul material">
                    <li class="col-sm-3">
                        <?php echo CHtml::hiddenField('ledger_id'); ?>
                        <?php echo CHtml::textField('ledger_name', '', array('class' => 'tooltipster', 'data-label' => 'Customer', 'onKeypress' => 'js:getLedgers(this.id);')); ?>
                    </li>
                     <div class="btn-wrap text-center">
                        <a type="button" class="btn btn-sm btn-theme" onclick="loadPage();">VIEW</a>
                        <a type="button" class="btn btn-sm btn-theme" onclick="window.open($('#liveSite').val()+'index.php?r=reportpdf/customerstatement&ledger_id='+$('#ledger_id').val(), '_blank'); ">PDF</a>
                        <a type="button" class="btn btn-sm btn-theme" onclick="window.open($('#liveSite').val()+'index.php?r=reportexcel/customerstatement&ledger_id='+$('#ledger_id').val());">XLS</a>
                    </div>
                </ul>
            </header>
            <div class="panel-body" id="data_div" style="display:none;" >
                <div class="tab-content">
                <div class="tab-pane main-li-data active" id="gl_tab">
                </div>
            </div>
        </section>
    </div>
</div>
