<?php



$cs = Yii::app()->getClientScript();



$cs->registerScript("getLedgers", "function getLedgers(field_id)

{



    $('#ledger_id').val('');



    var url = '" . Yii::app()->createUrl('ledger/get_customers') . "';

    $('#'+field_id).autocomplete({

        minLength   : 1,

        source      : function (request, response) { autoCompleteSource(request, response, url) },

        focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },

        select      : function( event, ui ) {

            event.preventDefault();

            $('#ledger_name').val(ui.item.label);

            $('#ledger_id').val(ui.item.value);

        }

    });

}", CClientScript::POS_HEAD);



$cs->registerScript("loadPage", "function loadPage(){



            $('#loader').show();

            jQuery.ajax({

                'type': 'post',

                'url': '" . Yii::app()->createUrl('financial/aging_html') . "',

                'data' : { 'ledger_id' : $('#ledger_id').val(), 'outlet' : $('#outlet').val() , 'to_date' : $('#to').val(), 'type' : 'receivable', 'salesman' : $('#salesman').val() },

                'success': function(data) {

                    $('#data_div').show();

                    $('.main-li-data').html(data);

                    $('#loader').hide();

                }

            });



    }", CClientScript::POS_HEAD);

?>



<div class="row">

    <div class="col-sm-12">

        <section class="panel">

            <header class="text-center panel-heading clearfix"><h4><b>RECEIVABLE AGING</b></h4></header>

            <header class="panel-heading clearfix">

                <ul class="clearfix form-ul material">

                    <?php if (Yii::app()->user->user_access_type == 'SU'): ?>

                        <li class="col-sm-3">

                            <?php echo CHtml::dropdownlist('outlet', '', VanOutlets::get_outlets(), array('class' => 'tooltipster', 'data-label' => 'Outlet', 'prompt' => 'All')); ?>

                        </li>

                    <?php endif;?>

                    <?php if (Yii::app()->user->user_access_type == 'CA'): ?>

                    <li class="col-sm-3">

                        <?php echo CHtml::hiddenField('ledger_id'); ?>

                        <?php echo CHtml::textField('ledger_name', '', array('class' => 'tooltipster', 'data-label' => 'Customer', 'onKeypress' => 'js:getLedgers(this.id);')); ?>

                    </li>

                    <li class="col-sm-2">
                        <?php echo CHtml::dropdownlist('salesman', '', VanOutlets::salesmans(), array('class' => 'tooltipster', 'data-label' => 'Salesman', 'prompt' => 'All')); ?>
                    </li>


                    <?php endif;?>

                    <li class="col-sm-2">

                        <?php echo CHtml::textField('to', date('d/m/Y'), array('class' => 'datepicker tooltipster', 'data-label' => 'As on date')); ?>

                    </li>

                     <div class="btn-wrap text-center">

                        <a type="button" class="btn btn-sm btn-theme" onclick="loadPage();">VIEW</a>

                        <a type="button" class="btn btn-sm btn-theme" onclick="window.open($('#liveSite').val()+'index.php?r=reportpdf/aging&outlet='+$('#outlet').val()+'&ledger_id='+$('#ledger_id').val()+'&type=receivable&to='+$('#to').val() +'&salesman=' + $('#salesman').val(), '_blank'); ">PDF</a>

                        <a type="button" class="btn btn-sm btn-theme" onclick="window.open($('#liveSite').val()+'index.php?r=reportexcel/aging&outlet='+$('#outlet').val()+'&ledger_id='+$('#ledger_id').val()+'&type=receivable&to='+$('#to').val() +'&salesman=' + $('#salesman').val() );">XLS</a>

                    </div>

                </ul>

            </header>

            <div class="panel-body" id="data_div" style="display:none;" >

                <div class="tab-content">

                <div class="tab-pane main-li-data active" id="gl_tab">

                </div>

            </div>

        </section>

    </div>

</div>

