<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("load", '
        $(document).ready(function() {
            $("#tbl_groups").on("preXhr.dt", function (e, settings, data) {
                data.type = "product_group";
                data.view_type = "outlet";
                data.outlet_id = "'.Yii::app()->user->outlet_id.'";
                return data;
            }).DataTable({
                "sScrollY": "auto",
                pageLength      : 50,
                columns: [
                    {className: "nw sl col-max-3"},
                    {className: "nw sl col-max-2"},
                ],
                ajax: {
                    url: "' . Yii::app()->createUrl('ledger/getGroups') . '",
                    type: "POST",
                    cache : false,
                },
                serverSide:     true,
                fixedColumns:   true,
                processing: true,
                order: [[ 0, "ASC" ]],
            });

    });', CClientScript::POS_HEAD);
?>

<div class="tab-content">
 
    <div class="tab-pane active">
        <section class="panel">
            <header class="panel-heading clearfix panel-theame">
                <i class="fa fa-cogs"></i> Product Groups
                <div class="pull-right">
                    <?php if( Yii::app()->user->user_access_type == 'CA' ): ?>
                        <button class="btn btn-sm btn-theme" onclick="loadPopupModal('ledger/creategroup&type=product_group&view_type=outlet','New Group','lg')"><i class="fa fa-plus"></i> ADD</button>
                    <?php  endif; ?>
                </div>
            </header>   
            <div class="panel-body">
                <div class="custom-data-table">
                    <table class="table table-hover table-bordered personal-task" id="tbl_groups">
                        <thead>
                            <tr>
                                <th>Name</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </section>
    </div>
</div>
