<?php
$cs = Yii::app()->getClientScript();
$cs->registerScript("load", '
        $(document).ready(function() {
            $("#tbl_products").on("preXhr.dt", function (e, settings, data) {
                data.type = "inventory";
                data.view_type = "company";
                return data;
            }).DataTable({
                "sScrollY": "auto",
                pageLength      : 50,
                columns: [
                    {className: "nw sl col-max-1"},
                    {className: "nw sl col-max-3"},
                    {className: "nw sl col-max-3"},
                    {className: "nw sl col-max-2"},
                    {className: "nw sl col-max-2"},
                    {className: "nw sl col-max-1"},
                    {className: "nw sl col-max-1"},
                ],
                ajax: {
                    url: "' . Yii::app()->createUrl('ledger/getLedgers') . '",
                    type: "POST",
                    cache : false,
                },
                serverSide:     true,
                fixedColumns:   true,
                processing: true,
                order: [[ 0, "ASC" ]],
            });


            $("#tbl_services").on("preXhr.dt", function (e, settings, data) {
                data.type = "expenses";
                data.view_type = "company";
                return data;
            }).DataTable({
                "sScrollY": "auto",
                pageLength      : 50,
                columns: [
                    {className: "nw sl col-max-1"},
                    {className: "nw sl col-max-3"},
                    {className: "nw sl col-max-3"},
                    {className: "nw sl col-max-2"},
                    {className: "nw sl col-max-1"},
                ],
                ajax: {
                    url: "' . Yii::app()->createUrl('ledger/getLedgers') . '",
                    type: "POST",
                    cache : false,
                },
                serverSide:     true,
                fixedColumns:   true,
                processing: true,
                order: [[ 0, "ASC" ]],
            });

    });', CClientScript::POS_HEAD);
?>

<!--ul start-->
<ul class="nav nav-tabs company-nav-tabs nav-tab-theme">
    <li onclick="reloadTable('#tbl_products')" class="active"><a href="#products_sec" data-toggle="tab"><i class="fa fa-cogs"></i> Products</a></li>
    <li onclick="reloadTable('#tbl_services')"><a href="#services_sec" data-toggle="tab"> <i class="fa fa-cogs"></i> Service</a></li>  
</ul>
<!--ul end-->


<div class="tab-content">
    <!--customers section start-->
    <div class="tab-pane active" id="products_sec">
        <section class="panel">
            <header class="panel-heading clearfix panel-theame">
                <i class="fa fa-users"></i> Products
                <div class="pull-right">
                    <button class="btn btn-sm btn-theme" onclick="loadPopupModal('ledger/createledger&type=inventory&view_type=company','New Item','lg')"><i class="fa fa-plus"></i> ADD</button>
                </div>
            </header>   
            <div class="panel-body">
                <div class="custom-data-table">
                    <table class="table table-hover table-bordered personal-task" id="tbl_products">
                        <thead>
                            <tr>
                                <th>Outlet</th>
                                <th>Part No</th>
                                <th>Description</th>
                                <th>Unit</th>
                                <th>Group</th>
                                <th>Stock In Hand</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </section>
    </div>
    <!--customers section end-->

    <!--vendors section start-->
    <div class="tab-pane" id="services_sec">
        <section class="panel">
            <header class="panel-heading clearfix panel-theame">
                <i class="fa fa-users"></i> Service
                <div class="pull-right">
                    <button class="btn btn-sm btn-theme" onclick="loadPopupModal('ledger/createledger&type=expenses&view_type=company','New Service','lg')"><i class="fa fa-plus"></i> ADD</button>
                </div>
            </header>   
            <div class="panel-body">
                <div class="custom-data-table">
                    <table class="table table-hover table-bordered personal-task" id="tbl_services">
                        <thead>
                            <tr>
                                <th>Outlet</th>
                                <th>Name</th>
                                <th>Alias</th>
                                <th>Group</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </section>
    </div>
    <!--vendors end-->
</div>
