<?php 
    
    $cs = Yii::app()->getClientScript();
    $cs->registerScript("loadPage", "function loadPage(){
        if( $('#product_id').val() > 0 ){
            $('#loader').show();
            jQuery.ajax({
                'type': 'post',
                'url': '" . Yii::app()->createUrl('reports/transaction_details_html') . "',
                'data' : { 'product_id' : $('#product_id').val(), 'from' : $('#from').val(), 'to' : $('#to').val(), 'salesman' : $('#salesman').val() },
                'success': function(data) {
                    $('#data_div').show();
                    $('.main-li-data').html(data);
                    $('#loader').hide();
                }
            });
        }else{
            t8.error('Choose Product!');
        }
    }", CClientScript::POS_HEAD);
    $cs->registerScript("loadPdf", "function loadPdf(){
        if( $('#product_id').val() > 0 ){
            window.open($('#liveSite').val()+'index.php?r=reportpdf/transactiondetail&product_id='+$('#product_id').val()+'&from='+$('#from').val()+'&to='+$('#to').val()+'&salesman='+$('#salesman').val(), '_blank');
        }else{
            t8.error('Choose Product!');
        }
    }", CClientScript::POS_HEAD);
    $cs->registerScript("loadexcel", "function loadexcel(){
        if( $('#product_id').val() > 0 ){
            window.open($('#liveSite').val()+'index.php?r=reportexcel/transactiondetail&product_id='+$('#product_id').val()+'&from='+$('#from').val()+'&to='+$('#to').val()+'&salesman='+$('#salesman').val());
        }else{
            t8.error('Choose Product!');
        }
    }", CClientScript::POS_HEAD);

    $cs->registerScript("getLegders", "function getLedgers(field_id)
    {

    $('#product_id').val(0);
    
    var url = '" . Yii::app()->createUrl('ledger/goods_and_services') . "&from=sales&service_flag=off';
    $('#'+field_id).autocomplete({
        minLength   : 1,
        source      : function (request, response) { autoCompleteSource(request, response, url) },
        focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },
        select      : function( event, ui ) {
            event.preventDefault();
            $('#product_id').val(ui.item.value);
        }
    });
}", CClientScript::POS_HEAD);

?>

<div class="row">
    <div class="col-sm-12">
        <section class="panel">
            <header class="text-center panel-heading clearfix"><h4><b>TRANSACTION DETAILS</b></h4></header>
            <header class="panel-heading clearfix">
                <ul class="clearfix form-ul material">
                    <li class="col-sm-3">
                        <?php echo CHtml::hiddenField('product_id'); ?>
                        <?php echo CHtml::textField('product', '', array('class' => 'tooltipster', 'data-label' => 'Product', 'onKeypress' => 'js:getLedgers(this.id);')); ?>
                    </li>
                    <li class="col-sm-2">
                        <?php echo CHtml::textField('from', date('01/m/Y'), array('class' => 'datepicker tooltipster', 'data-label' => 'From')); ?>
                    </li>
                    <li class="col-sm-2">
                        <?php echo CHtml::textField('to', date('t/m/Y'), array('class' => 'datepicker tooltipster', 'data-label' => 'To')); ?>
                    </li>
                    <?php if( Yii::app()->user->user_access_type == 'CA' ) :  ?>
                        <li class="col-sm-3">
                            <?php echo CHtml::dropdownlist('salesman', '', VanOutlets::salesmans(), array('class' => 'tooltipster', 'data-label' => 'Salesman')); ?>
                        </li>
                    <?php endif; ?>
                     <div class="btn-wrap text-center">
                        <a type="button" class="btn btn-sm btn-theme" onclick="loadPage();">VIEW</a>
                        <a type="button" class="btn btn-sm btn-theme" onclick="loadPdf(); ">PDF</a>
                        <a type="button" class="btn btn-sm btn-theme" onclick="loadexcel()">XLS</a>
                    </div>
                </ul>
            </header>
            <div class="panel-body" id="data_div" style="display:none;" >
                <div class="tab-content">
                <div class="tab-pane main-li-data active" id="gl_tab">
                </div>
            </div>
        </section>
    </div>
</div>
