<?php
$form = $this->beginWidget('CActiveForm', array(
    'id' => 'voucher-form' . rand(),
    'enableAjaxValidation' => false,
    'enableClientValidation' => false,
));
$cs = Yii::app()->getClientScript();

$cs->registerScript('calculateTotal', 'function calculateTotal(event){
            var grand_total = 0;
            var total_net_amount = 0;
            var total_vat_amount = 0;
            var net_amount =0;
            var discount_amount =0;
            var vat_percentage =0 ;
            var discount_val= 0;
            var count = 0;
            var vat_amount =0;
            var rate =0;
            var quantity =0;
            var amount =0;

            $("#voucher_entries").find("tr:gt(0)").each(function() {
                
                rate = Number($(this).find("[id $=_rate]").val());
                quantity =  Number($(this).find("[id $=_quantity]").val());
                discount_val = $(this).find("[id $=_discount_percentage]").val();
                vat_percentage = $(this).find("[id $=tax_percentage]").val().replace(/%/,"");
                
                amount = rate * quantity; 
                
                //Round of Four
                amount = round_off(amount);

                count = discount_val.indexOf("%") > -1 ? 1 : 0;
                if( count > 0 ){
                    discount_val    = discount_val.replace(/%/,"");              
                    discount_amount = ( Number(amount) * Number(discount_val) )/100;
                }else
                    discount_amount = Number(discount_val);
                
                discount_amount = round_off(discount_amount);
                amount -= discount_amount;

                vat_amount = $("#VanVouchers_is_taxable").val() == "Y" ? ( ( amount * vat_percentage ) / 100 ) : 0;
                vat_amount = round_off(vat_amount);

                net_amount = amount + vat_amount;
                net_amount = round_off(net_amount);
              
                total_vat_amount += vat_amount;
                total_net_amount += amount;
                grand_total += net_amount;
                
                $(this).find("[id $=_discount_value]").val(discount_amount);
                $(this).find("[id $=_tax_value]").val(vat_amount.toFixed(6));
                $(this).find("[id $=_net_amount]").val(net_amount.toFixed(6));
                    
            });
            
            $("#voucher_add_table").find("tr").each(function(){
                 grand_total += round_off( Number( $(this).find("[id $=_amount]").val() ) );
            });
            
            $("#voucher_ded_table").find("tr").each(function(){
                grand_total -= round_off( Number( $(this).find("[id $=_amount]").val() ) );
            });

            $(".vat_total").text(round_off_two(total_vat_amount).toFixed(2));
            $(".net_total").text(round_off_two(total_net_amount).toFixed(2));
            $(".grand_total").text(round_off_two(grand_total).toFixed(2));

        }', CClientScript::POS_HEAD);

        $cs->registerScript("check_min_qty", "function check_min_qty(field_id, value)
        {
            var arr_field_id = field_id.split('_');
            var i = arr_field_id[1];
            var max = Number( $('#VanTransactions_'+i+'_maximum_qty').val() );
            if( value > max ){
                t8.warning({
                    message:'Maximum quantity is '+Number(max).toFixed(6), 
                    title:'Warning',
                    iconClass: 'fa fa-dollar',
                });
                $('#VanTransactions_'+i+'_quantity').val('');
            }
        }", CClientScript::POS_HEAD);

        $cs->registerScript("round_field", "function round_field(field_id)
        {
            if( !isNaN( $('#'+field_id).val() )  ){
                var value = Number($('#'+field_id).val());
                value = value >= 0 ? round_off(value) : 0;
                $('#'+field_id).val(value.toFixed(6));
            }
        }", CClientScript::POS_HEAD);




?>

<div class="tab-content">
    <div class="tab-pane active">
        <ul class="clearfix form-ul material">
            <li class="col-sm-2">
                <?php echo $form->hiddenField($debitnote, "id"); ?>
                <?php $debitnote->date = $debitnote->isNewRecord ? date('d/m/Y') : date('d/m/Y', strtotime($debitnote->date)) ?>
                <?php echo $form->textField($debitnote, 'date', array('data-label' => 'Debitnote Date', 'class' => 'datepicker tooltipster')); ?>
            </li>
            <li class="col-sm-2">
                <?php $debitnote->invoice_no = $debitnote->isNewRecord ? $debitnote->invoice_no : $debitnote->invoice_parent->number; ?>
                <?php echo $form->textField($debitnote, 'invoice_no', array('data-label' => 'Invoice No', 'class' => 'tooltipster', 'readonly' => true)); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->hiddenField($debitnote, "party_ledger"); ?>
                <?php $debitnote->party_name = $debitnote->partyDetails->name; ?>
                <?php echo $form->textField($debitnote, 'party_name', array('data-label' => 'Vendor', 'class' => 'tooltipster', 'readonly' => true )); ?>
                <?php echo $form->hiddenField($debitnote, "return_parent"); ?>
                <?php echo $form->hiddenField($debitnote, "is_taxable"); ?>
            </li>
            <?php if(  $debitnote->isNewRecord  ) : ?>
                <li class="col-sm-2">
                    <?php echo $form->checkBoxList($debitnote, 'printable',array('Y' => 'Print Voucher'),array('title'=>'View')); ?>
                </li>
            <?php endif; ?>
        </ul>
        <table class="table table-bordered" id="voucher_entries" >
            <thead>
                <tr>
                    <th style="width:1%">#</th>
                    <th style="width:12%">Part no</th>
                    <th style="width:17%">Description</th>
                    <th style="width:8%">Quantity</th>
                    <th style="width:5%">UOM</th>
                    <th style="width:10%">Rate</th>
                    <th style="width:15%">Discount</th>
                    <th style="width:18%">VAT</th>
                    <th style="width:10%">Net</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ( $debitnoteitems as $i => $each): ?>
                    <tr>
                        <td><label><?php echo $i + 1; ?></label></td>
                        <td>
                            <?php echo $form->hiddenField($each, "[".$i."]id"); ?>
                            <?php echo $form->hiddenField($each, "[".$i."]ledger_id"); ?>
                            <?php echo $form->hiddenField($each, "[".$i."]returns_parent_id"); ?>
                            <?php $each->goods_service = $each->ledger->goods_or_service; ?>
                            <?php echo $form->hiddenField($each, "[".$i."]goods_service"); ?>
                            <?php $each->ledger_name = $each->ledger->name; ?>
                            <?php echo $form->textField($each, "[".$i."]ledger_name", array('class' => 'form-control', 'readonly' => true)); ?>
                        </td>
                        <td>
                            <?php echo $form->textField($each, "[".$i."]description", array('class' => 'form-control' , 'readonly' => true)); ?>
                        </td>
                        <td>
                            <?php 
                                $each->maximum_qty = $each->isNewRecord ? (float) abs($each->quantity) : $each->parentItem->Returnable_quantity + abs($each->quantity);
                                $each->quantity = $each->id > 0 ? abs($each->quantity) : 0; 
                            ?>
                            <?php echo $form->textField($each, "[".$i."]quantity", array('class' => 'go txt-10 text-right', 'onkeypress' => 'return isNumberKey(event)', 'onBlur' => 'round_field(this.id)', 'onKeyup' => 'check_min_qty(this.id, this.value); calculateTotal(this);')); ?>
                            <?php echo $form->hiddenField($each, "[".$i."]uom"); ?>
                            <?php echo $form->hiddenField($each, "[".$i."]maximum_qty"); ?>
                        </td>
                        <td>
                            <?php  $each->unit_label =$each->isNewRecord ? $each->unit_label : $each->unitDetails->symbol; ?>
                            <?php echo $each->unit_label; ?>
                        </td>
                        <td>
                            <?php echo $form->textField($each, "[".$i."]rate", array('class' => 'go txt-10 text-right', 'readonly' => true)); ?>
                        </td>
                        <td class="nw">
                            <?php echo $form->textField($each, "[".$i."]discount_percentage", array('class' => 'go txt-6 text-right', 'readonly' => true)); ?>
                            <?php echo $form->textField($each, "[".$i."]discount_value", array( 'class' => 'go txt-6 text-right', 'readonly' => true, 'tabindex' => '-1')); ?>
                        </td>
                        <td class="nw">
                            <?php echo $form->textField($each, "[".$i."]tax_percentage", array('class' => 'go txt-6 text-right', 'readonly' => true, 'tabindex' => '-1')); ?>
                            <?php echo $form->textField($each, "[".$i."]tax_value", array('class' => 'go txt-6 text-right', 'readonly' => true, 'tabindex' => '-1')); ?>
                        </td>
                        <td>
                            <?php echo $form->textField($each, "[".$i."]net_amount", array('class' => 'go txt-10 text-right', 'readonly' => true, 'tabindex' => '-1')); ?>
                        </td>
                    </tr>
                <?php endforeach;?>
                        </tbody>
                </table>
                <table class="table table-hover table-bordered table-nexted quotes_total">
                    <tr class="bg-total">
                        <td width="70%" class="text-right table_total_title">
                            <h2>Net Total</h2>
                        </td>
                        <td width="30%" class="text-right table_total ">
                            <h2 class="text-right net_total"><?php echo Yii::app()->numberFormatter->formatCurrency($total, " "); ?></h2>
                        </td>
                    </tr>
                </table>
                <table class="table table-hover table-bordered table-nexted quotes_total">
                    <tr class="bg-total">
                        <td width="70%" class="text-right table_total_title">
                            <h2>Net VAT</h2>
                        </td>
                        <td width="30%" class="text-right table_total ">
                            <h2 class="text-right vat_total"><?php echo Yii::app()->numberFormatter->formatCurrency($total, " "); ?></h2>
                        </td>
                    </tr>
                </table>
             
                <table class="table table-hover table-bordered table-nexted quotes_total">
                    <tr class="bg-total">
                        <td width="70%" class="text-right table_total_title">
                            <h2>Grand Total</h2>
                        </td>
                        <td width="30%" class="text-right table_total ">
                            <h2 class="text-right grand_total"><?php echo Yii::app()->numberFormatter->formatCurrency($total, " "); ?></h2>
                        </td>
                    </tr>
                </table>
            </div>
        </div>
        <div class="modal-footer">
    <button type="button" class="btn btn-danger" id="cust_close" data-dismiss="modal">Close</button>
    <?php

echo CHtml::ajaxSubmitButton('Save', Yii::app()->createUrl('voucher/savedebitnote'), array(
    'dataType' => 'json',
    'type' => 'post',
    'success' => 'function(data) {
            $("#loader").hide();
            if(data.status=="success"){
                t8.success("Done!");
                $(".x.close").click();
                reloadTable("#tbl_purchase");
                reloadTable("#tbl_purchase_rtn");
                if( data.generate_print )
                    window.open("index.php?r=voucher/print&id="+data.id);
                }else{
                    $.each(data, function(key, val) {
                        t8.error(""+val+"");
                    });
                }
            }',
            'beforeSend' => 'function(){
                $("#loader").show();
            }',
), array('id' => 'mybtn' . rand(), 'class' => 'voucher-submit btn btn-theme'));

?>
    </div>
<?php $this->endWidget();?>

    <script>
        $(function() {
            lastId = $('#voucher_entries').find('tr:last input:first').attr('id');
            thenum = lastId.match(/\d+/g);
            setTimeout(function() {
                $('#VanTransactions_'+thenum+'_ledger_name').focus();
                calculateTotal(this);
            }, 500);
        });
        function round_off(num) {    
            return +(Math.round(num + "e+6")  + "e-6");
        }
        function round_off_two(num) {    
            return +(Math.round(num + "e+2")  + "e-2");
        }
    </script>