<?php

$form = $this->beginWidget('CActiveForm', array(
    'id' => 'voucher-form' . rand(),
    'enableAjaxValidation' => false,
    'enableClientValidation' => false,
));

$cs = Yii::app()->getClientScript();

$cs->registerScript("customers", "function customers(field_id)
{
     
    $('#customer_id').val('');
    $('#alloc_data_body').html('<tr><td colspan=\"8\" class=\"text-center\"> No Data</td></tr>');

    var url = '" . Yii::app()->createUrl('ledger/get_customers') . "';
    $('#'+field_id).autocomplete({
        minLength   : 1,
        source      : function (request, response) { autoCompleteSource(request, response, url) },
        focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },
        select      : function( event, ui ) {
            event.preventDefault();
            $('#customer_id').val(ui.item.value);
            $('#customer').val(ui.item.label);

            if( ui.item.value > 0 ){
                jQuery.ajax({
                    'type': 'post',
                    'dataType' : 'json',
                    'url': '" . Yii::app()->createUrl('voucher/get_allocation_data') . "',
                    'data' : { 'ledger_id' : ui.item.value, 'retrieve' :  'debit', 'threshold' : $('#threshold').val() },
                    'success': function(data) {
                        $('#alloc_data_body').html(data.table);
                    }
                });
            }
        }
    });
}", CClientScript::POS_HEAD);


$cs->registerScript('calculateValue', 'function calculateValue(){
        var totalAlloc = 0;
        $("#allocation_table").find("tr:gt(0)").each(function() {
             if( parseFloat( $(this).find("[id $=_amount]").val() ) > 0 )
                totalAlloc += parseFloat( $(this).find("[id $=_amount]").val() );
            });
           
            var formatted_value_alloc = totalAlloc > 0 ? parseFloat(totalAlloc)
            .toFixed(2)
            .toString()
            .replace(/\B(?=(\d{3})+(?!\d))/g, ",") : 0.00;
           
            $("#total_adjusted").val( formatted_value_alloc );

        }', CClientScript::POS_HEAD);



$cs->registerScript("copyValue", "function copyValue(event, field_id){
    
    var arr_field_id = field_id.split('_');
    var i = arr_field_id[1];
    var totalAlloc = 0;
    
    if( $(event).prop('checked') ){
        var pastable = $('#Allocate_'+i+'_balance').val();
        $('#Allocate_'+i+'_amount').val( pastable );
    }else{
        $('#Allocate_'+i+'_amount').val(0);
    }

    calculateValue();

}", CClientScript::POS_HEAD);



$cs->registerScript('validateAmount', 'function validateAmount(maximum, field_id, value){
    if( value > Number(maximum) || value < 0 ){
        $("#"+field_id).val("");
    }
}', CClientScript::POS_HEAD);

?>

<div class="tab-content">
    <div class="tab-pane active">
        <ul class="clearfix form-ul material">
            <li class="col-sm-2">
                <?php echo $form->textField($model, 'date', array('data-label' => 'Voucher Date', 'class' => 'datepicker tooltipster', 'value' => date('d/m/Y'))); ?>
            </li>
            <li class="col-sm-2">
                <?php echo CHtml::textField('threshold', 5000, array('data-label' => 'Threshold', 'class' => 'tooltipster', 'title' => 'Maximum invoice value to be fetched')); ?>
            </li>
            <li class="col-sm-2">
                <?php echo CHtml::dropdownlist('expense_account', NULL,  VanLedgers::get_expense_accounts(), array('data-label' => 'Expense A/C', 'class' => 'tooltipster', 'data-search' => true)); ?>
            </li>
            <li class="col-sm-3">
                <?php echo CHtml::hiddenField('customer_id'); ?>
                <?php echo CHtml::textField('customer', '', array('class' => 'tooltipster', 'data-label' => 'Customer', 'onKeypress' => 'js:customers(this.id);')); ?>
            </li>
            <li class="col-sm-3">
                <?php echo $form->textArea($model, 'other_references', array('data-label' => 'Narration', 'class' => 'tooltipster')); ?>
            </li>
        </ul>
        
        <table class="table table-bordered" id="allocation_table">
            <thead>
                <tr>
                    <th style="width:1%">#</th>
                    <th style="width:5%">Date</th>
                    <th style="width:15%">Type</th>
                    <th style="width:10%">Inv #</th>
                    <th style="width:15%">Total</th>
                    <th style="width:15%">Allocated</th>
                    <th style="width:15%">Balance</th>
                    <th style="width:20%">Amount</th>
                </tr>
            </thead>
            <tbody id="alloc_data_body">
                <tr><td colspan="8" class="text-center"> No Data</td></tr>
            </tbody>
        </table>
        <table class="table table-hover table-bordered personal-task">
            <tr>
                <th colspan="7" class="text-right" style="width: 52.25%;"><b>Total (<?php echo VanCurrency::base_currency_code() ?>)</b></th>
                <th style="width: 19.85%;text-align:right !important;"><?php echo CHtml::textfield('total_adjusted', '0.00', array('tabindex' => '-1', 'class' => 'form-control text-bold text-right', 'readonly' => true)); ?></th>
            </tr>
        </table>
    </div>
</div>

<div class="modal-footer">
    <button type="button" class="btn btn-danger" id="cust_close" data-dismiss="modal">Close</button>
    <?php
echo CHtml::ajaxSubmitButton('Save', Yii::app()->createUrl('voucher/save_discount_allocation'), array(
    'dataType' => 'json',
    'type' => 'post',
    'success' => 'function(data) {
            $("#loader").hide();
            if(data.status=="success"){
                t8.success("Done!");
                $(".x.close").click();
                reloadTable("#tbl_allocation");
            }else{
                $.each(data, function(key, val) {
                    t8.error(""+val+"");
                });
            }
        }',
        'beforeSend' => 'function(){
            var sum = Number($("#total_adjusted").val().replace(/,/g, ""));
            if( sum > 0 ){
                $("#loader").show();
            }else{
                t8.error("Please select atleast one item!");
                return false;
            }
        }',
), array('id' => 'mybtn' . rand(), 'class' => 'voucher-submit btn btn-theme'));



?>

    </div>

<?php $this->endWidget();?>

