<?php

$form = $this->beginWidget('CActiveForm', array(

    'id' => 'voucher-form' . rand(),

    'enableAjaxValidation' => false,

    'enableClientValidation' => false,

));

$cs = Yii::app()->getClientScript();



$cs->registerScript("getExchange", "function getExchange(field_id, currency){

    var arr_field_id = field_id.split('_');

    var i = arr_field_id[1];

    jQuery.ajax({

        'type': 'post',

        'url': '" . Yii::app()->createUrl('voucher/getexchange_rate') . "',

        'data' : {'currency' : currency},

            'success': function(data) {

                $('#VanTransactions_'+i+'_exchange_rate').val(data);

                calculateTotal();

            }

        });

    }", CClientScript::POS_HEAD);



$cs->registerScript("getLegders", "function getLedgers(field_id)

{

    var arr_field_id = field_id.split('_');

    var i = arr_field_id[1];

    

    $('#VanTransactions_'+i+'_ledger_id').val('');

    

    var url = '" . Yii::app()->createUrl('ledger/ledgerlist') . "';

    $('#'+field_id).autocomplete({

        minLength   : 1,

        source      : function (request, response) { autoCompleteSource(request, response, url) },

        focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },

        select      : function( event, ui ) {

            event.preventDefault();

            $('#VanTransactions_'+i+'_ledger_name').val(ui.item.description);

            $('#VanTransactions_'+i+'_ledger_id').val(ui.item.value);

        }

    });

}", CClientScript::POS_HEAD);



$cs->registerScript('calculateTotal', 'function calculateTotal(){

            var creditTotal = 0;

            var debitTotal = 0;

            var debit, credit, ex_rate;

            $("#voucher_entries").find("tr:gt(0)").each(function() {

                debit = parseFloat($(this).find("[id $=_debit]").val().replace(/,/g, "") );

                ex_rate = parseFloat($(this).find("[id $=_exchange_rate]").val() );

                if( parseFloat($(this).find("[id $=_debit]").val().replace(/,/g, "") ) > 0 )

                    debitTotal += roundToTwo(( debit * ex_rate));

                credit = parseFloat($(this).find("[id $=_credit]").val().replace(/,/g, "") );

                if( parseFloat($(this).find("[id $=_credit]").val().replace(/,/g, "") ) > 0 )

                    creditTotal += roundToTwo(( credit * ex_rate ));

            });

            var formatted_value_debit = debitTotal > 0 ? parseFloat(debitTotal)

            .toFixed(2)

            .toString()

            .replace(/\B(?=(\d{3})+(?!\d))/g, ",") : 0.00;

            

            var formatted_value_credit = creditTotal > 0 ? parseFloat(creditTotal)

            .toFixed(2)

            .toString()

            .replace(/\B(?=(\d{3})+(?!\d))/g, ",") : 0.00;

            

            $("#debit_total").val( formatted_value_debit );

            $("#credit_total").val( formatted_value_credit );

        }', CClientScript::POS_HEAD);

$cs->registerScript("nextline", "function nextline(event)

        {

            if (event.keyCode == 13) {

                event.preventDefault();

                newVoucher($('#voucher_entries'));

                return false;

            }else if( event.keyCode == 9 ){

                event.preventDefault();

                var creditTotal = Number($('#credit_total').val().replace(/,/g, '') ) ;

                var debitTotal = Number($('#debit_total').val().replace(/,/g, '') ) ;

                var diff = debitTotal - creditTotal;

                if(diff != 0)

                    newVoucher($('#voucher_entries'));

            }

        }", CClientScript::POS_HEAD);

$cs->registerScript("newVoucher", " function newVoucher(jQtable) {

            formId              =   jQtable.attr('id');

            formIdStarter       =   jQtable.attr('id').split(/_(.+)?/)[0];

            lastId = jQtable.find('tr:last input:first').attr('id');

            thenum = lastId.match(/\d+/g);

            newId = Number(thenum) + 1;

            newrow= jQtable.find('tr:last').clone();

            newrow.find('label:first').html(newId+1);

            newrow.attr('class',newId);

            newrow.find('div,input,textarea,checkbox,td,select,.errorMessage,a').each(function() {

                this.id= this.id.replace(/\d+/,newId);

                if(!$(this).is(':checkbox'))

                    this.value  = '';

                else

                    $(this).prop('checked', false);

                (this.name!==undefined) ? this.name= this.name.replace(/\d+/,newId) : this.style = '';

            });

            jQtable.append(newrow);

            var creditTotal = Number($('#credit_total').val().replace(/,/g, '') ) ;

            var debitTotal = Number($('#debit_total').val().replace(/,/g, '') ) ;

            var diff = debitTotal - creditTotal;

            if( diff <= 0 ){

                $('#VanTransactions_'+newId+'_credit').attr( 'readonly', true );

                $('#VanTransactions_'+newId+'_credit').attr( 'tabindex', '-1' );

                $('#VanTransactions_'+newId+'_debit').attr( 'readonly', false );

                $('#VanTransactions_'+newId+'_debit').attr( 'tabindex', '0' );

            }else{

                $('#VanTransactions_'+newId+'_credit').attr( 'readonly', false );

                $('#VanTransactions_'+newId+'_credit').attr( 'tabindex', '0' );

                $('#VanTransactions_'+newId+'_debit').attr( 'readonly', true );

                $('#VanTransactions_'+newId+'_debit').attr( 'tabindex', '-1' );

            }

            $('#VanTransactions_'+newId+'_ledger_name').focus();

            $('#VanTransactions_'+newId+'_currency_id').val(1); //AED

            $('#VanTransactions_'+newId+'_exchange_rate').val(1); //AED

        }", CClientScript::POS_HEAD);





$cs->registerScript("format_currency", "function format_currency(field_id)

{

    var currency = $('#'+field_id).val().replace(/,/g, '') > 0 ?  $('#'+field_id).val().replace(/,/g, '') : 0;

    var formatted_value = currency > 0 ? parseFloat(currency.replace(/,/g, ''))

    .toFixed(2)

    .toString()

    .replace(/\B(?=(\d{3})+(?!\d))/g, ',') : 0.00;

    $('#'+field_id).val(formatted_value);

}", CClientScript::POS_HEAD);



$debitTotal = 0;

$creditTotal = 0;



?>

<?php echo $form->hiddenField($model, "id"); ?>

<div class="tab-content">

    <div class="tab-pane active">

        <table class="table table-bordered" id="voucher_entries" >

            <thead>

                <tr>

                    <th style="width:1%">No</th>

                    <th style="width:45%">Particular</th>

                    <th style="width:15%">Debit</th>

                    <th style="width:15%">Credit</th>

                    <th style="width:20%">Currency</th>

                    <th style="width:1%"class="text-center"><a class="btn btn-xs btn-theme " href="javascript:void(0);" onclick="newVoucher($('#voucher_entries'));"><i class="fa fa-plus"></i></a></th>

                </tr>

            </thead>

            <tbody id="template_div">

                <?php foreach ((!$model->isNewrecord) ? $model->entries : array(new VanTransactions) as $i => $each): ?>

                    <tr>

                        <td><label><?php echo $i + 1; ?></label></td>

                        

                        <td>

                            <?php echo $form->hiddenField($each, "[".$i."]id"); ?>

                            <?php echo $form->hiddenField($each, "[".$i."]ledger_id"); ?>

                            <?php $each->ledger_name = $each->ledger->name; ?>

                            <?php echo $form->textField($each, "[".$i."]ledger_name", array('class' => 'form-control', 'onKeypress' => 'js:getLedgers(this.id);')); ?>

                        </td>

                        

                        <?php

                            if ( $each->amount > 0 ) {

                                $each->debit = Yii::app()->numberFormatter->formatCurrency($each->amount, " ");

                                $debitTotal += round(( $each->amount * $each->exchange_rate ), 2);

                            }

                            

                            if ( $each->amount < 0 ) {

                                $each->credit = Yii::app()->numberFormatter->formatCurrency(abs($each->amount), " ");

                                $creditTotal += round(abs($each->amount* $each->exchange_rate), 2);

                            }

                        ?>

                        

                        <td>

                            <?php echo $form->textField($each, "[" . $i . "]debit", array('data-label' => 'Debit', 'class' => 'form-control text-right', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateTotal();', 'onBlur' => 'format_currency(this.id);' , 'readonly' => $each->amount > 0 || $each->isNewRecord  ? false : true, 'tabindex' => $each->amount > 0 || $each->isNewRecord ? '0' : '-1')); ?>

                        </td>

                                    

                        <td>

                            <?php echo $form->textField($each, "[" . $i . "]credit", array('data-label' => 'Credit', 'class' => 'form-control text-right', 'onkeypress' => 'return isNumberKey(event)', 'onkeyup' => 'calculateTotal();', 'onBlur' => 'format_currency(this.id);', 'readonly' => $each->amount < 0 ? false : true, 'tabindex' => $each->amount < 0 ? '0' : '-1' )); ?>

                        </td>

                        

                        <td class="nw">

                            <?php $each->exchange_rate = $each->isNewRecord ? 1 : $each->exchange_rate; ?>

                            <?php echo $form->dropdownlist($each, "[" . $i . "]currency_id", VanCurrency::all_codes(), array('class' => 'txt-6 go exception', 'onChange' => 'getExchange(this.id, this.value);')) . ' ' . $form->textField($each, "[" . $i . "]exchange_rate", array('class' => 'txt-6 go exception text-right', 'onkeyup' => 'calculateTotal();',  'onkeydown' => 'nextline(event)', 'readonly' => true)); ?>

                        </td>

                        

                        <td class="text-center nw" width="1%"><?php echo CHtml::link('<i class="fa fa-times"></i>', 'javascript:void(0);', array('tabindex' => '-1', 'class' => 'btn btn-xs btn-danger', 'onclick' => 'removeTableRow($(\'#voucher_entries\'),this)', 'title' => 'Remove this item')); ?></td>

                    </tr>

                <?php endforeach;?>

                        </tbody>

                </table>

                <table class="table table-hover table-bordered personal-task"  >

                    <tr>

                        <th colspan="4" class="text-right" style="width: 47.25%;"><b>Total (AED)</b></th>

                        <th style="width: 14.78%;text-align:right !important;"><?php echo CHtml::textfield('debit_total', Yii::app()->numberFormatter->formatCurrency($debitTotal, " "), array('tabindex' => '-1', 'class' => 'form-control text-bold text-right', 'readonly' => true)); ?></th>

                        <th style="width: 14.85%;text-align:right !important;"><?php echo CHtml::textfield('credit_total', Yii::app()->numberFormatter->formatCurrency($creditTotal, " "), array('tabindex' => '-1', 'class' => 'form-control text-bold text-right', 'readonly' => true)); ?></th>

                        <th></th>

                    </tr>

                </table>

                <ul class="clearfix form-ul material">

                    <li class="col-sm-3">

                        <?php $model->date = $model->isNewRecord ? date('d/m/Y') : date('d/m/Y', strtotime($model->date)) ?>

                        <?php echo $form->textField($model, 'date', array('data-label' => 'Voucher Date', 'class' => 'datepicker tooltipster')); ?>

                    </li>

                    <li class="col-sm-3">

                        <?php echo CHtml::textField('reference_no', $model->reference_no, array('data-label' => 'Reference', 'class' => 'tooltipster')); ?>

                    </li>
                                        

                    <li class="col-sm-3">

                        <?php echo $form->checkBoxList($model, 'printable',array('Y' => 'Print Voucher'),array('title'=>'View')); ?>

                    </li>

                    <li class="col-sm-12">

                        <?php echo $form->textArea($model, 'other_references', array('data-label' => 'Narration', 'class' => 'tooltipster')); ?>

                    </li>

                </ul>

            </div>

        </div>

        <div class="modal-footer">

    <button type="button" class="btn btn-danger" id="cust_close" data-dismiss="modal">Close</button>

    <?php



echo CHtml::ajaxSubmitButton('Save', Yii::app()->createUrl('voucher/savejournal'), array(

    'dataType' => 'json',

    'type' => 'post',

    'success' => 'function(data) {

            $("#loader").hide();

            if(data.status=="success"){

                t8.success("Done!");

                if( data.load_new )

                    loadPopupModal("voucher/create&type=journal","New Journal","xl");

                else

                    $(".x.close").click();

                    reloadTable("#tbl_journal");

                if( data.generate_print )

                    window.open("index.php?r=voucher/print&id="+data.id);

                }else{

                    $.each(data, function(key, val) {

                        t8.error(""+val+"");

                    });

                }

            }',

            'beforeSend' => 'function(){

                var creditTotal = Number($("#credit_total").val().replace(/,/g, "") ) ;

                var debitTotal = Number($("#debit_total").val().replace(/,/g, "") ) ;

                if( debitTotal == creditTotal && debitTotal > 0 && creditTotal > 0 )

                    $("#loader").show();

                else{

                    t8.error("Totals are not matching!");

                    return false;

                }

            }',

), array('id' => 'mybtn' . rand(), 'class' => 'voucher-submit btn btn-theme'));



?>

    </div>

<?php $this->endWidget();?>



    <script>

        $(function() {

            lastId = $('#voucher_entries').find('tr:last input:first').attr('id');

            thenum = lastId.match(/\d+/g);

            setTimeout(function() {

                $('#VanTransactions_'+thenum+'_ledger_name').focus();

            }, 500);

        });

        function roundToTwo(num) {    

            return +(Math.round(num + "e+2")  + "e-2");

        }

    </script>