<?php

$form = $this->beginWidget('CActiveForm', array(

    'id' => 'voucher-form' . rand(),

    'enableAjaxValidation' => false,

    'enableClientValidation' => false,

));

$cs = Yii::app()->getClientScript();



$cs->registerScript("getExchange", "function getExchange(currency){

    jQuery.ajax({

        'type': 'post',

        'url': '" . Yii::app()->createUrl('voucher/getexchange_rate') . "',

        'data' : {'currency' : currency },

            'success': function(data) {

                $('#exchange_rate').val(data);

            }

        });

    }", CClientScript::POS_HEAD);



$cs->registerScript("customers", "function customers(field_id)

    {

         

        $('#VanVouchers_party_ledger').val('');

        var url = '" . Yii::app()->createUrl('ledger/get_customers') . "';

        $('#'+field_id).autocomplete({

            minLength   : 1,

            source      : function (request, response) { autoCompleteSource(request, response, url) },

            focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },

            select      : function( event, ui ) {

                event.preventDefault();

                $('#VanVouchers_party_ledger').val(ui.item.value);

                $('#VanVouchers_party_name').val(ui.item.label);

                $('#VanVouchers_billing_address').val(ui.item.billing_address).addClass('filled');

                jQuery.ajax({

                    'type': 'post',

                    'dataType' : 'json',

                    'url': '" . Yii::app()->createUrl('voucher/get_vendor_properties') . "',

                    'data' : {'vendor_id' : ui.item.value},

                        'success': function(data) {

                            $('#currency_drop').html(data.currency_drop);

                            $('#exchange_rate').val(data.exchange_rate).addClass('filled');

                            $('#VanVouchers_payment_terms').val(data.credit_days).addClass('filled');

                        }

                    });

            }

        });

    }", CClientScript::POS_HEAD);



$cs->registerScript("getLedgers", "function getLedgers(field_id)

{

    var arr_field_id = field_id.split('_');

    var i = arr_field_id[1];

    

    $('#VanTransactions_'+i+'_ledger_id').val('');

    $('#VanTransactions_'+i+'_description').val('');

    

    var url = '" . Yii::app()->createUrl('ledger/goods_and_services') . "&from=sales&party=' + $('#VanVouchers_party_ledger').val();

    $('#'+field_id).autocomplete({

        minLength   : 1,

        source      : function (request, response) { autoCompleteSource(request, response, url) },

        focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },

        select      : function( event, ui ) {

            event.preventDefault();

            var ex_rate = $('#exchange_rate').val();

            var rate =  ui.item.sales_price / ex_rate;

            var min_rate = ui.item.min_selling_rate / ex_rate;



            $('#VanTransactions_'+i+'_ledger_name').val(ui.item.name);

            $('#VanTransactions_'+i+'_description').val(ui.item.description);

            $('#VanTransactions_'+i+'_ledger_id').val(ui.item.value);

            $('#VanTransactions_'+i+'_rate').val(round_off(rate));

            $('#VanTransactions_'+i+'_min_selling_price').val(round_off(min_rate));

            $('#VanTransactions_'+i+'_discount_percentage').val(ui.item.discount_percentage);

            $('#VanTransactions_'+i+'_goods_service').val(ui.item.goods_or_service);

            $('#VanTransactions_'+i+'_tax_percentage').val(ui.item.vat_percentage);

            $('#VanTransactions_'+i+'_excise_percentage').val(ui.item.excise_tax_percentage);

            $('#VanTransactions_'+i+'_uom').val(ui.item.uom);

            $('#unit_drop_'+i).text(ui.item.uom_symbol);

            $('#VanTransactions_'+i+'_quantity').focus();

            calculateTotal(this);

        }

    });

}", CClientScript::POS_HEAD);



$cs->registerScript('calculateTotal', 'function calculateTotal(event){

            var grand_total = 0;

            var total_net_amount = 0;

            var total_vat_amount = 0;

            var total_excise_tax = 0;

            var net_amount =0;

            var discount_amount =0;

            var vat_percentage =0 ;

            var excise_percentage =0 ;

            var discount_val= 0;

            var count = 0;

            var vat_amount =0;

            var excise_amount =0;

            var rate =0;

            var quantity =0;

            var amount =0;



            $("#voucher_entries").find("tr:gt(0)").each(function() {

                
                vat_percentage = $(this).find("[id $=tax_percentage]").val().replace(/%/,"");

                rate = Number($(this).find("[id $=_rate]").val());

                quantity =  Number($(this).find("[id $=_quantity]").val());

                discount_val = $(this).find("[id $=_discount_percentage]").val();

                vat_percentage = $(this).find("[id $=tax_percentage]").val().replace(/%/,"");

                excise_percentage = $(this).find("[id $=excise_percentage]").val().replace(/%/,"");

                amount = rate * quantity; 
                
                //Round of Four
                amount = round_off(amount);

                excise_amount =  ( amount * excise_percentage ) / 100;

                excise_amount = round_off(excise_amount);

                amount = amount + excise_amount;
               
                count = discount_val.indexOf("%") > -1 ? 1 : 0;

                if( count > 0 ){

                    discount_val    = discount_val.replace(/%/,"");              

                    discount_amount = ( Number(amount) * Number(discount_val) )/100;

                }else

                    discount_amount = Number(discount_val);

                

                discount_amount = round_off(discount_amount);

                amount -= discount_amount;

                vat_amount = $("#VanVouchers_is_taxable_0").is(":checked") ? ( ( amount * vat_percentage ) / 100 ) : 0;

                vat_amount = round_off(vat_amount);



                net_amount = amount + vat_amount;

                net_amount = round_off(net_amount);

              

                total_vat_amount += vat_amount;

                total_net_amount += amount;

                grand_total += net_amount;

                

                $(this).find("[id $=_discount_value]").val(discount_amount.toFixed(6));

                $(this).find("[id $=_tax_value]").val(vat_amount.toFixed(6));

                $(this).find("[id $=_excise_value]").val(excise_amount.toFixed(6));

                $(this).find("[id $=_net_amount]").val(net_amount.toFixed(6));

                    

            });

            

            $("#voucher_add_table").find("tr").each(function(){

                 grand_total += round_off( Number( $(this).find("[id $=_amount]").val() ) );

            });

            

            $("#voucher_ded_table").find("tr").each(function(){

                grand_total -= round_off( Number( $(this).find("[id $=_amount]").val() ) );

            });



            $(".vat_total").text(round_off_two(total_vat_amount).toFixed(2));

            $(".net_total").text(round_off_two(total_net_amount).toFixed(2));

            $(".grand_total").text(round_off_two(grand_total).toFixed(2));



            if( total_net_amount < 0 ){

                $("#"+event.id).val(0);

                calculateTotal(event);

            }



        }', CClientScript::POS_HEAD);


$cs->registerScript('reverseCalculation', 'function reverseCalculation(event){

            var field_id = event.id;
            var arr_field_id = field_id.split("_");
            var i = arr_field_id[1];
           
            var vatAmount = 0;
            var discAmount = 0;
            var exciseAmount = 0;
            var rate = 0;

            var net_amount = Number(event.value);
            net_amount = round_off(net_amount);
            var amount_after_disc = net_amount;

            //TAX Calculation

            var vat_percentage = $("#VanTransactions_"+i+"_tax_percentage").val();

            if( vat_percentage != "" ){

                var vatPercentage = Number(vat_percentage.replace(/%/,""));
                vatPercentage = round_off(vatPercentage);

                if( vatPercentage > 0 ){
                    
                    amount_after_disc = ( net_amount * 100 ) / ( 100 + vatPercentage );
                    amount_after_disc = round_off(amount_after_disc);
                  
                    vatAmount = ( amount_after_disc * vatPercentage ) / 100;
                    vatAmount = round_off(vatAmount);

                    $("#VanTransactions_"+i+"_tax_value").val(vatAmount.toFixed(6));
                }
            }

            //Discount Calculation

            var discount_val = $("#VanTransactions_"+i+"_discount_percentage").val();
            var amount_before_disc = amount_after_disc;
            
            if( discount_val != "" ){
                
                count = discount_val.indexOf("%") > -1 ? 1 : 0;
                
                //If is percentage
                if( count > 0 ){
                    
                    discount_val    = Number(discount_val.replace(/%/,""));        
                    discount_val = round_off(discount_val);  

                    amount_before_disc = ( amount_after_disc * 100 ) / ( 100 - discount_val );
                    amount_before_disc = round_off(amount_before_disc);

                    discAmount = ( amount_before_disc * Number(discount_val) ) / 100;
                    
                }else{
                    amount_before_disc = amount_after_disc + Number(discount_val);
                    amount_before_disc = round_off(amount_before_disc);

                    discAmount =  amount_before_disc - amount_after_disc;
                }
                
                discAmount = round_off(discAmount);

                $("#VanTransactions_"+i+"_discount_value").val(discAmount.toFixed(6));
            }

            //Excise tax Calculation

            var excise_val = $("#VanTransactions_"+i+"_excise_percentage").val();
            var amount_after_excise = amount_before_disc;
            
            if( excise_val != "" ){
                
                excise_val = Number(excise_val.replace(/%/,""));        
                excise_val = round_off(excise_val);  
                
                if( excise_val > 0 ){
                    amount_after_excise = ( amount_before_disc * 100 ) / ( 100 + excise_val );
                    amount_after_excise = round_off(amount_after_excise);
    
                    exciseAmount = ( amount_after_excise * Number(excise_val) ) / 100;
                    exciseAmount = round_off(exciseAmount);
    
                    $("#VanTransactions_"+i+"_excise_value").val(exciseAmount.toFixed(6));
                }
            }

            //Rate Calculation

            var quantity = Number($("#VanTransactions_"+i+"_quantity").val());
            if( quantity > 0 ){

                quantity = round_off(quantity);

                rate = amount_after_excise / quantity;
                rate = round_off(rate);
            }
            $("#VanTransactions_"+i+"_rate").val(rate.toFixed(6));


            //Bottom total calculation

            var totalVat = 0;
            var netAmount = 0;
            $("#voucher_entries").find("tr:gt(0)").each(function() {
                netAmount += Number($(this).find("[id $=_net_amount]").val());
                totalVat += Number($(this).find("[id $=_tax_value]").val());
            });

            var totalAmount = netAmount - totalVat;

            $(".vat_total").text(round_off_two(totalVat).toFixed(2));
            $(".net_total").text(round_off_two(totalAmount).toFixed(2));
            $(".grand_total").text(round_off_two(netAmount).toFixed(2));

        }', CClientScript::POS_HEAD);

$cs->registerScript("nextline", "function nextline(event)

        {

            if ( event.keyCode == 13  ) {

                event.preventDefault();

                newVoucher($('#voucher_entries'));

                return false;

            }

        }", CClientScript::POS_HEAD);

$cs->registerScript("newVoucher", " function newVoucher(jQtable) {

            formId              =   jQtable.attr('id');

            formIdStarter       =   jQtable.attr('id').split(/_(.+)?/)[0];

            lastId = jQtable.find('tr:last input:first').attr('id');

            thenum = lastId.match(/\d+/g);

            newId = Number(thenum) + 1;

            newrow= jQtable.find('tr:last').clone();

            newrow.find('label:first').html(newId+1);

            newrow.attr('class',newId);

            newrow.find('div,input,textarea,checkbox,td,select,.errorMessage,a').each(function() {

                this.id= this.id.replace(/\d+/,newId);

                if(!$(this).is(':checkbox'))

                    this.value  = '';

                else

                    $(this).prop('checked', false);

                (this.name!==undefined) ? this.name= this.name.replace(/\d+/,newId) : this.style = '';

            });

            jQtable.append(newrow);

            $('#VanTransactions_'+newId+'_ledger_name').focus();

            $('#unit_drop_'+newId).text('');

        }", CClientScript::POS_HEAD);





$cs->registerScript("format_currency", "function format_currency(field_id)

{

    var currency = $('#'+field_id).val().replace(/,/g, '') > 0 ?  $('#'+field_id).val().replace(/,/g, '') : 0;

    var formatted_value = currency > 0 ? parseFloat(currency.replace(/,/g, ''))

    .toFixed(2)

    .toString()

    .replace(/\B(?=(\d{3})+(?!\d))/g, ',') : 0.00;

    $('#'+field_id).val(formatted_value);

}", CClientScript::POS_HEAD);



$cs->registerScript("round_field", "function round_field(field_id)

{

    if( !isNaN( $('#'+field_id).val() )  ){

        var value = Number($('#'+field_id).val());

        value = value >= 0 ? round_off(value) : 0;

        $('#'+field_id).val(value.toFixed(6));

    }

}", CClientScript::POS_HEAD);



$cs->registerScript("check_min_price", "function check_min_price(field_id, value)

{

    var arr_field_id = field_id.split('_');

    var i = arr_field_id[1];

    var min = Number( $('#VanTransactions_'+i+'_min_selling_price').val() );

    if( value < min ){

        t8.warning({

            message:'Minimum sales rate is '+Number(min).toFixed(2), 

            title:'Warning',

            iconClass: 'fa fa-dollar',

        });

    }

}", CClientScript::POS_HEAD);



$cs->registerScript("customer_properties", "function customer_properties(vendor_id)

{

    jQuery.ajax({

        'type': 'post',

        'dataType' : 'json',

        'url': '" . Yii::app()->createUrl('voucher/get_vendor_properties') . "',

        'data' : {'vendor_id' : vendor_id},

            'success': function(data) {

                $('#currency_drop').html(data.currency_drop);

                $('#exchange_rate').val(data.exchange_rate).addClass('filled');

                $('#VanVouchers_payment_terms').val(data.credit_days).addClass('filled');

            }

        });

}", CClientScript::POS_HEAD);



$cs->registerScript("product_properties", "function product_properties(product_id, field_id)

{

    var arr_field_id = field_id.split('_');

    var i = arr_field_id[1];

    

    jQuery.ajax({

        'type': 'post',

        'dataType' : 'json',

        'url': '" . Yii::app()->createUrl('voucher/product_properties') . "',

        'data' : {'product_id' : product_id},

            'success': function(data) {

                $('#VanTransactions_'+i+'_ledger_name').val(data.label);

                $('#VanTransactions_'+i+'_description').val(data.description);

                $('#VanTransactions_'+i+'_ledger_id').val(data.value);

                $('#VanTransactions_'+i+'_rate').val(data.sales_price);

                $('#VanTransactions_'+i+'_min_selling_price').val(data.min_selling_rate);

                $('#VanTransactions_'+i+'_discount_percentage').val(data.discount_percentage);

                $('#VanTransactions_'+i+'_goods_service').val(data.goods_or_service);

                $('#VanTransactions_'+i+'_tax_percentage').val(data.vat_percentage);

                $('#VanTransactions_'+i+'_uom').val(data.uom);

                $('#unit_drop_'+i).text(data.uom_symbol);

                $('#VanTransactions_'+i+'_quantity').focus();

            }

        });

}", CClientScript::POS_HEAD);





?>



<div class="tab-content">

    <div class="tab-pane active">

        <ul class="clearfix form-ul material">

            <li class="col-sm-2">

                <?php echo $form->hiddenField($model, "id"); ?>

                <?php $model->date = $model->isNewRecord ? date('d/m/Y') : date('d/m/Y', strtotime($model->date)) ?>

                <?php echo $form->textField($model, 'date', array('data-label' => 'Invoice Date', 'class' => 'datepicker')); ?>

            </li>

            <li class="col-sm-3">

                <?php echo $form->hiddenField($model, "party_ledger"); ?>

                <?php $model->party_name = $model->partyDetails->name; ?>

                <?php echo $form->textField($model, 'party_name', array('data-label' => 'Customer', 'class' => 'tooltipster', 'onKeypress' => 'js:customers(this.id);')); ?>

            </li>

            <!-- <li class="col-sm-3">

                <?php //echo $form->dropdownlist($model, 'party_ledger', VanLedgers::get_accounts(array('"'.VanLedgers::CUSTOMER.'"')),array('data-label'=>'Customer', 'data-search' => true, 'prompt' => 'Select Customer', 'onChange' => 'customer_properties(this.value);')); 
                ?>

            </li> -->

            <li class="col-sm-2">

                <?php echo $form->textField($model, 'reference_no', array('data-label' => 'LPO No', 'class' => 'tooltipster')); ?>

            </li>

            <li class="col-sm-2">

                <?php echo $form->textField($model, 'payment_terms', array('data-label' => 'Credit Days', 'class' => 'tooltipster')); ?>

            </li>

            <li class="col-sm-2" id="currency_drop">

                <?php echo CHtml::dropdownlist('currency_id', $model->voucher_currency, VanCurrency::all_codes(), array('data-label' => 'Currency', 'onChange' => 'getExchange(this.value);')); ?>

            </li>

            <li class="col-sm-1">

                <?php echo CHtml::textField('exchange_rate', $model->voucher_exchange_rate, array('data-label' => 'Ex. Rate', 'class' => 'tooltipster', 'readonly' => true)); ?>

            </li>

            <li class="col-sm-3">

                <?php echo $form->textArea($model, 'billing_address', array('data-label' => 'Billing Address', 'class' => 'tooltipster')); ?>

            </li>

            <li class="col-sm-3">

                <?php echo $form->textArea($model, 'other_references', array('data-label' => 'Notes', 'class' => 'tooltipster')); ?>

            </li>

            <li class="col-sm-2">

                <?php $model->is_taxable = $model->isNewRecord ? 'Y' : $model->is_taxable ?>

                <?php echo $form->checkBoxList($model, 'is_taxable', array('Y' => 'Taxable'), array('title' => 'View', 'onChange' => 'calculateTotal(this);')); ?>

            </li>

            <?php if ($model->isNewRecord) : ?>

                <li class="col-sm-2">

                    <?php echo $form->checkBoxList($model, 'is_paid', array('Y' => 'Cash Received'), array('title' => 'View')); ?>

                </li>

                <li class="col-sm-2">

                    <?php echo $form->checkBoxList($model, 'printable', array('Y' => 'Print Voucher'), array('title' => 'View')); ?>

                </li>

            <?php endif; ?>

        </ul>

        <table class="table table-bordered" id="voucher_entries">

            <thead>

                <tr>

                    <th style="width:1%">#</th>

                    <th style="width:10%">Part no</th>

                    <th style="width:20%">Description</th>

                    <th style="width:6%">Quantity</th>

                    <th style="width:5%">UOM</th>

                    <th style="width:6%">Rate</th>

                    <th style="width:12%">Excise Tax</th>

                    <th style="width:12%">Discount</th>

                    <th style="width:12%">VAT</th>

                    <th style="width:10%">Net</th>

                    <th style="width:1%" class="text-center"><a class="btn btn-xs btn-theme " href="javascript:void(0);" onclick="newVoucher($('#voucher_entries'));"><i class="fa fa-plus"></i></a></th>

                </tr>

            </thead>

            <tbody>

                <?php foreach ((!$model->isNewrecord) ? $model->items : array(new VanTransactions) as $i => $each) : ?>

                    <tr>

                        <td><label><?php echo $i + 1; ?></label></td>

                        <td>

                            <?php echo $form->hiddenField($each, "[" . $i . "]id"); ?>

                            <?php echo $form->hiddenField($each, "[" . $i . "]ledger_id"); ?>

                            <?php $each->goods_service = $each->ledger->goods_or_service; ?>

                            <?php echo $form->hiddenField($each, "[" . $i . "]goods_service"); ?>

                            <?php $each->ledger_name = $each->ledger->name; ?>

                            <?php echo $form->textField($each, "[" . $i . "]ledger_name", array('class' => 'form-control', 'onKeypress' => 'js:getLedgers(this.id);')); ?>

                            <?php //echo $form->dropdownlist($each, "[".$i."]ledger_id", VanLedgers::get_inventory(), array('class' => 'form-control', 'onChange' => 'js:product_properties(this.value, this.id);', 'prompt' => '-select-')); 
                            ?>

                        </td>

                        <td>

                            <?php echo $form->textField($each, "[" . $i . "]description", array('class' => 'form-control')); ?>

                        </td>

                        <td>

                            <?php $each->quantity = abs($each->quantity); ?>

                            <?php echo $form->textField($each, "[" . $i . "]quantity", array('class' => 'go txt-10 text-right', 'onkeypress' => 'return isNumberKey(event)', 'onBlur' => 'round_field(this.id)', 'onKeyup' => 'calculateTotal(this);', 'onKeydown' => 'nextline(event);')); ?>

                            <?php echo $form->hiddenField($each, "[" . $i . "]uom"); ?>

                        </td>

                        <td id="unit_drop_<?php echo $i; ?>">

                            <?php echo $each->unitDetails->symbol; ?>

                        </td>

                        <td>

                            <?php $each->min_selling_price = (float) $each->ledger->min_sales_price; ?>

                            <?php echo $form->hiddenField($each, "[" . $i . "]min_selling_price"); ?>

                            <?php echo $form->textField($each, "[" . $i . "]rate", array('class' => 'go txt-10 text-right', 'onkeypress' => 'return isNumberKey(event)', 'onKeyup' => 'check_min_price(this.id, this.value); calculateTotal(this);', 'onBlur' => 'round_field(this.id)', 'onKeydown' => 'nextline(event);')); ?>

                        </td>

                        <td class="nw">

                            <?php echo $form->textField($each, "[" . $i . "]excise_percentage", array('class' => 'go txt-6 text-right', 'readonly' => true, 'tabindex' => '-1')); ?>

                            <?php echo $form->textField($each, "[" . $i . "]excise_value", array('class' => 'go txt-6 text-right', 'readonly' => true, 'tabindex' => '-1')); ?>

                        </td>

                        <td class="nw">

                            <?php echo $form->textField($each, "[" . $i . "]discount_percentage", array('class' => 'go txt-6 text-right', 'onkeypress' => 'return isNumberKey(event)', 'onKeyup' => 'calculateTotal(this);', 'onBlur' => 'round_field(this.id)', 'onKeydown' => 'nextline(event);')); ?>

                            <?php echo $form->textField($each, "[" . $i . "]discount_value", array('class' => 'go txt-6 text-right', 'readonly' => true, 'tabindex' => '-1')); ?>

                        </td>

                        <td class="nw">

                            <?php echo $form->textField($each, "[" . $i . "]tax_percentage", array('class' => 'go txt-6 text-right', 'readonly' => true, 'tabindex' => '-1')); ?>

                            <?php echo $form->textField($each, "[" . $i . "]tax_value", array('class' => 'go txt-6 text-right', 'readonly' => true, 'tabindex' => '-1')); ?>

                        </td>

                        <td>

                            <?php echo $form->textField($each, "[" . $i . "]net_amount", array('class' => 'go txt-10 text-right', 'onkeypress' => 'return isNumberKey(event)', 'onKeyup' => 'reverseCalculation(this);', 'onBlur' => 'round_field(this.id)')); ?>

                        </td>

                        <td class="text-center nw" width="1%"><?php echo CHtml::link('<i class="fa fa-times"></i>', 'javascript:void(0);', array('tabindex' => '-1', 'class' => 'btn btn-xs btn-danger', 'onclick' => 'removeTableRow($(\'#voucher_entries\'),this)', 'title' => 'Remove this item')); ?></td>

                    </tr>

                <?php endforeach; ?>

            </tbody>

        </table>

        <table class="table table-hover table-bordered table-nexted quotes_total">

            <tr class="bg-total">

                <td width="70%" class="text-right table_total_title">

                    <h2>Net Total</h2>

                </td>

                <td width="30%" class="text-right table_total ">

                    <h2 class="text-right net_total"><?php echo Yii::app()->numberFormatter->formatCurrency($total, " "); ?></h2>

                </td>

            </tr>

        </table>

        <table class="table table-hover table-bordered table-nexted quotes_total">

            <tr class="bg-total">

                <td width="70%" class="text-right table_total_title">

                    <h2>Net VAT</h2>

                </td>

                <td width="30%" class="text-right table_total ">

                    <h2 class="text-right vat_total"><?php echo Yii::app()->numberFormatter->formatCurrency($total, " "); ?></h2>

                </td>

            </tr>

        </table>


        <table class="table table-hover table-bordered table-nexted quotes_total">

            <tr class="bg-total">

                <td width="70%" class="text-right table_total_title">

                    <h2>Grand Total</h2>

                </td>

                <td width="30%" class="text-right table_total ">

                    <h2 class="text-right grand_total"><?php echo Yii::app()->numberFormatter->formatCurrency($total, " "); ?></h2>

                </td>

            </tr>

        </table>

    </div>

</div>

<div class="modal-footer">

    <button type="button" class="btn btn-danger" id="cust_close" data-dismiss="modal">Close</button>

    <?php



    echo CHtml::ajaxSubmitButton('Save', Yii::app()->createUrl('voucher/savesales'), array(

        'dataType' => 'json',

        'type' => 'post',

        'success' => 'function(data) {

            $("#loader").hide();

            if(data.status=="success"){

                t8.success("Done!");

                if( data.load_new )

                    loadPopupModal("voucher/create&type=sales","New Sales","xl");

                else

                    $(".x.close").click();

                    reloadTable("#tbl_sales");

                    reloadTable("#tbl_receipts");

                if( data.generate_print )

                    window.open("index.php?r=voucher/print&id="+data.id);

                }else{

                    $.each(data, function(key, val) {

                        t8.error(""+val+"");

                    });

                }

            }',

        'beforeSend' => 'function(){

                $("#loader").show();

            }',

    ), array('id' => 'mybtn' . rand(), 'class' => 'voucher-submit btn btn-theme'));



    ?>

</div>

<?php $this->endWidget(); ?>



<script>
    $(function() {

        lastId = $('#voucher_entries').find('tr:last input:first').attr('id');

        thenum = lastId.match(/\d+/g);

        setTimeout(function() {

            $('#VanTransactions_' + thenum + '_ledger_name').focus();

            calculateTotal(this);

        }, 1000);

    });

    function round_off(num) {

        return +(Math.round(num + "e+6") + "e-6");

    }

    function round_off_two(num) {

        return +(Math.round(num + "e+2") + "e-2");

    }
</script>