<?php

$cs = Yii::app()->getClientScript();

$cs->registerScript("cancel_voucher", "function cancel_voucher(id){

    var r = confirm('Are you sure to cancel the voucher? This cant be reverted!!');

    if(r==true)

        jQuery.ajax({

            'type'  : 'post',

            'data'  : {'id' : id},

            'url'  : $('#liveSite').val()+'index.php?r=voucher/cancelvoucher',

            'cache': false,

            'success':function(data){

                if(data=='success'){

                    t8.success('Done!');

                    reloadTable('#tbl_allocation');

                    reloadTable('#tbl_issues');

                    reloadTable('#tbl_transfer');

                    reloadTable('#tbl_conversion');

                }else{

                    t8.error(data);

                }

            }

        });

};", CClientScript::POS_HEAD);



$cs->registerScript("load", '
        $(document).ready(function() {
            $("#tbl_allocation").on("preXhr.dt", function (e, settings, data) {
                data.from = $("#allocation_from").val();
                data.to = $("#allocation_to").val();
                return data;
            }).DataTable({
                "sScrollY": "auto",
                pageLength      : 50,
                columns: [
                    {className: "nw sl col-max-1"},
                    {className: "nw sl col-max-1"},
                    {className: "nw sl col-max-5"},
                    {className: "nw sl col-max-1"},
                ],
                "oLanguage": {
                    "sSearch": "Voucher No:"
                },
                ajax: {
                    url: "' . Yii::app()->createUrl('voucher/get_discount_allocation_list') . '",
                    type: "POST",
                    cache : false,
                },
                serverSide:     true,
                fixedColumns:   true,
                processing: true,
                order: [[ 1, "DESC" ]],
            });

    });', CClientScript::POS_HEAD);

?>


<div class="tab-content">
    <!--Allocation section start-->
    <div class="tab-pane active">
        <section class="panel">
            <header class="panel-heading clearfix">
                Discount vouchers
                <div class="pull-right" style="display:inline-flex">
                    <input type="text" name="allocation_from" id="allocation_from" class="datepicker form-control" value="<?php echo date('01/m/Y') ?>">&NonBreakingSpace;<input type="text" name="allocation_to" id="allocation_to" class="datepicker form-control" value="<?php echo date('d/m/Y') ?>">&NonBreakingSpace;<button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_allocation');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>
            <div class="panel-body">
                <div class="custom-data-table">
                    <table class="table table-hover table-bordered personal-task" id="tbl_allocation">
                        <thead>
                            <tr>
                                <th>Voucher No</th>
                                <th>Date</th>
                                <th>Remarks</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </section>

    </div>

    <!--Allocation end-->
</div>

