<?php

$cs = Yii::app()->getClientScript();

$cs->registerScript("cancel_voucher", "function cancel_voucher(id){

    var r = confirm('Are you sure to cancel the voucher? This cant be reverted!!');

    if(r==true)

        jQuery.ajax({

            'type'  : 'post',

            'data'  : {'id' : id},

            'url'  : $('#liveSite').val()+'index.php?r=voucher/cancelvoucher',

            'cache': false,

            'success':function(data){

                if(data=='success'){

                    t8.success('Done!');

                    reloadTable('#tbl_journal');

                    reloadTable('#tbl_receipts');

                    reloadTable('#tbl_payments');

                    reloadTable('#tbl_purchase');

                    reloadTable('#tbl_sales');

                    reloadTable('#tbl_purchase_rtn');

                    reloadTable('#tbl_sales_rtn');

                }else{

                    t8.error(data);

                }

            }

        });

};", CClientScript::POS_HEAD);

$cs->registerScript("remove_allocation", "function remove_allocation(id){

    var r = confirm('Do you want to remove allocation!!');

    if(r==true)

        jQuery.ajax({

            'type'  : 'post',

            'data'  : {'id' : id},

            'url'  : $('#liveSite').val()+'index.php?r=voucher/removeallocation',

            'cache': false,

            'success':function(data){

                if(data=='success'){

                    t8.success('Done!');

                    reloadTable('#tbl_journal');

                    reloadTable('#tbl_receipts');

                    reloadTable('#tbl_payments');

                    reloadTable('#tbl_purchase');

                    reloadTable('#tbl_sales');

                    reloadTable('#tbl_purchase_rtn');

                    reloadTable('#tbl_sales_rtn');

                }else{

                    t8.error(data);

                }

            }

        });

};", CClientScript::POS_HEAD);



$cs->registerScript("load", '

        $(document).ready(function() {



            $("#tbl_payments").on("preXhr.dt", function (e, settings, data) {

                data.type = "payments";
                data.from = $("#payment_from").val();
                data.to = $("#payment_to").val();

                return data;

            }).DataTable({

                "sScrollY": "auto",

                pageLength      : 50,

                columns: [

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-3"},

                    {className: "nw sl col-max-1 text-right"},

                    {className: "nw sl col-max-1"},

                ],

                "oLanguage": {

                    "sSearch": "Voucher No:"

                },

                ajax: {

                    url: "' . Yii::app()->createUrl('voucher/getvouchers') . '",

                    type: "POST",

                    cache : false,

                },

                serverSide:     true,

                fixedColumns:   true,

                processing: true,

                order: [[ 1, "DESC" ]],

            });



            $("#tbl_purchase").on("preXhr.dt", function (e, settings, data) {

                data.type = "purchase";
                data.from = $("#purchase_from").val();
                data.to = $("#purchase_to").val();

                return data;

            }).DataTable({

                "sScrollY": "auto",

                pageLength      : 50,

                columns: [

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-5"},

                    {className: "nw sl col-max-1 text-right"},

                    {className: "nw sl col-max-1 text-right"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                ],

                ajax: {

                    url: "' . Yii::app()->createUrl('voucher/getvouchers') . '",

                    type: "POST",

                    cache : false,

                },

                "oLanguage": {

                    "sSearch": "Voucher No:"

                },

                serverSide:     true,

                fixedColumns:   true,

                processing: true,

                order: [[ 1, "DESC" ]],

            });



            $("#tbl_purchase_rtn").on("preXhr.dt", function (e, settings, data) {

                data.type = "debitnote";
                data.from = $("#purchase_rtn_from").val();
                data.to = $("#purchase_rtn_to").val();

                return data;

            }).DataTable({

                "sScrollY": "auto",

                pageLength      : 50,

                columns: [

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-1"},

                    {className: "nw sl col-max-5"},

                    {className: "nw sl col-max-1 text-right"},

                    {className: "nw sl col-max-1 text-right"},

                    {className: "nw sl col-max-1"},

                ],

                ajax: {

                    url: "' . Yii::app()->createUrl('voucher/getvouchers') . '",

                    type: "POST",

                    cache : false,

                },

                "oLanguage": {

                    "sSearch": "Voucher No:"

                },

                serverSide:     true,

                fixedColumns:   true,

                processing: true,

                order: [[ 1, "DESC" ]],

            });





    });', CClientScript::POS_HEAD);

?>



<!--ul start-->

<ul class="nav nav-tabs company-nav-tabs nav-tab-theme">

    <?php if( Yii::app()->user->user_access_type == 'CA' ): ?>

        <li class="active" onclick="reloadTable('#tbl_purchase')"><a href="#purchase_sec" data-toggle="tab"> <i class="fa fa-cogs"></i> Purchase</a></li>

        <li onclick="reloadTable('#tbl_purchase_rtn')"><a href="#purchase_rtn_sec" data-toggle="tab"> <i class="fa fa-cogs"></i> Returns</a></li>

    <?php endif; ?>

    <li <?php echo Yii::app()->user->user_access_type == 'SL' ? 'class="active"' : '' ?> onclick="reloadTable('#tbl_payments')"><a href="#payments_sec" data-toggle="tab"> <i class="fa fa-cogs"></i> Payments</a></li>



</ul>

<!--ul end-->





<div class="tab-content">



    <!--payments section start-->

    <div class="tab-pane <?php echo Yii::app()->user->user_access_type == 'SL' ? 'active' : '' ?>" id="payments_sec">

        <section class="panel">
            <header class="panel-heading clearfix">
                <div class="pull-right" style="display:inline-flex">
                    <input type="text" name="payment_from" id="payment_from" class="datepicker form-control" value="<?php echo date('01/m/Y') ?>">&NonBreakingSpace;<input type="text" name="payment_to" id="payment_to" class="datepicker form-control" value="<?php echo date('d/m/Y') ?>">&NonBreakingSpace;<button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_payments');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>
            <div class="panel-body">

                <div class="custom-data-table">

                    <table class="table table-hover table-bordered personal-task" id="tbl_payments">

                        <thead>

                            <tr>

                                <th>Voucher No</th>

                                <th>Date</th>

                                <th>Particulars</th>

                                <th>Value</th>

                                <th>Actions</th>

                            </tr>

                        </thead>

                    </table>

                </div>

            </div>

        </section>

    </div>

    <!--payments end-->



    <!--purchase section start-->

    <div class="tab-pane <?php echo Yii::app()->user->user_access_type == 'CA' ? 'active' : '' ?>" id="purchase_sec">

        <section class="panel">
            <header class="panel-heading clearfix">
                <div class="pull-right" style="display:inline-flex">
                    <input type="text" name="purchase_from" id="purchase_from" class="datepicker form-control" value="<?php echo date('01/m/Y') ?>">&NonBreakingSpace;<input type="text" name="purchase_to" id="purchase_to" class="datepicker form-control" value="<?php echo date('d/m/Y') ?>">&NonBreakingSpace;<button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_purchase');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>
            <div class="panel-body">

                <div class="custom-data-table">

                    <table class="table table-hover table-bordered personal-task" id="tbl_purchase">

                        <thead>

                            <tr>

                                <th>Voucher No</th>

                                <th>Date</th>

                                <th>Inv.No</th>

                                <th>Vendor</th>

                                <th>VAT</th>

                                <th>Grand Total</th>

                                <th>Status</th>

                                <th>Actions</th>

                            </tr>

                        </thead>

                    </table>

                </div>

            </div>

        </section>

    </div>

    <!--purchase end-->



    <!--purchase rtn section start-->

    <div class="tab-pane" id="purchase_rtn_sec">

        <section class="panel">
            <header class="panel-heading clearfix">
                <div class="pull-right" style="display:inline-flex">
                    <input type="text" name="purchase_rtn_from" id="purchase_rtn_from" class="datepicker form-control" value="<?php echo date('01/m/Y') ?>">&NonBreakingSpace;<input type="text" name="purchase_rtn_to" id="purchase_rtn_to" class="datepicker form-control" value="<?php echo date('d/m/Y') ?>">&NonBreakingSpace;<button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_purchase_rtn');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>
            <div class="panel-body">

                <div class="custom-data-table">

                    <table class="table table-hover table-bordered personal-task" id="tbl_purchase_rtn">

                        <thead>

                            <tr>

                                <th>Voucher No</th>

                                <th>Date</th>

                                <th>Inv.No</th>

                                <th>Vendor</th>

                                <th>VAT</th>

                                <th>Grand Total</th>

                                <th>Actions</th>

                            </tr>

                        </thead>

                    </table>

                </div>

            </div>

        </section>

    </div>

    <!--purchase end-->



</div>

