<?php
    $cs = Yii::app()->getClientScript();
    $baseUrl = Yii::app()->baseUrl;
    $cs->registerScript("loaddata",
    '$(document).ready(function() {
        var table = $("#order_collect_table").on("preXhr.dt", function (e, settings, data) {
            data.salesman = $("#search_salesman_id").val();
            data.date = $("#search_order_date").val();
            data.from = $("#search_order_date_from").val();
            data.to = $("#search_order_date_to").val();
            return data;
        }).DataTable({
            scrollY         : "380px",
            // scrollX         : "true",
            // scrollCollapse  : true,
            pageLength      : 50,
            processing: true,
    		"columnDefs": [
                        {
                        }
            ],
            "rowCallback": function ( row, data ){
            },
            ajax: {
                url: "' . Yii::app()->createUrl('ordercollect/GetList') . '",
                type: "POST",
                cache : false,
            },
            serverSide:     true,
            fixedColumns:   true,
            processing: true,
            fixedHeader: {
                headerOffset: $("header.main").outerHeight()
            }
        });
        $(".dataTables_scrollFoot").hide();
    });', CClientScript::POS_HEAD);
    
    $cs->registerScript("cancelorder", "function cancelorder(order_id) {
    r =confirm('This Process Cannot be undo.Are You sure to cancel this?');
    if (r == true) {
                jQuery.ajax({
                    'dataType':'json',
                    'data' :{'id':order_id},
                    'type':'post',
                    'url': '" . Yii::app()->createUrl('ordercollect/CancelOrder') . "',
                    'cache': false,
                    'success': function(data) {
                        if(data.status=='success'){
                            t8.success('Order Cancelled!');  
                            reloadTable('#order_collect_table'); 
                        }
                            else if(data.status=='error'){
                            t8.error(data.error_note);  
                        }    
                    else{
                            t8.error('Order Cannot Be Cancelled'); 
                        }
                    }, 
                    'beforeSend':function(){
                        $('#loader').show();
                    },
                    'complete':function(){
                        $('#loader').hide();   
                    }
                });     
    }
        
};", CClientScript::POS_HEAD);
    $cs->registerScript("getPDFPrint","function getPDFPrint(frm) {
        var order_date = $('#search_order_date').val();
        var from = $('#search_order_date_from').val();
        var to = $('#search_order_date_to').val();
        var salesman_id = $('#search_salesman_id').val();
        if(frm=='date' && order_date==''){
            alert('Please select a date');
            return false;
        }
        window.open($('#liveSite').val()+'index.php?r=ordercollect/printordercollectpdf&frm='+frm+'&salesman_id='+salesman_id+'&order_date='+order_date+'&to='+to+'&from='+from,'_blank');
    }", CClientScript::POS_HEAD);
?>    
<section class="panel">
    <header class="panel-heading clearfix panel-theame">
        <div class="pull-left"><i class="fa  fa-balance-scale"></i> Order</div>
        <?php 
        if(Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SL' || Yii::app()->user->user_access_type == 'OM' || Yii::app()->user->user_access_type == 'SM')
         {
         ?>
        <div class="pull-right">
            <button class="btn btn-sm btn-theme" onclick="loadPopupModal('ordercollect/create&type=create','Add Order','xl')"><i class="fa fa-plus"></i> ADD</button>
        </div>
        <?php } ?>
        <div class="pull-right">
            <button class="btn btn-sm btn-theme" onclick="getPDFPrint('date');"> Datewise PDF</button>&nbsp;
        </div>
        <div class="pull-right">
            <button class="btn btn-sm btn-theme" onclick="getPDFPrint('salesman');"> Salesman PDF</button>&nbsp;
        </div> 
        <div class="pull-right">
           <?php 
            if(Yii::app()->user->user_access_type == 'DEV' || Yii::app()->user->user_access_type == 'SU'|| Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SM' || Yii::app()->user->user_access_type == 'OM')
            {
            $uarray=array('class'=>'form-control','data-label'=>'Salesman','empty'=>'-Salesman--',  'onchange' => 'reloadTable("#order_collect_table");');
            }
            else if( Yii::app()->user->user_access_type == 'SL')
            {
            $uarray=array('class'=>'form-control','data-label'=>'Salesman',  'onchange' => 'reloadTable("#order_collect_table");');
            }
            $outlet=(int) Yii::app()->user->outlet_id;
            echo CHtml::dropdownlist('search_salesman_id','',MasUsers::get_outlet_salesandadmin($outlet), $uarray); ?> &nbsp;
        </div>
       
        <div class="pull-right">
            <?php echo CHtml::textField('search_order_date_to', date('d/m/Y'),array('class'=>'datepicker go form-control','title'=>'Order Date','data-label'=>'Order Date')); ?>
        </div> 
         <div class="pull-right">
            <?php //echo CHtml::textField('search_order_date', date('d/m/Y'),array('class'=>'datepicker go form-control','title'=>'Order Date','data-label'=>'Order Date')); ?>
            <?php echo CHtml::textField('search_order_date_from', date('d/m/Y'),array('class'=>'datepicker go form-control','title'=>'Order Date','data-label'=>'Order Date')); ?>
        </div> 
        <script>
            $('#search_order_date').on('dp.change', function(e){ 
                 reloadTable("#order_collect_table");
            });
            $('#search_order_date_from').on('dp.change', function(e){ 
                 reloadTable("#order_collect_table");
            });
            $('#search_order_date_to').on('dp.change', function(e){ 
                 reloadTable("#order_collect_table");
            });
        </script>
    </header>
    <div class="panel-body">
        <div class="custom-data-table">
            <table class="table table-hover table-bordered personal-task" id="order_collect_table">
                <thead>
                    <tr>
                        <th>Order No</th>
                        <th>Customer</th>
                        <th>Date</th>
                        <th>Salesman</th>
                        <th>Actions</th>
                    </tr>
                </thead>
                <tfoot>
                    <tr>
                        <th>Order No</th>
                        <th>Customer</th>
                        <th>Date</th>
                        <th>Salesman</th>
                        <th>Actions</th>
                    </tr>
                </tfoot>
            </table>
        </div>
    </div>
</section>