<!DOCTYPE html>
<html>
    <head>
        <title>Purchase Return</title>
    </head>
    <body>
        <?php
        $model = PurchaseReturn::model()->findByPk($id);
        $modelItems = PurchaseReturnItems::model()->findAll(array('condition' => 'return_id=' . $id,'order'=>'id ASC'));
        $userModel = MasUsers ::model()->findByPk((int) Yii::app()->user->id);
        ?>
        <div class="">
            <div class="col-12">
                <div class="text-center">
                    <img src="<?php echo 'images/' . $userModel->companyDetails->pdf_logo; ?>" class="logo">
                </div>
                <div class="text-center">
                    <b><?php echo $model->pr_outlet->name; ?></b><br>
                    <small><?php echo nl2br($model->pr_outlet->address); ?></small><br>
                    <small><?php echo $model->pr_outlet->phone_no; ?></small>
                </div>
            </div>
            <div class="col-12">
                <br>
                <div class="text-center">
                    <div class="h3" style="margin-top: 0;margin-bottom: 0;"><?php echo $model->tax_total > 0 ? ' فاتورة ضريبية <br>TAX Purchase Return' : 'Purchase Return' ?></div>
                </div>
            </div>
            <div class="col-6">
                <br>
                <b><?php echo strtoupper($model->pr_vendor->vendor_name); ?></b><br>
                <small><?php echo nl2br($model->pr_vendor->address); ?></small><br><br>
                <?php if ($model->tax_total > 0) : ?>
                    <small><b>TRN :</b> <?php echo $model->pr_vendor->trn_no;  ?></small>
                <?php endif; ?>
            </div>
            <div class="col-5 offset-1" style="color:#101010;">
                <br>
                <table class="table" style="width:100%">
                    <tr>
                        <td>Return No</td>
                        <td><?php echo $model->return_no ?></td>
                    </tr>
                    <tr>
                        <td>Invoice No</td>
                        <td><?php echo $model->pr_invoice->invoice_no ?></td>
                    </tr>
                    <tr>
                        <td>Return Date</td>
                        <td>
                            <?php echo date('d/m/Y', STRTOTIME($model->return_date)); ?>
                        </td>
                    </tr>
                    <tr>
                        <td>Reference No</td>
                        <td>
                            <?php echo $model->reference_no; ?>
                        </td>
                    </tr>
                    <?php if ($model->tax_total > 0) : ?>
                        <tr>
                            <td>Our TRN</td>
                            <td><?php echo $model->pr_outlet->trn_no ?></td>
                        </tr>
                    <?php endif; ?>
                    <tr>
                        <td>Outlet</td>
                        <td><?php echo $model->pr_outlet->name; ?></td>
                    </tr>
                    <tr>
                        <td>Salesman/Phone</td>
                        <td><?php echo nl2br($model->pr_user->full_name . '/<br>' . $model->pr_user->phone_no); ?></td>
                    </tr>
                </table>
            </div>
        </div>
        <br>
        <div class="col-md-12">
            <table class="table">
                <thead>
                    <tr>
                        <th style="width:4%">#</th>
                        <th style="width:15%">المنتج<br>Part No.</th>
                        <th style="width:30%">تفاصيل<br>Description</th>
                        <th style="width:9%">كمية<br>Qty</th>
                        <th style="width:8%">UOM</th>
                        <th style="width:9%">معدل<br>Rate</th>
                        <?php if ($model->excise_total > 0) : ?>
                            <th style="width:5%">Excise(%)</th>
                        <?php endif; ?>
                        <?php if ($model->tax_total > 0) : ?>
                            <th style="width:5%">VAT</th>
                        <?php endif; ?>
                        <th style="width:14%">الإجمالي<br>Amount</th>
                </thead>
                <tbody>
                    <?php
                    foreach ($modelItems as $i => $eachItem) {
                        ?>
                        <tr>
                            <td><?php echo $i + 1; ?></td>
                            <td>
                                <?php echo $eachItem->pr_product->part_number; ?>
                            </td>
                            <td><?php echo nl2br($eachItem->description); ?></td>
                            <td><?php echo abs($eachItem->returned_quantity); ?></td>
                            <td style="text-align:center;"><?php echo $eachItem->pr_units->label; ?></td>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($eachItem->rate, " "); ?></td>
                            <?php if ($model->excise_total > 0) : ?>
                                <td class="text-right"><?php echo $eachItem->excise_percentage; ?></td>
                            <?php endif; ?>
                            <?php if ($model->tax_total > 0) : ?>
                                <td class="text-right"><?php echo $eachItem->tax_percentage; ?></td>
                            <?php endif; ?>
                            <td class="text-right"><?php echo Yii::app()->numberFormatter->formatCurrency($eachItem->net_amount, " "); ?></td>
                        </tr>
                        <?php
                    }

                    $rowSpan = 6;
                    if ($model->excise_total > 0)
                        $rowSpan++;
                    if ($model->tax_total>0)
                        $rowSpan++;
                    ?>
                    <tr>
                        <td class="text-right" colspan="<?php echo $rowSpan; ?>"><b>Total (Ex. VAT)/ الإجمالي</b></td>
                        <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->total_amount, " "); ?></b></td>
                    </tr>
                    <?php if ($model->excise_total > 0) : ?>
                        <tr>
                            <td class="text-right" colspan="<?php echo $rowSpan; ?>"><b>Excise Tax/ الضريبة</b></td>
                            <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->excise_total, " "); ?></b></td>
                        </tr>
                    <?php endif; ?>
                    <?php if ($model->tax_total > 0) : ?>
                        <tr>
                            <td class="text-right" colspan="<?php echo $rowSpan; ?>"><b>VAT/ ضريبة القيمة المضافة </b></td>
                            <td class="text-right"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->tax_total, " "); ?></b></td>
                        </tr>
                    <?php endif; ?>
                    <tr>
                        <td class="text-right total bc-bl" colspan="<?php echo $rowSpan; ?>"><b>Grand Total/ الإجمالي</b></td>
                        <td class="text-right total bc-br"><b><?php echo Yii::app()->numberFormatter->formatCurrency($model->grand_total, " "); ?></b></td>
                    </tr>
                    <tr>
                        <td class="text-right" colspan="<?php echo $rowSpan + 1; ?>"><b><?php //$model->currency . " " .
                        echo  ucfirst($this->widget('ext.NumtoWord.NumtoWord', array('num' => floatval($model->grand_total)))->result) . ' only'; ?></b></td>
                    </tr>
                </tbody>
            </table>

            <br><br>
            <div style="position:relative;width:100%;">
                <div style="float:left; width: 40%;text-align: center;">
                    _______________________________________ <br>
                    <span style="text-align: center;"><small>Received By / Signature</small></span>
                </div>
                <div style="width: 20%;"></div>
                <div style="width: 40%;float: right;text-align: center;">
                    _______________________________________ <br>
                    <span style="text-align: center;"><small>Authorized signatory</small></span>
                </div>
            </div>
            <br>

        </div>
        <br />


    <htmlpagefooter name="myfooter">
        <div style="text-align:center;width:100%;font-size:10px">
        </div>
        <div style="border-top: 1px dotted #000000; font-size: 12px; text-align: center; background-color: #ffffff">
            <div class="col-12">
                 <div class="col-6">
                    <p style="text-align:left;font-size:10px;padding-left:17px;">
                        Generated by : <?php echo $userModel->full_name; ?>
                        <?php
                        date_default_timezone_set("Asia/Dubai");
                        echo ' On '.date('d-m-Y h:i a');
                        ?>
                    </p>
                </div>
                <div class="col-6">
                    <p style="text-align:right;font-size:10px;padding-right:17px;">
                        Created by : <?php echo $model->pr_user->full_name; ?>
                        <?php
                        date_default_timezone_set("Asia/Dubai");
                        echo ' On '.date('d-m-Y h:i a', strtotime($model->created_time))
                        ?>
                    </p>
                </div>
            </div>
            <div style="text-align:center;width:100%;padding-top:-22px;">
                <p style="text-align:center;font-size:9.5px">Page {PAGENO} of {nb}</p>
            </div>
        </div>
    </htmlpagefooter>
</body>

</html>