<div class="row">
    <div class="col-sm-12">
        <section class="panel">
            <header class="text-center panel-heading clearfix">
                <h4><b>Target Report</b></h4>
            </header>
            <header class="panel-heading clearfix">
                <div class="table-responsive">

                    <table class="table table-hover table-striped table-bordered ">
                        <thead>
                            <th>User Name</th>
                            <th>Target Amount</th>
                        </thead>
                        <tbody>
                            <?php

                            $user_list = MasUsers::model()->findAll(array(
                                'condition' => 'access_type NOT IN ("DEV", "SU") AND company_id=:company_id AND (:outlet_id = 0 OR outlet_id =:outlet_id)',
                                'params' => array(':company_id' => Yii::app()->user->company_id, ':outlet_id' => (int)Yii::app()->user->outlet_id),
                            ));

                            if (!empty($user_list)) {
                                foreach ($user_list as $list) {
                            ?>
                                    <tr>
                                        <td>
                                            <?php echo CHtml::hiddenField('user_id', $list['id'], array('class' => 'tooltipster')); ?>
                                            <?php echo CHtml::textField('user_name', $list['full_name'], array('class' => 'tooltipster', 'readonly' => 'true')); ?></td>
                                        <td><?php echo CHtml::textField('target_amount', '', array('class' => 'tooltipster', 'onkeypress' => 'return isNumberKey(event)',)); ?></td>
                                    </tr>
                            <?php

                                }
                            } ?>
                        </tbody>
                    </table>
                </div>


                <ul class="clearfix form-ul material">
                    <li class="col-sm-3">
                    </li>
                    <li class="col-sm-2">
                        <?php echo CHtml::textField('target_by_date', date('d/m/Y'), array('class' => 'datepicker tooltipster', 'data-label' => 'TARGET BY')); ?>
                    </li>
                    <li class="col-sm-2">
                        <?php echo CHtml::textField('no_of_working_days', '', array('class' => 'tooltipster', 'onkeypress' => 'return isNumberKey(event)', 'data-label' => 'NO. OF WORKING DAYS')); ?>
                    </li>
                    <li class="col-sm-2">
                        <?php echo CHtml::textField('days_passed', '', array('class' => 'tooltipster', 'onkeypress' => 'return isNumberKey(event)', 'data-label' => 'DAYS PASSED')); ?>
                    </li>

                    <li class="col-sm-2">
                        <br>
                        <a type="button" class="btn btn-sm btn-theme" id="viewButton">VIEW</a>
                        <!-- <a type="button" class="btn btn-sm btn-theme" id="PdfviewButton">PDF</a> -->

                    </li>
                </ul>

            </header>
            <div class="panel-body" id="data_div" style="display:none;">
                <div class="tab-content">
                    <div class="tab-pane main-li-data active" id="gl_tab">
                    </div>
                </div>
            </div>
        </section>
    </div>
</div>

<script>
    $(document).ready(function() {

        var dataToSend = []; // Declare dataToSend as a global variable

        $('#viewButton').click(function() {
            // Collecting the user IDs and target amounts for the HTML report
            dataToSend = []; // Clear the array before populating new data
            $('tbody tr').each(function() {
                var userId = $(this).find('[name="user_id"]').val();
                var targetAmount = $(this).find('[name="target_amount"]').val();
                dataToSend.push({
                    'userId': userId,
                    'targetAmount': targetAmount
                });
            });

            var no_of_working_days = parseFloat($('#no_of_working_days').val());
            var days_passed = parseFloat($('#days_passed').val());

            var target_by_date = $('#target_by_date').val();

            if (isNaN(no_of_working_days) || no_of_working_days <= 0) {
                t8.error('Please enter a valid number of working days greater than zero!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }

            if (isNaN(days_passed) || days_passed <= 0) {
                t8.error('Please enter a valid number of days passed greater than zero!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }

            // Check if target_by_date is not empty and is a valid date format
            if (target_by_date === '' || !isValidDateFormat(target_by_date)) {
                t8.error('Please enter a valid target date in the format dd/mm/yyyy!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }


            $('#loader').show();
            // Sending the data to the server using AJAX
            $.ajax({
                url: '<?php echo Yii::app()->createUrl('reports/HtmlTargetreport'); ?>',
                method: 'POST',
                data: {
                    'data': dataToSend,
                    'no_of_working_days': no_of_working_days,
                    'days_passed': days_passed,
                    'target_by_date': target_by_date
                },
                'success': function(data) {
                    $('#data_div').show();
                    $('.main-li-data').html(data);
                    $('#loader').hide();
                },
                error: function() {
                    t8.error('Error while processing the data.');
                    $('#data_div').hide(); // Hide data_div on error
                    $('#loader').hide();
                }
            });
        });

        $('#PdfviewButton').on('click', function() {
            // Make sure the dataToSend array is not empty before proceeding to generate the PDF
            if (dataToSend.length === 0) {
                t8.error('Please click the View Button first to populate data!');
                return;
            }

            var no_of_working_days = parseFloat($('#no_of_working_days').val());
            var days_passed = parseFloat($('#days_passed').val());

            var target_by_date = $('#target_by_date').val();

            if (isNaN(no_of_working_days) || no_of_working_days <= 0) {
                t8.error('Please enter a valid number of working days greater than zero!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }

            if (isNaN(days_passed) || days_passed <= 0) {
                t8.error('Please enter a valid number of days passed greater than zero!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }

            // Check if target_by_date is not empty and is a valid date format
            if (target_by_date === '' || !isValidDateFormat(target_by_date)) {
                t8.error('Please enter a valid target date in the format dd/mm/yyyy!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }

            var dataToSendJson = JSON.stringify(dataToSend);

            var liveSite = $('#liveSite').val();

            // Constructing the URL for the Excel report
            var url = liveSite + 'index.php?r=reports/PdfTargetreport';
            url += '&no_of_working_days=' + no_of_working_days + '&days_passed=' + days_passed + '&target_by_date=' + target_by_date + '&data=' + encodeURIComponent(dataToSendJson);
            cache: false, // Add this line to disable caching
                // Opening the Excel report in a new tab
                window.open(url, '_blank');


        });







        $('#viewButton1').click(function() {

            var no_of_working_days = parseFloat($('#no_of_working_days').val());
            var days_passed = parseFloat($('#days_passed').val());

            var target_by_date = $('#target_by_date').val();

            if (isNaN(no_of_working_days) || no_of_working_days <= 0) {
                t8.error('Please enter a valid number of working days greater than zero!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }

            if (isNaN(days_passed) || days_passed <= 0) {
                t8.error('Please enter a valid number of days passed greater than zero!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }

            // Check if target_by_date is not empty and is a valid date format
            if (target_by_date === '' || !isValidDateFormat(target_by_date)) {
                t8.error('Please enter a valid target date in the format dd/mm/yyyy!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }


            // Collecting the user IDs and target amounts
            var dataToSend = [];
            $('tbody tr').each(function() {
                var userId = $(this).find('[name="user_id"]').val();
                var targetAmount = $(this).find('[name="target_amount"]').val();
                dataToSend.push({
                    'userId': userId,
                    'targetAmount': targetAmount
                });
            });
            $('#loader').show();
            // Sending the data to the server using AJAX
            $.ajax({
                url: '<?php echo Yii::app()->createUrl('reports/HtmlTargetreport'); ?>',
                method: 'POST',
                data: {
                    'data': dataToSend,
                    'no_of_working_days': no_of_working_days,
                    'days_passed': days_passed,
                    'target_by_date': target_by_date
                },
                'success': function(data) {
                    $('#data_div').show();
                    $('.main-li-data').html(data);
                    $('#loader').hide();
                },
                error: function() {
                    t8.error('Error while processing the data.');
                    $('#data_div').hide(); // Hide data_div on error
                    $('#loader').hide();
                }
            });


        });

        $('#PdfviewButton1').on('click', function() {
            var no_of_working_days = parseFloat($('#no_of_working_days').val());
            var days_passed = parseFloat($('#days_passed').val());

            var target_by_date = $('#target_by_date').val();

            if (isNaN(no_of_working_days) || no_of_working_days <= 0) {
                t8.error('Please enter a valid number of working days greater than zero!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }

            if (isNaN(days_passed) || days_passed <= 0) {
                t8.error('Please enter a valid number of days passed greater than zero!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }

            // Check if target_by_date is not empty and is a valid date format
            if (target_by_date === '' || !isValidDateFormat(target_by_date)) {
                t8.error('Please enter a valid target date in the format dd/mm/yyyy!');
                $('#data_div').hide(); // Hide data_div on error
                return;
            }


            // Collecting the user IDs and target amounts
            var dataToSend = [];
            $('tbody tr').each(function() {
                var userId = $(this).find('[name="user_id"]').val();
                var targetAmount = $(this).find('[name="target_amount"]').val();
                dataToSend.push({
                    'userId': userId,
                    'targetAmount': targetAmount
                });
            });
            var dataToSendJson = JSON.stringify(dataToSend);

            var liveSite = $('#liveSite').val();

            // Constructing the URL for the Excel report
            var url = liveSite + 'index.php?r=reports/PdfTargetreport';
            url += '&no_of_working_days=' + no_of_working_days + '&days_passed=' + days_passed + '&target_by_date=' + target_by_date + '&data=' + encodeURIComponent(dataToSendJson);
            cache: false, // Add this line to disable caching
                // Opening the Excel report in a new tab
                window.open(url, '_blank');
        });





    });

    // Function to validate the date format
    function isValidDateFormat(dateString) {
        var regex = /^\d{2}\/\d{2}\/\d{4}$/;
        return regex.test(dateString);
    }
</script>



<?php

$cs = Yii::app()->getClientScript();

$cs->registerScript("customers", "function customers(field_id)
    {
        $('#customer_id').val('');
        var url = '" . Yii::app()->createUrl('reports/get_customers') . "';
        $('#focsales_customer_id').val('');
        $('#'+field_id).autocomplete({
            minLength   : 1,
            source      : function (request, response) { autoCompleteSource(request, response, url) },
            focus       : function( event, ui ) { $(this).val((ui.item.label)); return false; },
            select      : function( event, ui ) {
                event.preventDefault();
                $('#focsales_customer_id').val(ui.item.value);
                $('#focsales_customer').val(ui.item.label);
            }
        });
    }", CClientScript::POS_HEAD);
$cs->registerScript("loadPage", "function loadPage(){
        $('#loader').show();
        jQuery.ajax({
            'type': 'post',
            'url': '" . Yii::app()->createUrl('reports/HtmlTargetreport') . "',
            'data' : { 'outlet' : $('#focsales_outlet').val(), 'from' : $('#focsales_date_from').val(), 'to' : $('#focsales_date_to').val(), 'customer_id' : $('#focsales_customer_id').val(), 'salesman' : $('#focsales_salesman').val(), 'state' : $('#focsales_state').val() },
            'success': function(data) {
                $('#data_div').show();
                $('.main-li-data').html(data);
                $('#loader').hide();
            }
        });
    }", CClientScript::POS_HEAD);
?>