<div class="tab-content">
    <div class="tab-pane active" id="salesinvoice_sec">
        <section class="panel">
            <header class="panel-heading clearfix panel-theame">
                <i class="fa fa-balance-scale"></i> Sales Invoice
                <?php if (Yii::app()->user->user_access_type != 'DEV' && Yii::app()->user->user_access_type != 'SU' && Yii::app()->user->user_access_type != 'SM' && Yii::app()->user->user_access_type != 'OM') { ?>
                    <button class="btn btn-sm btn-theme" onclick="loadPopupModal('salesinvoice/create', 'New Sales Invoice', 'xl')"><i class="fa fa-plus"></i> ADD</button>
                <?php } ?>
                <div class="pull-right" style="display:inline-flex">
                    &NonBreakingSpace;
                    <?php
                    if (Yii::app()->user->user_access_type == 'DEV' || Yii::app()->user->user_access_type == 'SU') {
                        $array = array('class' => 'form-control', 'data-label' => 'Outlet', 'prompt' => 'All Outlets', 'style' => 'max-width: 130px;', 'onchange' => 'changeOutletUsers(this.id,"created_user","div_created_user");');
                    } else if (Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SL' || Yii::app()->user->user_access_type == 'SM' || Yii::app()->user->user_access_type == 'OM') {
                        $array = array('class' => 'form-control', 'data-label' => 'Outlet', 'style' => 'max-width: 130px;');
                    }
                    echo CHtml::dropdownlist('outlet', '', MasOutlets::getAllOutlets(), $array);
                    ?>
                    &NonBreakingSpace;
                    <div id="div_created_user">
                        <?php
                        $outlet = (int) Yii::app()->user->outlet_id;
                        if (Yii::app()->user->user_access_type == 'DEV' || Yii::app()->user->user_access_type == 'SU' || Yii::app()->user->user_access_type == 'CA' || Yii::app()->user->user_access_type == 'SM' || Yii::app()->user->user_access_type == 'OM') {
                            $uarray = array('class' => 'form-control', 'data-label' => 'User', 'prompt' => 'All Users');
                            if (Yii::app()->user->user_access_type == 'DEV' || Yii::app()->user->user_access_type == 'SU') {
                                $outlet = 0;
                            }
                        } else if (Yii::app()->user->user_access_type == 'SL') {
                            $uarray = array('class' => 'form-control', 'data-label' => 'User');
                        }

                        echo CHtml::dropdownlist('created_user', '', MasUsers::get_outlet_salesandadmin($outlet), $uarray); ?>
                    </div>
                    &NonBreakingSpace;
                    <label style="margin-top: 5px;margin-left: 5px;margin-right: 5px;">From</label>
                    &NonBreakingSpace;
                    <?php echo CHtml::textField('from', date('01/m/Y'), array('class' => 'form-control datepicker', 'data-label' => 'Start Date', 'style' => 'max-width: 103px;')); ?>
                    &NonBreakingSpace;
                    <label style="margin-top: 5px;margin-left: 5px;margin-right: 5px;">To</label>
                    &NonBreakingSpace;
                    <?php echo CHtml::textField('to', date('d/m/Y'), array('class' => 'form-control datepicker', 'data-label' => 'End Date', 'style' => 'max-width: 103px;')); ?>
                    &NonBreakingSpace;
                    <label style="margin-top: 5px;margin-left: 5px;margin-right: 5px;">Customer</label>
                    &NonBreakingSpace;
                    <?php echo CHtml::textField('customer_name', '', array('class' => 'form-control', 'data-label' => 'Customer Name', 'onKeyup' => 'js:autoCompleteCustomerDetails(this.id);', 'style' => 'max-width: 150px;')); ?>
                    <?php echo CHtml::hiddenField('customer_id', ''); ?>
                    &NonBreakingSpace;
                    <button class="btn btn-theme btn-md" onclick="reloadTable('#tbl_sales_invoice');"><i class="fa fa-retweet"></i></button>
                </div>
            </header>
            <div class="panel-body">
                <div class="custom-data-table">
                    <table class="table table-hover table-bordered personal-task" id="tbl_sales_invoice">
                        <thead>
                            <tr>
                                <th>#</th>
                                <th>Date</th>
                                <th>Customer</th>
                                <th>Payment Term</th>
                                <th>W/O VAT</th>
                                <th>VAT</th>
                                <th>Grand Total</th>
                                <th>Balance</th>
                                <th>Salesman</th>
                                <th>Outlet</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </section>
    </div>
</div>
<script>
    $(document).ready(function() {
        var table_details_id = "#tbl_sales_invoice";
        table_details = $(table_details_id).on("preXhr.dt", function(e, settings, data) {
            data.outlet = $("#outlet").val();
            data.from = $("#from").val();
            data.to = $("#to").val();
            data.customer_id = $("#customer_id").val();
            data.created_user = $("#created_user").val();
            return data;
        }).DataTable({
            scrollY: "550px",
            "bAutoWidth": true,
            pageLength: 50,
            columns: [{
                    className: ""
                },
                {
                    className: ""
                },
                {
                    className: ""
                },
                {
                    className: ""
                },
                {
                    className: "text-right"
                },
                {
                    className: "text-right"
                },
                {
                    className: "text-right"
                },
                {
                    className: "text-right"
                },
                {
                    className: ""
                },
                {
                    className: ""
                },
                {
                    className: ""
                },
            ],
            ajax: {
                url: "index.php?r=salesinvoice/getlist",
                type: "POST",
                cache: false,
            },
            serverSide: true,
            fixedColumns: true,
            processing: true,
            // order: [[2, "desc"]],
            aaSorting: [
                [1, 'desc'],
                [0, 'desc']
            ],
            aoColumnDefs: [{
                    "bSortable": false,
                    "aTargets": [10]
                },
                {
                    "targets": [11],
                    "visible": false,
                },
            ],
            "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {

                if (aData[11] == "N") {
                    $("td", nRow).addClass("bg-danger");
                }
            }
        });
        $(".dataTables_scrollFoot").hide();

    });
</script>
<?php
$cs = Yii::app()->getClientScript();
$baseUrl = Yii::app()->baseUrl;
$cs->registerScript("autoCompleteCustomerDetails", "function autoCompleteCustomerDetails(field_id){
    $('#customer_id').val('');
    var url = '" . Yii::app()->createUrl('Customer/GetCustomerDetails') . "';
    $('#'+field_id).autocomplete({
        minLength : 1,
        source : function (request, response) {
            autoCompleteSource(request, response,url)
        },
        focus : function( event, ui ) {
            $(this).val((ui.item.label)); return false;
        },
        select : function( event, ui ) {
            event.preventDefault();
            trigger_target_id = $(event.target).attr('id');
            var customer_id=ui.item.value;
            $('#customer_id').val(customer_id);
        } 
    }) 
}", CClientScript::POS_HEAD);

$cs->registerScript("CancelSales", "function cancelsales(invoice_id) {
    r =confirm('This Process Cannot be undo.Are You sure to cancel this?');
    if (r == true) {
                jQuery.ajax({
                    'dataType':'json',
                    'data' :{'id':invoice_id},
                    'type':'post',
                    'url': '" . Yii::app()->createUrl('salesinvoice/CancelSales') . "',
                    'cache': false,
                    'success': function(data) {
                        if(data.status=='success'){
                            t8.success('Sales Invoice Cancelled!');  
                            reloadTable('#tbl_sales_invoice'); 
                        }
                            else if(data.status=='error'){
                            t8.error(data.error_note);  
                        }    
                    else{
                            t8.error('Sales Invoice Cannot Be Cancelled'); 
                        }
                    }, 
                    'beforeSend':function(){
                        $('#loader').show();
                    },
                    'complete':function(){
                        $('#loader').hide();   
                    }
                });     
    }
        
};", CClientScript::POS_HEAD);

$cs->registerScript("changepaymenttermstocash", "function changepaymenttermstocash(invoice_id) {
    r =confirm('Change to Cash Invoice?');
    if (r == true) {
                jQuery.ajax({
                    'dataType':'json',
                    'data' :{'id':invoice_id},
                    'type':'post',
                    'url': '" . Yii::app()->createUrl('salesinvoice/ChangeCashSales') . "',
                    'cache': false,
                    'success': function(data) {
                        if(data.status=='success'){
                            t8.success('Saved Successfully!');  
                            reloadTable('#tbl_sales_invoice'); 
                        }
                            else if(data.status=='error'){
                            t8.error(data.error_note);  
                        }    
                    else{
                            t8.error('Sales Invoice Cannot Be Saved'); 
                        }
                    }, 
                    'beforeSend':function(){
                        $('#loader').show();
                    },
                    'complete':function(){
                        $('#loader').hide();   
                    }
                });     
    }
        
};", CClientScript::POS_HEAD);
?>