<?php

class ReportsController extends Controller
{

    public function accessRules()
    {
        return array(
            array(
                'allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('login', 'error', 'logout'),
                'users' => array('*'),
            ),
            array(
                'allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array(
                    'GL_report',
                    'GL_html',
                    'GL_excel',
                    'GL_pdf',
                    'Gl_summary_report',
                    'Gl_summary_html',
                    'Gl_summary_excel',
                    'Gl_summary_pdf',
                    'Tb_report',
                    'Tb_html',
                    'Tb_excel',
                    'Tb_pdf_level',
                    'Tb_pdf',
                    'Bs_report',
                    'Bs_html',
                    'Bs_excel',
                    'Bs_pdf_level',
                    'Bs_pdf',
                    'Pl_report',
                    'Pl_html',
                    'Pl_excel',
                    'Pl_pdf_level',
                    'Pl_pdf',
                    'Aging_report',
                    'Aging_html',
                    'Aging_vouchers_html',
                    'Aging_pdf',
                    'Aging_excel',
                    'Vat_report',
                    'Vat_html',
                    'Vat_pdf',
                    'Vat_pdf_extras',
                    'Vat_excel',
                    'Statement_report',
                    'Statement_html',
                    'Statement_pdf',
                    'Statement_pdf_filter',
                    'Statement_excel',
                    'Reconciliation_report',
                    'Rec_gl_html',
                    'Rec_gL_excel',
                    'Rec_gL_pdf',
                    'Cus_pl_report',
                    'Cus_pl_html',
                    'cus_pl_excel',
                    'Pl_cus_detailed',
                    'Emp_pl_report',
                    'Emp_pl_html',
                    'Pl_emp_detailed',
                    'Sales_cg_report',
                    'Sales_cg_html',
                    'Subledger_report',
                    'Subledger_report_html',
                    'Cus_pl_pdf',
                    'Emp_pl_pdf',
                    'Emp_pl_excel',
                    'Sales_cg_pdf',
                    'Sales_cg_excel',
                    'Cashflow_report',
                    'Cashflow_report_html',
                    'Cashflow_finance_report',
                    'Cashflow_finance_report_html',
                    'Cashflow_finance_report_excel',
                    'Sales_finance_report',
                    'Sales_finance_report_html',
                    'Sales_finance_report_excel',
                    'Purchase_finance_report',
                    'Purchase_finance_report_html',
                    'Purchase_finance_report_excel',
                    'Pl_new_html',
                    'Tb_new_html',
                    'Bs_new_html',
                    'Cost_report',
                    'Cost_html', 'Cost_group_html',  'Parentaccountlist','UpdateMaterialConversionCost','UserCashReport',
                    'Cash_Gl_html',
                    'Cash_GL_pdf',
                    'Cash_GL_excel',
                    'TestReport',
                    'day_book_report',
                    'Day_book_html',
                    'Day_book_pdf',
                    'Day_book_excel',
                    'Vat_return_html',
                    'Vat_return_report',
                    'Pl_new_pdf',
                    'Bs_new_pdf',
                    'Tb_new_pdf',
                    'Vat_new_pdf',
                    'Vat_return_new_pdf',
                    'tb_new_excel',
                    'Bs_new_excel',
                    'Pl_new_excel',
                    'Vat_return_new_excel',
                    'Vat_new_excel',
                    'Vat_summary_report',
                    'Vat_summary_html',
                    'Cost_pdf',
                    'Invoice_cost_html',
                    'Vat_summary_pdf'
                ),
                'expression' => '$user->isMember()',
            ),
            array(
                'deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function addVoucherhead($arr_items)
    {
        $model = new FinanceVoucherHead;
        $model->voucher_type = $arr_items['voucher_type'];
        $model->voucher_no = $arr_items['voucher_no'];
        $model->voucher_date = $arr_items['voucher_date'];
        $model->due_date = $model->voucher_date;
        $model->header_table_id = $arr_items['header_table_id'];
        $model->reference_no = $arr_items['reference_no'];
        $model->is_posted = (isset($arr_items['is_posted'])) ? $arr_items['is_posted'] : 'Y';
        $model->created_by = Yii::app()->user->id;
        $model->created_datetime = date('Y-m-d h:i:s');
        return ($model->save(false)) ? $model->id : 0; //exception
    }

    public function addVoucheritems($headerId, $arr_items)
    {
        $model = new FinanceVoucherItems;
        $model->header_id = $headerId;
        $model->ledger_id = $arr_items['ledger_id'];
        $model->subledger_id = $arr_items['subledger_id'];
        $model->narration = $arr_items['narration'];
        $model->currency_id = $arr_items['currency'];
        $model->exchange_rate = $arr_items['exchange_rate'];
        $model->amount = $arr_items['amount'];
        $model->save(false);
        $model->update_currency_code();
    }

    public function actionGl_report()
    {
        $this->render('gl_report');
    }

    public function actionGl_html()
    {
        $ledgerItems = array();

        $ledger_id = (int) $_POST['ledger_id'];
        $subledger = (int) $_POST['subledger_id'];
        $brand = (int) $_POST['brand'];
        $currency = (int) $_POST['currency'];
        $outlet = (int) $_POST['outlet'];
        $created_user = (int) $_POST['created_user'];
        $costcenter = (int) $_POST['costcenter'];
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;

        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-t');

        $condition = 'parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        $condition_for_opening = 'H.is_posted = "Y" AND H.voucher_date < "' . $from_date . '"';

        if ($ledger_id > 0) {
            $condition .= ' AND t.ledger_id IN(' . $ledger_id . ')';
            $condition_for_opening .= ' AND I.ledger_id IN(' . $ledger_id . ')';
        }

        if ($subledger > 0) {
            $condition .= ' AND t.subledger_id=' . $subledger;
            $condition_for_opening .= ' AND I.subledger_id=' . $subledger;
        }

        if ($brand > 0) {
            $condition .= ' AND t.brand_id=' . $brand;
            $condition_for_opening .= ' AND I.subledger_id=' . $brand;
        }

        if ($outlet > 0) {
            $condition .= ' AND t.outlet=' . $outlet;
            $condition_for_opening .= ' AND I.outlet=' . $outlet;
        }
        if ($created_user > 0) {
            $condition .= ' AND parent.created_by=' . $created_user;
            $condition_for_opening .= ' AND H.created_by=' . $created_user;
        }
        if ($costcenter > 0) {
            $condition .= ' AND parent.costcenter=' . $costcenter;
            $condition_for_opening .= ' AND H.costcenter=' . $costcenter;
        }

        function generateUrl($childModel)
        {
            $url = '#';
            $code = $childModel->parent->vtype->code;
            if ($code == 'SI') {
                $headModel = $childModel->parent->vtype->header_table;
                $vat_field = $childModel->parent->vtype->vat_value;
                $inv = $headModel::model()->findBypk($childModel->parent->header_table_id);
                $tax = $inv->$vat_field;
                $taxType = ($tax > 0) ? 'tax' : 'taxnil';
                $url = "window.open($('#liveSite').val()+'index.php?r=invoice/PrintInvoiceReportPDF&id=" . $childModel->parent->header_table_id . "&frm=" . $taxType . "&type=1', '_blank');";
            } else if ($code == 'PI') {
                $url = "window.open($('#liveSite').val()+'index.php?r=purchaseinvoice/PrintInvoiceReportPDF&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'DN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=debitnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'CN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=creditnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else {
                $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $childModel->header_id . "', '_blank');";
            }
            return $url;
        }

        $openingBalance1 = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE I.currency_id=' . $currency . ' AND ' . $condition_for_opening . ' ')->queryScalar();
        $openingBalance2 = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE I.currency_id!=' . $currency . ' AND ' . $condition_for_opening . ' ')->queryScalar();
        $items = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => $condition, 'order' => 'parent.voucher_date ASC'));
        $openingBalance = $openingBalance1 + ($openingBalance2 / $exchange_rate);
        $previousBalance = $openingBalance;
        $closingBalance = $openingBalance;
        $symbol = ($previousBalance > 0) ? 'Dr' : 'Cr';

        $total_debit = 0;
        $total_credit = 0;

        $table = '<table class="table table-hover table-fixed table-bordered" id="gl_table">
                  <thead>
                      <tr>
                        <th style="width:7%" >Date</th>
                        <th style="width:5%" >VO #</th>
                        <th style="width:10%" >Ledger</th>
                        <th style="width:20%" >Subledger</th>
                        <th style="width:12%;text-align:right !important;" class="text-right">Debit</th>
                        <th style="width:12%;text-align:right !important;" class="text-right">Credit</th>
                        <th style="width:12%;text-align:right !important;" class="text-right">Balance</th>
                        <th style="width:40%">Narration</th>
                      </tr>
                  </thead>
                  <tbody>
                  <tr>
                      <td colspan="4" class="text-right" style="text-align:right !important;"><b>Opening Balance</b></td>
                      <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency((($previousBalance > 0) ? abs($previousBalance) : ''), " ") . '</td>
                      <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency((($previousBalance < 0) ? abs($previousBalance) : ''), " ") . '</td>
                      <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($previousBalance), " ") . ' ' . $symbol . '</td>
                      <td></td>
                  </tr>';
        //                  $total_debit += $previousBalance > 0 ? abs($previousBalance) : '';
        //                  $total_credit += $previousBalance < 0 ? abs($previousBalance) : '';
        $parent = 1;
        foreach ($items as $each) {

            $debit = ($each->amount > 0) ? round(($each->amount * $each->exchange_rate), 4) : '';
            $credit = ($each->amount < 0) ? round(abs($each->amount * $each->exchange_rate), 4) : '';

            $debit = ($currency == $each->currency_id) ? $debit / $each->exchange_rate : $debit / $exchange_rate;
            $credit = ($currency == $each->currency_id) ? $credit / $each->exchange_rate : $credit / $exchange_rate;

            $running = $debit - $credit + $previousBalance;
            $previousBalance = $running;
            $symbol = ($running > 0) ? 'Dr' : 'Cr';
            $closingBalance += ($debit - $credit);

            $total_debit += $debit;
            $total_credit += $credit;

            $subledgerName = ($each->subledger_id > 0) ? $each->subledger->description : '';
            $vouchreformat = '<a href="#" onclick="' . generateUrl($each) . '">' . $each->parent->fullvoucher . '</a>';
            $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($running), " ") . " " . $symbol . '</td>
                          <td><small>' . $each->narration . '</small></td>
                      </tr>';

            //            $eachItem = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => 't.header_id="' . (int) $each->header_id . '" AND t.id != "' . (int) $each->id . '"', 'order' => 'parent.voucher_date ASC'));
            //            $child = $parent + 1;
            //            foreach ($eachItem as $eachLine) {
            //
            //                $debit = ($eachLine->amount > 0) ? round(($eachLine->amount * $eachLine->exchange_rate), 2) : '';
            //                $credit = ($eachLine->amount < 0) ? round(abs($eachLine->amount * $eachLine->exchange_rate), 2) : '';
            //
            //                $debit= ($currency==$each->currency_id) ? $debit/$each->exchange_rate : $debit/$exchange_rate;
            //                $credit= ($currency==$each->currency_id) ? $credit/$each->exchange_rate : $credit/$exchange_rate;
            //
            //                $subledgerName = ($eachLine->subledger_id > 0) ? $eachLine->subledger->description : '';
            //
            //                $table .= ' <tr data-id="' . $child . '" data-parent="' . $parent . '">
            //                                    <td style="background-color:#d8f5df"></td>
            //                                    <td style="background-color:#d8f5df"></td>
            //                                    <td style="background-color:#d8f5df">' . $eachLine->ledger->description . '</td>
            //                                    <td style="background-color:#d8f5df">' . $subledgerName . '</td>
            //                                    <td style="background-color:#d8f5df; text-align:right !important;">' . $currency_code . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
            //                                    <td style="background-color:#d8f5df; text-align:right !important;">' . $currency_code . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
            //                                    <td style="background-color:#d8f5df"></td>
            //                                    <td style="background-color:#d8f5df"><small>' . $eachLine->narration . '</small></td>
            //                            </tr>';
            //                $child++;
            //            }
            $parent = $child;
        }
        $running = $debit - $credit + $previousBalance;
        $symbol = ($closingBalance > 0) ? 'Dr' : 'Cr';
        $table .= '<tr>
                      <td colspan="4" style="text-align:right !important;"><b>Total</b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " ") . '</b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " ") . '</b></td>
                      <td style="text-align:right !important;"></td>
                      <td></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="4" style="text-align:right !important;"><b>Closing Balance</b></td>
                      <td colspan="3" style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($closingBalance), " ") . ' ' . $symbol . '</b></td>
                      <td></td>
                  </tr>';
        $table .= '</tbody>
              </table>';
        echo $table;
    }

    public function actionGL_excel()
    {

        Yii::import('ext.PHPExcel.PHPExcel');

        $ledger = $_GET['ledger'];
        $subledger = (int) $_GET['subledger'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-t');
        $currency = (int) $_GET['currency'];
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;
        $condition = 'parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        $condition_for_opening = 'H.is_posted = "Y" AND H.voucher_date < "' . $from_date . '"';
        $title = '';
        if ($ledger > 0) {
            $condition .= ' AND t.ledger_id IN(' . $ledger . ')';
            $condition_for_opening .= ' AND I.ledger_id IN(' . $ledger . ')';
            $ledger_details = FinanceLegder::model()->findByPk($ledger);
            $title = $ledger_details->description;
        }
        if ($subledger > 0) {
            $condition .= ' AND t.subledger_id=' . $subledger;
            $condition_for_opening .= ' AND I.subledger_id=' . $subledger;
            $subledger_details = FinanceSubledger::model()->findByPk($subledger);
            $title = $subledger_details->description;
        }
        $brand = (int) $_GET['brand'];
        if ($brand > 0) {
            $condition .= ' AND t.brand_id=' . $brand;
            $condition_for_opening .= ' AND I.subledger_id=' . $brand;
        }

        $outlet = (int) $_GET['outlet'];
        if ($outlet > 0) {
            $condition .= ' AND t.outlet=' . $outlet;
            $condition_for_opening .= ' AND I.outlet=' . $outlet;
        }
        $costcenter = (int) $_GET['costcenter'];
        if ($costcenter > 0) {
            $condition .= ' AND parent.costcenter=' . $costcenter;
            $condition_for_opening .= ' AND H.costcenter=' . $costcenter;
        }

        $openingBalance1 = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE I.currency_id=' . $currency . ' AND ' . $condition_for_opening . ' ')->queryScalar();
        $openingBalance2 = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE I.currency_id!=' . $currency . ' AND ' . $condition_for_opening . ' ')->queryScalar();
        $items = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => $condition, 'order' => 'parent.voucher_date ASC'));
        $openingBalance = $openingBalance1 + ($openingBalance2 / $exchange_rate);

        $previousBalance = $openingBalance;
        $closingBalance = $openingBalance;
        $symbol = ($previousBalance > 0) ? 'Dr' : 'Cr';

        $total_debit = 0;
        $total_credit = 0;

        // Create new PHPExcel object
        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(6)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(7)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("General Transaction Ledger Report")
            ->setSubject("General Transaction Ledger Report")
            ->setDescription("General Transaction Ledger Report Generated on " . date('d/m/Y'))
            ->setKeywords("General Transaction Ledger Report")
            ->setCategory("Financial Report");

        // Add some data
        $settings = MasCompany::model()->findByPk(Yii::app()->user->company_id);
        $excel->getActiveSheet()->getStyle('A1:G1')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A1:G1');
        $excel->getActiveSheet(0)
            ->setCellValue('A1', $settings->name);

        // $excel->getActiveSheet()->getStyle('A2:H2')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A2:G2');
        $excel->getActiveSheet(0)
            ->setCellValue('A2', $settings->billing_address);

        // $excel->getActiveSheet()->getStyle('A3:H3')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A3:G3');
        $excel->getActiveSheet(0)
            ->setCellValue('A3', '');

        $excel->setActiveSheetIndex(0)->mergeCells('A4:G4');

        // $excel->getActiveSheet()->getStyle('A4:H4')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A5:G5');
        $excel->getActiveSheet(0)
            ->setCellValue('A5', 'TRN : ' . $settings->trn_no);

        $excel->getActiveSheet()->getStyle('A6:G6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A6:G6');
        $excel->getActiveSheet(0)
            ->setCellValue('A6', $title);

        $date_title = date("d-m-Y", strtotime($from_date)) . ' TO ' . date("d-m-Y", strtotime($to_date));
        // $excel->getActiveSheet()->getStyle('A6:H6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A7:G7');
        $excel->getActiveSheet(0)
            ->setCellValue('A7', $date_title);
        $excel->setActiveSheetIndex(0)->mergeCells('A8:G8');
        $currency1 = 'Currency : ' . $currency_code;
        $excel->getActiveSheet(0)
            ->setCellValue('A8', $currency1);
        $excel->setActiveSheetIndex(0)->mergeCells('A9:G9');

        $excel->getActiveSheet(0)
            ->setCellValue('A10', 'Date')
            ->setCellValue('B10', 'Voucher')
            ->setCellValue('C10', 'Particular')
            ->setCellValue('D10', 'Debit')
            ->setCellValue('E10', 'Credit')
            ->setCellValue('F10', 'Balance')
            ->setCellValue('G10', 'Narration');

        //Opening Balance
        $excel->setActiveSheetIndex(0)
            ->setCellValue('C11', 'Opening Balance');

        if ($openingBalance > 0) {
            $excel->setActiveSheetIndex(0)
                ->setCellValue('D11', Yii::app()->numberFormatter->formatCurrency(abs($openingBalance), " "));
        } else {
            $excel->setActiveSheetIndex(0)
                ->setCellValue('E11', Yii::app()->numberFormatter->formatCurrency(abs($openingBalance), " "));
        }
        //Data Items
        $total_debit += $previousBalance > 0 ? abs($previousBalance) : '';
        $total_credit += $previousBalance < 0 ? abs($previousBalance) : '';
        $parent = 12;
        foreach ($items as $each) {

            $debit = ($each->amount > 0) ? round(($each->amount * $each->exchange_rate), 4) : '';
            $credit = ($each->amount < 0) ? round(abs($each->amount * $each->exchange_rate), 4) : '';

            $debit = ($currency == $each->currency_id) ? $debit / $each->exchange_rate : $debit / $exchange_rate;
            $credit = ($currency == $each->currency_id) ? $credit / $each->exchange_rate : $credit / $exchange_rate;

            $running = $debit - $credit + $previousBalance;
            $previousBalance = $running;
            $symbol = ($running > 0) ? 'Dr' : 'Cr';
            $closingBalance += ($debit - $credit);

            $total_debit += $debit;
            $total_credit += $credit;

            $subledgerName = ($each->subledger_id > 0) ? $each->subledger->description : '';
            $particular = '';
            if ($each->amount > 0) {
                $itemparticular = FinanceVoucherItems::model()->find(array('condition' => 'amount<0 AND header_id=' . $each->header_id, 'order' => 'amount ASC'));
                $particular = ($itemparticular->subledger_id > 0) ? $itemparticular->subledger->description : $itemparticular->ledger->description;
            } else if ($each->amount < 0) {
                $itemparticular = FinanceVoucherItems::model()->find(array('condition' => 'amount>0 AND header_id=' . $each->header_id, 'order' => 'amount DESC'));
                $particular = ($itemparticular->subledger_id > 0) ? $itemparticular->subledger->description : $itemparticular->ledger->description;
            }
            $excel->getActiveSheet()->getStyle('A1:G1')->getFont()->setBold(true)->setSize(12);
            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $parent, date("d/m/Y", strtotime($each->parent->voucher_date)))
                ->setCellValue('B' . $parent, $each->parent->fullvoucher)
                ->setCellValue('C' . $parent, $particular)
                ->setCellValue('D' . $parent,  Yii::app()->numberFormatter->formatCurrency($debit, " "))
                ->setCellValue('E' . $parent,  Yii::app()->numberFormatter->formatCurrency($credit, " "))
                ->setCellValue('F' . $parent,  Yii::app()->numberFormatter->formatCurrency(abs($running), " ") . " " . $symbol)
                ->setCellValue('G' . $parent, $each->narration);
            $parent++;
        }
        $symbol = ($closingBalance > 0) ? 'Dr' : 'Cr';
        $excel->getActiveSheet()->getStyle('A' . $parent . ':G' . $parent)->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $parent, 'Total')
            ->setCellValue('D' . $parent, Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " "))
            ->setCellValue('E' . $parent, Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $parent . ':C' . $parent);
        $excel->getActiveSheet()
            ->getStyle('D2:D' . $parent)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()
            ->getStyle('E2:E' . $parent)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()
            ->getStyle('F2:F' . $parent)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);

        // Rename worksheet
        $excel->getActiveSheet()->setTitle('General Ledger');

        // Set active sheet index to the first sheet, so Excel opens this as the first sheet
        $excel->setActiveSheetIndex(0);
        $parent++;
        $excel->getActiveSheet()->getStyle('A' . $parent . ':G' . $parent)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $parent . ':E' . $parent);
        $excel->getActiveSheet(0)
            ->getStyle('F' . $parent)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $parent, 'Closing Balance')
            ->setCellValue('F' . $parent, Yii::app()->numberFormatter->formatCurrency(abs($closingBalance), " ") . ' ' . $symbol);

        $styleArray = array(
            'borders' => array(
                'allborders' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        $excel->getActiveSheet(0)->getStyle('A1:G' . $parent)->applyFromArray($styleArray);

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="general_ledger.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionGL_pdf()
    {

        $from_date = Yii::app()->request->getParam('from_date');
        $to_date = Yii::app()->request->getParam('to_date');
        $ledger = Yii::app()->request->getParam('ledger');
        $subledger = (int) Yii::app()->request->getParam('subledger');
        $brand = (int) Yii::app()->request->getParam('brand');
        $currency = (int) Yii::app()->request->getParam('currency');
        $outlet = (int) Yii::app()->request->getParam('outlet');
        $costcenter = (int) Yii::app()->request->getParam('costcenter');
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;

        $param = array(
            'from_date' => $from_date,
            'to_date' => $to_date,
            'ledger' => $ledger,
            'subledger' => $subledger,
            'currency_code' => $currency_code,
            'exchange_rate' => $exchange_rate,
            'currency' => $currency,
            'costcenter' => $costcenter,
            'outlet' => $outlet
        );

        $mode = 'A4-L';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'pdf_gl_report';
        $mpdf->WriteHTML($this->renderPartial($view, $param, true));
        $mpdf->Output("GLReport" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionGl_summary_report()
    {
        $this->render('gl_summary_report');
    }

    public function actionGl_summary_html()
    {
        $ledger = (int) $_POST['ledger_id'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $brand = (int) $_POST['brand'];
        $outlet = (int) $_POST['outlet'];
        $salesman = (int) $_POST['salesman'];
        $condition = 'VI.ledger_id="' . $ledger . '" AND V.is_posted = "Y" AND V.voucher_date >= "' . $from_date . '" AND V.voucher_date <= "' . $to_date . '"';
        //        if ($brand > 0) {
        //            $condition .= ' AND VI.brand_id=' . $brand;
        //        }
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
            $condition .= ' AND SL.outlet=' . $outlet;
        }
        if ($salesman > 0) {
            $customer = Customer::model()->findAll(array('condition' => 'accessed_by = "' . $salesman . '" OR accessed_by like "%,' . $salesman . ',%" OR accessed_by like "' . $salesman . ',%" OR accessed_by like "%,' . $salesman . '"'));
            //            $SQL_Customers=Yii::app()->db->createCommand('select group_concat(id) AS customer_id from erp_customer where accessed_by = "'.$salesman.'" OR accessed_by like "%,'.$salesman.',%" OR accessed_by like "'.$salesman.',%" OR accessed_by like "%,'.$salesman.'"')->queryScalar();
            //            echo 'select group_concat(id) AS customer_id from erp_customer where accessed_by = "'.$salesman.'" OR accessed_by like "%,'.$salesman.',%" OR accessed_by like "'.$salesman.',%" OR accessed_by like "%,'.$salesman.'"';
            //            $SQL_Customers=rtrim($SQL_Customers, ',');
            //            if(!empty($SQL_Customers))
            //            {
            //            $condition .= ' AND (SL.parent_id IN(' . $SQL_Customers . '))';
            //            }
        }
        //        echo $condition;
        $glSummaryquery = 'CREATE OR REPLACE VIEW {{finance_gl_summary}} AS SELECT
                                SL.id AS subledger_id,
								SL.account_no AS subledger_no,SL.parent_id AS customer_id,
								IFNULL(SL.description, "No Subledger") AS subledger_name,
                                ROUND(SUM( CASE WHEN VI.amount > 0 THEN VI.amount*VI.exchange_rate ELSE 0 END ), 4) AS debit,
                                ROUND(SUM( CASE WHEN VI.amount < 0 THEN ABS(VI.amount*VI.exchange_rate) ELSE 0 END ), 4) AS credit,
								ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance,
                                L.id AS ledger_id
							FROM {{finance_voucher_items}} VI
							LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
							LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
							LEFT JOIN {{finance_subledger}} SL ON SL.id = VI.subledger_id
							WHERE ' . $condition . '
							GROUP BY  VI.ledger_id, VI.subledger_id';
        Yii::app()->db->createCommand($glSummaryquery)->execute();

        //        $summaryItems = Yii::app()->db->createCommand('SELECT * FROM {{finance_gl_summary}} WHERE balance != 0 ORDER BY subledger_name')->queryAll();
        if ($salesman > 0) {
            $summaryItems = Yii::app()->db->createCommand('SELECT S.* FROM {{finance_gl_summary}} AS S INNER JOIN {{customer}} AS C ON S.customer_id=C.id where accessed_by = "' . $salesman . '" OR accessed_by like "%,' . $salesman . ',%" OR accessed_by like "' . $salesman . ',%" OR accessed_by like "%,' . $salesman . '" ORDER BY S.subledger_name')->queryAll();
        } else {
            $summaryItems = Yii::app()->db->createCommand('SELECT * FROM {{finance_gl_summary}} ORDER BY subledger_name')->queryAll();
        }
        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:10%" >#</th>
                            <th style="width:30%" >Particular</th>
                            <th style="width:15%" >Phone No</th>
                            <th style="width:15%;text-align:right !important;" class="text-right">Debit</th>
                            <th style="width:15%;text-align:right !important;" class="text-right">Credit</th>
                            <th style="width:15%;text-align:right !important;" class="text-right">Balance</th>
                        </tr>
                    </thead>
                    <tbody>';

        $totalDebit = $totalCredit = 0;
        $accountingPeriod = FinanceVoucherType::generateAccountingperiod($to_date);

        foreach ($summaryItems as $each) {
            // $debit = ($each['balance'] > 0) ? $each['balance'] : '';
            // $credit = ($each['balance'] < 0) ? abs($each['balance']) : '';

            $debit = $each['debit'];
            $credit = $each['credit'];

            $totalDebit += $debit;
            $totalCredit += $credit;
            $phone_no = '-';
            if ($each['subledger_id'] > 0) {
                $FinanceSubledger = FinanceSubledger::model()->findByPk($each['subledger_id']);
                $phone_no = $FinanceSubledger->phone;
            }
            $subledgerName = '<a href="#" onclick="js:load_gl_report(' . $each['ledger_id'] . ', ' . $each['subledger_id'] . ', \'' . date('d/m/Y', strtotime($from_date)) . '\', \'' . date('d/m/Y', strtotime($to_date)) . '\');" >' . $each['subledger_name'] . '</a>';
            $table .= '  <tr>
                            <td>' . $each['subledger_no'] . '</td>
                            <td>' . $subledgerName . '</td>
                            <td>' . $phone_no . '</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit - $debit, " ") . '</td>
                        </tr>';
        }

        $table .= ' <tr>
                        <td colspan="3" style="text-align:right !important;"><b>Total</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($totalDebit, " ") . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($totalCredit, " ") . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($totalDebit - $totalCredit, " ") . '</b></td>
                    </tr>';

        $balance = $totalDebit - $totalCredit;
        $debitBalance = ($balance > 0) ? $balance : 0;
        $creditBalance = ($balance <= 0) ? abs($balance) : 0;

        $table .= '<tr>
                        <td colspan="3"style="text-align:right !important;"><b>Balance</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($debitBalance, " ") . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($creditBalance, " ") . '</b></td>
                        <td style="text-align:right !important;"></td>
                    </tr>';
        $table .= '</tbody>
            </table>';
        echo $table;
    }

    public function actionGl_summary_pdf()
    {

        $ledger = (int) $_GET['ledger'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-d');
        $brand = (int) $_GET['brand'];
        $outlet = (int) $_GET['outlet'];
        $salesman = (int) $_GET['salesman'];
        $condition = '';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
        }
        if ($salesman > 0) {
            //            $customer=Customer::model()->find(array('condition'=>'accessed_by like "'.$salesman.'" OR accessed_by like "%,'.$salesman.',%" OR accessed_by like "'.$salesman.',%" OR accessed_by like "%,'.$salesman.'"'));
            //            $SQL_Customers=Yii::app()->db->createCommand('select group_concat(id) AS customer_id from erp_customer where accessed_by like "'.$salesman.'" OR accessed_by like "%,'.$salesman.',%" OR accessed_by like "'.$salesman.',%" OR accessed_by like "%,'.$salesman.'"')->queryScalar();
            //            $SQL_Customers=rtrim($SQL_Customers, ',');
            //            if(!empty($SQL_Customers))
            //            {
            //            $condition .= ' AND SL.parent_id IN(' . $SQL_Customers . ')';
            //            }
        }


        $glSummaryquery = 'CREATE OR REPLACE VIEW {{finance_gl_summary}} AS SELECT
                                SL.id AS subledger_id,
								SL.account_no AS subledger_no,SL.parent_id AS customer_id,
								IFNULL(SL.description, "No Subledger") AS subledger_name,
                                ROUND(SUM( CASE WHEN VI.amount > 0 THEN VI.amount*VI.exchange_rate ELSE 0 END ), 4) AS debit,
                                ROUND(SUM( CASE WHEN VI.amount < 0 THEN ABS(VI.amount*VI.exchange_rate) ELSE 0 END ), 4) AS credit,
								ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance,
                                L.id AS ledger_id
							FROM {{finance_voucher_items}} VI
							LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
							LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
							LEFT JOIN {{finance_subledger}} SL ON SL.id = VI.subledger_id
							WHERE VI.ledger_id="' . $ledger . '" AND V.is_posted = "Y" AND V.voucher_date >= "' . $from_date . '"  AND V.voucher_date <= "' . $to_date . '" ' . $condition . '
							GROUP BY  VI.ledger_id, VI.subledger_id';

        Yii::app()->db->createCommand($glSummaryquery)->execute();

        $param = array(
            'to_date' => $to_date,
            'ledger' => $ledger,
            'outlet' => $outlet,
            'salesman' => $salesman
        );

        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf_gl_summary_report', $param, true));

        $mpdf->Output("gl_summary" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionGl_summary_excel()
    {
        $ledger = (int) $_GET['ledger'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-d');
        $brand = (int) $_GET['brand'];
        $outlet = (int) $_GET['outlet'];
        $salesman = (int) $_GET['salesman'];
        $condition = '';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
        }
        $ledgerModel = FinanceLegder::model()->findBypk($ledger);

        $glSummaryquery = 'CREATE OR REPLACE VIEW {{finance_gl_summary}} AS SELECT
                                SL.id AS subledger_id,
								SL.account_no AS subledger_no,SL.parent_id AS customer_id,
								IFNULL(SL.description, "No Subledger") AS subledger_name,
                                ROUND(SUM( CASE WHEN VI.amount > 0 THEN VI.amount*VI.exchange_rate ELSE 0 END ), 4) AS debit,
                                ROUND(SUM( CASE WHEN VI.amount < 0 THEN ABS(VI.amount*VI.exchange_rate) ELSE 0 END ), 4) AS credit,
								ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance,
                                L.id AS ledger_id
							FROM {{finance_voucher_items}} VI
							LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
							LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
							LEFT JOIN {{finance_subledger}} SL ON SL.id = VI.subledger_id
							WHERE VI.ledger_id="' . $ledger . '" AND V.is_posted = "Y" AND V.voucher_date >= "' . $from_date . '"  AND V.voucher_date <= "' . $to_date . '" ' . $condition . '
							GROUP BY  VI.ledger_id, VI.subledger_id';

        Yii::app()->db->createCommand($glSummaryquery)->execute();

        Yii::import('ext.PHPExcel.PHPExcel');

        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Ledger Summary Report")
            ->setSubject("Ledger Summary Report")
            ->setDescription("Ledger Summary Report Generated on " . date('d/m/Y'))
            ->setKeywords("Ledger Summary Report")
            ->setCategory("Financial Report");

        // Add some data
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', '#')
            ->setCellValue('B1', 'Particular')
            ->setCellValue('C1', 'Phone No')
            ->setCellValue('D1', 'Debit')
            ->setCellValue('E1', 'Credit')
            ->setCellValue('F1', 'Balance');

        $border = array(
            'borders' => array(
                'bottom' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THICK,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        $excel->getActiveSheet(0)->getStyle('A1:F1')->applyFromArray($border);

        $excel->getActiveSheet()->getStyle('A1:F1')->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));

        $excel->getActiveSheet()->getStyle('A1:F1')->getFont()->setBold(true)->setSize(12);
        if ($salesman > 0) {
            $summaryItems = Yii::app()->db->createCommand('SELECT S.* FROM {{finance_gl_summary}} AS S INNER JOIN {{customer}} AS C ON S.customer_id=C.id where accessed_by = "' . $salesman . '" OR accessed_by like "%,' . $salesman . ',%" OR accessed_by like "' . $salesman . ',%" OR accessed_by like "%,' . $salesman . '" ORDER BY S.subledger_name')->queryAll();
        } else {
            $summaryItems = Yii::app()->db->createCommand('SELECT * FROM {{finance_gl_summary}} ORDER BY subledger_name')->queryAll();
        }
        $totalDebit = $totalCredit = 0;

        $rowId = 2;
        foreach ($summaryItems as $each) {

            // $debit = ($each['balance'] > 0) ? $each['balance'] : '';
            // $credit = ($each['balance'] < 0) ? abs($each['balance']) : '';

            $debit = $each['debit'];
            $credit = $each['credit'];
            $phone_no = '-';
            if ($each['subledger_id'] > 0) {
                $FinanceSubledger = FinanceSubledger::model()->findByPk($each['subledger_id']);
                $phone_no = $FinanceSubledger->phone;
            }
            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, $each['subledger_no'])
                ->setCellValue('B' . $rowId, $each['subledger_name'])
                ->setCellValue('C' . $rowId, $phone_no)
                ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency($debit, " "))
                ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency($credit, " "))
                ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency($credit - $debit, " "));

            $totalDebit += $debit;
            $totalCredit += $credit;
            $rowId++;
        }

        $excel->getActiveSheet(0)->getStyle('A' . ($rowId - 1) . ':F' . ($rowId - 1))->applyFromArray($border);
        $excel->getActiveSheet(0)->getStyle('A' . $rowId . ':F' . $rowId)->applyFromArray($border);

        $excel->setActiveSheetIndex(0)
            ->setCellValue('A' . $rowId, 'Total')
            ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency($totalDebit, " "))
            ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency($totalCredit, " "))
            ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency($totalCredit - $totalDebit, " "));
        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $rowId . ':C' . $rowId);

        $balance = $totalDebit - $totalCredit;
        $debitBalance = ($balance > 0) ? $balance : 0;
        $creditBalance = ($balance <= 0) ? abs($balance) : 0;

        $rowId++;
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A' . $rowId, 'Balance')
            ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency($debitBalance, " "))
            ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency($creditBalance, " "));
        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setBold(true)->setSize(14);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $rowId . ':C' . $rowId);

        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));

        // Rename worksheet
        $excel->getActiveSheet()->setTitle($ledgerModel->description);

        $excel->getActiveSheet()
            ->getStyle('D2:F' . $rowId)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="' . $ledgerModel->description . '.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionTB_report()
    {
        $this->render('tb_report');
    }

    public function actionTb_html()
    {
        $brand = (int) $_POST['brand'];
        $outlet = (int) $_POST['outlet'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = '';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        // $accountingPeriod = FinanceVoucherType::generateAccountingperiod($to_date);
        $accountingPeriod = $from_date;
        $query = 'CREATE OR REPLACE VIEW {{finance_trialbalance}} AS SELECT
                            L.id AS ledger_id,
                            L.account_no AS ledger_no,
                            L.description AS ledger_name,
                            L.level AS level,
                            L.parent_account AS parent,
                            IFNULL(S.description, "N/A") AS subledger,
                            IFNULL(S.id, 0) AS subledger_id,
                            ROUND((SUM(CASE WHEN VI.amount > 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS debit,
                            ROUND((SUM(CASE WHEN VI.amount < 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS credit,
                            ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance
                        FROM {{finance_legder}} L
                        LEFT JOIN {{finance_voucher_items}} VI ON VI.ledger_id = L.id
                        LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id
                        LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                        WHERE V.is_posted="Y" AND L.id!=25 AND V.voucher_date BETWEEN  "' . $from_date . '" AND "' . $to_date . '" AND L.type_of_account IN ("B", "P")' . $condition . '
                        GROUP BY L.id, S.id';
        Yii::app()->db->createCommand($query)->execute();

        $table = '<table class="table table-hover table-fixed table-bordered" id="tb_table">
                    <thead>
                        <tr>
                            <th style="width:10%" >#</th>
                            <th style="width:30%" >Particular</th>
                            <th style="width:15%;text-align:right !important;" >Opening Balance</th>
                            <th style="width:15%;text-align:right !important;" class="text-right">Debit (' . FinanceLegder::baseCurrency() . ')</th>
                            <th style="width:15%;text-align:right !important;" class="text-right">Credit (' . FinanceLegder::baseCurrency() . ')</th>
                            <th style="width:15%;text-align:right !important;" class="text-right">Balance (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';

        function get_symbol($value)
        {
            return ($value) > 0 ? ' Dr' : ' Cr';
        }

        function getClick($model, $accountingPeriod, $to_date)
        {
            return ($model->haveSubledger == 'Y') ? 'js:load_summary(' . $model->id . ', \'' . date('d/m/Y', strtotime($from_date)) . '\', \'' . date('d/m/Y', strtotime($to_date)) . '\');' : 'js:load_gl_report(' . $model->id . ', 0, \'' . date('d/m/Y', strtotime($from_date)) . '\', \'' . date('d/m/Y', strtotime($to_date)) . '\');';
        }

        //We have 5 levels
        $total_debit = $total_credit = 0;
        $levelOne = FinanceLegder::model()->findAll(array('condition' => 'level=1 AND type_of_account IN ("B", "P") '));
        foreach ($levelOne as $eachOne) {

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                JOIN
                (SELECT @pv:=' . $eachOne->id . ') tmp
                ) a';
            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $debit = $credit = $balance = $opening = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE  H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                $balance += $opening;
            }

            $table .= '<tr data-id="' . $eachOne->id . '" data-parent="" >
                            <td><b>' . $eachOne->account_no . '</b></td>
                            <td><b>' . $accountName . '</b></td>
                            <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening) . '</b></td>
                            <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($debit), " ") . '</b></td>
                            <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($credit), " ") . '</b></td>
                            <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance) . '</b></td>
                        </tr>';

            $total_debit += $debit;
            $total_credit += $credit;
            //LEVEL 2
            $levelTwo = FinanceLegder::model()->findAll(array('condition' => 'level=2 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelTwo as $eachTwo) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                    JOIN
                    (SELECT @pv:=' . $eachTwo->id . ') tmp
                    ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $debit = $credit = $balance = $opening = 0;
                $bo = $bc = '';
                $accountName = $eachTwo->description;

                if ($ids[0]['child'] != '') {
                    $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                    $balance += $opening;
                    $bo = '<b>';
                    $bc = '</b>';
                } else {
                    $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachTwo->id . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();

                    $balance += $opening;

                    $accountName = '<a href="#" onclick="' . getClick($eachTwo, $accountingPeriod, $to_date) . '">' . $eachTwo->description . '</a>';
                }
                $table .= '<tr data-id="' . $eachTwo->id . '" data-parent="' . $eachOne->id . '" >
                                <td>' . $bo . $eachTwo->account_no . $bc . '</td>
                                <td>&nbsp;&nbsp;&nbsp;' . $bo . $accountName . '</td>
                                <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening) . $bc . '</td>
                                <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($debit), " ") . $bc . '</td>
                                <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($credit), " ") . $bc . '</td>
                                <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance) . $bc . '</td>
                            </tr>';
                //LEVEL 3
                $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachTwo->id));
                foreach ($levelThree as $eachThree) {
                    //            if($eachThree->id==6)
                    //                {
                    //                 $accountName =  $eachThree->description;
                    //                 $debit = $credit = $balance = $opening = 0;
                    //                 $opening_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                    //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' group by product_id')->queryAll();
                    //                 $opening=0;
                    //                 foreach($opening_in_rate as $eachOpen)
                    //                 {
                    //                 $opening_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOpen["product_id"])->queryScalar();
                    //                 
                    //                 $opening_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOpen["product_id"])->queryScalar();
                    //                 $opening+=($opening_in-$opening_out)*$eachOpen['avg_purchase_rate'];
                    //                 }
                    //                 $current_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                    //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' group by product_id')->queryAll();
                    //                 $current=0;
                    //                 foreach($current_in_rate as $eachCurrent)
                    //                 {
                    //                 $current_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                    //                 $current_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                    //                 $current+=($current_in-$current_out)*$eachCurrent['avg_purchase_rate'];
                    //                 }
                    //                 if($current>0)
                    //                 {
                    //                 $debit=$current;
                    //                 $credit=0;
                    //                 $balance=$opening+$current;
                    //                 }
                    //                 else {
                    //                $debit=0;
                    //                $credit=$current;
                    //                $balance=$opening+$current;     
                    //                }
                    //                $total_debit += $debit;
                    //                $total_credit += $credit;
                    //                }
                    //                else if($eachThree->id==7)
                    //                {
                    //                 $accountName =  $eachThree->description;
                    //                 $debit = $credit = $balance = $opening = 0;
                    //                 $opening_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                    //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' group by product_id')->queryAll();
                    //                 $opening=0;
                    //                 foreach($opening_in_rate as $eachOpen)
                    //                 {
                    //                 $opening_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOpen["product_id"])->queryScalar();
                    //                 
                    //                 $opening_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOpen["product_id"])->queryScalar();
                    //                 $opening+=($opening_out)*$eachOpen['avg_purchase_rate'];
                    //                 }
                    //                 $current_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                    //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' group by product_id')->queryAll();
                    //                 $current=0;
                    //                 foreach($current_in_rate as $eachCurrent)
                    //                 {
                    //                 $current_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                    //                 $current_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                    //                 $current+=($current_out)*$eachCurrent['avg_purchase_rate'];
                    //                 }
                    //                 if($current>0)
                    //                 {
                    //                 $debit=0;
                    //                 $credit=$current;
                    //                 $balance=1*($opening-$current);
                    //                 }
                    //                 else {
                    //                $debit=$current;
                    //                $credit=0;
                    //                $balance=1*($opening-$current);     
                    //                }
                    //                $total_debit += $debit;
                    //                $total_credit += $credit;
                    //                }
                    //                else {
                    $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachThree->id . ') tmp
                        ) a';
                    $ids = Yii::app()->db->createCommand($query)->queryAll();

                    $debit = $credit = $balance = $opening = 0;
                    $bo = $bc = '';
                    $accountName = $eachThree->description;

                    if ($ids[0]['child'] != '') {
                        $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                        $balance += $opening;
                        $bo = '<b>';
                        $bc = '</b>';
                    } else {
                        $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachThree->id . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();

                        $balance += $opening;

                        $accountName = '<a href="#" onclick="' . getClick($eachThree, $from_date, $to_date) . '">' . $eachThree->description . '</a>';
                    }
                    //                }
                    $table .= '<tr data-id="' . $eachThree->id . '" data-parent="' . $eachTwo->id . '" >
                                    <td>' . $bo . $eachThree->account_no . $bc . '</td>
                                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                    <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening) . $bc . '</td>
                                    <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($debit), " ") . $bc . '</td>
                                    <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($credit), " ") . $bc . '</td>
                                    <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance) . $bc . '</td>
                                </tr>';
                    //LEVEL 4
                    $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachThree->id));
                    foreach ($levelFour as $eachFour) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachFour->id . ') tmp
                                ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $debit = $credit = $balance = $opening = 0;
                        $bo = $bc = '';
                        $accountName = $eachFour->description;

                        if ($ids[0]['child'] != '') {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                            $balance += $opening;
                            $bo = '<b>';
                            $bc = '</b>';
                        } else {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachFour->id . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();

                            $balance += $opening;

                            $accountName = '<a href="#" onclick="' . getClick($eachFour, $from_date, $to_date) . '">' . $eachFour->description . '</a>';
                        }
                        $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                            <td>' . $bo . $eachFour->account_no . $bc . '</td>
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . $bc . '</td>
                                            <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening) . $bc . '</td>
                                            <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($debit), " ") . $bc . '</td>
                                            <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($credit), " ") . $bc . '</td>
                                            <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance) . $bc . '</td>
                                        </tr>';

                        //LEVEL 4
                        $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachFour->id));
                        foreach ($levelFive as $eachFive) {

                            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $eachFive->id . ') tmp
                                    ) a';
                            $ids = Yii::app()->db->createCommand($query)->queryAll();

                            $debit = $credit = $balance = $opening = 0;
                            $bo = $bc = '';
                            $accountName = $eachFive->description;

                            if ($ids[0]['child'] != '') {
                                $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                                $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                                $balance += $opening;
                                $bo = '<b>';
                                $bc = '</b>';
                            } else {
                                $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachFive->id . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                                $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();

                                $balance += $opening;

                                $accountName = '<a href="#" onclick="' . getClick($eachFive, $from_date, $to_date) . '">' . $eachFive->description . '</a>';
                            }
                            $table .= '<tr data-id="' . $eachFive->id . '" data-parent="' . $eachFour->id . '" >
                                                <td>' . $bo . $eachFive->account_no . $bc . '</td>
                                                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                                <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening) . $bc . '</td>
                                                <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($debit), " ") . $bc . '</td>
                                                <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($credit), " ") . $bc . '</td>
                                                <td style="text-align:right !important;" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance) . $bc . '</td>
                                            </tr>';
                        }
                    }
                }
            }
        }
        $table .= '<tr data-id="1000" data-parent="" >
                        <td colspan="3" style="text-align:right !important;"><b>Total</b></td>
                        <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " ") . '</b></td>
                        <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " ") . '</b></td>
                        <td></td>
                </tr>';
        $table .= '</tbody>
                </table>';
        echo $table;
    }

    public function actionTb_excel()
    {
        $brand = (int) $_GET['brand'];
        $outlet = (int) $_GET['outlet'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-d');
        $condition = '';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        // $accountingPeriod = FinanceVoucherType::generateAccountingperiod($to_date);
        $accountingPeriod = $from_date;
        $query = 'CREATE OR REPLACE VIEW {{finance_trialbalance}} AS SELECT
                            L.id AS ledger_id,
                            L.account_no AS ledger_no,
                            L.description AS ledger_name,
                            L.level AS level,
                            L.parent_account AS parent,
                            IFNULL(S.description, "N/A") AS subledger,
                            S.id AS subledger_id,
                            ROUND((SUM(CASE WHEN VI.amount > 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS debit,
                            ROUND((SUM(CASE WHEN VI.amount < 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS credit,
                            ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance
                        FROM {{finance_legder}} L
                        LEFT JOIN {{finance_voucher_items}} VI ON VI.ledger_id = L.id
                        LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id
                        LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                        WHERE V.is_posted="Y" AND L.id!=25 AND V.voucher_date BETWEEN  "' . $from_date . '" AND "' . $to_date . '" AND L.type_of_account IN ("B", "P")' . $condition . ' 
                        GROUP BY L.id, S.id';

        Yii::app()->db->createCommand($query)->execute();

        // Create new PHPExcel object
        Yii::import('ext.PHPExcel.PHPExcel');

        $excel = new PHPExcel();

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Trial Balance")
            ->setSubject("Trial Balance")
            ->setDescription("Trial Balance as From " . $from_date . " to " . $to_date)
            ->setKeywords("Trial Balance")
            ->setCategory("Financial Report");

        // Add some data
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', '#')
            ->setCellValue('B1', 'Particular')
            ->setCellValue('C1', 'Beginning Balance (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('D1', 'Debit (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('E1', 'Credit (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('F1', 'Closing Balance');

        $excel->getActiveSheet()->getStyle('A1:F1')->getFont()->setBold(true)->setSize(12);

        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);

        function get_symbol($value)
        {
            return ($value) > 0 ? ' Dr' : ' Cr';
        }

        //We have 5 levels
        $total_debit = $total_credit = 0;
        $levelOne = FinanceLegder::model()->findAll(array('condition' => 'level=1 AND type_of_account IN ("B", "P") '));
        $rowId = 2;
        foreach ($levelOne as $eachOne) {

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachOne->id . ') tmp
                        ) a';
            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $debit = $credit = $balance = $opening = 0;
            $accountName = $eachOne->description;
            $subledgerCount = 0;

            if ($ids[0]['child'] != '') {
                $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE  H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                $balance += $opening;

                $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setBold(true);
            }

            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, $eachOne->account_no)
                ->setCellValue('B' . $rowId, $accountName)
                ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening))
                ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($debit), " "))
                ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($credit), " "))
                ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance));

            $total_debit += $debit;
            $total_credit += $credit;
            $rowId++;
            //LEVEL 2
            $levelTwo = FinanceLegder::model()->findAll(array('condition' => 'level=2 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelTwo as $eachTwo) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                            SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                            WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                            JOIN
                            (SELECT @pv:=' . $eachTwo->id . ') tmp
                            ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $debit = $credit = $balance = $opening = 0;
                $accountName = $eachTwo->description;
                $subledgerCount = 0;

                if ($ids[0]['child'] != '') {
                    $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                    $balance += $opening;

                    $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setBold(true);
                } else {
                    $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachTwo->id . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();

                    $balance += $opening;

                    $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                }

                $excel->setActiveSheetIndex(0)
                    ->setCellValue('A' . $rowId, $eachTwo->account_no)
                    ->setCellValue('B' . $rowId, $accountName)
                    ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening))
                    ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($debit), " "))
                    ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($credit), " "))
                    ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance));

                if (abs($balance) == 0) {
                    $excel->getActiveSheet()->getRowDimension($rowId)->setVisible(false);
                }

                $rowId++;

                if ($subledgerCount > 0) {
                    foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_trialbalance}} WHERE ledger_id=' . $eachTwo->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {
                        $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id=' . $eachTwo->id . ' AND I.subledger_id=' . (int) $eachSub['subledger_id'] . ' AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                        $excel->setActiveSheetIndex(0)
                            ->setCellValue('B' . $rowId, $eachSub['subledger'])
                            ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening))
                            ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['debit']), " "))
                            ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['credit']), " "))
                            ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['balance']), " ") . get_symbol($eachSub['balance']));

                        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setItalic(true)->setSize(9);
                        $rowId++;
                    }
                }
                //LEVEL 3
                $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachTwo->id));
                foreach ($levelThree as $eachThree) {
                    if ($eachThree->id == 6) {
                        $accountName =  $eachThree->description;
                        $debit = $credit = $balance = $opening = 0;
                        $opening_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $opening = 0;
                        foreach ($opening_in_rate as $eachOpen) {
                            $opening_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();

                            $opening_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();
                            $opening += ($opening_in - $opening_out) * $eachOpen['avg_purchase_rate'];
                        }
                        $current_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $current = 0;
                        foreach ($current_in_rate as $eachCurrent) {
                            $current_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current += ($current_in - $current_out) * $eachCurrent['avg_purchase_rate'];
                        }
                        if ($current > 0) {
                            $debit = $current;
                            $credit = 0;
                            $balance = $opening + $current;
                        } else {
                            $debit = 0;
                            $credit = $current;
                            $balance = $opening + $current;
                        }
                        $total_debit += $debit;
                        $total_credit += $credit;
                    } else if ($eachThree->id == 7) {
                        $accountName =  $eachThree->description;
                        $debit = $credit = $balance = $opening = 0;
                        $opening_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $opening = 0;
                        foreach ($opening_in_rate as $eachOpen) {
                            $opening_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();

                            $opening_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();
                            $opening += ($opening_out) * $eachOpen['avg_purchase_rate'];
                        }
                        $current_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $current = 0;
                        foreach ($current_in_rate as $eachCurrent) {
                            $current_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current += ($current_out) * $eachCurrent['avg_purchase_rate'];
                        }
                        if ($current > 0) {
                            $debit = 0;
                            $credit = $current;
                            $balance = 1 * ($opening - $current);
                        } else {
                            $debit = $current;
                            $credit = 0;
                            $balance = 1 * ($opening - $current);
                        }
                        $total_debit += $debit;
                        $total_credit += $credit;
                    } else {
                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachThree->id . ') tmp
                                ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $debit = $credit = $balance = $opening = 0;
                        $accountName = $eachThree->description;
                        $subledgerCount = 0;

                        if ($ids[0]['child'] != '') {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                            $balance += $opening;

                            $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setBold(true);
                        } else {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachThree->id . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();

                            $balance += $opening;

                            $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                        }
                    }
                    $excel->setActiveSheetIndex(0)
                        ->setCellValue('A' . $rowId, $eachThree->account_no)
                        ->setCellValue('B' . $rowId, $accountName)
                        ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening))
                        ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($debit), " "))
                        ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($credit), " "))
                        ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance));

                    if (abs($balance) == 0) {
                        $excel->getActiveSheet()->getRowDimension($rowId)->setVisible(false);
                    }

                    $rowId++;

                    if ($subledgerCount > 0) {
                        foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_trialbalance}} WHERE ledger_id=' . $eachThree->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id=' . $eachThree->id . ' AND I.subledger_id=' . (int) $eachSub['subledger_id'] . ' AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                            $excel->setActiveSheetIndex(0)
                                ->setCellValue('B' . $rowId, $eachSub['subledger'])
                                ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening))
                                ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['debit']), " "))
                                ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['credit']), " "))
                                ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['balance']), " ") . get_symbol($eachSub['balance']));

                            $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setItalic(true)->setSize(9);
                            $rowId++;
                        }
                    }
                    //LEVEL 4
                    $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachThree->id));
                    foreach ($levelFour as $eachFour) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $eachFour->id . ') tmp
                                    ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $debit = $credit = $balance = $opening = 0;
                        $accountName = $eachFour->description;
                        $subledgerCount = 0;

                        if ($ids[0]['child'] != '') {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                            $balance += $opening;

                            $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setBold(true);
                        } else {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachFour->id . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();

                            $balance += $opening;

                            $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        }

                        $excel->setActiveSheetIndex(0)
                            ->setCellValue('A' . $rowId, $eachFour->account_no)
                            ->setCellValue('B' . $rowId, $accountName)
                            ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening))
                            ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($debit), " "))
                            ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($credit), " "))
                            ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance));

                        if (abs($balance) == 0) {
                            $excel->getActiveSheet()->getRowDimension($rowId)->setVisible(false);
                        }

                        $rowId++;

                        if ($subledgerCount > 0) {
                            foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_trialbalance}} WHERE ledger_id=' . $eachFour->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {
                                $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id=' . $eachFour->id . ' AND I.subledger_id=' . (int) $eachSub['subledger_id'] . ' AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                                $excel->setActiveSheetIndex(0)
                                    ->setCellValue('B' . $rowId, $eachSub['subledger'])
                                    ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening))
                                    ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['debit']), " "))
                                    ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['credit']), " "))
                                    ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['balance']), " ") . get_symbol($eachSub['balance']));

                                $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setItalic(true)->setSize(9);
                                $rowId++;
                            }
                        }

                        //LEVEL 5
                        $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachFour->id));
                        foreach ($levelFive as $eachFive) {

                            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                        JOIN
                                        (SELECT @pv:=' . $eachFive->id . ') tmp
                                        ) a';
                            $ids = Yii::app()->db->createCommand($query)->queryAll();

                            $debit = $credit = $balance = $opening = 0;
                            $accountName = $eachFive->description;
                            $subledgerCount = 0;

                            if ($ids[0]['child'] != '') {
                                $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                                $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                                $balance += $opening;

                                $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setBold(true);
                            } else {
                                $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachFive->id . ') AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                                $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();

                                $balance += $opening;

                                $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            }

                            $excel->setActiveSheetIndex(0)
                                ->setCellValue('A' . $rowId, $eachFive->account_no)
                                ->setCellValue('B' . $rowId, $accountName)
                                ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening))
                                ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($debit), " "))
                                ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($credit), " "))
                                ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance));

                            if (abs($balance) == 0) {
                                $excel->getActiveSheet()->getRowDimension($rowId)->setVisible(false);
                            }

                            $rowId++;

                            if ($subledgerCount > 0) {
                                foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_trialbalance}} WHERE ledger_id=' . $eachFive->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {
                                    $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id=' . $eachFive->id . ' AND I.subledger_id=' . (int) $eachSub['subledger_id'] . ' AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                                    $excel->setActiveSheetIndex(0)
                                        ->setCellValue('B' . $rowId, $eachSub['subledger'])
                                        ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening))
                                        ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['debit']), " "))
                                        ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['credit']), " "))
                                        ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['balance']), " ") . get_symbol($eachSub['balance']));

                                    $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setItalic(true)->setSize(9);
                                    $rowId++;
                                }
                            }
                        }
                    }
                }
            }
        }

        $excel->getActiveSheet()->getStyle('A' . $rowId . ':E' . $rowId)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $rowId . ':C' . $rowId);

        $excel->getActiveSheet()->getStyle('C2:C' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('D2:D' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('E2:E' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('F2:F' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);

        $excel->setActiveSheetIndex(0)
            ->setCellValue('A' . $rowId, 'Total')
            ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " "))
            ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " "));

        // Rename worksheet
        $excel->getActiveSheet()->setTitle('Trial Balance');

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="trial_balance.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionTb_pdf_level()
    {
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false);
        $this->render('tb_level_filter', array('from_date' => $_GET['from_date'], 'to_date' => $_GET['to_date'], 'brand' => (int) $_GET['brand'], 'outlet' => (int) $_GET['outlet']));
    }

    public function actionTb_pdf()
    {
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-d');
        // $accountingPeriod = FinanceVoucherType::generateAccountingperiod($to_date);
        $accountingPeriod = $from;
        $level = in_array((int) $_GET['level'], array(1, 2, 3, 4, 5)) ? (int) $_GET['level'] : 5;
        $condition = '';
        $outlet = (int) $_GET['outlet'];
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        $query = 'CREATE OR REPLACE VIEW {{finance_trialbalance}} AS SELECT
                    L.id AS ledger_id,
                    L.account_no AS ledger_no,
                    L.description AS ledger_name,
                    L.level AS level,
                    L.parent_account AS parent,
                    IFNULL(S.description, "N/A") AS subledger,
                    IFNULL(S.id, 0) AS subledger_id,
                    ROUND((SUM(CASE WHEN VI.amount > 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS debit,
                    ROUND((SUM(CASE WHEN VI.amount < 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS credit,
                    ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance
                FROM {{finance_legder}} L
                LEFT JOIN {{finance_voucher_items}} VI ON VI.ledger_id = L.id
                LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id
                LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                WHERE V.is_posted="Y" AND L.id!=25 AND V.voucher_date BETWEEN  "' . $from_date . '" AND "' . $to_date . '" AND L.type_of_account IN ("B", "P")' . $condition . '
                GROUP BY L.id, S.id';

        Yii::app()->db->createCommand($query)->execute();

        $table = '<table class="table table-hover table-fixed table-bordered" id="tb_table">
                    <thead>
                        <tr>
                            <th style="width:5%" >#</th>
                            <th style="width:45%" >Particular</th>
                            <th style="width:17%;" >Opening Balance</th>
                            <th style="width:17%;" class="text-right">Debit (' . FinanceLegder::baseCurrency() . ')</th>
                            <th style="width:17%;" class="text-right">Credit (' . FinanceLegder::baseCurrency() . ')</th>
                            <th style="width:17%;" class="text-right">Balance (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';

        function get_symbol($value)
        {
            return ($value) > 0 ? ' Dr' : ' Cr';
        }

        //We have 5 levels
        $total_debit = $total_credit = 0;
        $levelOne = FinanceLegder::model()->findAll(array('condition' => 'level=1 AND type_of_account IN ("B", "P") '));
        foreach ($levelOne as $eachOne) {

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                JOIN
                (SELECT @pv:=' . $eachOne->id . ') tmp
                ) a';
            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $debit = $credit = $balance = $opening = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE  H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $accountingPeriod['from'] . '" ')->queryScalar();
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                $balance += $opening;
            }

            if (abs($balance) > 0 && $level >= 1) {
                $table .= '<tr>
                            <td><b>' . $eachOne->account_no . '</b></td>
                            <td><b>' . $accountName . '</b></td>
                            <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening) . '</b></td>
                            <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($debit), " ") . '</b></td>
                            <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($credit), " ") . '</b></td>
                            <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance) . '</b></td>
                        </tr>';
            }

            $total_debit += $debit;
            $total_credit += $credit;
            //LEVEL 2
            $levelTwo = FinanceLegder::model()->findAll(array('condition' => 'level=2 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelTwo as $eachTwo) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                            SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                            WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                            JOIN
                            (SELECT @pv:=' . $eachTwo->id . ') tmp
                            ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $debit = $credit = $balance = $opening = 0;
                $bo = $bc = '';
                $accountName = $eachTwo->description;

                if ($ids[0]['child'] != '') {
                    $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $accountingPeriod['from'] . '" ')->queryScalar();
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                    $balance += $opening;
                    $bo = '<b>';
                    $bc = '</b>';
                } else {
                    $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachTwo->id . ') AND H.voucher_date < "' . $accountingPeriod['from'] . '" ')->queryScalar();
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();

                    $balance += $opening;
                }
                if (abs($balance) > 0 && $level >= 2) {
                    $table .= '<tr>
                                    <td>' . $bo . $eachTwo->account_no . $bc . '</td>
                                    <td>&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                    <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening) . $bc . '</td>
                                    <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($debit), " ") . $bc . '</td>
                                    <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($credit), " ") . $bc . '</td>
                                    <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance) . $bc . '</td>
                                </tr>';
                }

                //LEVEL 3
                $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachTwo->id));
                foreach ($levelThree as $eachThree) {
                    if ($eachThree->id == 6) {
                        $accountName =  $eachThree->description;
                        $debit = $credit = $balance = $opening = 0;
                        $opening_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $opening = 0;
                        foreach ($opening_in_rate as $eachOpen) {
                            $opening_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();

                            $opening_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();
                            $opening += ($opening_in - $opening_out) * $eachOpen['avg_purchase_rate'];
                        }
                        $current_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $current = 0;
                        foreach ($current_in_rate as $eachCurrent) {
                            $current_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current += ($current_in - $current_out) * $eachCurrent['avg_purchase_rate'];
                        }
                        if ($current > 0) {
                            $debit = $current;
                            $credit = 0;
                            $balance = $opening + $current;
                        } else {
                            $debit = 0;
                            $credit = $current;
                            $balance = $opening + $current;
                        }
                        $total_debit += $debit;
                        $total_credit += $credit;
                    } else if ($eachThree->id == 7) {
                        $accountName =  $eachThree->description;
                        $debit = $credit = $balance = $opening = 0;
                        $opening_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $opening = 0;
                        foreach ($opening_in_rate as $eachOpen) {
                            $opening_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();

                            $opening_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();
                            $opening += ($opening_out) * $eachOpen['avg_purchase_rate'];
                        }
                        $current_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $current = 0;
                        foreach ($current_in_rate as $eachCurrent) {
                            $current_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current += ($current_out) * $eachCurrent['avg_purchase_rate'];
                        }
                        if ($current > 0) {
                            $debit = 0;
                            $credit = $current;
                            $balance = 1 * ($opening - $current);
                        } else {
                            $debit = $current;
                            $credit = 0;
                            $balance = 1 * ($opening - $current);
                        }
                        $total_debit += $debit;
                        $total_credit += $credit;
                    } else {
                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachThree->id . ') tmp
                                ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $debit = $credit = $balance = $opening = 0;
                        $bo = $bc = '';
                        $accountName = $eachThree->description;

                        if ($ids[0]['child'] != '') {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $accountingPeriod['from'] . '" ')->queryScalar();
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                            $balance += $opening;
                            $bo = '<b>';
                            $bc = '</b>';
                        } else {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachThree->id . ') AND H.voucher_date < "' . $accountingPeriod['from'] . '" ')->queryScalar();
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();

                            $balance += $opening;
                        }
                    }
                    if (abs($balance) > 0 && $level >= 3) {
                        $table .= '<tr>
                                        <td>' . $bo . $eachThree->account_no . $bc . '</td>
                                        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                        <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening) . $bc . '</td>
                                        <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($debit), " ") . $bc . '</td>
                                        <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($credit), " ") . $bc . '</td>
                                        <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance) . $bc . '</td>
                                    </tr>';
                    }

                    //LEVEL 4
                    $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachThree->id));
                    foreach ($levelFour as $eachFour) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $eachFour->id . ') tmp
                                    ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $debit = $credit = $balance = $opening = 0;
                        $bo = $bc = '';
                        $accountName = $eachFour->description;

                        if ($ids[0]['child'] != '') {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $accountingPeriod['from'] . '" ')->queryScalar();
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                            $balance += $opening;
                            $bo = '<b>';
                            $bc = '</b>';
                        } else {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachFour->id . ') AND H.voucher_date < "' . $accountingPeriod['from'] . '" ')->queryScalar();
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();

                            $balance += $opening;
                        }
                        if (abs($balance) > 0 && $level >= 4) {
                            $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                    <td>' . $bo . $eachFour->account_no . $bc . '</td>
                                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . $bc . '</td>
                                    <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening) . $bc . '</td>
                                    <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($debit), " ") . $bc . '</td>
                                    <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($credit), " ") . $bc . '</td>
                                    <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance) . $bc . '</td>
                                </tr>';
                        }

                        //LEVEL 4
                        $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("B", "P")  AND parent_account=' . (int) $eachFour->id));
                        foreach ($levelFive as $eachFive) {

                            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                        JOIN
                                        (SELECT @pv:=' . $eachFive->id . ') tmp
                                        ) a';
                            $ids = Yii::app()->db->createCommand($query)->queryAll();

                            $debit = $credit = $balance = $opening = 0;
                            $bo = $bc = '';
                            $accountName = $eachFive->description;

                            if ($ids[0]['child'] != '') {
                                $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $ids[0]['child'] . ') AND H.voucher_date < "' . $accountingPeriod['from'] . '" ')->queryScalar();
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                                $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();

                                $bo = '<b>';
                                $bc = '</b>';
                            } else {
                                $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id IN (' . $eachFive->id . ') AND H.voucher_date < "' . $accountingPeriod['from'] . '" ')->queryScalar();
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                                $credit = Yii::app()->db->createCommand('SELECT SUM(credit) AS credit FROM {{finance_trialbalance}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();

                                $balance += $opening;
                            }
                            if (abs($balance) > 0 && $level >= 5) {
                                $table .= '<tr>
                                            <td>' . $bo . $eachFive->account_no . $bc . '</td>
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                            <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($opening), " ") . get_symbol($opening) . $bc . '</td>
                                            <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($debit), " ") . $bc . '</td>
                                            <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($credit), " ") . $bc . '</td>
                                            <td class="text-right" >' . $bo . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . get_symbol($balance) . $bc . '</td>
                                        </tr>';
                            }
                        }
                    }
                }
            }
        }
        $table .= '<tr>
                        <td colspan="3" class="text-right"><b>Total</b></td>
                        <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " ") . '</b></td>
                        <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " ") . '</b></td>
                        <td></td>
                </tr>';
        $table .= '</tbody>
            </table>';

        $param = array('table' => $table, 'from_date' => date('d/m/Y', strtotime($accountingPeriod['from'])), 'to_date' => date('d/m/Y', strtotime($to_date)));
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf_tb_report', $param, true));
        $mpdf->Output("trialbalance" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionBs_report()
    {
        $this->render('bs_report');
    }

    public function actionBs_html()
    {
        $brand = (int) $_POST['brand'];
        $outlet = (int) $_POST['outlet'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        // $accountingPeriod = FinanceVoucherType::generateAccountingperiod($to_date);
        $accountingPeriod = $from_date;

        $balanceQuery = 'SELECT ROUND((SUM(VI.amount*VI.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} VI LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id LEFT JOIN {{finance_legder}} L ON VI.ledger_id = L.id WHERE  V.is_posted="Y" AND  L.main_account_type IN ("I", "E") AND V.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        $grossProfitorloss = Yii::app()->db->createCommand($balanceQuery)->queryScalar();

        $voucherHead = array();
        $voucherHead['voucher_type'] = 11; //Year Closing
        $voucherHead['voucher_no'] = date('Y', strtotime($to_date));
        $voucherHead['voucher_date'] = $to_date;
        $voucherHead['header_table_id'] = 0;
        $voucherHead['reference_no'] = 'System generated voucher';
        $voucherHead['is_posted'] = 'Y';
        $voucherHead['created_by'] = Yii::app()->user->id;
        $voucherHead['created_datetime'] = date('Y-m-d h:i:s');

        $lastSavedid = $this->addVoucherhead($voucherHead);
        if ($lastSavedid > 0) {
            $this->addVoucheritems($lastSavedid, array('narration' => 'Current Year Profit', 'amount' => $grossProfitorloss, 'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('current_year_profit'), 'currency' => MasCurrency::base_currency_id(), 'exchange_rate' => 1));
        }
        $condition = '';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        $query = 'CREATE OR REPLACE VIEW {{finance_balance_sheet}} AS SELECT
                            L.id AS ledger_id,
                            L.account_no AS ledger_no,
                            L.description AS ledger_name,
                            L.level AS level,
                            L.parent_account AS parent,
                            IFNULL(S.description, "N/A") AS subledger,
                            IFNULL(S.id, 0) AS subledger_id,
                            ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance
                        FROM {{finance_legder}} L
                        LEFT JOIN {{finance_voucher_items}} VI ON VI.ledger_id = L.id
                        LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id
                        LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                        WHERE V.is_posted="Y" AND L.id!=25 AND V.voucher_date >= "' . $from_date . '" AND V.voucher_date <= "' . $to_date . '" AND L.type_of_account IN ("B")  ' . $condition . '
                        GROUP BY L.id, S.id';
        Yii::app()->db->createCommand($query)->execute();

        function get_symbol($value)
        {
            return $value >= 0 ? '' : '(-)';
        }

        function addSpace($value)
        {
            $space = '';
            for ($i = 0; $i <= $value; $i++) {
                $space .= '&nbsp;';
            }

            return $space;
        }

        function getClick($model, $from_date, $to_date)
        {
            return ($model->haveSubledger == 'Y') ? 'js:load_summary(' . $model->id . ', \'' . date('d/m/Y', strtotime($from_date)) . '\', \'' . date('d/m/Y', strtotime($to_date)) . '\');' : 'js:load_gl_report(' . $model->id . ', 0, \'' . date('d/m/Y', strtotime($from_date)) . '\', \'' . date('d/m/Y', strtotime($to_date)) . '\');';
        }

        //We have 5 levels
        $table = '';
        $levelOne = FinanceLegder::model()->findAll(array('condition' => 'level=1 AND type_of_account IN ("B") '));
        foreach ($levelOne as $p => $eachOne) {
            $grandTotal = 0;
            $table .= '<table class="table table-hover table-fixed table-bordered" id="bs_table_' . ($p + 1) . '">
                        <thead>
                            <tr>
                                <th style="width:40%">' . $eachOne->description . '</th>
                                <th style="width:60%">Balance</th>
                            </tr>
                        </thead>
                    <tbody>';

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachOne->id . ') tmp
                     ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
            }

            $table .= '<tr data-id="' . $eachOne->id . '" data-parent="" >
                            <td><b>' . $accountName . '</b></td>
                            <td style="text-align:right !important;" ><b>' . get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . '</b></td>
                        </tr>';

            $grandTotal += $balance;
            //LEVEL 2
            $levelTwo = FinanceLegder::model()->findAll(array('condition' => 'level=2 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelTwo as $eachTwo) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                    JOIN
                    (SELECT @pv:=' . $eachTwo->id . ') tmp
                    ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $balance = 0;
                $bo = $bc = '';
                $accountName = $eachTwo->description;

                if ($ids[0]['child'] != '') {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $bo = '<b>';
                    $bc = '</b>';
                } else {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                    $accountName = '<a href="#" onclick="' . getClick($eachTwo, $accountingPeriod, $to_date) . '">' . $eachTwo->description . '</a>';
                }

                if (abs($balance) != 0) {
                    $table .= '<tr data-id="' . $eachTwo->id . '" data-parent="' . $eachOne->id . '" >
                                <td>&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                <td style="text-align:right !important;" >' . $bo . get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . $bc . addSpace(30) . '</td>
                            </tr>';
                }

                //LEVEL 3
                $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachTwo->id));
                foreach ($levelThree as $eachThree) {
                    if ($eachThree->id == 6) {
                        $accountName =  $eachThree->description;
                        $debit = $credit = $balance = $opening = 0;
                        $opening_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $opening = 0;
                        foreach ($opening_in_rate as $eachOpen) {
                            $opening_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();

                            $opening_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();
                            $opening += ($opening_in - $opening_out) * $eachOpen['avg_purchase_rate'];
                        }
                        $current_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $current = 0;
                        foreach ($current_in_rate as $eachCurrent) {
                            $current_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current += ($current_in - $current_out) * $eachCurrent['avg_purchase_rate'];
                        }
                        if ($current > 0) {
                            $debit = $current;
                            $credit = 0;
                            $balance = $opening + $current;
                        } else {
                            $debit = 0;
                            $credit = $current;
                            $balance = $opening + $current;
                        }
                        $total_debit += $debit;
                        $total_credit += $credit;
                    }
                    //                else if($eachThree->id==7)
                    //                {
                    //                 $accountName =  $eachThree->description;
                    //                 $debit = $credit = $balance = $opening = 0;
                    //                 $opening_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                    //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' group by product_id')->queryAll();
                    //                 $opening=0;
                    //                 foreach($opening_in_rate as $eachOpen)
                    //                 {
                    //                 $opening_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOne["product_id"])->queryScalar();
                    //                 
                    //                 $opening_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOne["product_id"])->queryScalar();
                    //                 $opening+=($opening_out)*$eachOpen['avg_purchase_rate'];
                    //                 }
                    //                 $current_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                    //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' group by product_id')->queryAll();
                    //                 $current=0;
                    //                 foreach($current_in_rate as $eachCurrent)
                    //                 {
                    //                 $current_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                    //                 $current_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                    //                 $current+=($current_out)*$eachCurrent['avg_purchase_rate'];
                    //                 }
                    //                 if($current>0)
                    //                 {
                    //                 $debit=0;
                    //                 $credit=$current;
                    //                 $balance=1*($opening-$current);
                    //                 }
                    //                 else {
                    //                $debit=$current;
                    //                $credit=0;
                    //                $balance=1*($opening-$current);     
                    //                }
                    //                $total_debit += $debit;
                    //                $total_credit += $credit;
                    //                }
                    else {
                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachThree->id . ') tmp
                        ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $bo = $bc = '';
                        $accountName = $eachThree->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $bo = '<b>';
                            $bc = '</b>';
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                            $accountName = '<a href="#" onclick="' . getClick($eachThree, $accountingPeriod, $to_date) . '">' . $eachThree->description . '</a>';
                        }
                    }
                    if (abs($balance) != 0) {
                        $table .= '<tr data-id="' . $eachThree->id . '" data-parent="' . $eachTwo->id . '" >
                                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                    <td style="text-align:right !important;" >' . $bo . get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . $bc . addSpace(60) . '</td>
                                </tr>';
                    }

                    //LEVEL 4
                    $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachThree->id));
                    foreach ($levelFour as $eachFour) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachFour->id . ') tmp
                                ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $bo = $bc = '';
                        $accountName = $eachFour->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $bo = '<b>';
                            $bc = '</b>';
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();

                            $accountName = '<a href="#" onclick="' . getClick($eachFour, $accountingPeriod, $to_date) . '">' . $eachFour->description . '</a>';
                        }

                        if (abs($balance) != 0) {
                            $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . $bc . '</td>
                                            <td style="text-align:right !important;" >' . $bo . get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . $bc . addSpace(90) . '</td>
                                        </tr>';
                        }

                        //LEVEL 5
                        $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachFour->id));
                        foreach ($levelFive as $eachFive) {

                            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $eachFive->id . ') tmp
                                    ) a';
                            $ids = Yii::app()->db->createCommand($query)->queryAll();

                            $balance = 0;
                            $bo = $bc = '';
                            $accountName = $eachFive->description;

                            if ($ids[0]['child'] != '') {
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                                $bo = '<b>';
                                $bc = '</b>';
                            } else {
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();

                                $accountName = '<a href="#" onclick="' . getClick($eachFive, $accountingPeriod, $to_date) . '">' . $eachFive->description . '</a>';
                            }

                            if (abs($balance) != 0) {
                                $table .= '<tr data-id="' . $eachFive->id . '" data-parent="' . $eachFour->id . '" >
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                            <td style="text-align:right !important;" >' . $bo . get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . $bc . addSpace(120) . '</td>
                                        </tr>';
                            }
                        }
                    }
                }
            }

            $table .= '<tr data-id="1000" data-parent="" >
                            <td style="text-align:right !important;"><b>Total</b></td>
                            <td style="text-align:right !important;" ><b>' . get_symbol($grandTotal) . Yii::app()->numberFormatter->formatCurrency(abs($grandTotal), " ") . '</b></td>

                    </tr>';
            $table .= '</tbody>
                </table><br>';
        }

        if ($lastSavedid > 0) {
            FinanceVoucherHead::model()->deletebypk($lastSavedid);
            FinanceVoucherItems::model()->deleteAll('header_id=:refer_id', array(':refer_id' => $lastSavedid));
        }
        echo $table;
    }

    public function actionBs_excel()
    {
        $brand = (int) $_GET['brand'];
        $outlet = (int) $_GET['outlet'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-d');
        // $accountingPeriod = FinanceVoucherType::generateAccountingperiod($to_date);
        $accountingPeriod = $from_date;
        $balanceQuery = 'SELECT ROUND((SUM(VI.amount*VI.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} VI LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id LEFT JOIN {{finance_legder}} L ON VI.ledger_id = L.id WHERE  V.is_posted="Y" AND  L.main_account_type IN ("I", "E") AND V.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        $grossProfitorloss = Yii::app()->db->createCommand($balanceQuery)->queryScalar();

        $voucherHead = array();
        $voucherHead['voucher_type'] = 11; //Year Closing
        $voucherHead['voucher_no'] = date('Y', strtotime($to_date));
        $voucherHead['voucher_date'] = $to_date;
        $voucherHead['header_table_id'] = 0;
        $voucherHead['reference_no'] = 'System generated voucher';
        $voucherHead['is_posted'] = 'Y';
        $voucherHead['created_by'] = Yii::app()->user->id;
        $voucherHead['created_datetime'] = date('Y-m-d h:i:s');

        $lastSavedid = $this->addVoucherhead($voucherHead);
        if ($lastSavedid > 0) {
            $this->addVoucheritems($lastSavedid, array('narration' => 'Current Year Profit', 'amount' => $grossProfitorloss, 'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('current_year_profit'), 'currency' => MasCurrency::base_currency_id(), 'exchange_rate' => 1));
        }

        $condition = '';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }

        $query = 'CREATE OR REPLACE VIEW {{finance_balance_sheet}} AS SELECT
                    L.id AS ledger_id,
                    L.account_no AS ledger_no,
                    L.description AS ledger_name,
                    L.level AS level,
                    L.parent_account AS parent,
                    IFNULL(S.description, "N/A") AS subledger,
                    S.id AS subledger_id,
                    ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance
                FROM {{finance_legder}} L
                LEFT JOIN {{finance_voucher_items}} VI ON VI.ledger_id = L.id
                LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id
                LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                WHERE V.is_posted="Y" AND L.id!=25 AND V.voucher_date >= "' . $from_date . '" AND V.voucher_date <= "' . $to_date . '" AND L.type_of_account IN ("B")  ' . $condition . '
                GROUP BY L.id, S.id';

        Yii::app()->db->createCommand($query)->execute();

        // Create new PHPExcel object
        Yii::import('ext.PHPExcel.PHPExcel');

        $excel = new PHPExcel();

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Balance Sheet")
            ->setSubject("Balance Sheet")
            ->setDescription("Balance Sheet as on date" . $to_date)
            ->setKeywords("Balance Sheet")
            ->setCategory("Financial Report");

        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(6)->setAutoSize(true);

        function get_symbol($value)
        {
            return ($value) > 0 ? '' : '(-)';
        }

        function addSpace($value)
        {
            $space = '';
            for ($i = 0; $i <= $value; $i++) {
                $space .= '  ';
            }

            return $space;
        }

        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Particular')
            ->setCellValue('B1', 'Balance');
        $excel->getActiveSheet()->getStyle('A1:G1')->getFont()->setBold(true)->setSize(18);
        $excel->setActiveSheetIndex(0)->mergeCells('B1:G1');
        $excel->getActiveSheet()->getStyle('A1:G1')->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));
        $style = array(
            'alignment' => array(
                'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
            ),
        );
        $excel->getActiveSheet()->getStyle("B1:G1")->applyFromArray($style);

        $border = array(
            'borders' => array(
                'bottom' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        $borderRight = array(
            'borders' => array(
                'right' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        $borderUp = array(
            'borders' => array(
                'top' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        $rowId++;
        //We have 5 levels
        $rowId = 2;
        $table = '';
        $levelOne = FinanceLegder::model()->findAll(array('condition' => 'level=1 AND type_of_account IN ("B") '));
        foreach ($levelOne as $eachOne) {
            $grandTotal = 0;
            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                         SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                         WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                         JOIN
                         (SELECT @pv:=' . $eachOne->id . ') tmp
                      ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
            }

            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, $accountName)
                ->setCellValue('G' . $rowId, get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " "));
            $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setBold(true)->setSize(16);
            $rowId++;

            $grandTotal += $balance;
            //LEVEL 2
            $levelTwo = FinanceLegder::model()->findAll(array('condition' => 'level=2 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelTwo as $eachTwo) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                     SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                     WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                     JOIN
                     (SELECT @pv:=' . $eachTwo->id . ') tmp
                     ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $balance = 0;
                $accountName = addSpace(1) . $eachTwo->description;
                $subledgerCount = 0;

                if ($ids[0]['child'] != '') {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setBold(true);
                } else {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                    $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                }

                if (abs($balance) == 0) {
                    $excel->getActiveSheet()->getRowDimension($rowId)->setVisible(false);
                }

                if ($subledgerCount > 0) {
                    $excel->getActiveSheet(0)->getStyle('A' . $rowId . ':G' . $rowId)->applyFromArray($border);
                }

                $excel->setActiveSheetIndex(0)
                    ->setCellValue('A' . $rowId, $accountName)
                    ->setCellValue('F' . $rowId, get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " "));
                $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setSize(14);
                $rowId++;

                if ($subledgerCount > 0) {
                    foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_balance_sheet}} WHERE ledger_id=' . $eachTwo->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {
                        $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id=' . $eachTwo->id . ' AND I.subledger_id=' . (int) $eachSub['subledger_id'] . ' AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                        $excel->setActiveSheetIndex(0)
                            ->setCellValue('A' . $rowId, addSpace(3) . $eachSub['subledger'])
                            ->setCellValue('B' . $rowId, get_symbol($eachSub['balance']) . Yii::app()->numberFormatter->formatCurrency(abs($eachSub['balance']), " "));

                        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setItalic(true)->setSize(9);
                        $rowId++;
                    }
                }
                //LEVEL 3
                $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachTwo->id));
                foreach ($levelThree as $eachThree) {
                    if ($eachThree->id == 6) {
                        $accountName =  $eachThree->description;
                        $debit = $credit = $balance = $opening = 0;
                        $opening_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $opening = 0;
                        foreach ($opening_in_rate as $eachOpen) {
                            $opening_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();

                            $opening_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();
                            $opening += ($opening_in - $opening_out) * $eachOpen['avg_purchase_rate'];
                        }
                        $current_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $current = 0;
                        foreach ($current_in_rate as $eachCurrent) {
                            $current_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current += ($current_in - $current_out) * $eachCurrent['avg_purchase_rate'];
                        }
                        if ($current > 0) {
                            $debit = $current;
                            $credit = 0;
                            $balance = $opening + $current;
                        } else {
                            $debit = 0;
                            $credit = $current;
                            $balance = $opening + $current;
                        }
                        $total_debit += $debit;
                        $total_credit += $credit;
                    }
                    //                else if($eachThree->id==7)
                    //                {
                    //                 $accountName =  $eachThree->description;
                    //                 $debit = $credit = $balance = $opening = 0;
                    //                 $opening_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                    //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' group by product_id')->queryAll();
                    //                 $opening=0;
                    //                 foreach($opening_in_rate as $eachOpen)
                    //                 {
                    //                 $opening_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOne["product_id"])->queryScalar();
                    //                 
                    //                 $opening_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOne["product_id"])->queryScalar();
                    //                 $opening+=($opening_out)*$eachOpen['avg_purchase_rate'];
                    //                 }
                    //                 $current_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                    //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' group by product_id')->queryAll();
                    //                 $current=0;
                    //                 foreach($current_in_rate as $eachCurrent)
                    //                 {
                    //                 $current_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                    //                 $current_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                    //                 $current+=($current_out)*$eachCurrent['avg_purchase_rate'];
                    //                 }
                    //                 if($current>0)
                    //                 {
                    //                 $debit=0;
                    //                 $credit=$current;
                    //                 $balance=1*($opening-$current);
                    //                 }
                    //                 else {
                    //                $debit=$current;
                    //                $credit=0;
                    //                $balance=1*($opening-$current);     
                    //                }
                    //                $total_debit += $debit;
                    //                $total_credit += $credit;
                    //                }
                    else {
                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                         SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                         WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                         JOIN
                         (SELECT @pv:=' . $eachThree->id . ') tmp
                         ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = addSpace(2) . $eachThree->description;
                        $subledgerCount = 0;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setBold(true);
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                            $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                        }
                    }
                    if (abs($balance) == 0) {
                        $excel->getActiveSheet()->getRowDimension($rowId)->setVisible(false);
                    }

                    if ($subledgerCount > 0) {
                        $excel->getActiveSheet(0)->getStyle('A' . $rowId . ':G' . $rowId)->applyFromArray($border);
                    }

                    $excel->setActiveSheetIndex(0)
                        ->setCellValue('A' . $rowId, $accountName)
                        ->setCellValue('E' . $rowId, get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " "));
                    $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setSize(12);
                    $rowId++;

                    if ($subledgerCount > 0) {
                        foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_balance_sheet}} WHERE ledger_id=' . $eachThree->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {
                            $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id=' . $eachThree->id . ' AND I.subledger_id=' . (int) $eachSub['subledger_id'] . ' AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                            $excel->setActiveSheetIndex(0)
                                ->setCellValue('A' . $rowId, addSpace(4) . $eachSub['subledger'])
                                ->setCellValue('B' . $rowId, get_symbol($eachSub['balance']) . Yii::app()->numberFormatter->formatCurrency(abs($eachSub['balance']), " "));

                            $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setItalic(true)->setSize(9);
                            $rowId++;
                        }
                    }
                    //LEVEL 4
                    $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachThree->id));
                    foreach ($levelFour as $eachFour) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                 SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                 WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                 JOIN
                                 (SELECT @pv:=' . $eachFour->id . ') tmp
                                 ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = addSpace(5) . $eachFour->description;
                        $subledgerCount = 0;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setBold(true);
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                            $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        }

                        if (abs($balance) == 0) {
                            $excel->getActiveSheet()->getRowDimension($rowId)->setVisible(false);
                        }

                        if ($subledgerCount > 0) {
                            $excel->getActiveSheet(0)->getStyle('A' . $rowId . ':G' . $rowId)->applyFromArray($border);
                        }

                        $excel->setActiveSheetIndex(0)
                            ->setCellValue('A' . $rowId, $accountName)
                            ->setCellValue('D' . $rowId, get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " "));
                        $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setSize(11);
                        $rowId++;

                        if ($subledgerCount > 0) {
                            foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_balance_sheet}} WHERE ledger_id=' . $eachFour->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {
                                $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id=' . $eachFour->id . ' AND I.subledger_id=' . (int) $eachSub['subledger_id'] . ' AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                                $excel->setActiveSheetIndex(0)
                                    ->setCellValue('A' . $rowId, addSpace(7) . $eachSub['subledger'])
                                    ->setCellValue('B' . $rowId, get_symbol($eachSub['balance']) . Yii::app()->numberFormatter->formatCurrency(abs($eachSub['balance']), " "));

                                $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setItalic(true)->setSize(9);
                                $rowId++;
                            }
                        }
                        //LEVEL 5
                        $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachFour->id));
                        foreach ($levelFive as $eachFive) {

                            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                     SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                     WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                     JOIN
                                     (SELECT @pv:=' . $eachFive->id . ') tmp
                                     ) a';
                            $ids = Yii::app()->db->createCommand($query)->queryAll();

                            $balance = 0;
                            $accountName = addSpace(8) . $eachFive->description;
                            $subledgerCount = 0;

                            if ($ids[0]['child'] != '') {
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                                $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setBold(true);
                            } else {
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                                $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            }
                            if (abs($balance) == 0) {
                                $excel->getActiveSheet()->getRowDimension($rowId)->setVisible(false);
                            }

                            if ($subledgerCount > 0) {
                                $excel->getActiveSheet(0)->getStyle('A' . $rowId . ':G' . $rowId)->applyFromArray($border);
                            }

                            $excel->setActiveSheetIndex(0)
                                ->setCellValue('A' . $rowId, $accountName)
                                ->setCellValue('C' . $rowId, get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " "));
                            $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setSize(10);
                            $rowId++;

                            if ($subledgerCount > 0) {
                                foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_balance_sheet}} WHERE ledger_id=' . $eachFive->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {
                                    $opening = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE H.is_posted = "Y" AND I.ledger_id=' . $eachFive->id . ' AND I.subledger_id=' . (int) $eachSub['subledger_id'] . ' AND H.voucher_date < "' . $from_date . '" ')->queryScalar();
                                    $excel->setActiveSheetIndex(0)
                                        ->setCellValue('A' . $rowId, addSpace(10) . $eachSub['subledger'])
                                        ->setCellValue('B' . $rowId, get_symbol($eachSub['balance']) . Yii::app()->numberFormatter->formatCurrency(abs($eachSub['balance']), " "));

                                    $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setItalic(true)->setSize(9);
                                    $rowId++;
                                }
                            }
                        }
                    }
                }
            }
            $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFill()->applyFromArray(array(
                'type' => PHPExcel_Style_Fill::FILL_SOLID,
                'startcolor' => array(
                    'rgb' => 'd9d9d9',
                ),
            ));
            $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId)->getFont()->setBold(true)->setSize(18);
            $excel->setActiveSheetIndex(0)->mergeCells('A' . $rowId . ':F' . $rowId);
            $excel->getActiveSheet(0)->getStyle('G' . $rowId)->applyFromArray($borderUp);
            $excel->getActiveSheet(0)->getStyle('A1:A' . $rowId)->applyFromArray($borderRight);
            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, 'Total' . '(' . FinanceLegder::baseCurrency() . ')')
                ->setCellValue('G' . $rowId, get_symbol($grandTotal) . Yii::app()->numberFormatter->formatCurrency(abs($grandTotal), " "));
            $rowId++;
        }

        $excel->getActiveSheet()->getStyle('B2:B' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('C2:C' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('D2:D' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('E2:E' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('F2:F' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('G2:G' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);

        // Rename worksheet
        $excel->getActiveSheet()->setTitle('Balance Sheet');

        if ($lastSavedid > 0) {
            FinanceVoucherHead::model()->deletebypk($lastSavedid);
            FinanceVoucherItems::model()->deleteAll('header_id=:refer_id', array(':refer_id' => $lastSavedid));
        }

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="balance_sheet.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionBs_pdf_level()
    {
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false);
        $this->render('bs_level_filter', array('from_date' => $_GET['from_date'], 'to_date' => $_GET['to_date'], 'brand' => (int) $_GET['brand'], 'outlet' => (int) $_GET['outlet']));
    }

    public function actionBs_pdf()
    {
        $brand = (int) $_GET['brand'];
        $outlet = (int) $_GET['outlet'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-d');
        $level = in_array((int) $_GET['level'], array(1, 2, 3, 4, 5)) ? (int) $_GET['level'] : 5;
        // $accountingPeriod = FinanceVoucherType::generateAccountingperiod($to_date);
        $accountingPeriod = $from_date;
        $balanceQuery = 'SELECT ROUND((SUM(VI.amount*VI.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} VI LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id LEFT JOIN {{finance_legder}} L ON VI.ledger_id = L.id WHERE  V.is_posted="Y" AND  L.main_account_type IN ("I", "E") AND V.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        $grossProfitorloss = Yii::app()->db->createCommand($balanceQuery)->queryScalar();

        $voucherHead = array();
        $voucherHead['voucher_type'] = 11; //Year Closing
        $voucherHead['voucher_no'] = date('Y');
        $voucherHead['voucher_date'] = date('Y-m-d');
        $voucherHead['header_table_id'] = 0;
        $voucherHead['reference_no'] = 'System generated voucher';
        $voucherHead['is_posted'] = 'Y';
        $voucherHead['created_by'] = Yii::app()->user->id;
        $voucherHead['created_datetime'] = date('Y-m-d h:i:s');

        $lastSavedid = $this->addVoucherhead($voucherHead);
        if ($lastSavedid > 0) {
            $this->addVoucheritems($lastSavedid, array('narration' => 'Current Year Profit', 'amount' => $grossProfitorloss, 'ledger_id' => FinanceSystemAccountsMapping::getSystemdefault('current_year_profit'), 'currency' => MasCurrency::base_currency_id(), 'exchange_rate' => 1));
        }

        $condition = '';
        if ($outlet > 0) {
            $condition .= ' AND V.outlet=' . $outlet;
        }

        $query = 'CREATE OR REPLACE VIEW {{finance_balance_sheet}} AS SELECT
                            L.id AS ledger_id,
                            L.account_no AS ledger_no,
                            L.description AS ledger_name,
                            L.level AS level,
                            L.parent_account AS parent,
                            IFNULL(S.description, "N/A") AS subledger,
                            IFNULL(S.id, 0) AS subledger_id,
                            ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance
                        FROM {{finance_legder}} L
                        LEFT JOIN {{finance_voucher_items}} VI ON VI.ledger_id = L.id
                        LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id
                        LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                        WHERE V.is_posted="Y" AND L.id!=25 AND V.voucher_date >= "' . $from_date . '" AND V.voucher_date <= "' . $to_date . '" AND L.type_of_account IN ("B") ' . $condition . '
                        GROUP BY L.id, S.id';
        Yii::app()->db->createCommand($query)->execute();

        function get_symbol($value)
        {
            return $value >= 0 ? '' : '(-)';
        }

        function addSpace($value)
        {
            $space = '';
            for ($i = 0; $i <= $value; $i++) {
                $space .= '&nbsp;';
            }

            return $space;
        }

        //We have 5 levels
        $table = '';
        $levelOne = FinanceLegder::model()->findAll(array('condition' => 'level=1 AND type_of_account IN ("B") '));
        foreach ($levelOne as $p => $eachOne) {
            $grandTotal = 0;
            $table .= '<div class="col-md-12">
                        <table class="table table-hover table-fixed table-bordered" id="bs_table_' . ($p + 1) . '">
                        <thead>
                            <tr>
                                <th style="width:40%">' . $eachOne->description . '</th>
                                <th style="width:60%">Balance</th>
                            </tr>
                        </thead>
                    <tbody>';

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachOne->id . ') tmp
                     ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
            }

            if ($level >= 1) {
                $table .= '<tr data-id="' . $eachOne->id . '" data-parent="" >
                            <td><b>' . $accountName . '</b></td>
                            <td class="text-right" ><b>' . get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . '</b></td>
                        </tr>';
            }

            $grandTotal += $balance;
            //LEVEL 2
            $levelTwo = FinanceLegder::model()->findAll(array('condition' => 'level=2 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelTwo as $eachTwo) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                    JOIN
                    (SELECT @pv:=' . $eachTwo->id . ') tmp
                    ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $balance = 0;
                $bo = $bc = '';
                $accountName = $eachTwo->description;

                if ($ids[0]['child'] != '') {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $bo = '<b>';
                    $bc = '</b>';
                } else {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                }

                if (abs($balance) != 0 && $level >= 2) {
                    $table .= '<tr data-id="' . $eachTwo->id . '" data-parent="' . $eachOne->id . '" >
                                <td>&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                <td class="text-right" >' . $bo . get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . $bc . addSpace(25) . '</td>
                            </tr>';
                }

                //LEVEL 3
                $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachTwo->id));
                foreach ($levelThree as $eachThree) {
                    if ($eachThree->id == 6) {
                        $accountName =  $eachThree->description;
                        $debit = $credit = $balance = $opening = 0;
                        $opening_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $opening = 0;
                        foreach ($opening_in_rate as $eachOpen) {
                            $opening_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();

                            $opening_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();
                            $opening += ($opening_in - $opening_out) * $eachOpen['avg_purchase_rate'];
                        }
                        $current_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $current = 0;
                        foreach ($current_in_rate as $eachCurrent) {
                            $current_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current += ($current_in - $current_out) * $eachCurrent['avg_purchase_rate'];
                        }
                        if ($current > 0) {
                            $debit = $current;
                            $credit = 0;
                            $balance = $opening + $current;
                        } else {
                            $debit = 0;
                            $credit = $current;
                            $balance = $opening + $current;
                        }
                        $total_debit += $debit;
                        $total_credit += $credit;
                    }
                    //                else if($eachThree->id==7)
                    //                {
                    //                 $accountName =  $eachThree->description;
                    //                 $debit = $credit = $balance = $opening = 0;
                    //                 $opening_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                    //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' group by product_id')->queryAll();
                    //                 $opening=0;
                    //                 foreach($opening_in_rate as $eachOpen)
                    //                 {
                    //                 $opening_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOne["product_id"])->queryScalar();
                    //                 
                    //                 $opening_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOne["product_id"])->queryScalar();
                    //                 $opening+=($opening_out)*$eachOpen['avg_purchase_rate'];
                    //                 }
                    //                 $current_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                    //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' group by product_id')->queryAll();
                    //                 $current=0;
                    //                 foreach($current_in_rate as $eachCurrent)
                    //                 {
                    //                 $current_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                    //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                    //                 $current_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                    //                 $current+=($current_out)*$eachCurrent['avg_purchase_rate'];
                    //                 }
                    //                 if($current>0)
                    //                 {
                    //                 $debit=0;
                    //                 $credit=$current;
                    //                 $balance=1*($opening-$current);
                    //                 }
                    //                 else {
                    //                $debit=$current;
                    //                $credit=0;
                    //                $balance=1*($opening-$current);     
                    //                }
                    //                $total_debit += $debit;
                    //                $total_credit += $credit;
                    //                }
                    else {
                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachThree->id . ') tmp
                        ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $bo = $bc = '';
                        $accountName = $eachThree->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $bo = '<b>';
                            $bc = '</b>';
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                        }
                    }
                    if (abs($balance) != 0 && $level >= 3) {
                        $table .= '<tr data-id="' . $eachThree->id . '" data-parent="' . $eachTwo->id . '" >
                                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                    <td class="text-right" >' . $bo . get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . $bc . addSpace(50) . '</td>
                                </tr>';
                    }

                    //LEVEL 4
                    $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachThree->id));
                    foreach ($levelFour as $eachFour) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachFour->id . ') tmp
                                ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $bo = $bc = '';
                        $accountName = $eachFour->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $bo = '<b>';
                            $bc = '</b>';
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        }

                        if (abs($balance) != 0 && $level >= 4) {
                            $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . $bc . '</td>
                                            <td class="text-right" >' . $bo . get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . $bc . addSpace(75) . '</td>
                                        </tr>';
                        }

                        //LEVEL 5
                        $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("B")  AND parent_account=' . (int) $eachFour->id));
                        foreach ($levelFive as $eachFive) {

                            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $eachFive->id . ') tmp
                                    ) a';
                            $ids = Yii::app()->db->createCommand($query)->queryAll();

                            $balance = 0;
                            $bo = $bc = '';
                            $accountName = $eachFive->description;

                            if ($ids[0]['child'] != '') {
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                                $bo = '<b>';
                                $bc = '</b>';
                            } else {
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_balance_sheet}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            }

                            if (abs($balance) != 0 && $level >= 5) {
                                $table .= '<tr data-id="' . $eachFive->id . '" data-parent="' . $eachFour->id . '" >
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                            <td class="text-right" >' . $bo . get_symbol($balance) . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . $bc . addSpace(100) . '</td>
                                        </tr>';
                            }
                        }
                    }
                }
            }

            $table .= '<tr data-id="1000" data-parent="" >
                            <td class="text-right"><b>Total (' . FinanceLegder::baseCurrency() . ')</b></td>
                            <td class="text-right" ><b>' . get_symbol($grandTotal) . Yii::app()->numberFormatter->formatCurrency(abs($grandTotal), " ") . '</b></td>

                    </tr>';
            $table .= '</tbody>
                    </table>
                </div>
                <br>';
        }

        if ($lastSavedid > 0) {
            FinanceVoucherHead::model()->deletebypk($lastSavedid);
            FinanceVoucherItems::model()->deleteAll('header_id=:refer_id', array(':refer_id' => $lastSavedid));
        }

        $param = array('table' => $table, 'to_date' => date('d/m/Y', strtotime($to_date)));
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf_bs_report', $param, true));
        $mpdf->Output("balance_sheet" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionPl_report()
    {
        $this->render('pl_report');
    }

    public function actionPl_html()
    {
        $brand = (int) $_POST['brand'];
        $outlet = (int) $_POST['outlet'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = 'V.is_posted="Y" AND L.id!=25 AND V.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND L.type_of_account IN ("P")';
        if ($brand > 0) {
            $condition .= ' AND VI.brand_id=' . $brand;
        }
        $condition = '1=1';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        $query = 'CREATE OR REPLACE VIEW {{finance_profit_and_loss}} AS SELECT
                            L.id AS ledger_id,
                            L.account_no AS ledger_no,
                            L.description AS ledger_name,
                            L.level AS level,
                            L.parent_account AS parent,
                            IFNULL(S.description, "N/A") AS subledger,
                            S.id AS subledger_id,
                            ROUND((SUM(CASE WHEN VI.amount > 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS debit,
                            ROUND((SUM(CASE WHEN VI.amount < 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS credit,
                            ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance
                        FROM {{finance_legder}} L
                        LEFT JOIN {{finance_voucher_items}} VI ON VI.ledger_id = L.id
                        LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id
                        LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                        WHERE ' . $condition . '
                        GROUP BY L.id, S.id';
        Yii::app()->db->createCommand($query)->execute();

        function addSpace($value)
        {
            $space = '';
            for ($i = 0; $i <= $value; $i++) {
                $space .= '&nbsp;';
            }

            return $space;
        }

        function getSymbol($value, $item)
        {
            return (($value <= 0 && $item == 'I') || ($value > 0 && $item == 'E')) ? '' : '(-)';
        }

        function getClick($model, $from_date, $to_date)
        {
            return ($model->haveSubledger == 'Y') ? 'js:load_summary(' . $model->id . ', \'' . date('d/m/Y', strtotime($from_date)) . '\', \'' . date('d/m/Y', strtotime($to_date)) . '\');' : 'js:load_gl_report(' . $model->id . ', 0, \'' . date('d/m/Y', strtotime($from_date)) . '\', \'' . date('d/m/Y', strtotime($to_date)) . '\');';
        }

        //We have 5 levels
        $table = '<table class="table table-hover table-fixed table-bordered" id="pl_table_' . ($p + 1) . '">
                    <thead>
                        <tr>
                            <th style="width:50%">Accounts</th>
                            <th style="width:25%">Debit</th>
                            <th style="width:25%">Credit</th>
                        </tr>
                    </thead>
                <tbody>';
        $totals = array();
        $directIncome = FinanceLegder::model()->findAll(array('condition' => 'classification="DIRECT_INCOME"', 'order' => 'id ASC'));
        $totalDirectincome = 0;
        $totalDirectexpense = 0;
        $totalIndirectincome = 0;
        $totalIndirectexpense = 0;
        //level - 2
        foreach ($directIncome as $p => $eachOne) {

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachOne->id . ') tmp
                     ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $totalDebit = $debit;
                $totalCredit = $credit;

                $totals[] = $balance;
            }

            $table .= '<tr data-id="' . $eachOne->id . '" data-parent="" >
                            <td><b>' . $accountName . '</b></td>
                            <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</b></td>
                            <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</b></td>
                        </tr>';

            $totalDirectincome = $balance;
            //LEVEL 3
            $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelThree as $eachThree) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachThree->id . ') tmp
                        ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $balance = 0;
                $accountName = $eachThree->description;

                if ($ids[0]['child'] != '') {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                } else {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $accountName = '<a href="#" onclick="' . getClick($eachThree, $from_date, $to_date) . '">' . $eachThree->description . '</a>';
                }

                if (abs($balance) != 0) {
                    $table .= '<tr data-id="' . $eachThree->id . '" data-parent="' . $eachOne->id . '" >
                                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                    <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                    <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                </tr>';
                }

                //LEVEL 4
                $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachThree->id));
                foreach ($levelFour as $eachFour) {

                    $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachFour->id . ') tmp
                                ) a';
                    $ids = Yii::app()->db->createCommand($query)->queryAll();

                    $balance = 0;
                    $accountName = $eachFour->description;

                    if ($ids[0]['child'] != '') {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    } else {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();

                        $accountName = '<a href="#" onclick="' . getClick($eachFour, $from_date, $to_date) . '">' . $eachFour->description . '</a>';
                    }

                    if (abs($balance) != 0) {
                        $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                    }

                    //LEVEL 5
                    $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachFour->id));
                    foreach ($levelFive as $eachFive) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $eachFive->id . ') tmp
                                    ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = $eachFive->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();

                            $accountName = '<a href="#" onclick="' . getClick($eachFive, $from_date, $to_date) . '">' . $eachFive->description . '</a>';
                        }

                        if (abs($balance) != 0) {
                            $table .= '<tr data-id="' . $eachFive->id . '" data-parent="' . $eachFour->id . '" >
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                        }
                    }
                }
            }
        }
        $symbol = ($totalDirectincome <= 0) ? '' : '(-)';
        $table .= '<tr>
                                <td colspan="2" style="color:#1F67B2;text-align:right !important;"><b>Total Direct Income (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($totalDirectincome), " ") . '</b></td>
                            </tr>';
        //direct expense
        $directExpense = FinanceLegder::model()->findAll(array('condition' => 'classification="DIRECT_EXPENSE"', 'order' => 'id ASC'));
        //level - 2
        foreach ($directExpense as $p => $eachOne) {

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachOne->id . ') tmp
                     ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $totalDebit = $debit;
                $totalCredit = $credit;

                $totals[] = $balance;
            }

            $table .= '<tr data-id="' . $eachOne->id . '" data-parent="" >
                            <td><b>' . $accountName . '</b></td>
                            <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</b></td>
                            <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</b></td>
                        </tr>';

            $totalDirectexpense = $balance;
            //LEVEL 3
            $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelThree as $eachThree) {
                //            if($eachThree->id==7)
                //                {
                //                 $accountName =  $eachThree->description;
                //                 $debit = $credit = $balance = $opening = 0;
                //                 $opening_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type="GT" AND transaction_date < "' . $from_date . '" '.$conditions.' group by product_id')->queryAll();
                //                 $opening=0;
                //                 foreach($opening_in_rate as $eachOpen)
                //                 {
                //                 $opening_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type="GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOpen["product_id"])->queryScalar();
                //                 
                //                 $opening_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type="GT" AND transaction_date < "' . $from_date . '" '.$conditions.' AND product_id='.$eachOpen["product_id"])->queryScalar();
                //                 $opening+=($opening_out)*$eachOpen['avg_purchase_rate'];
                //                 }
                //                 $current_in_rate=Yii::app()->db->createCommand('SELECT product_id,CASE
                //                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' group by product_id')->queryAll();
                //                 $current=0;
                //                 foreach($current_in_rate as $eachCurrent)
                //                 {
                //                 $current_in=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                //                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type="GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                //                 $current_out=Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type="GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" '.$conditions.' AND product_id='.$eachCurrent["product_id"])->queryScalar();
                //                 $current+=($current_out)*$eachCurrent['avg_purchase_rate'];
                //                 }
                //                 if($current>0)
                //                 {
                //                 $debit=0;
                //                 $credit=$current;
                //                 $balance=1*($opening-$current);
                //                 }
                //                 else {
                //                $debit=$current;
                //                $credit=0;
                //                $balance=-1*($opening-$current);     
                //                }
                //                $total_debit += $debit;
                //                $total_credit += $credit;
                //                $totalDirectexpense+= $balance;
                //                }
                //                else {   
                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachThree->id . ') tmp
                        ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $balance = 0;
                $accountName = $eachThree->description;

                if ($ids[0]['child'] != '') {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                } else {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $accountName = '<a href="#" onclick="' . getClick($eachThree, $from_date, $to_date) . '">' . $eachThree->description . '</a>';
                }
                //                }
                if (abs($balance) != 0) {
                    $table .= '<tr data-id="' . $eachThree->id . '" data-parent="' . $eachOne->id . '" >
                                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                    <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                    <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                </tr>';
                }

                //LEVEL 4
                $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachThree->id));
                foreach ($levelFour as $eachFour) {

                    $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachFour->id . ') tmp
                                ) a';
                    $ids = Yii::app()->db->createCommand($query)->queryAll();

                    $balance = 0;
                    $accountName = $eachFour->description;

                    if ($ids[0]['child'] != '') {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    } else {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();

                        $accountName = '<a href="#" onclick="' . getClick($eachFour, $from_date, $to_date) . '">' . $eachFour->description . '</a>';
                    }

                    if (abs($balance) != 0) {
                        $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                    }

                    //LEVEL 5
                    $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachFour->id));
                    foreach ($levelFive as $eachFive) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $eachFive->id . ') tmp
                                    ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = $eachFive->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();

                            $accountName = '<a href="#" onclick="' . getClick($eachFive, $from_date, $to_date) . '">' . $eachFive->description . '</a>';
                        }

                        if (abs($balance) != 0) {
                            $table .= '<tr data-id="' . $eachFive->id . '" data-parent="' . $eachFour->id . '" >
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                        }
                    }
                }
            }
        }

        $symbol = ($totalDirectexpense >= 0) ? '' : '(-)';
        $table .= '<tr>
                                <td colspan="2" style="color:#1F67B2;text-align:right !important;"><b>Total Direct Expense (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($totalDirectexpense), " ") . '</b></td>
                            </tr>';
        $grossProfit = $totalDirectincome + $totalDirectexpense;
        $symbol = ($grossProfit < 0) ? '' : '(-)';
        $table .= '<tr>
                                <td colspan="2" style="color:#1F67B2;text-align:right !important;"><b>Gross Profit (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($grossProfit), " ") . '</b></td>
                            </tr>';
        //indirect expense
        $indirectExpense = FinanceLegder::model()->findAll(array('condition' => 'classification="INDIRECT_EXPENSE"', 'order' => 'id ASC'));
        //level - 2
        foreach ($indirectExpense as $p => $eachOne) {

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachOne->id . ') tmp
                             ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $totalDebit = $debit;
                $totalCredit = $credit;

                $totals[] = $balance;
            }

            $table .= '<tr data-id="' . $eachOne->id . '" data-parent="" >
                                    <td><b>' . $accountName . '</b></td>
                                    <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</b></td>
                                    <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</b></td>
                                </tr>';

            $totalIndirectexpense = $balance;
            //LEVEL 3
            $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelThree as $eachThree) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachThree->id . ') tmp
                                ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $balance = 0;
                $accountName = $eachThree->description;

                if ($ids[0]['child'] != '') {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                } else {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $accountName = '<a href="#" onclick="' . getClick($eachThree, $from_date, $to_date) . '">' . $eachThree->description . '</a>';
                }

                if (abs($balance) != 0) {
                    $table .= '<tr data-id="' . $eachThree->id . '" data-parent="' . $eachOne->id . '" >
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                }

                //LEVEL 4
                $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachThree->id));
                foreach ($levelFour as $eachFour) {

                    $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                        JOIN
                                        (SELECT @pv:=' . $eachFour->id . ') tmp
                                        ) a';
                    $ids = Yii::app()->db->createCommand($query)->queryAll();

                    $balance = 0;
                    $accountName = $eachFour->description;

                    if ($ids[0]['child'] != '') {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    } else {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();

                        $accountName = '<a href="#" onclick="' . getClick($eachFour, $from_date, $to_date) . '">' . $eachFour->description . '</a>';
                    }

                    if (abs($balance) != 0) {
                        $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                                    <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                                    <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                                </tr>';
                    }

                    //LEVEL 5
                    $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachFour->id));
                    foreach ($levelFive as $eachFive) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                            SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                            WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                            JOIN
                                            (SELECT @pv:=' . $eachFive->id . ') tmp
                                            ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = $eachFive->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();

                            $accountName = '<a href="#" onclick="' . getClick($eachFive, $from_date, $to_date) . '">' . $eachFive->description . '</a>';
                        }

                        if (abs($balance) != 0) {
                            $table .= '<tr data-id="' . $eachFive->id . '" data-parent="' . $eachFour->id . '" >
                                                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                                    <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                                    <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                                </tr>';
                        }
                    }
                }
            }
        }
        $symbol = ($totalIndirectexpense >= 0) ? '' : '(-)';
        $table .= '<tr>
                                <td colspan="2" style="color:#1F67B2;text-align:right !important;"><b>Total Operating Expense (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($totalIndirectexpense), " ") . '</b></td>
                            </tr>';
        //indirect income
        $indirectIncome = FinanceLegder::model()->findAll(array('condition' => 'classification="INDIRECT_INCOME"', 'order' => 'id ASC'));
        //level - 2
        foreach ($indirectIncome as $p => $eachOne) {

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                        JOIN
                                        (SELECT @pv:=' . $eachOne->id . ') tmp
                                     ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $totalDebit = $debit;
                $totalCredit = $credit;

                $totals[] = $balance;
            }

            $table .= '<tr data-id="' . $eachOne->id . '" data-parent="" >
                                            <td><b>' . $accountName . '</b></td>
                                            <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</b></td>
                                            <td style="text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</b></td>
                                        </tr>';

            $totalIndirectincome = $balance;
            //LEVEL 3
            $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelThree as $eachThree) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                        JOIN
                                        (SELECT @pv:=' . $eachThree->id . ') tmp
                                        ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $balance = 0;
                $accountName = $eachThree->description;

                if ($ids[0]['child'] != '') {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                } else {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $accountName = '<a href="#" onclick="' . getClick($eachThree, $from_date, $to_date) . '">' . $eachThree->description . '</a>';
                }

                if (abs($balance) != 0) {
                    $table .= '<tr data-id="' . $eachThree->id . '" data-parent="' . $eachOne->id . '" >
                                                    <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                                    <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                                    <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                                </tr>';
                }

                //LEVEL 4
                $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachThree->id));
                foreach ($levelFour as $eachFour) {

                    $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                                JOIN
                                                (SELECT @pv:=' . $eachFour->id . ') tmp
                                                ) a';
                    $ids = Yii::app()->db->createCommand($query)->queryAll();

                    $balance = 0;
                    $accountName = $eachFour->description;

                    if ($ids[0]['child'] != '') {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    } else {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();

                        $accountName = '<a href="#" onclick="' . getClick($eachFour, $from_date, $to_date) . '">' . $eachFour->description . '</a>';
                    }

                    if (abs($balance) != 0) {
                        $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                                        </tr>';
                    }

                    //LEVEL 5
                    $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachFour->id));
                    foreach ($levelFive as $eachFive) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                                    JOIN
                                                    (SELECT @pv:=' . $eachFive->id . ') tmp
                                                    ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = $eachFive->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();

                            $accountName = '<a href="#" onclick="' . getClick($eachFive, $from_date, $to_date) . '">' . $eachFive->description . '</a>';
                        }

                        if (abs($balance) != 0) {
                            $table .= '<tr data-id="' . $eachFive->id . '" data-parent="' . $eachFour->id . '" >
                                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                                        </tr>';
                        }
                    }
                }
            }
        }
        $symbol = ($totalIndirectincome <= 0) ? '' : '(-)';
        $table .= '<tr>
                                <td colspan="2" style="color:#1F67B2;text-align:right !important;"><b>Total Indirect Income (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($totalIndirectincome), " ") . '</b></td>
                            </tr>';
        $netProfit = $totalDirectincome + $totalDirectexpense + $totalIndirectexpense + $totalIndirectincome;
        $symbol = ($netProfit < 0) ? '' : '(-)';
        $table .= '<tr>
                                <td colspan="2" style="color:#1F67B2;text-align:right !important;"><b>Net Profit (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " ") . '</b></td>
                            </tr>';
        $table .= '</tbody>
                </table>';
        echo $table;
    }

    public function actionPl_excel()
    {
        $brand = (int) $_GET['brand'];
        $outlet = (int) $_GET['outlet'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-d');
        $condition = 'V.is_posted="Y" AND L.id!=25 AND V.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND L.type_of_account IN ("P")';
        if ($brand > 0) {
            $condition .= ' AND VI.brand_id=' . $brand;
        }
        $condition = '1=1';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        $query = 'CREATE OR REPLACE VIEW {{finance_profit_and_loss}} AS SELECT
                            L.id AS ledger_id,
                            L.account_no AS ledger_no,
                            L.description AS ledger_name,
                            L.level AS level,
                            L.parent_account AS parent,
                            IFNULL(S.description, "N/A") AS subledger,
                            S.id AS subledger_id,
                            ROUND((SUM(CASE WHEN VI.amount > 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS debit,
                            ROUND((SUM(CASE WHEN VI.amount < 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS credit,
                            ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance
                        FROM {{finance_legder}} L
                        LEFT JOIN {{finance_voucher_items}} VI ON VI.ledger_id = L.id
                        LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id
                        LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                        WHERE ' . $condition . '
                        GROUP BY L.id, S.id';
        Yii::app()->db->createCommand($query)->execute();

        function addSpace($value)
        {
            $space = '';
            for ($i = 0; $i <= $value; $i++) {
                $space .= ' ';
            }

            return $space;
        }
        function getSymbol($value, $item)
        {
            return (($value <= 0 && $item == 'I') || ($value > 0 && $item == 'E')) ? '' : '(-)';
        }

        //We have 5 levels
        $table = '';
        $totals = array();
        $levelOne = FinanceLegder::model()->findAll(array('condition' => 'level=1 AND type_of_account IN ("P") ', 'order' => 'id ASC'));
        $rowId = 2;

        // Create new PHPExcel object
        Yii::import('ext.PHPExcel.PHPExcel');

        $excel = new PHPExcel();

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Profit and Loss")
            ->setSubject("Profit and Loss")
            ->setDescription("Profit and Loss as on date" . $to_date)
            ->setKeywords("Profit and Loss")
            ->setCategory("Financial Report");

        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);

        $content = $brand > 0 ? 'Profit and Loss for the Period ' . date('d/m/Y', strtotime($from_date)) . ' to ' . date('d/m/Y', strtotime($to_date)) . ' for Brand ' . $brandModel->description : 'Profit and Loss for the Period ' . date('d/m/Y', strtotime($from_date)) . ' to ' . date('d/m/Y', strtotime($to_date));
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', $content);
        $excel->setActiveSheetIndex(0)->mergeCells('A1:C1');
        $excel->getActiveSheet()->getStyle('A1:C1')->getFont()->setBold(true)->setSize(15);

        foreach ($levelOne as $p => $eachOne) {
            $grandTotal = 0;
            $totalDebit = $totalCredit = 0;

            $headingOne = ($eachOne->main_account_type == 'I') ? 'Funds Out' : 'Funds In';
            $headingTwo = ($eachOne->main_account_type == 'I') ? 'Funds In' : 'Funds Out';
            $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setBold(true)->setSize(15);

            $excel->getActiveSheet(0)->getStyle('A' . $rowId . ':C' . $rowId)->applyFromArray(array(
                'borders' => array(
                    'bottom' => array(
                        'style' => PHPExcel_Style_Border::BORDER_THIN,
                        'color' => array('argb' => '#1E1F20'),
                    ),
                ),
            ));

            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, 'Particular')
                ->setCellValue('B' . $rowId, $headingOne)
                ->setCellValue('C' . $rowId, $headingTwo);
            $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFill()->applyFromArray(array(
                'type' => PHPExcel_Style_Fill::FILL_SOLID,
                'startcolor' => array(
                    'rgb' => 'd9d9d9',
                ),
            ));
            $rowId++;

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachOne->id . ') tmp
                     ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $totalDebit = $debit;
                $totalCredit = $credit;
                $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setBold(true)->setSize(15);
                $totals[] = $balance;
            }

            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, $accountName)
                ->setCellValue('B' . $rowId, Yii::app()->numberFormatter->formatCurrency($debit, " "))
                ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency($credit, " "));
            $rowId++;

            $grandTotal += $balance;
            //LEVEL 2
            $levelTwo = FinanceLegder::model()->findAll(array('condition' => 'level=2 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelTwo as $eachTwo) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                    JOIN
                    (SELECT @pv:=' . $eachTwo->id . ') tmp
                    ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $balance = 0;
                $bo = $bc = '';
                $accountName = $eachTwo->description;
                $subledgerCount = 0;

                if ($ids[0]['child'] != '') {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setBold(true)->setSize(14);
                } else {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                    $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachTwo->id . ')')->queryScalar();
                }

                if (abs($balance) != 0) {
                    $excel->setActiveSheetIndex(0)
                        ->setCellValue('A' . $rowId, addSpace(5) . $accountName)
                        ->setCellValue('B' . $rowId, Yii::app()->numberFormatter->formatCurrency($debit, " "))
                        ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                    $rowId++;
                }

                if ($subledgerCount > 0) {
                    foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_profit_and_loss}} WHERE ledger_id=' . $eachTwo->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {

                        $excel->setActiveSheetIndex(0)
                            ->setCellValue('A' . $rowId, addSpace(8) . $eachSub['subledger'])
                            ->setCellValue('B' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['debit']), " "))
                            ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['credit']), " "));

                        $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setItalic(true)->setSize(9);
                        $rowId++;
                    }
                }

                //LEVEL 3
                $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachTwo->id));
                foreach ($levelThree as $eachThree) {
                    if ($eachThree->id == 7) {
                        $accountName =  $eachThree->description;
                        $debit = $credit = $balance = $opening = 0;
                        $opening_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type="GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $opening = 0;
                        foreach ($opening_in_rate as $eachOpen) {
                            $opening_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type="GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();

                            $opening_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type="GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();
                            $opening += ($opening_out) * $eachOpen['avg_purchase_rate'];
                        }
                        $current_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' group by product_id')->queryAll();
                        $current = 0;
                        foreach ($current_in_rate as $eachCurrent) {
                            $current_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type="GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type="GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                            $current += ($current_out) * $eachCurrent['avg_purchase_rate'];
                        }
                        if ($current > 0) {
                            $debit = 0;
                            $credit = $current;
                            $balance = 1 * ($opening - $current);
                        } else {
                            $debit = $current;
                            $credit = 0;
                            $balance = -1 * ($opening - $current);
                        }
                        $total_debit += $debit;
                        $total_credit += $credit;
                        $totalDirectexpense += $balance;
                    } else {
                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                        JOIN
                        (SELECT @pv:=' . $eachThree->id . ') tmp
                        ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = $eachThree->description;
                        $subledgerCount = 0;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setBold(true)->setSize(12);
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                            $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                        }
                    }
                    if (abs($balance) != 0) {
                        $excel->setActiveSheetIndex(0)
                            ->setCellValue('A' . $rowId, addSpace(10) . $accountName)
                            ->setCellValue('B' . $rowId, Yii::app()->numberFormatter->formatCurrency($debit, " "))
                            ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                        $rowId++;
                    }

                    if ($subledgerCount > 0) {
                        foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_profit_and_loss}} WHERE ledger_id=' . $eachThree->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {

                            $excel->setActiveSheetIndex(0)
                                ->setCellValue('A' . $rowId, addSpace(13) . $eachSub['subledger'])
                                ->setCellValue('B' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['debit']), " "))
                                ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['credit']), " "));

                            $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setItalic(true)->setSize(9);
                            $rowId++;
                        }
                    }

                    //LEVEL 4
                    $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachThree->id));
                    foreach ($levelFour as $eachFour) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachFour->id . ') tmp
                                ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = $eachFour->description;
                        $subledgerCount = 0;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setBold(true)->setSize(10);
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                            $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        }

                        if (abs($balance) != 0) {
                            $excel->setActiveSheetIndex(0)
                                ->setCellValue('A' . $rowId, addSpace(15) . $accountName)
                                ->setCellValue('B' . $rowId, Yii::app()->numberFormatter->formatCurrency($debit, " "))
                                ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                            $rowId++;
                        }

                        if ($subledgerCount > 0) {
                            foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_profit_and_loss}} WHERE ledger_id=' . $eachFour->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {

                                $excel->setActiveSheetIndex(0)
                                    ->setCellValue('A' . $rowId, addSpace(18) . $eachSub['subledger'])
                                    ->setCellValue('B' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['debit']), " "))
                                    ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['credit']), " "));

                                $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setItalic(true)->setSize(9);
                                $rowId++;
                            }
                        }

                        //LEVEL 5
                        $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachFour->id));
                        foreach ($levelFive as $eachFive) {

                            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $eachFive->id . ') tmp
                                    ) a';
                            $ids = Yii::app()->db->createCommand($query)->queryAll();

                            $balance = 0;
                            $accountName = $eachFive->description;
                            $subledgerCount = 0;

                            if ($ids[0]['child'] != '') {
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                                $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            } else {
                                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                                $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                                $subledgerCount = Yii::app()->db->createCommand('SELECT COUNT(subledger_id) AS count FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            }

                            $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setBold(true)->setSize(10);
                            if (abs($balance) != 0) {
                                $excel->setActiveSheetIndex(0)
                                    ->setCellValue('A' . $rowId, addSpace(20) . $accountName)
                                    ->setCellValue('B' . $rowId, Yii::app()->numberFormatter->formatCurrency($debit, " "))
                                    ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                                $rowId++;
                            }

                            if ($subledgerCount > 0) {
                                foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_profit_and_loss}} WHERE ledger_id=' . $eachFive->id . ' AND balance != 0 ORDER BY subledger ASC')->queryAll() as $eachSub) {

                                    $excel->setActiveSheetIndex(0)
                                        ->setCellValue('A' . $rowId, addSpace(23) . $eachSub['subledger'])
                                        ->setCellValue('B' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['debit']), " "))
                                        ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($eachSub['credit']), " "));

                                    $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setItalic(true)->setSize(9);
                                    $rowId++;
                                }
                            }
                        }
                    }
                }
            }

            $excel->getActiveSheet(0)->getStyle('C' . $rowId)->applyFromArray(array(
                'borders' => array(
                    'bottom' => array(
                        'style' => PHPExcel_Style_Border::BORDER_THICK,
                        'color' => array('argb' => '#1E1F20'),
                    ),

                    'top' => array(
                        'style' => PHPExcel_Style_Border::BORDER_THICK,
                        'color' => array('argb' => '#1E1F20'),
                    ),

                ),
            ));

            $excel->getActiveSheet(0)->getStyle('B' . $rowId . ':C' . $rowId)->applyFromArray(array(
                'borders' => array(
                    'top' => array(
                        'style' => PHPExcel_Style_Border::BORDER_THICK,
                        'color' => array('argb' => '#1E1F20'),
                    ),

                ),
            ));
            $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFill()->applyFromArray(array(
                'type' => PHPExcel_Style_Fill::FILL_SOLID,
                'startcolor' => array(
                    'rgb' => 'bbbbc1',
                ),
            ));

            $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setBold(true)->setSize(14);
            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, 'Total')
                ->setCellValue('B' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($totalDebit), " "))
                ->setCellValue('C' . $rowId, Yii::app()->numberFormatter->formatCurrency(abs($totalCredit), " "));
            $rowId++;
            $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFill()->applyFromArray(array(
                'type' => PHPExcel_Style_Fill::FILL_SOLID,
                'startcolor' => array(
                    'rgb' => 'bbbbc1',
                ),
            ));
            $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setBold(true)->setSize(16);
            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, 'Total ' . $eachOne->description)
                ->setCellValue('C' . $rowId, getSymbol($grandTotal, $eachOne->main_account_type) . Yii::app()->numberFormatter->formatCurrency(abs($grandTotal), " "));
            $rowId++;

            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, '')
                ->setCellValue('C' . $rowId, '');
            $rowId++;

            if ($eachOne->main_account_type == 'E') {
                //                $cost_of_goods_sold = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . FinanceSystemAccountsMapping::getSystemdefault('cost_of_sale') . ')')->queryScalar();
                $grossProfit = $totals[0] + $cost_of_goods_sold;
                $symbol = ($grossProfit < 0) ? '' : '(-)';

                $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFill()->applyFromArray(array(
                    'type' => PHPExcel_Style_Fill::FILL_SOLID,
                    'startcolor' => array(
                        'rgb' => 'd1d6ff',
                    ),
                ));
                $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setBold(true)->setSize(16);
                // $excel->setActiveSheetIndex(0)
                //     ->setCellValue('A' . $rowId, 'Gross Profit (' . FinanceLegder::baseCurrency() . ')')
                //     ->setCellValue('C' . $rowId, $symbol . Yii::app()->numberFormatter->formatCurrency(abs($grossProfit), " "));
                $rowId++;
                $netProfit = $totals[0] + $totals[1];
                $symbol = ($netProfit < 0) ? '' : '(-)';

                $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFill()->applyFromArray(array(
                    'type' => PHPExcel_Style_Fill::FILL_SOLID,
                    'startcolor' => array(
                        'rgb' => 'd1ebff',
                    ),
                ));
                $excel->getActiveSheet()->getStyle('A' . $rowId . ':C' . $rowId)->getFont()->setBold(true)->setSize(16);
                // $excel->setActiveSheetIndex(0)
                //     ->setCellValue('A' . $rowId, 'Net Profit (' . FinanceLegder::baseCurrency() . ')')
                //     ->setCellValue('C' . $rowId, $symbol . Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " "));

            }
        }

        $excel->getActiveSheet()->getStyle('B2:C' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);

        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="profit_and_loss.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionPl_pdf_level()
    {
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false);
        $this->render('pl_level_filter', array('from_date' => $_GET['from_date'], 'to_date' => $_GET['to_date'], 'brand' => (int) $_GET['brand'], 'outlet' => (int) $_GET['outlet']));
    }

    public function actionPl_pdf()
    {
        $brand = (int) $_GET['brand'];
        $outlet = (int) $_GET['outlet'];
        $level = in_array((int) $_GET['level'], array(1, 2, 3, 4, 5)) ? (int) $_GET['level'] : 5;
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-d');
        $condition = 'V.is_posted="Y" AND L.id!=25 AND V.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND L.type_of_account IN ("P")';
        if ($brand > 0) {
            $condition .= ' AND VI.brand_id=' . $brand;
        }
        $condition = '1=1';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }

        $query = 'CREATE OR REPLACE VIEW {{finance_profit_and_loss}} AS SELECT
                            L.id AS ledger_id,
                            L.account_no AS ledger_no,
                            L.description AS ledger_name,
                            L.level AS level,
                            L.parent_account AS parent,
                            IFNULL(S.description, "N/A") AS subledger,
                            S.id AS subledger_id,
                            ROUND((SUM(CASE WHEN VI.amount > 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS debit,
                            ROUND((SUM(CASE WHEN VI.amount < 0 THEN VI.amount*VI.exchange_rate ELSE 0 END)), 4) AS credit,
                            ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS balance
                        FROM {{finance_legder}} L
                        LEFT JOIN {{finance_voucher_items}} VI ON VI.ledger_id = L.id
                        LEFT JOIN {{finance_voucher_head}} V ON VI.header_id = V.id
                        LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                        WHERE ' . $condition . '
                        GROUP BY L.id, S.id';
        Yii::app()->db->createCommand($query)->execute();

        function addSpace($value)
        {
            $space = '';
            for ($i = 0; $i <= $value; $i++) {
                $space .= '&nbsp;';
            }

            return $space;
        }

        function getSymbol($value, $item)
        {
            return (($value <= 0 && $item == 'I') || ($value > 0 && $item == 'E')) ? '' : '(-)';
        }

        //We have 5 levels
        $table = '<table class="table table-hover table-fixed table-bordered" id="pl_table_' . ($p + 1) . '">
                <thead>
                    <tr>
                        <th style="width:50%">Accounts</th>
                        <th style="width:25%">Debit</th>
                        <th style="width:25%">Credit</th>
                    </tr>
                </thead>
            <tbody>';
        $totals = array();
        $directIncome = FinanceLegder::model()->findAll(array('condition' => 'classification="DIRECT_INCOME"', 'order' => 'id ASC'));
        $totalDirectincome = 0;
        $totalDirectexpense = 0;
        $totalIndirectincome = 0;
        $totalIndirectexpense = 0;
        //level - 2
        foreach ($directIncome as $p => $eachOne) {

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                    JOIN
                    (SELECT @pv:=' . $eachOne->id . ') tmp
                 ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $totalDebit = $debit;
                $totalCredit = $credit;

                $totals[] = $balance;
            }

            $table .= '<tr data-id="' . $eachOne->id . '" data-parent="" >
                        <td><b>' . $accountName . '</b></td>
                        <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</b></td>
                        <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</b></td>
                    </tr>';

            $totalDirectincome = $balance;
            //LEVEL 3
            $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelThree as $eachThree) {
                if ($eachThree->id == 7) {
                    $accountName =  $eachThree->description;
                    $debit = $credit = $balance = $opening = 0;
                    $opening_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type="GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' group by product_id')->queryAll();
                    $opening = 0;
                    foreach ($opening_in_rate as $eachOpen) {
                        $opening_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type="GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();

                        $opening_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type="GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();
                        $opening += ($opening_out) * $eachOpen['avg_purchase_rate'];
                    }
                    $current_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' group by product_id')->queryAll();
                    $current = 0;
                    foreach ($current_in_rate as $eachCurrent) {
                        $current_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                        $current_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                        $current += ($current_out) * $eachCurrent['avg_purchase_rate'];
                    }
                    if ($current > 0) {
                        $debit = 0;
                        $credit = $current;
                        $balance = -1 * ($opening - $current);
                    } else {
                        $debit = $current;
                        $credit = 0;
                        $balance = 1 * ($opening - $current);
                    }
                    $total_debit += $debit;
                    $total_credit += $credit;
                    $totalDirectexpense = $balance;
                } else {
                    $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                    JOIN
                    (SELECT @pv:=' . $eachThree->id . ') tmp
                    ) a';
                    $ids = Yii::app()->db->createCommand($query)->queryAll();

                    $balance = 0;
                    $accountName = $eachThree->description;

                    if ($ids[0]['child'] != '') {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    } else {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    }
                }
                if (abs($balance) != 0) {
                    $table .= '<tr data-id="' . $eachThree->id . '" data-parent="' . $eachOne->id . '" >
                                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                            </tr>';
                }

                //LEVEL 4
                $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachThree->id));
                foreach ($levelFour as $eachFour) {

                    $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                            SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                            WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                            JOIN
                            (SELECT @pv:=' . $eachFour->id . ') tmp
                            ) a';
                    $ids = Yii::app()->db->createCommand($query)->queryAll();

                    $balance = 0;
                    $accountName = $eachFour->description;

                    if ($ids[0]['child'] != '') {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    } else {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                    }

                    if (abs($balance) != 0) {
                        $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                    </tr>';
                    }

                    //LEVEL 5
                    $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachFour->id));
                    foreach ($levelFive as $eachFive) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachFive->id . ') tmp
                                ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = $eachFive->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                        }

                        if (abs($balance) != 0) {
                            $table .= '<tr data-id="' . $eachFive->id . '" data-parent="' . $eachFour->id . '" >
                                        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                    </tr>';
                        }
                    }
                }
            }
        }
        $symbol = ($totalDirectincome <= 0) ? '' : '(-)';
        $table .= '<tr>
                            <td colspan="2" style="color:#1F67B2;" class="text-right"><b>Total Direct Income (' . FinanceLegder::baseCurrency() . ')</b></td>
                            <td style="color:#1F67B2;" class="text-right" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($totalDirectincome), " ") . '</b></td>
                        </tr>';
        //direct expense
        $directExpense = FinanceLegder::model()->findAll(array('condition' => 'classification="DIRECT_EXPENSE"', 'order' => 'id ASC'));
        //level - 2
        foreach ($directExpense as $p => $eachOne) {

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                    JOIN
                    (SELECT @pv:=' . $eachOne->id . ') tmp
                 ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $totalDebit = $debit;
                $totalCredit = $credit;

                $totals[] = $balance;
            }

            $table .= '<tr data-id="' . $eachOne->id . '" data-parent="" >
                        <td><b>' . $accountName . '</b></td>
                        <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</b></td>
                        <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</b></td>
                    </tr>';

            //LEVEL 3
            $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelThree as $eachThree) {
                if ($eachThree->id == 7) {
                    $accountName =  $eachThree->description;
                    $debit = $credit = $balance = $opening = 0;
                    $opening_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type="GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' group by product_id')->queryAll();
                    $opening = 0;
                    foreach ($opening_in_rate as $eachOpen) {
                        $opening_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type="GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();

                        $opening_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type="GT" AND transaction_date < "' . $from_date . '" ' . $conditions . ' AND product_id=' . $eachOpen["product_id"])->queryScalar();
                        $opening += ($opening_out) * $eachOpen['avg_purchase_rate'];
                    }
                    $current_in_rate = Yii::app()->db->createCommand('SELECT product_id,CASE
                 WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' group by product_id')->queryAll();
                    $current = 0;
                    foreach ($current_in_rate as $eachCurrent) {
                        $current_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type="GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                        $current_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type="GT" AND transaction_date >= "' . $from_date . '"  AND transaction_date <= "' . $to_date . '" ' . $conditions . ' AND product_id=' . $eachCurrent["product_id"])->queryScalar();
                        $current += ($current_out) * $eachCurrent['avg_purchase_rate'];
                    }
                    if ($current > 0) {
                        $debit = 0;
                        $credit = $current;
                        $balance = 1 * ($opening - $current);
                    } else {
                        $debit = $current;
                        $credit = 0;
                        $balance = -1 * ($opening - $current);
                    }
                    $total_debit += $debit;
                    $total_credit += $credit;
                    $totalDirectexpense += $balance;
                } else {
                    $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                    JOIN
                    (SELECT @pv:=' . $eachThree->id . ') tmp
                    ) a';
                    $ids = Yii::app()->db->createCommand($query)->queryAll();

                    $balance = 0;
                    $accountName = $eachThree->description;

                    if ($ids[0]['child'] != '') {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    } else {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    }

                    $totalDirectexpense += $balance;
                }
                if (abs($balance) != 0) {
                    $table .= '<tr data-id="' . $eachThree->id . '" data-parent="' . $eachOne->id . '" >
                                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                            </tr>';
                }
                //LEVEL 4
                $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachThree->id));
                foreach ($levelFour as $eachFour) {

                    $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                            SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                            WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                            JOIN
                            (SELECT @pv:=' . $eachFour->id . ') tmp
                            ) a';
                    $ids = Yii::app()->db->createCommand($query)->queryAll();

                    $balance = 0;
                    $accountName = $eachFour->description;

                    if ($ids[0]['child'] != '') {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    } else {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                    }

                    if (abs($balance) != 0) {
                        $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                    </tr>';
                    }

                    //LEVEL 5
                    $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachFour->id));
                    foreach ($levelFive as $eachFive) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                JOIN
                                (SELECT @pv:=' . $eachFive->id . ') tmp
                                ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = $eachFive->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                        }

                        if (abs($balance) != 0) {
                            $table .= '<tr data-id="' . $eachFive->id . '" data-parent="' . $eachFour->id . '" >
                                        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                    </tr>';
                        }
                    }
                }
            }
        }

        $symbol = ($totalDirectexpense >= 0) ? '' : '(-)';
        $table .= '<tr>
                            <td colspan="2" style="color:#1F67B2;" class="text-right"><b>Total Direct Expense (' . FinanceLegder::baseCurrency() . ')</b></td>
                            <td style="color:#1F67B2;" class="text-right" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($totalDirectexpense), " ") . '</b></td>
                        </tr>';
        $grossProfit = $totalDirectincome + $totalDirectexpense;
        $symbol = ($grossProfit < 0) ? '' : '(-)';
        $table .= '<tr>
                            <td colspan="2" style="color:#1F67B2;" class="text-right"><b>Gross Profit (' . FinanceLegder::baseCurrency() . ')</b></td>
                            <td style="color:#1F67B2;" class="text-right" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($grossProfit), " ") . '</b></td>
                        </tr>';
        //indirect expense
        $indirectExpense = FinanceLegder::model()->findAll(array('condition' => 'classification="INDIRECT_EXPENSE"', 'order' => 'id ASC'));
        //level - 2
        foreach ($indirectExpense as $p => $eachOne) {

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                            SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                            WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                            JOIN
                            (SELECT @pv:=' . $eachOne->id . ') tmp
                         ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $totalDebit = $debit;
                $totalCredit = $credit;

                $totals[] = $balance;
            }

            $table .= '<tr data-id="' . $eachOne->id . '" data-parent="" >
                                <td><b>' . $accountName . '</b></td>
                                <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</b></td>
                                <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</b></td>
                            </tr>';

            $totalIndirectexpense = $balance;
            //LEVEL 3
            $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelThree as $eachThree) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                            SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                            WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                            JOIN
                            (SELECT @pv:=' . $eachThree->id . ') tmp
                            ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $balance = 0;
                $accountName = $eachThree->description;

                if ($ids[0]['child'] != '') {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                } else {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                }

                if (abs($balance) != 0) {
                    $table .= '<tr data-id="' . $eachThree->id . '" data-parent="' . $eachOne->id . '" >
                                        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                    </tr>';
                }

                //LEVEL 4
                $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachThree->id));
                foreach ($levelFour as $eachFour) {

                    $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $eachFour->id . ') tmp
                                    ) a';
                    $ids = Yii::app()->db->createCommand($query)->queryAll();

                    $balance = 0;
                    $accountName = $eachFour->description;

                    if ($ids[0]['child'] != '') {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    } else {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                    }

                    if (abs($balance) != 0) {
                        $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                                <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                                <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                            </tr>';
                    }

                    //LEVEL 5
                    $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachFour->id));
                    foreach ($levelFive as $eachFive) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                        SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                        WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                        JOIN
                                        (SELECT @pv:=' . $eachFive->id . ') tmp
                                        ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = $eachFive->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                        }

                        if (abs($balance) != 0) {
                            $table .= '<tr data-id="' . $eachFive->id . '" data-parent="' . $eachFour->id . '" >
                                                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                                <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                                <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                            </tr>';
                        }
                    }
                }
            }
        }
        $symbol = ($totalIndirectexpense >= 0) ? '' : '(-)';
        $table .= '<tr>
                            <td colspan="2" style="color:#1F67B2;" class="text-right"><b>Total Operating Expense (' . FinanceLegder::baseCurrency() . ')</b></td>
                            <td style="color:#1F67B2;" class="text-right" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($totalIndirectexpense), " ") . '</b></td>
                        </tr>';
        //indirect income
        $indirectIncome = FinanceLegder::model()->findAll(array('condition' => 'classification="INDIRECT_INCOME"', 'order' => 'id ASC'));
        //level - 2
        foreach ($indirectIncome as $p => $eachOne) {

            $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $eachOne->id . ') tmp
                                 ) a';

            $ids = Yii::app()->db->createCommand($query)->queryAll();

            $balance = 0;
            $accountName = $eachOne->description;

            if ($ids[0]['child'] != '') {
                $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                $totalDebit = $debit;
                $totalCredit = $credit;

                $totals[] = $balance;
            }

            $table .= '<tr data-id="' . $eachOne->id . '" data-parent="" >
                                        <td><b>' . $accountName . '</b></td>
                                        <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</b></td>
                                        <td class="text-right" ><b>' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</b></td>
                                    </tr>';

            $totalIndirectincome = $balance;
            //LEVEL 3
            $levelThree = FinanceLegder::model()->findAll(array('condition' => 'level=3 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachOne->id));
            foreach ($levelThree as $eachThree) {

                $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $eachThree->id . ') tmp
                                    ) a';
                $ids = Yii::app()->db->createCommand($query)->queryAll();

                $balance = 0;
                $accountName = $eachThree->description;

                if ($ids[0]['child'] != '') {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                } else {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                    $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachThree->id . ')')->queryScalar();
                }

                if (abs($balance) != 0) {
                    $table .= '<tr data-id="' . $eachThree->id . '" data-parent="' . $eachOne->id . '" >
                                                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $bo . $accountName . $bc . '</td>
                                                <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                                <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                            </tr>';
                }

                //LEVEL 4
                $levelFour = FinanceLegder::model()->findAll(array('condition' => 'level=4 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachThree->id));
                foreach ($levelFour as $eachFour) {

                    $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                            SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                            WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                            JOIN
                                            (SELECT @pv:=' . $eachFour->id . ') tmp
                                            ) a';
                    $ids = Yii::app()->db->createCommand($query)->queryAll();

                    $balance = 0;
                    $accountName = $eachFour->description;

                    if ($ids[0]['child'] != '') {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                    } else {
                        $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                        $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFour->id . ')')->queryScalar();
                    }

                    if (abs($balance) != 0) {
                        $table .= '<tr data-id="' . $eachFour->id . '" data-parent="' . $eachThree->id . '" >
                                                        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                                    </tr>';
                    }

                    //LEVEL 5
                    $levelFive = FinanceLegder::model()->findAll(array('condition' => 'level=5 AND type_of_account IN ("P")  AND parent_account=' . (int) $eachFour->id));
                    foreach ($levelFive as $eachFive) {

                        $query = 'SELECT GROUP_CONCAT(lv) AS child FROM (
                                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                                JOIN
                                                (SELECT @pv:=' . $eachFive->id . ') tmp
                                                ) a';
                        $ids = Yii::app()->db->createCommand($query)->queryAll();

                        $balance = 0;
                        $accountName = $eachFive->description;

                        if ($ids[0]['child'] != '') {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $ids[0]['child'] . ')')->queryScalar();
                        } else {
                            $balance = Yii::app()->db->createCommand('SELECT SUM(balance) AS balance FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $debit = Yii::app()->db->createCommand('SELECT SUM(debit) AS debit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                            $credit = Yii::app()->db->createCommand('SELECT ABS(SUM(credit)) AS credit FROM {{finance_profit_and_loss}} WHERE ledger_id IN (' . $eachFive->id . ')')->queryScalar();
                        }

                        if (abs($balance) != 0) {
                            $table .= '<tr data-id="' . $eachFive->id . '" data-parent="' . $eachFour->id . '" >
                                                        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                                        <td class="text-right" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                                    </tr>';
                        }
                    }
                }
            }
        }
        $symbol = ($totalIndirectincome <= 0) ? '' : '(-)';
        $table .= '<tr>
                            <td colspan="2" style="color:#1F67B2;" class="text-right"><b>Total Indirect Income (' . FinanceLegder::baseCurrency() . ')</b></td>
                            <td style="color:#1F67B2;" class="text-right" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($totalIndirectincome), " ") . '</b></td>
                        </tr>';
        $netProfit = $totalDirectincome + $totalDirectexpense + $totalIndirectexpense + $totalIndirectincome;
        $symbol = ($netProfit < 0) ? '' : '(-)';
        $table .= '<tr>
                            <td colspan="2" style="color:#1F67B2;" class="text-right"><b>Net Profit (' . FinanceLegder::baseCurrency() . ')</b></td>
                            <td style="color:#1F67B2;" class="text-right" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " ") . '</b></td>
                        </tr>';
        $table .= '</tbody>
            </table>';

        $param = array('brandModel' => $brandModel, 'table' => $table, 'from_date' => date('d/m/Y', strtotime($from_date)), 'to_date' => date('d/m/Y', strtotime($to_date)));
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf_pl_report', $param, true));
        $mpdf->Output("profit_or_loss" . date("d-m-Y") . ".pdf", 'I');
    }

    public function getCategories($category)
    {
        return CHtml::listData(FinanceLegder::model()->findAll(array('condition' => 'isParent="N" AND classification="' . $category . '"', 'order' => 'description ASC')), 'id', 'description');
    }

    public function actionAging_report()
    {
        $category = ((int) $_GET['type'] == 1) ? 'RECEIVABLE' : 'PAYABLE';
        $this->render('aging_report', array('filter_array' => $this->getCategories($category), 'category' => $category));
    }

    public function actionAging_html()
    {
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $ledger = (int) $_POST['ledger_id'];
        $brand = (int) $_POST['brand'];
        $outlet = (int) $_POST['outlet'];
        $salesman = (int) $_POST['salesman'];
        $category = ($_POST['category'] == 'RECEIVABLE') ? 'RECEIVABLE' : 'PAYABLE';
        $condition = '';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
        }
        if ($salesman > 0) {
            $customers = Yii::app()->db->createCommand('select group_concat(S.id) from {{finance_subledger}} AS S INNER JOIN {{customer}} AS C ON S.parent_id=C.id where accessed_by = "' . $salesman . '" OR accessed_by like "%,' . $salesman . ',%" OR accessed_by like "' . $salesman . ',%" OR accessed_by like "%,' . $salesman . '"')->queryScalar();
            if ($customers != '') {
                $condition .= ' AND VI.subledger_id IN(' . $customers . ')';
            }
            //        echo $customers;die;
        }

        $dates_array = array(
            '0_to_30' => array('from' => date('Y-m-d', strtotime($to_date . ' -30 days')), 'to' => $to_date),
            '31_to_60' => array('from' => date('Y-m-d', strtotime($to_date . ' -60 days')), 'to' => date('Y-m-d', strtotime($to_date . ' -31 days'))),
            '61_to_90' => array('from' => date('Y-m-d', strtotime($to_date . ' -90 days')), 'to' => date('Y-m-d', strtotime($to_date . ' -61 days'))),
            '91_to_120' => array('from' => date('Y-m-d', strtotime($to_date . ' -120 days')), 'to' => date('Y-m-d', strtotime($to_date . ' -91 days'))),
            'greaterthan_120' => array('from' => '2010-01-01', 'to' => date('Y-m-d', strtotime($to_date . ' -121 days'))),
        );

        function getSymbol($value)
        {
            return $value >= 0 ? '' : '(-)';
        }

        function generateUrl($ledger_id, $subledger_id, $tail, $mode)
        {
            return 'loadVouchers(' . $ledger_id . ', ' . (int) $subledger_id . ', \'' . $tail . '\', ' . $mode . ');';
        }

        foreach ($dates_array as $key => $each_date_pair) {

            $query = 'CREATE OR REPLACE VIEW {{finance_ageing_' . $key . '}} AS SELECT
                            VI.ledger_id AS ledger_id,
                            VI.subledger_id AS subledger_id,
                            IFNULL(S.description, "No Subledger") AS subledger,
                            V.id AS voucher_id,
                            V.voucher_date AS voucher_date,
                            V.due_date AS due_date,
                            V.reference_no AS reference_no,
                            VI.narration AS narration,
                            VI.id AS voucher_item_id,
                            CONCAT(VT.code,"/",V.voucher_no) AS voucher_no,
                            ROUND((VI.amount*VI.exchange_rate), 4) AS total_amount,
                            IFNULL(ABS(ROUND( SUM(AI.amount), 4)), 0) AS allocated,
                            ROUND((VI.amount*VI.exchange_rate), 4) - IFNULL(ROUND( SUM(AI.amount), 4), 0) AS amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
                        LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
                        LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id=V.voucher_type
                        WHERE V.voucher_date BETWEEN "' . $each_date_pair['from'] . '" AND "' . $each_date_pair['to'] . '" AND
                        V.is_posted="Y" AND VI.ledger_id = "' . (int) $ledger . '" ' . $condition . '
                        GROUP BY VI.id, VI.subledger_id';

            $selectQuery = 'SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        SUM(0_30_receivable) AS 0_30_receivable,
                        SUM(0_30_unallocated) AS 0_30_unallocated,
                        SUM(31_60_receivable) AS 31_60_receivable,
                        SUM(31_60_unallocated) AS 31_60_unallocated,
                        SUM(61_90_receivable) AS 61_90_receivable,
                        SUM(61_90_unallocated) AS 61_90_unallocated,
                        SUM(91_120_receivable) AS 91_120_receivable,
                        SUM(91_120_unallocated) AS 91_120_unallocated,
                        SUM(greater_120_receivable) AS greater_120_receivable,
                        SUM(greater_120_unallocated) AS greater_120_unallocated
                    FROM ( SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 0_30_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_0_to_30}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 31_60_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_31_to_60}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 61_90_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_61_to_90}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 91_120_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_91_to_120}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS greater_120_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS greater_120_unallocated
                    FROM {{finance_ageing_greaterthan_120}} GROUP BY subledger_id ) AS A GROUP BY A.subledger_id ORDER BY A.subledger ASC';

            Yii::app()->db->createCommand($query)->execute();
        }

        $aging_report = Yii::app()->db->createCommand($selectQuery)->queryAll();

        $data = '<table class="table table-hover table-fixed table-bordered" id="tb_table">
                <thead>
                    <tr>
                        <th>#</th>
                        <th>Subledger</th>
                        <th>Type</th>
                        <th>0-30</th>
                        <th>31-60</th>
                        <th>61-90</th>
                        <th>91-120</th>
                        <th> > 120</th>
                        <th>Total</th>
                    </tr>
                </thead>
                <tbody>';
        $grand_total = 0;
        $one = 0;
        $two = 0;
        $three = 0;
        $four = 0;
        $five = 0;
        $labelOne = ($category == 'RECEIVABLE') ? 'Receivable' : 'Unallocated';
        $labelTwo = ($category == 'RECEIVABLE') ? 'Unallocated' : 'Payable';

        $z = 0;
        foreach ($aging_report as $i => $each):
            $total_receivable = $each['0_30_receivable'] + $each['31_60_receivable'] + $each['61_90_receivable'] + $each['91_120_receivable'] + $each['greater_120_receivable'];
            $total_unallocated = $each['0_30_unallocated'] + $each['31_60_unallocated'] + $each['61_90_unallocated'] + $each['91_120_unallocated'] + $each['greater_120_unallocated'];

            $one_receivable += $each['0_30_receivable'];
            $two_receivable += $each['31_60_receivable'];
            $three_receivable += $each['61_90_receivable'];
            $four_receivable += $each['91_120_receivable'];
            $five_receivable += $each['greater_120_receivable'];
            $grand_total_receivable += $total_receivable;

            $one_unallocated += $each['0_30_unallocated'];
            $two_unallocated += $each['31_60_unallocated'];
            $three_unallocated += $each['61_90_unallocated'];
            $four_unallocated += $each['91_120_unallocated'];
            $five_unallocated += $each['greater_120_unallocated'];
            $grand_total_unallocated += $total_unallocated;
            if ($total_receivable > 0 || $total_unallocated > 0):
                $data .= '<tr>
																																									<td rowspan="2" >' . ($z + 1) . '</td>
																																		                            <td rowspan="2" >' . $each['subledger'] . '</td>
																																		                            <td>' . $labelOne . '</td>
																																									<td style="text-align:right !important;"><a href="#" onclick="' . generateUrl($each['ledger_id'], $each['subledger_id'], '0_to_30', 1) . '">' . Yii::app()->numberFormatter->formatCurrency($each['0_30_receivable'], " ") . '</a></td>
																																									<td style="text-align:right !important;"><a href="#" onclick="' . generateUrl($each['ledger_id'], $each['subledger_id'], '31_to_60', 1) . '">' . Yii::app()->numberFormatter->formatCurrency($each['31_60_receivable'], " ") . '</a></td>
																																									<td style="text-align:right !important;"><a href="#" onclick="' . generateUrl($each['ledger_id'], $each['subledger_id'], '61_to_90', 1) . '">' . Yii::app()->numberFormatter->formatCurrency($each['61_90_receivable'], " ") . '</a></td>
																																									<td style="text-align:right !important;"><a href="#" onclick="' . generateUrl($each['ledger_id'], $each['subledger_id'], '91_to_120', 1) . '">' . Yii::app()->numberFormatter->formatCurrency($each['91_120_receivable'], " ") . '</a></td>
																																									<td style="text-align:right !important;"><a href="#" onclick="' . generateUrl($each['ledger_id'], $each['subledger_id'], 'greaterthan_120', 1) . '">' . Yii::app()->numberFormatter->formatCurrency($each['greater_120_receivable'], " ") . '</a></td>
																																									<td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total_receivable, " ") . '</td>
																																						        </tr>';
                $data .= '<tr>
																																		                            <td>' . $labelTwo . '</td>
																																		                            <td style="text-align:right !important;"><a href="#" onclick="' . generateUrl($each['ledger_id'], $each['subledger_id'], '0_to_30', 0) . '">' . Yii::app()->numberFormatter->formatCurrency($each['0_30_unallocated'], " ") . '</a></td>
																																						            <td style="text-align:right !important;"><a href="#" onclick="' . generateUrl($each['ledger_id'], $each['subledger_id'], '31_to_60', 0) . '">' . Yii::app()->numberFormatter->formatCurrency($each['31_60_unallocated'], " ") . '</a></td>
																																						            <td style="text-align:right !important;"><a href="#" onclick="' . generateUrl($each['ledger_id'], $each['subledger_id'], '61_to_90', 0) . '">' . Yii::app()->numberFormatter->formatCurrency($each['61_90_unallocated'], " ") . '</a></td>
																																						            <td style="text-align:right !important;"><a href="#" onclick="' . generateUrl($each['ledger_id'], $each['subledger_id'], '91_to_120', 0) . '">' . Yii::app()->numberFormatter->formatCurrency($each['91_120_unallocated'], " ") . '</a></td>
																																						            <td style="text-align:right !important;"><a href="#" onclick="' . generateUrl($each['ledger_id'], $each['subledger_id'], 'greaterthan_120', 0) . '">' . Yii::app()->numberFormatter->formatCurrency($each['greater_120_unallocated'], " ") . '</a></td>
																																						            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total_unallocated, " ") . '</td>
																																						        </tr>';
                $z++;
            endif;
        endforeach;

        $data .= '<tr>
                        <td colspan="2" rowspan="2" style="text-align:right !important;"><b>Total</b></td>
                        <td>' . $labelOne . '</td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($one_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($two_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($three_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($four_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($five_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($grand_total_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                    </tr>';

        $data .= '<tr>
                        <td>' . $labelTwo . '</td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($one_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($two_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($three_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($four_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($five_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($grand_total_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                    </tr>';
        $data .= ' </tbody>
            </table>';

        echo $data;
    }

    public function actionAging_vouchers_html()
    {
        $ledger = (int) $_POST['ledger_id'];
        $subledger = (int) $_POST['subledger_id'];
        $tail = $_POST['tail'];
        $mode = $_POST['mode'] == 1 ? 1 : 0;

        function generateUrl($parentModel)
        {
            $url = '#';
            $code = $parentModel->vtype->code;
            if ($code == 'SI') {
                $headModel = $parentModel->vtype->header_table;
                $vat_field = $parentModel->vtype->vat_value;
                $tax = $headModel::model()->findBypk($parentModel->header_table_id)->$vat_field;
                $taxType = ($tax > 0) ? 'tax' : 'taxnil';
                $url = "window.open($('#liveSite').val()+'index.php?r=salesinvoice/PrintPDF&id=" . $parentModel->header_table_id . "&frm=" . $taxType . "', '_blank');";
            } else if ($code == 'PI') {
                $url = "window.open($('#liveSite').val()+'index.php?r=purchaseinvoice/PrintInvoiceReportPDF&id=" . $parentModel->header_table_id . "', '_blank');";
            } else if ($code == 'DN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=debitnote/printfile&id=" . $parentModel->header_table_id . "', '_blank');";
            } else if ($code == 'CN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=creditnote/printfile&id=" . $parentModel->header_table_id . "', '_blank');";
            } else {
                $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $parentModel->id . "', '_blank');";
            }
            return $url;
        }

        $condition = 'ledger_id=' . $ledger . ' AND subledger_id=' . $subledger;
        if ($mode == 1) {
            $condition .= ' AND amount > 0';
        } else {
            $condition .= ' AND amount < 0';
        }

        $items = Yii::app()->db->createCommand('SELECT * FROM {{finance_ageing_' . $tail . '}} WHERE ' . $condition . ' ORDER BY voucher_date')->queryAll();
        $table = '<table class="table table-hover table-fixed table-bordered" id="gl_table">
                    <thead>
                        <tr>
                            <th>Date</th>
                            <th>Voucher No</th>
                            <th>Ref No</th>
                            <th>Description</th>
                            <th>Total</th>
                            <th>Allocated</th>
                            <th>Balance</th>
                        </tr>
                    <tbody>';
        if (!empty($items)) {
            foreach ($items as $each) {
                $table .= '<tr>
                                <td>' . date('d/m/Y', strtotime($each['voucher_date'])) . '</td>
                                <td><a href="#" onclick="' . generateUrl(FinanceVoucherHead::model()->findBypk((int) $each['voucher_id'])) . '">' . $each['voucher_no'] . '</a></td>
                                <td>' . $each['reference_no'] . '</td>
                                <td>' . $each['narration'] . '</td>
                                <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($each['total_amount']), " ") . '</td>
                                <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($each['allocated']), " ") . '</td>
                                <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($each['amount']), " ") . '</td>
                            </tr>';
            }
        } else {
            $table .= '<tr>
                            <td style="text-align:center !important;" colspan="7"> No data</td>
                      </tr>';
        }

        $table .= '</tbody>
                      </table>';
        echo $table;
    }

    public function actionAging_pdf()
    {
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-d');
        $ledger = (int) $_GET['ledger'];
        $brand = (int) $_GET['brand'];
        $salesman = (int) $_GET['salesman'];
        $outlet = (int) $_GET['outlet'];
        $category = ($_GET['category'] == 'RECEIVABLE') ? 'RECEIVABLE' : 'PAYABLE';
        $condition = '';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
            $condition_for_opening .= ' AND I.outlet=' . $outlet;
        }
        if ($salesman > 0) {
            $customers = Yii::app()->db->createCommand('select group_concat(S.id) from {{finance_subledger}} AS S INNER JOIN {{customer}} AS C ON S.parent_id=C.id where accessed_by = "' . $salesman . '" OR accessed_by like "%,' . $salesman . ',%" OR accessed_by like "' . $salesman . ',%" OR accessed_by like "%,' . $salesman . '"')->queryScalar();
            if ($customers != '') {
                $condition .= ' AND VI.subledger_id IN(' . $customers . ')';
            }
            //        echo $customers;die;
        }
        $dates_array = array(
            '0_to_30' => array('from' => date('Y-m-d', strtotime($to_date . ' -30 days')), 'to' => $to_date),
            '31_to_60' => array('from' => date('Y-m-d', strtotime($to_date . ' -60 days')), 'to' => date('Y-m-d', strtotime($to_date . ' -31 days'))),
            '61_to_90' => array('from' => date('Y-m-d', strtotime($to_date . ' -90 days')), 'to' => date('Y-m-d', strtotime($to_date . ' -61 days'))),
            '91_to_120' => array('from' => date('Y-m-d', strtotime($to_date . ' -120 days')), 'to' => date('Y-m-d', strtotime($to_date . ' -91 days'))),
            'greaterthan_120' => array('from' => '2010-01-01', 'to' => date('Y-m-d', strtotime($to_date . ' -121 days'))),
        );

        foreach ($dates_array as $key => $each_date_pair) {

            $query = 'CREATE OR REPLACE VIEW {{finance_ageing_' . $key . '}} AS SELECT
                            VI.ledger_id AS ledger_id,
                            VI.subledger_id AS subledger_id,
                            IFNULL(S.description, "No Subledger") AS subledger,
                            V.id AS voucher_id,
                            V.voucher_date AS voucher_date,
                            V.due_date AS due_date,
                            V.reference_no AS reference_no,
                            VI.narration AS narration,
                            VI.id AS voucher_item_id,
                            CONCAT(VT.code,"/",V.voucher_no) AS voucher_no,
                            ROUND((VI.amount*VI.exchange_rate), 4) AS total_amount,
                            IFNULL(ABS(ROUND( SUM(AI.amount), 4)), 0) AS allocated,
                            ROUND((VI.amount*VI.exchange_rate), 4) - IFNULL(ROUND( SUM(AI.amount), 4), 0) AS amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
                        LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
                        LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id=V.voucher_type
                        WHERE V.voucher_date BETWEEN "' . $each_date_pair['from'] . '" AND "' . $each_date_pair['to'] . '" AND
                        V.is_posted="Y" AND VI.ledger_id = "' . (int) $ledger . '" ' . $condition . '
                        GROUP BY VI.id, VI.subledger_id';

            $selectQuery = 'SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        SUM(0_30_receivable) AS 0_30_receivable,
                        SUM(0_30_unallocated) AS 0_30_unallocated,
                        SUM(31_60_receivable) AS 31_60_receivable,
                        SUM(31_60_unallocated) AS 31_60_unallocated,
                        SUM(61_90_receivable) AS 61_90_receivable,
                        SUM(61_90_unallocated) AS 61_90_unallocated,
                        SUM(91_120_receivable) AS 91_120_receivable,
                        SUM(91_120_unallocated) AS 91_120_unallocated,
                        SUM(greater_120_receivable) AS greater_120_receivable,
                        SUM(greater_120_unallocated) AS greater_120_unallocated
                    FROM ( SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 0_30_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_0_to_30}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 31_60_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_31_to_60}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 61_90_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_61_to_90}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 91_120_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_91_to_120}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS greater_120_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS greater_120_unallocated
                    FROM {{finance_ageing_greaterthan_120}} GROUP BY subledger_id ) AS A GROUP BY A.subledger_id ORDER BY A.subledger ASC';

            Yii::app()->db->createCommand($query)->execute();
        }

        $aging_report = Yii::app()->db->createCommand($selectQuery)->queryAll();

        $data = '<table class="table table-hover table-fixed table-bordered" id="tb_table">
                <thead>
                    <tr>
                        <th>#</th>
                        <th>Subledger</th>
                        <th>Type</th>
                        <th>0-30</th>
                        <th>31-60</th>
                        <th>61-90</th>
                        <th>91-120</th>
                        <th> > 120</th>
                        <th>Total</th>
                    </tr>
                </thead>
                <tbody>';
        $grand_total = 0;
        $one = 0;
        $two = 0;
        $three = 0;
        $four = 0;
        $five = 0;
        $labelOne = ($category == 'RECEIVABLE') ? 'Receivable' : 'Unallocated';
        $labelTwo = ($category == 'RECEIVABLE') ? 'Unallocated' : 'Payable';

        $z = 0;
        foreach ($aging_report as $i => $each):
            $total_receivable = $each['0_30_receivable'] + $each['31_60_receivable'] + $each['61_90_receivable'] + $each['91_120_receivable'] + $each['greater_120_receivable'];
            $total_unallocated = $each['0_30_unallocated'] + $each['31_60_unallocated'] + $each['61_90_unallocated'] + $each['91_120_unallocated'] + $each['greater_120_unallocated'];

            $one_receivable += $each['0_30_receivable'];
            $two_receivable += $each['31_60_receivable'];
            $three_receivable += $each['61_90_receivable'];
            $four_receivable += $each['91_120_receivable'];
            $five_receivable += $each['greater_120_receivable'];
            $grand_total_receivable += $total_receivable;

            $one_unallocated += $each['0_30_unallocated'];
            $two_unallocated += $each['31_60_unallocated'];
            $three_unallocated += $each['61_90_unallocated'];
            $four_unallocated += $each['91_120_unallocated'];
            $five_unallocated += $each['greater_120_unallocated'];
            $grand_total_unallocated += $total_unallocated;

            if ($total_receivable > 0 || $total_unallocated > 0):
                $data .= '<tr>
																																									<td rowspan="2" >' . ($z + 1) . '</td>
																																		                            <td rowspan="2" >' . $each['subledger'] . '</td>
																																		                            <td>' . $labelOne . '</td>
																																									<td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($each['0_30_receivable'], " ") . '</td>
																																									<td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($each['31_60_receivable'], " ") . '</td>
																																									<td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($each['61_90_receivable'], " ") . '</td>
																																									<td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($each['91_120_receivable'], " ") . '</td>
																																									<td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($each['greater_120_receivable'], " ") . '</td>
																																									<td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($total_receivable, " ") . '</td>
																																						        </tr>';
                $data .= '<tr>
																																		                            <td>' . $labelTwo . '</td>
																																		                            <td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($each['0_30_unallocated'], " ") . '</td>
																																						            <td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($each['31_60_unallocated'], " ") . '</td>
																																						            <td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($each['61_90_unallocated'], " ") . '</td>
																																						            <td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($each['91_120_unallocated'], " ") . '</td>
																																						            <td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($each['greater_120_unallocated'], " ") . '</td>
																																						            <td class="text-right">' . Yii::app()->numberFormatter->formatCurrency($total_unallocated, " ") . '</td>
																																						        </tr>';
                $z++;
            endif;
        endforeach;

        $data .= '<tr>
                        <td colspan="2" rowspan="2" class="text-right"><b>Total</b></td>
                        <td>' . $labelOne . '</td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($one_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($two_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($three_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($four_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($five_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($grand_total_receivable, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                    </tr>';

        $data .= '<tr>
                        <td>' . $labelTwo . '</td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($one_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($two_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($three_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($four_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($five_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                        <td class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($grand_total_unallocated, " ") . " " . FinanceLegder::baseCurrency() . '</b></td>
                    </tr>';
        $data .= ' </tbody>
            </table>';

        $param = array(
            'to_date' => $to_date,
            'ledger' => $ledger,
            'table' => $data,
            'head' => $category == 'RECEIVABLE' ? 'Receivable Aging Report' : 'Payable Aging Report',
        );

        $mode = 'A4-L';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'pdf_aging_report';
        $mpdf->WriteHTML($this->renderPartial($view, $param, true));
        $mpdf->Output("aging" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionAging_excel()
    {
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-d');
        $ledger = (int) $_GET['ledger'];
        $brand = (int) $_GET['brand'];
        $salesman = (int) $_GET['salesman'];
        $outlet = (int) $_GET['outlet'];
        $category = ($_GET['category'] == 'RECEIVABLE') ? 'RECEIVABLE' : 'PAYABLE';
        $condition = '';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
        }
        if ($salesman > 0) {
            $customers = Yii::app()->db->createCommand('select group_concat(S.id) from {{finance_subledger}} AS S INNER JOIN {{customer}} AS C ON S.parent_id=C.id where accessed_by = "' . $salesman . '" OR accessed_by like "%,' . $salesman . ',%" OR accessed_by like "' . $salesman . ',%" OR accessed_by like "%,' . $salesman . '"')->queryScalar();
            if ($customers != '') {
                $condition .= ' AND VI.subledger_id IN(' . $customers . ')';
            }
            //        echo $customers;die;
        }
        $dates_array = array(
            '0_to_30' => array('from' => date('Y-m-d', strtotime($to_date . ' -30 days')), 'to' => $to_date),
            '31_to_60' => array('from' => date('Y-m-d', strtotime($to_date . ' -60 days')), 'to' => date('Y-m-d', strtotime($to_date . ' -31 days'))),
            '61_to_90' => array('from' => date('Y-m-d', strtotime($to_date . ' -90 days')), 'to' => date('Y-m-d', strtotime($to_date . ' -61 days'))),
            '91_to_120' => array('from' => date('Y-m-d', strtotime($to_date . ' -120 days')), 'to' => date('Y-m-d', strtotime($to_date . ' -91 days'))),
            'greaterthan_120' => array('from' => '2010-01-01', 'to' => date('Y-m-d', strtotime($to_date . ' -121 days'))),
        );

        foreach ($dates_array as $key => $each_date_pair) {

            $query = 'CREATE OR REPLACE VIEW {{finance_ageing_' . $key . '}} AS SELECT
                            VI.ledger_id AS ledger_id,
                            VI.subledger_id AS subledger_id,
                            IFNULL(S.description, "No Subledger") AS subledger,
                            V.id AS voucher_id,
                            V.voucher_date AS voucher_date,
                            V.due_date AS due_date,
                            V.reference_no AS reference_no,
                            VI.narration AS narration,
                            VI.id AS voucher_item_id,
                            CONCAT(VT.code,"/",V.voucher_no) AS voucher_no,
                            ROUND((VI.amount*VI.exchange_rate), 4) AS total_amount,
                            IFNULL(ABS(ROUND( SUM(AI.amount), 4)), 0) AS allocated,
                            ROUND((VI.amount*VI.exchange_rate), 4) - IFNULL(ROUND( SUM(AI.amount), 4), 0) AS amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
                        LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
                        LEFT JOIN {{finance_subledger}} S ON S.id = VI.subledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id=V.voucher_type
                        WHERE V.voucher_date BETWEEN "' . $each_date_pair['from'] . '" AND "' . $each_date_pair['to'] . '" AND
                        V.is_posted="Y" AND VI.ledger_id = "' . (int) $ledger . '" ' . $condition . '
                        GROUP BY VI.id, VI.subledger_id';

            $selectQuery = 'SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        SUM(0_30_receivable) AS 0_30_receivable,
                        SUM(0_30_unallocated) AS 0_30_unallocated,
                        SUM(31_60_receivable) AS 31_60_receivable,
                        SUM(31_60_unallocated) AS 31_60_unallocated,
                        SUM(61_90_receivable) AS 61_90_receivable,
                        SUM(61_90_unallocated) AS 61_90_unallocated,
                        SUM(91_120_receivable) AS 91_120_receivable,
                        SUM(91_120_unallocated) AS 91_120_unallocated,
                        SUM(greater_120_receivable) AS greater_120_receivable,
                        SUM(greater_120_unallocated) AS greater_120_unallocated
                    FROM ( SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 0_30_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_0_to_30}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 31_60_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_31_to_60}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 61_90_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_61_to_90}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS 91_120_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS 91_120_unallocated,
                        0 AS greater_120_receivable,
                        0 AS greater_120_unallocated
                    FROM {{finance_ageing_91_to_120}} GROUP BY subledger_id
                    UNION
                    SELECT
                        ledger_id,
                        subledger_id,
                        subledger,
                        0 AS 0_30_receivable,
                        0 AS 0_30_unallocated,
                        0 AS 31_60_receivable,
                        0 AS 31_60_unallocated,
                        0 AS 61_90_receivable,
                        0 AS 61_90_unallocated,
                        0 AS 91_120_receivable,
                        0 AS 91_120_unallocated,
                        SUM( CASE WHEN amount > 0 THEN amount ELSE 0 END) AS greater_120_receivable,
                        SUM( CASE WHEN amount < 0 THEN ABS(amount) ELSE 0 END) AS greater_120_unallocated
                    FROM {{finance_ageing_greaterthan_120}} GROUP BY subledger_id ) AS A GROUP BY A.subledger_id ORDER BY A.subledger ASC';

            Yii::app()->db->createCommand($query)->execute();
        }

        $aging_report = Yii::app()->db->createCommand($selectQuery)->queryAll();

        // Create new PHPExcel object
        Yii::import('ext.PHPExcel.PHPExcel');

        $excel = new PHPExcel();

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Aging Report")
            ->setSubject("Aging Report")
            ->setDescription("Aging Report as on date" . $to_date)
            ->setKeywords("Aging Report")
            ->setCategory("Financial Report");

        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(6)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(7)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(8)->setAutoSize(true);

        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', '#')
            ->setCellValue('B1', 'Subledger')
            ->setCellValue('C1', 'Type')
            ->setCellValue('D1', '0-30')
            ->setCellValue('E1', '31-60')
            ->setCellValue('F1', '61-90')
            ->setCellValue('G1', '91-120')
            ->setCellValue('H1', ' > 120')
            ->setCellValue('I1', 'Total');

        $excel->getActiveSheet()->getStyle('A1:I1')->getFont()->setBold(true)->setSize(14);
        $excel->getActiveSheet()->getStyle('A1:I1')->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));

        $grand_total = 0;
        $one = 0;
        $two = 0;
        $three = 0;
        $four = 0;
        $five = 0;
        $labelOne = ($category == 'RECEIVABLE') ? 'Receivable' : 'Unallocated';
        $labelTwo = ($category == 'RECEIVABLE') ? 'Unallocated' : 'Payable';
        $rowId = 2;
        $number = 1;
        foreach ($aging_report as $i => $each):
            $total_receivable = $each['0_30_receivable'] + $each['31_60_receivable'] + $each['61_90_receivable'] + $each['91_120_receivable'] + $each['greater_120_receivable'];
            $total_unallocated = $each['0_30_unallocated'] + $each['31_60_unallocated'] + $each['61_90_unallocated'] + $each['91_120_unallocated'] + $each['greater_120_unallocated'];

            $one_receivable += $each['0_30_receivable'];
            $two_receivable += $each['31_60_receivable'];
            $three_receivable += $each['61_90_receivable'];
            $four_receivable += $each['91_120_receivable'];
            $five_receivable += $each['greater_120_receivable'];
            $grand_total_receivable += $total_receivable;

            $one_unallocated += $each['0_30_unallocated'];
            $two_unallocated += $each['31_60_unallocated'];
            $three_unallocated += $each['61_90_unallocated'];
            $four_unallocated += $each['91_120_unallocated'];
            $five_unallocated += $each['greater_120_unallocated'];
            $grand_total_unallocated += $total_unallocated;

            if ($total_receivable > 0 || $total_unallocated > 0):

                $excel->setActiveSheetIndex(0)
                    ->setCellValue('A' . $rowId, $number)
                    ->setCellValue('B' . $rowId, $each['subledger'])
                    ->setCellValue('C' . $rowId, $labelOne)
                    ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency($each['0_30_receivable'], " "))
                    ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency($each['31_60_receivable'], " "))
                    ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency($each['61_90_receivable'], " "))
                    ->setCellValue('G' . $rowId, Yii::app()->numberFormatter->formatCurrency($each['91_120_receivable'], " "))
                    ->setCellValue('H' . $rowId, Yii::app()->numberFormatter->formatCurrency($each['greater_120_receivable'], " "))
                    ->setCellValue('I' . $rowId, Yii::app()->numberFormatter->formatCurrency($total_receivable, " "));

                $rowId++;
                $excel->setActiveSheetIndex(0)->mergeCells('A' . ($rowId - 1) . ':A' . $rowId);
                $excel->setActiveSheetIndex(0)->mergeCells('B' . ($rowId - 1) . ':B' . $rowId);
                $excel->setActiveSheetIndex(0)
                    ->setCellValue('C' . $rowId, $labelTwo)
                    ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency($each['0_30_unallocated'], " "))
                    ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency($each['31_60_unallocated'], " "))
                    ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency($each['61_90_unallocated'], " "))
                    ->setCellValue('G' . $rowId, Yii::app()->numberFormatter->formatCurrency($each['91_120_unallocated'], " "))
                    ->setCellValue('H' . $rowId, Yii::app()->numberFormatter->formatCurrency($each['greater_120_unallocated'], " "))
                    ->setCellValue('I' . $rowId, Yii::app()->numberFormatter->formatCurrency($total_unallocated, " "));
                $rowId++;
                $number++;
            endif;
        endforeach;
        $excel->setActiveSheetIndex(0)
            ->setCellValue('B' . $rowId, 'Total')
            ->setCellValue('C' . $rowId, $labelOne)
            ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency($one_receivable, " ") . " " . FinanceLegder::baseCurrency())
            ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency($two_receivable, " ") . " " . FinanceLegder::baseCurrency())
            ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency($three_receivable, " ") . " " . FinanceLegder::baseCurrency())
            ->setCellValue('G' . $rowId, Yii::app()->numberFormatter->formatCurrency($four_receivable, " ") . " " . FinanceLegder::baseCurrency())
            ->setCellValue('H' . $rowId, Yii::app()->numberFormatter->formatCurrency($five_receivable, " ") . " " . FinanceLegder::baseCurrency())
            ->setCellValue('I' . $rowId, Yii::app()->numberFormatter->formatCurrency($grand_total_receivable, " ") . " " . FinanceLegder::baseCurrency());

        $rowId++;
        $excel->getActiveSheet()->getStyle('A' . ($rowId - 1) . ':I' . $rowId)->getFont()->setBold(true)->setSize(14);
        $excel->getActiveSheet()->getStyle('A' . ($rowId - 1) . ':I' . $rowId)->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . ($rowId - 1) . ':A' . $rowId);
        $excel->setActiveSheetIndex(0)->mergeCells('B' . ($rowId - 1) . ':B' . $rowId);
        $excel->getActiveSheet(0)->getStyle('A1:I' . $rowId)->applyFromArray(array(
            'borders' => array(
                'allborders' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        ));

        $excel->setActiveSheetIndex(0)
            ->setCellValue('C' . $rowId, $labelTwo)
            ->setCellValue('D' . $rowId, Yii::app()->numberFormatter->formatCurrency($one_unallocated, " ") . " " . FinanceLegder::baseCurrency())
            ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency($two_unallocated, " ") . " " . FinanceLegder::baseCurrency())
            ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency($three_unallocated, " ") . " " . FinanceLegder::baseCurrency())
            ->setCellValue('G' . $rowId, Yii::app()->numberFormatter->formatCurrency($four_unallocated, " ") . " " . FinanceLegder::baseCurrency())
            ->setCellValue('H' . $rowId, Yii::app()->numberFormatter->formatCurrency($five_unallocated, " ") . " " . FinanceLegder::baseCurrency())
            ->setCellValue('I' . $rowId, Yii::app()->numberFormatter->formatCurrency($grand_total_unallocated, " ") . " " . FinanceLegder::baseCurrency());
        $rowId++;

        $excel->getActiveSheet()->getStyle('D2:I' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->setTitle('Aging Report');

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="aging.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionVat_report()
    {
        $this->render('vat_report');
    }

    public function actionVat_html()
    {
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $outlet = (int) $_POST['outlet'];
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="A" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));

        //        function generateUrl($parentModel)
        //        {
        //            $url = '#';
        //            $code = $parentModel->vtype->code;
        //            if ($code == 'SI') {
        //                $headModel = $parentModel->vtype->header_table;
        //                $vat_field = $parentModel->vtype->vat_value;
        //                $tax = $headModel::model()->findBypk($parentModel->header_table_id)->$vat_field;
        //                $taxType = ($tax > 0) ? 'tax' : 'taxnil';
        //                $url = "window.open($('#liveSite').val()+'index.php?r=invoice/PrintInvoiceReportPDF&id=" . $parentModel->header_table_id . "&frm=" . $taxType . "', '_blank');";
        //            } else if ($code == 'PI') {
        //                $url = "window.open($('#liveSite').val()+'index.php?r=purchaseinvoice/PrintInvoiceReportPDF&id=" . $parentModel->header_table_id . "', '_blank');";
        //            } else if ($code == 'DN') {
        //                $url = "window.open($('#liveSite').val()+'index.php?r=debitnote/printfile&id=" . $parentModel->header_table_id . "', '_blank');";
        //            } else if ($code == 'CN') {
        //                $url = "window.open($('#liveSite').val()+'index.php?r=creditnote/printfile&id=" . $parentModel->header_table_id . "', '_blank');";
        //            } else {
        //                $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $parentModel->id . "', '_blank');";
        //            }
        //            return $url;
        //        }
        function generateUrl($parentModel)
        {
            $url = '#';
            $code = $parentModel->parent->vtype->code;
            $head_id = $parentModel->id;
            if ($code == 'SI') {
                $headModel = $parentModel->parent->vtype->header_table;
                $vat_field = $parentModel->parent->vtype->vat_value;
                $inv = $headModel::model()->findBypk($parentModel->parent->header_table_id);
                $tax = $inv->$vat_field;
                $taxType = ($tax > 0) ? 'tax' : 'taxnil';
                $url = "window.open($('#liveSite').val()+'index.php?r=salesinvoice/PrintPDF&id=" . $parentModel->parent->header_table_id . "&frm=" . $taxType . "&type=1', '_blank');";
            } else if ($code == 'PI') {
                $url = "window.open($('#liveSite').val()+'index.php?r=purchaseinvoice/PrintPDF&id=" . $parentModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'DN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=purchasereturn/PrintPDF&id=" . $parentModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'CN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=salesreturn/PrintPDF&id=" . $parentModel->parent->header_table_id . "', '_blank');";
            } else {
                $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $head_id . "', '_blank');";
            }
            return $url;
        }
        function generateUrl1($parentModel)
        {
            $url = '#';
            $head_id = $parentModel->id;
            $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $head_id . "', '_blank');";
            return $url;
        }

        function getSymbol($value, $reverse)
        {
            if (!$reverse) {
                $result = ($value <= 0) ? '' : '(-)';
            } else {
                $result = ($value < 0) ? '(-)' : '';
            }

            return $result;
        }

        function getVendor($code, $header_id)
        {
            return $code == 'PI' || $code == 'DN' ? FinanceVoucherItems::model()->find(array('condition' => 'ledger_id=' . FinanceSystemAccountsMapping::getSystemdefault('creditors') . ' AND header_id=' . $header_id))->subledger->description : 'N/A';
        }

        $table = '<br><table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="6">VAT on Sales (Outwards)</th>
                        </tr>
                        <tr>
                            <th style="width:5%">Date</th>
                            <th style="width:8%">Voucher No</th>
                            <th style="width:8%">Voucher Ref</th>
                            <th style="width:20%">Customer</th>
                            <th style="width:15%">Taxable Amount</th>
                            <th style="width:15%">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';

        $total_amount = 0;
        $total_vat = 0;
        foreach ($items as $each) {
            if ($each->parent->vtype->code == 'SI' || $each->parent->vtype->code == 'CN') {
                $vat = -1 * round(($each->amount * $each->exchange_rate), 4);
                $total = -1 * $each->get_sales_value();
                $table .= '<tr>
                                            <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                                            <td><a href="#" onclick="' . generateUrl($each) . '">' . $each->parent->fullvoucher . '</a></td>
                                            <td>' . $each->parent->reference_no . '</td>
                                            <td><small>' . $each->get_any_subledger() . '</small></td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                        </tr>';

                $total_amount += $total;
                $total_vat += $vat;
            }
        }

        $table .= '<tr>
                                    <td colspan="4" style="text-align:right !important;"><b>Total VAT (' . FinanceLegder::baseCurrency() . ')</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat, " ") . '</b></td>
                                </tr>';
        $table .= '</tbody>
                        <table>';
        // Start Other Income
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="A" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));
        $table .= '<br><table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="7">VAT on Other Income</th>
                        </tr>
                        <tr>
                            <th style="width:5%">Date</th>
                            <th style="width:8%">Voucher No</th>
                            <th style="width:8%">Voucher Ref</th>
                            <th style="width:20%">Customer</th>
                            <th style="width:20%">Narration</th>
                            <th style="width:15%">Taxable Amount</th>
                            <th style="width:15%">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';

        $total_amount_income = 0;
        $total_vat_income = 0;
        foreach ($items as $each) {
            if ($each->parent->vtype->code != 'SI' && $each->parent->vtype->code != 'CN') {
                $model = FinanceVoucherHead::model()->findBypk($each->parent->id);
                $vat = round(-1 * ($each->amount * $each->exchange_rate), 4);
                //            $total = $each->get_sales_value();
                if ($vat > 0) {
                    $total = ($model->debit_total - $vat);
                } else {
                    $total = -1 * ($model->debit_total + $vat);
                }
                $vat = $vat;
                $table .= '<tr>
                                            <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                                            <td><a href="#" onclick="' . generateUrl1($model) . '">' . $each->parent->fullvoucher . '</a></td>
                                            <td>' . $each->parent->reference_no . '</td>
                                            <td><small>' . $each->get_any_subledger() . '</small></td>
                                            <td><small>' . $each->narration . '</small></td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                        </tr>';
                //            if($vat<0)
                //            {
                //            $total_amount_income += -1*$total;
                //            }
                //            else {
                $total_amount_income += $total;
                //            }
                $total_vat_income += $vat;
            }
        }

        $table .= '<tr>
                                    <td colspan="5" style="text-align:right !important;"><b>Total VAT (' . FinanceLegder::baseCurrency() . ')</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount_income, " ") . '</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat_income, " ") . '</b></td>
                                </tr>';
        $table .= '</tbody>
                        <table>';
        // End Other Income
        // Start  Purchase Expenses
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="L" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));
        $table .= '<br><table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="7">VAT on Purchases</th>
                        </tr>
                        <tr>
                            <th style="width:5%">Date</th>
                            <th style="width:8%">Voucher No</th>
                            <th style="width:8%">Voucher Ref</th>
                            <th style="width:20%">Subledger</th>
                            <th style="width:20%">Narration</th>
                            <th style="width:15%">Voucher Amount</th>
                            <th style="width:15%">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';
        $total_amount = 0;
        $total_vat_purchase = 0;
        foreach ($items as $each) {
            if ($each->parent->vtype->code == 'PI' || $each->parent->vtype->code == 'DN') {
                $vat = round(($each->amount * $each->exchange_rate), 4);
                $total = $each->get_purchase_value();
                $table .= '<tr>
                                            <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                                            <td><a href="#" onclick="' . generateUrl($each) . '">' . $each->parent->fullvoucher . '</a></td>
                                            <td>' . $each->parent->reference_no . '</td>
                                            <td><small>' . $each->get_any_subledger() . '</small></td>
                                            <td><small>' . $each->narration . '</small></td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                        </tr>';

                $total_amount += $total;
                $total_vat_purchase += $vat;
            }
        }

        $table .= '<tr>
                                    <td colspan="5" style="text-align:right !important;"><b>Total VAT (' . FinanceLegder::baseCurrency() . ')</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat_purchase, " ") . '</b></td>
                                </tr>';
        $table .= '</tbody>
                        <table>';
        //End Purchase Expenses
        // Start  Vat on Expenses
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="L" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));
        $table .= '<br><table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="7">VAT on Expense</th>
                        </tr>
                        <tr>
                            <th style="width:5%">Date</th>
                            <th style="width:8%">Voucher No</th>
                            <th style="width:8%">Voucher Ref</th>
                            <th style="width:20%">Subledger</th>
                            <th style="width:20%">Narration</th>
                            <th style="width:15%">Voucher Amount</th>
                            <th style="width:15%">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';
        $total_amount = 0;
        $total_vat_exp = 0;
        foreach ($items as $each) {
            if ($each->parent->vtype->code != 'PI' && $each->parent->vtype->code != 'DN') {
                $vat = round(($each->amount * $each->exchange_rate), 4);
                //            $total = $each->get_purchase_value();
                //            if($vat>0)
                //            {
                //            $total = -1*($model->credit_total-$vat);
                //            }
                //            else {
                $total = ($each->parent->debit_total - $vat);
                //            }
                if ($total > $vat) {
                    if ($vat < 0) {
                        $total = -1 * ($total + (2 * $vat));
                    }
                    $table .= '<tr>
                                            <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                                            <td><a href="#" onclick="' . generateUrl1($each) . '">' . $each->parent->fullvoucher . '</a></td>
                                            <td>' . $each->parent->reference_no . '</td>
                                            <td><small>' . $each->get_any_subledger() . '</small></td>
                                            <td><small>' . $each->narration . '</small></td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                        </tr>';

                    $total_amount += $total;
                    $total_vat_exp += $vat;
                }
            }
        }

        $table .= '<tr>
                                    <td colspan="5" style="text-align:right !important;"><b>Total VAT (' . FinanceLegder::baseCurrency() . ')</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat_exp, " ") . '</b></td>
                                </tr>';
        $table .= '</tbody>
                        <table>';
        //End Vat On Expenses
        //        $query = 'SELECT
        //                        VH.voucher_date,
        //                        VH.id AS voucher_id,
        //                        T.code AS voucher_code,
        //                        CONCAT(T.code,"/", VH.voucher_no) AS voucher_no,
        //                        VH.reference_no AS reference_no,
        //                        GROUP_CONCAT(DISTINCT VI.narration SEPARATOR "\n") AS narration,
        //                        COUNT(VI.id) AS count_of_items,
        //                        VI.id AS voucher_item_id,
        //                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
        //                        FROM {{finance_voucher_items}} VI
        //                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
        //                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
        //                        LEFT JOIN {{finance_voucher_type}} T ON T.id = VH.voucher_type
        //                        WHERE L.main_account_type="L" AND L.classification="VAT" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="'.$outlet.'"
        //                        GROUP BY VH.id
        //                        ORDER BY T.code ASC,VH.voucher_date ASC';
        //        $items = Yii::app()->db->createCommand($query)->queryAll();
        //        $table .= '<br><table class="table table-hover table-fixed table-bordered">
        //                    <thead>
        //                        <tr>
        //                            <th colspan="7">VAT on Purchases/Expenses (Inwards)</th>
        //                        </tr>
        //                        <tr>
        //                            <th style="width:5%">Date</th>
        //                            <th style="width:8%">Voucher No</th>
        //                            <th style="width:8%">Voucher Ref</th>
        //                            <th style="width:20%">Subledger</th>
        //                            <th style="width:20%">Narration</th>
        //                            <th style="width:15%">Voucher Amount</th>
        //                            <th style="width:15%">VAT (' . FinanceLegder::baseCurrency() . ')</th>
        //                        </tr>
        //                    </thead>
        //                    <tbody>';
        //
        //        $total_amount_expense = 0;
        //        $total_vat_expense = 0;
        //        foreach ($items as $each) {
        //            $model = FinanceVoucherHead::model()->findBypk($each['voucher_id']);
        //            $vat = $each['vat_amount'];
        ////            if($vat>0)
        ////            {
        ////            $total = $model->debit_total;    
        ////            }
        ////            else {
        //            $total = $model->debit_total;    
        ////            }
        //             
        ////            $total = round($each['vat_amount'] / 0.05, 4);
        //            $table .= '<tr>
        //                                            <td>' . date("d/m/Y", strtotime($model->voucher_date)) . '</td>
        //                                            <td><a href="#" onclick="' . generateUrl1($model) . '">' . $model->fullvoucher . '</a></td>
        //                                            <td>' . $model->reference_no . '</td>
        //                                            <td><small>' . getVendor($each['voucher_code'], $model->id) . '</small></td>
        //                                            <td><small>' . $each['narration'] . '</small></td>
        //                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</td>
        //                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
        //                                        </tr>';
        //
        //            $total_amount_expense += $total;
        //            $total_vat_expense += $vat;
        //        }
        ////        $total_amount_expense=-1*$total_amount_expense;
        ////        $total_vat_expense=-1*$total_vat_expense;
        //        $table .= '<tr>
        //                                    <td colspan="5" style="text-align:right !important;"><b>Total VAT (' . FinanceLegder::baseCurrency() . ')</b></td>
        //                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount_expense, " ") . '</b></td>
        //                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat_expense, " ") . '</b></td>
        //                                </tr>';
        $payable = $total_vat + $total_vat_income - $total_vat_purchase - $total_vat_exp;
        $table .= '<tr>
                                    <td colspan="6" style="text-align:right !important;"><b> VAT Payable(' . FinanceLegder::baseCurrency() . ')</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($payable, " ") . '</b></td>
                                </tr>';
        $table .= '</tbody>
                        <table>';
        echo $table;
    }

    public function actionVat_pdf_extras()
    {
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false);
        $this->render('vat_filter', array('from_date' => $_GET['from_date'], 'to_date' => $_GET['to_date'], 'brand' => (int) $_GET['brand']));
    }

    public function actionVat_pdf()
    {
        $from_date = Yii::app()->request->getParam('from_date');
        $to_date = Yii::app()->request->getParam('to_date');
        $due_date = Yii::app()->request->getParam('due_date');
        $tax_year_end = Yii::app()->request->getParam('tax_year_end');
        $submission_date = Yii::app()->request->getParam('submission_date');
        $name = Yii::app()->request->getParam('name');
        $phone = Yii::app()->request->getParam('phone');
        $email = Yii::app()->request->getParam('email');
        $brand = Yii::app()->request->getParam('brand');

        $from_date = (count(explode('/', $from_date)) == 3) ? $from_date : date('01/m/Y');
        $to_date = (count(explode('/', $to_date)) == 3) ? $to_date : date('t/m/Y');

        // ALTER TABLE `crm_mas_emirates_list` ADD `have_vat` ENUM('N','Y') NOT NULL DEFAULT 'N' AFTER `isDefault`;

        $param = array(
            'from_date' => $from_date,
            'to_date' => $to_date,
            'due_date' => $due_date,
            'tax_year_end' => $tax_year_end,
            'submission_date' => $submission_date,
            'name' => $name,
            'phone' => $phone,
            'email' => $email,
            'brand' => $brand,
        );

        $mode = 'A4';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'pdf_vat_201_report';
        $mpdf->WriteHTML($this->renderPartial($view, $param, true));
        $mpdf->Output("vat_report" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionVat_excel()
    {
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-d');

        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="L" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"', 'order' => 'parent.voucher_date ASC'));

        function getSymbol($value, $reverse)
        {
            if (!$reverse) {
                $result = ($value <= 0) ? '' : '(-)';
            } else {
                $result = ($value < 0) ? '(-)' : '';
            }

            return $result;
        }

        function getVendor($code, $header_id)
        {
            return $code == 'PI' || $code == 'DN' ? FinanceVoucherItems::model()->find(array('condition' => 'ledger_id=' . FinanceSystemAccountsMapping::getSystemdefault('creditors') . ' AND header_id=' . $header_id))->subledger->description : 'N/A';
        }

        // Create new PHPExcel object
        Yii::import('ext.PHPExcel.PHPExcel');

        $excel = new PHPExcel();

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("VAT Report")
            ->setSubject("VAT Report")
            ->setDescription("VAT Report")
            ->setKeywords("VAT Report")
            ->setCategory("Financial Report");

        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(6)->setAutoSize(true);

        $excel->getActiveSheet()->getStyle('A1:F1')->getFont()->setBold(true)->setSize(14);
        $excel->getActiveSheet()->getStyle('A1:F1')->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Date')
            ->setCellValue('B1', 'Voucher No')
            ->setCellValue('C1', 'Voucher Ref')
            ->setCellValue('D1', 'Customer')
            ->setCellValue('E1', 'Taxable Amount')
            ->setCellValue('F1', 'VAT (' . FinanceLegder::baseCurrency() . ')');

        $total_amount = 0;
        $total_vat = 0;
        $rowId = 2;
        foreach ($items as $each) {
            $vat = round(($each->amount * $each->exchange_rate), 4);
            $total = $each->get_sales_value();
            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, date("d/m/Y", strtotime($each->parent->voucher_date)))
                ->setCellValue('B' . $rowId, $each->parent->fullvoucher)
                ->setCellValue('C' . $rowId, $each->parent->reference_no)
                ->setCellValue('D' . $rowId, $each->get_any_subledger())
                ->setCellValue('E' . $rowId, getSymbol($total, false) . Yii::app()->numberFormatter->formatCurrency(abs($total), " "))
                ->setCellValue('F' . $rowId, getSymbol($vat, false) . Yii::app()->numberFormatter->formatCurrency(abs($vat), " "));

            $total_amount += $total;
            $total_vat += $vat;
            $rowId++;
        }
        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId . '')->getFont()->setBold(true)->setSize(14);
        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId . '')->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));
        $excel->setActiveSheetIndex(0)
            ->setCellValue('D' . $rowId, 'Total VAT (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('E' . $rowId, getSymbol($total_amount, false) . Yii::app()->numberFormatter->formatCurrency(abs($total_amount), " "))
            ->setCellValue('F' . $rowId, getSymbol($total_vat, false) . Yii::app()->numberFormatter->formatCurrency(abs($total_vat), " "));
        $rowId++;
        $rowId++;

        $query = 'SELECT
                        VH.voucher_date,
                        VH.id AS voucher_id,
                        T.code AS voucher_code,
                        CONCAT(T.code,"/", VH.voucher_no) AS voucher_no,
                        VH.reference_no AS reference_no,
                        GROUP_CONCAT(DISTINCT VI.narration SEPARATOR "\n") AS narration,
                        COUNT(VI.id) AS count_of_items,
                        VI.id AS voucher_item_id,
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        LEFT JOIN {{finance_voucher_type}} T ON T.id = VH.voucher_type
                        WHERE L.main_account_type="A" AND L.classification="VAT" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"
                        GROUP BY VH.id
                        ORDER BY VH.voucher_date ASC';
        $items = Yii::app()->db->createCommand($query)->queryAll();

        $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId . '')->getFont()->setBold(true)->setSize(14);
        $excel->getActiveSheet()->getStyle('A' . $rowId . ':G' . $rowId . '')->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A' . $rowId, 'Date')
            ->setCellValue('B' . $rowId, 'Voucher No')
            ->setCellValue('C' . $rowId, 'Voucher Ref')
            ->setCellValue('D' . $rowId, 'Subledger')
            ->setCellValue('E' . $rowId, 'Taxable Amount')
            ->setCellValue('F' . $rowId, 'VAT (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('G' . $rowId, 'Narration');
        $rowId++;

        $total_amount_expense = 0;
        $total_vat_expense = 0;
        foreach ($items as $each) {
            $model = FinanceVoucherHead::model()->findBypk($each['voucher_id']);
            $vat = $each['vat_amount'];
            // $total = $model->debit_total;
            $total = round($each['vat_amount'] / 0.05, 4);

            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, date("d/m/Y", strtotime($model->voucher_date)))
                ->setCellValue('B' . $rowId, $model->fullvoucher)
                ->setCellValue('C' . $rowId, $model->reference_no)
                ->setCellValue('D' . $rowId, getVendor($each['voucher_code'], $model->id))
                ->setCellValue('E' . $rowId, getSymbol($total, true) . Yii::app()->numberFormatter->formatCurrency(abs($total), " "))
                ->setCellValue('F' . $rowId, getSymbol($vat, true) . Yii::app()->numberFormatter->formatCurrency(abs($vat), " "))
                ->setCellValue('G' . $rowId, $each['narration']);

            $total_amount_expense += $total;
            $total_vat_expense += $vat;
            $rowId++;
        }

        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId . '')->getFont()->setBold(true)->setSize(14);
        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId . '')->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));
        $excel->setActiveSheetIndex(0)
            ->setCellValue('D' . $rowId, 'Total VAT (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('E' . $rowId, getSymbol($total_amount_expense, true) . Yii::app()->numberFormatter->formatCurrency(abs($total_amount_expense), " "))
            ->setCellValue('F' . $rowId, getSymbol($total_vat_expense, true) . Yii::app()->numberFormatter->formatCurrency(abs($total_vat_expense), " "));

        $payable = $total_vat + $total_vat_expense;
        $rowId++;

        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId . '')->getFont()->setBold(true)->setSize(14);
        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId . '')->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));
        $excel->getActiveSheet()->getStyle('E2:F' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->setActiveSheetIndex(0)
            ->setCellValue('E' . $rowId, 'VAT Payable(' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('F' . $rowId, getSymbol($payable, false) . Yii::app()->numberFormatter->formatCurrency(abs($payable), " "));
        // Rename worksheet
        $excel->getActiveSheet()->setTitle('VAT Report');

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="vat_report.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionStatement_report()
    {
        $legder_Array = array('customer' => FinanceSystemAccountsMapping::getSystemdefault('debtors'), 'vendor' => FinanceSystemAccountsMapping::getSystemdefault('creditors'), 'bank' => FinanceSystemAccountsMapping::getSystemdefault('creditors'));
        $this->render('statement_report', array('type' => $_GET['type'], 'ledger_id' => (int) $legder_Array[$_GET['type']]));
    }

    public function actionReconciliation_report()
    {
        $this->render('reconciliation_report');
    }

    public function actionStatement_html()
    {
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');

        $ledger_id = (int) $_POST['ledger_id'];
        $subledger_id = (int) $_POST['subledger_id'];
        $currency = (int) $_POST['currency'];
        $outlet = (int) $_POST['outlet'];
        $salesman = (int) $_POST['salesman']; 
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;
        $amountType = 'VI.amount < 0';
        $paidType = 'VI.amount > 0';
        if ($_POST['type'] == 'customer') {
            $amountType = 'VI.amount > 0';
            $paidType = 'VI.amount < 0';
        }

        function generateUrl($childModel)
        {
            $url = '#';
            $code = $childModel->parent->vtype->code;
            if ($code == 'SI') {
                $headModel = $childModel->parent->vtype->header_table;
                $vat_field = $childModel->parent->vtype->vat_value;
                $inv = $headModel::model()->findBypk($childModel->parent->header_table_id);
                $tax = $inv->$vat_field;
                $taxType = ($tax > 0) ? 'tax' : 'taxnil';
                $url = "window.open($('#liveSite').val()+'index.php?r=salesinvoice/PrintPDF&id=" . $childModel->parent->header_table_id . "&frm=" . $taxType . "&type=1', '_blank');";
            } else if ($code == 'PI') {
                $url = "window.open($('#liveSite').val()+'index.php?r=purchaseinvoice/PrintInvoiceReportPDF&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'DN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=debitnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'CN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=creditnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else {
                $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $childModel->header_id . "', '_blank');";
            }
            return $url;
        }

        $items = array();
        $table = '<table class="table table-hover table-fixed table-bordered" id="gl_table">
                    <thead>
                        <tr>
                            <th style="width:10%">Date</th>
                             <th style="width:10%"> Type </th>
                            <th style="width:10%">Voucher #</th>
                            <th style="width:10%">Due Date</th>
                            <th style="width:10%">Over Due</th>
                            <th style="width:10%">Ref</th>
                            <th style="width:10%">Voucher value</th>
                            <th style="width:10%">Paid</th>
                            <th style="width:10%">Balance</th>
                        </tr>
                    </thead>
                    <tbody>';
        $condition = '';
        $condition_for_opening = '';
        if ($outlet > 0) {
            $condition .= ' AND V.outlet=' . $outlet;
            $condition_for_opening .= ' AND V.outlet=' . $outlet;
        }
        
        /*if ($salesman > 0) {
            $subledger_id = FinanceSubledger::model()->find(array('condition' => 'subledger_type_id=3 AND parent_id=' . $salesman))->id;
            if ((int)$subledger_id > 0) {
                $condition .= ' AND VI.subledger_id=' . $subledger_id;
                $condition_for_opening .= ' AND VI.subledger_id=' . $subledger_id;
            }
        }*/
         
            
        
       
        $query = 'CREATE OR REPLACE VIEW {{finance_statement}} AS (SELECT
    VT.description AS voucher_type,
    V.id AS voucher_id,
    V.voucher_date AS voucher_date,
    V.due_date AS due_date,
    V.reference_no AS reference_no,
    VI.narration AS narration,
    VI.id AS voucher_item_id,
    V.voucher_no,
    ROUND(ABS(VI.amount*VI.exchange_rate), 4) AS amount,
    ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS allocated,
    ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS balance
FROM {{finance_voucher_items}} VI
LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
LEFT JOIN {{finance_voucher_type}} VT ON VT.id = V.voucher_type
LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
WHERE V.is_posted ="Y" AND V.voucher_date<="' . $to_date . '"  AND ' . $amountType . ' AND VI.ledger_id = ' . $ledger_id . ' AND VI.subledger_id = ' . $subledger_id . ' ' . $condition . '
GROUP BY VI.id)
UNION
(SELECT
    VT.description AS voucher_type,
    V.id AS voucher_id,
    V.voucher_date AS voucher_date,
    V.due_date AS due_date,
    V.reference_no AS reference_no,
    VI.narration AS narration,
    VI.id AS voucher_item_id,
    V.voucher_no,
    -(ROUND(ABS(VI.amount*VI.exchange_rate), 4)) AS amount,
    -(ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS allocated,
    -(ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS balance
FROM {{finance_voucher_items}} VI
LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
LEFT JOIN {{finance_voucher_type}} VT ON VT.id = V.voucher_type
LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
WHERE V.is_posted ="Y" AND V.voucher_date<="' . $to_date . '"  AND ' . $paidType . ' AND VI.ledger_id = ' . $ledger_id . ' AND VI.subledger_id = ' . $subledger_id . ' ' . $condition . '
GROUP BY VI.id)';
        if ($ledger_id > 0 && $subledger_id > 0) {
            Yii::app()->db->createCommand($query)->execute();
            $items = Yii::app()->db->createCommand('SELECT * FROM {{finance_statement}} order by voucher_date')->queryAll();
        }
        $amount = 0;
        $allocated = 0;
        $balanced = 0;
        //        $table .= '<tr>
        //                            <td colspan="3">Opening Balance</td>
        //                            <td style="text-align:right !important;">'.Yii::app()->numberFormatter->formatCurrency(($opening_bal/$exchange_rate), " ") . '</td>
        //                            <td style="text-align:right !important;">'.Yii::app()->numberFormatter->formatCurrency((0/$exchange_rate), " ") . '</td>
        //                            <td style="text-align:right !important;">'.Yii::app()->numberFormatter->formatCurrency(($opening_bal/$exchange_rate), " ") . '</td>
        //                        </tr>';
        $amount += $opening_bal;
        $allocated += 0;
        $balanced += $opening_bal;
        if (!empty($items)) {
            foreach ($items as $each) {
                if (round($each['balance'], 2) != 0) {
                    if ($_POST['type'] == 'customer') {
                        $vouchreformat = '<a href="#" onclick="' . generateUrl(FinanceVoucherItems::model()->findBypk((int) $each['voucher_item_id'])) . '">' . $each['voucher_no'] . '</a>';

                        $head = FinanceVoucherHead::model()->findByPk($each['voucher_id']);
                        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="SI" AND outlet=' . $outlet))->id;
                        if ($head->voucher_type == $vouchertype) {
                            $ref = PurchaseInvoice::model()->findByPk($head->voucher_no)->reference_no;
                        } else {
                            $ref = $each['reference_no'];
                        }
                        if (empty($ref)) {
                            $ref = $head->voucher_no;
                        }
                        $vouchreformat = '<a href="#" onclick="' . generateUrl(FinanceVoucherItems::model()->findBypk((int) $each['voucher_item_id'])) . '">' .  $each['voucher_no'] . '</a>';
                    } else {
                        $head = FinanceVoucherHead::model()->findByPk($each['voucher_id']);
                        $vouchertype = FinanceVoucherType::model()->find(array('condition' => 'code="PI" AND outlet=' . $outlet))->id;
                        if ($head->voucher_type == $vouchertype) {
                            $ref = PurchaseInvoice::model()->findByPk($head->header_table_id)->reference_no;
                        } else {
                            $ref = $each['reference_no'];
                        }
                        if (empty($ref)) {
                            $ref = $head->voucher_no;
                        }
                        $vouchreformat = '<a href="#" onclick="' . generateUrl(FinanceVoucherItems::model()->findBypk((int) $each['voucher_item_id'])) . '">' . $each['voucher_no']  . '</a>';
                    }
                    $now = time(); // or your date as well
                    $your_date = strtotime($each['due_date']);
                    $datediff = $now - $your_date;
                    $over_due = round($datediff / (60 * 60 * 24));
                    if ($over_due <= 0) {
                        $over_due = 0;
                    }
                    $table .= '<tr>
                            <td>' . date("d/m/Y", strtotime($each['voucher_date'])) . '</td>
                            <td>' . $each['voucher_type'] . '</td>
                            <td>' . $vouchreformat . '</td>
                            <td>' . date("d/m/Y", strtotime($each['due_date'])) . '</td>
                            <td>' . $over_due . ' Days</td>
                            <td>' . $ref . '</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($each['amount'] / $exchange_rate), " ") . '</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($each['allocated'] / $exchange_rate), " ") . '</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($each['balance'] / $exchange_rate), " ") . '</td>
                        </tr>';
                    $amount += $each['amount'] / $exchange_rate;
                    $allocated += $each['allocated'] / $exchange_rate;
                    $balanced += $each['balance'] / $exchange_rate;
                }
            }
            $table .= '<tr>
                            <td style="text-align:right !important;" colspan="6"><b>Total</b></td>
                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(($amount / $exchange_rate), " ") . '</b></td>
                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(($allocated / $exchange_rate), " ") . '</b></td>
                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(($balanced / $exchange_rate), " ") . '</b></td>
                        </tr>';
        } else {
            $table .= '<tr>
                            <td colspan="6" style="text-align:center !important;">No Data</td>
                      </tr>';
        }
        echo $table;
    }

    public function actionStatement_pdf_filter()
    {
        Yii::app()->clientScript->scriptMap = array('*jquery.js' => false, '*jquery.min.js' => false, 'jquery.min.js' => false, '*jquery-ui.js' => false, '*jquery-ui.min.js' => false);
        $this->render('statement_filter', array('ledger_id' => $_GET['ledger_id'], 'subledger_id' => $_GET['subledger_id'], 'type' => $_GET['type']));
    }

    public function actionstatement_pdf()
    {
        $from = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-01');
        $to = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');

        $ledger = (int) Yii::app()->request->getParam('ledger_id');
        $subledger = (int) Yii::app()->request->getParam('subledger_id');
        $layout = (int) Yii::app()->request->getParam('layout');
        $type = Yii::app()->request->getParam('type');
        $currency = Yii::app()->request->getParam('currency');
        $outlet = Yii::app()->request->getParam('outlet');
        $param = array(
            'ledger' => $ledger,
            'subledger' => $subledger,
            'type' => $type,
            'from' => $from,
            'to' => $to,
            'currency' => $currency,
            'outlet' => $outlet
        );

        $mode = 'A4';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = $layout == 1 ? 'pdf_statement_base' : 'pdf_statement_voucher';

        $mpdf->WriteHTML($this->renderPartial($view, $param, true));
        $mpdf->Output("statement" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionstatement_excel()
    {
        $from = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-01');
        $to = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');

        $ledger = (int) Yii::app()->request->getParam('ledger_id');
        $subledger = (int) Yii::app()->request->getParam('subledger_id');
        $type = Yii::app()->request->getParam('type');
        $currency = (int) Yii::app()->request->getParam('currency');
        $outlet = (int) Yii::app()->request->getParam('outlet');
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;

        $subledgerModel = FinanceSubledger::model()->findBypk((int) $subledger);

        $amountType = 'VI.amount < 0';
        $paidType = 'VI.amount > 0';
        if ($type == 'customer') {
            $amountType = 'VI.amount > 0';
            $paidType = 'VI.amount < 0';
        }
        $condition = '';
        $condition_for_opening = '';
        if ($outlet > 0) {
            $condition .= ' AND V.outlet=' . $outlet;
            $condition_for_opening .= ' AND V.outlet=' . $outlet;
        }
        $items = array();
        //        $query = 'CREATE OR REPLACE VIEW {{finance_statement}} AS (SELECT
        //        V.id AS voucher_id,
        //        V.voucher_date AS voucher_date,
        //        V.due_date AS due_date,
        //        V.reference_no AS reference_no,
        //        VI.narration AS narration,
        //        VI.id AS voucher_item_id,
        //        V.voucher_no,
        //        ROUND(ABS(VI.amount*VI.exchange_rate), 4) AS amount,
        //        ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS allocated,
        //        ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS balance
        //    FROM {{finance_voucher_items}} VI
        //    LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
        //    LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
        //    WHERE V.is_posted ="Y" AND V.voucher_date>="'.$from.'" AND V.voucher_date<="'.$to.'"  AND ' . $amountType . ' AND VI.ledger_id = ' . $ledger . ' AND VI.subledger_id = ' . $subledger . ' '.$condition.'
        //    GROUP BY VI.id)
        //    UNION
        //    (SELECT
        //        V.id AS voucher_id,
        //        V.voucher_date AS voucher_date,
        //        V.due_date AS due_date,
        //        V.reference_no AS reference_no,
        //        VI.narration AS narration,
        //        VI.id AS voucher_item_id,
        //        V.voucher_no,
        //        -(ROUND(ABS(VI.amount*VI.exchange_rate), 4)) AS amount,
        //        -(ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS allocated,
        //        -(ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS balance
        //    FROM {{finance_voucher_items}} VI
        //    LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
        //    LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
        //    WHERE V.is_posted ="Y" AND V.voucher_date<="'.$to.'"  AND ' . $paidType . ' AND VI.ledger_id = ' . $ledger . ' AND VI.subledger_id = ' . $subledger . ' '.$condition.'
        //    GROUP BY VI.id)';
        $query = 'CREATE OR REPLACE VIEW {{finance_statement}} AS (SELECT
                                    VT.description AS voucher_type,
                                    V.id AS voucher_id,
                                    V.voucher_date AS voucher_date,
                                    V.due_date AS due_date,
                                    V.reference_no AS reference_no,
                                    VI.narration AS narration,
                                    VI.id AS voucher_item_id,
                                    V.voucher_no,
                                    ROUND(ABS(VI.amount*VI.exchange_rate), 4) AS amount,
                                    ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS allocated,
                                    ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4) AS balance
                                FROM {{finance_voucher_items}} VI
                                LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
                                LEFT JOIN {{finance_voucher_type}} VT ON VT.id = V.voucher_type
                                LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
                                WHERE V.is_posted ="Y" AND V.voucher_date<="' . $to . '"  AND ' . $amountType . ' AND VI.ledger_id = ' . $ledger . ' AND VI.subledger_id = ' . $subledger . '
                                GROUP BY VI.id)
                                UNION
                                (SELECT
                                    VT.description AS voucher_type,
                                    V.id AS voucher_id,
                                    V.voucher_date AS voucher_date,
                                    V.due_date AS due_date,
                                    V.reference_no AS reference_no,
                                    VI.narration AS narration,
                                    VI.id AS voucher_item_id,
                                    V.voucher_no,
                                    -(ROUND(ABS(VI.amount*VI.exchange_rate), 4)) AS amount,
                                    -(ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS allocated,
                                    -(ROUND(ABS(VI.amount*VI.exchange_rate), 4) - ROUND(IFNULL(ABS(SUM(AI.amount)), 0), 4)) AS balance
                                FROM {{finance_voucher_items}} VI
                                LEFT JOIN {{finance_voucher_head}} V ON V.id = VI.header_id
                                LEFT JOIN {{finance_voucher_type}} VT ON VT.id = V.voucher_type
                                LEFT JOIN {{finance_allocation_items}} AI ON AI.voucher_item_id = VI.id
                                WHERE V.is_posted ="Y" AND V.voucher_date<="' . $to . '"  AND ' . $paidType . ' AND VI.ledger_id = ' . $ledger . ' AND VI.subledger_id = ' . $subledger . '
                                GROUP BY VI.id)';
        if ($ledger > 0 && $subledger > 0) {
            Yii::app()->db->createCommand($query)->execute();
            $items = Yii::app()->db->createCommand('SELECT * FROM {{finance_statement}} order by voucher_date')->queryAll();
        }

        Yii::import('ext.PHPExcel.PHPExcel');

        $excel = new PHPExcel();
        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Statement of Account")
            ->setSubject("Statement of Account")
            ->setDescription("Statement of Account Upto : $to")
            ->setKeywords("Statement of Account")
            ->setCategory("Financial Report");

        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);

        $excel->setActiveSheetIndex(0)->mergeCells('A1:F1');
        $excel->getActiveSheet()->getStyle('A1:F1')->getFont()->setBold(true)->setSize(14);
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Statement for ' . $subledgerModel->description . ' Upto : ' . date("d/m/Y", strtotime($to)));

        $rowId = 3;
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A' . $rowId, 'Date')
            ->setCellValue('B' . $rowId, 'Invoice No')
            ->setCellValue('C' . $rowId, 'Due Date')
            ->setCellValue('D' . $rowId, 'Invoice value')
            ->setCellValue('E' . $rowId, 'Paid')
            ->setCellValue('F' . $rowId, 'Balance');

        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setBold(true)->setSize(14);
        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFill()->applyFromArray(array(
            'type' => PHPExcel_Style_Fill::FILL_SOLID,
            'startcolor' => array(
                'rgb' => 'd9d9d9',
            ),
        ));

        $totalValue = 0;
        $balanceTotal = 0;
        $totalPaid = 0;
        $rowId++;
        //        $excel->setActiveSheetIndex(0)->mergeCells('A' . $rowId . ':C' . $rowId);
        //        $excel->setActiveSheetIndex(0)
        //            ->setCellValue('A' . $rowId, 'Opening Balance');
        //        $excel->setActiveSheetIndex(0)
        //            ->setCellValue('D' . $rowId, $currency_code.Yii::app()->numberFormatter->formatCurrency(($opening_bal/$exchange_rate), " "))
        //            ->setCellValue('E' . $rowId, $currency_code.Yii::app()->numberFormatter->formatCurrency((0/$exchange_rate), " "))
        //            ->setCellValue('F' . $rowId, $currency_code.Yii::app()->numberFormatter->formatCurrency(($opening_bal/$exchange_rate), " "));
        //        $rowId++;
        //        $totalValue += $opening_bal;
        //        $balanceTotal += $opening_bal;
        $totalPaid += 0;
        foreach ($items as $each) {
            if (round($each['balance'], 2) != 0) :
                $totalValue += $each['amount'];
                $balanceTotal += $each['balance'];
                $totalPaid += $each['allocated'];
                if ($_REQUEST['type'] == 'customer') {
                    $vouchreformat = $each['voucher_no'];
                } else {
                    $head = FinanceVoucherHead::model()->findByPk($each['voucher_id']);
                    if ($head->voucher_type == 8) {
                        $ref = PurchaseInvoice::model()->findByPk($head->voucher_no)->invoice_no;
                    } else {
                        $ref = $each['reference_no'];
                    }
                    $vouchreformat = $ref;
                }
                if (empty($ref)) {
                    $ref = $head->voucher_no;
                }
                $excel->setActiveSheetIndex(0)
                    ->setCellValue('A' . $rowId, date("d/m/Y", strtotime($each['voucher_date'])))
                    ->setCellValue('B' . $rowId, $vouchreformat)
                    ->setCellValue('C' . $rowId, date("d/m/Y", strtotime($each['due_date'])))
                    ->setCellValue('D' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($each['amount'] / $exchange_rate), " "))
                    ->setCellValue('E' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($each['allocated'] / $exchange_rate), " "))
                    ->setCellValue('F' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($each['balance'] / $exchange_rate), " "));
                $rowId++;
            endif;
        }

        $excel->getActiveSheet()->getStyle('A' . $rowId . ':F' . $rowId)->getFont()->setBold(true)->setSize(14);
        $excel->getActiveSheet(0)->getStyle('A' . $rowId . ':F' . $rowId)->applyFromArray(array(
            'borders' => array(
                'top' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        ));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $rowId . ':C' . $rowId);
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A' . $rowId, 'Total in AED');
        $excel->setActiveSheetIndex(0)
            ->setCellValue('D' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($totalValue / $exchange_rate), " "))
            ->setCellValue('E' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($totalPaid / $exchange_rate), " "))
            ->setCellValue('F' . $rowId, $currency_code . Yii::app()->numberFormatter->formatCurrency(($balanceTotal / $exchange_rate), " "));

        $excel->getActiveSheet()->getStyle('D2:F' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $rowId)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="statement.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionRec_gl_html()
    {
        $ledgerItems = array();

        $ledger_id = (int) $_POST['ledger_id'];
        $subledger = (int) $_POST['subledger_id'];
        $brand = (int) $_POST['brand'];
        $outlet = (int) $_POST['outlet'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-t');

        $condition = 't.reconciled="Y" AND parent.is_posted = "Y" AND t.reconciled_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        $condition_for_opening = 'I.reconciled="Y" AND H.is_posted = "Y" AND I.reconciled_date < "' . $from_date . '"';

        if ($ledger_id > 0) {
            $condition .= ' AND t.ledger_id IN(' . $ledger_id . ')';
            $condition_for_opening .= ' AND I.ledger_id IN(' . $ledger_id . ')';
        }

        if ($subledger > 0) {
            $condition .= ' AND t.subledger_id=' . $subledger;
            $condition_for_opening .= ' AND I.subledger_id=' . $subledger;
        }

        if ($brand > 0) {
            $condition .= ' AND t.brand_id=' . $brand;
            $condition_for_opening .= ' AND t.brand_id=' . $brand;
        }
        if ($outlet > 0) {
            $condition .= ' AND t.outlet=' . $outlet;
            $condition_for_opening .= ' AND I.outlet=' . $outlet;
        }

        function generateUrl($childModel)
        {
            $url = '#';
            $code = $childModel->parent->vtype->code;
            if ($code == 'SI') {
                $headModel = $childModel->parent->vtype->header_table;
                $vat_field = $childModel->parent->vtype->vat_value;
                $tax = $headModel::model()->findBypk($childModel->parent->header_table_id)->$vat_field;
                $taxType = ($tax > 0) ? 'tax' : 'taxnil';
                $url = "window.open($('#liveSite').val()+'index.php?r=salesinvoice/PrintPDF&id=" . $childModel->parent->header_table_id . "&frm=" . $taxType . "', '_blank');";
            } else if ($code == 'PI') {
                $url = "window.open($('#liveSite').val()+'index.php?r=purchaseinvoice/PrintInvoiceReportPDF&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'DN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=debitnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'CN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=creditnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else {
                $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $childModel->header_id . "', '_blank');";
            }
            return $url;
        }

        $openingBalance = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE ' . $condition_for_opening . ' ')->queryScalar();
        $items = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => $condition, 'order' => 't.reconciled_date ASC'));

        $previousBalance = $openingBalance;
        $closingBalance = $openingBalance;
        $symbol = ($previousBalance > 0) ? 'Dr' : 'Cr';

        $total_debit = 0;
        $total_credit = 0;

        $table = '<table class="table table-hover table-fixed table-bordered" id="gl_table">
                  <thead>
                      <tr>
                        <th style="width:10%" >Date</th>
                        <th style="width:5%" >VO #</th>
                        <th style="width:10%" >Ledger</th>
                        <th style="width:20%" >Subledger</th>
                        <th style="width:8%;text-align:right !important;" class="text-right">Debit (' . FinanceLegder::baseCurrency() . ')</th>
                        <th style="width:8%;text-align:right !important;" class="text-right">Credit (' . FinanceLegder::baseCurrency() . ')</th>
                        <th style="width:10%;text-align:right !important;" class="text-right">Balance</th>
                        <th style="width:40%">Narration</th>
                      </tr>
                  </thead>
                  <tbody>
                  <tr>
                      <td colspan="4" class="text-right" style="text-align:right !important;"><b>Beginning Balance</b></td>
                      <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency((($previousBalance > 0) ? abs($previousBalance) : ''), " ") . '</td>
                      <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency((($previousBalance < 0) ? abs($previousBalance) : ''), " ") . '</td>
                      <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($previousBalance), " ") . ' ' . $symbol . '</td>
                      <td></td>
                  </tr>';
        $parent = 1;
        foreach ($items as $each) {

            $debit = ($each->amount > 0) ? round(($each->amount * $each->exchange_rate), 4) : '';
            $credit = ($each->amount < 0) ? round(abs($each->amount * $each->exchange_rate), 4) : '';
            $running = $debit - $credit + $previousBalance;
            $previousBalance = $running;
            $symbol = ($running > 0) ? 'Dr' : 'Cr';
            $closingBalance += ($debit - $credit);

            $total_debit += $debit;
            $total_credit += $credit;

            $subledgerName = ($each->subledger_id > 0) ? $each->subledger->description : '';
            $vouchreformat = '<a href="#" onclick="' . generateUrl($each) . '">' . $each->parent->fullvoucher . '</a>';
            $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . date("d/m/Y", strtotime($each->reconciled_date)) . '</td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($running), " ") . " " . $symbol . '</td>
                          <td><small>' . $each->narration . '</small></td>
                      </tr>';

            //            $eachItem = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => 't.header_id="' . (int) $each->header_id . '" AND t.id != "' . (int) $each->id . '"', 'order' => 'parent.voucher_date ASC'));
            //            $child = $parent + 1;
            //            foreach ($eachItem as $eachLine) {
            //
            //                $debit = ($eachLine->amount > 0) ? round(($eachLine->amount * $eachLine->exchange_rate), 2) : '';
            //                $credit = ($eachLine->amount < 0) ? round(abs($eachLine->amount * $eachLine->exchange_rate), 2) : '';
            //                $subledgerName = ($eachLine->subledger_id > 0) ? $eachLine->subledger->description : '';
            //
            //                $table .= ' <tr data-id="' . $child . '" data-parent="' . $parent . '">
            //                                    <td style="background-color:#d8f5df"></td>
            //                                    <td style="background-color:#d8f5df"></td>
            //                                    <td style="background-color:#d8f5df">' . $eachLine->ledger->description . '</td>
            //                                    <td style="background-color:#d8f5df">' . $subledgerName . '</td>
            //                                    <td style="background-color:#d8f5df; text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
            //                                    <td style="background-color:#d8f5df; text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
            //                                    <td style="background-color:#d8f5df"></td>
            //                                    <td style="background-color:#d8f5df"><small>' . $eachLine->narration . '</small></td>
            //                            </tr>';
            //                $child++;
            //            }
            $parent = $child;
        }
        $symbol = ($closingBalance > 0) ? 'Dr' : 'Cr';
        $table .= '<tr>
                      <td colspan="4" style="text-align:right !important;"><b>Total</b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " ") . '</b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " ") . '</b></td>
                      <td></td>
                      <td></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="4" style="text-align:right !important;"><b>Closing Balance</b></td>
                      <td colspan="3" style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($closingBalance), " ") . ' ' . $symbol . '</b></td>
                      <td></td>
                  </tr>';
        $table .= '</tbody>
              </table>';
        echo $table;
    }

    public function actionRec_gl_excel()
    {
        Yii::import('ext.PHPExcel.PHPExcel');

        $ledger = $_GET['ledger'];
        $subledger = (int) $_GET['subledger'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-t');
        $outlet = (int) $_GET['outlet'];

        $condition = 't.reconciled="Y" AND parent.is_posted = "Y" AND t.reconciled_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        $condition_for_opening = 'I.reconciled="Y" AND H.is_posted = "Y" AND I.reconciled_date < "' . $from_date . '"';

        if ($ledger != '') {
            $condition .= ' AND t.ledger_id IN(' . $ledger . ')';
            $condition_for_opening .= ' AND I.ledger_id IN(' . $ledger . ')';
        }
        if ($subledger > 0) {
            $condition .= ' AND t.subledger_id=' . $subledger;
            $condition_for_opening .= ' AND I.subledger_id=' . $subledger;
        }
        $brand = (int) $_GET['brand'];
        if ($brand > 0) {
            $condition .= ' AND t.brand_id=' . $brand;
            $condition_for_opening .= ' AND I.subledger_id=' . $brand;
        }
        if ($outlet > 0) {
            $condition .= ' AND t.outlet=' . $outlet;
            $condition_for_opening .= ' AND I.outlet=' . $outlet;
        }


        $openingBalance = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE ' . $condition_for_opening . ' ')->queryScalar();
        $items = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => $condition, 'order' => 't.reconciled_date'));

        $previousBalance = $openingBalance;
        $closingBalance = $openingBalance;
        $symbol = ($previousBalance > 0) ? 'Dr' : 'Cr';

        $total_debit = 0;
        $total_credit = 0;

        // Create new PHPExcel object
        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(6)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(7)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("General Transaction Ledger Report")
            ->setSubject("General Transaction Ledger Report")
            ->setDescription("General Transaction Ledger Report Generated on " . date('d/m/Y'))
            ->setKeywords("General Transaction Ledger Report")
            ->setCategory("Financial Report");

        // Add some data
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Date')
            ->setCellValue('B1', 'Voucher')
            ->setCellValue('C1', 'Ledger')
            ->setCellValue('D1', 'Subledger')
            ->setCellValue('E1', 'Debit (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('F1', 'Credit (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('G1', 'Balance')
            ->setCellValue('H1', 'Narration')
            ->setCellValue('D2', 'Beginning Balance');

        //Opening Balance
        $excel->setActiveSheetIndex(0)
            ->setCellValue('D2', 'Beginning Balance');

        if ($openingBalance > 0) {
            $excel->setActiveSheetIndex(0)
                ->setCellValue('E2', Yii::app()->numberFormatter->formatCurrency(abs($openingBalance), " "));
        } else {
            $excel->setActiveSheetIndex(0)
                ->setCellValue('F2', Yii::app()->numberFormatter->formatCurrency(abs($openingBalance), " "));
        }
        //Data Items
        $parent = 3;
        foreach ($items as $each) {

            $debit = ($each->amount > 0) ? round(($each->amount * $each->exchange_rate), 4) : '';
            $credit = ($each->amount < 0) ? round(abs($each->amount * $each->exchange_rate), 4) : '';
            $running = $debit - $credit + $previousBalance;
            $previousBalance = $running;
            $symbol = ($running > 0) ? 'Dr' : 'Cr';
            $closingBalance += ($debit - $credit);

            $total_debit += $debit;
            $total_credit += $credit;

            $subledgerName = ($each->subledger_id > 0) ? $each->subledger->description : '';

            $excel->getActiveSheet()->getStyle('A1:H1')->getFont()->setBold(true)->setSize(12);
            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $parent, date("d/m/Y", strtotime($each->reconciled_date)))
                ->setCellValue('B' . $parent, $each->parent->fullvoucher)
                ->setCellValue('C' . $parent, $each->ledger->description)
                ->setCellValue('D' . $parent, $subledgerName)
                ->setCellValue('E' . $parent, Yii::app()->numberFormatter->formatCurrency($debit, " "))
                ->setCellValue('F' . $parent, Yii::app()->numberFormatter->formatCurrency($credit, " "))
                ->setCellValue('G' . $parent, Yii::app()->numberFormatter->formatCurrency(abs($running), " ") . " " . $symbol)
                ->setCellValue('H' . $parent, $each->narration);

            if ($ledger != '') {
                $eachItem = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => 't.header_id="' . (int) $each->header_id . '" AND t.id != "' . (int) $each->id . '"', 'order' => 'parent.voucher_date ASC'));
                $child = $parent + 1;
                foreach ($eachItem as $eachLine) {

                    $debit = ($eachLine->amount > 0) ? round(($eachLine->amount * $eachLine->exchange_rate), 2) : '';
                    $credit = ($eachLine->amount < 0) ? round(abs($eachLine->amount * $eachLine->exchange_rate), 2) : '';
                    $subledgerName = ($eachLine->subledger_id > 0) ? $eachLine->subledger->description : '';

                    $excel->setActiveSheetIndex(0)
                        ->setCellValue('C' . $child, $eachLine->ledger->description)
                        ->setCellValue('D' . $child, $subledgerName)
                        ->setCellValue('E' . $child, Yii::app()->numberFormatter->formatCurrency($debit, " "))
                        ->setCellValue('F' . $child, Yii::app()->numberFormatter->formatCurrency($credit, " "))
                        ->setCellValue('H' . $child, $eachLine->narration);

                    $excel->getActiveSheet()->getRowDimension($child)->setVisible(false);

                    $child++;
                }
                $parent = $child;
            } else {
                $parent++;
            }
        }
        $symbol = ($closingBalance > 0) ? 'Dr' : 'Cr';
        $excel->getActiveSheet()->getStyle('A' . $parent . ':H' . $parent)->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $parent, 'Total')
            ->setCellValue('E' . $parent, Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " "))
            ->setCellValue('F' . $parent, Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $parent . ':D' . $parent);
        $excel->getActiveSheet()
            ->getStyle('E2:E' . $parent)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()
            ->getStyle('F2:F' . $parent)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()
            ->getStyle('G2:G' . $parent)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);

        // Rename worksheet
        $excel->getActiveSheet()->setTitle('General Ledger');

        // Set active sheet index to the first sheet, so Excel opens this as the first sheet
        $excel->setActiveSheetIndex(0);
        $parent++;
        $excel->getActiveSheet()->getStyle('A' . $parent . ':H' . $parent)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $parent . ':E' . $parent);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $parent, 'Closing Balance')
            ->setCellValue('F' . $parent, Yii::app()->numberFormatter->formatCurrency(abs($closingBalance), " ") . ' ' . $symbol);

        $styleArray = array(
            'borders' => array(
                'allborders' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        $excel->getActiveSheet(0)->getStyle('A1:H' . $parent)->applyFromArray($styleArray);

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="reconciled_report.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionRec_gL_pdf()
    {

        $from_date = Yii::app()->request->getParam('from_date');
        $to_date = Yii::app()->request->getParam('to_date');
        $ledger = Yii::app()->request->getParam('ledger');
        $subledger = (int) Yii::app()->request->getParam('subledger');
        $brand = (int) Yii::app()->request->getParam('brand');
        $outlet = (int) Yii::app()->request->getParam('outlet');

        $param = array(
            'from_date' => $from_date,
            'to_date' => $to_date,
            'ledger' => $ledger,
            'subledger' => $subledger,
            'outlet' => $outlet,
        );

        $mode = 'A4-L';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'pdf_reconciled_gl_report';
        $mpdf->WriteHTML($this->renderPartial($view, $param, true));
        $mpdf->Output("Reconciled_report" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionCus_pl_report()
    {
        $this->render('cus_pl_report');
    }

    public function actionCus_pl_excel()
    {

        $ledger_id = $_GET['ledger'];
        $subledger_id = $_GET['subledger'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-t');

        $totalSales = 0;
        $totalSales_bonus = 0;
        $totalSales_discount = 0;

        $extras = $subledger_id > 0 ? ' VH.related_subledger=' . $subledger_id . ' AND ' : '';

        $sales = FinanceLegder::findByclass('SALE');
        $services = FinanceLegder::findByclass('SALESRV');
        $bonus = FinanceLegder::findByclass('SALEB');
        $discount = FinanceLegder::findByclass('SALED');
        $cog = FinanceLegder::findByclass('COG');

        $query = 'SELECT
                        S.id AS subledger_id,
                        S.description AS subledger_name,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $sales . ' THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_goods,
                        ROUND((SUM( CASE WHEN VI.ledger_id IN( SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $services . ' ) tmp
                                    ) a ) THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_service,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $bonus . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_bonus,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $discount . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_discount,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $cog . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS cost_of_sales
                    FROM {{finance_voucher_items}} VI
                    LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                    LEFT JOIN {{finance_subledger}} S ON S.id = VH.related_subledger
                    WHERE ' . $extras . ' VH.related_subledger > 0 AND VH.is_posted="Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" GROUP BY VH.related_subledger ORDER BY S.description ASC';

        Yii::import('ext.PHPExcel.PHPExcel');

        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(6)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(7)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(8)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Customer Report")
            ->setSubject("Customer Report")
            ->setDescription("Customer Report Generated on " . date('d/m/Y'))
            ->setKeywords("Customer Report")
            ->setCategory("Financial Report");

        // Add some data
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Customer ')
            ->setCellValue('B1', 'Sales Goods (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('C1', 'Sales Bonus (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('D1', 'Sales Discount (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('E1', 'Services (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('F1', 'Net Sales (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('G1', 'Total COGS (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('H1', 'Total Expenses (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('I1', 'Net Profit (' . FinanceLegder::baseCurrency() . ')');

        $border = array(
            'borders' => array(
                'bottom' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THICK,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        $excel->getActiveSheet(0)->getStyle('A1:I1')->applyFromArray($border); //boom border
        $excel->getActiveSheet()->getStyle('A1:I1')->getFont()->setBold(true)->setSize(12); //bold

        $items = Yii::app()->db->createCommand($query)->queryAll();
        $rowId = 2;


        foreach ($items as $each) {

            $expenses = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id  LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id WHERE  H.is_posted = "Y" AND I.subledger_id=' . $each['subledger_id'] . '  AND L.main_account_type="E" AND  H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ')->queryScalar();

            $netSales = $each['sales_goods'] + $each['sales_service'] - $each['sales_bonus'] - $each['sales_discount'];
            $netProfit = $netSales - $each['cost_of_sales'] - $expenses;

            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, $each['subledger_name'])
                ->setCellValue('B' . $rowId, $each['sales_goods'])
                ->setCellValue('C' . $rowId, $each['sales_bonus'])
                ->setCellValue('D' . $rowId, $each['sales_discount'])
                ->setCellValue('E' . $rowId, $each['sales_service'])

                ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency($netSales, " "))

                ->setCellValue('G' . $rowId, $each['cost_of_sales'])

                ->setCellValue('H' . $rowId, Yii::app()->numberFormatter->formatCurrency($expenses, " "))
                ->setCellValue('I' . $rowId, Yii::app()->numberFormatter->formatCurrency($netProfit, " "));


            $rowId++;
        }

        $excel->getActiveSheet()
            ->getStyle('B2:D' . $rowId)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT); //right align

        // Rename worksheet
        $excel->getActiveSheet()->setTitle('Customer Report');

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="customer_report.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionCus_pl_pdf()
    {

        $ledger_id = $_GET['ledger'];
        $subledger_id = $_GET['subledger'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-t');

        $totalSales = 0;
        $totalSales_bonus = 0;
        $totalSales_discount = 0;

        $extras = $subledger_id > 0 ? ' VH.related_subledger=' . $subledger_id . ' AND ' : '';

        $sales = FinanceLegder::findByclass('SALE');
        $services = FinanceLegder::findByclass('SALESRV');
        $bonus = FinanceLegder::findByclass('SALEB');
        $discount = FinanceLegder::findByclass('SALED');
        $cog = FinanceLegder::findByclass('COG');

        $query = 'SELECT
                        S.id AS subledger_id,
                        S.description AS subledger_name,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $sales . ' THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_goods,
                        ROUND((SUM( CASE WHEN VI.ledger_id IN( SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $services . ' ) tmp
                                    ) a ) THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_service,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $bonus . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_bonus,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $discount . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_discount,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $cog . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS cost_of_sales
                    FROM {{finance_voucher_items}} VI
                    LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                    LEFT JOIN {{finance_subledger}} S ON S.id = VH.related_subledger
                    WHERE ' . $extras . ' VH.related_subledger > 0 AND VH.is_posted="Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" GROUP BY VH.related_subledger ORDER BY S.description ASC';

        $table = '<table class="table table-hover table-fixed table-bordered">
                        <thead>
                            <tr>
                                <th style="width:40%">Customer</th>
                                <th style="width:8%;text-align:right;">Sales Goods (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right;">Sales Bonus (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right;">Sales Discount (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right;">Services (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right;">Net Sales (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right;">Total COGS (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right;">Total Expenses (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right;">Net Profit</th>
                            </tr>
                        </thead>
                        <tbody>';

        $items = Yii::app()->db->createCommand($query)->queryAll();
        if (!empty($items)) {

            foreach ($items as $each) {

                $expenses = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id  LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id WHERE  H.is_posted = "Y" AND I.subledger_id=' . $each['subledger_id'] . '  AND L.main_account_type="E" AND  H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ')->queryScalar();

                $netSales = $each['sales_goods'] + $each['sales_service'] - $each['sales_bonus'] - $each['sales_discount'];
                $netProfit = $netSales - $each['cost_of_sales'] - $expenses;

                $table .= '<tr>
                                    <td>' . $each['subledger_name'] . '</td>
                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_goods'], " ") . '</td>
                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_bonus'], " ") . '</td>
                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_discount'], " ") . '</td>
                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_service'], " ") . '</td>
                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($netSales, " ") . '</td>
                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($each['cost_of_sales'], " ") . '</td>
                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($expenses, " ") . '</td>
                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($netProfit, " ") . '</td>
                               </tr>';
            }
        } else {
            $table .= '<tr>
                                <td colspan="9" class="text-center">No Data</td>
                           </tr>';
        }
        $table .= '</tbody>
        </table>';

        $mode = 'A4';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'pdf_cus_201_report';
        $mpdf->WriteHTML($this->renderPartial($view, array('table' => $table, 'to_date' => $to_date, 'from_date' => $from_date, 'ledger_id' => $ledger_id), true));
        $mpdf->Output("cus_pl_reportt" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionCus_pl_html()
    {
        $ledger_id = $_POST['ledger_id'];
        $subledger_id = $_POST['subledger_id'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-t');

        $totalSales = 0;
        $totalSales_bonus = 0;
        $totalSales_discount = 0;

        function getClick($from_date, $to_date, $subledger)
        {
            return 'js:load_details( \'' . date('d/m/Y', strtotime($from_date)) . '\', \'' . date('d/m/Y', strtotime($to_date)) . '\', ' . $subledger . ');';
        }

        $extras = $subledger_id > 0 ? ' VH.related_subledger=' . $subledger_id . ' AND ' : '';

        $sales = FinanceLegder::findByclass('SALE');
        $services = FinanceLegder::findByclass('SALESRV');
        $bonus = FinanceLegder::findByclass('SALEB');
        $discount = FinanceLegder::findByclass('SALED');
        $cog = FinanceLegder::findByclass('COG');

        $query = 'SELECT
                        S.id AS subledger_id,
                        S.description AS subledger_name,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $sales . ' THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_goods,
                        ROUND((SUM( CASE WHEN VI.ledger_id IN( SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $services . ' ) tmp
                                    ) a ) THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_service,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $bonus . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_bonus,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $discount . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_discount,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $cog . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS cost_of_sales
                    FROM {{finance_voucher_items}} VI
                    LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                    LEFT JOIN {{finance_subledger}} S ON S.id = VH.related_subledger
                    WHERE ' . $extras . ' VH.related_subledger > 0 AND VH.is_posted="Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" GROUP BY VH.related_subledger ORDER BY S.description ASC';

        $table = '<table class="table table-hover table-fixed table-bordered">
                        <thead>
                            <tr>
                                <th style="width:40%">Customer</th>
                                <th style="width:8%;text-align:right !important;">Sales Goods (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right !important;">Sales Bonus (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right !important;">Sales Discount (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right !important;">Services (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right !important;">Net Sales (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right !important;">Total COGS (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right !important;">Total Expenses (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:8%;text-align:right !important;">Net Profit</th>
                            </tr>
                        </thead>
                        <tbody>';

        $items = Yii::app()->db->createCommand($query)->queryAll();
        if (!empty($items)) {

            foreach ($items as $each) {

                $expenses = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id  LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id WHERE  H.is_posted = "Y" AND I.subledger_id=' . $each['subledger_id'] . '  AND L.main_account_type="E" AND  H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ')->queryScalar();

                $netSales = $each['sales_goods'] + $each['sales_service'] - $each['sales_bonus'] - $each['sales_discount'];
                $netProfit = $netSales - $each['cost_of_sales'] - $expenses;

                $table .= '<tr>
                                    <td><a href="#" onclick="' . getClick($from_date, $to_date, $each['subledger_id']) . '">' . $each['subledger_name'] . '</a>' . '</td>
                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_goods'], " ") . '</td>
                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_bonus'], " ") . '</td>
                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_discount'], " ") . '</td>
                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_service'], " ") . '</td>
                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($netSales, " ") . '</td>
                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['cost_of_sales'], " ") . '</td>
                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($expenses, " ") . '</td>
                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($netProfit, " ") . '</td>
                               </tr>';
            }
        } else {
            $table .= '<tr>
                                <td colspan="9" class="text-center">No Data</td>
                           </tr>';
        }
        $table .= '</tbody>
        </table>';
        echo $table;
    }

    public function actionPl_cus_detailed()
    {
        $subledger_id = $_POST['subledger_id'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-t');

        $sales = FinanceLegder::findByclass('SALE');
        $services = FinanceLegder::findByclass('SALESRV');
        $bonus = FinanceLegder::findByclass('SALEB');
        $discount = FinanceLegder::findByclass('SALED');
        $cog = FinanceLegder::findByclass('COG');

        $query = 'SELECT
                        S.id AS subledger_id,
                        S.description AS subledger_name,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $sales . ' THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_goods,
                        ROUND((SUM( CASE WHEN VI.ledger_id IN( SELECT GROUP_CONCAT(lv) AS child FROM (
                                    SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                    WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                    JOIN
                                    (SELECT @pv:=' . $services . ' ) tmp
                                    ) a ) THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_service,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $bonus . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_bonus,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $discount . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_discount,
                        ROUND((SUM( CASE WHEN VI.ledger_id = ' . $cog . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS cost_of_sales
                    FROM {{finance_voucher_items}} VI
                    LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                    LEFT JOIN {{finance_subledger}} S ON S.id = VH.related_subledger
                    WHERE VH.related_subledger=' . $subledger_id . ' AND VI.ledger_id IN (' . $sales . ', ' . $services . ', ' . $bonus . ', ' . $discount . ', ' . $cog . ') AND VH.related_subledger > 0 AND VH.is_posted="Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" GROUP BY VH.related_subledger ORDER BY S.description ASC';

        $items = Yii::app()->db->createCommand($query)->queryAll();
        $each = $items[0];
        $netSales = $each['sales_goods'] + $each['sales_service'] - $each['sales_bonus'] - $each['sales_discount'];

        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:60%">Paricular</th>
                            <th style="width:40%">Amount (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>Sales Goods</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_goods'], " ") . '</td>
                        </tr>
                         <tr>
                            <td>Sales Bonus</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_bonus'], " ") . '</td>
                        </tr>
                        <tr>
                            <td>Sales Discount</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_discount'], " ") . '</td>
                        </tr>
                        <tr>
                            <td>Services</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_service'], " ") . '</td>
                        </tr>
                        <tr>
                            <td>Net Sales</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($netSales, " ") . '</td>
                        </tr>';

        //COGS Expense
        $table .= '<tr>
                                        <td><b>Cost of Goods Sold (-)</b></td>
                                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($each['cost_of_sales'], " ") . '</b></td>
                                    </tr>';

        $netSales -= $each['cost_of_sales'];

        $expenses = Yii::app()->db->createCommand(
            'SELECT
                                                        L.description AS particular,
                                                        ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount
                                                        FROM {{finance_voucher_items}} I
                                                        LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id
                                                        LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id
                                                        WHERE  H.is_posted = "Y" AND I.subledger_id=' . $each['subledger_id'] . '
                                                        AND L.main_account_type="E" AND
                                                        H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" '
        )->queryAll();

        foreach ($expenses as $eachEx) {
            if ($eachEx['particular'] != "") {
                $table .= '<tr>
                                        <td><b>' . $eachEx['particular'] . ' (-)</b></td>
                                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($eachEx['amount'], " ") . '</b></td>
                                    </tr>';
            }

            $netSales -= $eachEx['amount'];
        }

        $table .= '<tr>
                            <td style="color:#1F67B2;text-align:right !important;"><b>Profit</b></td>
                            <td style="color:#1F67B2;text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($netSales, " ") . '</b></td>
                        </tr>';

        $table .= '</tbody>
                </table>';

        echo $table;
    }

    public function actionEmp_pl_report()
    {
        $this->render('emp_pl_report');
    }

    public function actionEmp_pl_pdf()
    {

        $subledger_id = $_GET['subledger_id'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-t');

        $sales = FinanceLegder::findByclass('SALE');
        $services = FinanceLegder::findByclass('SALESRV');
        $bonus = FinanceLegder::findByclass('SALEB');
        $discount = FinanceLegder::findByclass('SALED');
        $cog = FinanceLegder::findByclass('COG');

        $extras = $subledger_id > 0 ? ' I.subledger_id=' . $subledger_id . ' AND ' : '';
        $items = Yii::app()->db->createCommand(
            'SELECT
                                                    S.description AS subledger_name,
                                                    S.id AS subledger_id,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $sales . ' THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_goods,
                                                    ROUND((SUM( CASE WHEN I.ledger_id IN( SELECT GROUP_CONCAT(lv) AS child FROM (
                                                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                                                JOIN
                                                                (SELECT @pv:=' . $services . ' ) tmp
                                                                ) a ) THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_service,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $bonus . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_bonus,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $discount . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_discount
                                                FROM {{finance_voucher_items}} I
                                                LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id
                                                LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id
                                                LEFT JOIN {{finance_subledger}} S ON S.id = I.subledger_id
                                                WHERE ' . $extras . ' H.is_posted = "Y"
                                                AND L.main_account_type="I" AND L.id IN(' . $sales . ', ' . $services . ', ' . $bonus . ', ' . $discount . ') AND
                                                H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" GROUP BY I.subledger_id ORDER BY S.description ASC'
        )->queryAll();

        $table = '<table class="table table-hover table-fixed table-bordered">
                        <thead>
                            <tr>
                                <th style="width:20%">Employee/Salesman</th>
                                <th style="width:10%;text-align:right;">Sales Goods (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right;">Sales Bonus (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right;">Sales Discount (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right;">Services (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right;">Net Sales (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right;">COGS (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right;">Total Expenses (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right;">Profit</th>
                            </tr>
                        </thead>
                        <tbody>';

        if (!empty($items)) {

            foreach ($items as $each) {

                $cost_of_sales = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id  WHERE  H.is_posted = "Y" AND H.emp_subledger=' . $each['subledger_id'] . '  AND I.ledger_id=' . $cog . ' AND H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ')->queryScalar();
                $expenses = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id  LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id WHERE  H.is_posted = "Y" AND I.subledger_id=' . $each['subledger_id'] . '  AND L.main_account_type="E" AND  H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ')->queryScalar();

                $netSales = $each['sales_goods'] + $each['sales_service'] - $each['sales_bonus'] - $each['sales_discount'];
                $netProfit = $netSales - $cost_of_sales - $expenses;

                $table .= '<tr>
                                                   <td>' . $each['subledger_name'] . '</td>
                                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_goods'], " ") . '</td>
                                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_bonus'], " ") . '</td>
                                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_discount'], " ") . '</td>
                                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_service'], " ") . '</td>
                                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($netSales, " ") . '</td>
                                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($cost_of_sales, " ") . '</td>
                                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($expenses, " ") . '</td>
                                                    <td style="text-align:right;">' . Yii::app()->numberFormatter->formatCurrency($netProfit, " ") . '</td>
                                               </tr>';
            }
        } else {
            $table .= '<tr>
                                <td colspan="9" class="text-center">No Data</td>
                           </tr>';
        }
        $table .= '</tbody>
        </table>';

        $mode = 'A4';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'pdf_emp_report';
        $mpdf->WriteHTML($this->renderPartial($view, array('table' => $table, 'to_date' => $to_date, 'from_date' => $from_date, 'subledger_id' => $subledger_id), true));
        $mpdf->Output("emp_pl_reportt" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionEmp_pl_excel()
    {

        $subledger_id = $_GET['subledger_id'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-t');

        $sales = FinanceLegder::findByclass('SALE');
        $services = FinanceLegder::findByclass('SALESRV');
        $bonus = FinanceLegder::findByclass('SALEB');
        $discount = FinanceLegder::findByclass('SALED');
        $cog = FinanceLegder::findByclass('COG');

        $extras = $subledger_id > 0 ? ' I.subledger_id=' . $subledger_id . ' AND ' : '';
        $items = Yii::app()->db->createCommand(
            'SELECT
                                                    S.description AS subledger_name,
                                                    S.id AS subledger_id,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $sales . ' THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_goods,
                                                    ROUND((SUM( CASE WHEN I.ledger_id IN( SELECT GROUP_CONCAT(lv) AS child FROM (
                                                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                                                JOIN
                                                                (SELECT @pv:=' . $services . ' ) tmp
                                                                ) a ) THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_service,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $bonus . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_bonus,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $discount . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_discount
                                                FROM {{finance_voucher_items}} I
                                                LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id
                                                LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id
                                                LEFT JOIN {{finance_subledger}} S ON S.id = I.subledger_id
                                                WHERE ' . $extras . ' H.is_posted = "Y"
                                                AND L.main_account_type="I" AND L.id IN(' . $sales . ', ' . $services . ', ' . $bonus . ', ' . $discount . ') AND
                                                H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" GROUP BY I.subledger_id ORDER BY S.description ASC'
        )->queryAll();

        Yii::import('ext.PHPExcel.PHPExcel');

        $excel = new PHPExcel();

        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(6)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(7)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Employee Report")
            ->setSubject("Employee Report")
            ->setDescription("Employee Report Generated on " . date('d/m/Y'))
            ->setKeywords("Employee Report")
            ->setCategory("Financial Report");

        // Add some data
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Employee/Salesman ')
            ->setCellValue('B1', 'Sales Goods (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('C1', 'Sales Bonus (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('D1', 'Sales Discount (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('E1', 'Services (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('F1', 'Net Sales (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('G1', 'COGS (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('H1', 'Total Expenses (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('I1', 'Profit ');

        $border = array(
            'borders' => array(
                'bottom' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THICK,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        $excel->getActiveSheet(0)->getStyle('A1:I1')->applyFromArray($border); //boom border
        $excel->getActiveSheet()->getStyle('A1:I1')->getFont()->setBold(true)->setSize(12); //bold

        //  $items = Yii::app()->db->createCommand($query)->queryAll();
        $rowId = 2;



        foreach ($items as $each) {

            $cost_of_sales = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id  WHERE  H.is_posted = "Y" AND H.emp_subledger=' . $each['subledger_id'] . '  AND I.ledger_id=' . $cog . ' AND H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ')->queryScalar();
            $expenses = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id  LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id WHERE  H.is_posted = "Y" AND I.subledger_id=' . $each['subledger_id'] . '  AND L.main_account_type="E" AND  H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ')->queryScalar();

            $netSales = $each['sales_goods'] + $each['sales_service'] - $each['sales_bonus'] - $each['sales_discount'];
            $netProfit = $netSales - $cost_of_sales - $expenses;

            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, $each['subledger_name'])
                ->setCellValue('B' . $rowId, $each['sales_goods'])
                ->setCellValue('C' . $rowId, $each['sales_bonus'])
                ->setCellValue('D' . $rowId, $each['sales_discount'])
                ->setCellValue('E' . $rowId, $each['sales_service'])

                ->setCellValue('F' . $rowId, Yii::app()->numberFormatter->formatCurrency($netSales, " "))

                ->setCellValue('G' . $rowId, $each['cost_of_sales'])

                ->setCellValue('H' . $rowId, Yii::app()->numberFormatter->formatCurrency($expenses, " "))
                ->setCellValue('I' . $rowId, Yii::app()->numberFormatter->formatCurrency($netProfit, " "));


            $rowId++;
        }


        $excel->getActiveSheet()
            ->getStyle('B2:D' . $rowId)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT); //right align

        // Rename worksheet
        $excel->getActiveSheet()->setTitle('Employee Report');

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="employee_report.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionEmp_pl_html()
    {
        $subledger_id = $_POST['subledger_id'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-t');

        function getClick($from_date, $to_date, $subledger)
        {
            return 'js:load_details( \'' . date('d/m/Y', strtotime($from_date)) . '\', \'' . date('d/m/Y', strtotime($to_date)) . '\', ' . $subledger . ');';
        }

        $sales = FinanceLegder::findByclass('SALE');
        $services = FinanceLegder::findByclass('SALESRV');
        $bonus = FinanceLegder::findByclass('SALEB');
        $discount = FinanceLegder::findByclass('SALED');
        $cog = FinanceLegder::findByclass('COG');

        $extras = $subledger_id > 0 ? ' I.subledger_id=' . $subledger_id . ' AND ' : '';
        $items = Yii::app()->db->createCommand(
            'SELECT
                                                    S.description AS subledger_name,
                                                    S.id AS subledger_id,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $sales . ' THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_goods,
                                                    ROUND((SUM( CASE WHEN I.ledger_id IN( SELECT GROUP_CONCAT(lv) AS child FROM (
                                                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                                                JOIN
                                                                (SELECT @pv:=' . $services . ' ) tmp
                                                                ) a ) THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_service,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $bonus . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_bonus,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $discount . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_discount
                                                FROM {{finance_voucher_items}} I
                                                LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id
                                                LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id
                                                LEFT JOIN {{finance_subledger}} S ON S.id = I.subledger_id
                                                WHERE ' . $extras . ' H.is_posted = "Y"
                                                AND L.main_account_type="I" AND L.id IN(' . $sales . ', ' . $services . ', ' . $bonus . ', ' . $discount . ') AND
                                                H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" GROUP BY I.subledger_id ORDER BY S.description ASC'
        )->queryAll();

        $table = '<table class="table table-hover table-fixed table-bordered">
                        <thead>
                            <tr>
                                <th style="width:20%">Employee/Salesman</th>
                                <th style="width:10%;text-align:right !important;">Sales Goods (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right !important;">Sales Bonus (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right !important;">Sales Discount (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right !important;">Services (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right !important;">Net Sales (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right !important;">COGS (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right !important;">Total Expenses (' . FinanceLegder::baseCurrency() . ')</th>
                                <th style="width:10%;text-align:right !important;">Profit</th>
                            </tr>
                        </thead>
                        <tbody>';

        if (!empty($items)) {

            foreach ($items as $each) {

                $cost_of_sales = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id  WHERE  H.is_posted = "Y" AND H.emp_subledger=' . $each['subledger_id'] . '  AND I.ledger_id=' . $cog . ' AND H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ')->queryScalar();
                $expenses = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id  LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id WHERE  H.is_posted = "Y" AND I.subledger_id=' . $each['subledger_id'] . '  AND L.main_account_type="E" AND  H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ')->queryScalar();

                $netSales = $each['sales_goods'] + $each['sales_service'] - $each['sales_bonus'] - $each['sales_discount'];
                $netProfit = $netSales - $cost_of_sales - $expenses;

                $table .= '<tr>
                                                    <td><a href="#" onclick="' . getClick($from_date, $to_date, $each['subledger_id']) . '">' . $each['subledger_name'] . '</a>' . '</td>
                                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_goods'], " ") . '</td>
                                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_bonus'], " ") . '</td>
                                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_discount'], " ") . '</td>
                                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_service'], " ") . '</td>
                                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($netSales, " ") . '</td>
                                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($cost_of_sales, " ") . '</td>
                                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($expenses, " ") . '</td>
                                                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($netProfit, " ") . '</td>
                                               </tr>';
            }
        } else {
            $table .= '<tr>
                                                <td colspan="8" class="text-center">No Data</td>
                                           </tr>';
        }

        $table .= '</tbody>
        </table>';
        echo $table;
    }

    public function actionPl_emp_detailed()
    {
        $subledger_id = $_POST['subledger_id'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-t');

        $sales = FinanceLegder::findByclass('SALE');
        $services = FinanceLegder::findByclass('SALESRV');
        $bonus = FinanceLegder::findByclass('SALEB');
        $discount = FinanceLegder::findByclass('SALED');
        $cog = FinanceLegder::findByclass('COG');

        $items = Yii::app()->db->createCommand(
            'SELECT
                                                    S.description AS subledger_name,
                                                    S.id AS subledger_id,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $sales . ' THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_goods,
                                                    ROUND((SUM( CASE WHEN I.ledger_id IN( SELECT GROUP_CONCAT(lv) AS child FROM (
                                                                SELECT @pv:=(SELECT GROUP_CONCAT(id SEPARATOR ",") FROM {{finance_legder}}
                                                                WHERE FIND_IN_SET(parent_account, @pv)) AS lv FROM {{finance_legder}}
                                                                JOIN
                                                                (SELECT @pv:=' . $services . ' ) tmp
                                                                ) a ) THEN -1*( amount*exchange_rate) ELSE 0 END )), 4) AS sales_service,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $bonus . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_bonus,
                                                    ROUND((SUM( CASE WHEN I.ledger_id = ' . $discount . ' THEN ( amount*exchange_rate) ELSE 0 END )), 4) AS sales_discount
                                                FROM {{finance_voucher_items}} I
                                                LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id
                                                LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id
                                                LEFT JOIN {{finance_subledger}} S ON S.id = I.subledger_id
                                                WHERE I.subledger_id=' . $subledger_id . ' AND  H.is_posted = "Y"
                                                AND L.main_account_type="I" AND L.id IN(' . $sales . ', ' . $services . ', ' . $bonus . ', ' . $discount . ') AND
                                                H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" GROUP BY I.subledger_id ORDER BY S.description ASC'
        )->queryAll();
        $each = $items[0];

        $netSales = $each['sales_goods'] + $each['sales_service'] - $each['sales_bonus'] - $each['sales_discount'];
        $cost_of_sales = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id  WHERE  H.is_posted = "Y" AND H.emp_subledger=' . $subledger_id . '  AND I.ledger_id=' . $cog . ' AND H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" ')->queryScalar();

        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:60%">Paricular</th>
                            <th style="width:40%">Amount (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>Sales Goods</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_goods'], " ") . '</td>
                        </tr>
                         <tr>
                            <td>Sales Bonus</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_bonus'], " ") . '</td>
                        </tr>
                        <tr>
                            <td>Sales Discount</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_discount'], " ") . '</td>
                        </tr>
                        <tr>
                            <td>Services</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_service'], " ") . '</td>
                        </tr>
                        <tr>
                            <td>Net Sales</td>
                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($netSales, " ") . '</td>
                        </tr>
                        <tr>
                            <td><b>Cost of Sales (-)</b></td>
                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($cost_of_sales, " ") . '</b></td>
                        </tr>';

        $netSales -= $cost_of_sales;

        $expenses = Yii::app()->db->createCommand(
            'SELECT
                                                        L.description AS particular,
                                                        ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount
                                                        FROM {{finance_voucher_items}} I
                                                        LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id
                                                        LEFT JOIN {{finance_legder}} L ON L.id = I.ledger_id
                                                        WHERE  H.is_posted = "Y" AND I.subledger_id=' . $each['subledger_id'] . '
                                                        AND L.main_account_type="E" AND
                                                        H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" '
        )->queryAll();

        foreach ($expenses as $eachEx) {
            if ($eachEx['particular'] != "") {
                $table .= '<tr>
                                        <td><b>' . $eachEx['particular'] . ' (-)</b></td>
                                        <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($eachEx['amount'], " ") . '</b></td>
                                    </tr>';
            }

            $netSales -= $eachEx['amount'];
        }

        $table .= '<tr>
                            <td style="color:#1F67B2;text-align:right !important;"><b>Profit</b></td>
                            <td style="color:#1F67B2;text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($netSales, " ") . '</b></td>
                        </tr>';

        $table .= '</tbody>
                </table>';

        echo $table;
    }

    public function actionSales_cg_report()
    {
        $this->render('sales_cg_report');
    }

    public function actionSales_cg_pdf()
    {
        $product_id = (int) $_GET['product_id'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-t');

        $items = Yii::app()->db->createCommand('SELECT
                                                    C.customer_name,
                                                    ROUND((SUM(II.quantity*II.rate*I.exchange_rate)), 4) AS sales,
                                                    ROUND(SUM(II.bonus_qty*II.rate*I.exchange_rate), 4) AS sales_bonus,
                                                    ROUND(SUM(II.deduction_amount*I.exchange_rate), 4) AS sales_discount,
                                                    ROUND((SUM((II.quantity+II.bonus_qty)*II.cost_rate)), 4) AS total_cogs
                                                FROM {{invoice_item}} II
                                                LEFT JOIN {{invoice}} I ON I.id = II.invoice_id
                                                LEFT JOIN {{customer}} C ON C.id = I.customer_id
                                                WHERE II.product_id="' . $product_id . '" AND I.invoice_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND I.posted ="Y"
                                                GROUP BY I.customer_id
                                                ORDER BY C.customer_name')->queryAll();

        $table = '<table class="table table-hover table-fixed table-bordered">
                                                <thead>
                                                    <tr>
                                                        <th style="width:30%">Customer</th>
                                                        <th style="width:10%;text-align:right !important;">Sales (' . FinanceLegder::baseCurrency() . ')</th>
                                                        <th style="width:10%;text-align:right !important;">Sales Bonus (' . FinanceLegder::baseCurrency() . ')</th>
                                                        <th style="width:10%;text-align:right !important;">Sales Discount (' . FinanceLegder::baseCurrency() . ')</th>
                                                        <th style="width:10%;text-align:right !important;">Net Sales (' . FinanceLegder::baseCurrency() . ')</th>
                                                        <th style="width:10%;text-align:right !important;">COGS (' . FinanceLegder::baseCurrency() . ')</th>
                                                        <th style="width:10%;text-align:right !important;">Profitt (' . FinanceLegder::baseCurrency() . ')</th>
                                                    </tr>
                                                </thead>
                                                <tbody>';

        if (!empty($items)) {

            foreach ($items as $each) {
                $netSales = $each['sales'] - $each['sales_discount'];
                $netProfit = $netSales - $each['total_cogs'];
                $table .= '<tr>
                                                                            <td>' . $each['customer_name'] . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales'] + $each['sales_bonus'], " ") . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_bonus'], " ") . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_discount'], " ") . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($netSales, " ") . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['total_cogs'], " ") . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($netProfit, " ") . '</td>
                                                                       </tr>';
            }
        } else {
            $table .= '<tr>
                                <td colspan="9" class="text-center">No Data</td>
                           </tr>';
        }
        $table .= '</tbody>
        </table>';

        $mode = 'A4';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'pdf_sales_report';
        $mpdf->WriteHTML($this->renderPartial($view, array('table' => $table, 'to_date' => $to_date, 'from_date' => $from_date, 'product_id' => $product_id), true));
        $mpdf->Output("sales_cg_reportt" . date("d-m-Y") . ".pdf", 'I');
    }


    public function actionSales_cg_excel()
    {
        $product_id = (int) $_GET['product_id'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-t');

        $items = Yii::app()->db->createCommand('SELECT
                                                    C.customer_name,
                                                    ROUND((SUM(II.quantity*II.rate*I.exchange_rate)), 4) AS sales,
                                                    ROUND(SUM(II.bonus_qty*II.rate*I.exchange_rate), 4) AS sales_bonus,
                                                    ROUND(SUM(II.deduction_amount*I.exchange_rate), 4) AS sales_discount,
                                                    ROUND((SUM((II.quantity+II.bonus_qty)*II.cost_rate)), 4) AS total_cogs
                                                FROM {{invoice_item}} II
                                                LEFT JOIN {{invoice}} I ON I.id = II.invoice_id
                                                LEFT JOIN {{customer}} C ON C.id = I.customer_id
                                                WHERE II.product_id="' . $product_id . '" AND I.invoice_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND I.posted ="Y"
                                                GROUP BY I.customer_id
                                                ORDER BY C.customer_name')->queryAll();









        Yii::import('ext.PHPExcel.PHPExcel');

        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(6)->setAutoSize(true);


        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Sales VS COGS Report")
            ->setSubject("Sales VS COGS Report")
            ->setDescription("Sales VS COGS Report Generated on " . date('d/m/Y'))
            ->setKeywords("Sales VS COGS Report")
            ->setCategory("Financial Report");

        // Add some data
        $excel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Customer ')
            ->setCellValue('B1', 'Sales (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('C1', 'Sales Bonus (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('D1', 'Sales Discount (' . FinanceLegder::baseCurrency() . ')')

            ->setCellValue('E1', 'Net Sales (' . FinanceLegder::baseCurrency() . ')')
            ->setCellValue('F1', 'COGS (' . FinanceLegder::baseCurrency() . ')')

            ->setCellValue('G1', 'Profit (' . FinanceLegder::baseCurrency() . ')');

        $border = array(
            'borders' => array(
                'bottom' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THICK,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );


        $excel->getActiveSheet(0)->getStyle('A1:G1')->applyFromArray($border); //boom border
        $excel->getActiveSheet()->getStyle('A1:G1')->getFont()->setBold(true)->setSize(12); //bold


        $rowId = 2;


        foreach ($items as $each) {
            $netSales = $each['sales'] - $each['sales_discount'];
            $netProfit = $netSales - $each['total_cogs'];




            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $rowId, $each['customer_name'])
                ->setCellValue('B' . $rowId, $each['sales'] + $each['sales_bonus'])
                ->setCellValue('C' . $rowId, $each['sales_bonus'])
                ->setCellValue('D' . $rowId, $each['sales_discount'])

                ->setCellValue('E' . $rowId, Yii::app()->numberFormatter->formatCurrency($netSales, " "))

                ->setCellValue('F' . $rowId, $each['total_cogs'])


                ->setCellValue('G' . $rowId, Yii::app()->numberFormatter->formatCurrency($netProfit, " "));


            $rowId++;
        }


        $excel->getActiveSheet()
            ->getStyle('B2:D' . $rowId)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT); //right align

        // Rename worksheet
        $excel->getActiveSheet()->setTitle('Sales Vs COGS Report');

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="sales_cogs_report.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionSales_cg_html()
    {
        $product_id = (int) $_POST['product_id'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-t');

        $items = Yii::app()->db->createCommand('SELECT
                                                    C.customer_name,
                                                    ROUND((SUM(II.quantity*II.rate*I.exchange_rate)), 4) AS sales,
                                                    ROUND(SUM(II.bonus_qty*II.rate*I.exchange_rate), 4) AS sales_bonus,
                                                    ROUND(SUM(II.deduction_amount*I.exchange_rate), 4) AS sales_discount,
                                                    ROUND((SUM((II.quantity+II.bonus_qty)*II.cost_rate)), 4) AS total_cogs
                                                FROM {{invoice_item}} II
                                                LEFT JOIN {{invoice}} I ON I.id = II.invoice_id
                                                LEFT JOIN {{customer}} C ON C.id = I.customer_id
                                                WHERE II.product_id="' . $product_id . '" AND I.invoice_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND I.posted ="Y"
                                                GROUP BY I.customer_id
                                                ORDER BY C.customer_name')->queryAll();

        $table = '<table class="table table-hover table-fixed table-bordered">
                                                <thead>
                                                    <tr>
                                                        <th style="width:30%">Customer</th>
                                                        <th style="width:10%;text-align:right !important;">Sales (' . FinanceLegder::baseCurrency() . ')</th>
                                                        <th style="width:10%;text-align:right !important;">Sales Bonus (' . FinanceLegder::baseCurrency() . ')</th>
                                                        <th style="width:10%;text-align:right !important;">Sales Discount (' . FinanceLegder::baseCurrency() . ')</th>
                                                        <th style="width:10%;text-align:right !important;">Net Sales (' . FinanceLegder::baseCurrency() . ')</th>
                                                        <th style="width:10%;text-align:right !important;">COGS (' . FinanceLegder::baseCurrency() . ')</th>
                                                        <th style="width:10%;text-align:right !important;">Profitt (' . FinanceLegder::baseCurrency() . ')</th>
                                                    </tr>
                                                </thead>
                                                <tbody>';

        if (!empty($items)) {

            foreach ($items as $each) {
                $netSales = $each['sales'] - $each['sales_discount'];
                $netProfit = $netSales - $each['total_cogs'];
                $table .= '<tr>
                                                                            <td>' . $each['customer_name'] . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales'] + $each['sales_bonus'], " ") . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_bonus'], " ") . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['sales_discount'], " ") . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($netSales, " ") . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['total_cogs'], " ") . '</td>
                                                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($netProfit, " ") . '</td>
                                                                       </tr>';
            }
        } else {
            $table .= '<tr>
                                                                        <td colspan="7" class="text-center">No Data</td>
                                                                   </tr>';
        }

        $table .= '</tbody>
                                </table>';
        echo $table;
    }

    public function actionSubledger_report()
    {
        $this->render('subledger_report');
    }

    public function actionSubledger_report_html()
    {
        $subledger_id = (int) $_POST['subledger_id'];
        $outlet = (int) $_POST['outlet'];
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = '';
        if ($outlet > 0) {
            $condition .= ' AND VI.outlet=' . $outlet;
        }

        if ($subledger_id > 0) {
            Yii::app()->db->createCommand('CREATE OR REPLACE VIEW {{finance_subledger_summary}} AS SELECT
                                            L.main_account_type,
                                            L.description ,
                                            ROUND((SUM(VI.amount*VI.exchange_rate)), 4) AS balance
                                        FROM erp_finance_voucher_items VI
                                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                                        LEFT JOIN {{finance_subledger}} SL ON SL.id = VI.subledger_id
                                        WHERE VH.is_posted="Y" AND VH.voucher_date <= "' . $to_date . '" AND subledger_id=' . $subledger_id . ' ' . $condition . '
                                        GROUP BY L.id
                                        ORDER BY L.main_account_type ASC')->execute();
        }

        $items = $subledger_id > 0 ? Yii::app()->db->createCommand('SELECT main_account_type FROM {{finance_subledger_summary}} GROUP BY main_account_type')->queryAll() : array();

        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:50%">Ledger</th>
                            <th style="width:50%;text-align:right !important;">Closing Balance (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';
        $labels = array('A' => 'Assets', 'L' => 'Liability', 'I' => 'Income', 'E' => 'Expense');
        if (!empty($items)) {
            foreach ($items as $each) {
                $table .= '<tr> <td colspan="2"><b>' . $labels[$each['main_account_type']] . '</b></td> </tr>';

                foreach (Yii::app()->db->createCommand('SELECT * FROM {{finance_subledger_summary}} WHERE main_account_type="' . $each['main_account_type'] . '"')->queryAll() as $eachItem) {
                    $suffix = $eachItem['balance'] > 0 ? ' Dr' : ' Cr';
                    $table .= '<tr>
                                        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $eachItem['description'] . '</td>
                                        <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($eachItem['balance']), " ") . $suffix . '</td>
                                </tr>';
                }
            }
        } else {
            $table .= '<tr>
                            <td colspan="2" class="text-center">No Data</td>
                        </tr>';
        }

        $table .= '</tbody>
                </table>';
        echo $table;
    }
    public function actionCashflow_report()
    {
        $this->render('cashflow_report');
    }
    public function actionCashflow_report_html()
    {
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');

        //         $SQL="CREATE OR REPLACE VIEW erp_cash_flow AS (select inv.id,inv.invoice_no,inv.invoice_date,pay.payment_terms,pay.no_of_days,
        //         cust.customer_name, DATE_ADD(inv.invoice_date, INTERVAL pay.no_of_days DAY) AS receive_date,DATEDIFF(CURDATE(),
        //         DATE_ADD(inv.invoice_date, INTERVAL pay.no_of_days DAY)) AS due_days,'SI' AS type,cur.currency_code,inv.grand_total,inv.exchange_rate from erp_invoice inv 
        //           LEFT JOIN erp_customer cust ON inv.customer_id=cust.id LEFT JOIN erp_mas_payment_term pay ON inv.payment_terms=pay.id
        //   LEFT JOIN erp_mas_currency cur ON inv.currency=cur.id 
        //          ORDER BY `inv`.`invoice_date` DESC)
        //           UNION 
        //         (select inv.id,inv.invoice_no,inv.invoice_date,pay.payment_terms,pay.no_of_days,vendor.vendor_name,
        //          DATE_ADD(inv.invoice_date, INTERVAL pay.no_of_days DAY) AS receive_date,DATEDIFF(CURDATE(),DATE_ADD(inv.invoice_date, 
        //           INTERVAL pay.no_of_days DAY)) AS due_days,'PI' AS type,cur.currency_code,inv.grand_total,inv.exchange_rate from erp_purchasinginvoice inv 
        //           LEFT JOIN erp_vendor vendor ON inv.vendor_id=vendor.id LEFT JOIN erp_mas_payment_term pay ON inv.payment_terms=pay.id
        //         LEFT JOIN erp_mas_currency cur ON inv.currency=cur.id  ORDER BY `inv`.`invoice_date` DESC)";

        $items = Yii::app()->db->createCommand('SELECT * FROM {{cash_flow}}  where invoice_date>="' . $from_date . '" AND invoice_date<="' . $to_date . '"  order by invoice_date')->queryAll();

        $table = '<table class="table table-hover table-bordered">
                    <thead>
                        <tr>
                            <th style="width:5%">No.</th>
                            <th style="width:5%">Inv. No.</th>
                            <th style="width:30%">Customer / Vendor</th>
                            <th style="width:5%">Inv. Date</th>
                            <th style="width:20%">Payment terms</th>
                            <th style="width:5%">Receipt Date</th>
                            <th style="width:5%">Over Due</th>
                            <th  style="width:5%;text-align:right !important;">Value</th>
                            <th  style="width:5%;text-align:right !important;">Income(BC)</th>
                            <th  style="width:5%;text-align:right !important;">Expense(BC)</th>
                        </tr>
                    </thead>
                    <tbody>';
        $total_amount = 0;
        $total_income = 0;
        $total_expense = 0;
        if (!empty($items)) {
            foreach ($items as $i => $each) {
                $type = $each["type"] == "SI" ? "<i class='fa fa-plus-square' aria-hidden='true' style='color:blue'></i>" : "<i class='fa fa-minus-square' aria-hidden='true' style='color:blue'></i>";
                $color = $each["type"] == "PI" ? "#fff" : "#fff";
                if ($each["type"] == 'SI') {
                    $total += ($each['exchange_rate'] * $each['grand_total']);
                    $income = ($each['exchange_rate'] * $each['grand_total']);
                    $total_income += $income;
                    $expense = 0;
                } else {
                    $total -= ($each['exchange_rate'] * $each['grand_total']);
                    $expense = ($each['exchange_rate'] * $each['grand_total']);
                    $total_expense += $expense;
                    $income = 0;
                }
                $table .= '<tr bgcolor="' . $color . '"> <td>' . ($i + 1) . '</td> <td>' . $each["invoice_no"] . '</td> <td>' . $each["customer_name"] . '</td> 
                <td>' . date("d/m/Y", strtotime($each["invoice_date"])) . '</td>  <td>' . $each["payment_terms"] . '</td><td>' . date("d/m/Y", strtotime($each["receive_date"])) . '</td> <td>' .
                    $each["due_days"] . '</td> <td style="width:20%;text-align:right !important;">' . $each['currency_code'] . ' ' . Yii::app()->numberFormatter->formatCurrency($each['grand_total'], "") . '</td>
                <td style="width:20%;text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($income, "") . '</td>
                <td style="width:20%;text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($expense, "") . '</td></tr>';
            }
        } else {
            $table .= '<tr>
                            <td colspan="10" class="text-center">No Data</td>
                        </tr>';
        }

        $total_amount = Yii::app()->numberFormatter->formatCurrency(($total), "");

        $table .= '<tr>
                        <th colspan="8" class="text-right" style="width:20%;text-align:right !important;">TOTAL</th><th class="text-right" style="width:20%;text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total_income, "") . '</th>
                        <th class="text-right" style="width:20%;text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total_expense, "") . '</th>
                        </tr>';
        if ($total_amount > 0) {
            $table .= '<tr>
        <th colspan="8" class="text-right" style="width:20%;text-align:right !important;">TOTAL</th><th class="text-right" style="width:20%;text-align:right !important;">' . $total_amount . '</th><th></th></tr>';
        } else {
            $table .= '<tr>
        <th colspan="8" class="text-right" style="width:20%;text-align:right !important;">TOTAL</th><th></th><th class="text-right" style="width:20%;text-align:right !important;">' . $total_amount . '</th></tr>';
        }
        $table .= '</tbody>
                </table>';
        echo $table;
    }
    public function actionCashflow_finance_report()
    {
        $this->render('cashflow_finance_report');
    }
    public function actionCashflow_finance_report_html()
    {
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = '(t.ledger_id=21) AND (amount<0 AND t.opening_cheque_cleared="N" AND parent.is_posted = "Y" AND parent.cheque_date BETWEEN "' . $from_date . '" AND "' . $to_date . '")';
        $items = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => $condition, 'order' => 'parent.voucher_date ASC'));
        $total_debit = 0;
        $total_credit = 0;
        // $table = '<table class="table table-hover table-fixed table-bordered">
        //           <thead>
        //               <tr>
        //                 <th style="width:10%" >VO Date</th>
        //                 <th style="width:5%" >VO #</th>
        //                 <th style="width:10%" >Ledger</th>
        //                 <th style="width:20%" >Subledger</th>
        //                 <th style="width:10%" >Cheque Date</th>
        //                 <th style="width:8%;text-align:right !important;" class="text-right">Income (' . FinanceLegder::baseCurrency() . ')</th>
        //                 <th style="width:8%;text-align:right !important;" class="text-right">Expense (' . FinanceLegder::baseCurrency() . ')</th>
        //                 <th style="width:10%;text-align:right !important;" class="text-right">Balance</th>
        //                 <th style="width:40%">Narration</th>
        //               </tr>
        //           </thead>
        //           <tbody>';
        $table = '<table class="table table-hover table-fixed table-bordered">
                  <thead>
                      <tr>
                        <th style="width:80%" >Details</th>
                        <th style="width:10%;text-align:right !important;" class="text-right">Income (' . FinanceLegder::baseCurrency() . ')</th>
                        <th style="width:10%;text-align:right !important;" class="text-right">Expense (' . FinanceLegder::baseCurrency() . ')</th>
                      </tr>
                  </thead>
                  <tbody>';
        //OUTGOING
        $pdci_id = FinanceSystemAccountsMapping::getSystemdefault('pdc_i');
        $pdcr_id = FinanceSystemAccountsMapping::getSystemdefault('pdc_r');
        $cash_id = FinanceSystemAccountsMapping::getSystemdefault('cash_account');
        $debtors_id = FinanceSystemAccountsMapping::getSystemdefault('debtors');
        $bank_id = FinanceSystemAccountsMapping::getSystemdefault('bank');
        $condition = '(I.ledger_id=' . $pdci_id . ') AND (I.amount<0 AND I.opening_cheque_cleared="N" AND H.is_posted = "Y" AND H.cheque_date BETWEEN "' . $from_date . '" AND "' . $to_date . '")';
        $pdc_i = Yii::app()->db->createCommand('select SUM(amount*exchange_rate) from erp_finance_voucher_head H INNER JOIN erp_finance_voucher_items I ON H.id=I.header_id where ' . $condition)->queryScalar();
        $condition1 = '(I.ledger_id=' . $cash_id . ') AND (I.amount<0 AND H.is_posted = "Y" AND H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '")';
        $cash_out = Yii::app()->db->createCommand('select SUM(amount*exchange_rate) from erp_finance_voucher_head H INNER JOIN erp_finance_voucher_items I ON H.id=I.header_id where ' . $condition1)->queryScalar();
        $table .= '<tr bgcolor="#ffcccc"><td>Issued Cheques</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
                  <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($pdc_i), " ") . '</td>
                  </tr>';
        $table .= '<tr bgcolor="#ffcccc"><td>Cash Payables</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
                  <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($cash_out), " ") . '</td>
                  </tr>';
        $total_debit += abs($cash_out);
        $total_debit += abs($pdc_i);
        $purchase_order = Yii::app()->db->createCommand('select SUM(stock_grand_total*exchange_rate) from erp_purchasing_order where order_date>="' . $from_date . '" AND order_date<="' . $to_date . '"')->queryScalar();
        $table .= '<tr bgcolor="#ffcccc"><td>Purchase Order</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
                  <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($purchase_order), " ") . '</td>
                  </tr>';
        $total_debit += abs($purchase_order);
        $wps_value1 = EmployeeSalary::getemployeesmonthlysalary(1, date("m", strtotime($from_date)), date("Y", strtotime($from_date)));
        $wps_value2 = EmployeeSalary::getemployeesmonthlysalary(2, date("m", strtotime($from_date)), date("Y", strtotime($from_date)));
        $wps_value = $wps_value1 + $wps_value2;
        $table .= '<tr bgcolor="#ffcccc"><td>Fixed Salaries</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
                  <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($wps_value, " ") . '</td></tr>';
        $total_debit += $wps_value;
        $expenses = EmiCategory::model()->findAll(array('condition' => 'type="E"'));
        foreach ($expenses as $eachExp) {
            $exp_value = 0;
            $exp_value = FinanceEmiInstallment::TotalEmi($from_date, $to_date, $eachExp->id);
            $table .= '<tr bgcolor="#ffcccc"><td>' . $eachExp->name . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($exp_value, " ") . '</td></tr>';
            $total_debit += $exp_value;
        }
        //INCOMING
        $condition2 = '(I.ledger_id=' . $pdcr_id . ') AND (I.amount>0 AND I.opening_cheque_cleared="N" AND H.is_posted = "Y" AND H.cheque_date BETWEEN "' . $from_date . '" AND "' . $to_date . '")';
        $pdc_r = Yii::app()->db->createCommand('select SUM(amount*exchange_rate) from erp_finance_voucher_head H INNER JOIN erp_finance_voucher_items I ON H.id=I.header_id where ' . $condition2)->queryScalar();
        $condition3 = '(I.ledger_id=' . $cash_id . ') AND (I.amount>0 AND H.is_posted = "Y" AND H.voucher_date <="' . $to_date . '")';
        $cash_in = Yii::app()->db->createCommand('select SUM(amount*exchange_rate) from erp_finance_voucher_head H INNER JOIN erp_finance_voucher_items I ON H.id=I.header_id where ' . $condition3)->queryScalar();
        $table .= '<tr bgcolor="#ccffeb"><td>Received Cheques</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($pdc_r, " ") . '</td>
                  <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td></tr>';
        $table .= '<tr bgcolor="#ccffeb"><td>Cash In Hand</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($cash_in, " ") . '</td>
                  <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td></tr>';
        $total_credit += $cash_in;
        $total_credit += $pdc_r;
        $income = EmiCategory::model()->findAll(array('condition' => 'type="I"'));
        foreach ($income as $eachIncome) {
            $inc_value = 0;
            $inc_value = FinanceEmiInstallment::TotalEmi($from_date, $to_date, $eachIncome->id);
            $table .= '<tr bgcolor="#ccffeb"><td>' . $eachIncome->name . '</td>
                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($inc_value, " ") . '</td>
                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td></tr>';
            $total_credit += $inc_value;
        }
        $bank = FinanceLegder::model()->findByPk($bank_id);
        $bank_subledgers = FinanceSubledger::model()->findAll(array('condition' => 'subledger_type_id IN (' . $bank->subledger_types . ')'));
        foreach ($bank_subledgers as $eachSubledger) {
            $condition4 = '';
            $condition4 = '(I.ledger_id=' . $bank_id . ' AND I.subledger_id=' . $eachSubledger->id . ') AND (I.amount>0 AND H.is_posted = "Y" AND H.voucher_date <="' . $to_date . '")';
            $bank = Yii::app()->db->createCommand('select SUM(amount*exchange_rate) from erp_finance_voucher_head H INNER JOIN erp_finance_voucher_items I ON H.id=I.header_id where ' . $condition4)->queryScalar();
            $table .= '<tr bgcolor="#ccffeb"><td>' . $eachSubledger->description . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($bank, " ") . '</td>
                    <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td></tr>';
            $total_credit += $bank;
        }

        // $parent = 1;
        // foreach ($items as $each) {

        //     $debit = ($each->amount > 0) ? round(($each->amount * $each->exchange_rate), 4) : '';
        //     $credit = ($each->amount < 0) ? round(abs($each->amount * $each->exchange_rate), 4) : '';
        //     $running = $debit - $credit + $previousBalance;
        //     $previousBalance = $running;
        //     $symbol = ($running > 0) ? 'Dr' : 'Cr';
        //     $closingBalance += ($debit - $credit);

        //     $total_debit += $debit;
        //     $total_credit += $credit;

        //     $subledgerName = ($each->subledger_id > 0) ? $each->subledger->description : '';
        //     $table .= ' <tr>
        //                   <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
        //                   <td>' . $each->parent->fullvoucher . '</td>
        //                   <td>' . $each->ledger->description . '</td>
        //                   <td>' . $subledgerName . '</td>
        //                   <td>' . date("d/m/Y", strtotime($each->parent->cheque_date)) . '</td>
        //                   <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
        //                   <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
        //                   <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($running), " ") . " " . $symbol . '</td>
        //                   <td><small>' . $each->narration . '</small></td>
        //               </tr>';
        // }
        // $condition = '(t.ledger_id=9) AND (amount<0 AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '")';
        // $items = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => $condition, 'order' => 'parent.voucher_date ASC'));
        // foreach ($items as $each) {

        //     $debit = ($each->amount > 0) ? round(($each->amount * $each->exchange_rate), 4) : '';
        //     $credit = ($each->amount < 0) ? round(abs($each->amount * $each->exchange_rate), 4) : '';
        //     $running = $debit - $credit + $previousBalance;
        //     $previousBalance = $running;
        //     $symbol = ($running > 0) ? 'Dr' : 'Cr';
        //     $closingBalance += ($debit - $credit);

        //     $total_debit += $debit;
        //     $total_credit += $credit;

        //     $subledgerName = ($each->subledger_id > 0) ? $each->subledger->description : '';
        //     $table .= ' <tr>
        //                   <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
        //                   <td>' . $each->parent->fullvoucher . '</td>
        //                   <td>' . $each->ledger->description . '</td>
        //                   <td>' . $subledgerName . '</td>
        //                   <td>-</td>
        //                   <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
        //                   <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
        //                   <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(abs($running), " ") . " " . $symbol . '</td>
        //                   <td><small>' . $each->narration . '</small></td>
        //               </tr>';
        // }
        // $symbol = ($closingBalance > 0) ? 'Dr' : 'Cr';
        // $total_debit=$pdc_i+$cash_out;
        // $total_credit=$pdc_r+$cash_in;
        $table .= '<tr>
                      <th style="text-align:right !important;"><b>Total</b></th>
                      <th style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " ") . '</b></th>
                      <th style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " ") . '</b></th>
                  </tr>';
        $table .= '<tr>
                  <th colspan="2" style="text-align:right !important;"><b>Difference</b></th>
                  <th style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_credit) - abs($total_debit), " ") . '</b></th>
              </tr>';
        $table .= '</tbody>
              </table>';
        echo $table;
    }
    public function actionCashflow_finance_report_excel()
    {
        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $condition = '(t.ledger_id=10 OR t.ledger_id=21) AND (t.opening_cheque_cleared="N" AND parent.is_posted = "Y" AND parent.cheque_date BETWEEN "' . $from_date . '" AND "' . $to_date . '")';
        $items = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => $condition, 'order' => 'parent.voucher_date ASC'));

        $table = '<table>
                      <tr>
                        <th >VO Date</th>
                        <th >VO #</th>
                        <th >Ledger</th>
                        <th >Subledger</th>
                        <th >Cheque Date</th>
                        <th >Income (' . FinanceLegder::baseCurrency() . ')</th>
                        <th >Expense (' . FinanceLegder::baseCurrency() . ')</th>
                        <th >Balance</th>
                        <th >Narration</th>
                      </tr>
                  <tbody>';
        $parent = 1;
        foreach ($items as $each) {

            $debit = ($each->amount > 0) ? round(($each->amount * $each->exchange_rate), 4) : '';
            $credit = ($each->amount < 0) ? round(abs($each->amount * $each->exchange_rate), 4) : '';
            $running = $debit - $credit + $previousBalance;
            $previousBalance = $running;
            $symbol = ($running > 0) ? 'Dr' : 'Cr';
            $closingBalance += ($debit - $credit);

            $total_debit += $debit;
            $total_credit += $credit;

            $subledgerName = ($each->subledger_id > 0) ? $each->subledger->description : '';
            $table .= ' <tr>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td>' . $each->parent->fullvoucher . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->cheque_date)) . '</td>
                          <td >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                          <td >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                          <td >' . Yii::app()->numberFormatter->formatCurrency(abs($running), " ") . " " . $symbol . '</td>
                          <td><small>' . $each->narration . '</small></td>
                      </tr>';
        }
        $symbol = ($closingBalance > 0) ? 'Dr' : 'Cr';
        $table .= '<tr>
                      <th colspan="5" style="text-align:right !important;"><b>Total</b></th>
                      <th ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " ") . '</b></th>
                      <th ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " ") . '</b></th>
                      <th >' . Yii::app()->numberFormatter->formatCurrency(abs($closingBalance), " ") . ' ' . $symbol . '</th>
                      <th></th>
                  </tr>';
        $table .= '</tbody>
              </table>';

        // header('Content-Type: application/vnd.ms-excel');  
        // header('Content-disposition: attachment; filename=cashflow.xls');  
        header("Content-type: application/octet-stream");
        header("Content-Disposition: attachment; filename=cashflow.xls");
        header("Pragma: no-cache");
        header("Expires: 0");
        echo $table;
    }
    public function actionSales_finance_report()
    {
        $this->render('sales_finance_report');
    }
    public function actionSales_finance_report_html()
    {
        Yii::app()->db->createCommand("TRUNCATE TABLE temp_sales_finance_tbl")->execute();
        $sql = "INSERT INTO temp_sales_finance_tbl select voucher_no AS v_no,voucher_date AS v_date,header_id AS head_id,SUM(subledger_id) AS subledger_id,SUM(sales) AS sales,SUM(vat) AS vat from ((SELECT voucher_no,voucher_date,header_id,subledger_id,amount*exchange_rate AS sales,0 AS vat FROM `erp_finance_voucher_items` I INNER JOIN erp_finance_voucher_head H ON H.id=I.header_id where H.voucher_type IN (7,10) AND ledger_id=11 AND is_posted='Y') UNION (SELECT voucher_no,voucher_date,header_id,0 AS subledger_id,0 AS sales,amount*exchange_rate AS vat FROM `erp_finance_voucher_items` I INNER JOIN erp_finance_voucher_head H ON H.id=I.header_id where H.voucher_type IN (7,10) AND ledger_id=23 AND is_posted='Y')) AS Summary GROUP BY header_id";
        Yii::app()->db->createCommand($sql)->execute();
        $subledger_id = $_REQUEST['subledger_id'];
        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-t');
        $condition = "1=1";
        if (!empty($subledger_id)) {
            $condition .= " AND subledger_id=$subledger_id ";
        }
        if (!empty($from_date)) {
            $condition .= " AND v_date>='$from_date'";
        }
        if (!empty($to_date)) {
            $condition .= " AND v_date<='$to_date'";
        }
        $SQL = "select F.*,S.description,I.is_hiring_invoice,T.inv_name from temp_sales_finance_tbl F INNER JOIN erp_finance_subledger S ON F.subledger_id=S.id 
    LEFT JOIN erp_invoice I ON F.v_no=I.id LEFT JOIN erp_mas_invoice_type T ON I.invoice_type=T.id where $condition";
        $sales = Yii::app()->db->createCommand($SQL)->queryAll();
        $table = '<table class="table table-hover table-fixed table-bordered">
                  <thead>
                      <tr>
                        <th style="width:10%" >VO Date</th>
                        <th style="width:5%" >VO #</th>
                        <th style="width:20%" >Customer</th>
                        <th style="width:5%" >Sale/Hire</th>
                        <th style="width:10%" >Invoice Type</th>
                        <th style="width:8%;text-align:right !important;" class="text-right">Value W/O VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        <th style="width:8%;text-align:right !important;" class="text-right">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        <th style="width:10%;text-align:right !important;" class="text-right">Value(' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                  </thead>
                  <tbody>';
        $tot_sale = 0;
        $tot_vat = 0;
        $total = 0;
        foreach ($sales as $eachItem) {
            if (($eachItem["sales"] + $eachItem["vat"]) > 0) {
                $vat = abs($eachItem["vat"]);
            } else {
                $vat = -$eachItem["vat"];
            }
            $table .= ' <tr>
                          <td>' . date("d/m/Y", strtotime($eachItem["v_date"])) . '</td>
                          <td>' . $eachItem["v_no"] . '</td>
                          <td>' . $eachItem["description"] . '</td>
                          <td>' . $eachItem["is_hiring_invoice"] . '</td>
                          <td>' . $eachItem["inv_name"] . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($eachItem["sales"] + $eachItem["vat"]), " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($eachItem["sales"], " ") . '</td>
                      </tr>';
            $tot_sale += ($eachItem["sales"] + $eachItem["vat"]);
            $tot_vat += $vat;
            $total += $eachItem["sales"];
        }
        $table .= ' <tr>
    <td colspan="5" style="text-align:right !important;"><b>Total</b></td>
    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_sale, " ") . '</b></td>
    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_vat, " ") . '</b></td>
    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</b></td>
</tr>';
        $table .= '</tbody>
    </table>';
        echo $table;
    }
    public function actionSales_finance_report_excel()
    {
        Yii::app()->db->createCommand("TRUNCATE TABLE temp_sales_finance_tbl")->execute();
        $sql = "INSERT INTO temp_sales_finance_tbl select voucher_no AS v_no,voucher_date AS v_date,header_id AS head_id,SUM(subledger_id) AS subledger_id,SUM(sales) AS sales,SUM(vat) AS vat from ((SELECT voucher_no,voucher_date,header_id,subledger_id,amount*exchange_rate AS sales,0 AS vat FROM `erp_finance_voucher_items` I INNER JOIN erp_finance_voucher_head H ON H.id=I.header_id where H.voucher_type IN (7,10) AND ledger_id=11 AND is_posted='Y') UNION (SELECT voucher_no,voucher_date,header_id,0 AS subledger_id,0 AS sales,amount*exchange_rate AS vat FROM `erp_finance_voucher_items` I INNER JOIN erp_finance_voucher_head H ON H.id=I.header_id where H.voucher_type IN (7,10) AND ledger_id=23 AND is_posted='Y')) AS Summary GROUP BY header_id";
        Yii::app()->db->createCommand($sql)->execute();
        $subledger_id = $_REQUEST['subledger_id'];
        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-t');
        $condition = "1=1";
        if (!empty($subledger_id)) {
            $condition .= " AND subledger_id=$subledger_id ";
        }
        if (!empty($from_date)) {
            $condition .= " AND v_date>='$from_date'";
        }
        if (!empty($to_date)) {
            $condition .= " AND v_date<='$to_date'";
        }
        $SQL = "select F.*,S.description,I.is_hiring_invoice,T.inv_name from temp_sales_finance_tbl F INNER JOIN erp_finance_subledger S ON F.subledger_id=S.id 
    LEFT JOIN erp_invoice I ON F.v_no=I.id LEFT JOIN erp_mas_invoice_type T ON I.invoice_type=T.id where $condition";
        $sales = Yii::app()->db->createCommand($SQL)->queryAll();
        $table = '<table class="table table-hover table-fixed table-bordered">
                  <thead>
                      <tr>
                        <th style="width:10%" >VO Date</th>
                        <th style="width:5%" >VO #</th>
                        <th style="width:20%" >Customer</th>
                        <th style="width:5%" >Sale/Hire</th>
                        <th style="width:10%" >Invoice Type</th>
                        <th style="width:8%;text-align:right !important;" class="text-right">Value W/O VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        <th style="width:8%;text-align:right !important;" class="text-right">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        <th style="width:10%;text-align:right !important;" class="text-right">Value(' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                  </thead>
                  <tbody>';
        $tot_sale = 0;
        $tot_vat = 0;
        $total = 0;
        foreach ($sales as $eachItem) {
            if (($eachItem["sales"] + $eachItem["vat"]) > 0) {
                $vat = abs($eachItem["vat"]);
            } else {
                $vat = -$eachItem["vat"];
            }
            $table .= ' <tr>
                          <td>' . date("d/m/Y", strtotime($eachItem["v_date"])) . '</td>
                          <td>' . $eachItem["v_no"] . '</td>
                          <td>' . $eachItem["description"] . '</td>
                          <td>' . $eachItem["is_hiring_invoice"] . '</td>
                          <td>' . $eachItem["inv_name"] . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($eachItem["sales"] + $eachItem["vat"]), " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($eachItem["sales"], " ") . '</td>
                      </tr>';
            $tot_sale += ($eachItem["sales"] + $eachItem["vat"]);
            $tot_vat += $vat;
            $total += $eachItem["sales"];
        }
        $table .= ' <tr>
                          <td colspan="5" style="text-align:right !important;"><b>Total</b></td>
                          <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_sale, " ") . '</b></td>
                          <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_vat, " ") . '</b></td>
                          <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</b></td>
                      </tr>';
        $table .= '</tbody>
    </table>';

        // header('Content-Type: application/vnd.ms-excel');  
        // header('Content-disposition: attachment; filename=cashflow.xls');  
        header("Content-type: application/octet-stream");
        header("Content-Disposition: attachment; filename=sales_report.xls");
        header("Pragma: no-cache");
        header("Expires: 0");
        echo $table;
    }
    public function actionPurchase_finance_report()
    {
        $this->render('purchase_finance_report');
    }
    public function actionPurchase_finance_report_html()
    {
        Yii::app()->db->createCommand("TRUNCATE TABLE temp_purchase_finance_tbl")->execute();
        $sql = "INSERT INTO temp_purchase_finance_tbl select voucher_no AS v_no,voucher_date AS v_date,header_id AS head_id,SUM(subledger_id) AS subledger_id,SUM(purchase) AS purchase,SUM(vat) AS vat from ((SELECT voucher_no,voucher_date,header_id,subledger_id,amount*exchange_rate AS purchase,0 AS vat FROM `erp_finance_voucher_items` I INNER JOIN erp_finance_voucher_head H ON H.id=I.header_id where H.voucher_type IN (8,9) AND ledger_id=20 AND is_posted='Y') UNION (SELECT voucher_no,voucher_date,header_id,0 AS subledger_id,0 AS purchase,amount*exchange_rate AS vat FROM `erp_finance_voucher_items` I INNER JOIN erp_finance_voucher_head H ON H.id=I.header_id where H.voucher_type IN (8,9) AND ledger_id=31 AND is_posted='Y')) AS Summary GROUP BY header_id";
        Yii::app()->db->createCommand($sql)->execute();
        $subledger_id = $_REQUEST['subledger_id'];
        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-t');
        $condition = "1=1";
        if (!empty($subledger_id)) {
            $condition .= " AND subledger_id=$subledger_id ";
        }
        if (!empty($from_date)) {
            $condition .= " AND v_date>='$from_date'";
        }
        if (!empty($to_date)) {
            $condition .= " AND v_date<='$to_date'";
        }
        $SQL = "select F.*,S.description,T.inv_name from temp_purchase_finance_tbl F INNER JOIN erp_finance_subledger S ON F.subledger_id=S.id 
    LEFT JOIN erp_purchasinginvoice I ON F.v_no=I.id LEFT JOIN erp_mas_invoice_type T ON I.invoice_type=T.id where $condition";
        $sales = Yii::app()->db->createCommand($SQL)->queryAll();
        $table = '<table class="table table-hover table-fixed table-bordered">
                  <thead>
                      <tr>
                        <th style="width:10%" >VO Date</th>
                        <th style="width:5%" >VO #</th>
                        <th style="width:20%" >Vendor</th>
                        <th style="width:10%" >Invoice Type</th>
                        <th style="width:8%;text-align:right !important;" class="text-right">Value W/O VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        <th style="width:8%;text-align:right !important;" class="text-right">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        <th style="width:10%;text-align:right !important;" class="text-right">Value(' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                  </thead>
                  <tbody>';
        $tot_sale = 0;
        $tot_vat = 0;
        $total = 0;
        foreach ($sales as $eachItem) {
            $purchase = (-1 * $eachItem["purchase"]);
            $vat = (-1 * $eachItem["vat"]);
            if (($purchase + $vat) > 0) {
                $vat = abs($vat);
            } else {
                $vat = -$vat;
            }
            $table .= ' <tr>
                          <td>' . date("d/m/Y", strtotime($eachItem["v_date"])) . '</td>
                          <td>' . $eachItem["v_no"] . '</td>
                          <td>' . $eachItem["description"] . '</td>
                          <td>' . $eachItem["inv_name"] . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($purchase - $vat), " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($purchase, " ") . '</td>
                      </tr>';
            $tot_purchase += ($purchase - $vat);
            $tot_vat += $vat;
            $total += $purchase;
        }
        $table .= ' <tr>
    <td colspan="4" style="text-align:right !important;"><b>Total</b></td>
    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_purchase, " ") . '</b></td>
    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_vat, " ") . '</b></td>
    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</b></td>
</tr>';
        $table .= '</tbody>
    </table>';
        echo $table;
    }
    public function actionPurchase_finance_report_excel()
    {
        Yii::app()->db->createCommand("TRUNCATE TABLE temp_purchase_finance_tbl")->execute();
        $sql = "INSERT INTO temp_purchase_finance_tbl select voucher_no AS v_no,voucher_date AS v_date,header_id AS head_id,SUM(subledger_id) AS subledger_id,SUM(purchase) AS purchase,SUM(vat) AS vat from ((SELECT voucher_no,voucher_date,header_id,subledger_id,amount*exchange_rate AS purchase,0 AS vat FROM `erp_finance_voucher_items` I INNER JOIN erp_finance_voucher_head H ON H.id=I.header_id where H.voucher_type IN (8,9) AND ledger_id=20 AND is_posted='Y') UNION (SELECT voucher_no,voucher_date,header_id,0 AS subledger_id,0 AS sales,amount*exchange_rate AS vat FROM `erp_finance_voucher_items` I INNER JOIN erp_finance_voucher_head H ON H.id=I.header_id where H.voucher_type IN (8,9) AND ledger_id=31 AND is_posted='Y')) AS Summary GROUP BY header_id";
        Yii::app()->db->createCommand($sql)->execute();
        $subledger_id = $_REQUEST['subledger_id'];
        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-t');
        $condition = "1=1";
        if (!empty($subledger_id)) {
            $condition .= " AND subledger_id=$subledger_id ";
        }
        if (!empty($from_date)) {
            $condition .= " AND v_date>='$from_date'";
        }
        if (!empty($to_date)) {
            $condition .= " AND v_date<='$to_date'";
        }
        $SQL = "select F.*,S.description,T.inv_name from temp_purchase_finance_tbl F INNER JOIN erp_finance_subledger S ON F.subledger_id=S.id 
    LEFT JOIN erp_purchasinginvoice I ON F.v_no=I.id LEFT JOIN erp_mas_invoice_type T ON I.invoice_type=T.id where $condition";
        $sales = Yii::app()->db->createCommand($SQL)->queryAll();
        $table = '<table class="table table-hover table-fixed table-bordered">
                  <thead>
                      <tr>
                        <th style="width:10%" >VO Date</th>
                        <th style="width:5%" >VO #</th>
                        <th style="width:20%" >Customer</th>
                        <th style="width:10%" >Invoice Type</th>
                        <th style="width:8%;text-align:right !important;" class="text-right">Value W/O VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        <th style="width:8%;text-align:right !important;" class="text-right">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        <th style="width:10%;text-align:right !important;" class="text-right">Value(' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                  </thead>
                  <tbody>';
        $tot_sale = 0;
        $tot_vat = 0;
        $total = 0;
        foreach ($sales as $eachItem) {
            $purchase = (-1 * $eachItem["purchase"]);
            $vat = (-1 * $eachItem["vat"]);
            if (($purchase + $vat) > 0) {
                $vat = abs($vat);
            } else {
                $vat = -$vat;
            }
            $table .= ' <tr>
                          <td>' . date("d/m/Y", strtotime($eachItem["v_date"])) . '</td>
                          <td>' . $eachItem["v_no"] . '</td>
                          <td>' . $eachItem["description"] . '</td>
                          <td>' . $eachItem["inv_name"] . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($purchase - $vat), " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($purchase, " ") . '</td>
                      </tr>';
            $tot_purchase += ($purchase - $vat);
            $tot_vat += $vat;
            $total += $purchase;
        }
        $table .= ' <tr>
                          <td colspan="4" style="text-align:right !important;"><b>Total</b></td>
                          <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_purchase, " ") . '</b></td>
                          <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_vat, " ") . '</b></td>
                          <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</b></td>
                      </tr>';
        $table .= '</tbody>
    </table>';

        // header('Content-Type: application/vnd.ms-excel');  
        // header('Content-disposition: attachment; filename=cashflow.xls');  
        header("Content-type: application/octet-stream");
        header("Content-Disposition: attachment; filename=purchase_report.xls");
        header("Pragma: no-cache");
        header("Expires: 0");
        echo $table;
    }

    public function actionPl_new_html()
    {
        $brand = (int) $_POST['brand'];
        $outlet = (int) $_POST['outlet'];
        $created_user = (int) $_POST['created_user'];
        $costcenter = (int) $_POST['costcenter'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = 'H.is_posted="Y" AND H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';

        if ($outlet > 0) {
            $condition .= ' AND I.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }

        if ((int)$created_user > 0) {
            $condition .= ' AND H.created_by=' . $created_user;
            // $conditions .= ' AND created_by=' . $created_user;
        }
        if ((int)$costcenter > 0) {
            $condition .= ' AND H.costcenter=' . $costcenter;
        }

        $time = strtotime($end_date);
        $year = date("Y", $time);
        //echo '(SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  '.$condition.'   AND ( A.main_account_type="I") group by A.id order by A.account_no)';die;
        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $condition . '   AND ( A.main_account_type="I") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (SELECT id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='I')")->execute();
        $SQL = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $income = Yii::app()->db->createCommand($SQL)->queryAll();


        //We have 5 levels
        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:50%">Accounts</th>
                            <th style="width:25%">Amount</th>
                        </tr>
                    </thead>
                <tbody>';
        $totals = array();
        //        $directIncome = FinanceLegder::model()->findAll(array('condition' => 'classification="DIRECT_INCOME"', 'order' => 'id ASC'));
        $totalDirectincome = 0;
        $totalDirectexpense = 0;
        $totalIndirectincome = 0;
        $totalIndirectexpense = 0;
        //level - 2
        $Total_Income = 0;
        $TotalDirectIncome = 0;
        foreach ($income as $eachAccount) {

            $balance = 0;
            $accountName = $eachAccount['title'];
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $table .= '<tr>
                                            <td colspan="2"><b>' . $space . $accountName . '</b></td>
                                        </tr>';
                //                            $table .= '<tr>
                //                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency((-1*$eachAccount['amount']), " ") . '</td>
                //                                        </tr>';
            } else {
                if ($eachAccount['amount'] != 0) {
                    $table .= '<tr>
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency((-1 * $eachAccount['amount']), " ") . '</td>
                                        </tr>';
                }
            }
            if ($eachAccount['id'] == 11) {
                $TotalDirectIncome += $eachAccount['amount'];
            }
            if ($eachAccount['id'] == 12) {
                $TotalDirectIncome += $eachAccount['amount'];
            }
            if ($eachAccount['id'] == 53) {
                $TotalDirectIncome += $eachAccount['amount'];
            }

            $Total_Income += -1 * ($eachAccount['amount']);
        }

        $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
        $accountName = "Goods Receipt";
        $table .= '<tr>
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(($goods_receipt), " ") . '</td>
                                        </tr>';
        $Total_Income += $goods_receipt;
        $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Total Income </b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($Total_Income), " ") . '</b></td>
                            </tr>';
        //direct expense

        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE ' . $condition . ' AND ( A.main_account_type="E") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (select id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='E')")->execute();
        $SQL1 = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $expenses = Yii::app()->db->createCommand($SQL1)->queryAll();
        $Total_Expense = 0;
        foreach ($expenses as $eachAccount) {

            $balance = 0;
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }
            if ($eachAccount['id'] == 10005) {
                $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $Total_Expense += $balance;
                $accountName = 'Cost of Sale';
                $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($balance, " ") . '</td>
                                        </tr>';
            } else if ($eachAccount['id'] == 4114) {
                $balance = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $Total_Expense += $balance;
                $accountName = 'Damage/stock clearing/expiry';
                $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($balance, " ") . '</td>
                                        </tr>';
            } else {
                $accountName = $eachAccount['title'];
                if ($eachAccount['rollup_account'] == 'Y') {
                    $table .= '<tr>
                                            <td colspan="2"><b>' . $space . $accountName . '</b></td>
                                        </tr>';
                } else {
                   // if ($eachAccount['amount'] != 0) { commented to get all ledgers
                        $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($eachAccount['amount'], " ") . '</td>
                                        </tr>';
                   // }
                }
                $Total_Expense += $eachAccount['amount'];
            }
        }
        $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Total Expense </b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($Total_Expense), " ") . '</b></td>
                            </tr>';

        $netProfit = $Total_Income - $Total_Expense;
        if ($netProfit > 0) {
            $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Profit (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " ") . '</b></td>
                            </tr>';
        } else {
            $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Loss (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " ") . '</b></td>
                            </tr>';
        }
        $table .= '</tbody>
                </table>';
        echo $table;
    }
    public function actionTb_new_html()
    {
        $brand = (int) $_POST['brand'];
        $outlet = (int) $_POST['outlet'];
        $costcenter = (int) $_POST['costcenter'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = 'H.is_posted="Y" AND H.voucher_date >= "' . $from_date . '" AND H.voucher_date <= "' . $to_date . '"';
        $bs_condition = 'H.is_posted="Y" AND H.voucher_date <= "' . $to_date . '"';
        if ($outlet > 0) {
            $condition .= ' AND I.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
            $purchase_conditions .= ' AND I.outlet=' . $outlet;
            $bs_condition .= ' AND I.outlet=' . $outlet;
        }
        if ($costcenter > 0) {
            $condition .= ' AND H.costcenter=' . $costcenter;
            $purchase_conditions .= ' AND H.costcenter=' . $costcenter;
            $bs_condition .= ' AND H.costcenter=' . $costcenter;
        }

        $time = strtotime($end_date);
        $year = date("Y", $time);
        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT I.ledger_id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $bs_condition . ' AND (A.main_account_type="A" OR A.main_account_type="L") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT I.ledger_id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $condition . ' AND (A.main_account_type="I" OR A.main_account_type="E")  group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}})')->execute();
        $SQL = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $income = Yii::app()->db->createCommand($SQL)->queryAll();

        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:50%">Accounts</th>
                            <th style="width:25%">debit</th>
                            <th style="width:25%">credit</th>
                        </tr>
                    </thead>
                <tbody>';
        $totals = array();
        $total_debit = 0;
        $total_credit = 0;
        $Total_Income = 0;
        foreach ($income as $eachAccount) {
            $balance = 0;
            $debit = 0;
            $credit = 0;
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }

            $accountName = $eachAccount['title'];
            if ($eachAccount['amount'] > 0) {
                $debit = $eachAccount['amount'];
                $total_debit += $debit;
            } else {
                $credit = -1 * $eachAccount['amount'];
                $total_credit += $credit;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $acc_id = $eachAccount['id'];
                $table .= '<tr><td colspan="3"><b>' . $space . $accountName . '</b><a onclick="loadPopupModal(\'finance/reports/parentaccountlist&id=' . $acc_id . '&from_date=' . $from_date . '&to_date=' . $to_date . '&outlet=' . $outlet . '&costcenter=' . $costcenter . '\',\'Parent Accounts Total\',\'ls\')"><i class="fa fa-plus"></i></a></td></tr>';
            } else {
                if ($eachAccount['id'] == 10005) {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $Total_Expense += $balance;
                    $accountName = 'Cost of Sale';

                    if ($balance > 0) {
                        $debit = abs($balance);
                        $credit = 0;
                        //                        $total_debit+=abs($balance);   
                    } else {
                        $credit = abs($balance);
                        $debit = 0;
                        //                        $total_credit+=abs($balance);   
                    }
                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                } else if ($eachAccount['id'] == 4114) {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $Total_Expense += $balance;
                    $accountName = 'Damage/stock clearing/expiry';

                    if ($balance > 0) {
                        $debit = abs($balance);
                        $credit = 0;
                        //                        $total_debit+=abs($balance);   
                    } else {
                        $credit = abs($balance);
                        $debit = 0;
                        //                        $total_credit+=abs($balance);   
                    }
                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                } else if ($eachAccount['id'] == 10020) {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS stock 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $goods_issue = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $Total_Income += - ($balance + $goods_issue);
                    $accountName = 'Current Stock';

                    $purchase = Yii::app()->db->createCommand('SELECT SUM(amount) AS purchase 
                FROM erp_finance_voucher_items AS I INNER JOIN erp_finance_voucher_head AS H ON I.header_id=H.id WHERE ledger_id=10005 AND voucher_date <= "' . $to_date . '"  ' . $purchase_conditions)->queryScalar();
                    $Total_Income += ($purchase + $goods_receipt);

                    //                        $table .= '<tr>
                    //                                            <td>' . $space.$accountName . '</td>
                    //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(($purchase+$goods_receipt-$balance-$goods_issue), " ") . '</td>
                    //                                        </tr>';
                    $current_stock = ($purchase + $goods_receipt - $balance - $goods_issue);
                    if ($current_stock > 0) {
                        $debit = abs($current_stock);
                        $credit = 0;
                        //                        $total_debit+=abs($current_stock);   
                    } else {
                        $credit = abs($current_stock);
                        $debit = 0;
                        //                        $total_credit+=abs($current_stock);   
                    }
                    $total_debit += abs($current_stock);
                    $total_credit += abs($current_stock);
                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                    $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $accountName = "Goods Receipt";
                    if ($goods_receipt > 0) {
                        $debit = abs($goods_receipt);
                        $credit = 0;
                        //                        $total_debit+=abs($goods_receipt);   
                    } else {
                        $credit = abs($goods_receipt);
                        $debit = 0;
                        //                        $total_credit+=abs($goods_receipt);   
                    }

                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                } else {
                  //  if ($debit != 0 || $credit != 0) { commented to ge all ledgers
                        $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                  //  }
                }
            }
        }

        $pl_condition = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date <= "' . $to_date . '"';

        $pl_income_balance = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="I")')->queryScalar();
        $pl_expense_balance = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="E")')->queryScalar();
        $pl_pre_balance = (float)$pl_income_balance + (float)$pl_expense_balance;

        $pl_condition_old = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date < "' . $from_date . '"';
        $pl_income_balance_old = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition_old . ' AND (A.main_account_type="I")')->queryScalar();
        $pl_expense_balance_old = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition_old . ' AND (A.main_account_type="E")')->queryScalar();
        $goods_receipt_opening_old = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();
        $cost_of_sale_old = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();
        $goods_issue_damage_old = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();

        $profit_and_loss_old = $pl_income_balance_old - $goods_receipt_opening_old + $pl_expense_balance_old + $cost_of_sale_old + $goods_issue_damage_old;

        $accountName = 'Accumulated P&L';

        if ($pl_pre_balance > 0) {
            $total_debit += abs($pl_pre_balance);
        } else {
            $total_credit += abs($pl_pre_balance);
        }

        if ($profit_and_loss_old > 0) {
            //        $table .= '<tr>
            //                                            <td>' . $space. $accountName . '</td>
            //                                            <td style="text-align:right !important;" >'.$pl_income_balance_old.'/'.$goods_receipt_opening_old.'/'.$pl_expense_balance_old.'/'.$cost_of_sale_old.'/'.$goods_issue_damage_old.Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
            //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(abs($profit_and_loss_old), " ") . '</td>
            //                                        </tr>';   
        } else {
            //        $table .= '<tr>
            //                                            <td>' . $space. $accountName . '</td>
            //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(abs($profit_and_loss_old), " ") . '</td>
            //                                            <td style="text-align:right !important;" >'.$pl_income_balance_old.'/'.$goods_receipt_opening_old.'/'.$pl_expense_balance_old.'/'.$cost_of_sale_old.'/'.$goods_issue_damage_old. Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
            //                                        </tr>';    
        }
        $pl_condition = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date >= "' . $from_date . '" AND H.voucher_date <= "' . $to_date . '"';

        $pl_income_balance1 = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="I")')->queryScalar();
        $pl_expense_balance1 = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="E")')->queryScalar();
        $pl_balance = $pl_expense_balance1 + $pl_income_balance1;

        $goods_receipt_opening = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
        $cost_of_sale = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
        $goods_issue_damage = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();

        $profit_and_loss = $pl_income_balance1 - $goods_receipt_opening - $pl_expense_balance1 + $cost_of_sale + $goods_issue_damage;
        $accountName = 'Current P&L';
        if ($profit_and_loss > 0) {
            //        $table .= '<tr>
            //                                            <td>' . $space. $accountName . '</td>
            //                                            <td style="text-align:right !important;" >'.$pl_balance.'/'.$pl_income_balance1.'/'.$goods_receipt_opening.'/'.$pl_expense_balance1.'/'.$cost_of_sale.'/'.$goods_issue_damage.Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
            //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(abs($profit_and_loss), " ") . '</td>
            //                                        </tr>';    
        } else {
            //        $table .= '<tr>
            //                                            <td>' . $space. $accountName . '</td>
            //                                            <td style="text-align:right !important;" >'.Yii::app()->numberFormatter->formatCurrency(abs($profit_and_loss), " ") . '</td>
            //                                            <td style="text-align:right !important;" >'.$pl_balance.'/'.$pl_income_balance1.'/'.$goods_receipt_opening.'/'.$pl_expense_balance1.'/'.$cost_of_sale.'/'.$goods_issue_damage.Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
            //                                        </tr>';   
        }

        if ($pl_balance > 0) {
            $total_credit += abs($pl_balance);
        } else {
            $total_debit += abs($pl_balance);
        }

        $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Total  </b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " ") . '</b></td>
                                    <td style="color:#1F67B2;text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " ") . '</b></td>
                            </tr>';

        $table .= '</tbody>
                </table>';
        echo $table;
    }
    public function actionBs_new_html()
    {
        $brand = (int) $_POST['brand'];
        $outlet = (int) $_POST['outlet'];
        $costcenter = (int) $_POST['costcenter'];
        //        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $from_date = '2019-01-01';
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = 'H.is_posted="Y" AND H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';

        if ($outlet > 0) {
            $condition .= ' AND I.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
            $purchase_conditions .= ' AND I.outlet=' . $outlet;
        }
        if ($costcenter > 0) {
            $condition .= ' AND H.costcenter=' . $costcenter;
            $purchase_conditions .= ' AND H.costcenter=' . $costcenter;
        }

        $time = strtotime($end_date);
        $year = date("Y", $time);
        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $condition . '   AND ( A.main_account_type="A") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (select id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='A')")->execute();
        $SQL = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $income = Yii::app()->db->createCommand($SQL)->queryAll();


        //We have 5 levels
        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:50%">Accounts</th>
                            <th style="width:25%">Amount</th>
                        </tr>
                    </thead>
                <tbody>';
        $totals = array();
        //        $directIncome = FinanceLegder::model()->findAll(array('condition' => 'classification="DIRECT_INCOME"', 'order' => 'id ASC'));
        $totalDirectincome = 0;
        $totalDirectexpense = 0;
        $totalIndirectincome = 0;
        $totalIndirectexpense = 0;
        //level - 2
        $Total_Income = 0;
        foreach ($income as $eachAccount) {
            $balance = 0;
            $accountName = $eachAccount['title'];
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $table .= '<tr>
                                            <td colspan="2"><b>' . $space . $accountName . '</b></td>
                                        </tr>';
            } else {
                if ($eachAccount['amount'] != 0) {
                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(($eachAccount['amount']), " ") . '</td>
                                        </tr>';
                }
            }
            $Total_Income += ($eachAccount['amount']);
            if ($eachAccount['id'] == 10020) {
                $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS stock 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $goods_issue = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $Total_Income += - ($balance + $goods_issue);
                $accountName = 'Current Stock';

                $purchase = Yii::app()->db->createCommand('SELECT SUM(amount) AS purchase 
                FROM erp_finance_voucher_items AS I INNER JOIN erp_finance_voucher_head AS H ON I.header_id=H.id WHERE ledger_id=10005 AND voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $purchase_conditions)->queryScalar();
                $Total_Income += ($purchase + $goods_receipt);

                $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(($purchase + $goods_receipt - $balance - $goods_issue), " ") . '</td>
                                        </tr>';
                //               $accountName='Goods Receipt';
                //                      $table .= '<tr>
                //                                            <td>' . $space.$accountName . '</td>
                //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($goods_receipt, " ") . '</td>
                //                                        </tr>';
            }
        }
        $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Total Asset </b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($Total_Income), " ") . '</b></td>
                            </tr>';
        //direct expense

        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE ' . $condition . ' AND ( A.main_account_type="L") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (select id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='L')")->execute();
        $SQL1 = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $expenses = Yii::app()->db->createCommand($SQL1)->queryAll();
        $Total_Expense = 0;
        foreach ($expenses as $eachAccount) {
            $balance = 0;
            $accountName = $eachAccount['title'];
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $table .= '<tr>
                                            <td colspan="2"><b>' . $space . $accountName . '</b></td>
                                        </tr>';
            } else {
              //  if ($eachAccount['amount'] != 0) { commented to get all ledgers
                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(-1 * ($eachAccount['amount']), " ") . '</td>
                                        </tr>';
               // }
            }
            $Total_Expense += (-1 * $eachAccount['amount']);
        }

        $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Total Liability </b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($Total_Expense), " ") . '</b></td>
                            </tr>';

        $netProfit = $Total_Income - $Total_Expense;
        if ($netProfit > 0) {
            $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Profit (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " ") . '</b></td>
                            </tr>';
        } else {
            $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Loss (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " ") . '</b></td>
                            </tr>';
        }
        $table .= '</tbody>
                </table>';
        echo $table;
    }
    public function actionCost_report()
    {
        $this->render('cost_report');
    }
    public function actionCost_html()
    {
        $this->render('html/cost_sales_item', $_POST, false, true);
    }

    public function actionCost_pdf()
    {
        $outlet = (int) $_REQUEST['outlet'];
        $from_date = (count(explode('/', $_REQUEST['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to_date']))) : date('Y-m-d');
        $condition = ' where H.active="Y" AND H.invoice_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        if ($outlet > 0) {
            $condition .= ' AND H.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        $SQL = ' Select H.invoice_no,C.customer_name,I.description,I.net_amount,I.quantity,H.invoice_date,I.product_id,I.tax_amount,H.id AS invoice_id,I.id AS item_id from erp_sales_invoice H INNER JOIN erp_sales_invoice_items I ON H.id=I.invoice_id INNER JOIN erp_customer C ON H.customer_id=C.id ' . $condition . ' order by H.id';

        $all = Yii::app()->db->createCommand($SQL)->queryAll();
        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:10%">Date</th>
                            <th style="width:10%">Invoice No</th>
                            <th style="width:25%">Customer</th>
                            <th style="width:25%">Part No.</th>
                            <th style="width:5%">Net Total</th>
                            <th style="width:5%">Tax</th>
                            <th style="width:5%">Qty</th>
                            <th style="width:5%">Cost</th>
                            <th style="width:5%">Total Cost</th>
                            <th style="width:5%">Profit</th>
                            <th style="width:5%">Profit(%)</th>
                        </tr>
                    </thead>
                <tbody>';
        $total_cost = 0;
        $total_profit = 0;
        $total_sales = 0;
        $total_tax = 0;
        foreach ($all as $each) {
            $qty = Yii::app()->db->createCommand('SELECT quantity*unit_exchange_rate AS qty from erp_stock_ledger where  type="SI" AND header_id=' . $each["invoice_id"] . ' AND item_id=' . $each["item_id"] . ' AND product_id=' . $each["product_id"] . ' AND transaction_date <= "' . $each['invoice_date'] . '" ' . $conditions)->queryScalar();
            $qty = round($qty, 2);
            $current_in_rate = Yii::app()->db->createCommand('SELECT CASE
        WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
        FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND product_id=' . $each["product_id"] . ' AND transaction_date <= "' . $each['invoice_date'] . '" ' . $conditions)->queryScalar();
            $profit = $each['net_amount'] - $each['tax_amount'] - ($qty * $current_in_rate);
            $cost = ($qty * $current_in_rate);
            if ($cost > 0) {
                $profit_percent = $profit / ($cost) * 100;
            }
            $table .= '<tr><td>' . date("d-m-Y", strtotime($each['invoice_date'])) . '</td><td>' . $each['invoice_no'] . '</td><td>' . $each['customer_name'] . '</td><td>' . $each["product_id"] . '/' . $each['description'] . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['net_amount'], "") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($each['tax_amount'], "") . '</td><td>' . $qty . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($current_in_rate, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($qty * $current_in_rate, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($profit, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($profit_percent, " ") . '%</td></tr>';
            $total_cost += $qty * $current_in_rate;
            $total_profit += $profit;
            $total_sales += $each['net_amount'];
            $total_tax += $each['tax_amount'];
        }
        $percent = ($total_sales - $total_cost) / $total_cost * 100;
        $table .= '<tr><td colspan="4" align="right"><b>Total</b></td><td style="text-align:right !important;" align="right"><b>' . Yii::app()->numberFormatter->formatCurrency($total_sales, " ") . '</b></td><td align="right" style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_tax, " ") . '</b></td><td></td><td></td><td style="text-align:right !important;" align="right"><b>' . Yii::app()->numberFormatter->formatCurrency($total_cost, " ") . '</b></td><td style="text-align:right !important;" align="right"><b>' . Yii::app()->numberFormatter->formatCurrency($total_profit, " ") . '</b></td><td style="text-align:right !important;" align="right"><b>' . Yii::app()->numberFormatter->formatCurrency($percent, " ") . '%</b></td></tr>';
        $table .= '</tbody>
                </table>';

        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf_cost_report', array('from_date' => $from_date, 'to_date' => $to_date, 'outlet' => $outlet, 'table' => $table), true));

        $mpdf->Output("Cost_report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionCost_group_html()
    {
        $outlet = (int) $_POST['outlet'];
        if ($outlet > 0) {
            $condition .= ' AND H.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }

        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $begin = new DateTime($from_date);
        $end = new DateTime($to_date);
        $daterange = new DatePeriod($begin, new DateInterval('P1D'), $end);
        //Yii::app()->db->createCommand("TRUNCATE TABLE temp_cost_stock_tbl")->execute();
        foreach ($daterange as $date) {
            $inv = Inventory::model()->findAll(array('select' => 'id', 'condition' => 'outlet=' . $outlet));
            foreach ($inv as $each) {
                // $current_in_rate=Yii::app()->db->createCommand('SELECT SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) AS avg_purchase_rate 
                // FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "MTM" AND type!= "GT" AND product_id='.$each["id"].' AND transaction_date <= "' . $date->format("Y-m-d") . '" '.$conditions)->queryScalar();
                $current_in_rate = StockLedger::getAvgPurchaseRate($each['id'], $date->format("Y-m-d"), $outlet);
                $in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty 
                 FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "MTM" AND type!= "GT" AND transaction_date = "' . $date->format("Y-m-d") . '" ' . $conditions . ' AND product_id=' . $each["id"])->queryScalar();
                $out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type!= "MTM" AND type!= "GT" AND type!= "GI" AND transaction_date = "' . $date->format("Y-m-d") . '" ' . $conditions . ' AND product_id=' . $each["id"])->queryScalar();
                $sales_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type= "SI" AND transaction_date = "' . $date->format("Y-m-d") . '" ' . $conditions . ' AND product_id=' . $each["id"])->queryScalar();
                $sales_return_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS in_qty FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type= "SR" AND transaction_date = "' . $date->format("Y-m-d") . '" ' . $conditions . ' AND product_id=' . $each["id"])->queryScalar();
                $goods_issue_out = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "OUT" AND type= "GI" AND transaction_date = "' . $date->format("Y-m-d") . '" ' . $conditions . ' AND product_id=' . $each["id"])->queryScalar();
                $goods_receipt_in = Yii::app()->db->createCommand('SELECT SUM(quantity*unit_exchange_rate) AS out_qty FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type= "GR" AND transaction_date = "' . $date->format("Y-m-d") . '" ' . $conditions . ' AND product_id=' . $each["id"])->queryScalar();
                $stock = ($in - $out) * $current_in_rate;
                $cost = ($sales_out) * $current_in_rate;
                $goods_issue_cost = ($goods_issue_out) * $current_in_rate;
                $goods_receipt_cost = ($goods_receipt_in) * $current_in_rate;
                $sales_return_cost = ($sales_return_in) * $current_in_rate;
                $SQL = "INSERT INTO `temp_cost_stock_tbl` (`date`, `product_id`, `cost`, `stock`, `outlet`,`goods_issue`,`sales_return`,`goods_receipt`,`cost_per_item`,`out_qty`) VALUES ('" . $date->format("Y-m-d") . "', '" . $each->id . "', '" . $cost . "', '" . $stock . "', '" . $outlet . "', '" . $goods_issue_cost . "', '" . $sales_return_cost . "', '" . $goods_receipt_cost . "', '" . $current_in_rate . "', '" . $sales_out . "')";
                Yii::app()->db->createCommand($SQL)->execute();
            }
        }
    }
   
    public function actionUpdateMaterialConversionCost()
    {
        $materialtransfer = MaterialConversion::model()->findAll();
        foreach ($materialtransfer as $eachMaterial) {
            $from = $eachMaterial->from_product_id;
            $outlet = $eachMaterial->outlet;
            $date = $eachMaterial['conversion_date'];
            //echo $from.'/'.$date.'/'.$outlet;
            $from_cost = StockLedger::getAvgPurchaseRate($from, $date, $outlet);
            $to = $eachMaterial->to_product_id;
            //echo 'update erp_stock_ledger SET rate='.$from_cost.' where transaction_date="'.$date.'" AND type="MTM" AND transaction_type="IN" AND header_id='.$eachMaterial->id.' AND product_id='.$to;die;
            Yii::app()->db->createCommand('update erp_stock_ledger SET rate=' . $from_cost . ' where transaction_date="' . $date . '" AND type="MTM" AND transaction_type="IN" AND header_id=' . $eachMaterial->id . ' AND product_id=' . $to)->execute();
        }
    }
    public function actionUserCashReport()
    {
        $this->render('user_cash_report');
    }
    public function actionCash_Gl_html()
    {
        $ledgerItems = array();

        $ledger_id = (int) $_POST['ledger_id'];
        $subledger = (int) $_POST['subledger_id'];
        $brand = (int) $_POST['brand'];
        //        $currency = (int) $_POST['currency'];
        $currency = 1;
        $outlet = (int) $_POST['outlet'];
        $created_by = (int) $_POST['created_user'];
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;

        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-t');

        $condition = 'parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        $condition_for_opening = 'H.is_posted = "Y" AND H.voucher_date < "' . $from_date . '"';

        if ($ledger_id > 0) {
            $condition .= ' AND t.ledger_id IN(' . $ledger_id . ')';
            $condition_for_opening .= ' AND I.ledger_id IN(' . $ledger_id . ')';
        }

        if ($subledger > 0) {
            $condition .= ' AND t.subledger_id=' . $subledger;
            $condition_for_opening .= ' AND I.subledger_id=' . $subledger;
        }

        if ($brand > 0) {
            $condition .= ' AND t.brand_id=' . $brand;
            $condition_for_opening .= ' AND I.subledger_id=' . $brand;
        }

        if ($outlet > 0) {
            $condition .= ' AND t.outlet=' . $outlet;
            $condition_for_opening .= ' AND I.outlet=' . $outlet;
        }

        if ($created_by > 0) {
            $condition .= ' AND parent.created_by=' . $created_by;
            $condition_for_opening .= ' AND H.created_by=' . $created_by;
        }

        function generateUrl($childModel)
        {
            $url = '#';
            $code = $childModel->parent->vtype->code;
            if ($code == 'SI') {
                $headModel = $childModel->parent->vtype->header_table;
                $vat_field = $childModel->parent->vtype->vat_value;
                $inv = $headModel::model()->findBypk($childModel->parent->header_table_id);
                $tax = $inv->$vat_field;
                $taxType = ($tax > 0) ? 'tax' : 'taxnil';
                $url = "window.open($('#liveSite').val()+'index.php?r=invoice/PrintInvoiceReportPDF&id=" . $childModel->parent->header_table_id . "&frm=" . $taxType . "&type=1', '_blank');";
            } else if ($code == 'PI') {
                $url = "window.open($('#liveSite').val()+'index.php?r=purchaseinvoice/PrintInvoiceReportPDF&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'DN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=debitnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else if ($code == 'CN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=creditnote/printfile&id=" . $childModel->parent->header_table_id . "', '_blank');";
            } else {
                $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $childModel->header_id . "', '_blank');";
            }
            return $url;
        }

        $openingBalance1 = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE I.currency_id=' . $currency . ' AND ' . $condition_for_opening . ' ')->queryScalar();
        $openingBalance2 = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE I.currency_id!=' . $currency . ' AND ' . $condition_for_opening . ' ')->queryScalar();
        $items = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => $condition, 'order' => 'parent.voucher_date ASC'));
        $openingBalance = $openingBalance1 + ($openingBalance2 / $exchange_rate);
        $previousBalance = $openingBalance;
        $closingBalance = $openingBalance;
        $symbol = ($previousBalance > 0) ? 'Dr' : 'Cr';

        $total_debit = 0;
        $total_credit = 0;

        $table = '<table class="table table-hover table-fixed table-bordered" id="gl_table">
                  <thead>
                      <tr>
                        <th style="width:7%" >Date</th>
                        <th style="width:5%" >VO #</th>
                        <th style="width:10%" >Ledger</th>
                        <th style="width:20%" >Subledger</th>
                        <th style="width:12%;text-align:right !important;" class="text-right">Debit</th>
                        <th style="width:12%;text-align:right !important;" class="text-right">Credit</th>
                        <th style="width:12%;text-align:right !important;" class="text-right">Balance</th>
                        <th style="width:40%">Narration</th>
                      </tr>
                  </thead>
                  <tbody>
                  <tr>
                      <td colspan="4" class="text-right" style="text-align:right !important;"><b>Opening Balance</b></td>
                      <td style="text-align:right !important;">' . $currency_code . Yii::app()->numberFormatter->formatCurrency((($previousBalance > 0) ? abs($previousBalance) : ''), " ") . '</td>
                      <td style="text-align:right !important;">' . $currency_code . Yii::app()->numberFormatter->formatCurrency((($previousBalance < 0) ? abs($previousBalance) : ''), " ") . '</td>
                      <td style="text-align:right !important;">' . $currency_code . Yii::app()->numberFormatter->formatCurrency(abs($previousBalance), " ") . ' ' . $symbol . '</td>
                      <td></td>
                  </tr>';
        $parent = 1;
        foreach ($items as $each) {

            $debit = ($each->amount > 0) ? round(($each->amount * $each->exchange_rate), 4) : '';
            $credit = ($each->amount < 0) ? round(abs($each->amount * $each->exchange_rate), 4) : '';

            $debit = ($currency == $each->currency_id) ? $debit / $each->exchange_rate : $debit / $exchange_rate;
            $credit = ($currency == $each->currency_id) ? $credit / $each->exchange_rate : $credit / $exchange_rate;

            $running = $debit - $credit + $previousBalance;
            $previousBalance = $running;
            $symbol = ($running > 0) ? 'Dr' : 'Cr';
            $closingBalance += ($debit - $credit);

            $total_debit += $debit;
            $total_credit += $credit;

            $subledgerName = ($each->subledger_id > 0) ? $each->subledger->description : '';
            $vouchreformat = '<a href="#" onclick="' . generateUrl($each) . '">' . $each->parent->fullvoucher . '</a>';
            $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td style="text-align:right !important;">' . $currency_code . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                          <td style="text-align:right !important;">' . $currency_code . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                          <td style="text-align:right !important;">' . $currency_code . Yii::app()->numberFormatter->formatCurrency(abs($running), " ") . " " . $symbol . '</td>
                          <td><small>' . $each->narration . '</small></td>
                      </tr>';
            $parent = $child;
        }
        $running = $debit - $credit + $previousBalance;
        $symbol = ($closingBalance > 0) ? 'Dr' : 'Cr';
        $table .= '<tr>
                      <td colspan="4" style="text-align:right !important;"><b>Total</b></td>
                      <td style="text-align:right !important;"><b>' . $currency_code . Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " ") . '</b></td>
                      <td style="text-align:right !important;"><b>' . $currency_code . Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " ") . '</b></td>
                      <td style="text-align:right !important;"><b>' . $currency_code . Yii::app()->numberFormatter->formatCurrency(abs($running), " ") . '</b></td>
                      <td></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="4" style="text-align:right !important;"><b>Closing Balance</b></td>
                      <td colspan="3" style="text-align:right !important;"><b>' . $currency_code . Yii::app()->numberFormatter->formatCurrency(abs($closingBalance), " ") . ' ' . $symbol . '</b></td>
                      <td></td>
                  </tr>';
        $table .= '</tbody>
              </table>';
        echo $table;
    }
    public function actionCash_GL_pdf()
    {

        $from_date = Yii::app()->request->getParam('from_date');
        $to_date = Yii::app()->request->getParam('to_date');
        $ledger = Yii::app()->request->getParam('ledger');
        $subledger = (int) Yii::app()->request->getParam('subledger');
        $brand = (int) Yii::app()->request->getParam('brand');
        //        $currency = (int) Yii::app()->request->getParam('currency');
        $currency = 1;
        $outlet = (int) Yii::app()->request->getParam('outlet');
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;
        $created_by = (int) Yii::app()->request->getParam('created_user');
        $param = array(
            'from_date' => $from_date,
            'to_date' => $to_date,
            'ledger' => $ledger,
            'subledger' => $subledger,
            'currency_code' => $currency_code,
            'exchange_rate' => $exchange_rate,
            'currency' => $currency,
            'outlet' => $outlet,
            'created_by' => $created_by
        );

        $mode = 'A4-L';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'cash_pdf_gl_report';
        $mpdf->WriteHTML($this->renderPartial($view, $param, true));
        $mpdf->Output("CashGLReport" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionCash_GL_excel()
    {

        Yii::import('ext.PHPExcel.PHPExcel');

        $ledger = $_GET['ledger'];
        $subledger = (int) $_GET['subledger'];
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_GET['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['to_date']))) : date('Y-m-t');
        //        $currency = (int) $_GET['currency'];
        $currency = 1;
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;
        $created_by = (int) Yii::app()->request->getParam('created_user');
        $condition = 'parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        $condition_for_opening = 'H.is_posted = "Y" AND H.voucher_date < "' . $from_date . '"';
        $title = '';
        if ($ledger > 0) {
            $condition .= ' AND t.ledger_id IN(' . $ledger . ')';
            $condition_for_opening .= ' AND I.ledger_id IN(' . $ledger . ')';
            $ledger_details = FinanceLegder::model()->findByPk($ledger);
            $title = $ledger_details->description;
        }
        if ($subledger > 0) {
            $condition .= ' AND t.subledger_id=' . $subledger;
            $condition_for_opening .= ' AND I.subledger_id=' . $subledger;
            $subledger_details = FinanceSubledger::model()->findByPk($subledger);
            $title = $subledger_details->description;
        }
        $brand = (int) $_GET['brand'];
        if ($brand > 0) {
            $condition .= ' AND t.brand_id=' . $brand;
            $condition_for_opening .= ' AND I.subledger_id=' . $brand;
        }

        $outlet = (int) $_GET['outlet'];
        if ($outlet > 0) {
            $condition .= ' AND t.outlet=' . $outlet;
            $condition_for_opening .= ' AND I.outlet=' . $outlet;
        }

        if ($created_by > 0) {
            $condition .= ' AND parent.created_by=' . $created_by;
            $condition_for_opening .= ' AND H.created_by=' . $created_by;
        }

        $openingBalance1 = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE I.currency_id=' . $currency . ' AND ' . $condition_for_opening . ' ')->queryScalar();
        $openingBalance2 = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE I.currency_id!=' . $currency . ' AND ' . $condition_for_opening . ' ')->queryScalar();
        $items = FinanceVoucherItems::model()->with('parent')->findAll(array('condition' => $condition, 'order' => 'parent.voucher_date ASC'));
        $openingBalance = $openingBalance1 + ($openingBalance2 / $exchange_rate);

        $previousBalance = $openingBalance;
        $closingBalance = $openingBalance;
        $symbol = ($previousBalance > 0) ? 'Dr' : 'Cr';

        $total_debit = 0;
        $total_credit = 0;

        // Create new PHPExcel object
        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(6)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(7)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("General Transaction Ledger Report")
            ->setSubject("General Transaction Ledger Report")
            ->setDescription("General Transaction Ledger Report Generated on " . date('d/m/Y'))
            ->setKeywords("General Transaction Ledger Report")
            ->setCategory("Financial Report");

        // Add some data
        $settings = MasCompany::model()->findByPk(Yii::app()->user->company_id);
        $excel->getActiveSheet()->getStyle('A1:G1')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A1:G1');
        $excel->getActiveSheet(0)
            ->setCellValue('A1', $settings->name);

        // $excel->getActiveSheet()->getStyle('A2:H2')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A2:G2');
        $excel->getActiveSheet(0)
            ->setCellValue('A2', $settings->billing_address);

        // $excel->getActiveSheet()->getStyle('A3:H3')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A3:G3');
        $excel->getActiveSheet(0)
            ->setCellValue('A3', '');

        $excel->setActiveSheetIndex(0)->mergeCells('A4:G4');

        // $excel->getActiveSheet()->getStyle('A4:H4')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A5:G5');
        $excel->getActiveSheet(0)
            ->setCellValue('A5', 'TRN : ' . $settings->trn_no);

        $excel->getActiveSheet()->getStyle('A6:G6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A6:G6');
        $excel->getActiveSheet(0)
            ->setCellValue('A6', $title);

        $date_title = date("d-m-Y", strtotime($from_date)) . ' TO ' . date("d-m-Y", strtotime($to_date));
        // $excel->getActiveSheet()->getStyle('A6:H6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A7:G7');
        $excel->getActiveSheet(0)
            ->setCellValue('A7', $date_title);
        $excel->setActiveSheetIndex(0)->mergeCells('A8:G8');
        $currency1 = 'Currency : ' . $currency_code;
        $excel->getActiveSheet(0)
            ->setCellValue('A8', $currency1);
        $excel->setActiveSheetIndex(0)->mergeCells('A9:G9');

        $excel->getActiveSheet(0)
            ->setCellValue('A10', 'Date')
            ->setCellValue('B10', 'Voucher')
            ->setCellValue('C10', 'Particular')
            ->setCellValue('D10', 'Debit')
            ->setCellValue('E10', 'Credit')
            ->setCellValue('F10', 'Balance')
            ->setCellValue('G10', 'Narration');

        //Opening Balance
        $excel->setActiveSheetIndex(0)
            ->setCellValue('C11', 'Opening Balance');

        if ($openingBalance > 0) {
            $excel->setActiveSheetIndex(0)
                ->setCellValue('D11', Yii::app()->numberFormatter->formatCurrency(abs($openingBalance), " "));
        } else {
            $excel->setActiveSheetIndex(0)
                ->setCellValue('E11', Yii::app()->numberFormatter->formatCurrency(abs($openingBalance), " "));
        }
        //Data Items
        $total_debit += $previousBalance > 0 ? abs($previousBalance) : '';
        $total_credit += $previousBalance < 0 ? abs($previousBalance) : '';
        $parent = 12;
        foreach ($items as $each) {

            $debit = ($each->amount > 0) ? round(($each->amount * $each->exchange_rate), 4) : '';
            $credit = ($each->amount < 0) ? round(abs($each->amount * $each->exchange_rate), 4) : '';

            $debit = ($currency == $each->currency_id) ? $debit / $each->exchange_rate : $debit / $exchange_rate;
            $credit = ($currency == $each->currency_id) ? $credit / $each->exchange_rate : $credit / $exchange_rate;

            $running = $debit - $credit + $previousBalance;
            $previousBalance = $running;
            $symbol = ($running > 0) ? 'Dr' : 'Cr';
            $closingBalance += ($debit - $credit);

            $total_debit += $debit;
            $total_credit += $credit;

            $subledgerName = ($each->subledger_id > 0) ? $each->subledger->description : '';
            $particular = '';
            if ($each->amount > 0) {
                $itemparticular = FinanceVoucherItems::model()->find(array('condition' => 'amount<0 AND header_id=' . $each->header_id, 'order' => 'amount ASC'));
                $particular = ($itemparticular->subledger_id > 0) ? $itemparticular->subledger->description : $itemparticular->ledger->description;
            } else if ($each->amount < 0) {
                $itemparticular = FinanceVoucherItems::model()->find(array('condition' => 'amount>0 AND header_id=' . $each->header_id, 'order' => 'amount DESC'));
                $particular = ($itemparticular->subledger_id > 0) ? $itemparticular->subledger->description : $itemparticular->ledger->description;
            }
            $excel->getActiveSheet()->getStyle('A1:G1')->getFont()->setBold(true)->setSize(12);
            $excel->setActiveSheetIndex(0)
                ->setCellValue('A' . $parent, date("d/m/Y", strtotime($each->parent->voucher_date)))
                ->setCellValue('B' . $parent, $each->parent->fullvoucher)
                ->setCellValue('C' . $parent, $particular)
                ->setCellValue('D' . $parent,  Yii::app()->numberFormatter->formatCurrency($debit, " "))
                ->setCellValue('E' . $parent,  Yii::app()->numberFormatter->formatCurrency($credit, " "))
                ->setCellValue('F' . $parent,  Yii::app()->numberFormatter->formatCurrency(abs($running), " ") . " " . $symbol)
                ->setCellValue('G' . $parent, $each->narration);
            $parent++;
        }
        $symbol = ($closingBalance > 0) ? 'Dr' : 'Cr';
        $excel->getActiveSheet()->getStyle('A' . $parent . ':G' . $parent)->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $parent, 'Total')
            ->setCellValue('D' . $parent, Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " "))
            ->setCellValue('E' . $parent, Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $parent . ':C' . $parent);
        $excel->getActiveSheet()
            ->getStyle('D2:D' . $parent)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()
            ->getStyle('E2:E' . $parent)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()
            ->getStyle('F2:F' . $parent)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);

        // Rename worksheet
        $excel->getActiveSheet()->setTitle('General Ledger');

        // Set active sheet index to the first sheet, so Excel opens this as the first sheet
        $excel->setActiveSheetIndex(0);
        $parent++;
        $excel->getActiveSheet()->getStyle('A' . $parent . ':G' . $parent)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $parent . ':E' . $parent);
        $excel->getActiveSheet(0)
            ->getStyle('F' . $parent)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $parent, 'Closing Balance')
            ->setCellValue('F' . $parent, Yii::app()->numberFormatter->formatCurrency(abs($closingBalance), " ") . ' ' . $symbol);

        $styleArray = array(
            'borders' => array(
                'allborders' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        $excel->getActiveSheet(0)->getStyle('A1:G' . $parent)->applyFromArray($styleArray);

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="general_ledger.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }
    public function actionTestReport()
    {
        $ledger_id = 4186;
        $ledgerModel = FinanceSubledger::model()->find(array('condition' => 'subledger_type_id=2 AND parent_id=' . $ledger_id));
        $subledger = $ledgerModel->id;
        $count = 0;
        if ($ledgerModel->id > 0) {
            $query = "select id,invoice_no,invoice_date,vendor_id,7 AS voucher_type,grand_total from erp_purchase_invoice where active='Y' AND vendor_id=" . $ledger_id;
            $items = Yii::app()->db->createCommand($query)->queryAll();
        }
        $ledgerModel = Vendor::model()->findByPk($ledger_id);
        if (!empty($items)) {
            foreach ($items as $i => $each) {
                $allocated = Yii::app()->db->createCommand("select SUM(A.amount) from erp_finance_voucher_head H INNER JOIN erp_finance_voucher_items I ON H.id=I.header_id INNER JOIN erp_finance_allocation_items A ON A.voucher_item_id=I.id where H.voucher_type=8 AND H.header_table_id=" . $each['id'] . " AND I.ledger_id=6 AND I.subledger_id=" . $subledger)->queryScalar();
                echo "Test" . $allocated;
                die;
                $balance = $each['grand_total'] - abs($allocated);
                if (round($balance, 2) > 0) {
                    $this->responseBody['data'][] = array(
                        'voucher_id' => $each['id'],
                        'voucher_item_id' => $each['id'],
                        'ledger_id' => $each['customer_id'],
                        'voucher_date' => $each['invoice_date'],
                        'voucher_type' => $each['voucher_type'],
                        'voucher_no' => $each['invoice_no'],
                        'voucher_value' => $this->format_currency($each['grand_total']),
                        'allocated' => $this->format_currency($allocated),
                        'balance' => $this->format_currency($balance),
                    );
                    $count++;
                }
            }
        }
    }
    public function actionDay_book_report()
    {
        $this->render('day_book_report');
    }
    public function actionDay_book_html()
    {
        $ledgerItems = array();

        $ledger_id = (int) $_POST['ledger_id'];
        $subledger = (int) $_POST['subledger_id'];
        $brand = (int) $_POST['brand'];
        $currency = 1;
        $outlet = (int) $_POST['outlet'];
        $user = (int) $_POST['created_user'];
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;

        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-d');
        //        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-t');

        $condition = 'parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        //        $condition_for_opening = 'H.is_posted = "Y" AND H.voucher_date < "' . $from_date . '"';

        if ($ledger_id > 0) {
            $condition .= ' AND t.ledger_id IN(' . $ledger_id . ')';
            //            $condition_for_opening .= ' AND I.ledger_id IN(' . $ledger_id . ')';
        }

        if ($subledger > 0) {
            $condition .= ' AND t.subledger_id=' . $subledger;
            //            $condition_for_opening .= ' AND I.subledger_id=' . $subledger;
        }

        if ($brand > 0) {
            $condition .= ' AND t.brand_id=' . $brand;
            //            $condition_for_opening .= ' AND I.subledger_id=' . $brand;
        }

        if ($outlet > 0) {
            $condition .= ' AND t.outlet=' . $outlet;
            //            $condition_for_opening .= ' AND I.outlet=' . $outlet;
        }

        if ($user > 0) {
            $condition .= ' AND parent.created_by=' . $user;
            //            $condition_for_opening .= ' AND I.outlet=' . $outlet;
        }
        //        $openingBalance1 = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE I.currency_id='.$currency.' AND '. $condition_for_opening . ' ')->queryScalar();
        //        $openingBalance2 = Yii::app()->db->createCommand('SELECT ROUND((SUM(I.amount*I.exchange_rate)), 4) AS amount FROM {{finance_voucher_items}} I LEFT JOIN {{finance_voucher_head}} H ON I.header_id = H.id WHERE I.currency_id!='.$currency.' AND '. $condition_for_opening . ' ')->queryScalar();
        $items = FinanceVoucherItems::model()->with('parent', 'parent.vtype')->findAll(array('condition' => $condition, 'order' => 'parent.voucher_date DESC,vtype.code ASC,parent.voucher_no ASC'));
        //        $openingBalance=$openingBalance1+($openingBalance2/$exchange_rate);
        $previousBalance = $openingBalance;
        $closingBalance = $openingBalance;
        $symbol = ($previousBalance > 0) ? 'Dr' : 'Cr';

        $total_debit = 0;
        $total_credit = 0;
        $discount_allowed = FinanceSystemAccountsMapping::getSystemdefault('discount_allowed');
        $table = '<table class="table table-hover table-fixed table-bordered" id="gl_table">
                  <thead>
                      <tr>
                        <th style="width:7%" >Salesman</th>
                        <th style="width:7%" >Date</th>
                         <th style="width:5%" >Type</th>
                        <th style="width:5%" >VO #</th>
                        <th style="width:10%" >Ledger</th>
                        <th style="width:20%" >Subledger</th>
                        <th style="width:10%" >PT</th>
                        <th style="width:20%" >Ref</th>
                        <th style="width:40%">Narration</th>
                        <th style="width:12%;text-align:right !important;" class="text-right">Value</th>
                      </tr>
                  </thead>
                  <tbody>';
        $parent = 1;
        $sales_total = 0;
        $purchase_total = 0;
        $creditnote_total = 0;
        $debitnote_total = 0;
        $receipt_total = 0;
        $payment_total = 0;
        $journal_total = 0;
        $discount_total = 0;
        $receipt_discount_total = 0;
        $salary_total = 0;
        $fixed_asset_total = 0;
        foreach ($items as $each) {

            $debit = ($each->amount > 0) ? round(($each->amount * $each->exchange_rate), 4) : '';
            $credit = ($each->amount < 0) ? round(abs($each->amount * $each->exchange_rate), 4) : '';

            $debit = ($currency == $each->currency_id) ? $debit / $each->exchange_rate : $debit / $exchange_rate;
            $credit = ($currency == $each->currency_id) ? $credit / $each->exchange_rate : $credit / $exchange_rate;

            $running = $debit - $credit + $previousBalance;
            $previousBalance = $running;
            $symbol = ($running > 0) ? 'Dr' : 'Cr';
            $closingBalance += ($debit - $credit);

            $total_debit += $debit;
            $total_credit += $credit;

            $subledgerName = ($each->subledger_id > 0) ? $each->subledger->description : '';
            $vouchreformat =  $each->parent->fullvoucher;
            if ($each->parent->vtype->code == "SI" && $debit > 0) {
                if ($each->parent->header_table_id > 0) {
                    $SalesInvoice = SalesInvoice::model()->findByPk($each->parent->header_table_id);
                    switch ($SalesInvoice->payment_term) {
                        case 1:
                            $payTerms = 'Cash';
                            break;
                        case 2:
                            $payTerms = 'Credit';
                            if ($SalesInvoice->customer->credit_days > 0) {
                                $payTerms .= ' - ' . $SalesInvoice->customer->credit_days . ' Days ';
                            }
                            break;
                        case 3:
                            $payTerms = 'Credit 60 PDC';
                            break;
                        case 4:
                            $payTerms = 'Credit 90 PDC';
                            break;
                        case 5:
                            $payTerms = 'Credit 30 PDC';
                            break;
                        case 6:
                            $payTerms = 'Credit 15 PDC';
                            break;
                    }
                }
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td> SALES </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td>' . $payTerms . '</td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                      </tr>';
                $sales_total += $debit;
            } else if ($each->parent->vtype->code == "PI" && $credit > 0) {
                if ($each->parent->header_table_id > 0) {
                    $PurchaseInvoice = PurchaseInvoice::model()->findByPk($each->parent->header_table_id);
                    switch ($PurchaseInvoice->payment_term) {
                        case 1:
                            $payTerms = 'Cash';
                            break;
                        case 2:
                            $payTerms = 'Credit';
                            break;
                        case 3:
                            $payTerms = 'Credit 60 PDC';
                            break;
                        case 4:
                            $payTerms = 'Credit 90 PDC';
                            break;
                        case 5:
                            $payTerms = 'Credit 30 PDC';
                            break;
                        case 6:
                            $payTerms = 'Credit 15 PDC';
                            break;
                    }
                }
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td> PURCHASE </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td>' . $payTerms . '</td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                      </tr>';
                $purchase_total += $credit;
            } else if ($each->parent->vtype->code == "CN" && $credit > 0) {
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td> CREDIT NOTE </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td></td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                      </tr>';
                $creditnote_total += $credit;
            } else if ($each->parent->vtype->code == "DN" && $debit > 0) {
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td> DEBIT NOTE </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td></td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                      </tr>';
                $debitnote_total += $debit;
            } else if ($each->parent->vtype->code == "PV" && $debit > 0) {
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td> PAYMENT </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td></td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                      </tr>';
                $payment_total += $debit;
            } else if ($each->parent->vtype->code == "CA" && $credit > 0) {
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                           <td> RECEIPT </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td></td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                      </tr>';
                $receipt_total += $credit;
            } else if ($each->parent->vtype->code == "CA" && $each->ledger_id == $discount_allowed) {
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                           <td> DISCOUNT RECEIPT </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td></td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                      </tr>';
                $receipt_discount_total += $debit;
            } else if ($each->parent->vtype->code == "CHQ" && $credit > 0) {
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td> RECEIPT </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td></td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                      </tr>';
                $receipt_total += $credit;
            } else if ($each->parent->vtype->code == "DA" && $credit > 0) {
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td> DISCOUNT </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td></td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                      </tr>';
                $discount_total += $credit;
            } else if ($each->parent->vtype->code == "JV" && $debit > 0) {
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td> JOURNAL </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td></td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                      </tr>';
                $journal_total += $debit;
            } else if ($each->parent->vtype->code == "SL" && $debit > 0) {
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td> SALARY </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td></td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                      </tr>';
                $salary_total += $debit;
            } else if ($each->parent->vtype->code == "FA" && $debit > 0) {
                $table .= ' <tr  data-id="' . $parent . '" data-parent="">
                          <td>' . $each->parent->created->full_name . '</td>
                          <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                          <td> FIXED ASSET </td>
                          <td>' . $vouchreformat . '</td>
                          <td>' . $each->ledger->description . '</td>
                          <td>' . $subledgerName . '</td>
                          <td></td>
                          <td>' . $each->parent->reference_no . '</td>
                          <td><small>' . $each->narration . '</small></td>
                          <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                      </tr>';
                $fixed_asset_total += $debit;
            }
            $parent = $child;
        }
        $running = $debit - $credit + $previousBalance;
        $symbol = ($closingBalance > 0) ? 'Dr' : 'Cr';
        $table .= '<tr>
                      <td colspan="9" style="text-align:right !important;"><b>TOTAL PURCHASE </b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($purchase_total), " ") . '</b></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="9" style="text-align:right !important;"><b>TOTAL DEBIT NOTE </b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($debitnote_total), " ") . '</b></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="9" style="text-align:right !important;"><b>TOTAL SALES </b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($sales_total), " ") . '</b></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="9" style="text-align:right !important;"><b>TOTAL CREDIT NOTE </b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($creditnote_total), " ") . '</b></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="9" style="text-align:right !important;"><b>TOTAL RECEIPT </b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($receipt_total), " ") . '</b></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="9" style="text-align:right !important;"><b>TOTAL PAYMENT </b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($payment_total), " ") . '</b></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="9" style="text-align:right !important;"><b>TOTAL JOURNAL </b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($journal_total), " ") . '</b></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="9" style="text-align:right !important;"><b>TOTAL SALES DISCOUNT </b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($discount_total), " ") . '</b></td>
                  </tr>';

        $table .= '<tr>
                      <td colspan="9" style="text-align:right !important;"><b>TOTAL RECEIPT DISCOUNT </b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($receipt_discount_total), " ") . '</b></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="9" style="text-align:right !important;"><b>TOTAL SALARY </b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($salary_total), " ") . '</b></td>
                  </tr>';
        $table .= '<tr>
                      <td colspan="9" style="text-align:right !important;"><b>TOTAL FIXED ASSET </b></td>
                      <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($fixed_asset_total), " ") . '</b></td>
                  </tr>';

        $table .= '</tbody>
              </table>';
        echo $table;
    }
    public function actionDay_book_pdf()
    {

        $from_date = Yii::app()->request->getParam('from_date');
        $to_date = Yii::app()->request->getParam('to_date');
        $ledger = Yii::app()->request->getParam('ledger');
        $user = Yii::app()->request->getParam('created_user');
        $subledger = (int) Yii::app()->request->getParam('subledger');
        $brand = (int) Yii::app()->request->getParam('brand');
        $currency = (int) Yii::app()->request->getParam('currency');
        $outlet = (int) Yii::app()->request->getParam('outlet');
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;

        $param = array(
            'from_date' => $from_date,
            'to_date' => $to_date,
            'ledger' => $ledger,
            'subledger' => $subledger,
            'currency_code' => $currency_code,
            'exchange_rate' => $exchange_rate,
            'currency' => $currency,
            'outlet' => $outlet,
            'user' => $user
        );

        //        $mode = 'A4-L';
        $mode = 'A4';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'pdf_day_book_report';
        $mpdf->WriteHTML($this->renderPartial($view, $param, true));
        $mpdf->Output("DayBookReport" . date("d-m-Y") . ".pdf", 'I');
    }

    public function actionDay_book_excel()
    {

        Yii::import('ext.PHPExcel.PHPExcel');
        $ledger_id = (int) $_GET['ledger_id'];
        $subledger = (int) $_GET['subledger_id'];
        $brand = (int) $_GET['brand'];
        $currency = 1;
        $outlet = (int) $_GET['outlet'];
        $user = (int) $_GET['created_user'];
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;
        $from_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-d');
        $to_date = (count(explode('/', $_GET['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_GET['from_date']))) : date('Y-m-d');
        //        $currency = (int) $_GET['currency'];
        $currency = 1;
        $cur = MasCurrency::model()->findByPk($currency);
        $exchange_rate = $cur->exchange_rate;
        $currency_code = $cur->currency_code;
        $created_by = (int) Yii::app()->request->getParam('created_user');

        $condition = 'parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';

        if ($ledger_id > 0) {
            $condition .= ' AND t.ledger_id IN(' . $ledger_id . ')';
        }

        if ($subledger > 0) {
            $condition .= ' AND t.subledger_id=' . $subledger;
        }

        if ($brand > 0) {
            $condition .= ' AND t.brand_id=' . $brand;
        }

        if ($outlet > 0) {
            $condition .= ' AND t.outlet=' . $outlet;
        }

        if ($user > 0) {
            $condition .= ' AND parent.created_by=' . $user;
        }

        $items = FinanceVoucherItems::model()->with('parent', 'parent.vtype')->findAll(array('condition' => $condition, 'order' => 'parent.voucher_date DESC,vtype.code ASC,parent.voucher_no ASC'));
        $previousBalance = $openingBalance;
        $closingBalance = $openingBalance;
        $symbol = ($previousBalance > 0) ? 'Dr' : 'Cr';

        // Create new PHPExcel object
        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(3)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(4)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(5)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(6)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(7)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Day Book Report")
            ->setSubject("Day Book Report")
            ->setDescription("Day Book Report Generated on " . date('d/m/Y'))
            ->setKeywords("Day Book Report")
            ->setCategory("Financial Report");

        // Add some data
        $settings = MasCompany::model()->findByPk(Yii::app()->user->company_id);
        $excel->getActiveSheet()->getStyle('A1:J1')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A1:J1');
        $excel->getActiveSheet(0)
            ->setCellValue('A1', $settings->name);

        // $excel->getActiveSheet()->getStyle('A2:H2')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A2:J2');
        $excel->getActiveSheet(0)
            ->setCellValue('A2', $settings->billing_address);

        // $excel->getActiveSheet()->getStyle('A3:H3')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A3:J3');
        $excel->getActiveSheet(0)
            ->setCellValue('A3', '');

        $excel->setActiveSheetIndex(0)->mergeCells('A4:J4');

        // $excel->getActiveSheet()->getStyle('A4:H4')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A5:J5');
        $excel->getActiveSheet(0)
            ->setCellValue('A5', 'TRN : ' . $settings->trn_no);

        $excel->getActiveSheet()->getStyle('A6:J6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A6:J6');
        $excel->getActiveSheet(0)
            ->setCellValue('A6', $title);

        $date_title = date("d-m-Y", strtotime($from_date)) . ' TO ' . date("d-m-Y", strtotime($to_date));
        // $excel->getActiveSheet()->getStyle('A6:H6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A7:J7');
        $excel->getActiveSheet(0)
            ->setCellValue('A7', $date_title);
        $excel->setActiveSheetIndex(0)->mergeCells('A8:J8');
        $currency1 = 'Currency : ' . $currency_code;
        $excel->getActiveSheet(0)
            ->setCellValue('A8', $currency1);
        $excel->setActiveSheetIndex(0)->mergeCells('A9:J9');

        $total_debit = 0;
        $total_credit = 0;

        $parent = 1;
        $sales_total = 0;
        $purchase_total = 0;
        $creditnote_total = 0;
        $debitnote_total = 0;
        $receipt_total = 0;
        $payment_total = 0;
        $journal_total = 0;
        $discount_total = 0;
        $receipt_discount_total = 0;
        $discount_allowed = FinanceSystemAccountsMapping::getSystemdefault('discount_allowed');
        $excel->getActiveSheet()->getStyle('A10:J10')->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)
            ->setCellValue('A10', 'Salesman')
            ->setCellValue('B10', 'Date')
            ->setCellValue('C10', 'Type')
            ->setCellValue('D10', 'VO#')
            ->setCellValue('E10', 'Ledger')
            ->setCellValue('F10', 'Subledger')
            ->setCellValue('G10', 'PT')
            ->setCellValue('H10', 'Ref')
            ->setCellValue('I10', 'Narration')
            ->setCellValue('J10', 'Value');

        $row_no = 11;
        foreach ($items as $each) {

            $debit = ($each->amount > 0) ? round(($each->amount * $each->exchange_rate), 4) : '';
            $credit = ($each->amount < 0) ? round(abs($each->amount * $each->exchange_rate), 4) : '';

            $debit = ($currency == $each->currency_id) ? $debit / $each->exchange_rate : $debit / $exchange_rate;
            $credit = ($currency == $each->currency_id) ? $credit / $each->exchange_rate : $credit / $exchange_rate;

            $running = $debit - $credit + $previousBalance;
            $previousBalance = $running;
            $symbol = ($running > 0) ? 'Dr' : 'Cr';
            $closingBalance += ($debit - $credit);

            $total_debit += $debit;
            $total_credit += $credit;

            $subledgerName = ($each->subledger_id > 0) ? $each->subledger->description : '';
            $vouchreformat =  $each->parent->fullvoucher;
            if ($each->parent->vtype->code == "SI" && $debit > 0) {
                if ($each->parent->header_table_id > 0) {
                    $SalesInvoice = SalesInvoice::model()->findByPk($each->parent->header_table_id);
                    switch ($SalesInvoice->payment_term) {
                        case 1:
                            $payTerms = 'Cash';
                            break;
                        case 2:
                            $payTerms = 'Credit';
                            if ($SalesInvoice->customer->credit_days > 0) {
                                $payTerms .= ' - ' . $SalesInvoice->customer->credit_days . ' Days ';
                            }
                            break;
                        case 3:
                            $payTerms = 'Credit 60 PDC';
                            break;
                        case 4:
                            $payTerms = 'Credit 90 PDC';
                            break;
                        case 5:
                            $payTerms = 'Credit 30 PDC';
                            break;
                        case 6:
                            $payTerms = 'Credit 15 PDC';
                            break;
                    }
                }
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $each->parent->created->full_name);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'SALES');
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $vouchreformat);
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, $each->ledger->description);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, $subledgerName);
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, $payTerms);
                $excel->setActiveSheetIndex(0)->setCellValue('H' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('I' . $row_no, $each->narration);
                $excel->setActiveSheetIndex(0)->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency($debit, " "));
                $sales_total += $debit;
                $row_no++;
            } else if ($each->parent->vtype->code == "PI" && $credit > 0) {
                if ($each->parent->header_table_id > 0) {
                    $PurchaseInvoice = PurchaseInvoice::model()->findByPk($each->parent->header_table_id);
                    switch ($PurchaseInvoice->payment_term) {
                        case 1:
                            $payTerms = 'Cash';
                            break;
                        case 2:
                            $payTerms = 'Credit';
                            break;
                        case 3:
                            $payTerms = 'Credit 60 PDC';
                            break;
                        case 4:
                            $payTerms = 'Credit 90 PDC';
                            break;
                        case 5:
                            $payTerms = 'Credit 30 PDC';
                            break;
                        case 6:
                            $payTerms = 'Credit 15 PDC';
                            break;
                    }
                }
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $each->parent->created->full_name);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'PURCHASE');
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $vouchreformat);
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, $each->ledger->description);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, $subledgerName);
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, $payTerms);
                $excel->setActiveSheetIndex(0)->setCellValue('H' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('I' . $row_no, $each->narration);
                $excel->setActiveSheetIndex(0)->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                $purchase_total += $credit;
                $row_no++;
            } else if ($each->parent->vtype->code == "CN" && $credit > 0) {
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $each->parent->created->full_name);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'CREDIT NOTE');
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $vouchreformat);
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, $each->ledger->description);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, $subledgerName);
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, '');
                $excel->setActiveSheetIndex(0)->setCellValue('H' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('I' . $row_no, $each->narration);
                $excel->setActiveSheetIndex(0)->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                $creditnote_total += $credit;
                $row_no++;
            } else if ($each->parent->vtype->code == "DN" && $debit > 0) {
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $each->parent->created->full_name);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'DEBIT NOTE');
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $vouchreformat);
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, $each->ledger->description);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, $subledgerName);
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, '');
                $excel->setActiveSheetIndex(0)->setCellValue('H' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('I' . $row_no, $each->narration);
                $excel->setActiveSheetIndex(0)->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                $debitnote_total += $debit;
                $row_no++;
            } else if ($each->parent->vtype->code == "PV" && $debit > 0) {
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $each->parent->created->full_name);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'PAYMENT');
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $vouchreformat);
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, $each->ledger->description);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, $subledgerName);
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, '');
                $excel->setActiveSheetIndex(0)->setCellValue('H' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('I' . $row_no, $each->narration);
                $excel->setActiveSheetIndex(0)->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                $payment_total += $debit;
                $row_no++;
            } else if ($each->parent->vtype->code == "CA" && $credit > 0) {
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $each->parent->created->full_name);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'RECEIPT');
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $vouchreformat);
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, $each->ledger->description);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, $subledgerName);
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, '');
                $excel->setActiveSheetIndex(0)->setCellValue('H' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('I' . $row_no, $each->narration);
                $excel->setActiveSheetIndex(0)->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                $receipt_total += $credit;
                $row_no++;
            } else if ($each->parent->vtype->code == "CA" && $each->ledger_id == $discount_allowed) {
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $each->parent->created->full_name);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'DISCOUNT RECEIPT');
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $vouchreformat);
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, $each->ledger->description);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, $subledgerName);
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, '');
                $excel->setActiveSheetIndex(0)->setCellValue('H' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('I' . $row_no, $each->narration);
                $excel->setActiveSheetIndex(0)->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency($debit, " "));
                $receipt_discount_total += $debit;
                $row_no++;
            } else if ($each->parent->vtype->code == "CHQ" && $credit > 0) {
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $each->parent->created->full_name);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'RECEIPT');
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $vouchreformat);
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, $each->ledger->description);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, $subledgerName);
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, '');
                $excel->setActiveSheetIndex(0)->setCellValue('H' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('I' . $row_no, $each->narration);
                $excel->setActiveSheetIndex(0)->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                $receipt_total += $credit;
                $row_no++;
            } else if ($each->parent->vtype->code == "DA" && $credit > 0) {
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $each->parent->created->full_name);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'DISCOUNT');
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $vouchreformat);
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, $each->ledger->description);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, $subledgerName);
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, '');
                $excel->setActiveSheetIndex(0)->setCellValue('H' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('I' . $row_no, $each->narration);
                $excel->setActiveSheetIndex(0)->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                $discount_total += $credit;
                $row_no++;
            } else if ($each->parent->vtype->code == "JV" && $debit > 0) {
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $each->parent->created->full_name);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'DISCOUNT');
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $vouchreformat);
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, $each->ledger->description);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, $subledgerName);
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, '');
                $excel->setActiveSheetIndex(0)->setCellValue('H' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('I' . $row_no, $each->narration);
                $excel->setActiveSheetIndex(0)->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                $journal_total += $debit;
                $row_no++;
            }
        }


        $running = $debit - $credit + $previousBalance;
        $symbol = ($closingBalance > 0) ? 'Dr' : 'Cr';
        $excel->getActiveSheet()->getStyle('J11:J' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':I' . $row_no);
        //        $excel->setActiveSheetIndex(0)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':A' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':J' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $row_no, 'TOTAL PURCHASE')
            ->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($purchase_total), " "));
        $row_no++;
        $excel->getActiveSheet()->getStyle('J11:J' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':A' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':J' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':I' . $row_no);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $row_no, 'TOTAL DEBIT NOTE')
            ->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($debitnote_total), " "));
        $row_no++;
        $excel->getActiveSheet()->getStyle('J11:J' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':A' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':J' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':I' . $row_no);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $row_no, 'TOTAL SALES')
            ->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($sales_total), " "));
        $row_no++;
        $excel->getActiveSheet()->getStyle('J11:J' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':A' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':J' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':I' . $row_no);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $row_no, 'TOTAL CREDIT NOTE')
            ->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($creditnote_total), " "));
        $row_no++;
        $excel->getActiveSheet()->getStyle('J11:J' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':A' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':J' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':I' . $row_no);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $row_no, 'TOTAL RECEIPT')
            ->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($receipt_total), " "));
        $row_no++;
        $excel->getActiveSheet()->getStyle('J11:J' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':A' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':J' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':I' . $row_no);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $row_no, 'TOTAL PAYMENT')
            ->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($payment_total), " "));
        $row_no++;
        $excel->getActiveSheet()->getStyle('J11:J' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':A' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':J' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':I' . $row_no);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $row_no, 'TOTAL JOURNAL')
            ->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($journal_total), " "));
        $row_no++;
        $excel->getActiveSheet()->getStyle('J11:J' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':A' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':J' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':I' . $row_no);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $row_no, 'TOTAL SALES DISCOUNT')
            ->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($discount_total), " "));
        $row_no++;
        $excel->getActiveSheet()->getStyle('J11:J' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':A' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':J' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':I' . $row_no);
        $excel->getActiveSheet(0)
            ->setCellValue('A' . $row_no, 'TOTAL RECEIPT DISCOUNT')
            ->setCellValue('J' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($receipt_discount_total), " "));
        $row_no++;
        // Rename worksheet
        $excel->getActiveSheet()->setTitle('DAY BOOK');

        $styleArray = array(
            'borders' => array(
                'allborders' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        $excel->getActiveSheet(0)->getStyle('A1:J' . $parent)->applyFromArray($styleArray);

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="day_book.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }
    public function actionVat_return_html()
    {
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $outlet = (int) $_POST['outlet'];
        $condition = '(t.invoice_date>="' . $from_date . '" AND t.invoice_date<="' . $to_date . '") AND t.active="Y"';
        if ($outlet > 0) {
            $condition .= ' AND outlet="' . $outlet . '"';
        }
        $sales_view_sql = 'CREATE OR REPLACE VIEW view_net_sale_report AS (SELECT "I" as type,I.id,I.customer_id,I.invoice_no,I.invoice_date,C.customer_name,I.exchange_rate,I.total_amount,0 AS total_amount1,I.grand_total,0 AS grand_total1,I.tax_total,0 AS tax_total1,I.outlet,I.active,C.state
              FROM  {{sales_invoice}} I
              LEFT JOIN  {{customer}} C
              ON C.id=I.customer_id
              )
              UNION ALL
              (SELECT "CN" as type,CN.id,CN.customer_id,CN.return_no AS invoice_no,CN.return_date AS invoice_date,C.customer_name,CN.exchange_rate,0 AS total_amount,(CN.total_amount) AS total_amount1,0 AS grand_total,(CN.grand_total) AS grand_total1,0 AS tax_total,(CN.tax_total) AS tax_total1,CN.outlet,CN.active,C.state 
              FROM  {{sales_return}} CN
              LEFT JOIN  {{customer}} C
              ON C.id=CN.customer_id)';
        Yii::app()->db->createCommand($sales_view_sql)->execute();
        $sales_sql = 'SELECT S.state_name,t.state,SUM(grand_total-grand_total1) AS grand,SUM(total_amount-total_amount1) AS tot,SUM(tax_total-tax_total1) AS vat FROM view_net_sale_report t INNER JOIN erp_master_state S ON t.state=S.id WHERE ' . $condition . ' GROUP BY state ORDER BY S.state_name ASC';

        $table = '<br><table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="6">VAT on Sales (Outwards)</th>
                        </tr>
                        <tr>
                            <th style="width:8%">Emirate</th>
                            <th style="width:15%">Taxable Amount</th>
                            <th style="width:15%">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';

        $total_amount = 0;
        $total_vat = 0;
        $items = Yii::app()->db->createCommand($sales_sql)->queryAll();
        foreach ($items as $each) {
            $vat = round($each['vat'], 4);
            $tot = round($each['tot'], 4);
            if ($each['state'] > 0) {
                $emirate = $each['state_name'];
            }
            $table .= '<tr>
                                            <td>' . $emirate . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($tot, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                        </tr>';

            $total_amount += $tot;
            $total_vat += $vat;
        }
        $table .= '<tr>
                                            <td style="text-align:right !important;"><b>TOTAL</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat, " ") . '</b></td>
                                        </tr>';

        // Start Other Income

        $vat_sales_account = FinanceSystemAccountsMapping::getSystemdefault('sales_vat');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id = VH.voucher_type
                        WHERE VT.code!="SI" AND VT.code!="CN" AND L.main_account_type="A" AND L.id="' . $vat_sales_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_other_income = -1 * Yii::app()->db->createCommand($query)->queryScalar();
        $table .= '<tr><td colspan="2" style="text-align:right !important;"><b>VAT ON OTHER INCOME</b></td>
                                <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(($vat_on_other_income), " ") . '</b></td></tr>';

        // End Other Income
        $purchase_view_sql = 'CREATE OR REPLACE VIEW view_net_purchase_report AS (SELECT "I" as type,I.id,I.invoice_date,I.exchange_rate,I.total_amount,0 AS total_amount1,I.grand_total,0 AS grand_total1,I.tax_total,0 AS tax_total1,I.outlet,I.active
              FROM  {{purchase_invoice}} I
              )
              UNION ALL
              (SELECT "CN" as type,CN.id,CN.return_date AS invoice_date,CN.exchange_rate,0 AS total_amount,(CN.total_amount) AS total_amount1,0 AS grand_total,(CN.grand_total) AS grand_total1,0 AS tax_total,(CN.tax_total) AS tax_total1,CN.outlet,CN.active
              FROM  {{purchase_return}} CN)';
        Yii::app()->db->createCommand($purchase_view_sql)->execute();

        $purchase_vat = Yii::app()->db->createCommand('SELECT SUM(tax_total-tax_total1) AS vat FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();

        $table .= '<tr>
                                            <td colspan="2" style="text-align:right !important;"><b>VAT ON PURCHASE</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($purchase_vat, " ") . '</b></td>
                                        </tr>';
        $vat_account = FinanceSystemAccountsMapping::getSystemdefault('vat_on_expense');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        WHERE L.main_account_type="L" AND L.id="' . $vat_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_expense = Yii::app()->db->createCommand($query)->queryScalar();
        $vat_purchase_account = FinanceSystemAccountsMapping::getSystemdefault('purchase_vat');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id = VH.voucher_type
                        WHERE VT.code!="PI" AND VT.code!="DN" AND L.main_account_type="L" AND L.id="' . $vat_purchase_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_other_expense = Yii::app()->db->createCommand($query)->queryScalar();
        $table .= '<tr>
                                            <td colspan="2" style="text-align:right !important;"><b>VAT ON EXPENSE</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(($vat_on_expense + $vat_on_other_expense), " ") . '</b></td>
                                        </tr>';
        $table .= '<tr>
                                            <td colspan="2" style="text-align:right !important;"><b>VAT PAYABLE</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(($total_vat + $vat_on_other_income - $vat_on_expense - $vat_on_other_expense - $purchase_vat), " ") . '</b></td>
                                        </tr>';
        $table .= '</tbody>
                        <table>';
        echo $table;
    }
    public function actionVat_return_report()
    {
        $this->render('vat_return_report');
    }
    public function actionPl_new_pdf()
    {
        $brand = (int) $_REQUEST['brand'];
        $outlet = (int) $_REQUEST['outlet'];
        $created_user = (int) $_REQUEST['created_user'];
        $costcenter = (int) $_REQUEST['costcenter'];
        $from_date = (count(explode('/', $_REQUEST['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to_date']))) : date('Y-m-d');
        $condition = 'H.is_posted="Y" AND H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';

        if ($outlet > 0) {
            $condition .= ' AND I.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        if ((int)$created_user > 0) {
            $condition .= ' AND H.created_by=' . $created_user;
            // $conditions .= ' AND created_by=' . $created_user;
        }
        if ((int)$costcenter > 0) {
            $condition .= ' AND H.costcenter=' . $costcenter;
        }

        $time = strtotime($end_date);
        $year = date("Y", $time);
        //echo '(SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  '.$condition.'   AND ( A.main_account_type="I") group by A.id order by A.account_no)';die;
        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $condition . '   AND ( A.main_account_type="I") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (SELECT id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='I')")->execute();
        $SQL = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $income = Yii::app()->db->createCommand($SQL)->queryAll();


        //We have 5 levels
        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:50%">Accounts</th>
                            <th style="width:25%">Amount</th>
                        </tr>
                    </thead>
                <tbody>';
        $totals = array();
        //        $directIncome = FinanceLegder::model()->findAll(array('condition' => 'classification="DIRECT_INCOME"', 'order' => 'id ASC'));
        $totalDirectincome = 0;
        $totalDirectexpense = 0;
        $totalIndirectincome = 0;
        $totalIndirectexpense = 0;
        //level - 2
        $Total_Income = 0;
        $TotalDirectIncome = 0;
        foreach ($income as $eachAccount) {

            $balance = 0;
            $accountName = $eachAccount['title'];
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $table .= '<tr>
                                            <td colspan="2"><b>' . $space . $accountName . '</b></td>
                                        </tr>';
                //                            $table .= '<tr>
                //                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency((-1*$eachAccount['amount']), " ") . '</td>
                //                                        </tr>';
            } else {
                if ($eachAccount['amount'] != 0) {
                    $table .= '<tr>
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency((-1 * $eachAccount['amount']), " ") . '</td>
                                        </tr>';
                }
            }
            if ($eachAccount['id'] == 11) {
                $TotalDirectIncome += $eachAccount['amount'];
            }
            if ($eachAccount['id'] == 12) {
                $TotalDirectIncome += $eachAccount['amount'];
            }
            if ($eachAccount['id'] == 53) {
                $TotalDirectIncome += $eachAccount['amount'];
            }

            $Total_Income += -1 * ($eachAccount['amount']);
        }

        $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
        $accountName = "Goods Receipt";
        $table .= '<tr>
                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(($goods_receipt), " ") . '</td>
                                        </tr>';
        $Total_Income += $goods_receipt;
        $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Total Income </b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($Total_Income), " ") . '</b></td>
                            </tr>';
        //direct expense

        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE ' . $condition . ' AND ( A.main_account_type="E") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (select id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='E')")->execute();
        $SQL1 = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $expenses = Yii::app()->db->createCommand($SQL1)->queryAll();
        $Total_Expense = 0;
        foreach ($expenses as $eachAccount) {

            $balance = 0;
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }
            if ($eachAccount['id'] == 10005) {
                $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $Total_Expense += $balance;
                $accountName = 'Cost of Sale';
                $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($balance, " ") . '</td>
                                        </tr>';
            } else if ($eachAccount['id'] == 4114) {
                $balance = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $Total_Expense += $balance;
                $accountName = 'Damage/stock clearing/expiry';
                $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($balance, " ") . '</td>
                                        </tr>';
            } else {
                $accountName = $eachAccount['title'];
                if ($eachAccount['rollup_account'] == 'Y') {
                    $table .= '<tr>
                                            <td colspan="2"><b>' . $space . $accountName . '</b></td>
                                        </tr>';
                } else {
                  //  if ($eachAccount['amount'] != 0) {  commented to get all ledgers
                        $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($eachAccount['amount'], " ") . '</td>
                                        </tr>';
                  //  }
                }
                $Total_Expense += $eachAccount['amount'];
            }
        }
        $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Total Expense </b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($Total_Expense), " ") . '</b></td>
                            </tr>';

        $netProfit = $Total_Income - $Total_Expense;
        if ($netProfit > 0) {
            $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Profit (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " ") . '</b></td>
                            </tr>';
        } else {
            $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Loss (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " ") . '</b></td>
                            </tr>';
        }
        $table .= '</tbody>
                </table>';

        $param = array('brandModel' => $brandModel, 'table' => $table, 'from_date' => date('d/m/Y', strtotime($from_date)), 'to_date' => date('d/m/Y', strtotime($to_date)));
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf_pl_report', $param, true));
        $mpdf->Output("profit_or_loss" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionBs_new_pdf()
    {
        $brand = (int) $_REQUEST['brand'];
        $outlet = (int) $_REQUEST['outlet'];
        $costcenter = (int) $_REQUEST['costcenter'];
        //        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $from_date = '2019-01-01';
        $to_date = (count(explode('/', $_REQUEST['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to_date']))) : date('Y-m-d');
        $condition = 'H.is_posted="Y" AND H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';

        if ($outlet > 0) {
            $condition .= ' AND I.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
            $purchase_conditions .= ' AND I.outlet=' . $outlet;
        }
        if ($costcenter > 0) {
            $condition .= ' AND H.costcenter=' . $costcenter;
            $purchase_conditions .= ' AND H.costcenter=' . $costcenter;
        }

        $time = strtotime($end_date);
        $year = date("Y", $time);
        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $condition . '   AND ( A.main_account_type="A") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (select id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='A')")->execute();
        $SQL = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $income = Yii::app()->db->createCommand($SQL)->queryAll();


        //We have 5 levels
        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:50%">Accounts</th>
                            <th style="width:25%">Amount</th>
                        </tr>
                    </thead>
                <tbody>';
        $totals = array();
        //        $directIncome = FinanceLegder::model()->findAll(array('condition' => 'classification="DIRECT_INCOME"', 'order' => 'id ASC'));
        $totalDirectincome = 0;
        $totalDirectexpense = 0;
        $totalIndirectincome = 0;
        $totalIndirectexpense = 0;
        //level - 2
        $Total_Income = 0;
        foreach ($income as $eachAccount) {
            $balance = 0;
            $accountName = $eachAccount['title'];
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $table .= '<tr>
                                            <td colspan="2"><b>' . $space . $accountName . '</b></td>
                                        </tr>';
            } else {
                if ($eachAccount['amount'] != 0) {
                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(($eachAccount['amount']), " ") . '</td>
                                        </tr>';
                }
            }
            $Total_Income += ($eachAccount['amount']);
            if ($eachAccount['id'] == 10020) {
                $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS stock 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $goods_issue = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $Total_Income += - ($balance + $goods_issue);
                $accountName = 'Current Stock';

                $purchase = Yii::app()->db->createCommand('SELECT SUM(amount) AS purchase 
                FROM erp_finance_voucher_items AS I INNER JOIN erp_finance_voucher_head AS H ON I.header_id=H.id WHERE ledger_id=10005 AND voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $purchase_conditions)->queryScalar();
                $Total_Income += ($purchase + $goods_receipt);

                $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(($purchase + $goods_receipt - $balance - $goods_issue), " ") . '</td>
                                        </tr>';
                //               $accountName='Goods Receipt';
                //                      $table .= '<tr>
                //                                            <td>' . $space.$accountName . '</td>
                //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency($goods_receipt, " ") . '</td>
                //                                        </tr>';
            }
        }
        $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Total Asset </b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($Total_Income), " ") . '</b></td>
                            </tr>';
        //direct expense

        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE ' . $condition . ' AND ( A.main_account_type="L") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (select id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='L')")->execute();
        $SQL1 = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $expenses = Yii::app()->db->createCommand($SQL1)->queryAll();
        $Total_Expense = 0;
        foreach ($expenses as $eachAccount) {
            $balance = 0;
            $accountName = $eachAccount['title'];
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $table .= '<tr>
                                            <td colspan="2"><b>' . $space . $accountName . '</b></td>
                                        </tr>';
            } else {
               // if ($eachAccount['amount'] != 0) {  commented to get all ledgers
                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(-1 * ($eachAccount['amount']), " ") . '</td>
                                        </tr>';
              //  }
            }
            $Total_Expense += (-1 * $eachAccount['amount']);
        }

        $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Total Liability </b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . Yii::app()->numberFormatter->formatCurrency(abs($Total_Expense), " ") . '</b></td>
                            </tr>';

        $netProfit = $Total_Income - $Total_Expense;
        if ($netProfit > 0) {
            $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Profit (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " ") . '</b></td>
                            </tr>';
        } else {
            $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;"><b>Loss (' . FinanceLegder::baseCurrency() . ')</b></td>
                                <td style="color:#1F67B2;text-align:right !important;" ><b>' . $symbol . Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " ") . '</b></td>
                            </tr>';
        }
        $table .= '</tbody>
                </table>';

        $param = array('table' => $table, 'to_date' => date('d/m/Y', strtotime($to_date)));
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf_bs_report', $param, true));
        $mpdf->Output("balance_sheet" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionTb_new_pdf()
    {
        $brand = (int) $_REQUEST['brand'];
        $outlet = (int) $_REQUEST['outlet'];
        $costcenter = (int) $_REQUEST['costcenter'];
        $from_date = (count(explode('/', $_REQUEST['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to_date']))) : date('Y-m-d');
        $condition = 'H.is_posted="Y" AND H.voucher_date >= "' . $from_date . '" AND H.voucher_date <= "' . $to_date . '"';
        $bs_condition = 'H.is_posted="Y" AND H.voucher_date <= "' . $to_date . '"';
        if ($outlet > 0) {
            $condition .= ' AND I.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
            $purchase_conditions .= ' AND I.outlet=' . $outlet;
            $bs_condition .= ' AND I.outlet=' . $outlet;
        }
        if ($costcenter > 0) {
            $condition .= ' AND H.costcenter=' . $costcenter;
            $purchase_conditions .= ' AND H.costcenter=' . $costcenter;
            $bs_condition .= ' AND H.costcenter=' . $costcenter;
        }

        $time = strtotime($end_date);
        $year = date("Y", $time);
        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT I.ledger_id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $bs_condition . ' AND (A.main_account_type="A" OR A.main_account_type="L") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT I.ledger_id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $condition . ' AND (A.main_account_type="I" OR A.main_account_type="E")  group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}})')->execute();
        $SQL = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $income = Yii::app()->db->createCommand($SQL)->queryAll();

        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:50%">Accounts</th>
                            <th style="width:25%">debit</th>
                            <th style="width:25%">credit</th>
                        </tr>
                    </thead>
                <tbody>';
        $totals = array();
        $total_debit = 0;
        $total_credit = 0;
        $Total_Income = 0;
        foreach ($income as $eachAccount) {
            $balance = 0;
            $debit = 0;
            $credit = 0;
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }

            $accountName = $eachAccount['title'];
            if ($eachAccount['amount'] > 0) {
                $debit = $eachAccount['amount'];
                $total_debit += $debit;
            } else {
                $credit = -1 * $eachAccount['amount'];
                $total_credit += $credit;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $acc_id = $eachAccount['id'];
                $table .= '<tr><td colspan="3"><b>' . $space . $accountName . '</b><a onclick="loadPopupModal(\'finance/reports/parentaccountlist&id=' . $acc_id . '&from_date=' . $from_date . '&to_date=' . $to_date . '&outlet=' . $outlet . '\',\'Parent Accounts Total\',\'ls\')"><i class="fa fa-plus"></i></a></td></tr>';
            } else {
                if ($eachAccount['id'] == 10005) {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $Total_Expense += $balance;
                    $accountName = 'Cost of Sale';

                    if ($balance > 0) {
                        $debit = abs($balance);
                        $credit = 0;
                        //                        $total_debit+=abs($balance);   
                    } else {
                        $credit = abs($balance);
                        $debit = 0;
                        //                        $total_credit+=abs($balance);   
                    }
                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                } else if ($eachAccount['id'] == 4114) {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $Total_Expense += $balance;
                    $accountName = 'Damage/stock clearing/expiry';

                    if ($balance > 0) {
                        $debit = abs($balance);
                        $credit = 0;
                        //                        $total_debit+=abs($balance);   
                    } else {
                        $credit = abs($balance);
                        $debit = 0;
                        //                        $total_credit+=abs($balance);   
                    }
                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                } else if ($eachAccount['id'] == 10020) {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS stock 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $goods_issue = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $Total_Income += - ($balance + $goods_issue);
                    $accountName = 'Current Stock';

                    $purchase = Yii::app()->db->createCommand('SELECT SUM(amount) AS purchase 
                FROM erp_finance_voucher_items AS I INNER JOIN erp_finance_voucher_head AS H ON I.header_id=H.id WHERE ledger_id=10005 AND voucher_date <= "' . $to_date . '"  ' . $purchase_conditions)->queryScalar();
                    $Total_Income += ($purchase + $goods_receipt);

                    //                        $table .= '<tr>
                    //                                            <td>' . $space.$accountName . '</td>
                    //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(($purchase+$goods_receipt-$balance-$goods_issue), " ") . '</td>
                    //                                        </tr>';
                    $current_stock = ($purchase + $goods_receipt - $balance - $goods_issue);
                    if ($current_stock > 0) {
                        $debit = abs($current_stock);
                        $credit = 0;
                        //                        $total_debit+=abs($current_stock);   
                    } else {
                        $credit = abs($current_stock);
                        $debit = 0;
                        //                        $total_credit+=abs($current_stock);   
                    }
                    $total_debit += abs($current_stock);
                    $total_credit += abs($current_stock);
                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                    $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $accountName = "Goods Receipt";
                    if ($goods_receipt > 0) {
                        $debit = abs($goods_receipt);
                        $credit = 0;
                        //                        $total_debit+=abs($goods_receipt);   
                    } else {
                        $credit = abs($goods_receipt);
                        $debit = 0;
                        //                        $total_credit+=abs($goods_receipt);   
                    }

                    $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                } else {
                   // if ($debit != 0 || $credit != 0) { commented to ge all ledgers
                        $table .= '<tr>
                                            <td>' . $space . $accountName . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($debit, " ") . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($credit, " ") . '</td>
                                        </tr>';
                   // }
                }
            }
        }

        $pl_condition = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date <= "' . $to_date . '"';

        $pl_income_balance = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="I")')->queryScalar();
        $pl_expense_balance = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="E")')->queryScalar();
        $pl_pre_balance = (float)$pl_income_balance + (float)$pl_expense_balance;

        $pl_condition_old = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date < "' . $from_date . '"';
        $pl_income_balance_old = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition_old . ' AND (A.main_account_type="I")')->queryScalar();
        $pl_expense_balance_old = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition_old . ' AND (A.main_account_type="E")')->queryScalar();
        $goods_receipt_opening_old = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();
        $cost_of_sale_old = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();
        $goods_issue_damage_old = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();

        $profit_and_loss_old = $pl_income_balance_old - $goods_receipt_opening_old + $pl_expense_balance_old + $cost_of_sale_old + $goods_issue_damage_old;

        $accountName = 'Accumulated P&L';

        if ($pl_pre_balance > 0) {
            $total_debit += abs($pl_pre_balance);
        } else {
            $total_credit += abs($pl_pre_balance);
        }

        if ($profit_and_loss_old > 0) {
            //        $table .= '<tr>
            //                                            <td>' . $space. $accountName . '</td>
            //                                            <td style="text-align:right !important;" >'.$pl_income_balance_old.'/'.$goods_receipt_opening_old.'/'.$pl_expense_balance_old.'/'.$cost_of_sale_old.'/'.$goods_issue_damage_old.Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
            //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(abs($profit_and_loss_old), " ") . '</td>
            //                                        </tr>';   
        } else {
            //        $table .= '<tr>
            //                                            <td>' . $space. $accountName . '</td>
            //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(abs($profit_and_loss_old), " ") . '</td>
            //                                            <td style="text-align:right !important;" >'.$pl_income_balance_old.'/'.$goods_receipt_opening_old.'/'.$pl_expense_balance_old.'/'.$cost_of_sale_old.'/'.$goods_issue_damage_old. Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
            //                                        </tr>';    
        }
        $pl_condition = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date >= "' . $from_date . '" AND H.voucher_date <= "' . $to_date . '"';

        $pl_income_balance1 = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="I")')->queryScalar();
        $pl_expense_balance1 = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="E")')->queryScalar();
        $pl_balance = $pl_expense_balance1 + $pl_income_balance1;

        $goods_receipt_opening = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
        $cost_of_sale = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
        $goods_issue_damage = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();

        $profit_and_loss = $pl_income_balance1 - $goods_receipt_opening - $pl_expense_balance1 + $cost_of_sale + $goods_issue_damage;
        $accountName = 'Current P&L';
        if ($profit_and_loss > 0) {
            //        $table .= '<tr>
            //                                            <td>' . $space. $accountName . '</td>
            //                                            <td style="text-align:right !important;" >'.$pl_balance.'/'.$pl_income_balance1.'/'.$goods_receipt_opening.'/'.$pl_expense_balance1.'/'.$cost_of_sale.'/'.$goods_issue_damage.Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
            //                                            <td style="text-align:right !important;" >' . Yii::app()->numberFormatter->formatCurrency(abs($profit_and_loss), " ") . '</td>
            //                                        </tr>';    
        } else {
            //        $table .= '<tr>
            //                                            <td>' . $space. $accountName . '</td>
            //                                            <td style="text-align:right !important;" >'.Yii::app()->numberFormatter->formatCurrency(abs($profit_and_loss), " ") . '</td>
            //                                            <td style="text-align:right !important;" >'.$pl_balance.'/'.$pl_income_balance1.'/'.$goods_receipt_opening.'/'.$pl_expense_balance1.'/'.$cost_of_sale.'/'.$goods_issue_damage.Yii::app()->numberFormatter->formatCurrency(0, " ") . '</td>
            //                                        </tr>';   
        }

        if ($pl_balance > 0) {
            $total_credit += abs($pl_balance);
        } else {
            $total_debit += abs($pl_balance);
        }

        $table .= '<tr>
                                <td style="color:#1F67B2;text-align:right !important;" class="text-right"><b>Total  </b></td>
                                <td style="color:#1F67B2;text-align:right !important;" class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_debit), " ") . '</b></td>
                                    <td style="color:#1F67B2;text-align:right !important;" class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency(abs($total_credit), " ") . '</b></td>
                            </tr>';

        $table .= '</tbody>
                </table>';

        $param = array('table' => $table, 'from_date' => date('d/m/Y', strtotime($from_date)), 'to_date' => date('d/m/Y', strtotime($to_date)));
        $mpdf = Yii::app()->ePdf->mpdf('', 'A4');
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $mpdf->WriteHTML($this->renderPartial('pdf_tb_report', $param, true));
        $mpdf->Output("trialbalance" . date("d-m-Y") . ".pdf", 'I');
    }


    public function actionVat_new_pdf()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = (int) $_REQUEST['outlet'];
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="A" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));

        function generateUrl($parentModel)
        {
            $url = '#';
            $code = $parentModel->vtype->code;
            if ($code == 'SI') {
                $headModel = $parentModel->vtype->header_table;
                $vat_field = $parentModel->vtype->vat_value;
                $tax = $headModel::model()->findBypk($parentModel->header_table_id)->$vat_field;
                $taxType = ($tax > 0) ? 'tax' : 'taxnil';
                $url = "window.open($('#liveSite').val()+'index.php?r=invoice/PrintInvoiceReportPDF&id=" . $parentModel->header_table_id . "&frm=" . $taxType . "', '_blank');";
            } else if ($code == 'PI') {
                $url = "window.open($('#liveSite').val()+'index.php?r=purchaseinvoice/PrintInvoiceReportPDF&id=" . $parentModel->header_table_id . "', '_blank');";
            } else if ($code == 'DN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=debitnote/printfile&id=" . $parentModel->header_table_id . "', '_blank');";
            } else if ($code == 'CN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=creditnote/printfile&id=" . $parentModel->header_table_id . "', '_blank');";
            } else {
                $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $parentModel->id . "', '_blank');";
            }
            return $url;
        }

        function getSymbol($value, $reverse)
        {
            if (!$reverse) {
                $result = ($value <= 0) ? '' : '(-)';
            } else {
                $result = ($value < 0) ? '(-)' : '';
            }

            return $result;
        }

        function getVendor($code, $header_id)
        {
            return $code == 'PI' || $code == 'DN' ? FinanceVoucherItems::model()->find(array('condition' => 'ledger_id=' . FinanceSystemAccountsMapping::getSystemdefault('creditors') . ' AND header_id=' . $header_id))->subledger->description : 'N/A';
        }

        $table = '<br><table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="6">VAT on Sales (Outwards)</th>
                        </tr>
                        <tr>
                            <th style="width:5%">Date</th>
                            <th style="width:8%">Voucher No</th>
                            <th style="width:8%">Voucher Ref</th>
                            <th style="width:20%">Customer</th>
                            <th style="width:15%">Taxable Amount</th>
                            <th style="width:15%">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';

        $total_amount = 0;
        $total_vat = 0;
        foreach ($items as $each) {
            if ($each->parent->vtype->code == 'SI' || $each->parent->vtype->code == 'CN') {
                $vat = -1 * round(($each->amount * $each->exchange_rate), 4);
                $total = -1 * $each->get_sales_value();
                $table .= '<tr>
                                            <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                                            <td>' . $each->parent->fullvoucher . '</td>
                                            <td>' . $each->parent->reference_no . '</td>
                                            <td><small>' . $each->get_any_subledger() . '</small></td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                        </tr>';

                $total_amount += $total;
                $total_vat += $vat;
            }
        }

        $table .= '<tr>
                                    <td colspan="4" style="text-align:right !important;"><b>Total VAT (' . FinanceLegder::baseCurrency() . ')</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat, " ") . '</b></td>
                                </tr>';
        $table .= '</tbody>
                        </table>';
        // Start Other Income
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="A" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));
        $table .= '<br><table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="7">VAT on Other Income</th>
                        </tr>
                        <tr>
                            <th style="width:5%">Date</th>
                            <th style="width:8%">Voucher No</th>
                            <th style="width:8%">Voucher Ref</th>
                            <th style="width:20%">Customer</th>
                            <th style="width:20%">Narration</th>
                            <th style="width:15%">Taxable Amount</th>
                            <th style="width:15%">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';

        $total_amount_income = 0;
        $total_vat_income = 0;
        foreach ($items as $each) {
            if ($each->parent->vtype->code != 'SI' && $each->parent->vtype->code != 'CN') {
                $model = FinanceVoucherHead::model()->findBypk($each->parent->id);
                $vat = round(-1 * ($each->amount * $each->exchange_rate), 4);
                if ($vat > 0) {
                    $total = ($model->debit_total - $vat);
                } else {
                    $total = -1 * ($model->debit_total + $vat);
                }
                $vat = $vat;
                $table .= '<tr>
                                            <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                                            <td>' . $each->parent->fullvoucher . '</td>
                                            <td>' . $each->parent->reference_no . '</td>
                                            <td><small>' . $each->get_any_subledger() . '</small></td>
                                            <td><small>' . $each->narration . '</small></td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                        </tr>';
                $total_amount_income += $total;
                $total_vat_income += $vat;
            }
        }

        $table .= '<tr>
                                    <td colspan="5" style="text-align:right !important;"><b>Total VAT (' . FinanceLegder::baseCurrency() . ')</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount_income, " ") . '</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat_income, " ") . '</b></td>
                                </tr>';
        $table .= '</tbody>
                        </table>';
        // End Other Income
        // Start  Purchase Expenses
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="L" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));
        $table .= '<br><table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="7">VAT on Purchases</th>
                        </tr>
                        <tr>
                            <th style="width:5%">Date</th>
                            <th style="width:8%">Voucher No</th>
                            <th style="width:8%">Voucher Ref</th>
                            <th style="width:20%">Subledger</th>
                            <th style="width:20%">Narration</th>
                            <th style="width:15%">Voucher Amount</th>
                            <th style="width:15%">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';
        $total_amount = 0;
        $total_vat_purchase = 0;
        foreach ($items as $each) {
            if ($each->parent->vtype->code == 'PI' || $each->parent->vtype->code == 'DN') {
                $vat = round(($each->amount * $each->exchange_rate), 4);
                $total = $each->get_purchase_value();
                $table .= '<tr>
                                            <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                                            <td>' . $each->parent->fullvoucher . '</td>
                                            <td>' . $each->parent->reference_no . '</td>
                                            <td><small>' . $each->get_any_subledger() . '</small></td>
                                            <td><small>' . $each->narration . '</small></td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                        </tr>';

                $total_amount += $total;
                $total_vat_purchase += $vat;
            }
        }

        $table .= '<tr>
                                    <td colspan="5" style="text-align:right !important;"><b>Total VAT (' . FinanceLegder::baseCurrency() . ')</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat_purchase, " ") . '</b></td>
                                </tr>';
        $table .= '</tbody>
                        </table>';
        //End Purchase Expenses
        // Start  Vat on Expenses
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="L" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));
        $table .= '<br><table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="7">VAT on Expense</th>
                        </tr>
                        <tr>
                            <th style="width:5%">Date</th>
                            <th style="width:8%">Voucher No</th>
                            <th style="width:8%">Voucher Ref</th>
                            <th style="width:20%">Subledger</th>
                            <th style="width:20%">Narration</th>
                            <th style="width:15%">Voucher Amount</th>
                            <th style="width:15%">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';
        $total_amount = 0;
        $total_vat_exp = 0;
        foreach ($items as $each) {
            if ($each->parent->vtype->code != 'PI' && $each->parent->vtype->code != 'DN') {
                $vat = round(($each->amount * $each->exchange_rate), 4);

                $total = ($each->parent->debit_total - $vat);

                if ($total > $vat) {
                    if ($vat < 0) {
                        $total = -1 * ($total + (2 * $vat));
                    }
                    $table .= '<tr>
                                            <td>' . date("d/m/Y", strtotime($each->parent->voucher_date)) . '</td>
                                            <td>' . $each->parent->fullvoucher . '</td>
                                            <td>' . $each->parent->reference_no . '</td>
                                            <td><small>' . $each->get_any_subledger() . '</small></td>
                                            <td><small>' . $each->narration . '</small></td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                        </tr>';

                    $total_amount += $total;
                    $total_vat_exp += $vat;
                }
            }
        }

        $table .= '<tr>
                                    <td colspan="5" style="text-align:right !important;"><b>Total VAT (' . FinanceLegder::baseCurrency() . ')</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat_exp, " ") . '</b></td>
                                </tr>';
        //End Vat On Expenses
        $payable = $total_vat + $total_vat_income - $total_vat_purchase - $total_vat_exp;
        $table .= '<tr>
                                    <td colspan="6" style="text-align:right !important;"><b> VAT Payable(' . FinanceLegder::baseCurrency() . ')</b></td>
                                    <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($payable, " ") . '</b></td>
                                </tr>';
        $table .= '</tbody>
                        </table>';

        $param = array(
            'from_date' => $from_date,
            'to_date' => $to_date,
            'table' => $table,
        );

        $mode = 'A4';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'pdf_vat_new_report';
        $mpdf->WriteHTML($this->renderPartial($view, $param, true));
        $mpdf->Output("vat_report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionVat_return_new_pdf()
    {
        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = (int) $_REQUEST['outlet'];
        $condition = '(t.invoice_date>="' . $from_date . '" AND t.invoice_date<="' . $to_date . '") AND t.active="Y"';
        if ($outlet > 0) {
            $condition .= ' AND outlet="' . $outlet . '"';
        }
        $sales_view_sql = 'CREATE OR REPLACE VIEW view_net_sale_report AS (SELECT "I" as type,I.id,I.customer_id,I.invoice_no,I.invoice_date,C.customer_name,I.exchange_rate,I.total_amount,0 AS total_amount1,I.grand_total,0 AS grand_total1,I.tax_total,0 AS tax_total1,I.outlet,I.active,C.state
              FROM  {{sales_invoice}} I
              LEFT JOIN  {{customer}} C
              ON C.id=I.customer_id
              )
              UNION ALL
              (SELECT "CN" as type,CN.id,CN.customer_id,CN.return_no AS invoice_no,CN.return_date AS invoice_date,C.customer_name,CN.exchange_rate,0 AS total_amount,(CN.total_amount) AS total_amount1,0 AS grand_total,(CN.grand_total) AS grand_total1,0 AS tax_total,(CN.tax_total) AS tax_total1,CN.outlet,CN.active,C.state 
              FROM  {{sales_return}} CN
              LEFT JOIN  {{customer}} C
              ON C.id=CN.customer_id)';
        Yii::app()->db->createCommand($sales_view_sql)->execute();
        $sales_sql = 'SELECT S.state_name,t.state,SUM(grand_total-grand_total1) AS grand,SUM(total_amount-total_amount1) AS tot,SUM(tax_total-tax_total1) AS vat FROM view_net_sale_report t INNER JOIN erp_master_state S ON t.state=S.id WHERE ' . $condition . ' GROUP BY state ORDER BY S.state_name ASC';

        $table = '<br><table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="3">VAT on Sales (Outwards)</th>
                        </tr>
                        <tr>
                            <th style="width:8%">Emirate</th>
                            <th style="width:15%">Taxable Amount</th>
                            <th style="width:15%">VAT (' . FinanceLegder::baseCurrency() . ')</th>
                        </tr>
                    </thead>
                    <tbody>';

        $total_amount = 0;
        $total_vat = 0;
        $items = Yii::app()->db->createCommand($sales_sql)->queryAll();
        foreach ($items as $each) {
            $vat = round($each['vat'], 4);
            $tot = round($each['tot'], 4);
            if ($each['state'] > 0) {
                $emirate = $each['state_name'];
            }
            $table .= '<tr>
                                            <td>' . $emirate . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($tot, " ") . '</td>
                                            <td style="text-align:right !important;" class="text-right">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                        </tr>';

            $total_amount += $tot;
            $total_vat += $vat;
        }
        $table .= '<tr>
                                            <td style="text-align:right !important;" class="text-right"><b>TOTAL</b></td>
                                            <td style="text-align:right !important;" class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                            <td style="text-align:right !important;" class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat, " ") . '</b></td>
                                        </tr>';
        // Start Other Income

        $vat_sales_account = FinanceSystemAccountsMapping::getSystemdefault('sales_vat');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id = VH.voucher_type
                        WHERE VT.code!="SI" AND VT.code!="CN" AND L.main_account_type="A" AND L.id="' . $vat_sales_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_other_income = -1 * Yii::app()->db->createCommand($query)->queryScalar();
        $table .= '<tr><td colspan="2" style="text-align:right !important;"><b>VAT ON OTHER INCOME</b></td>
                                <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(($vat_on_other_income), " ") . '</b></td></tr>';

        // End Other Income
        $purchase_view_sql = 'CREATE OR REPLACE VIEW view_net_purchase_report AS (SELECT "I" as type,I.id,I.invoice_date,I.exchange_rate,I.total_amount,0 AS total_amount1,I.grand_total,0 AS grand_total1,I.tax_total,0 AS tax_total1,I.outlet,I.active
              FROM  {{purchase_invoice}} I
              )
              UNION ALL
              (SELECT "CN" as type,CN.id,CN.return_date AS invoice_date,CN.exchange_rate,0 AS total_amount,(CN.total_amount) AS total_amount1,0 AS grand_total,(CN.grand_total) AS grand_total1,0 AS tax_total,(CN.tax_total) AS tax_total1,CN.outlet,CN.active
              FROM  {{purchase_return}} CN)';
        Yii::app()->db->createCommand($purchase_view_sql)->execute();
        $purchase_vat = Yii::app()->db->createCommand('SELECT SUM(tax_total-tax_total1) AS vat FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();

        $table .= '<tr>
                                            <td colspan="2" style="text-align:right !important;" class="text-right"><b>VAT ON PURCHASE</b></td>
                                            <td style="text-align:right !important;" class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency($purchase_vat, " ") . '</b></td>
                                        </tr>';
        $vat_account = FinanceSystemAccountsMapping::getSystemdefault('vat_on_expense');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        WHERE L.main_account_type="L" AND L.id="' . $vat_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_expense = Yii::app()->db->createCommand($query)->queryScalar();
        $vat_purchase_account = FinanceSystemAccountsMapping::getSystemdefault('purchase_vat');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id = VH.voucher_type
                        WHERE VT.code!="PI" AND VT.code!="DN" AND L.main_account_type="L" AND L.id="' . $vat_purchase_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_other_expense = Yii::app()->db->createCommand($query)->queryScalar();
        $table .= '<tr>
                                            <td colspan="2" style="text-align:right !important;" class="text-right"><b>VAT ON EXPENSE</b></td>
                                            <td style="text-align:right !important;" class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency(($vat_on_expense + $vat_on_other_expense), " ") . '</b></td>
                                        </tr>';
        $table .= '<tr>
                                            <td colspan="2" style="text-align:right !important;" class="text-right"><b>VAT PAYABLE</b></td>
                                            <td style="text-align:right !important;" class="text-right"><b>' . Yii::app()->numberFormatter->formatCurrency(($total_vat + $vat_on_other_income - $vat_on_expense - $vat_on_other_expense - $purchase_vat), " ") . '</b></td>
                                        </tr>';
        $table .= '</tbody>
                        </table>';

        $param = array(
            'from_date' => $from_date,
            'to_date' => $to_date,
            'table' => $table,
        );

        $mode = 'A4';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'pdf_vat_return_new_report';
        $mpdf->WriteHTML($this->renderPartial($view, $param, true));
        $mpdf->Output("vat_report" . date("d-m-Y") . ".pdf", 'I');
    }
    public function actionTb_new_excel()
    {

        Yii::import('ext.PHPExcel.PHPExcel');

        $brand = (int) $_REQUEST['brand'];
        $outlet = (int) $_REQUEST['outlet'];
        $costcenter = (int) $_REQUEST['costcenter'];
        $from_date = (count(explode('/', $_REQUEST['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to_date']))) : date('Y-m-d');
        $condition = 'H.is_posted="Y" AND H.voucher_date >= "' . $from_date . '" AND H.voucher_date <= "' . $to_date . '"';
        $bs_condition = 'H.is_posted="Y" AND H.voucher_date <= "' . $to_date . '"';
        if ($outlet > 0) {
            $condition .= ' AND I.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
            $purchase_conditions .= ' AND I.outlet=' . $outlet;
            $bs_condition .= ' AND I.outlet=' . $outlet;
        }
        if ($costcenter > 0) {
            $condition .= ' AND H.costcenter=' . $costcenter;
            $purchase_conditions .= ' AND H.costcenter=' . $costcenter;
            $bs_condition .= ' AND H.costcenter=' . $costcenter;
        }

        $time = strtotime($end_date);
        $year = date("Y", $time);


        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT I.ledger_id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $bs_condition . ' AND (A.main_account_type="A" OR A.main_account_type="L") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT I.ledger_id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $condition . ' AND (A.main_account_type="I" OR A.main_account_type="E")  group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}})')->execute();
        $SQL = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $income = Yii::app()->db->createCommand($SQL)->queryAll();

        // Create new PHPExcel object
        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Trial Balance Report")
            ->setSubject("Trial Balance Report")
            ->setDescription("Trial Balance Report Generated on " . date('d/m/Y'))
            ->setKeywords("Trial Balance Report")
            ->setCategory("Financial Report");

        // Add some data
        $settings = MasCompany::model()->findByPk(Yii::app()->user->company_id);
        $excel->getActiveSheet()->getStyle('A1:C1')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A1:C1');
        $excel->getActiveSheet(0)
            ->setCellValue('A1', $settings->name);

        // $excel->getActiveSheet()->getStyle('A2:H2')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A2:C2');
        $excel->getActiveSheet(0)
            ->setCellValue('A2', $settings->billing_address);

        // $excel->getActiveSheet()->getStyle('A3:H3')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A3:C3');
        $excel->getActiveSheet(0)
            ->setCellValue('A3', '');

        $excel->setActiveSheetIndex(0)->mergeCells('A4:C4');

        // $excel->getActiveSheet()->getStyle('A4:H4')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A5:C5');
        $excel->getActiveSheet(0)
            ->setCellValue('A5', 'TRN : ' . $settings->trn_no);

        $excel->getActiveSheet()->getStyle('A6:C6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A6:C6');
        $excel->getActiveSheet(0)
            ->setCellValue('A6', $title);

        $date_title = date("d-m-Y", strtotime($from_date)) . ' TO ' . date("d-m-Y", strtotime($to_date));
        // $excel->getActiveSheet()->getStyle('A6:H6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A7:C7');
        $excel->getActiveSheet(0)
            ->setCellValue('A7', $date_title);
        $excel->setActiveSheetIndex(0)->mergeCells('A8:C8');
        $currency1 = 'Currency : AED';
        $excel->getActiveSheet(0)
            ->setCellValue('A8', $currency1);
        $excel->setActiveSheetIndex(0)->mergeCells('A9:C9');

        $parent = 1;
        $excel->getActiveSheet()->getStyle('A10:C10')->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)
            ->setCellValue('A10', 'Accounts')
            ->setCellValue('B10', 'Debit')
            ->setCellValue('C10', 'Credit');

        $row_no = 11;
        $totals = array();
        $total_debit = 0;
        $total_credit = 0;
        $Total_Income = 0;

        foreach ($income as $eachAccount) {
            $balance = 0;
            $debit = 0;
            $credit = 0;
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }

            $accountName = $eachAccount['title'];
            if ($eachAccount['amount'] > 0) {
                $debit = $eachAccount['amount'];
                $total_debit += $debit;
            } else {
                $credit = -1 * $eachAccount['amount'];
                $total_credit += $credit;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $acc_id = $eachAccount['id'];
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':C' . $row_no);
                $row_no++;
            } else {
                if ($eachAccount['id'] == 10005) {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $Total_Expense += $balance;
                    $accountName = 'Cost of Sale';

                    if ($balance > 0) {
                        $debit = abs($balance);
                        $credit = 0;
                    } else {
                        $credit = abs($balance);
                        $debit = 0;
                    }
                    $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                    $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency($debit, " "));
                    $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                    $row_no++;
                } else if ($eachAccount['id'] == 4114) {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $Total_Expense += $balance;
                    $accountName = 'Damage/stock clearing/expiry';

                    if ($balance > 0) {
                        $debit = abs($balance);
                        $credit = 0;
                    } else {
                        $credit = abs($balance);
                        $debit = 0;
                    }

                    $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                    $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency($debit, " "));
                    $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                    $row_no++;
                } else if ($eachAccount['id'] == 10020) {
                    $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS stock 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $goods_issue = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date <= "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $Total_Income += - ($balance + $goods_issue);
                    $accountName = 'Current Stock';

                    $purchase = Yii::app()->db->createCommand('SELECT SUM(amount) AS purchase 
                FROM erp_finance_voucher_items AS I INNER JOIN erp_finance_voucher_head AS H ON I.header_id=H.id WHERE ledger_id=10005 AND voucher_date <= "' . $to_date . '"  ' . $purchase_conditions)->queryScalar();
                    $Total_Income += ($purchase + $goods_receipt);

                    $current_stock = ($purchase + $goods_receipt - $balance - $goods_issue);
                    if ($current_stock > 0) {
                        $debit = abs($current_stock);
                        $credit = 0;
                    } else {
                        $credit = abs($current_stock);
                        $debit = 0;
                    }
                    $total_debit += abs($current_stock);
                    $total_credit += abs($current_stock);
                    $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                    $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency($debit, " "));
                    $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                    $row_no++;

                    $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                    $accountName = "Goods Receipt";
                    if ($goods_receipt > 0) {
                        $debit = abs($goods_receipt);
                        $credit = 0;
                    } else {
                        $credit = abs($goods_receipt);
                        $debit = 0;
                    }

                    $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                    $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency($debit, " "));
                    $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                    $row_no++;
                } else {
                   // if ($debit != 0 || $credit != 0) { commented to ge all ledgers
                        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency($debit, " "));
                        $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency($credit, " "));
                        $row_no++;
                   // }
                }
            }
        }


        $pl_condition = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date <= "' . $to_date . '"';
        $pl_income_balance = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="I")')->queryScalar();
        $pl_expense_balance = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="E")')->queryScalar();
        $pl_pre_balance = (float)$pl_income_balance + (float)$pl_expense_balance;
        $pl_condition_old = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date < "' . $from_date . '"';
        $pl_income_balance_old = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition_old . ' AND (A.main_account_type="I")')->queryScalar();
        $pl_expense_balance_old = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition_old . ' AND (A.main_account_type="E")')->queryScalar();
        $goods_receipt_opening_old = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();
        $cost_of_sale_old = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();
        $goods_issue_damage_old = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue FROM temp_cost_stock_tbl  WHERE date <"' . $from_date . '"  ' . $conditions)->queryScalar();

        $profit_and_loss_old = $pl_income_balance_old - $goods_receipt_opening_old + $pl_expense_balance_old + $cost_of_sale_old + $goods_issue_damage_old;

        $accountName = 'Accumulated P&L';

        if ($pl_pre_balance > 0) {
            $total_debit += abs($pl_pre_balance);
        } else {
            $total_credit += abs($pl_pre_balance);
        }
        $pl_condition = 'H.is_posted="Y" AND I.outlet=' . $outlet . ' AND H.voucher_date >= "' . $from_date . '" AND H.voucher_date <= "' . $to_date . '"';

        $pl_income_balance1 = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="I")')->queryScalar();
        $pl_expense_balance1 = Yii::app()->db->createCommand('SELECT SUM(I.amount) AS amt  FROM {{finance_legder}} as A left join  {{finance_voucher_items}} as I on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $pl_condition . ' AND (A.main_account_type="E")')->queryScalar();
        $pl_balance = $pl_expense_balance1 + $pl_income_balance1;

        $goods_receipt_opening = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
        $cost_of_sale = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
        $goods_issue_damage = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();

        $profit_and_loss = $pl_income_balance1 - $goods_receipt_opening - $pl_expense_balance1 + $cost_of_sale + $goods_issue_damage;
        $accountName = 'Current P&L';

        if ($pl_balance > 0) {
            $total_credit += abs($pl_balance);
        } else {
            $total_debit += abs($pl_balance);
        }
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':C' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet()->getStyle('B11:B' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->getActiveSheet()->getStyle('C11:C' . $row_no)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Total');
        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency($total_debit, " "));
        $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency($total_credit, " "));
        $row_no++;

        // Rename worksheet
        $excel->getActiveSheet()->setTitle('TRIAL BALANCE');

        $styleArray = array(
            'borders' => array(
                'allborders' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        $excel->getActiveSheet(0)->getStyle('A1:C' . $parent)->applyFromArray($styleArray);

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="trial_balance.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionBs_new_excel()
    {
        Yii::import('ext.PHPExcel.PHPExcel');
        $brand = (int) $_REQUEST['brand'];
        $outlet = (int) $_REQUEST['outlet'];
        $costcenter = (int) $_REQUEST['costcenter'];
        $from_date = '2019-01-01';
        $to_date = (count(explode('/', $_REQUEST['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to_date']))) : date('Y-m-d');
        $condition = 'H.is_posted="Y" AND H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';

        if ($outlet > 0) {
            $condition .= ' AND I.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
            $purchase_conditions .= ' AND I.outlet=' . $outlet;
        }
        if ($costcenter > 0) {
            $condition .= ' AND H.costcenter=' . $costcenter;
            $purchase_conditions .= ' AND H.costcenter=' . $costcenter;
        }

        $time = strtotime($end_date);
        $year = date("Y", $time);
        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $condition . '   AND ( A.main_account_type="A") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (select id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='A')")->execute();
        $SQL = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $income = Yii::app()->db->createCommand($SQL)->queryAll();

        // Create new PHPExcel object
        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Balance Sheet Report")
            ->setSubject("Balance Sheet Report")
            ->setDescription("Balance Sheet Report Generated on " . date('d/m/Y'))
            ->setKeywords("Balance Sheet Report")
            ->setCategory("Financial Report");

        // Add some data
        $settings = MasCompany::model()->findByPk(Yii::app()->user->company_id);
        $excel->getActiveSheet()->getStyle('A1:B1')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A1:B1');
        $excel->getActiveSheet(0)
            ->setCellValue('A1', $settings->name);

        // $excel->getActiveSheet()->getStyle('A2:H2')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A2:B2');
        $excel->getActiveSheet(0)
            ->setCellValue('A2', $settings->billing_address);

        // $excel->getActiveSheet()->getStyle('A3:H3')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A3:B3');
        $excel->getActiveSheet(0)
            ->setCellValue('A3', '');

        $excel->setActiveSheetIndex(0)->mergeCells('A4:B4');

        // $excel->getActiveSheet()->getStyle('A4:H4')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A5:B5');
        $excel->getActiveSheet(0)
            ->setCellValue('A5', 'TRN : ' . $settings->trn_no);

        $excel->getActiveSheet()->getStyle('A6:B6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A6:B6');
        $excel->getActiveSheet(0)
            ->setCellValue('A6', $title);

        $date_title = 'AS ON ' . date("d-m-Y", strtotime($to_date));
        // $excel->getActiveSheet()->getStyle('A6:H6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A7:B7');
        $excel->getActiveSheet(0)
            ->setCellValue('A7', $date_title);
        $excel->setActiveSheetIndex(0)->mergeCells('A8:B8');
        $currency1 = 'Currency : AED';
        $excel->getActiveSheet(0)
            ->setCellValue('A8', $currency1);
        $excel->setActiveSheetIndex(0)->mergeCells('A9:B9');

        $parent = 1;
        $excel->getActiveSheet()->getStyle('A10:B10')->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)
            ->setCellValue('A10', 'Accounts')
            ->setCellValue('B10', 'Amount');

        $row_no = 11;
        $totals = array();
        $total_debit = 0;
        $total_credit = 0;
        $Total_Income = 0;

        $totals = array();
        $totalDirectincome = 0;
        $totalDirectexpense = 0;
        $totalIndirectincome = 0;
        $totalIndirectexpense = 0;
        //level - 2
        $Total_Income = 0;
        foreach ($income as $eachAccount) {
            $balance = 0;
            $accountName = $eachAccount['title'];
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '   ';
                    break;
                case 2:
                    $space = '      ';
                    break;
                case 3:
                    $space = '         ';
                    break;
                case 4:
                    $space = '            ';
                    break;
                case 5:
                    $space = '               ';
                    break;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $excel->getActiveSheet()->getStyle('A' . $row_no)->getFont()->setBold(true)->setSize(12);
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $space . $accountName);
                $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':B' . $row_no);
                $row_no++;
            } else {
                if ($eachAccount['amount'] != 0) {
                    $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $space . $accountName);
                    $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(($eachAccount['amount']), " "));
                    $row_no++;
                }
            }
            $Total_Income += ($eachAccount['amount']);
            if ($eachAccount['id'] == 10020) {
                $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS stock 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $goods_issue = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $Total_Income += - ($balance + $goods_issue);
                $accountName = 'Current Stock';

                $purchase = Yii::app()->db->createCommand('SELECT SUM(amount) AS purchase 
                FROM erp_finance_voucher_items AS I INNER JOIN erp_finance_voucher_head AS H ON I.header_id=H.id WHERE ledger_id=10005 AND voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $purchase_conditions)->queryScalar();
                $Total_Income += ($purchase + $goods_receipt);

                $excel->getActiveSheet()->getStyle('A' . $row_no)->getFont()->setBold(true)->setSize(12);
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(($purchase + $goods_receipt - $balance - $goods_issue), " "));
                $row_no++;
            }
        }

        $excel->getActiveSheet()->getStyle('A' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Total Asset');
        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(($Total_Income), " "));
        $row_no++;
        //direct expense

        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE ' . $condition . ' AND ( A.main_account_type="L") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (select id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='L')")->execute();
        $SQL1 = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $expenses = Yii::app()->db->createCommand($SQL1)->queryAll();
        $Total_Expense = 0;
        foreach ($expenses as $eachAccount) {
            $balance = 0;
            $accountName = $eachAccount['title'];
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '   ';
                    break;
                case 2:
                    $space = '      ';
                    break;
                case 3:
                    $space = '         ';
                    break;
                case 4:
                    $space = '            ';
                    break;
                case 5:
                    $space = '               ';
                    break;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $excel->getActiveSheet()->getStyle('A' . $row_no)->getFont()->setBold(true)->setSize(12);
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $space . $accountName);
                $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':B' . $row_no);
                $row_no++;
            } else {
              //  if ($eachAccount['amount'] != 0) {  commented to get all ledgers
                    $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $space . $accountName);
                    $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(-1 * ($eachAccount['amount']), " "));
                    $row_no++;
                    //                            $excel->setActiveSheetIndex(0)->setCellValue('A'.$row_no, $accountName);
                    //                            $excel->setActiveSheetIndex(0)->setCellValue('B'.$row_no, Yii::app()->numberFormatter->formatCurrency(-1*($purchase+$goods_receipt-$balance-$goods_issue), " "));
                    //                            $row_no++;   
              //  }
            }
            $Total_Expense += (-1 * $eachAccount['amount']);
        }
        $excel->getActiveSheet()->getStyle('A' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Total Liability');
        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($Total_Expense), " "));
        $row_no++;

        $netProfit = $Total_Income - $Total_Expense;
        if ($netProfit > 0) {
            $excel->getActiveSheet()->getStyle('A' . $row_no)->getFont()->setBold(true)->setSize(12);
            $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Profit');
            $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " "));
            $row_no++;
        } else {
            $excel->getActiveSheet()->getStyle('A' . $row_no)->getFont()->setBold(true)->setSize(12);
            $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Loss');
            $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " "));
            $row_no++;
        }
        $excel->getActiveSheet()->setTitle('BALANCE SHEET');

        $styleArray = array(
            'borders' => array(
                'allborders' => array(
                    'style' => PHPExcel_Style_Border::BORDER_THIN,
                    'color' => array('argb' => '#1E1F20'),
                ),
            ),
        );

        //        $excel->getActiveSheet(0)->getStyle('A1:B' . $parent)->applyFromArray($styleArray);
        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="balance_sheet.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionPl_new_excel()
    {
        Yii::import('ext.PHPExcel.PHPExcel');
        $brand = (int) $_REQUEST['brand'];
        $outlet = (int) $_REQUEST['outlet'];
        $created_user = (int) $_REQUEST['created_user'];
        $costcenter = (int) $_REQUEST['costcenter'];
        $from_date = (count(explode('/', $_REQUEST['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to_date']))) : date('Y-m-d');
        $condition = 'H.is_posted="Y" AND H.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';

        if ($outlet > 0) {
            $condition .= ' AND I.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        if ((int)$created_user > 0) {
            $condition .= ' AND H.created_by=' . $created_user;
            // $conditions .= ' AND created_by=' . $created_user;
        }
        if ((int)$costcenter > 0) {
            $condition .= ' AND H.costcenter=' . $costcenter;
        }

        $time = strtotime($end_date);
        $year = date("Y", $time);
        //echo '(SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  '.$condition.'   AND ( A.main_account_type="I") group by A.id order by A.account_no)';die;
        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE  ' . $condition . '   AND ( A.main_account_type="I") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (SELECT id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='I')")->execute();
        $SQL = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $income = Yii::app()->db->createCommand($SQL)->queryAll();

        // Create new PHPExcel object
        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("Balance Sheet Report")
            ->setSubject("Balance Sheet Report")
            ->setDescription("Balance Sheet Report Generated on " . date('d/m/Y'))
            ->setKeywords("Balance Sheet Report")
            ->setCategory("Financial Report");

        // Add some data
        $settings = MasCompany::model()->findByPk(Yii::app()->user->company_id);
        $excel->getActiveSheet()->getStyle('A1:B1')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A1:B1');
        $excel->getActiveSheet(0)
            ->setCellValue('A1', $settings->name);

        // $excel->getActiveSheet()->getStyle('A2:H2')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A2:B2');
        $excel->getActiveSheet(0)
            ->setCellValue('A2', $settings->billing_address);

        // $excel->getActiveSheet()->getStyle('A3:H3')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A3:B3');
        $excel->getActiveSheet(0)
            ->setCellValue('A3', '');

        $excel->setActiveSheetIndex(0)->mergeCells('A4:B4');

        // $excel->getActiveSheet()->getStyle('A4:H4')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A5:B5');
        $excel->getActiveSheet(0)
            ->setCellValue('A5', 'TRN : ' . $settings->trn_no);

        $excel->getActiveSheet()->getStyle('A6:B6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A6:B6');
        $excel->getActiveSheet(0)
            ->setCellValue('A6', $title);

        $date_title = 'AS ON ' . date("d-m-Y", strtotime($to_date));
        // $excel->getActiveSheet()->getStyle('A6:H6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A7:B7');
        $excel->getActiveSheet(0)
            ->setCellValue('A7', $date_title);
        $excel->setActiveSheetIndex(0)->mergeCells('A8:B8');
        $currency1 = 'Currency : AED';
        $excel->getActiveSheet(0)
            ->setCellValue('A8', $currency1);
        $excel->setActiveSheetIndex(0)->mergeCells('A9:B9');

        $parent = 1;
        $excel->getActiveSheet()->getStyle('A10:B10')->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)
            ->setCellValue('A10', 'Accounts')
            ->setCellValue('B10', 'Amount');

        $row_no = 11;
        $totals = array();
        $total_debit = 0;
        $total_credit = 0;
        $Total_Income = 0;

        $totals = array();
        $totalDirectincome = 0;
        $totalDirectexpense = 0;
        $totalIndirectincome = 0;
        $totalIndirectexpense = 0;
        //level - 2
        $Total_Income = 0;
        $TotalDirectIncome = 0;
        foreach ($income as $eachAccount) {

            $balance = 0;
            $accountName = $eachAccount['title'];
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }
            if ($eachAccount['rollup_account'] == 'Y') {
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':B' . $row_no);
                $row_no++;
            } else {
                if ($eachAccount['amount'] != 0) {
                    $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                    $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency((-1 * $eachAccount['amount']), " "));
                    $row_no++;
                }
            }
            if ($eachAccount['id'] == 11) {
                $TotalDirectIncome += $eachAccount['amount'];
            }
            if ($eachAccount['id'] == 12) {
                $TotalDirectIncome += $eachAccount['amount'];
            }
            if ($eachAccount['id'] == 53) {
                $TotalDirectIncome += $eachAccount['amount'];
            }

            $Total_Income += -1 * ($eachAccount['amount']);
        }

        $goods_receipt = Yii::app()->db->createCommand('SELECT SUM(goods_receipt) AS goods_receipt 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
        $accountName = "Goods Receipt";
        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(($goods_receipt), " "));
        $row_no++;
        $Total_Income += $goods_receipt;
        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($Total_Income), " "));
        $row_no++;
        //direct expense

        Yii::app()->db->createCommand('TRUNCATE TABLE trail_balance_tbl')->execute();
        Yii::app()->db->createCommand('INSERT INTO  trail_balance_tbl (SELECT A.id,A.account_order,0 AS account_open_amount,A.account_no,A.description,A.level,A.main_account_type,A.isParent,sum(I.amount) AS amount FROM {{finance_voucher_items}} as I left join {{finance_legder}} as A on I.ledger_id=A.id left join {{finance_voucher_head}} as H on H.id=I.header_id WHERE ' . $condition . ' AND ( A.main_account_type="E") group by A.id order by A.account_no)')->execute();
        Yii::app()->db->createCommand("INSERT INTO  trail_balance_tbl (select id,account_order,0 AS account_open_amount,account_no,description,level,main_account_type,isParent,0 AS amount FROM {{finance_legder}}  where main_account_type='E')")->execute();
        $SQL1 = "select id,account_sorting_number,account_open_amount,accounting_number,title,stage,type_of_account,rollup_account,sum(amount) AS amount from trail_balance_tbl group by id order by account_sorting_number,accounting_number,title";
        $expenses = Yii::app()->db->createCommand($SQL1)->queryAll();
        $Total_Expense = 0;
        foreach ($expenses as $eachAccount) {

            $balance = 0;
            switch ($eachAccount['stage']) {
                case 1:
                    $space = '&nbsp;&nbsp;&nbsp;';
                    break;
                case 2:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 3:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 4:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
                case 5:
                    $space = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                    break;
            }
            if ($eachAccount['id'] == 10005) {
                $balance = Yii::app()->db->createCommand('SELECT SUM(cost)-SUM(sales_return) AS cost 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $Total_Expense += $balance;
                $accountName = 'Cost of Sale';
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency($balance, " "));
                $row_no++;
            } else if ($eachAccount['id'] == 4114) {
                $balance = Yii::app()->db->createCommand('SELECT SUM(goods_issue) AS goods_issue 
                FROM temp_cost_stock_tbl  WHERE date BETWEEN "' . $from_date . '" AND "' . $to_date . '"  ' . $conditions)->queryScalar();
                $Total_Expense += $balance;
                $accountName = 'Damage/stock clearing/expiry';
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency($balance, " "));
                $row_no++;
            } else {
                $accountName = $eachAccount['title'];
                if ($eachAccount['rollup_account'] == 'Y') {
                    $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                    $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':B' . $row_no);
                    $row_no++;
                } else {
                  //  if ($eachAccount['amount'] != 0) {  commented to get all ledgers
                        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $accountName);
                        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(($eachAccount['amount']), " "));
                        $row_no++;
                  //  }
                }
                $Total_Expense += $eachAccount['amount'];
            }
        }
        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Total Expense');
        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($Total_Expense), " "));
        $row_no++;

        $netProfit = $Total_Income - $Total_Expense;
        if ($netProfit > 0) {
            $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Profit');
            $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " "));
            $row_no++;
        } else {

            $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Loss');
            $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(abs($netProfit), " "));
            $row_no++;
        }

        //        $excel->getActiveSheet(0)->getStyle('A1:B' . $parent)->applyFromArray($styleArray);

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="profit_loss.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }
    public function actionVat_return_new_excel()
    {
        Yii::import('ext.PHPExcel.PHPExcel');


        $from_date = (count(explode('/', $_REQUEST['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to_date']))) : date('Y-m-d');
        $outlet = (int) $_REQUEST['outlet'];
        $year = date("Y", $time);

        // Create new PHPExcel object
        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("VAT Report")
            ->setSubject("VAT Report")
            ->setDescription("VAT Report Generated on " . date('d/m/Y'))
            ->setKeywords("VAT Report")
            ->setCategory("Financial Report");

        // Add some data
        $settings = MasCompany::model()->findByPk(Yii::app()->user->company_id);
        $excel->getActiveSheet()->getStyle('A1:C1')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A1:C1');
        $excel->getActiveSheet(0)
            ->setCellValue('A1', $settings->name);

        // $excel->getActiveSheet()->getStyle('A2:H2')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A2:C2');
        $excel->getActiveSheet(0)
            ->setCellValue('A2', $settings->billing_address);

        // $excel->getActiveSheet()->getStyle('A3:H3')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A3:C3');
        $excel->getActiveSheet(0)
            ->setCellValue('A3', '');

        $excel->setActiveSheetIndex(0)->mergeCells('A4:C4');

        // $excel->getActiveSheet()->getStyle('A4:H4')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A5:C5');
        $excel->getActiveSheet(0)
            ->setCellValue('A5', 'TRN : ' . $settings->trn_no);

        $excel->getActiveSheet()->getStyle('A6:C6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A6:C6');
        $excel->getActiveSheet(0)
            ->setCellValue('A6', $title);


        $date_title = date("d-m-Y", strtotime($from_date)) . ' TO ' . date("d-m-Y", strtotime($to_date));
        // $excel->getActiveSheet()->getStyle('A6:H6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A7:C7');
        $excel->getActiveSheet(0)
            ->setCellValue('A7', $date_title);
        $excel->setActiveSheetIndex(0)->mergeCells('A8:C8');
        $currency1 = 'Currency : AED';
        $excel->getActiveSheet(0)
            ->setCellValue('A8', $currency1);
        $excel->setActiveSheetIndex(0)->mergeCells('A9:C9');

        $parent = 1;
        $excel->getActiveSheet()->getStyle('A10:C10')->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)->setCellValue('A10', 'VAT on Sales (Outwards)');
        $excel->setActiveSheetIndex(0)->mergeCells('A10:C10');
        $excel->getActiveSheet()->getStyle('A11:C11')->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)
            ->setCellValue('A11', 'Emirate')
            ->setCellValue('B11', 'Taxable Amount')
            ->setCellValue('C11', 'VAT');

        $row_no = 12;
        $condition = '(t.invoice_date>="' . $from_date . '" AND t.invoice_date<="' . $to_date . '") AND t.active="Y"';
        if ($outlet > 0) {
            $condition .= ' AND outlet="' . $outlet . '"';
        }
        $sales_view_sql = 'CREATE OR REPLACE VIEW view_net_sale_report AS (SELECT "I" as type,I.id,I.customer_id,I.invoice_no,I.invoice_date,C.customer_name,I.exchange_rate,I.total_amount,0 AS total_amount1,I.grand_total,0 AS grand_total1,I.tax_total,0 AS tax_total1,I.outlet,I.active,C.state
              FROM  {{sales_invoice}} I
              LEFT JOIN  {{customer}} C
              ON C.id=I.customer_id
              )
              UNION ALL
              (SELECT "CN" as type,CN.id,CN.customer_id,CN.return_no AS invoice_no,CN.return_date AS invoice_date,C.customer_name,CN.exchange_rate,0 AS total_amount,(CN.total_amount) AS total_amount1,0 AS grand_total,(CN.grand_total) AS grand_total1,0 AS tax_total,(CN.tax_total) AS tax_total1,CN.outlet,CN.active,C.state 
              FROM  {{sales_return}} CN
              LEFT JOIN  {{customer}} C
              ON C.id=CN.customer_id)';
        Yii::app()->db->createCommand($sales_view_sql)->execute();
        $sales_sql = 'SELECT S.state_name,t.state,SUM(grand_total-grand_total1) AS grand,SUM(total_amount-total_amount1) AS tot,SUM(tax_total-tax_total1) AS vat FROM view_net_sale_report t INNER JOIN erp_master_state S ON t.state=S.id WHERE ' . $condition . ' GROUP BY state ORDER BY S.state_name ASC';
        $total_amount = 0;
        $total_vat = 0;
        $items = Yii::app()->db->createCommand($sales_sql)->queryAll();
        foreach ($items as $each) {
            $vat = round($each['vat'], 4);
            $tot = round($each['tot'], 4);
            if ($each['state'] > 0) {
                $emirate = $each['state_name'];
            }
            $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, $emirate);
            $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(($tot), " "));
            $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency(($vat), " "));
            $row_no++;

            $total_amount += $tot;
            $total_vat += $vat;
        }
        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'TOTAL');
        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, Yii::app()->numberFormatter->formatCurrency(($total_amount), " "));
        $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency(($total_vat), " "));
        $row_no++;
        // Start Other Income

        $vat_sales_account = FinanceSystemAccountsMapping::getSystemdefault('sales_vat');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id = VH.voucher_type
                        WHERE VT.code!="SI" AND VT.code!="CN" AND L.main_account_type="A" AND L.id="' . $vat_sales_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_other_income = -1 * Yii::app()->db->createCommand($query)->queryScalar();
        $table .= '<tr><td colspan="2" style="text-align:right !important;"><b>VAT ON OTHER INCOME</b></td>
                                <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency(($vat_on_other_income), " ") . '</b></td></tr>';
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':C' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)->setCellValue('A' . $row_no, 'VAT ON OTHER INCOME');
        $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency(($vat_on_other_income), " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':B' . $row_no);
        $row_no++;
        // End Other Income
        $purchase_view_sql = 'CREATE OR REPLACE VIEW view_net_purchase_report AS (SELECT "I" as type,I.id,I.invoice_date,I.exchange_rate,I.total_amount,0 AS total_amount1,I.grand_total,0 AS grand_total1,I.tax_total,0 AS tax_total1,I.outlet,I.active
              FROM  {{purchase_invoice}} I
              )
              UNION ALL
              (SELECT "CN" as type,CN.id,CN.return_date AS invoice_date,CN.exchange_rate,0 AS total_amount,(CN.total_amount) AS total_amount1,0 AS grand_total,(CN.grand_total) AS grand_total1,0 AS tax_total,(CN.tax_total) AS tax_total1,CN.outlet,CN.active
              FROM  {{purchase_return}} CN)';
        Yii::app()->db->createCommand($purchase_view_sql)->execute();
        $purchase_vat = Yii::app()->db->createCommand('SELECT SUM(tax_total-tax_total1) AS vat FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();
        $excel->getActiveSheet()->getStyle('A' . $row_no . ':C' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)->setCellValue('A' . $row_no, 'VAT ON PURCHASE');
        $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency(($purchase_vat), " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':B' . $row_no);
        $row_no++;
        $vat_account = FinanceSystemAccountsMapping::getSystemdefault('vat_on_expense');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        WHERE L.main_account_type="L" AND L.id="' . $vat_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_expense = Yii::app()->db->createCommand($query)->queryScalar();

        $vat_purchase_account = FinanceSystemAccountsMapping::getSystemdefault('purchase_vat');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id = VH.voucher_type
                        WHERE VT.code!="PI" AND VT.code!="DN" AND L.main_account_type="L" AND L.id="' . $vat_purchase_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_other_expense = Yii::app()->db->createCommand($query)->queryScalar();

        $excel->getActiveSheet()->getStyle('A' . $row_no . ':C' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)->setCellValue('A' . $row_no, 'VAT ON EXPENSE');
        $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency(($vat_on_expense + $vat_on_other_expense), " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':B' . $row_no);
        $row_no++;

        $excel->getActiveSheet()->getStyle('A' . $row_no . ':C' . $row_no)->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)->setCellValue('A' . $row_no, 'VAT PAYABLE');
        $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, Yii::app()->numberFormatter->formatCurrency(($total_vat + $vat_on_other_income - $vat_on_expense - $vat_on_other_expense - $purchase_vat), " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':B' . $row_no);
        $row_no++;

        //        $excel->getActiveSheet(0)->getStyle('A1:B' . $parent)->applyFromArray($styleArray);

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="vat_report.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }
    public function actionVat_new_excel()
    {
        Yii::import('ext.PHPExcel.PHPExcel');


        $from_date = (count(explode('/', $_REQUEST['from_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from_date']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to_date'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to_date']))) : date('Y-m-d');
        $outlet = (int) $_REQUEST['outlet'];
        $year = date("Y", $time);

        // Create new PHPExcel object
        $excel = new PHPExcel();

        // Set document properties
        $excel->getActiveSheet()->getColumnDimensionByColumn(0)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(1)->setAutoSize(true);
        $excel->getActiveSheet()->getColumnDimensionByColumn(2)->setAutoSize(true);

        $excel->getProperties()->setCreator("Bluesky ERP")
            ->setLastModifiedBy("Bluesky ERP")
            ->setTitle("VAT Report")
            ->setSubject("VAT Report")
            ->setDescription("VAT Report Generated on " . date('d/m/Y'))
            ->setKeywords("VAT Report")
            ->setCategory("Financial Report");

        // Add some data
        $settings = MasCompany::model()->findByPk(Yii::app()->user->company_id);
        $excel->getActiveSheet()->getStyle('A1:F1')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A1:F1');
        $excel->getActiveSheet(0)
            ->setCellValue('A1', $settings->name);

        // $excel->getActiveSheet()->getStyle('A2:H2')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A2:F2');
        $excel->getActiveSheet(0)
            ->setCellValue('A2', $settings->billing_address);

        // $excel->getActiveSheet()->getStyle('A3:H3')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A3:F3');
        $excel->getActiveSheet(0)
            ->setCellValue('A3', '');

        $excel->setActiveSheetIndex(0)->mergeCells('A4:F4');

        // $excel->getActiveSheet()->getStyle('A4:H4')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A5:F5');
        $excel->getActiveSheet(0)
            ->setCellValue('A5', 'TRN : ' . $settings->trn_no);

        $excel->getActiveSheet()->getStyle('A6:F6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A6:F6');
        $excel->getActiveSheet(0)
            ->setCellValue('A6', $title);


        $date_title = date("d-m-Y", strtotime($from_date)) . ' TO ' . date("d-m-Y", strtotime($to_date));
        // $excel->getActiveSheet()->getStyle('A6:H6')->getFont()->setBold(true)->setSize(12);
        $excel->setActiveSheetIndex(0)->mergeCells('A7:F7');
        $excel->getActiveSheet(0)
            ->setCellValue('A7', $date_title);
        $excel->setActiveSheetIndex(0)->mergeCells('A8:F8');
        $currency1 = 'Currency : AED';
        $excel->getActiveSheet(0)
            ->setCellValue('A8', $currency1);
        $excel->setActiveSheetIndex(0)->mergeCells('A9:F9');

        $parent = 1;
        $excel->getActiveSheet()->getStyle('A10:F10')->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)->setCellValue('A10', 'VAT on Sales (Outwards)');
        $excel->setActiveSheetIndex(0)->mergeCells('A10:C10');
        $excel->getActiveSheet()->getStyle('A11:C11')->getFont()->setBold(true)->setSize(12);
        $excel->getActiveSheet(0)
            ->setCellValue('A11', 'Date')
            ->setCellValue('B11', 'Voucher No')
            ->setCellValue('C11', 'Voucher Ref')
            ->setCellValue('D11', 'Customer')
            ->setCellValue('E11', 'Taxable Amount')
            ->setCellValue('F11', 'VAT');

        $row_no = 12;
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="A" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));

        function generateUrl($parentModel)
        {
            $url = '#';
            $code = $parentModel->vtype->code;
            if ($code == 'SI') {
                $headModel = $parentModel->vtype->header_table;
                $vat_field = $parentModel->vtype->vat_value;
                $tax = $headModel::model()->findBypk($parentModel->header_table_id)->$vat_field;
                $taxType = ($tax > 0) ? 'tax' : 'taxnil';
                $url = "window.open($('#liveSite').val()+'index.php?r=invoice/PrintInvoiceReportPDF&id=" . $parentModel->header_table_id . "&frm=" . $taxType . "', '_blank');";
            } else if ($code == 'PI') {
                $url = "window.open($('#liveSite').val()+'index.php?r=purchaseinvoice/PrintInvoiceReportPDF&id=" . $parentModel->header_table_id . "', '_blank');";
            } else if ($code == 'DN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=debitnote/printfile&id=" . $parentModel->header_table_id . "', '_blank');";
            } else if ($code == 'CN') {
                $url = "window.open($('#liveSite').val()+'index.php?r=creditnote/printfile&id=" . $parentModel->header_table_id . "', '_blank');";
            } else {
                $url = "window.open($('#liveSite').val()+'index.php?r=finance/core/print&id=" . $parentModel->id . "', '_blank');";
            }
            return $url;
        }

        function getSymbol($value, $reverse)
        {
            if (!$reverse) {
                $result = ($value <= 0) ? '' : '(-)';
            } else {
                $result = ($value < 0) ? '(-)' : '';
            }

            return $result;
        }

        function getVendor($code, $header_id)
        {
            return $code == 'PI' || $code == 'DN' ? FinanceVoucherItems::model()->find(array('condition' => 'ledger_id=' . FinanceSystemAccountsMapping::getSystemdefault('creditors') . ' AND header_id=' . $header_id))->subledger->description : 'N/A';
        }

        $total_amount = 0;
        $total_vat = 0;
        foreach ($items as $each) {
            if ($each->parent->vtype->code == 'SI' || $each->parent->vtype->code == 'CN') {
                $vat = -1 * round(($each->amount * $each->exchange_rate), 4);
                $total = -1 * $each->get_sales_value();
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, $each->parent->fullvoucher);
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $each->get_any_subledger());
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, Yii::app()->numberFormatter->formatCurrency($total, " "));
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, Yii::app()->numberFormatter->formatCurrency($vat, " "));
                $row_no++;
                $total_amount += $total;
                $total_vat += $vat;
            }
        }

        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Total VAT');
        $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, Yii::app()->numberFormatter->formatCurrency($total_amount, " "));
        $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, Yii::app()->numberFormatter->formatCurrency($total_vat, " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':D' . $row_no);
        $row_no++;
        // Start Other Income
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="A" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));
        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'VAT on Other Income');
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':G' . $row_no);
        $row_no++;

        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Date');
        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, 'Voucher No');
        $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'Voucher Ref');
        $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, 'Subledger');
        $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, 'Narration');
        $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, 'Voucher Amount');
        $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, 'VAT');
        $row_no++;

        $total_amount_income = 0;
        $total_vat_income = 0;
        foreach ($items as $each) {
            if ($each->parent->vtype->code != 'SI' && $each->parent->vtype->code != 'CN') {
                $model = FinanceVoucherHead::model()->findBypk($each->parent->id);
                $vat = round(-1 * ($each->amount * $each->exchange_rate), 4);
                if ($vat > 0) {
                    $total = ($model->debit_total - $vat);
                } else {
                    $total = -1 * ($model->debit_total + $vat);
                }
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, $each->parent->fullvoucher);
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $each->get_any_subledger());
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, $each['narration']);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, Yii::app()->numberFormatter->formatCurrency($total, " "));
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, Yii::app()->numberFormatter->formatCurrency($vat, " "));
                $row_no++;
                $total_amount_income += $total;
                $total_vat_income += $vat;
            }
        }

        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Total VAT');
        $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, Yii::app()->numberFormatter->formatCurrency($total_amount_income, " "));
        $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, Yii::app()->numberFormatter->formatCurrency($total_vat_income, " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':E' . $row_no);
        $row_no++;
        // End Other Income
        // Start  Purchase Expenses
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="L" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));

        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'VAT on Purchases');
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':G' . $row_no);
        $row_no++;

        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Date');
        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, 'Voucher No');
        $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'Voucher Ref');
        $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, 'Subledger');
        $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, 'Narration');
        $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, 'Voucher Amount');
        $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, 'VAT');
        $row_no++;

        $total_amount = 0;
        $total_vat_purchase = 0;
        foreach ($items as $each) {
            $vat = round(($each->amount * $each->exchange_rate), 4);
            $total = $each->get_purchase_value();
            if ($each->parent->vtype->code == 'PI' || $each->parent->vtype->code == 'DN') {
                $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, $each->parent->fullvoucher);
                $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, $each->parent->reference_no);
                $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $each->get_any_subledger());
                $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no,  $each->narration);
                $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, Yii::app()->numberFormatter->formatCurrency($total, " "));
                $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, Yii::app()->numberFormatter->formatCurrency($vat, " "));
                $row_no++;
                $total_amount += $total;
                $total_vat_purchase += $vat;
            }
        }

        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Total VAT');
        $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, Yii::app()->numberFormatter->formatCurrency($total_amount, " "));
        $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, Yii::app()->numberFormatter->formatCurrency($total_vat_purchase, " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':E' . $row_no);
        $row_no++;
        //End Purchase Expenses
        // Start  Vat on Expenses
        $items = FinanceVoucherItems::model()->with('parent', 'ledger')->findAll(array('condition' => 'ledger.main_account_type="L" AND ledger.classification="VAT" AND parent.is_posted = "Y" AND parent.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND t.outlet=' . $outlet, 'order' => 'parent.voucher_date,parent.voucher_no ASC'));

        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'VAT on Expenses (Inwards)');
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':G' . $row_no);
        $row_no++;

        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Date');
        $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, 'Voucher No');
        $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, 'Voucher Ref');
        $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, 'Subledger');
        $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no, 'Narration');
        $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, 'Voucher Amount');
        $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, 'VAT');
        $row_no++;

        $total_amount = 0;
        $total_vat_exp = 0;
        foreach ($items as $each) {
            $vat = round(($each->amount * $each->exchange_rate), 4);
            $total = $each->get_purchase_value();
            if ($each->parent->vtype->code != 'PI' && $each->parent->vtype->code != 'DN') {
                $vat = round(($each->amount * $each->exchange_rate), 4);
                $total = ($each->parent->debit_total - $vat);
                if ($total > $vat) {
                    if ($vat < 0) {
                        $total = -1 * ($total + (2 * $vat));
                    }
                    $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, date("d/m/Y", strtotime($each->parent->voucher_date)));
                    $excel->setActiveSheetIndex(0)->setCellValue('B' . $row_no, $each->parent->fullvoucher);
                    $excel->setActiveSheetIndex(0)->setCellValue('C' . $row_no, $each->parent->reference_no);
                    $excel->setActiveSheetIndex(0)->setCellValue('D' . $row_no, $each->get_any_subledger());
                    $excel->setActiveSheetIndex(0)->setCellValue('E' . $row_no,  $each->narration);
                    $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, Yii::app()->numberFormatter->formatCurrency($total, " "));
                    $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, Yii::app()->numberFormatter->formatCurrency($vat, " "));
                    $row_no++;
                    $total_amount += $total;
                    $total_vat_exp += $vat;
                }
            }
        }
        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'Total VAT');
        $excel->setActiveSheetIndex(0)->setCellValue('F' . $row_no, Yii::app()->numberFormatter->formatCurrency($total_amount, " "));
        $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, Yii::app()->numberFormatter->formatCurrency($total_vat_exp, " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':E' . $row_no);
        $row_no++;
        //End Vat On Expenses
        $payable = $total_vat + $total_vat_income - $total_vat_purchase - $total_vat_exp;
        $excel->setActiveSheetIndex(0)->setCellValue('A' . $row_no, 'VAT Payable');
        $excel->setActiveSheetIndex(0)->setCellValue('G' . $row_no, Yii::app()->numberFormatter->formatCurrency($payable, " "));
        $excel->setActiveSheetIndex(0)->mergeCells('A' . $row_no . ':F' . $row_no);
        $row_no++;

        // Redirect output to a client’s web browser (Excel2007)
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        header('Content-Disposition: attachment;filename="vat_report.xlsx"');
        header('Cache-Control: max-age=0');
        // If you're serving to IE 9, then the following may be needed
        header('Cache-Control: max-age=1');

        // If you're serving to IE over SSL, then the following may be needed
        header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
        header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); // always modified
        header('Cache-Control: cache, must-revalidate'); // HTTP/1.1
        header('Pragma: public'); // HTTP/1.0

        $objWriter = PHPExcel_IOFactory::createWriter($excel, 'Excel2007');
        $objWriter->save('php://output');
        exit;
    }

    public function actionParentaccountlist()
    {
        $parent_id = (int) $_REQUEST['id'];
        $from_date = $_REQUEST['from_date'];
        $to_date = $_REQUEST['to_date'];
        $outlet = (int) $_REQUEST['outlet'];
        $costcenter = (int) $_REQUEST['costcenter'];
        $Ledgers = FinanceLegder::model()->findAll(array('condition' => 'root like "%,' . $parent_id . ',%" OR root like "' . $parent_id . ',%" OR root like "%,' . $parent_id . '" OR root like "' . $parent_id . '"', 'order' => 'account_order'));
        $debit_total = $credit_total = 0;
        echo '<table><tr><th>Accounts</th><th>Debit</th><th>Credit</th></tr>';
        foreach ($Ledgers as $i => $each) {
            $debit = $credit = 0;
            if ($each->isParent == 'N') {
                if ($each->main_account_type == "A" || $each->main_account_type == "L") {
                    if($costcenter>0){
                        $amount = Yii::app()->db->createCommand('SELECT SUM(amount) from {{finance_voucher_head}} head INNER JOIN {{finance_voucher_items}} items ON head.id=items.header_id where head.is_posted ="Y" AND head.voucher_date<="' . $to_date . '"  AND items.ledger_id = ' . $each->id . ' AND head.costcenter=' . $costcenter . ' AND items.outlet=' . $outlet)->queryScalar();
                     }else{
                        $amount = Yii::app()->db->createCommand('SELECT SUM(amount) from {{finance_voucher_head}} head INNER JOIN {{finance_voucher_items}} items ON head.id=items.header_id where head.is_posted ="Y" AND head.voucher_date<="' . $to_date . '"  AND items.ledger_id = ' . $each->id . '  AND items.outlet=' . $outlet)->queryScalar();
                     }
                } else {
                    if($costcenter>0){
                        $amount = Yii::app()->db->createCommand('SELECT SUM(amount) from {{finance_voucher_head}} head INNER JOIN {{finance_voucher_items}} items ON head.id=items.header_id where head.is_posted ="Y" AND head.voucher_date>="' . $from_date . '" AND head.voucher_date<="' . $to_date . '"  AND items.ledger_id = ' . $each->id . ' AND head.costcenter=' . $costcenter . ' AND items.outlet=' . $outlet)->queryScalar();
                    }else{
                        $amount = Yii::app()->db->createCommand('SELECT SUM(amount) from {{finance_voucher_head}} head INNER JOIN {{finance_voucher_items}} items ON head.id=items.header_id where head.is_posted ="Y" AND head.voucher_date>="' . $from_date . '" AND head.voucher_date<="' . $to_date . '"  AND items.ledger_id = ' . $each->id . '  AND items.outlet=' . $outlet)->queryScalar();
                    }
                }
                if ($amount > 0) {
                    $debit = $amount;
                    $debit_total += $debit;
                } else {
                    $credit = abs($amount);
                    $credit_total += $credit;
                }
                if ($debit != 0 || $credit != 0) {
                    echo '<tr><td>' . $each->description . '</td><td>' . Yii::app()->numberFormatter->formatCurrency(($debit), " ") . '</td><td>' . Yii::app()->numberFormatter->formatCurrency(($credit), " ") . '</td></tr>';
                }
            }
        }
        echo '<tr><td><b>Total</b></td><td><b>' . Yii::app()->numberFormatter->formatCurrency(($debit_total), " ") . '</b></td><td><b>' . Yii::app()->numberFormatter->formatCurrency(($credit_total), " ") . '</b></td></tr>';
        $balance = $debit_total - $credit_total;
        if ($balance > 0) {
            echo '<tr><td><b>Balance</b></td><td><b>' . Yii::app()->numberFormatter->formatCurrency(($balance), " ") . '</b></td><td><b>' . Yii::app()->numberFormatter->formatCurrency(0, " ") . '</b></td></tr>';
        } else {
            echo '<tr><td><b>Balance</b></td><td><b>' . Yii::app()->numberFormatter->formatCurrency(0, " ") . '</b></td><td><b>' . Yii::app()->numberFormatter->formatCurrency(abs($balance), " ") . '</b></td></tr>';
        }
    }

    public function actionVat_summary_report()
    {
        $this->render('vat_summary_report');
    }
    public function actionVat_summary_html()
    {

        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $outlet = (int) $_POST['outlet'];
        $condition = '(t.invoice_date>="' . $from_date . '" AND t.invoice_date<="' . $to_date . '") AND t.active="Y"';
        if ($outlet > 0) {
            $condition .= ' AND outlet="' . $outlet . '"';
        }
        $sales_view_sql = 'CREATE OR REPLACE VIEW view_net_sale_report AS (SELECT "I" as type,I.id,I.customer_id,I.invoice_no,I.invoice_date,C.customer_name,I.exchange_rate,I.total_amount,0 AS total_amount1,I.grand_total,0 AS grand_total1,I.tax_total,0 AS tax_total1,I.outlet,I.active,C.state
              FROM  {{sales_invoice}} I
              LEFT JOIN  {{customer}} C
              ON C.id=I.customer_id
              )
              UNION ALL
              (SELECT "CN" as type,CN.id,CN.customer_id,CN.return_no AS invoice_no,CN.return_date AS invoice_date,C.customer_name,CN.exchange_rate,0 AS total_amount,(CN.total_amount) AS total_amount1,0 AS grand_total,(CN.grand_total) AS grand_total1,0 AS tax_total,(CN.tax_total) AS tax_total1,CN.outlet,CN.active,C.state 
              FROM  {{sales_return}} CN
              LEFT JOIN  {{customer}} C
              ON C.id=CN.customer_id)';
        Yii::app()->db->createCommand($sales_view_sql)->execute();
        $sales_sql = 'SELECT SUM(grand_total) AS grand,SUM(total_amount) AS tot,SUM(tax_total) AS vat FROM view_net_sale_report t WHERE ' . $condition;

        $table = '<div class="row">
            <div class="col-sm-6">
            <div class="table-responsive">
            <table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="6">VAT on Sales (Outwards)</th>
                        </tr>
                        <tr>
                            <th style="width:15%">Transaction</th>
                            <th style="width:8%">Amount</th>
                            <th style="width:8%">VAT </th>
                            <th style="width:8%">Grand Total</th>
                        </tr>
                    </thead>
                    <tbody>';

        $total_amount = 0;
        $total_vat = 0;
        $total_grand = 0;
        $grand = Yii::app()->db->createCommand('SELECT SUM(grand_total) AS grand FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();
        $tot = Yii::app()->db->createCommand('SELECT SUM(total_amount) AS tot FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();
        $vat = Yii::app()->db->createCommand('SELECT SUM(tax_total) AS vat FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();

        $table .= '<tr>
                                            <td style="text-align:left !important;"> SALES</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($tot, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($grand, " ") . '</td>
                                        </tr>';
        $total_grand += $grand;
        $total_amount += $tot;
        $total_vat += $vat;

        $grand1 = Yii::app()->db->createCommand('SELECT SUM(grand_total1) AS grand FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();
        $tot1 = Yii::app()->db->createCommand('SELECT SUM(total_amount1) AS tot FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();
        $vat1 = Yii::app()->db->createCommand('SELECT SUM(tax_total1) AS vat FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();

        $table .= '<tr>         
                                            <td style="text-align:left !important;"> SALES RETURN</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($tot1, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat1, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($grand1, " ") . '</td>
                                        </tr>';
        $total_grand -= $grand1;
        $total_amount -= $tot1;
        $total_vat -= $vat1;
        $table .= '<tr>
                                            <td style="text-align:right !important;"><b>TOTAL SALES</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_grand, " ") . '</b></td>
                                        </tr>';
        $table .= '<tr>
                                            <td colspan="4"></td>
                                        </tr>';
        // Start Other Income

        $vat_sales_account = FinanceSystemAccountsMapping::getSystemdefault('sales_vat');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id = VH.voucher_type
                        WHERE VT.code!="SI" AND VT.code!="CN" AND L.main_account_type="A" AND L.id="' . $vat_sales_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_other_income = -1 * Yii::app()->db->createCommand($query)->queryScalar();
        $other_income_amount = $vat_on_other_income * 100 / 5;
        $other_income = $other_income_amount + $vat_on_other_income;
        $table .= '<tr>
                                            <td style="text-align:right !important;"><b>OTHER INCOME</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($other_income_amount, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($vat_on_other_income, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($other_income, " ") . '</b></td>
                                        </tr>';
        $total_grand += $other_income;
        $total_amount += $other_income_amount;
        $total_vat += $vat_on_other_income;
        $table .= '<tr>
                                            <td style="text-align:right !important;"><b>TOTAL INCOME</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_grand, " ") . '</b></td>
                                        </tr>';

        // End Other Income
        $table .= '</table></div></div><div class="col-sm-6">            
               <table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="6">VAT on Purchase (Inwards)</th>
                        </tr>
                        <tr>
                            <th style="width:15%">Transaction</th>
                            <th style="width:8%">Amount</th>
                            <th style="width:8%">VAT </th>
                            <th style="width:8%">Grand Total</th>
                        </tr>
                    </thead>
                    <tbody>
                <div class="table-responsive">';
        $purchase_view_sql = 'CREATE OR REPLACE VIEW view_net_purchase_report AS (SELECT "I" as type,I.id,I.invoice_date,I.exchange_rate,I.total_amount,0 AS total_amount1,I.grand_total,0 AS grand_total1,I.tax_total,0 AS tax_total1,I.outlet,I.active
              FROM  {{purchase_invoice}} I
              )
              UNION ALL
              (SELECT "CN" as type,CN.id,CN.return_date AS invoice_date,CN.exchange_rate,0 AS total_amount,(CN.total_amount) AS total_amount1,0 AS grand_total,(CN.grand_total) AS grand_total1,0 AS tax_total,(CN.tax_total) AS tax_total1,CN.outlet,CN.active
              FROM  {{purchase_return}} CN)';
        Yii::app()->db->createCommand($purchase_view_sql)->execute();

        $total_amount1 = 0;
        $total_vat1 = 0;
        $total_grand1 = 0;
        $grand2 = Yii::app()->db->createCommand('SELECT SUM(grand_total) AS grand FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();
        $tot2 = Yii::app()->db->createCommand('SELECT SUM(total_amount) AS tot FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();
        $vat2 = Yii::app()->db->createCommand('SELECT SUM(tax_total) AS vat FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();

        $table .= '<tr>
                                            <td style="text-align:left !important;"> PURCHASE</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($tot2, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat2, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($grand2, " ") . '</td>
                                        </tr>';
        $total_grand1 += $grand2;
        $total_amount1 += $tot2;
        $total_vat1 += $vat2;

        $grand3 = Yii::app()->db->createCommand('SELECT SUM(grand_total1) AS grand FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();
        $tot3 = Yii::app()->db->createCommand('SELECT SUM(total_amount1) AS tot FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();
        $vat3 = Yii::app()->db->createCommand('SELECT SUM(tax_total1) AS vat FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();

        $table .= '<tr>         
                                            <td style="text-align:left !important;"> PURCHASE RETURN</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($tot3, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat3, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($grand3, " ") . '</td>
                                        </tr>';
        $total_grand1 -= $grand3;
        $total_amount1 -= $tot3;
        $total_vat1 -= $vat3;
        $table .= '<tr>         
                                            <td style="text-align:right !important;"><b>TOTAL PURCHASE</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount1, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat1, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_grand1, " ") . '</b></td>
                                        </tr>';
        $table .= '<tr>
                                            <td colspan="4"></td>
                                        </tr>';
        $purchase_vat = Yii::app()->db->createCommand('SELECT SUM(tax_total-tax_total1) AS vat FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();

        $vat_account = FinanceSystemAccountsMapping::getSystemdefault('vat_on_expense');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        WHERE L.main_account_type="L" AND L.id="' . $vat_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_expense = Yii::app()->db->createCommand($query)->queryScalar();
        $vat_purchase_account = FinanceSystemAccountsMapping::getSystemdefault('purchase_vat');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id = VH.voucher_type
                        WHERE VT.code!="PI" AND VT.code!="DN" AND L.main_account_type="L" AND L.id="' . $vat_purchase_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_other_expense = Yii::app()->db->createCommand($query)->queryScalar();
        $tot_vat_on_exp = $vat_on_expense + $vat_on_other_expense;
        $other_exp_amount = $tot_vat_on_exp * 100 / 5;
        $other_exp = $other_exp_amount + $tot_vat_on_exp;
        $table .= '<tr>
                                            <td style="text-align:right !important;"><b>OTHER EXPENSES</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($other_exp_amount, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_vat_on_exp, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($other_exp, " ") . '</b></td>
                                        </tr>';
        $total_grand1 += $other_exp;
        $total_amount1 += $other_exp_amount;
        $total_vat1 += $tot_vat_on_exp;
        $table .= '<tr>
                                            <td style="text-align:right !important;"><b>TOTAL EXPENSES</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount1, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat1, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_grand1, " ") . '</b></td>
                                        </tr>';
        //        $table .= '<tr>
        //                                            <td colspan="3" style="text-align:right !important;background-color:#66ff33;"><b>VAT PAYABLE</b></td>
        //                                            <td style="text-align:right !important;background-color:#66ff33;"><b>' . Yii::app()->numberFormatter->formatCurrency(($total_vat-$total_vat1), " ") . '</b></td>
        //                                        </tr>';
        $table .= '</tbody>
                        </table></div></div>
                        <div class="col-sm-12">
            <div class="table-responsive">
            <table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <td style="text-align:right !important;background-color:#66ff33;">VAT PAYABLE</td>
                            <td style="text-align:right !important;background-color:#66ff33;"><b>' . Yii::app()->numberFormatter->formatCurrency(($total_vat - $total_vat1), " ") . '</b></td>
                        </tr>
                        </div></div></div>';
        echo $table;
    }

    public function actionInvoice_cost_html()
    {
        $outlet = (int) $_POST['outlet'];
        $customer_id = (int) $_POST['salesinvoice_customer_id'];
        $created_user = (int) $_POST['created_user'];
        $brand_id = (int) $_POST['brand_id'];
        $from_date = (count(explode('/', $_POST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_POST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_POST['to']))) : date('Y-m-d');
        $condition = ' where H.active="Y" AND H.invoice_date BETWEEN "' . $from_date . '" AND "' . $to_date . '"';
        if ($outlet > 0) {
            $condition .= ' AND H.outlet=' . $outlet;
            $conditions .= ' AND outlet=' . $outlet;
        }
        if ($customer_id) {
            $condition .= ' AND H.customer_id=' . $customer_id;
        }

        if ($created_user > 0) {
            $condition .= ' AND H.sales_man=' . $created_user;
        }
        if ((int)$brand_id > 0) {
            $condition .= ' AND S.brand=' . (int)$brand_id;
        }
        $SQL = ' Select H.invoice_no,C.customer_name,I.description,I.net_amount,I.quantity,H.invoice_date,I.amount,H.grand_total,I.product_id,I.tax_amount from erp_sales_invoice H 
       INNER JOIN erp_sales_invoice_items I ON H.id=I.invoice_id 
       INNER JOIN erp_inventory S ON S.id=I.product_id 
       INNER JOIN erp_master_brand B ON B.id=S.brand 
       INNER JOIN erp_customer C ON H.customer_id=C.id ' . $condition . ' order by H.id';
        $all = Yii::app()->db->createCommand($SQL)->queryAll();
        $table = '<table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th style="width:10%">Date</th>
                            <th style="width:10%">Invoice No</th>
                            <th style="width:25%">Customer</th>
                            <th style="width:5%">Net Total</th>
                            <th style="width:5%">Tax</th>
                             <th style="width:5%">Total</th>
                            <th style="width:5%">Cost</th>
                            <th style="width:5%">Profit</th>
                            <th style="width:5%">Profit(%)</th>
                        </tr>
                    </thead>
                <tbody>';
        $total_cost = 0;
        $total_profit = 0;
        $amount = 0;
        $total_sales = 0;
        $total_tax = 0;
        $inv_no = 0;
        $invoice_date = '';
        $customer_name = '';
        $net_amount = 0;
        $tax_amount = 0;
        $inv_cost = 0;
        $inv_profit = 0;
        $inv_profit_percent = 0;
        $inv_count = 1;
        foreach ($all as $i => $each) {
            $current_in_rate = Yii::app()->db->createCommand('SELECT CASE
        WHEN SUM(quantity*unit_exchange_rate) > 0 THEN SUM(quantity*rate)/SUM(quantity*unit_exchange_rate) ELSE 0 END AS avg_purchase_rate 
        FROM {{stock_ledger}}  WHERE transaction_type = "IN" AND type!= "GT" AND product_id=' . $each["product_id"] . ' AND transaction_date <= "' . $each['invoice_date'] . '" ' . $conditions)->queryScalar();

            $avg_cost = StockLedger::getAvgPurchaseRate($each["product_id"], $each['invoice_date'], $outlet);
            $profit = $each['net_amount'] - $each['tax_amount'] - ($each['quantity'] * $avg_cost);
            $cost = ($each['quantity'] * $avg_cost);

            if ($each['invoice_no'] != $inv_no && $i > 0) {

                if ($amount != 0) {
                    $inv_profit_percent = $inv_profit / ($amount) * 100;
                }

                $table .= '<tr><td>' . date("d-m-Y", strtotime($invoice_date)) . '</td><td>' . $inv_no . '</td><td>' . $customer_name . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($net_amount, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($tax_amount, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($amount, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($inv_cost, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($inv_profit, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($inv_profit_percent), " ") . '%</td></tr>';
                $inv_no = $each['invoice_no'];
                $invoice_date = $each['invoice_date'];
                $customer_name = $each['customer_name'];
                $amount = $each['amount'];
                $net_amount = $each['net_amount'];
                $tax_amount = $each['tax_amount'];

                $inv_cost = $cost;
                $inv_profit = $profit;
                $inv_count = 1;
            } else {
                $inv_no = $each['invoice_no'];
                $invoice_date = $each['invoice_date'];
                $customer_name = $each['customer_name'];
                $amount += $each['amount'];
                $net_amount += $each['net_amount'];
                $tax_amount += $each['tax_amount'];
                $inv_cost += $cost;
                $inv_profit += $profit;
                $inv_count++;
            }
            $total_cost += $each['quantity'] * $avg_cost;
            $total_profit += $profit;
            $total_sales += $each['net_amount'];
            $total += $each['amount'];
            $total_tax += $each['tax_amount'];
        }

        $table .= '<tr><td>' . date("d-m-Y", strtotime($invoice_date)) . '</td><td>' . $inv_no . '</td><td>' . $customer_name . '</td>
        <td style="text-align:right !important;">' . $net_amount . '</td><td style="text-align:right !important;">' . $tax_amount . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($amount, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($inv_cost, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($inv_profit, " ") . '</td><td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency(($inv_profit_percent), " ") . '%</td></tr>';
        if ($total_sales > 0) {
            $percent = $total_profit / ($total_sales) * 100;
        } else {
            $percent = 0;
        }
        $table .= '<tr><td colspan="3" style="text-align:right !important;"><b>Total</b></td><td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_sales, " ") . '</b></td><td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_tax, " ") . '</b></td><td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total, " ") . '</b></td><td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_cost, " ") . '</b></td><td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_profit, " ") . '</b></td><td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($percent, " ") . '%</b></td></tr>';
        $table .= '</tbody>
                </table>';
        echo $table;
    }
    public function actionVat_summary_pdf()
    {

        $from_date = (count(explode('/', $_REQUEST['from'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['from']))) : date('Y-m-01');
        $to_date = (count(explode('/', $_REQUEST['to'])) == 3) ? date("Y-m-d", strtotime(str_replace('/', '-', $_REQUEST['to']))) : date('Y-m-d');
        $outlet = (int) $_REQUEST['outlet'];
        $condition = '(t.invoice_date>="' . $from_date . '" AND t.invoice_date<="' . $to_date . '") AND t.active="Y"';
        if ($outlet > 0) {
            $condition .= ' AND outlet="' . $outlet . '"';
        }
        $sales_view_sql = 'CREATE OR REPLACE VIEW view_net_sale_report AS (SELECT "I" as type,I.id,I.customer_id,I.invoice_no,I.invoice_date,C.customer_name,I.exchange_rate,I.total_amount,0 AS total_amount1,I.grand_total,0 AS grand_total1,I.tax_total,0 AS tax_total1,I.outlet,I.active,C.state
              FROM  {{sales_invoice}} I
              LEFT JOIN  {{customer}} C
              ON C.id=I.customer_id
              )
              UNION ALL
              (SELECT "CN" as type,CN.id,CN.customer_id,CN.return_no AS invoice_no,CN.return_date AS invoice_date,C.customer_name,CN.exchange_rate,0 AS total_amount,(CN.total_amount) AS total_amount1,0 AS grand_total,(CN.grand_total) AS grand_total1,0 AS tax_total,(CN.tax_total) AS tax_total1,CN.outlet,CN.active,C.state 
              FROM  {{sales_return}} CN
              LEFT JOIN  {{customer}} C
              ON C.id=CN.customer_id)';
        Yii::app()->db->createCommand($sales_view_sql)->execute();
        $sales_sql = 'SELECT SUM(grand_total) AS grand,SUM(total_amount) AS tot,SUM(tax_total) AS vat FROM view_net_sale_report t WHERE ' . $condition;

        $table = '<div class="row">
            <div class="col-sm-6">
            <div class="table-responsive">
            <table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="4">VAT on Sales (Outwards)</th>
                        </tr>
                        <tr>
                            <th style="width:15%">Transaction</th>
                            <th style="width:8%">Amount</th>
                            <th style="width:8%">VAT </th>
                            <th style="width:8%">Grand Total</th>
                        </tr>
                    </thead>
                    <tbody>';

        $total_amount = 0;
        $total_vat = 0;
        $total_grand = 0;
        $grand = Yii::app()->db->createCommand('SELECT SUM(grand_total) AS grand FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();
        $tot = Yii::app()->db->createCommand('SELECT SUM(total_amount) AS tot FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();
        $vat = Yii::app()->db->createCommand('SELECT SUM(tax_total) AS vat FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();

        $table .= '<tr>
                                            <td style="text-align:left !important;"> SALES</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($tot, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($grand, " ") . '</td>
                                        </tr>';
        $total_grand += $grand;
        $total_amount += $tot;
        $total_vat += $vat;

        $grand1 = Yii::app()->db->createCommand('SELECT SUM(grand_total1) AS grand FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();
        $tot1 = Yii::app()->db->createCommand('SELECT SUM(total_amount1) AS tot FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();
        $vat1 = Yii::app()->db->createCommand('SELECT SUM(tax_total1) AS vat FROM view_net_sale_report t WHERE ' . $condition)->queryScalar();

        $table .= '<tr>         
                                            <td style="text-align:left !important;"> SALES RETURN</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($tot1, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat1, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($grand1, " ") . '</td>
                                        </tr>';
        $total_grand -= $grand1;
        $total_amount -= $tot1;
        $total_vat -= $vat1;
        $table .= '<tr>
                                            <td style="text-align:right !important;"><b>TOTAL SALES</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_grand, " ") . '</b></td>
                                        </tr>';
        $table .= '<tr>
                                            <td colspan="4"></td>
                                        </tr>';
        // Start Other Income

        $vat_sales_account = FinanceSystemAccountsMapping::getSystemdefault('sales_vat');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id = VH.voucher_type
                        WHERE VT.code!="SI" AND VT.code!="CN" AND L.main_account_type="A" AND L.id="' . $vat_sales_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_other_income = -1 * Yii::app()->db->createCommand($query)->queryScalar();
        $other_income_amount = $vat_on_other_income * 100 / 5;
        $other_income = $other_income_amount + $vat_on_other_income;
        $table .= '<tr>
                                            <td style="text-align:right !important;"><b>OTHER INCOME</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($other_income_amount, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($vat_on_other_income, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($other_income, " ") . '</b></td>
                                        </tr>';
        $total_grand += $other_income;
        $total_amount += $other_income_amount;
        $total_vat += $vat_on_other_income;
        $table .= '<tr>
                                            <td style="text-align:right !important;"><b>TOTAL</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_grand, " ") . '</b></td>
                                        </tr>';

        // End Other Income
        $table .= '</table></div></div><br><div class="col-sm-6">            
               <table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <th colspan="4">VAT on Purchase (Inwards)</th>
                        </tr>
                        <tr>
                            <th style="width:15%">Transaction</th>
                            <th style="width:8%">Amount</th>
                            <th style="width:8%">VAT </th>
                            <th style="width:8%">Grand Total</th>
                        </tr>
                    </thead>
                    <tbody>
                <div class="table-responsive">';
        $purchase_view_sql = 'CREATE OR REPLACE VIEW view_net_purchase_report AS (SELECT "I" as type,I.id,I.invoice_date,I.exchange_rate,I.total_amount,0 AS total_amount1,I.grand_total,0 AS grand_total1,I.tax_total,0 AS tax_total1,I.outlet,I.active
              FROM  {{purchase_invoice}} I
              )
              UNION ALL
              (SELECT "CN" as type,CN.id,CN.return_date AS invoice_date,CN.exchange_rate,0 AS total_amount,(CN.total_amount) AS total_amount1,0 AS grand_total,(CN.grand_total) AS grand_total1,0 AS tax_total,(CN.tax_total) AS tax_total1,CN.outlet,CN.active
              FROM  {{purchase_return}} CN)';
        Yii::app()->db->createCommand($purchase_view_sql)->execute();

        $total_amount1 = 0;
        $total_vat1 = 0;
        $total_grand1 = 0;
        $grand2 = Yii::app()->db->createCommand('SELECT SUM(grand_total) AS grand FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();
        $tot2 = Yii::app()->db->createCommand('SELECT SUM(total_amount) AS tot FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();
        $vat2 = Yii::app()->db->createCommand('SELECT SUM(tax_total) AS vat FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();

        $table .= '<tr>
                                            <td style="text-align:left !important;"> PURCHASE</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($tot2, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat2, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($grand2, " ") . '</td>
                                        </tr>';
        $total_grand1 += $grand2;
        $total_amount1 += $tot2;
        $total_vat1 += $vat2;

        $grand3 = Yii::app()->db->createCommand('SELECT SUM(grand_total1) AS grand FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();
        $tot3 = Yii::app()->db->createCommand('SELECT SUM(total_amount1) AS tot FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();
        $vat3 = Yii::app()->db->createCommand('SELECT SUM(tax_total1) AS vat FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();

        $table .= '<tr>         
                                            <td style="text-align:left !important;"> PURCHASE RETURN</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($tot3, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($vat3, " ") . '</td>
                                            <td style="text-align:right !important;">' . Yii::app()->numberFormatter->formatCurrency($grand3, " ") . '</td>
                                        </tr>';
        $total_grand1 -= $grand3;
        $total_amount1 -= $tot3;
        $total_vat1 -= $vat3;
        $table .= '<tr>         
                                            <td style="text-align:right !important;"><b>TOTAL PURCHASE</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount1, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat1, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_grand1, " ") . '</b></td>
                                        </tr>';
        $table .= '<tr>
                                            <td colspan="4"></td>
                                        </tr>';
        $purchase_vat = Yii::app()->db->createCommand('SELECT SUM(tax_total-tax_total1) AS vat FROM view_net_purchase_report t WHERE ' . $condition)->queryScalar();

        $vat_account = FinanceSystemAccountsMapping::getSystemdefault('vat_on_expense');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        WHERE L.main_account_type="L" AND L.id="' . $vat_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_expense = Yii::app()->db->createCommand($query)->queryScalar();
        $vat_purchase_account = FinanceSystemAccountsMapping::getSystemdefault('purchase_vat');
        $query = 'SELECT
                        ROUND(SUM(VI.amount*VI.exchange_rate), 4) AS vat_amount
                        FROM {{finance_voucher_items}} VI
                        LEFT JOIN {{finance_voucher_head}} VH ON VH.id = VI.header_id
                        LEFT JOIN {{finance_legder}} L ON L.id = VI.ledger_id
                        LEFT JOIN {{finance_voucher_type}} VT ON VT.id = VH.voucher_type
                        WHERE VT.code!="PI" AND VT.code!="DN" AND L.main_account_type="L" AND L.id="' . $vat_purchase_account . '" AND VH.is_posted = "Y" AND VH.voucher_date BETWEEN "' . $from_date . '" AND "' . $to_date . '" AND VH.outlet="' . $outlet . '"';
        $vat_on_other_expense = Yii::app()->db->createCommand($query)->queryScalar();
        $tot_vat_on_exp = $vat_on_expense + $vat_on_other_expense;
        $other_exp_amount = $tot_vat_on_exp * 100 / 5;
        $other_exp = $other_exp_amount + $tot_vat_on_exp;
        $table .= '<tr>
                                            <td style="text-align:right !important;"><b>OTHER EXPENSES</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($other_exp_amount, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($tot_vat_on_exp, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($other_exp, " ") . '</b></td>
                                        </tr>';
        $total_grand1 += $other_exp;
        $total_amount1 += $other_exp_amount;
        $total_vat1 += $tot_vat_on_exp;
        $table .= '<tr>
                                            <td style="text-align:right !important;"><b>TOTAL</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_amount1, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_vat1, " ") . '</b></td>
                                            <td style="text-align:right !important;"><b>' . Yii::app()->numberFormatter->formatCurrency($total_grand1, " ") . '</b></td>
                                        </tr>';
        //        $table .= '<tr>
        //                                            <td colspan="3" style="text-align:right !important;background-color:#66ff33;"><b>VAT PAYABLE</b></td>
        //                                            <td style="text-align:right !important;background-color:#66ff33;"><b>' . Yii::app()->numberFormatter->formatCurrency(($total_vat-$total_vat1), " ") . '</b></td>
        //                                        </tr>';
        $table .= '</tbody>
                        </table></div></div><br>
                        <div class="col-sm-12">
            <div class="table-responsive">
            <table class="table table-hover table-fixed table-bordered">
                    <thead>
                        <tr>
                            <td style="text-align:right !important;background-color:#66ff33;">VAT PAYABLE</td>
                            <td style="text-align:right !important;background-color:#66ff33;"><b>' . Yii::app()->numberFormatter->formatCurrency(($total_vat - $total_vat1), " ") . '</b></td>
                        </tr>
                        </thead></table>
                        </div></div></div>';

        $param = array(
            'from_date' => $from_date,
            'to_date' => $to_date,
            'table' => $table,
        );

        $mode = 'A4';
        $mpdf = Yii::app()->ePdf->mpdf('', $mode);
        $stylesheet = file_get_contents(Yii::getPathOfAlias('webroot.css') . '/pdf_style.css');
        $mpdf->WriteHTML($stylesheet, 1);
        $view = 'pdf_vat_return_new_report';
        $mpdf->WriteHTML($this->renderPartial($view, $param, true));
        $mpdf->Output("vat_report" . date("d-m-Y") . ".pdf", 'I');
    }
}
